#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 3310
#define SYMBOL_COUNT 279
#define ALIAS_COUNT 22
#define TOKEN_COUNT 118
#define EXTERNAL_TOKEN_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym_raw_string_literal = 1,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH = 2,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH = 3,
  aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH = 4,
  anon_sym_LF = 5,
  anon_sym_LPAREN = 6,
  anon_sym_DOT_DOT_DOT = 7,
  anon_sym_COMMA = 8,
  anon_sym_RPAREN = 9,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH = 10,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH = 11,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH = 12,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH = 13,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH = 14,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH = 15,
  sym_preproc_directive = 16,
  sym_preproc_arg = 17,
  anon_sym_SEMI = 18,
  anon_sym_typedef = 19,
  anon_sym_extern = 20,
  anon_sym_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_STAR = 23,
  anon_sym_LBRACK = 24,
  anon_sym_RBRACK = 25,
  anon_sym_EQ = 26,
  anon_sym_static = 27,
  anon_sym_register = 28,
  anon_sym_inline = 29,
  anon_sym_const = 30,
  anon_sym_restrict = 31,
  anon_sym_volatile = 32,
  anon_sym__Atomic = 33,
  anon_sym_mutable = 34,
  anon_sym_explicit = 35,
  anon_sym_constexpr = 36,
  anon_sym_unsigned = 37,
  anon_sym_long = 38,
  anon_sym_short = 39,
  sym_primitive_type = 40,
  anon_sym_enum = 41,
  anon_sym_struct = 42,
  anon_sym_union = 43,
  anon_sym_COLON = 44,
  anon_sym_if = 45,
  anon_sym_else = 46,
  anon_sym_switch = 47,
  anon_sym_case = 48,
  anon_sym_default = 49,
  anon_sym_while = 50,
  anon_sym_do = 51,
  anon_sym_for = 52,
  anon_sym_return = 53,
  anon_sym_break = 54,
  anon_sym_continue = 55,
  anon_sym_goto = 56,
  anon_sym_QMARK = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_PLUS_EQ = 61,
  anon_sym_DASH_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_AMP_EQ = 65,
  anon_sym_CARET_EQ = 66,
  anon_sym_PIPE_EQ = 67,
  anon_sym_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_BANG = 71,
  anon_sym_PIPE = 72,
  anon_sym_CARET = 73,
  anon_sym_TILDE = 74,
  anon_sym_EQ_EQ = 75,
  anon_sym_BANG_EQ = 76,
  anon_sym_LT = 77,
  anon_sym_GT = 78,
  anon_sym_LT_EQ = 79,
  anon_sym_GT_EQ = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_PLUS = 83,
  anon_sym_DASH = 84,
  anon_sym_SLASH = 85,
  anon_sym_PERCENT = 86,
  anon_sym_DASH_DASH = 87,
  anon_sym_PLUS_PLUS = 88,
  anon_sym_sizeof = 89,
  anon_sym_DOT = 90,
  anon_sym_DASH_GT = 91,
  sym_number_literal = 92,
  sym_char_literal = 93,
  sym_string_literal = 94,
  sym_system_lib_string = 95,
  sym_true = 96,
  sym_false = 97,
  sym_null = 98,
  sym_identifier = 99,
  sym_comment = 100,
  anon_sym_class = 101,
  sym_virtual_specifier = 102,
  anon_sym_public = 103,
  sym_auto = 104,
  anon_sym_typename = 105,
  anon_sym_template = 106,
  anon_sym_friend = 107,
  anon_sym_private = 108,
  anon_sym_protected = 109,
  sym_noexcept = 110,
  anon_sym_namespace = 111,
  anon_sym_using = 112,
  anon_sym_new = 113,
  anon_sym_COLON_COLON = 114,
  anon_sym_delete = 115,
  sym_operator_name = 116,
  sym_nullptr = 117,
  sym_translation_unit = 118,
  sym_preproc_include = 119,
  sym_preproc_def = 120,
  sym_preproc_function_def = 121,
  sym_preproc_params = 122,
  sym_preproc_call = 123,
  sym_preproc_if = 124,
  sym_preproc_ifdef = 125,
  sym_preproc_else = 126,
  sym_preproc_elif = 127,
  sym_preproc_if_in_compound_statement = 128,
  sym_preproc_ifdef_in_compound_statement = 129,
  sym_preproc_else_in_compound_statement = 130,
  sym_preproc_elif_in_compound_statement = 131,
  sym_preproc_if_in_field_declaration_list = 132,
  sym_preproc_ifdef_in_field_declaration_list = 133,
  sym_preproc_else_in_field_declaration_list = 134,
  sym_preproc_elif_in_field_declaration_list = 135,
  sym_function_definition = 136,
  sym_declaration = 137,
  sym_type_definition = 138,
  sym__declaration_specifiers = 139,
  sym_linkage_specification = 140,
  sym_declaration_list = 141,
  sym__declarator = 142,
  sym__field_declarator = 143,
  sym__type_declarator = 144,
  sym__abstract_declarator = 145,
  sym_pointer_declarator = 146,
  sym_pointer_field_declarator = 147,
  sym_pointer_type_declarator = 148,
  sym_abstract_pointer_declarator = 149,
  sym_function_declarator = 150,
  sym_function_field_declarator = 151,
  sym_function_type_declarator = 152,
  sym_abstract_function_declarator = 153,
  sym_array_declarator = 154,
  sym_array_field_declarator = 155,
  sym_array_type_declarator = 156,
  sym_abstract_array_declarator = 157,
  sym_init_declarator = 158,
  sym_compound_statement = 159,
  sym_storage_class_specifier = 160,
  sym_type_qualifier = 161,
  sym__type_specifier = 162,
  sym_sized_type_specifier = 163,
  sym_enum_specifier = 164,
  sym_enumerator_list = 165,
  sym_struct_specifier = 166,
  sym_union_specifier = 167,
  sym_field_declaration_list = 168,
  sym__field_declaration_list_item = 169,
  sym_field_declaration = 170,
  sym_enumerator = 171,
  sym_parameter_list = 172,
  sym_parameter_declaration = 173,
  sym_labeled_statement = 174,
  sym_expression_statement = 175,
  sym_if_statement = 176,
  sym_switch_statement = 177,
  sym_case_statement = 178,
  sym_while_statement = 179,
  sym_do_statement = 180,
  sym_for_statement = 181,
  sym_return_statement = 182,
  sym_break_statement = 183,
  sym_continue_statement = 184,
  sym_goto_statement = 185,
  sym__expression = 186,
  sym_comma_expression = 187,
  sym_conditional_expression = 188,
  sym_assignment_expression = 189,
  sym_pointer_expression = 190,
  sym_logical_expression = 191,
  sym_bitwise_expression = 192,
  sym_equality_expression = 193,
  sym_relational_expression = 194,
  sym_shift_expression = 195,
  sym_math_expression = 196,
  sym_cast_expression = 197,
  sym_type_descriptor = 198,
  sym_sizeof_expression = 199,
  sym_subscript_expression = 200,
  sym_call_expression = 201,
  sym_argument_list = 202,
  sym_field_expression = 203,
  sym_compound_literal_expression = 204,
  sym_parenthesized_expression = 205,
  sym_initializer_list = 206,
  sym_initializer_pair = 207,
  sym_subscript_designator = 208,
  sym_field_designator = 209,
  sym_concatenated_string = 210,
  sym__empty_declaration = 211,
  sym_macro_type_specifier = 212,
  sym_class_specifier = 213,
  sym__class_name = 214,
  sym_base_class_clause = 215,
  sym_dependent_type = 216,
  sym_structured_binding_declaration = 217,
  sym_template_declaration = 218,
  sym_template_instantiation = 219,
  sym_template_parameter_list = 220,
  sym_type_parameter_declaration = 221,
  sym_optional_type_parameter_declaration = 222,
  sym_field_initializer_list = 223,
  sym_field_initializer = 224,
  sym_inline_method_definition = 225,
  sym_constructor_or_destructor_definition = 226,
  sym_constructor_or_destructor_declaration = 227,
  sym_friend_declaration = 228,
  sym_access_specifier = 229,
  sym_reference_declarator = 230,
  sym_reference_field_declarator = 231,
  sym_abstract_reference_declarator = 232,
  sym_structured_binding_reference_declarator = 233,
  sym_structured_binding_declarator = 234,
  sym_trailing_return_type = 235,
  sym_template_type = 236,
  sym_template_method = 237,
  sym_template_function = 238,
  sym_template_argument_list = 239,
  sym_namespace_definition = 240,
  sym_using_declaration = 241,
  sym_alias_declaration = 242,
  sym_for_range_loop = 243,
  sym_for_range_declaration = 244,
  sym_new_expression = 245,
  sym_new_declarator = 246,
  sym_delete_expression = 247,
  sym_lambda_expression = 248,
  sym_lambda_capture_specifier = 249,
  sym_lambda_default_capture = 250,
  sym_destructor_name = 251,
  sym_scoped_field_identifier = 252,
  sym_scoped_identifier = 253,
  sym_scoped_type_identifier = 254,
  sym_scoped_namespace_identifier = 255,
  aux_sym_translation_unit_repeat1 = 256,
  aux_sym_preproc_params_repeat1 = 257,
  aux_sym_preproc_if_in_compound_statement_repeat1 = 258,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 259,
  aux_sym_declaration_repeat1 = 260,
  aux_sym_type_definition_repeat1 = 261,
  aux_sym__declaration_specifiers_repeat1 = 262,
  aux_sym_function_declarator_repeat1 = 263,
  aux_sym_abstract_function_declarator_repeat1 = 264,
  aux_sym_sized_type_specifier_repeat1 = 265,
  aux_sym_enumerator_list_repeat1 = 266,
  aux_sym_field_declaration_repeat1 = 267,
  aux_sym_parameter_list_repeat1 = 268,
  aux_sym_for_statement_repeat1 = 269,
  aux_sym_argument_list_repeat1 = 270,
  aux_sym_initializer_list_repeat1 = 271,
  aux_sym_initializer_pair_repeat1 = 272,
  aux_sym_concatenated_string_repeat1 = 273,
  aux_sym_base_class_clause_repeat1 = 274,
  aux_sym_template_parameter_list_repeat1 = 275,
  aux_sym_field_initializer_list_repeat1 = 276,
  aux_sym_structured_binding_declarator_repeat1 = 277,
  aux_sym_template_argument_list_repeat1 = 278,
  anon_alias_sym_POUNDdefine = 279,
  anon_alias_sym_POUNDelif = 280,
  anon_alias_sym_POUNDelse = 281,
  anon_alias_sym_POUNDendif = 282,
  anon_alias_sym_POUNDif = 283,
  anon_alias_sym_POUNDifdef = 284,
  anon_alias_sym_POUNDifndef = 285,
  anon_alias_sym_POUNDinclude = 286,
  alias_sym_array_declarator = 287,
  alias_sym_declaration = 288,
  alias_sym_field_identifier = 289,
  alias_sym_function_declarator = 290,
  alias_sym_function_definition = 291,
  alias_sym_namespace_identifier = 292,
  alias_sym_pointer_declarator = 293,
  alias_sym_preproc_elif = 294,
  alias_sym_preproc_else = 295,
  alias_sym_preproc_if = 296,
  alias_sym_preproc_ifdef = 297,
  alias_sym_reference_declarator = 298,
  alias_sym_statement_identifier = 299,
  alias_sym_type_identifier = 300,
};

static const char *ts_symbol_names[] = {
  [sym_raw_string_literal] = "raw_string_literal",
  [ts_builtin_sym_end] = "END",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = "/#[ 	]*include/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = "/#[ 	]*define/",
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = "/[ \\t]+/",
  [anon_sym_LF] = "\n",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = "/#[ 	]*if/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = "/#[ 	]*endif/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = "/#[ 	]*ifdef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = "/#[ 	]*ifndef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = "/#[ 	]*else/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = "/#[ 	]*elif/",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_restrict] = "restrict",
  [anon_sym_volatile] = "volatile",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_mutable] = "mutable",
  [anon_sym_explicit] = "explicit",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [sym_char_literal] = "char_literal",
  [sym_string_literal] = "string_literal",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [anon_sym_class] = "class",
  [sym_virtual_specifier] = "virtual_specifier",
  [anon_sym_public] = "public",
  [sym_auto] = "auto",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_friend] = "friend",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [sym_noexcept] = "noexcept",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_new] = "new",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_delete] = "delete",
  [sym_operator_name] = "operator_name",
  [sym_nullptr] = "nullptr",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_compound_statement] = "preproc_if_in_compound_statement",
  [sym_preproc_ifdef_in_compound_statement] = "preproc_ifdef_in_compound_statement",
  [sym_preproc_else_in_compound_statement] = "preproc_else_in_compound_statement",
  [sym_preproc_elif_in_compound_statement] = "preproc_elif_in_compound_statement",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if_in_field_declaration_list",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef_in_field_declaration_list",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else_in_field_declaration_list",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif_in_field_declaration_list",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_field_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_field_declarator",
  [sym_function_type_declarator] = "function_type_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_field_declarator",
  [sym_array_type_declarator] = "array_type_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_math_expression] = "math_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_concatenated_string] = "concatenated_string",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_base_class_clause] = "base_class_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_structured_binding_declaration] = "structured_binding_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "inline_method_definition",
  [sym_constructor_or_destructor_definition] = "constructor_or_destructor_definition",
  [sym_constructor_or_destructor_declaration] = "constructor_or_destructor_declaration",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_field_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_reference_declarator] = "structured_binding_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_for_range_loop] = "for_range_loop",
  [sym_for_range_declaration] = "for_range_declaration",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym_destructor_name] = "destructor_name",
  [sym_scoped_field_identifier] = "scoped_field_identifier",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_scoped_namespace_identifier] = "scoped_namespace_identifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_compound_statement_repeat1] = "preproc_if_in_compound_statement_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_abstract_function_declarator_repeat1] = "abstract_function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [anon_alias_sym_POUNDdefine] = "#define",
  [anon_alias_sym_POUNDelif] = "#elif",
  [anon_alias_sym_POUNDelse] = "#else",
  [anon_alias_sym_POUNDendif] = "#endif",
  [anon_alias_sym_POUNDif] = "#if",
  [anon_alias_sym_POUNDifdef] = "#ifdef",
  [anon_alias_sym_POUNDifndef] = "#ifndef",
  [anon_alias_sym_POUNDinclude] = "#include",
  [alias_sym_array_declarator] = "array_declarator",
  [alias_sym_declaration] = "declaration",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_function_declarator] = "function_declarator",
  [alias_sym_function_definition] = "function_definition",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_pointer_declarator] = "pointer_declarator",
  [alias_sym_preproc_elif] = "preproc_elif",
  [alias_sym_preproc_else] = "preproc_else",
  [alias_sym_preproc_if] = "preproc_if",
  [alias_sym_preproc_ifdef] = "preproc_ifdef",
  [alias_sym_reference_declarator] = "reference_declarator",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_nullptr] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_abstract_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_POUNDdefine] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifdef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifndef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDinclude] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[53][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [0] = alias_sym_function_definition,
  },
  [3] = {
    [0] = anon_alias_sym_POUNDinclude,
  },
  [4] = {
    [1] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = alias_sym_namespace_identifier,
  },
  [6] = {
    [0] = anon_alias_sym_POUNDdefine,
  },
  [7] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = anon_alias_sym_POUNDendif,
  },
  [8] = {
    [0] = anon_alias_sym_POUNDelse,
  },
  [9] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [10] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [11] = {
    [0] = alias_sym_pointer_declarator,
  },
  [12] = {
    [0] = alias_sym_function_declarator,
  },
  [13] = {
    [0] = alias_sym_array_declarator,
  },
  [14] = {
    [0] = alias_sym_preproc_if,
  },
  [15] = {
    [0] = alias_sym_preproc_ifdef,
  },
  [16] = {
    [0] = alias_sym_declaration,
  },
  [17] = {
    [0] = alias_sym_namespace_identifier,
  },
  [18] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_namespace_identifier,
  },
  [20] = {
    [2] = alias_sym_type_identifier,
  },
  [21] = {
    [2] = alias_sym_namespace_identifier,
  },
  [22] = {
    [0] = anon_alias_sym_POUNDelif,
  },
  [23] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [24] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [25] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [26] = {
    [0] = alias_sym_field_identifier,
  },
  [27] = {
    [0] = alias_sym_reference_declarator,
  },
  [28] = {
    [1] = alias_sym_reference_declarator,
  },
  [29] = {
    [1] = alias_sym_field_identifier,
  },
  [30] = {
    [0] = anon_alias_sym_POUNDif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [31] = {
    [0] = anon_alias_sym_POUNDifdef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [32] = {
    [0] = anon_alias_sym_POUNDifndef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [33] = {
    [2] = alias_sym_field_identifier,
  },
  [34] = {
    [1] = alias_sym_statement_identifier,
  },
  [35] = {
    [0] = alias_sym_statement_identifier,
  },
  [36] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_field_identifier,
  },
  [37] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [38] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [39] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [40] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [41] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [42] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [43] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_else,
  },
  [44] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_elif,
  },
  [45] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [46] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [47] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [48] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [49] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [50] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [51] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_else,
  },
  [52] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_elif,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(62);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 6:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(7);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'n')
        ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(27);
      if (lookahead == 'n')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u')
        ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 45:
      if (lookahead == '\\')
        ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(49);
      END_STATE();
    case 46:
      if (lookahead == '\'')
        ADVANCE(47);
      if (lookahead != 0)
        ADVANCE(49);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_char_literal);
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 49:
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      if (lookahead == '=')
        ADVANCE(56);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == '.')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(69);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'b')
        ADVANCE(75);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == 'x')
        ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      END_STATE();
    case 75:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(78);
      if (lookahead == 'U')
        ADVANCE(78);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '=')
        ADVANCE(86);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(106);
      if (lookahead == '%')
        ADVANCE(106);
      if (lookahead == '&')
        ADVANCE(108);
      if (lookahead == '(')
        ADVANCE(109);
      if (lookahead == '*')
        ADVANCE(106);
      if (lookahead == '+')
        ADVANCE(110);
      if (lookahead == ',')
        ADVANCE(107);
      if (lookahead == '-')
        ADVANCE(111);
      if (lookahead == '/')
        ADVANCE(106);
      if (lookahead == '<')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(114);
      if (lookahead == '[')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(116);
      if (lookahead == '~')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_operator_name);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '&')
        ADVANCE(107);
      if (lookahead == '=')
        ADVANCE(107);
      END_STATE();
    case 109:
      if (lookahead == ')')
        ADVANCE(107);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '+')
        ADVANCE(107);
      if (lookahead == '=')
        ADVANCE(107);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '-')
        ADVANCE(107);
      if (lookahead == '=')
        ADVANCE(107);
      if (lookahead == '>')
        ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '*')
        ADVANCE(107);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '<')
        ADVANCE(106);
      if (lookahead == '=')
        ADVANCE(107);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(107);
      if (lookahead == '>')
        ADVANCE(106);
      END_STATE();
    case 115:
      if (lookahead == ']')
        ADVANCE(107);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(107);
      if (lookahead == '|')
        ADVANCE(107);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(120);
      if (lookahead == '|')
        ADVANCE(121);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 124:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(125);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 125:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(125);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(43);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 128:
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      END_STATE();
    case 129:
      if (lookahead == ':')
        ADVANCE(81);
      END_STATE();
    case 130:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '<')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(130);
      END_STATE();
    case 131:
      if (lookahead == '>')
        ADVANCE(132);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 133:
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(131);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>')
        ADVANCE(132);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(131);
      END_STATE();
    case 135:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(136);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 136:
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(141);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(149);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*')
        ADVANCE(143);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(148);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead != 0)
        ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead != 0)
        ADVANCE(143);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(143);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead != 0)
        ADVANCE(143);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(148);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '\r')
        SKIP(150);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(152);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(152);
      END_STATE();
    case 153:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 154:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      END_STATE();
    case 155:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 156:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(157);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 158:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(125);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 159:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 160:
      if (lookahead == '#')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 161:
      if (lookahead == 'i')
        ADVANCE(162);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(161);
      END_STATE();
    case 162:
      if (lookahead == 'f')
        ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(164);
      if (lookahead == 'n')
        ADVANCE(167);
      END_STATE();
    case 164:
      if (lookahead == 'e')
        ADVANCE(165);
      END_STATE();
    case 165:
      if (lookahead == 'f')
        ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      END_STATE();
    case 167:
      if (lookahead == 'd')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'e')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'f')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      END_STATE();
    case 171:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(157);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 172:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 173:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(157);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 174:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 175:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '.')
        ADVANCE(180);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      END_STATE();
    case 180:
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 182:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(125);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(148);
      END_STATE();
    case 185:
      if (lookahead == '#')
        ADVANCE(186);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 186:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(187);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(186);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(189);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 189:
      if (lookahead == 'e')
        ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(189);
      END_STATE();
    case 190:
      if (lookahead == 'n')
        ADVANCE(191);
      END_STATE();
    case 191:
      if (lookahead == 'd')
        ADVANCE(192);
      END_STATE();
    case 192:
      if (lookahead == 'i')
        ADVANCE(193);
      END_STATE();
    case 193:
      if (lookahead == 'f')
        ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      END_STATE();
    case 196:
      if (lookahead == '#')
        ADVANCE(197);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 197:
      if (lookahead == 'e')
        ADVANCE(198);
      if (lookahead == 'i')
        ADVANCE(162);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(197);
      END_STATE();
    case 198:
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'n')
        ADVANCE(191);
      END_STATE();
    case 199:
      if (lookahead == 'i')
        ADVANCE(200);
      if (lookahead == 's')
        ADVANCE(202);
      END_STATE();
    case 200:
      if (lookahead == 'f')
        ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      END_STATE();
    case 202:
      if (lookahead == 'e')
        ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      END_STATE();
    case 204:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(157);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 205:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 206:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 207:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 208:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(139);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 210:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 211:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 212:
      if (lookahead == '#')
        ADVANCE(197);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 213:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 214:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      END_STATE();
    case 215:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '.')
        ADVANCE(180);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 216:
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '.')
        ADVANCE(180);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 217:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(125);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 218:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 219:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 220:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 222:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(126);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 223:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == ']')
        ADVANCE(95);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(98);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 224:
      if (lookahead == '!')
        ADVANCE(176);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(186);
      if (lookahead == '&')
        ADVANCE(177);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(178);
      if (lookahead == '-')
        ADVANCE(179);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 225:
      if (lookahead == '!')
        ADVANCE(174);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(157);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    case 227:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(89);
      if (lookahead == '?')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(94);
      if (lookahead == '^')
        ADVANCE(96);
      if (lookahead == '{')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F')
        ADVANCE(1);
      if (lookahead == 'N')
        ADVANCE(6);
      if (lookahead == 'T')
        ADVANCE(10);
      if (lookahead == '_')
        ADVANCE(14);
      if (lookahead == 'a')
        ADVANCE(21);
      if (lookahead == 'b')
        ADVANCE(25);
      if (lookahead == 'c')
        ADVANCE(33);
      if (lookahead == 'd')
        ADVANCE(64);
      if (lookahead == 'e')
        ADVANCE(79);
      if (lookahead == 'f')
        ADVANCE(97);
      if (lookahead == 'g')
        ADVANCE(114);
      if (lookahead == 'i')
        ADVANCE(118);
      if (lookahead == 'l')
        ADVANCE(125);
      if (lookahead == 'm')
        ADVANCE(129);
      if (lookahead == 'n')
        ADVANCE(136);
      if (lookahead == 'p')
        ADVANCE(160);
      if (lookahead == 'r')
        ADVANCE(179);
      if (lookahead == 's')
        ADVANCE(197);
      if (lookahead == 't')
        ADVANCE(224);
      if (lookahead == 'u')
        ADVANCE(244);
      if (lookahead == 'v')
        ADVANCE(262);
      if (lookahead == 'w')
        ADVANCE(271);
      END_STATE();
    case 1:
      if (lookahead == 'A')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'L')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'S')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'E')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 6:
      if (lookahead == 'U')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'L')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'L')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 10:
      if (lookahead == 'R')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'U')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'E')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 14:
      if (lookahead == 'A')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 't')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'o')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'm')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'i')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'c')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 21:
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 't')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'o')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 25:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'a')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'k')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      if (lookahead == 'h')
        ADVANCE(37);
      if (lookahead == 'l')
        ADVANCE(47);
      if (lookahead == 'o')
        ADVANCE(51);
      END_STATE();
    case 34:
      if (lookahead == 's')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'e')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1')
        ADVANCE(40);
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(44);
      if (lookahead == '8')
        ADVANCE(41);
      if (lookahead == 'p')
        ADVANCE(45);
      END_STATE();
    case 40:
      if (lookahead == '6')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == '_')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 43:
      if (lookahead == '2')
        ADVANCE(41);
      END_STATE();
    case 44:
      if (lookahead == '4')
        ADVANCE(41);
      END_STATE();
    case 45:
      if (lookahead == 't')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'r')
        ADVANCE(41);
      END_STATE();
    case 47:
      if (lookahead == 'a')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 's')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 's')
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 51:
      if (lookahead == 'n')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 's')
        ADVANCE(53);
      if (lookahead == 't')
        ADVANCE(59);
      END_STATE();
    case 53:
      if (lookahead == 't')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 'x')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'p')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 'r')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 59:
      if (lookahead == 'i')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'n')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 'u')
        ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == 'e')
        ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead == 'o')
        ADVANCE(75);
      END_STATE();
    case 65:
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'l')
        ADVANCE(71);
      END_STATE();
    case 66:
      if (lookahead == 'a')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'u')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'l')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 't')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 71:
      if (lookahead == 'e')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 't')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'e')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'b')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == 'l')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'e')
        ADVANCE(28);
      END_STATE();
    case 79:
      if (lookahead == 'l')
        ADVANCE(80);
      if (lookahead == 'n')
        ADVANCE(83);
      if (lookahead == 'x')
        ADVANCE(86);
      END_STATE();
    case 80:
      if (lookahead == 's')
        ADVANCE(81);
      END_STATE();
    case 81:
      if (lookahead == 'e')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 83:
      if (lookahead == 'u')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'm')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 86:
      if (lookahead == 'p')
        ADVANCE(87);
      if (lookahead == 't')
        ADVANCE(93);
      END_STATE();
    case 87:
      if (lookahead == 'l')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == 'i')
        ADVANCE(89);
      END_STATE();
    case 89:
      if (lookahead == 'c')
        ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == 'i')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 't')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 93:
      if (lookahead == 'e')
        ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 'r')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'n')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 97:
      if (lookahead == 'a')
        ADVANCE(98);
      if (lookahead == 'i')
        ADVANCE(101);
      if (lookahead == 'l')
        ADVANCE(105);
      if (lookahead == 'o')
        ADVANCE(107);
      if (lookahead == 'r')
        ADVANCE(109);
      END_STATE();
    case 98:
      if (lookahead == 'l')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 's')
        ADVANCE(100);
      END_STATE();
    case 100:
      if (lookahead == 'e')
        ADVANCE(5);
      END_STATE();
    case 101:
      if (lookahead == 'n')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'a')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'l')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_virtual_specifier);
      END_STATE();
    case 105:
      if (lookahead == 'o')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 107:
      if (lookahead == 'r')
        ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 109:
      if (lookahead == 'i')
        ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == 'e')
        ADVANCE(111);
      END_STATE();
    case 111:
      if (lookahead == 'n')
        ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == 'd')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 114:
      if (lookahead == 'o')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 't')
        ADVANCE(116);
      END_STATE();
    case 116:
      if (lookahead == 'o')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 118:
      if (lookahead == 'f')
        ADVANCE(119);
      if (lookahead == 'n')
        ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 120:
      if (lookahead == 'l')
        ADVANCE(121);
      if (lookahead == 't')
        ADVANCE(39);
      END_STATE();
    case 121:
      if (lookahead == 'i')
        ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == 'e')
        ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 125:
      if (lookahead == 'o')
        ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == 'n')
        ADVANCE(127);
      END_STATE();
    case 127:
      if (lookahead == 'g')
        ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 129:
      if (lookahead == 'u')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == 'a')
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'b')
        ADVANCE(133);
      END_STATE();
    case 133:
      if (lookahead == 'l')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == 'e')
        ADVANCE(135);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 136:
      if (lookahead == 'a')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(145);
      if (lookahead == 'o')
        ADVANCE(147);
      if (lookahead == 'u')
        ADVANCE(154);
      END_STATE();
    case 137:
      if (lookahead == 'm')
        ADVANCE(138);
      END_STATE();
    case 138:
      if (lookahead == 'e')
        ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == 's')
        ADVANCE(140);
      END_STATE();
    case 140:
      if (lookahead == 'p')
        ADVANCE(141);
      END_STATE();
    case 141:
      if (lookahead == 'a')
        ADVANCE(142);
      END_STATE();
    case 142:
      if (lookahead == 'c')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'e')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 145:
      if (lookahead == 'w')
        ADVANCE(146);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 147:
      if (lookahead == 'e')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'x')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == 'c')
        ADVANCE(150);
      END_STATE();
    case 150:
      if (lookahead == 'e')
        ADVANCE(151);
      END_STATE();
    case 151:
      if (lookahead == 'p')
        ADVANCE(152);
      END_STATE();
    case 152:
      if (lookahead == 't')
        ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_noexcept);
      END_STATE();
    case 154:
      if (lookahead == 'l')
        ADVANCE(155);
      END_STATE();
    case 155:
      if (lookahead == 'l')
        ADVANCE(156);
      END_STATE();
    case 156:
      if (lookahead == 'p')
        ADVANCE(157);
      END_STATE();
    case 157:
      if (lookahead == 't')
        ADVANCE(158);
      END_STATE();
    case 158:
      if (lookahead == 'r')
        ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_nullptr);
      END_STATE();
    case 160:
      if (lookahead == 'r')
        ADVANCE(161);
      if (lookahead == 'u')
        ADVANCE(174);
      END_STATE();
    case 161:
      if (lookahead == 'i')
        ADVANCE(162);
      if (lookahead == 'o')
        ADVANCE(167);
      END_STATE();
    case 162:
      if (lookahead == 'v')
        ADVANCE(163);
      END_STATE();
    case 163:
      if (lookahead == 'a')
        ADVANCE(164);
      END_STATE();
    case 164:
      if (lookahead == 't')
        ADVANCE(165);
      END_STATE();
    case 165:
      if (lookahead == 'e')
        ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 167:
      if (lookahead == 't')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'e')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'c')
        ADVANCE(170);
      END_STATE();
    case 170:
      if (lookahead == 't')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'e')
        ADVANCE(172);
      END_STATE();
    case 172:
      if (lookahead == 'd')
        ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 174:
      if (lookahead == 'b')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'l')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'i')
        ADVANCE(177);
      END_STATE();
    case 177:
      if (lookahead == 'c')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 179:
      if (lookahead == 'e')
        ADVANCE(180);
      END_STATE();
    case 180:
      if (lookahead == 'g')
        ADVANCE(181);
      if (lookahead == 's')
        ADVANCE(187);
      if (lookahead == 't')
        ADVANCE(193);
      END_STATE();
    case 181:
      if (lookahead == 'i')
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == 's')
        ADVANCE(183);
      END_STATE();
    case 183:
      if (lookahead == 't')
        ADVANCE(184);
      END_STATE();
    case 184:
      if (lookahead == 'e')
        ADVANCE(185);
      END_STATE();
    case 185:
      if (lookahead == 'r')
        ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 187:
      if (lookahead == 't')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == 'r')
        ADVANCE(189);
      END_STATE();
    case 189:
      if (lookahead == 'i')
        ADVANCE(190);
      END_STATE();
    case 190:
      if (lookahead == 'c')
        ADVANCE(191);
      END_STATE();
    case 191:
      if (lookahead == 't')
        ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 193:
      if (lookahead == 'u')
        ADVANCE(194);
      END_STATE();
    case 194:
      if (lookahead == 'r')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'n')
        ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 197:
      if (lookahead == 'h')
        ADVANCE(198);
      if (lookahead == 'i')
        ADVANCE(202);
      if (lookahead == 's')
        ADVANCE(207);
      if (lookahead == 't')
        ADVANCE(210);
      if (lookahead == 'w')
        ADVANCE(219);
      END_STATE();
    case 198:
      if (lookahead == 'o')
        ADVANCE(199);
      END_STATE();
    case 199:
      if (lookahead == 'r')
        ADVANCE(200);
      END_STATE();
    case 200:
      if (lookahead == 't')
        ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 202:
      if (lookahead == 'z')
        ADVANCE(203);
      END_STATE();
    case 203:
      if (lookahead == 'e')
        ADVANCE(204);
      END_STATE();
    case 204:
      if (lookahead == '_')
        ADVANCE(42);
      if (lookahead == 'o')
        ADVANCE(205);
      END_STATE();
    case 205:
      if (lookahead == 'f')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 207:
      if (lookahead == 'i')
        ADVANCE(208);
      END_STATE();
    case 208:
      if (lookahead == 'z')
        ADVANCE(209);
      END_STATE();
    case 209:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 210:
      if (lookahead == 'a')
        ADVANCE(211);
      if (lookahead == 'r')
        ADVANCE(215);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(212);
      END_STATE();
    case 212:
      if (lookahead == 'i')
        ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == 'c')
        ADVANCE(214);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 215:
      if (lookahead == 'u')
        ADVANCE(216);
      END_STATE();
    case 216:
      if (lookahead == 'c')
        ADVANCE(217);
      END_STATE();
    case 217:
      if (lookahead == 't')
        ADVANCE(218);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 219:
      if (lookahead == 'i')
        ADVANCE(220);
      END_STATE();
    case 220:
      if (lookahead == 't')
        ADVANCE(221);
      END_STATE();
    case 221:
      if (lookahead == 'c')
        ADVANCE(222);
      END_STATE();
    case 222:
      if (lookahead == 'h')
        ADVANCE(223);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 224:
      if (lookahead == 'e')
        ADVANCE(225);
      if (lookahead == 'r')
        ADVANCE(232);
      if (lookahead == 'y')
        ADVANCE(234);
      END_STATE();
    case 225:
      if (lookahead == 'm')
        ADVANCE(226);
      END_STATE();
    case 226:
      if (lookahead == 'p')
        ADVANCE(227);
      END_STATE();
    case 227:
      if (lookahead == 'l')
        ADVANCE(228);
      END_STATE();
    case 228:
      if (lookahead == 'a')
        ADVANCE(229);
      END_STATE();
    case 229:
      if (lookahead == 't')
        ADVANCE(230);
      END_STATE();
    case 230:
      if (lookahead == 'e')
        ADVANCE(231);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 232:
      if (lookahead == 'u')
        ADVANCE(233);
      END_STATE();
    case 233:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 234:
      if (lookahead == 'p')
        ADVANCE(235);
      END_STATE();
    case 235:
      if (lookahead == 'e')
        ADVANCE(236);
      END_STATE();
    case 236:
      if (lookahead == 'd')
        ADVANCE(237);
      if (lookahead == 'n')
        ADVANCE(240);
      END_STATE();
    case 237:
      if (lookahead == 'e')
        ADVANCE(238);
      END_STATE();
    case 238:
      if (lookahead == 'f')
        ADVANCE(239);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 240:
      if (lookahead == 'a')
        ADVANCE(241);
      END_STATE();
    case 241:
      if (lookahead == 'm')
        ADVANCE(242);
      END_STATE();
    case 242:
      if (lookahead == 'e')
        ADVANCE(243);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 244:
      if (lookahead == 'i')
        ADVANCE(245);
      if (lookahead == 'n')
        ADVANCE(248);
      if (lookahead == 's')
        ADVANCE(258);
      END_STATE();
    case 245:
      if (lookahead == 'n')
        ADVANCE(246);
      END_STATE();
    case 246:
      if (lookahead == 't')
        ADVANCE(247);
      END_STATE();
    case 247:
      if (lookahead == '1')
        ADVANCE(40);
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(44);
      if (lookahead == '8')
        ADVANCE(41);
      if (lookahead == 'p')
        ADVANCE(45);
      END_STATE();
    case 248:
      if (lookahead == 'i')
        ADVANCE(249);
      if (lookahead == 's')
        ADVANCE(252);
      END_STATE();
    case 249:
      if (lookahead == 'o')
        ADVANCE(250);
      END_STATE();
    case 250:
      if (lookahead == 'n')
        ADVANCE(251);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 252:
      if (lookahead == 'i')
        ADVANCE(253);
      END_STATE();
    case 253:
      if (lookahead == 'g')
        ADVANCE(254);
      END_STATE();
    case 254:
      if (lookahead == 'n')
        ADVANCE(255);
      END_STATE();
    case 255:
      if (lookahead == 'e')
        ADVANCE(256);
      END_STATE();
    case 256:
      if (lookahead == 'd')
        ADVANCE(257);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 258:
      if (lookahead == 'i')
        ADVANCE(259);
      END_STATE();
    case 259:
      if (lookahead == 'n')
        ADVANCE(260);
      END_STATE();
    case 260:
      if (lookahead == 'g')
        ADVANCE(261);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 262:
      if (lookahead == 'o')
        ADVANCE(263);
      END_STATE();
    case 263:
      if (lookahead == 'i')
        ADVANCE(264);
      if (lookahead == 'l')
        ADVANCE(265);
      END_STATE();
    case 264:
      if (lookahead == 'd')
        ADVANCE(28);
      END_STATE();
    case 265:
      if (lookahead == 'a')
        ADVANCE(266);
      END_STATE();
    case 266:
      if (lookahead == 't')
        ADVANCE(267);
      END_STATE();
    case 267:
      if (lookahead == 'i')
        ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == 'l')
        ADVANCE(269);
      END_STATE();
    case 269:
      if (lookahead == 'e')
        ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 271:
      if (lookahead == 'h')
        ADVANCE(272);
      END_STATE();
    case 272:
      if (lookahead == 'i')
        ADVANCE(273);
      END_STATE();
    case 273:
      if (lookahead == 'l')
        ADVANCE(274);
      END_STATE();
    case 274:
      if (lookahead == 'e')
        ADVANCE(275);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 124},
  [2] = {.lex_state = 130},
  [3] = {.lex_state = 135},
  [4] = {.lex_state = 124},
  [5] = {.lex_state = 141},
  [6] = {.lex_state = 135},
  [7] = {.lex_state = 135},
  [8] = {.lex_state = 150},
  [9] = {.lex_state = 135},
  [10] = {.lex_state = 153},
  [11] = {.lex_state = 124},
  [12] = {.lex_state = 124},
  [13] = {.lex_state = 124},
  [14] = {.lex_state = 135},
  [15] = {.lex_state = 135},
  [16] = {.lex_state = 135},
  [17] = {.lex_state = 124},
  [18] = {.lex_state = 135},
  [19] = {.lex_state = 153},
  [20] = {.lex_state = 135},
  [21] = {.lex_state = 135},
  [22] = {.lex_state = 153},
  [23] = {.lex_state = 135},
  [24] = {.lex_state = 135},
  [25] = {.lex_state = 124},
  [26] = {.lex_state = 154},
  [27] = {.lex_state = 155},
  [28] = {.lex_state = 0},
  [29] = {.lex_state = 156},
  [30] = {.lex_state = 155},
  [31] = {.lex_state = 158},
  [32] = {.lex_state = 153},
  [33] = {.lex_state = 135},
  [34] = {.lex_state = 153},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 124},
  [37] = {.lex_state = 124},
  [38] = {.lex_state = 155},
  [39] = {.lex_state = 158},
  [40] = {.lex_state = 150},
  [41] = {.lex_state = 124},
  [42] = {.lex_state = 124},
  [43] = {.lex_state = 135},
  [44] = {.lex_state = 124},
  [45] = {.lex_state = 156},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 135},
  [48] = {.lex_state = 155},
  [49] = {.lex_state = 155},
  [50] = {.lex_state = 155},
  [51] = {.lex_state = 141},
  [52] = {.lex_state = 158},
  [53] = {.lex_state = 135},
  [54] = {.lex_state = 135},
  [55] = {.lex_state = 135},
  [56] = {.lex_state = 135},
  [57] = {.lex_state = 135},
  [58] = {.lex_state = 135},
  [59] = {.lex_state = 135},
  [60] = {.lex_state = 135},
  [61] = {.lex_state = 135},
  [62] = {.lex_state = 135},
  [63] = {.lex_state = 135},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 135},
  [66] = {.lex_state = 135},
  [67] = {.lex_state = 135},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 159},
  [70] = {.lex_state = 153},
  [71] = {.lex_state = 153},
  [72] = {.lex_state = 160},
  [73] = {.lex_state = 135},
  [74] = {.lex_state = 153},
  [75] = {.lex_state = 156},
  [76] = {.lex_state = 135},
  [77] = {.lex_state = 153},
  [78] = {.lex_state = 153},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 153},
  [81] = {.lex_state = 153},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 156},
  [84] = {.lex_state = 153},
  [85] = {.lex_state = 153},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 171},
  [88] = {.lex_state = 135},
  [89] = {.lex_state = 124},
  [90] = {.lex_state = 153},
  [91] = {.lex_state = 156},
  [92] = {.lex_state = 153},
  [93] = {.lex_state = 153},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 153},
  [96] = {.lex_state = 135},
  [97] = {.lex_state = 153},
  [98] = {.lex_state = 153},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 135},
  [101] = {.lex_state = 124},
  [102] = {.lex_state = 135},
  [103] = {.lex_state = 124},
  [104] = {.lex_state = 135},
  [105] = {.lex_state = 172},
  [106] = {.lex_state = 135},
  [107] = {.lex_state = 124},
  [108] = {.lex_state = 124},
  [109] = {.lex_state = 155},
  [110] = {.lex_state = 124},
  [111] = {.lex_state = 135},
  [112] = {.lex_state = 124},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 135},
  [115] = {.lex_state = 124},
  [116] = {.lex_state = 158},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 158},
  [119] = {.lex_state = 159},
  [120] = {.lex_state = 135},
  [121] = {.lex_state = 124},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 155},
  [124] = {.lex_state = 153},
  [125] = {.lex_state = 173},
  [126] = {.lex_state = 158},
  [127] = {.lex_state = 124},
  [128] = {.lex_state = 135},
  [129] = {.lex_state = 153},
  [130] = {.lex_state = 159},
  [131] = {.lex_state = 155},
  [132] = {.lex_state = 135},
  [133] = {.lex_state = 135},
  [134] = {.lex_state = 175},
  [135] = {.lex_state = 181, .external_lex_state = 1},
  [136] = {.lex_state = 156},
  [137] = {.lex_state = 182, .external_lex_state = 1},
  [138] = {.lex_state = 135},
  [139] = {.lex_state = 158},
  [140] = {.lex_state = 0},
  [141] = {.lex_state = 153},
  [142] = {.lex_state = 153},
  [143] = {.lex_state = 155},
  [144] = {.lex_state = 124},
  [145] = {.lex_state = 173},
  [146] = {.lex_state = 153},
  [147] = {.lex_state = 124},
  [148] = {.lex_state = 156},
  [149] = {.lex_state = 155},
  [150] = {.lex_state = 124},
  [151] = {.lex_state = 153},
  [152] = {.lex_state = 153},
  [153] = {.lex_state = 155},
  [154] = {.lex_state = 141},
  [155] = {.lex_state = 158},
  [156] = {.lex_state = 175},
  [157] = {.lex_state = 183},
  [158] = {.lex_state = 156},
  [159] = {.lex_state = 156},
  [160] = {.lex_state = 124},
  [161] = {.lex_state = 135},
  [162] = {.lex_state = 135},
  [163] = {.lex_state = 171},
  [164] = {.lex_state = 156},
  [165] = {.lex_state = 124},
  [166] = {.lex_state = 130},
  [167] = {.lex_state = 135},
  [168] = {.lex_state = 141},
  [169] = {.lex_state = 158},
  [170] = {.lex_state = 135},
  [171] = {.lex_state = 135},
  [172] = {.lex_state = 185},
  [173] = {.lex_state = 141},
  [174] = {.lex_state = 150},
  [175] = {.lex_state = 135},
  [176] = {.lex_state = 153},
  [177] = {.lex_state = 153},
  [178] = {.lex_state = 135},
  [179] = {.lex_state = 135},
  [180] = {.lex_state = 188},
  [181] = {.lex_state = 155},
  [182] = {.lex_state = 156},
  [183] = {.lex_state = 155},
  [184] = {.lex_state = 155},
  [185] = {.lex_state = 124},
  [186] = {.lex_state = 158},
  [187] = {.lex_state = 188},
  [188] = {.lex_state = 155},
  [189] = {.lex_state = 158},
  [190] = {.lex_state = 188},
  [191] = {.lex_state = 155},
  [192] = {.lex_state = 195},
  [193] = {.lex_state = 159},
  [194] = {.lex_state = 135},
  [195] = {.lex_state = 135},
  [196] = {.lex_state = 160},
  [197] = {.lex_state = 135},
  [198] = {.lex_state = 156},
  [199] = {.lex_state = 135},
  [200] = {.lex_state = 135},
  [201] = {.lex_state = 156},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 135},
  [204] = {.lex_state = 156},
  [205] = {.lex_state = 0},
  [206] = {.lex_state = 156},
  [207] = {.lex_state = 135},
  [208] = {.lex_state = 156},
  [209] = {.lex_state = 0},
  [210] = {.lex_state = 135},
  [211] = {.lex_state = 135},
  [212] = {.lex_state = 135},
  [213] = {.lex_state = 156},
  [214] = {.lex_state = 135},
  [215] = {.lex_state = 156},
  [216] = {.lex_state = 0},
  [217] = {.lex_state = 135},
  [218] = {.lex_state = 135},
  [219] = {.lex_state = 135},
  [220] = {.lex_state = 135},
  [221] = {.lex_state = 135},
  [222] = {.lex_state = 155},
  [223] = {.lex_state = 135},
  [224] = {.lex_state = 135},
  [225] = {.lex_state = 135},
  [226] = {.lex_state = 135},
  [227] = {.lex_state = 135},
  [228] = {.lex_state = 135},
  [229] = {.lex_state = 135},
  [230] = {.lex_state = 135},
  [231] = {.lex_state = 135},
  [232] = {.lex_state = 135},
  [233] = {.lex_state = 158},
  [234] = {.lex_state = 124},
  [235] = {.lex_state = 135},
  [236] = {.lex_state = 158},
  [237] = {.lex_state = 153},
  [238] = {.lex_state = 159},
  [239] = {.lex_state = 159},
  [240] = {.lex_state = 153},
  [241] = {.lex_state = 141},
  [242] = {.lex_state = 135},
  [243] = {.lex_state = 135},
  [244] = {.lex_state = 135},
  [245] = {.lex_state = 153},
  [246] = {.lex_state = 135},
  [247] = {.lex_state = 135},
  [248] = {.lex_state = 172},
  [249] = {.lex_state = 135},
  [250] = {.lex_state = 156},
  [251] = {.lex_state = 135},
  [252] = {.lex_state = 135},
  [253] = {.lex_state = 135},
  [254] = {.lex_state = 135},
  [255] = {.lex_state = 124},
  [256] = {.lex_state = 196},
  [257] = {.lex_state = 196},
  [258] = {.lex_state = 172},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 204},
  [261] = {.lex_state = 172},
  [262] = {.lex_state = 196},
  [263] = {.lex_state = 196},
  [264] = {.lex_state = 172},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 160},
  [267] = {.lex_state = 124},
  [268] = {.lex_state = 172},
  [269] = {.lex_state = 135},
  [270] = {.lex_state = 135},
  [271] = {.lex_state = 135},
  [272] = {.lex_state = 135},
  [273] = {.lex_state = 135},
  [274] = {.lex_state = 135},
  [275] = {.lex_state = 135},
  [276] = {.lex_state = 153},
  [277] = {.lex_state = 153},
  [278] = {.lex_state = 0},
  [279] = {.lex_state = 153},
  [280] = {.lex_state = 156},
  [281] = {.lex_state = 135},
  [282] = {.lex_state = 153},
  [283] = {.lex_state = 153},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 156},
  [286] = {.lex_state = 188, .external_lex_state = 1},
  [287] = {.lex_state = 135},
  [288] = {.lex_state = 135},
  [289] = {.lex_state = 153},
  [290] = {.lex_state = 135},
  [291] = {.lex_state = 135},
  [292] = {.lex_state = 135},
  [293] = {.lex_state = 135},
  [294] = {.lex_state = 135},
  [295] = {.lex_state = 135},
  [296] = {.lex_state = 135},
  [297] = {.lex_state = 153},
  [298] = {.lex_state = 173},
  [299] = {.lex_state = 153},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 156},
  [302] = {.lex_state = 135},
  [303] = {.lex_state = 153},
  [304] = {.lex_state = 153},
  [305] = {.lex_state = 135},
  [306] = {.lex_state = 155},
  [307] = {.lex_state = 155},
  [308] = {.lex_state = 135},
  [309] = {.lex_state = 135},
  [310] = {.lex_state = 153},
  [311] = {.lex_state = 153},
  [312] = {.lex_state = 135},
  [313] = {.lex_state = 135},
  [314] = {.lex_state = 153},
  [315] = {.lex_state = 124},
  [316] = {.lex_state = 155},
  [317] = {.lex_state = 172},
  [318] = {.lex_state = 155},
  [319] = {.lex_state = 158},
  [320] = {.lex_state = 159},
  [321] = {.lex_state = 124},
  [322] = {.lex_state = 135},
  [323] = {.lex_state = 158},
  [324] = {.lex_state = 155},
  [325] = {.lex_state = 155},
  [326] = {.lex_state = 135},
  [327] = {.lex_state = 155},
  [328] = {.lex_state = 124},
  [329] = {.lex_state = 124},
  [330] = {.lex_state = 135},
  [331] = {.lex_state = 124},
  [332] = {.lex_state = 158},
  [333] = {.lex_state = 158},
  [334] = {.lex_state = 158},
  [335] = {.lex_state = 158},
  [336] = {.lex_state = 135},
  [337] = {.lex_state = 124},
  [338] = {.lex_state = 159},
  [339] = {.lex_state = 155},
  [340] = {.lex_state = 159},
  [341] = {.lex_state = 124},
  [342] = {.lex_state = 124},
  [343] = {.lex_state = 159},
  [344] = {.lex_state = 181},
  [345] = {.lex_state = 159},
  [346] = {.lex_state = 135},
  [347] = {.lex_state = 175, .external_lex_state = 1},
  [348] = {.lex_state = 124},
  [349] = {.lex_state = 158},
  [350] = {.lex_state = 182, .external_lex_state = 1},
  [351] = {.lex_state = 188, .external_lex_state = 1},
  [352] = {.lex_state = 158},
  [353] = {.lex_state = 159},
  [354] = {.lex_state = 135},
  [355] = {.lex_state = 155},
  [356] = {.lex_state = 205, .external_lex_state = 1},
  [357] = {.lex_state = 206, .external_lex_state = 1},
  [358] = {.lex_state = 188, .external_lex_state = 1},
  [359] = {.lex_state = 155},
  [360] = {.lex_state = 188, .external_lex_state = 1},
  [361] = {.lex_state = 155},
  [362] = {.lex_state = 156},
  [363] = {.lex_state = 171},
  [364] = {.lex_state = 135},
  [365] = {.lex_state = 207},
  [366] = {.lex_state = 207},
  [367] = {.lex_state = 135},
  [368] = {.lex_state = 207},
  [369] = {.lex_state = 188, .external_lex_state = 1},
  [370] = {.lex_state = 188, .external_lex_state = 1},
  [371] = {.lex_state = 208, .external_lex_state = 1},
  [372] = {.lex_state = 171},
  [373] = {.lex_state = 135},
  [374] = {.lex_state = 135},
  [375] = {.lex_state = 135},
  [376] = {.lex_state = 188, .external_lex_state = 1},
  [377] = {.lex_state = 188, .external_lex_state = 1},
  [378] = {.lex_state = 188, .external_lex_state = 1},
  [379] = {.lex_state = 188, .external_lex_state = 1},
  [380] = {.lex_state = 209},
  [381] = {.lex_state = 209, .external_lex_state = 1},
  [382] = {.lex_state = 135},
  [383] = {.lex_state = 135},
  [384] = {.lex_state = 135},
  [385] = {.lex_state = 124},
  [386] = {.lex_state = 188, .external_lex_state = 1},
  [387] = {.lex_state = 181, .external_lex_state = 1},
  [388] = {.lex_state = 181, .external_lex_state = 1},
  [389] = {.lex_state = 209},
  [390] = {.lex_state = 181, .external_lex_state = 1},
  [391] = {.lex_state = 135},
  [392] = {.lex_state = 173},
  [393] = {.lex_state = 210, .external_lex_state = 1},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 135},
  [396] = {.lex_state = 181, .external_lex_state = 1},
  [397] = {.lex_state = 171},
  [398] = {.lex_state = 135},
  [399] = {.lex_state = 156},
  [400] = {.lex_state = 130},
  [401] = {.lex_state = 135},
  [402] = {.lex_state = 188, .external_lex_state = 1},
  [403] = {.lex_state = 141},
  [404] = {.lex_state = 135},
  [405] = {.lex_state = 135},
  [406] = {.lex_state = 150},
  [407] = {.lex_state = 182, .external_lex_state = 1},
  [408] = {.lex_state = 135},
  [409] = {.lex_state = 182, .external_lex_state = 1},
  [410] = {.lex_state = 158},
  [411] = {.lex_state = 188, .external_lex_state = 1},
  [412] = {.lex_state = 135},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 188, .external_lex_state = 1},
  [415] = {.lex_state = 156},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 188, .external_lex_state = 1},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 188, .external_lex_state = 1},
  [420] = {.lex_state = 155},
  [421] = {.lex_state = 155},
  [422] = {.lex_state = 135},
  [423] = {.lex_state = 188, .external_lex_state = 1},
  [424] = {.lex_state = 188, .external_lex_state = 1},
  [425] = {.lex_state = 188, .external_lex_state = 1},
  [426] = {.lex_state = 188, .external_lex_state = 1},
  [427] = {.lex_state = 159},
  [428] = {.lex_state = 211},
  [429] = {.lex_state = 124},
  [430] = {.lex_state = 188, .external_lex_state = 1},
  [431] = {.lex_state = 182, .external_lex_state = 1},
  [432] = {.lex_state = 182, .external_lex_state = 1},
  [433] = {.lex_state = 155},
  [434] = {.lex_state = 159},
  [435] = {.lex_state = 155},
  [436] = {.lex_state = 153},
  [437] = {.lex_state = 153},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 182, .external_lex_state = 1},
  [440] = {.lex_state = 135},
  [441] = {.lex_state = 135},
  [442] = {.lex_state = 124},
  [443] = {.lex_state = 135},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 158},
  [447] = {.lex_state = 155},
  [448] = {.lex_state = 153},
  [449] = {.lex_state = 173},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 155},
  [452] = {.lex_state = 195},
  [453] = {.lex_state = 156},
  [454] = {.lex_state = 183},
  [455] = {.lex_state = 158},
  [456] = {.lex_state = 195},
  [457] = {.lex_state = 135},
  [458] = {.lex_state = 135},
  [459] = {.lex_state = 156},
  [460] = {.lex_state = 135},
  [461] = {.lex_state = 155},
  [462] = {.lex_state = 150},
  [463] = {.lex_state = 155},
  [464] = {.lex_state = 155},
  [465] = {.lex_state = 155},
  [466] = {.lex_state = 130},
  [467] = {.lex_state = 135},
  [468] = {.lex_state = 141},
  [469] = {.lex_state = 135},
  [470] = {.lex_state = 135},
  [471] = {.lex_state = 150},
  [472] = {.lex_state = 135},
  [473] = {.lex_state = 153},
  [474] = {.lex_state = 153},
  [475] = {.lex_state = 135},
  [476] = {.lex_state = 135},
  [477] = {.lex_state = 155},
  [478] = {.lex_state = 156},
  [479] = {.lex_state = 185},
  [480] = {.lex_state = 185},
  [481] = {.lex_state = 124},
  [482] = {.lex_state = 155},
  [483] = {.lex_state = 141},
  [484] = {.lex_state = 155},
  [485] = {.lex_state = 135},
  [486] = {.lex_state = 135},
  [487] = {.lex_state = 135},
  [488] = {.lex_state = 124},
  [489] = {.lex_state = 155},
  [490] = {.lex_state = 135},
  [491] = {.lex_state = 158},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 155},
  [494] = {.lex_state = 159},
  [495] = {.lex_state = 135},
  [496] = {.lex_state = 155},
  [497] = {.lex_state = 158},
  [498] = {.lex_state = 155},
  [499] = {.lex_state = 159},
  [500] = {.lex_state = 155},
  [501] = {.lex_state = 135},
  [502] = {.lex_state = 135},
  [503] = {.lex_state = 182, .external_lex_state = 1},
  [504] = {.lex_state = 155},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 188},
  [507] = {.lex_state = 155},
  [508] = {.lex_state = 156},
  [509] = {.lex_state = 158},
  [510] = {.lex_state = 188},
  [511] = {.lex_state = 158},
  [512] = {.lex_state = 188},
  [513] = {.lex_state = 158},
  [514] = {.lex_state = 158},
  [515] = {.lex_state = 135},
  [516] = {.lex_state = 159},
  [517] = {.lex_state = 135},
  [518] = {.lex_state = 135},
  [519] = {.lex_state = 160},
  [520] = {.lex_state = 135},
  [521] = {.lex_state = 135},
  [522] = {.lex_state = 135},
  [523] = {.lex_state = 135},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 135},
  [526] = {.lex_state = 156},
  [527] = {.lex_state = 135},
  [528] = {.lex_state = 135},
  [529] = {.lex_state = 135},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 156},
  [532] = {.lex_state = 135},
  [533] = {.lex_state = 135},
  [534] = {.lex_state = 135},
  [535] = {.lex_state = 135},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 156},
  [538] = {.lex_state = 135},
  [539] = {.lex_state = 156},
  [540] = {.lex_state = 135},
  [541] = {.lex_state = 158},
  [542] = {.lex_state = 181, .external_lex_state = 1},
  [543] = {.lex_state = 135},
  [544] = {.lex_state = 135},
  [545] = {.lex_state = 155},
  [546] = {.lex_state = 135},
  [547] = {.lex_state = 135},
  [548] = {.lex_state = 153},
  [549] = {.lex_state = 188, .external_lex_state = 1},
  [550] = {.lex_state = 159},
  [551] = {.lex_state = 159},
  [552] = {.lex_state = 212},
  [553] = {.lex_state = 212},
  [554] = {.lex_state = 212},
  [555] = {.lex_state = 135},
  [556] = {.lex_state = 135},
  [557] = {.lex_state = 172},
  [558] = {.lex_state = 172},
  [559] = {.lex_state = 124},
  [560] = {.lex_state = 172},
  [561] = {.lex_state = 172},
  [562] = {.lex_state = 196},
  [563] = {.lex_state = 135},
  [564] = {.lex_state = 196},
  [565] = {.lex_state = 124},
  [566] = {.lex_state = 155},
  [567] = {.lex_state = 159},
  [568] = {.lex_state = 135},
  [569] = {.lex_state = 155},
  [570] = {.lex_state = 172},
  [571] = {.lex_state = 124},
  [572] = {.lex_state = 196},
  [573] = {.lex_state = 124},
  [574] = {.lex_state = 188, .external_lex_state = 1},
  [575] = {.lex_state = 124},
  [576] = {.lex_state = 135},
  [577] = {.lex_state = 124},
  [578] = {.lex_state = 204},
  [579] = {.lex_state = 171},
  [580] = {.lex_state = 171},
  [581] = {.lex_state = 171},
  [582] = {.lex_state = 171},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 135},
  [585] = {.lex_state = 204},
  [586] = {.lex_state = 196},
  [587] = {.lex_state = 182, .external_lex_state = 1},
  [588] = {.lex_state = 196},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 172},
  [591] = {.lex_state = 124},
  [592] = {.lex_state = 153},
  [593] = {.lex_state = 160},
  [594] = {.lex_state = 156},
  [595] = {.lex_state = 172},
  [596] = {.lex_state = 172},
  [597] = {.lex_state = 135},
  [598] = {.lex_state = 135},
  [599] = {.lex_state = 135},
  [600] = {.lex_state = 153},
  [601] = {.lex_state = 135},
  [602] = {.lex_state = 153},
  [603] = {.lex_state = 153},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 153},
  [606] = {.lex_state = 153},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 188, .external_lex_state = 1},
  [609] = {.lex_state = 188, .external_lex_state = 1},
  [610] = {.lex_state = 188, .external_lex_state = 1},
  [611] = {.lex_state = 188, .external_lex_state = 1},
  [612] = {.lex_state = 188, .external_lex_state = 1},
  [613] = {.lex_state = 188, .external_lex_state = 1},
  [614] = {.lex_state = 213},
  [615] = {.lex_state = 214},
  [616] = {.lex_state = 124},
  [617] = {.lex_state = 188, .external_lex_state = 1},
  [618] = {.lex_state = 213},
  [619] = {.lex_state = 156},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 135},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 171},
  [624] = {.lex_state = 171},
  [625] = {.lex_state = 171},
  [626] = {.lex_state = 171},
  [627] = {.lex_state = 215},
  [628] = {.lex_state = 135},
  [629] = {.lex_state = 181, .external_lex_state = 1},
  [630] = {.lex_state = 135},
  [631] = {.lex_state = 135},
  [632] = {.lex_state = 135},
  [633] = {.lex_state = 135},
  [634] = {.lex_state = 153},
  [635] = {.lex_state = 135},
  [636] = {.lex_state = 135},
  [637] = {.lex_state = 135},
  [638] = {.lex_state = 153},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 153},
  [641] = {.lex_state = 153},
  [642] = {.lex_state = 153},
  [643] = {.lex_state = 135},
  [644] = {.lex_state = 216},
  [645] = {.lex_state = 153},
  [646] = {.lex_state = 153},
  [647] = {.lex_state = 135},
  [648] = {.lex_state = 124},
  [649] = {.lex_state = 135},
  [650] = {.lex_state = 135},
  [651] = {.lex_state = 156},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 135},
  [654] = {.lex_state = 153},
  [655] = {.lex_state = 135},
  [656] = {.lex_state = 135},
  [657] = {.lex_state = 135},
  [658] = {.lex_state = 153},
  [659] = {.lex_state = 153},
  [660] = {.lex_state = 172},
  [661] = {.lex_state = 158},
  [662] = {.lex_state = 135},
  [663] = {.lex_state = 159},
  [664] = {.lex_state = 124},
  [665] = {.lex_state = 155},
  [666] = {.lex_state = 155},
  [667] = {.lex_state = 155},
  [668] = {.lex_state = 172},
  [669] = {.lex_state = 124},
  [670] = {.lex_state = 158},
  [671] = {.lex_state = 158},
  [672] = {.lex_state = 135},
  [673] = {.lex_state = 155},
  [674] = {.lex_state = 155},
  [675] = {.lex_state = 135},
  [676] = {.lex_state = 204},
  [677] = {.lex_state = 159},
  [678] = {.lex_state = 158},
  [679] = {.lex_state = 159},
  [680] = {.lex_state = 135},
  [681] = {.lex_state = 135},
  [682] = {.lex_state = 181},
  [683] = {.lex_state = 171},
  [684] = {.lex_state = 213},
  [685] = {.lex_state = 124},
  [686] = {.lex_state = 213},
  [687] = {.lex_state = 156},
  [688] = {.lex_state = 207},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 159},
  [691] = {.lex_state = 155},
  [692] = {.lex_state = 188, .external_lex_state = 1},
  [693] = {.lex_state = 158},
  [694] = {.lex_state = 182, .external_lex_state = 1},
  [695] = {.lex_state = 217},
  [696] = {.lex_state = 188, .external_lex_state = 1},
  [697] = {.lex_state = 208, .external_lex_state = 1},
  [698] = {.lex_state = 188, .external_lex_state = 1},
  [699] = {.lex_state = 188, .external_lex_state = 1},
  [700] = {.lex_state = 188, .external_lex_state = 1},
  [701] = {.lex_state = 188, .external_lex_state = 1},
  [702] = {.lex_state = 135},
  [703] = {.lex_state = 159},
  [704] = {.lex_state = 124},
  [705] = {.lex_state = 188, .external_lex_state = 1},
  [706] = {.lex_state = 159},
  [707] = {.lex_state = 159},
  [708] = {.lex_state = 135},
  [709] = {.lex_state = 124},
  [710] = {.lex_state = 159},
  [711] = {.lex_state = 135},
  [712] = {.lex_state = 135},
  [713] = {.lex_state = 159},
  [714] = {.lex_state = 158},
  [715] = {.lex_state = 155},
  [716] = {.lex_state = 173},
  [717] = {.lex_state = 188, .external_lex_state = 1},
  [718] = {.lex_state = 173},
  [719] = {.lex_state = 188, .external_lex_state = 1},
  [720] = {.lex_state = 188, .external_lex_state = 1},
  [721] = {.lex_state = 188, .external_lex_state = 1},
  [722] = {.lex_state = 188, .external_lex_state = 1},
  [723] = {.lex_state = 188, .external_lex_state = 1},
  [724] = {.lex_state = 159},
  [725] = {.lex_state = 124},
  [726] = {.lex_state = 188, .external_lex_state = 1},
  [727] = {.lex_state = 159},
  [728] = {.lex_state = 188, .external_lex_state = 1},
  [729] = {.lex_state = 188, .external_lex_state = 1},
  [730] = {.lex_state = 188, .external_lex_state = 1},
  [731] = {.lex_state = 188, .external_lex_state = 1},
  [732] = {.lex_state = 188, .external_lex_state = 1},
  [733] = {.lex_state = 188, .external_lex_state = 1},
  [734] = {.lex_state = 159},
  [735] = {.lex_state = 124},
  [736] = {.lex_state = 188, .external_lex_state = 1},
  [737] = {.lex_state = 159},
  [738] = {.lex_state = 155},
  [739] = {.lex_state = 158},
  [740] = {.lex_state = 159},
  [741] = {.lex_state = 155},
  [742] = {.lex_state = 158},
  [743] = {.lex_state = 175},
  [744] = {.lex_state = 171},
  [745] = {.lex_state = 156},
  [746] = {.lex_state = 207},
  [747] = {.lex_state = 207},
  [748] = {.lex_state = 156},
  [749] = {.lex_state = 156},
  [750] = {.lex_state = 156},
  [751] = {.lex_state = 207},
  [752] = {.lex_state = 207},
  [753] = {.lex_state = 207},
  [754] = {.lex_state = 213},
  [755] = {.lex_state = 135},
  [756] = {.lex_state = 124},
  [757] = {.lex_state = 156},
  [758] = {.lex_state = 213},
  [759] = {.lex_state = 156},
  [760] = {.lex_state = 156},
  [761] = {.lex_state = 135},
  [762] = {.lex_state = 156},
  [763] = {.lex_state = 124},
  [764] = {.lex_state = 173},
  [765] = {.lex_state = 188, .external_lex_state = 1},
  [766] = {.lex_state = 188, .external_lex_state = 1},
  [767] = {.lex_state = 135},
  [768] = {.lex_state = 181},
  [769] = {.lex_state = 181, .external_lex_state = 1},
  [770] = {.lex_state = 188, .external_lex_state = 1},
  [771] = {.lex_state = 188, .external_lex_state = 1},
  [772] = {.lex_state = 188, .external_lex_state = 1},
  [773] = {.lex_state = 188, .external_lex_state = 1},
  [774] = {.lex_state = 209},
  [775] = {.lex_state = 124},
  [776] = {.lex_state = 188, .external_lex_state = 1},
  [777] = {.lex_state = 209},
  [778] = {.lex_state = 181},
  [779] = {.lex_state = 159},
  [780] = {.lex_state = 181, .external_lex_state = 1},
  [781] = {.lex_state = 181, .external_lex_state = 1},
  [782] = {.lex_state = 160},
  [783] = {.lex_state = 218, .external_lex_state = 1},
  [784] = {.lex_state = 156},
  [785] = {.lex_state = 135},
  [786] = {.lex_state = 181, .external_lex_state = 1},
  [787] = {.lex_state = 219, .external_lex_state = 1},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 219, .external_lex_state = 1},
  [790] = {.lex_state = 218, .external_lex_state = 1},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 156},
  [793] = {.lex_state = 181, .external_lex_state = 1},
  [794] = {.lex_state = 219, .external_lex_state = 1},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 173},
  [797] = {.lex_state = 173},
  [798] = {.lex_state = 173},
  [799] = {.lex_state = 188, .external_lex_state = 1},
  [800] = {.lex_state = 209},
  [801] = {.lex_state = 209},
  [802] = {.lex_state = 135},
  [803] = {.lex_state = 124},
  [804] = {.lex_state = 173},
  [805] = {.lex_state = 209, .external_lex_state = 1},
  [806] = {.lex_state = 156},
  [807] = {.lex_state = 181, .external_lex_state = 1},
  [808] = {.lex_state = 219, .external_lex_state = 1},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 210, .external_lex_state = 1},
  [811] = {.lex_state = 135},
  [812] = {.lex_state = 181, .external_lex_state = 1},
  [813] = {.lex_state = 181, .external_lex_state = 1},
  [814] = {.lex_state = 210, .external_lex_state = 1},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 135},
  [817] = {.lex_state = 135},
  [818] = {.lex_state = 135},
  [819] = {.lex_state = 135},
  [820] = {.lex_state = 209, .external_lex_state = 1},
  [821] = {.lex_state = 188, .external_lex_state = 1},
  [822] = {.lex_state = 208, .external_lex_state = 1},
  [823] = {.lex_state = 209},
  [824] = {.lex_state = 171},
  [825] = {.lex_state = 209},
  [826] = {.lex_state = 181, .external_lex_state = 1},
  [827] = {.lex_state = 181, .external_lex_state = 1},
  [828] = {.lex_state = 181, .external_lex_state = 1},
  [829] = {.lex_state = 188, .external_lex_state = 1},
  [830] = {.lex_state = 188, .external_lex_state = 1},
  [831] = {.lex_state = 188, .external_lex_state = 1},
  [832] = {.lex_state = 188, .external_lex_state = 1},
  [833] = {.lex_state = 188, .external_lex_state = 1},
  [834] = {.lex_state = 188, .external_lex_state = 1},
  [835] = {.lex_state = 188, .external_lex_state = 1},
  [836] = {.lex_state = 188, .external_lex_state = 1},
  [837] = {.lex_state = 188, .external_lex_state = 1},
  [838] = {.lex_state = 188, .external_lex_state = 1},
  [839] = {.lex_state = 188, .external_lex_state = 1},
  [840] = {.lex_state = 188, .external_lex_state = 1},
  [841] = {.lex_state = 188, .external_lex_state = 1},
  [842] = {.lex_state = 173},
  [843] = {.lex_state = 135},
  [844] = {.lex_state = 173},
  [845] = {.lex_state = 124},
  [846] = {.lex_state = 173},
  [847] = {.lex_state = 135},
  [848] = {.lex_state = 135},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 135},
  [852] = {.lex_state = 135},
  [853] = {.lex_state = 135},
  [854] = {.lex_state = 181, .external_lex_state = 1},
  [855] = {.lex_state = 181, .external_lex_state = 1},
  [856] = {.lex_state = 181, .external_lex_state = 1},
  [857] = {.lex_state = 181, .external_lex_state = 1},
  [858] = {.lex_state = 181, .external_lex_state = 1},
  [859] = {.lex_state = 135},
  [860] = {.lex_state = 135},
  [861] = {.lex_state = 135},
  [862] = {.lex_state = 135},
  [863] = {.lex_state = 135},
  [864] = {.lex_state = 135},
  [865] = {.lex_state = 135},
  [866] = {.lex_state = 156},
  [867] = {.lex_state = 135},
  [868] = {.lex_state = 171},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 156},
  [871] = {.lex_state = 156},
  [872] = {.lex_state = 182, .external_lex_state = 1},
  [873] = {.lex_state = 150},
  [874] = {.lex_state = 156},
  [875] = {.lex_state = 220, .external_lex_state = 1},
  [876] = {.lex_state = 220, .external_lex_state = 1},
  [877] = {.lex_state = 220, .external_lex_state = 1},
  [878] = {.lex_state = 141},
  [879] = {.lex_state = 182, .external_lex_state = 1},
  [880] = {.lex_state = 135},
  [881] = {.lex_state = 135},
  [882] = {.lex_state = 182, .external_lex_state = 1},
  [883] = {.lex_state = 182, .external_lex_state = 1},
  [884] = {.lex_state = 188, .external_lex_state = 1},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 188, .external_lex_state = 1},
  [887] = {.lex_state = 188, .external_lex_state = 1},
  [888] = {.lex_state = 188, .external_lex_state = 1},
  [889] = {.lex_state = 188, .external_lex_state = 1},
  [890] = {.lex_state = 188, .external_lex_state = 1},
  [891] = {.lex_state = 188, .external_lex_state = 1},
  [892] = {.lex_state = 188, .external_lex_state = 1},
  [893] = {.lex_state = 173},
  [894] = {.lex_state = 124},
  [895] = {.lex_state = 188, .external_lex_state = 1},
  [896] = {.lex_state = 173},
  [897] = {.lex_state = 173},
  [898] = {.lex_state = 188, .external_lex_state = 1},
  [899] = {.lex_state = 188, .external_lex_state = 1},
  [900] = {.lex_state = 135},
  [901] = {.lex_state = 182, .external_lex_state = 1},
  [902] = {.lex_state = 135},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 188, .external_lex_state = 1},
  [905] = {.lex_state = 156},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 188, .external_lex_state = 1},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 188, .external_lex_state = 1},
  [910] = {.lex_state = 155},
  [911] = {.lex_state = 155},
  [912] = {.lex_state = 135},
  [913] = {.lex_state = 159},
  [914] = {.lex_state = 135},
  [915] = {.lex_state = 159},
  [916] = {.lex_state = 155},
  [917] = {.lex_state = 188, .external_lex_state = 1},
  [918] = {.lex_state = 182, .external_lex_state = 1},
  [919] = {.lex_state = 159},
  [920] = {.lex_state = 155},
  [921] = {.lex_state = 182, .external_lex_state = 1},
  [922] = {.lex_state = 182, .external_lex_state = 1},
  [923] = {.lex_state = 155},
  [924] = {.lex_state = 188, .external_lex_state = 1},
  [925] = {.lex_state = 159},
  [926] = {.lex_state = 159},
  [927] = {.lex_state = 188, .external_lex_state = 1},
  [928] = {.lex_state = 124},
  [929] = {.lex_state = 221},
  [930] = {.lex_state = 221},
  [931] = {.lex_state = 188, .external_lex_state = 1},
  [932] = {.lex_state = 208, .external_lex_state = 1},
  [933] = {.lex_state = 159},
  [934] = {.lex_state = 182, .external_lex_state = 1},
  [935] = {.lex_state = 159},
  [936] = {.lex_state = 155},
  [937] = {.lex_state = 135},
  [938] = {.lex_state = 135},
  [939] = {.lex_state = 188, .external_lex_state = 1},
  [940] = {.lex_state = 182, .external_lex_state = 1},
  [941] = {.lex_state = 188, .external_lex_state = 1},
  [942] = {.lex_state = 188, .external_lex_state = 1},
  [943] = {.lex_state = 188, .external_lex_state = 1},
  [944] = {.lex_state = 188, .external_lex_state = 1},
  [945] = {.lex_state = 188, .external_lex_state = 1},
  [946] = {.lex_state = 188, .external_lex_state = 1},
  [947] = {.lex_state = 188, .external_lex_state = 1},
  [948] = {.lex_state = 188, .external_lex_state = 1},
  [949] = {.lex_state = 188, .external_lex_state = 1},
  [950] = {.lex_state = 188, .external_lex_state = 1},
  [951] = {.lex_state = 188, .external_lex_state = 1},
  [952] = {.lex_state = 188, .external_lex_state = 1},
  [953] = {.lex_state = 124},
  [954] = {.lex_state = 158},
  [955] = {.lex_state = 182, .external_lex_state = 1},
  [956] = {.lex_state = 124},
  [957] = {.lex_state = 135},
  [958] = {.lex_state = 135},
  [959] = {.lex_state = 135},
  [960] = {.lex_state = 135},
  [961] = {.lex_state = 135},
  [962] = {.lex_state = 124},
  [963] = {.lex_state = 135},
  [964] = {.lex_state = 158},
  [965] = {.lex_state = 158},
  [966] = {.lex_state = 175},
  [967] = {.lex_state = 183},
  [968] = {.lex_state = 156},
  [969] = {.lex_state = 158},
  [970] = {.lex_state = 135},
  [971] = {.lex_state = 135},
  [972] = {.lex_state = 135},
  [973] = {.lex_state = 135},
  [974] = {.lex_state = 135},
  [975] = {.lex_state = 156},
  [976] = {.lex_state = 156},
  [977] = {.lex_state = 156},
  [978] = {.lex_state = 141},
  [979] = {.lex_state = 155},
  [980] = {.lex_state = 183},
  [981] = {.lex_state = 155},
  [982] = {.lex_state = 188},
  [983] = {.lex_state = 155},
  [984] = {.lex_state = 155},
  [985] = {.lex_state = 188},
  [986] = {.lex_state = 155},
  [987] = {.lex_state = 155},
  [988] = {.lex_state = 188},
  [989] = {.lex_state = 155},
  [990] = {.lex_state = 185},
  [991] = {.lex_state = 150},
  [992] = {.lex_state = 155},
  [993] = {.lex_state = 155},
  [994] = {.lex_state = 155},
  [995] = {.lex_state = 141},
  [996] = {.lex_state = 185},
  [997] = {.lex_state = 135},
  [998] = {.lex_state = 135},
  [999] = {.lex_state = 135},
  [1000] = {.lex_state = 124},
  [1001] = {.lex_state = 155},
  [1002] = {.lex_state = 135},
  [1003] = {.lex_state = 158},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 185},
  [1006] = {.lex_state = 159},
  [1007] = {.lex_state = 135},
  [1008] = {.lex_state = 155},
  [1009] = {.lex_state = 185},
  [1010] = {.lex_state = 159},
  [1011] = {.lex_state = 155},
  [1012] = {.lex_state = 135},
  [1013] = {.lex_state = 135},
  [1014] = {.lex_state = 182, .external_lex_state = 1},
  [1015] = {.lex_state = 185},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 185},
  [1018] = {.lex_state = 156},
  [1019] = {.lex_state = 188},
  [1020] = {.lex_state = 155},
  [1021] = {.lex_state = 195},
  [1022] = {.lex_state = 155},
  [1023] = {.lex_state = 135},
  [1024] = {.lex_state = 155},
  [1025] = {.lex_state = 124},
  [1026] = {.lex_state = 155},
  [1027] = {.lex_state = 155},
  [1028] = {.lex_state = 155},
  [1029] = {.lex_state = 155},
  [1030] = {.lex_state = 155},
  [1031] = {.lex_state = 158},
  [1032] = {.lex_state = 155},
  [1033] = {.lex_state = 155},
  [1034] = {.lex_state = 135},
  [1035] = {.lex_state = 159},
  [1036] = {.lex_state = 155},
  [1037] = {.lex_state = 155},
  [1038] = {.lex_state = 182, .external_lex_state = 1},
  [1039] = {.lex_state = 155},
  [1040] = {.lex_state = 155},
  [1041] = {.lex_state = 188, .external_lex_state = 1},
  [1042] = {.lex_state = 155},
  [1043] = {.lex_state = 188, .external_lex_state = 1},
  [1044] = {.lex_state = 155},
  [1045] = {.lex_state = 155},
  [1046] = {.lex_state = 182, .external_lex_state = 1},
  [1047] = {.lex_state = 155},
  [1048] = {.lex_state = 158},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 158},
  [1051] = {.lex_state = 158},
  [1052] = {.lex_state = 135},
  [1053] = {.lex_state = 159},
  [1054] = {.lex_state = 159},
  [1055] = {.lex_state = 135},
  [1056] = {.lex_state = 135},
  [1057] = {.lex_state = 135},
  [1058] = {.lex_state = 135},
  [1059] = {.lex_state = 135},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 135},
  [1062] = {.lex_state = 135},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 135},
  [1065] = {.lex_state = 135},
  [1066] = {.lex_state = 135},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 135},
  [1069] = {.lex_state = 135},
  [1070] = {.lex_state = 181, .external_lex_state = 1},
  [1071] = {.lex_state = 209},
  [1072] = {.lex_state = 158},
  [1073] = {.lex_state = 135},
  [1074] = {.lex_state = 135},
  [1075] = {.lex_state = 135},
  [1076] = {.lex_state = 135},
  [1077] = {.lex_state = 159},
  [1078] = {.lex_state = 153},
  [1079] = {.lex_state = 159},
  [1080] = {.lex_state = 159},
  [1081] = {.lex_state = 159},
  [1082] = {.lex_state = 196},
  [1083] = {.lex_state = 212},
  [1084] = {.lex_state = 141},
  [1085] = {.lex_state = 188},
  [1086] = {.lex_state = 188},
  [1087] = {.lex_state = 212},
  [1088] = {.lex_state = 196},
  [1089] = {.lex_state = 188},
  [1090] = {.lex_state = 188},
  [1091] = {.lex_state = 212},
  [1092] = {.lex_state = 196},
  [1093] = {.lex_state = 188},
  [1094] = {.lex_state = 188},
  [1095] = {.lex_state = 212},
  [1096] = {.lex_state = 155},
  [1097] = {.lex_state = 135},
  [1098] = {.lex_state = 172},
  [1099] = {.lex_state = 196},
  [1100] = {.lex_state = 155},
  [1101] = {.lex_state = 159},
  [1102] = {.lex_state = 155},
  [1103] = {.lex_state = 196},
  [1104] = {.lex_state = 196},
  [1105] = {.lex_state = 135},
  [1106] = {.lex_state = 159},
  [1107] = {.lex_state = 155},
  [1108] = {.lex_state = 124},
  [1109] = {.lex_state = 124},
  [1110] = {.lex_state = 156},
  [1111] = {.lex_state = 135},
  [1112] = {.lex_state = 204},
  [1113] = {.lex_state = 159},
  [1114] = {.lex_state = 204},
  [1115] = {.lex_state = 124},
  [1116] = {.lex_state = 214},
  [1117] = {.lex_state = 135},
  [1118] = {.lex_state = 124},
  [1119] = {.lex_state = 196},
  [1120] = {.lex_state = 181, .external_lex_state = 1},
  [1121] = {.lex_state = 188, .external_lex_state = 1},
  [1122] = {.lex_state = 196},
  [1123] = {.lex_state = 204},
  [1124] = {.lex_state = 204},
  [1125] = {.lex_state = 124},
  [1126] = {.lex_state = 135},
  [1127] = {.lex_state = 173},
  [1128] = {.lex_state = 135},
  [1129] = {.lex_state = 204},
  [1130] = {.lex_state = 196},
  [1131] = {.lex_state = 182, .external_lex_state = 1},
  [1132] = {.lex_state = 196},
  [1133] = {.lex_state = 172},
  [1134] = {.lex_state = 172},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 172},
  [1137] = {.lex_state = 135},
  [1138] = {.lex_state = 135},
  [1139] = {.lex_state = 135},
  [1140] = {.lex_state = 135},
  [1141] = {.lex_state = 153},
  [1142] = {.lex_state = 135},
  [1143] = {.lex_state = 153},
  [1144] = {.lex_state = 153},
  [1145] = {.lex_state = 156},
  [1146] = {.lex_state = 188, .external_lex_state = 1},
  [1147] = {.lex_state = 213},
  [1148] = {.lex_state = 213},
  [1149] = {.lex_state = 124},
  [1150] = {.lex_state = 214},
  [1151] = {.lex_state = 214},
  [1152] = {.lex_state = 188, .external_lex_state = 1},
  [1153] = {.lex_state = 208, .external_lex_state = 1},
  [1154] = {.lex_state = 213},
  [1155] = {.lex_state = 188, .external_lex_state = 1},
  [1156] = {.lex_state = 135},
  [1157] = {.lex_state = 188, .external_lex_state = 1},
  [1158] = {.lex_state = 188, .external_lex_state = 1},
  [1159] = {.lex_state = 188, .external_lex_state = 1},
  [1160] = {.lex_state = 188, .external_lex_state = 1},
  [1161] = {.lex_state = 188, .external_lex_state = 1},
  [1162] = {.lex_state = 188, .external_lex_state = 1},
  [1163] = {.lex_state = 188, .external_lex_state = 1},
  [1164] = {.lex_state = 188, .external_lex_state = 1},
  [1165] = {.lex_state = 188, .external_lex_state = 1},
  [1166] = {.lex_state = 188, .external_lex_state = 1},
  [1167] = {.lex_state = 188, .external_lex_state = 1},
  [1168] = {.lex_state = 188, .external_lex_state = 1},
  [1169] = {.lex_state = 124},
  [1170] = {.lex_state = 156},
  [1171] = {.lex_state = 156},
  [1172] = {.lex_state = 156},
  [1173] = {.lex_state = 156},
  [1174] = {.lex_state = 135},
  [1175] = {.lex_state = 171},
  [1176] = {.lex_state = 181, .external_lex_state = 1},
  [1177] = {.lex_state = 209},
  [1178] = {.lex_state = 135},
  [1179] = {.lex_state = 181, .external_lex_state = 1},
  [1180] = {.lex_state = 135},
  [1181] = {.lex_state = 135},
  [1182] = {.lex_state = 171},
  [1183] = {.lex_state = 135},
  [1184] = {.lex_state = 135},
  [1185] = {.lex_state = 153},
  [1186] = {.lex_state = 135},
  [1187] = {.lex_state = 135},
  [1188] = {.lex_state = 153},
  [1189] = {.lex_state = 135},
  [1190] = {.lex_state = 207},
  [1191] = {.lex_state = 207},
  [1192] = {.lex_state = 135},
  [1193] = {.lex_state = 135},
  [1194] = {.lex_state = 124},
  [1195] = {.lex_state = 135},
  [1196] = {.lex_state = 175, .external_lex_state = 1},
  [1197] = {.lex_state = 206, .external_lex_state = 1},
  [1198] = {.lex_state = 188, .external_lex_state = 1},
  [1199] = {.lex_state = 135},
  [1200] = {.lex_state = 124},
  [1201] = {.lex_state = 135},
  [1202] = {.lex_state = 153},
  [1203] = {.lex_state = 135},
  [1204] = {.lex_state = 135},
  [1205] = {.lex_state = 135},
  [1206] = {.lex_state = 153},
  [1207] = {.lex_state = 135},
  [1208] = {.lex_state = 204},
  [1209] = {.lex_state = 204},
  [1210] = {.lex_state = 159},
  [1211] = {.lex_state = 155},
  [1212] = {.lex_state = 155},
  [1213] = {.lex_state = 155},
  [1214] = {.lex_state = 155},
  [1215] = {.lex_state = 155},
  [1216] = {.lex_state = 159},
  [1217] = {.lex_state = 158},
  [1218] = {.lex_state = 155},
  [1219] = {.lex_state = 204},
  [1220] = {.lex_state = 181},
  [1221] = {.lex_state = 135},
  [1222] = {.lex_state = 181},
  [1223] = {.lex_state = 124},
  [1224] = {.lex_state = 213},
  [1225] = {.lex_state = 213},
  [1226] = {.lex_state = 188, .external_lex_state = 1},
  [1227] = {.lex_state = 173},
  [1228] = {.lex_state = 156},
  [1229] = {.lex_state = 124},
  [1230] = {.lex_state = 156},
  [1231] = {.lex_state = 173},
  [1232] = {.lex_state = 182, .external_lex_state = 1},
  [1233] = {.lex_state = 124},
  [1234] = {.lex_state = 209},
  [1235] = {.lex_state = 188, .external_lex_state = 1},
  [1236] = {.lex_state = 159},
  [1237] = {.lex_state = 135},
  [1238] = {.lex_state = 159},
  [1239] = {.lex_state = 188, .external_lex_state = 1},
  [1240] = {.lex_state = 208, .external_lex_state = 1},
  [1241] = {.lex_state = 159},
  [1242] = {.lex_state = 206, .external_lex_state = 1},
  [1243] = {.lex_state = 188, .external_lex_state = 1},
  [1244] = {.lex_state = 188, .external_lex_state = 1},
  [1245] = {.lex_state = 188, .external_lex_state = 1},
  [1246] = {.lex_state = 188, .external_lex_state = 1},
  [1247] = {.lex_state = 188, .external_lex_state = 1},
  [1248] = {.lex_state = 188, .external_lex_state = 1},
  [1249] = {.lex_state = 188, .external_lex_state = 1},
  [1250] = {.lex_state = 188, .external_lex_state = 1},
  [1251] = {.lex_state = 188, .external_lex_state = 1},
  [1252] = {.lex_state = 188, .external_lex_state = 1},
  [1253] = {.lex_state = 188, .external_lex_state = 1},
  [1254] = {.lex_state = 188, .external_lex_state = 1},
  [1255] = {.lex_state = 159},
  [1256] = {.lex_state = 206, .external_lex_state = 1},
  [1257] = {.lex_state = 188, .external_lex_state = 1},
  [1258] = {.lex_state = 188, .external_lex_state = 1},
  [1259] = {.lex_state = 135},
  [1260] = {.lex_state = 135},
  [1261] = {.lex_state = 135},
  [1262] = {.lex_state = 135},
  [1263] = {.lex_state = 135},
  [1264] = {.lex_state = 204},
  [1265] = {.lex_state = 204},
  [1266] = {.lex_state = 159},
  [1267] = {.lex_state = 156},
  [1268] = {.lex_state = 188, .external_lex_state = 1},
  [1269] = {.lex_state = 159},
  [1270] = {.lex_state = 159},
  [1271] = {.lex_state = 188, .external_lex_state = 1},
  [1272] = {.lex_state = 208, .external_lex_state = 1},
  [1273] = {.lex_state = 159},
  [1274] = {.lex_state = 188, .external_lex_state = 1},
  [1275] = {.lex_state = 188, .external_lex_state = 1},
  [1276] = {.lex_state = 188, .external_lex_state = 1},
  [1277] = {.lex_state = 188, .external_lex_state = 1},
  [1278] = {.lex_state = 188, .external_lex_state = 1},
  [1279] = {.lex_state = 188, .external_lex_state = 1},
  [1280] = {.lex_state = 188, .external_lex_state = 1},
  [1281] = {.lex_state = 188, .external_lex_state = 1},
  [1282] = {.lex_state = 188, .external_lex_state = 1},
  [1283] = {.lex_state = 188, .external_lex_state = 1},
  [1284] = {.lex_state = 188, .external_lex_state = 1},
  [1285] = {.lex_state = 188, .external_lex_state = 1},
  [1286] = {.lex_state = 156},
  [1287] = {.lex_state = 188, .external_lex_state = 1},
  [1288] = {.lex_state = 159},
  [1289] = {.lex_state = 159},
  [1290] = {.lex_state = 188, .external_lex_state = 1},
  [1291] = {.lex_state = 208, .external_lex_state = 1},
  [1292] = {.lex_state = 159},
  [1293] = {.lex_state = 158},
  [1294] = {.lex_state = 188, .external_lex_state = 1},
  [1295] = {.lex_state = 188, .external_lex_state = 1},
  [1296] = {.lex_state = 188, .external_lex_state = 1},
  [1297] = {.lex_state = 188, .external_lex_state = 1},
  [1298] = {.lex_state = 188, .external_lex_state = 1},
  [1299] = {.lex_state = 188, .external_lex_state = 1},
  [1300] = {.lex_state = 188, .external_lex_state = 1},
  [1301] = {.lex_state = 188, .external_lex_state = 1},
  [1302] = {.lex_state = 188, .external_lex_state = 1},
  [1303] = {.lex_state = 188, .external_lex_state = 1},
  [1304] = {.lex_state = 188, .external_lex_state = 1},
  [1305] = {.lex_state = 188, .external_lex_state = 1},
  [1306] = {.lex_state = 158},
  [1307] = {.lex_state = 156},
  [1308] = {.lex_state = 171},
  [1309] = {.lex_state = 156},
  [1310] = {.lex_state = 156},
  [1311] = {.lex_state = 156},
  [1312] = {.lex_state = 156},
  [1313] = {.lex_state = 156},
  [1314] = {.lex_state = 188, .external_lex_state = 1},
  [1315] = {.lex_state = 156},
  [1316] = {.lex_state = 156},
  [1317] = {.lex_state = 135},
  [1318] = {.lex_state = 156},
  [1319] = {.lex_state = 207},
  [1320] = {.lex_state = 207},
  [1321] = {.lex_state = 156},
  [1322] = {.lex_state = 173},
  [1323] = {.lex_state = 188, .external_lex_state = 1},
  [1324] = {.lex_state = 156},
  [1325] = {.lex_state = 156},
  [1326] = {.lex_state = 156},
  [1327] = {.lex_state = 188, .external_lex_state = 1},
  [1328] = {.lex_state = 209},
  [1329] = {.lex_state = 209},
  [1330] = {.lex_state = 188, .external_lex_state = 1},
  [1331] = {.lex_state = 208, .external_lex_state = 1},
  [1332] = {.lex_state = 209},
  [1333] = {.lex_state = 188, .external_lex_state = 1},
  [1334] = {.lex_state = 188, .external_lex_state = 1},
  [1335] = {.lex_state = 135},
  [1336] = {.lex_state = 188, .external_lex_state = 1},
  [1337] = {.lex_state = 188, .external_lex_state = 1},
  [1338] = {.lex_state = 188, .external_lex_state = 1},
  [1339] = {.lex_state = 188, .external_lex_state = 1},
  [1340] = {.lex_state = 188, .external_lex_state = 1},
  [1341] = {.lex_state = 188, .external_lex_state = 1},
  [1342] = {.lex_state = 188, .external_lex_state = 1},
  [1343] = {.lex_state = 188, .external_lex_state = 1},
  [1344] = {.lex_state = 188, .external_lex_state = 1},
  [1345] = {.lex_state = 188, .external_lex_state = 1},
  [1346] = {.lex_state = 188, .external_lex_state = 1},
  [1347] = {.lex_state = 181},
  [1348] = {.lex_state = 158},
  [1349] = {.lex_state = 181, .external_lex_state = 1},
  [1350] = {.lex_state = 159},
  [1351] = {.lex_state = 181, .external_lex_state = 1},
  [1352] = {.lex_state = 181, .external_lex_state = 1},
  [1353] = {.lex_state = 160},
  [1354] = {.lex_state = 135},
  [1355] = {.lex_state = 135},
  [1356] = {.lex_state = 219, .external_lex_state = 1},
  [1357] = {.lex_state = 181, .external_lex_state = 1},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 218, .external_lex_state = 1},
  [1360] = {.lex_state = 156},
  [1361] = {.lex_state = 135},
  [1362] = {.lex_state = 219, .external_lex_state = 1},
  [1363] = {.lex_state = 181, .external_lex_state = 1},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 156},
  [1366] = {.lex_state = 156},
  [1367] = {.lex_state = 209},
  [1368] = {.lex_state = 209, .external_lex_state = 1},
  [1369] = {.lex_state = 135},
  [1370] = {.lex_state = 209, .external_lex_state = 1},
  [1371] = {.lex_state = 181, .external_lex_state = 1},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 156},
  [1374] = {.lex_state = 135},
  [1375] = {.lex_state = 181, .external_lex_state = 1},
  [1376] = {.lex_state = 210, .external_lex_state = 1},
  [1377] = {.lex_state = 135},
  [1378] = {.lex_state = 188, .external_lex_state = 1},
  [1379] = {.lex_state = 173},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 135},
  [1382] = {.lex_state = 135},
  [1383] = {.lex_state = 173},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 173},
  [1386] = {.lex_state = 208, .external_lex_state = 1},
  [1387] = {.lex_state = 209},
  [1388] = {.lex_state = 222, .external_lex_state = 1},
  [1389] = {.lex_state = 171},
  [1390] = {.lex_state = 181, .external_lex_state = 1},
  [1391] = {.lex_state = 173},
  [1392] = {.lex_state = 209},
  [1393] = {.lex_state = 209},
  [1394] = {.lex_state = 173},
  [1395] = {.lex_state = 209},
  [1396] = {.lex_state = 209},
  [1397] = {.lex_state = 209},
  [1398] = {.lex_state = 209},
  [1399] = {.lex_state = 209},
  [1400] = {.lex_state = 209},
  [1401] = {.lex_state = 209},
  [1402] = {.lex_state = 209},
  [1403] = {.lex_state = 209},
  [1404] = {.lex_state = 214},
  [1405] = {.lex_state = 173},
  [1406] = {.lex_state = 135},
  [1407] = {.lex_state = 209, .external_lex_state = 1},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 135},
  [1410] = {.lex_state = 135},
  [1411] = {.lex_state = 173},
  [1412] = {.lex_state = 135},
  [1413] = {.lex_state = 135},
  [1414] = {.lex_state = 223},
  [1415] = {.lex_state = 135},
  [1416] = {.lex_state = 181, .external_lex_state = 1},
  [1417] = {.lex_state = 135},
  [1418] = {.lex_state = 181, .external_lex_state = 1},
  [1419] = {.lex_state = 159},
  [1420] = {.lex_state = 171},
  [1421] = {.lex_state = 171},
  [1422] = {.lex_state = 160},
  [1423] = {.lex_state = 135},
  [1424] = {.lex_state = 156},
  [1425] = {.lex_state = 171},
  [1426] = {.lex_state = 204},
  [1427] = {.lex_state = 0},
  [1428] = {.lex_state = 135},
  [1429] = {.lex_state = 171},
  [1430] = {.lex_state = 156},
  [1431] = {.lex_state = 171},
  [1432] = {.lex_state = 204},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 135},
  [1435] = {.lex_state = 135},
  [1436] = {.lex_state = 135},
  [1437] = {.lex_state = 156},
  [1438] = {.lex_state = 171},
  [1439] = {.lex_state = 204},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 171},
  [1442] = {.lex_state = 135},
  [1443] = {.lex_state = 156},
  [1444] = {.lex_state = 156},
  [1445] = {.lex_state = 156},
  [1446] = {.lex_state = 156},
  [1447] = {.lex_state = 135},
  [1448] = {.lex_state = 135},
  [1449] = {.lex_state = 171},
  [1450] = {.lex_state = 171},
  [1451] = {.lex_state = 156},
  [1452] = {.lex_state = 141},
  [1453] = {.lex_state = 182, .external_lex_state = 1},
  [1454] = {.lex_state = 183},
  [1455] = {.lex_state = 188, .external_lex_state = 1},
  [1456] = {.lex_state = 130},
  [1457] = {.lex_state = 135},
  [1458] = {.lex_state = 141},
  [1459] = {.lex_state = 182, .external_lex_state = 1},
  [1460] = {.lex_state = 135},
  [1461] = {.lex_state = 135},
  [1462] = {.lex_state = 224, .external_lex_state = 1},
  [1463] = {.lex_state = 141},
  [1464] = {.lex_state = 150},
  [1465] = {.lex_state = 220, .external_lex_state = 1},
  [1466] = {.lex_state = 135},
  [1467] = {.lex_state = 182, .external_lex_state = 1},
  [1468] = {.lex_state = 135},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 188, .external_lex_state = 1},
  [1471] = {.lex_state = 156},
  [1472] = {.lex_state = 0},
  [1473] = {.lex_state = 188, .external_lex_state = 1},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 188, .external_lex_state = 1},
  [1476] = {.lex_state = 155},
  [1477] = {.lex_state = 155},
  [1478] = {.lex_state = 135},
  [1479] = {.lex_state = 211},
  [1480] = {.lex_state = 220, .external_lex_state = 1},
  [1481] = {.lex_state = 220, .external_lex_state = 1},
  [1482] = {.lex_state = 188},
  [1483] = {.lex_state = 188},
  [1484] = {.lex_state = 155},
  [1485] = {.lex_state = 159},
  [1486] = {.lex_state = 155},
  [1487] = {.lex_state = 220, .external_lex_state = 1},
  [1488] = {.lex_state = 182, .external_lex_state = 1},
  [1489] = {.lex_state = 188},
  [1490] = {.lex_state = 188},
  [1491] = {.lex_state = 220, .external_lex_state = 1},
  [1492] = {.lex_state = 182, .external_lex_state = 1},
  [1493] = {.lex_state = 188},
  [1494] = {.lex_state = 188},
  [1495] = {.lex_state = 220, .external_lex_state = 1},
  [1496] = {.lex_state = 195},
  [1497] = {.lex_state = 155},
  [1498] = {.lex_state = 135},
  [1499] = {.lex_state = 182, .external_lex_state = 1},
  [1500] = {.lex_state = 188, .external_lex_state = 1},
  [1501] = {.lex_state = 188, .external_lex_state = 1},
  [1502] = {.lex_state = 188, .external_lex_state = 1},
  [1503] = {.lex_state = 188, .external_lex_state = 1},
  [1504] = {.lex_state = 188, .external_lex_state = 1},
  [1505] = {.lex_state = 188, .external_lex_state = 1},
  [1506] = {.lex_state = 213},
  [1507] = {.lex_state = 124},
  [1508] = {.lex_state = 188, .external_lex_state = 1},
  [1509] = {.lex_state = 213},
  [1510] = {.lex_state = 188, .external_lex_state = 1},
  [1511] = {.lex_state = 213},
  [1512] = {.lex_state = 156},
  [1513] = {.lex_state = 173},
  [1514] = {.lex_state = 173},
  [1515] = {.lex_state = 173},
  [1516] = {.lex_state = 173},
  [1517] = {.lex_state = 188, .external_lex_state = 1},
  [1518] = {.lex_state = 173},
  [1519] = {.lex_state = 173},
  [1520] = {.lex_state = 188, .external_lex_state = 1},
  [1521] = {.lex_state = 208, .external_lex_state = 1},
  [1522] = {.lex_state = 173},
  [1523] = {.lex_state = 188, .external_lex_state = 1},
  [1524] = {.lex_state = 188, .external_lex_state = 1},
  [1525] = {.lex_state = 188, .external_lex_state = 1},
  [1526] = {.lex_state = 188, .external_lex_state = 1},
  [1527] = {.lex_state = 188, .external_lex_state = 1},
  [1528] = {.lex_state = 188, .external_lex_state = 1},
  [1529] = {.lex_state = 188, .external_lex_state = 1},
  [1530] = {.lex_state = 188, .external_lex_state = 1},
  [1531] = {.lex_state = 188, .external_lex_state = 1},
  [1532] = {.lex_state = 188, .external_lex_state = 1},
  [1533] = {.lex_state = 188, .external_lex_state = 1},
  [1534] = {.lex_state = 188, .external_lex_state = 1},
  [1535] = {.lex_state = 188, .external_lex_state = 1},
  [1536] = {.lex_state = 135},
  [1537] = {.lex_state = 211},
  [1538] = {.lex_state = 124},
  [1539] = {.lex_state = 182, .external_lex_state = 1},
  [1540] = {.lex_state = 124},
  [1541] = {.lex_state = 153},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 213},
  [1544] = {.lex_state = 173},
  [1545] = {.lex_state = 182, .external_lex_state = 1},
  [1546] = {.lex_state = 188, .external_lex_state = 1},
  [1547] = {.lex_state = 0},
  [1548] = {.lex_state = 188, .external_lex_state = 1},
  [1549] = {.lex_state = 173},
  [1550] = {.lex_state = 188, .external_lex_state = 1},
  [1551] = {.lex_state = 188, .external_lex_state = 1},
  [1552] = {.lex_state = 135},
  [1553] = {.lex_state = 188, .external_lex_state = 1},
  [1554] = {.lex_state = 135},
  [1555] = {.lex_state = 159},
  [1556] = {.lex_state = 155},
  [1557] = {.lex_state = 135},
  [1558] = {.lex_state = 135},
  [1559] = {.lex_state = 155},
  [1560] = {.lex_state = 188, .external_lex_state = 1},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 135},
  [1563] = {.lex_state = 188, .external_lex_state = 1},
  [1564] = {.lex_state = 211},
  [1565] = {.lex_state = 124},
  [1566] = {.lex_state = 124},
  [1567] = {.lex_state = 159},
  [1568] = {.lex_state = 156},
  [1569] = {.lex_state = 182, .external_lex_state = 1},
  [1570] = {.lex_state = 182, .external_lex_state = 1},
  [1571] = {.lex_state = 156},
  [1572] = {.lex_state = 159},
  [1573] = {.lex_state = 159},
  [1574] = {.lex_state = 182, .external_lex_state = 1},
  [1575] = {.lex_state = 221},
  [1576] = {.lex_state = 208, .external_lex_state = 1},
  [1577] = {.lex_state = 159},
  [1578] = {.lex_state = 222, .external_lex_state = 1},
  [1579] = {.lex_state = 182, .external_lex_state = 1},
  [1580] = {.lex_state = 155},
  [1581] = {.lex_state = 188, .external_lex_state = 1},
  [1582] = {.lex_state = 155},
  [1583] = {.lex_state = 188, .external_lex_state = 1},
  [1584] = {.lex_state = 155},
  [1585] = {.lex_state = 159},
  [1586] = {.lex_state = 135},
  [1587] = {.lex_state = 159},
  [1588] = {.lex_state = 173},
  [1589] = {.lex_state = 159},
  [1590] = {.lex_state = 159},
  [1591] = {.lex_state = 159},
  [1592] = {.lex_state = 159},
  [1593] = {.lex_state = 159},
  [1594] = {.lex_state = 159},
  [1595] = {.lex_state = 159},
  [1596] = {.lex_state = 159},
  [1597] = {.lex_state = 159},
  [1598] = {.lex_state = 221},
  [1599] = {.lex_state = 135},
  [1600] = {.lex_state = 135},
  [1601] = {.lex_state = 135},
  [1602] = {.lex_state = 135},
  [1603] = {.lex_state = 135},
  [1604] = {.lex_state = 135},
  [1605] = {.lex_state = 156},
  [1606] = {.lex_state = 183},
  [1607] = {.lex_state = 156},
  [1608] = {.lex_state = 171},
  [1609] = {.lex_state = 171},
  [1610] = {.lex_state = 171},
  [1611] = {.lex_state = 171},
  [1612] = {.lex_state = 156},
  [1613] = {.lex_state = 156},
  [1614] = {.lex_state = 156},
  [1615] = {.lex_state = 156},
  [1616] = {.lex_state = 156},
  [1617] = {.lex_state = 195},
  [1618] = {.lex_state = 155},
  [1619] = {.lex_state = 195},
  [1620] = {.lex_state = 155},
  [1621] = {.lex_state = 188},
  [1622] = {.lex_state = 155},
  [1623] = {.lex_state = 188},
  [1624] = {.lex_state = 155},
  [1625] = {.lex_state = 188},
  [1626] = {.lex_state = 141},
  [1627] = {.lex_state = 185},
  [1628] = {.lex_state = 183},
  [1629] = {.lex_state = 185},
  [1630] = {.lex_state = 188},
  [1631] = {.lex_state = 155},
  [1632] = {.lex_state = 185},
  [1633] = {.lex_state = 188},
  [1634] = {.lex_state = 155},
  [1635] = {.lex_state = 185},
  [1636] = {.lex_state = 188},
  [1637] = {.lex_state = 155},
  [1638] = {.lex_state = 195},
  [1639] = {.lex_state = 155},
  [1640] = {.lex_state = 135},
  [1641] = {.lex_state = 185},
  [1642] = {.lex_state = 124},
  [1643] = {.lex_state = 155},
  [1644] = {.lex_state = 185},
  [1645] = {.lex_state = 185},
  [1646] = {.lex_state = 155},
  [1647] = {.lex_state = 185},
  [1648] = {.lex_state = 158},
  [1649] = {.lex_state = 185},
  [1650] = {.lex_state = 185},
  [1651] = {.lex_state = 135},
  [1652] = {.lex_state = 159},
  [1653] = {.lex_state = 155},
  [1654] = {.lex_state = 185},
  [1655] = {.lex_state = 182, .external_lex_state = 1},
  [1656] = {.lex_state = 185},
  [1657] = {.lex_state = 155},
  [1658] = {.lex_state = 188, .external_lex_state = 1},
  [1659] = {.lex_state = 155},
  [1660] = {.lex_state = 188, .external_lex_state = 1},
  [1661] = {.lex_state = 155},
  [1662] = {.lex_state = 185},
  [1663] = {.lex_state = 182, .external_lex_state = 1},
  [1664] = {.lex_state = 185},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 188},
  [1667] = {.lex_state = 155},
  [1668] = {.lex_state = 155},
  [1669] = {.lex_state = 155},
  [1670] = {.lex_state = 155},
  [1671] = {.lex_state = 155},
  [1672] = {.lex_state = 155},
  [1673] = {.lex_state = 155},
  [1674] = {.lex_state = 155},
  [1675] = {.lex_state = 155},
  [1676] = {.lex_state = 159},
  [1677] = {.lex_state = 155},
  [1678] = {.lex_state = 155},
  [1679] = {.lex_state = 159},
  [1680] = {.lex_state = 155},
  [1681] = {.lex_state = 155},
  [1682] = {.lex_state = 155},
  [1683] = {.lex_state = 155},
  [1684] = {.lex_state = 135},
  [1685] = {.lex_state = 159},
  [1686] = {.lex_state = 135},
  [1687] = {.lex_state = 135},
  [1688] = {.lex_state = 135},
  [1689] = {.lex_state = 135},
  [1690] = {.lex_state = 135},
  [1691] = {.lex_state = 135},
  [1692] = {.lex_state = 135},
  [1693] = {.lex_state = 209},
  [1694] = {.lex_state = 135},
  [1695] = {.lex_state = 135},
  [1696] = {.lex_state = 135},
  [1697] = {.lex_state = 135},
  [1698] = {.lex_state = 135},
  [1699] = {.lex_state = 153},
  [1700] = {.lex_state = 135},
  [1701] = {.lex_state = 212},
  [1702] = {.lex_state = 212},
  [1703] = {.lex_state = 196},
  [1704] = {.lex_state = 196},
  [1705] = {.lex_state = 196},
  [1706] = {.lex_state = 188},
  [1707] = {.lex_state = 188},
  [1708] = {.lex_state = 212},
  [1709] = {.lex_state = 196},
  [1710] = {.lex_state = 196},
  [1711] = {.lex_state = 196},
  [1712] = {.lex_state = 188},
  [1713] = {.lex_state = 188},
  [1714] = {.lex_state = 196},
  [1715] = {.lex_state = 196},
  [1716] = {.lex_state = 196},
  [1717] = {.lex_state = 188},
  [1718] = {.lex_state = 188},
  [1719] = {.lex_state = 196},
  [1720] = {.lex_state = 155},
  [1721] = {.lex_state = 196},
  [1722] = {.lex_state = 196},
  [1723] = {.lex_state = 182, .external_lex_state = 1},
  [1724] = {.lex_state = 196},
  [1725] = {.lex_state = 155},
  [1726] = {.lex_state = 155},
  [1727] = {.lex_state = 196},
  [1728] = {.lex_state = 156},
  [1729] = {.lex_state = 156},
  [1730] = {.lex_state = 171},
  [1731] = {.lex_state = 156},
  [1732] = {.lex_state = 196},
  [1733] = {.lex_state = 135},
  [1734] = {.lex_state = 124},
  [1735] = {.lex_state = 124},
  [1736] = {.lex_state = 204},
  [1737] = {.lex_state = 171},
  [1738] = {.lex_state = 181, .external_lex_state = 1},
  [1739] = {.lex_state = 209},
  [1740] = {.lex_state = 159},
  [1741] = {.lex_state = 135},
  [1742] = {.lex_state = 204},
  [1743] = {.lex_state = 188, .external_lex_state = 1},
  [1744] = {.lex_state = 204},
  [1745] = {.lex_state = 135},
  [1746] = {.lex_state = 225},
  [1747] = {.lex_state = 135},
  [1748] = {.lex_state = 135},
  [1749] = {.lex_state = 204},
  [1750] = {.lex_state = 204},
  [1751] = {.lex_state = 204},
  [1752] = {.lex_state = 196},
  [1753] = {.lex_state = 196},
  [1754] = {.lex_state = 135},
  [1755] = {.lex_state = 153},
  [1756] = {.lex_state = 188, .external_lex_state = 1},
  [1757] = {.lex_state = 156},
  [1758] = {.lex_state = 213},
  [1759] = {.lex_state = 214},
  [1760] = {.lex_state = 208, .external_lex_state = 1},
  [1761] = {.lex_state = 213},
  [1762] = {.lex_state = 222, .external_lex_state = 1},
  [1763] = {.lex_state = 213},
  [1764] = {.lex_state = 213},
  [1765] = {.lex_state = 173},
  [1766] = {.lex_state = 213},
  [1767] = {.lex_state = 213},
  [1768] = {.lex_state = 213},
  [1769] = {.lex_state = 213},
  [1770] = {.lex_state = 213},
  [1771] = {.lex_state = 213},
  [1772] = {.lex_state = 213},
  [1773] = {.lex_state = 213},
  [1774] = {.lex_state = 213},
  [1775] = {.lex_state = 214},
  [1776] = {.lex_state = 156},
  [1777] = {.lex_state = 156},
  [1778] = {.lex_state = 171},
  [1779] = {.lex_state = 156},
  [1780] = {.lex_state = 135},
  [1781] = {.lex_state = 156},
  [1782] = {.lex_state = 171},
  [1783] = {.lex_state = 209},
  [1784] = {.lex_state = 181, .external_lex_state = 1},
  [1785] = {.lex_state = 171},
  [1786] = {.lex_state = 135},
  [1787] = {.lex_state = 135},
  [1788] = {.lex_state = 135},
  [1789] = {.lex_state = 135},
  [1790] = {.lex_state = 135},
  [1791] = {.lex_state = 135},
  [1792] = {.lex_state = 135},
  [1793] = {.lex_state = 213},
  [1794] = {.lex_state = 156},
  [1795] = {.lex_state = 158},
  [1796] = {.lex_state = 135},
  [1797] = {.lex_state = 159},
  [1798] = {.lex_state = 159},
  [1799] = {.lex_state = 188, .external_lex_state = 1},
  [1800] = {.lex_state = 188, .external_lex_state = 1},
  [1801] = {.lex_state = 188, .external_lex_state = 1},
  [1802] = {.lex_state = 188, .external_lex_state = 1},
  [1803] = {.lex_state = 188, .external_lex_state = 1},
  [1804] = {.lex_state = 188, .external_lex_state = 1},
  [1805] = {.lex_state = 159},
  [1806] = {.lex_state = 124},
  [1807] = {.lex_state = 188, .external_lex_state = 1},
  [1808] = {.lex_state = 159},
  [1809] = {.lex_state = 135},
  [1810] = {.lex_state = 135},
  [1811] = {.lex_state = 135},
  [1812] = {.lex_state = 204},
  [1813] = {.lex_state = 204},
  [1814] = {.lex_state = 159},
  [1815] = {.lex_state = 159},
  [1816] = {.lex_state = 204},
  [1817] = {.lex_state = 155},
  [1818] = {.lex_state = 155},
  [1819] = {.lex_state = 159},
  [1820] = {.lex_state = 135},
  [1821] = {.lex_state = 159},
  [1822] = {.lex_state = 155},
  [1823] = {.lex_state = 213},
  [1824] = {.lex_state = 213},
  [1825] = {.lex_state = 156},
  [1826] = {.lex_state = 173},
  [1827] = {.lex_state = 156},
  [1828] = {.lex_state = 213},
  [1829] = {.lex_state = 188, .external_lex_state = 1},
  [1830] = {.lex_state = 135},
  [1831] = {.lex_state = 156},
  [1832] = {.lex_state = 159},
  [1833] = {.lex_state = 208, .external_lex_state = 1},
  [1834] = {.lex_state = 159},
  [1835] = {.lex_state = 222, .external_lex_state = 1},
  [1836] = {.lex_state = 173},
  [1837] = {.lex_state = 159},
  [1838] = {.lex_state = 159},
  [1839] = {.lex_state = 159},
  [1840] = {.lex_state = 173},
  [1841] = {.lex_state = 159},
  [1842] = {.lex_state = 159},
  [1843] = {.lex_state = 159},
  [1844] = {.lex_state = 159},
  [1845] = {.lex_state = 159},
  [1846] = {.lex_state = 159},
  [1847] = {.lex_state = 159},
  [1848] = {.lex_state = 159},
  [1849] = {.lex_state = 159},
  [1850] = {.lex_state = 206, .external_lex_state = 1},
  [1851] = {.lex_state = 159},
  [1852] = {.lex_state = 159},
  [1853] = {.lex_state = 209},
  [1854] = {.lex_state = 159},
  [1855] = {.lex_state = 159},
  [1856] = {.lex_state = 171},
  [1857] = {.lex_state = 171},
  [1858] = {.lex_state = 171},
  [1859] = {.lex_state = 204},
  [1860] = {.lex_state = 204},
  [1861] = {.lex_state = 159},
  [1862] = {.lex_state = 159},
  [1863] = {.lex_state = 204},
  [1864] = {.lex_state = 188, .external_lex_state = 1},
  [1865] = {.lex_state = 156},
  [1866] = {.lex_state = 159},
  [1867] = {.lex_state = 208, .external_lex_state = 1},
  [1868] = {.lex_state = 159},
  [1869] = {.lex_state = 222, .external_lex_state = 1},
  [1870] = {.lex_state = 159},
  [1871] = {.lex_state = 173},
  [1872] = {.lex_state = 159},
  [1873] = {.lex_state = 159},
  [1874] = {.lex_state = 159},
  [1875] = {.lex_state = 159},
  [1876] = {.lex_state = 159},
  [1877] = {.lex_state = 159},
  [1878] = {.lex_state = 159},
  [1879] = {.lex_state = 159},
  [1880] = {.lex_state = 159},
  [1881] = {.lex_state = 188, .external_lex_state = 1},
  [1882] = {.lex_state = 156},
  [1883] = {.lex_state = 159},
  [1884] = {.lex_state = 208, .external_lex_state = 1},
  [1885] = {.lex_state = 159},
  [1886] = {.lex_state = 222, .external_lex_state = 1},
  [1887] = {.lex_state = 159},
  [1888] = {.lex_state = 173},
  [1889] = {.lex_state = 159},
  [1890] = {.lex_state = 159},
  [1891] = {.lex_state = 159},
  [1892] = {.lex_state = 159},
  [1893] = {.lex_state = 159},
  [1894] = {.lex_state = 159},
  [1895] = {.lex_state = 159},
  [1896] = {.lex_state = 159},
  [1897] = {.lex_state = 159},
  [1898] = {.lex_state = 213},
  [1899] = {.lex_state = 135},
  [1900] = {.lex_state = 156},
  [1901] = {.lex_state = 156},
  [1902] = {.lex_state = 135},
  [1903] = {.lex_state = 156},
  [1904] = {.lex_state = 156},
  [1905] = {.lex_state = 156},
  [1906] = {.lex_state = 173},
  [1907] = {.lex_state = 173},
  [1908] = {.lex_state = 156},
  [1909] = {.lex_state = 188, .external_lex_state = 1},
  [1910] = {.lex_state = 156},
  [1911] = {.lex_state = 209},
  [1912] = {.lex_state = 208, .external_lex_state = 1},
  [1913] = {.lex_state = 209},
  [1914] = {.lex_state = 222, .external_lex_state = 1},
  [1915] = {.lex_state = 209},
  [1916] = {.lex_state = 209},
  [1917] = {.lex_state = 173},
  [1918] = {.lex_state = 209},
  [1919] = {.lex_state = 209},
  [1920] = {.lex_state = 209},
  [1921] = {.lex_state = 209},
  [1922] = {.lex_state = 209},
  [1923] = {.lex_state = 209},
  [1924] = {.lex_state = 209},
  [1925] = {.lex_state = 209},
  [1926] = {.lex_state = 209},
  [1927] = {.lex_state = 135},
  [1928] = {.lex_state = 181},
  [1929] = {.lex_state = 181, .external_lex_state = 1},
  [1930] = {.lex_state = 159},
  [1931] = {.lex_state = 159},
  [1932] = {.lex_state = 181, .external_lex_state = 1},
  [1933] = {.lex_state = 219, .external_lex_state = 1},
  [1934] = {.lex_state = 135},
  [1935] = {.lex_state = 218, .external_lex_state = 1},
  [1936] = {.lex_state = 181, .external_lex_state = 1},
  [1937] = {.lex_state = 0},
  [1938] = {.lex_state = 218, .external_lex_state = 1},
  [1939] = {.lex_state = 181, .external_lex_state = 1},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 209, .external_lex_state = 1},
  [1942] = {.lex_state = 209, .external_lex_state = 1},
  [1943] = {.lex_state = 135},
  [1944] = {.lex_state = 181, .external_lex_state = 1},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 210, .external_lex_state = 1},
  [1947] = {.lex_state = 210, .external_lex_state = 1},
  [1948] = {.lex_state = 209},
  [1949] = {.lex_state = 173},
  [1950] = {.lex_state = 173},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 173},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 222, .external_lex_state = 1},
  [1955] = {.lex_state = 209},
  [1956] = {.lex_state = 173},
  [1957] = {.lex_state = 188, .external_lex_state = 1},
  [1958] = {.lex_state = 135},
  [1959] = {.lex_state = 135},
  [1960] = {.lex_state = 135},
  [1961] = {.lex_state = 135},
  [1962] = {.lex_state = 135},
  [1963] = {.lex_state = 135},
  [1964] = {.lex_state = 135},
  [1965] = {.lex_state = 135},
  [1966] = {.lex_state = 135},
  [1967] = {.lex_state = 135},
  [1968] = {.lex_state = 135},
  [1969] = {.lex_state = 135},
  [1970] = {.lex_state = 223},
  [1971] = {.lex_state = 135},
  [1972] = {.lex_state = 181, .external_lex_state = 1},
  [1973] = {.lex_state = 135},
  [1974] = {.lex_state = 158},
  [1975] = {.lex_state = 171},
  [1976] = {.lex_state = 159},
  [1977] = {.lex_state = 171},
  [1978] = {.lex_state = 171},
  [1979] = {.lex_state = 160},
  [1980] = {.lex_state = 171},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 156},
  [1983] = {.lex_state = 171},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 156},
  [1986] = {.lex_state = 135},
  [1987] = {.lex_state = 135},
  [1988] = {.lex_state = 135},
  [1989] = {.lex_state = 171},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 156},
  [1992] = {.lex_state = 156},
  [1993] = {.lex_state = 156},
  [1994] = {.lex_state = 156},
  [1995] = {.lex_state = 156},
  [1996] = {.lex_state = 135},
  [1997] = {.lex_state = 195},
  [1998] = {.lex_state = 182, .external_lex_state = 1},
  [1999] = {.lex_state = 195},
  [2000] = {.lex_state = 220, .external_lex_state = 1},
  [2001] = {.lex_state = 150},
  [2002] = {.lex_state = 220, .external_lex_state = 1},
  [2003] = {.lex_state = 220, .external_lex_state = 1},
  [2004] = {.lex_state = 220, .external_lex_state = 1},
  [2005] = {.lex_state = 130},
  [2006] = {.lex_state = 135},
  [2007] = {.lex_state = 141},
  [2008] = {.lex_state = 135},
  [2009] = {.lex_state = 135},
  [2010] = {.lex_state = 150},
  [2011] = {.lex_state = 224, .external_lex_state = 1},
  [2012] = {.lex_state = 135},
  [2013] = {.lex_state = 182, .external_lex_state = 1},
  [2014] = {.lex_state = 135},
  [2015] = {.lex_state = 0},
  [2016] = {.lex_state = 188, .external_lex_state = 1},
  [2017] = {.lex_state = 156},
  [2018] = {.lex_state = 0},
  [2019] = {.lex_state = 188, .external_lex_state = 1},
  [2020] = {.lex_state = 0},
  [2021] = {.lex_state = 188, .external_lex_state = 1},
  [2022] = {.lex_state = 155},
  [2023] = {.lex_state = 155},
  [2024] = {.lex_state = 135},
  [2025] = {.lex_state = 211},
  [2026] = {.lex_state = 224, .external_lex_state = 1},
  [2027] = {.lex_state = 224, .external_lex_state = 1},
  [2028] = {.lex_state = 155},
  [2029] = {.lex_state = 159},
  [2030] = {.lex_state = 155},
  [2031] = {.lex_state = 224, .external_lex_state = 1},
  [2032] = {.lex_state = 220, .external_lex_state = 1},
  [2033] = {.lex_state = 141},
  [2034] = {.lex_state = 220, .external_lex_state = 1},
  [2035] = {.lex_state = 135},
  [2036] = {.lex_state = 135},
  [2037] = {.lex_state = 220, .external_lex_state = 1},
  [2038] = {.lex_state = 182, .external_lex_state = 1},
  [2039] = {.lex_state = 188, .external_lex_state = 1},
  [2040] = {.lex_state = 0},
  [2041] = {.lex_state = 188, .external_lex_state = 1},
  [2042] = {.lex_state = 173},
  [2043] = {.lex_state = 188, .external_lex_state = 1},
  [2044] = {.lex_state = 188, .external_lex_state = 1},
  [2045] = {.lex_state = 135},
  [2046] = {.lex_state = 188, .external_lex_state = 1},
  [2047] = {.lex_state = 220, .external_lex_state = 1},
  [2048] = {.lex_state = 159},
  [2049] = {.lex_state = 155},
  [2050] = {.lex_state = 220, .external_lex_state = 1},
  [2051] = {.lex_state = 220, .external_lex_state = 1},
  [2052] = {.lex_state = 155},
  [2053] = {.lex_state = 188, .external_lex_state = 1},
  [2054] = {.lex_state = 182, .external_lex_state = 1},
  [2055] = {.lex_state = 182, .external_lex_state = 1},
  [2056] = {.lex_state = 220, .external_lex_state = 1},
  [2057] = {.lex_state = 159},
  [2058] = {.lex_state = 155},
  [2059] = {.lex_state = 135},
  [2060] = {.lex_state = 135},
  [2061] = {.lex_state = 220, .external_lex_state = 1},
  [2062] = {.lex_state = 182, .external_lex_state = 1},
  [2063] = {.lex_state = 188},
  [2064] = {.lex_state = 188},
  [2065] = {.lex_state = 220, .external_lex_state = 1},
  [2066] = {.lex_state = 182, .external_lex_state = 1},
  [2067] = {.lex_state = 182, .external_lex_state = 1},
  [2068] = {.lex_state = 182, .external_lex_state = 1},
  [2069] = {.lex_state = 188},
  [2070] = {.lex_state = 188},
  [2071] = {.lex_state = 182, .external_lex_state = 1},
  [2072] = {.lex_state = 182, .external_lex_state = 1},
  [2073] = {.lex_state = 182, .external_lex_state = 1},
  [2074] = {.lex_state = 188},
  [2075] = {.lex_state = 188},
  [2076] = {.lex_state = 182, .external_lex_state = 1},
  [2077] = {.lex_state = 182, .external_lex_state = 1},
  [2078] = {.lex_state = 155},
  [2079] = {.lex_state = 156},
  [2080] = {.lex_state = 188, .external_lex_state = 1},
  [2081] = {.lex_state = 213},
  [2082] = {.lex_state = 213},
  [2083] = {.lex_state = 188, .external_lex_state = 1},
  [2084] = {.lex_state = 208, .external_lex_state = 1},
  [2085] = {.lex_state = 213},
  [2086] = {.lex_state = 188, .external_lex_state = 1},
  [2087] = {.lex_state = 188, .external_lex_state = 1},
  [2088] = {.lex_state = 188, .external_lex_state = 1},
  [2089] = {.lex_state = 188, .external_lex_state = 1},
  [2090] = {.lex_state = 188, .external_lex_state = 1},
  [2091] = {.lex_state = 188, .external_lex_state = 1},
  [2092] = {.lex_state = 188, .external_lex_state = 1},
  [2093] = {.lex_state = 188, .external_lex_state = 1},
  [2094] = {.lex_state = 188, .external_lex_state = 1},
  [2095] = {.lex_state = 188, .external_lex_state = 1},
  [2096] = {.lex_state = 188, .external_lex_state = 1},
  [2097] = {.lex_state = 188, .external_lex_state = 1},
  [2098] = {.lex_state = 188, .external_lex_state = 1},
  [2099] = {.lex_state = 213},
  [2100] = {.lex_state = 188, .external_lex_state = 1},
  [2101] = {.lex_state = 188, .external_lex_state = 1},
  [2102] = {.lex_state = 156},
  [2103] = {.lex_state = 173},
  [2104] = {.lex_state = 208, .external_lex_state = 1},
  [2105] = {.lex_state = 173},
  [2106] = {.lex_state = 222, .external_lex_state = 1},
  [2107] = {.lex_state = 173},
  [2108] = {.lex_state = 173},
  [2109] = {.lex_state = 182, .external_lex_state = 1},
  [2110] = {.lex_state = 173},
  [2111] = {.lex_state = 173},
  [2112] = {.lex_state = 173},
  [2113] = {.lex_state = 173},
  [2114] = {.lex_state = 173},
  [2115] = {.lex_state = 173},
  [2116] = {.lex_state = 173},
  [2117] = {.lex_state = 173},
  [2118] = {.lex_state = 173},
  [2119] = {.lex_state = 173},
  [2120] = {.lex_state = 124},
  [2121] = {.lex_state = 211},
  [2122] = {.lex_state = 211},
  [2123] = {.lex_state = 124},
  [2124] = {.lex_state = 188, .external_lex_state = 1},
  [2125] = {.lex_state = 173},
  [2126] = {.lex_state = 213},
  [2127] = {.lex_state = 188, .external_lex_state = 1},
  [2128] = {.lex_state = 213},
  [2129] = {.lex_state = 188, .external_lex_state = 1},
  [2130] = {.lex_state = 135},
  [2131] = {.lex_state = 211},
  [2132] = {.lex_state = 135},
  [2133] = {.lex_state = 124},
  [2134] = {.lex_state = 213},
  [2135] = {.lex_state = 0},
  [2136] = {.lex_state = 188, .external_lex_state = 1},
  [2137] = {.lex_state = 159},
  [2138] = {.lex_state = 156},
  [2139] = {.lex_state = 135},
  [2140] = {.lex_state = 135},
  [2141] = {.lex_state = 135},
  [2142] = {.lex_state = 188, .external_lex_state = 1},
  [2143] = {.lex_state = 205, .external_lex_state = 1},
  [2144] = {.lex_state = 159},
  [2145] = {.lex_state = 124},
  [2146] = {.lex_state = 124},
  [2147] = {.lex_state = 204},
  [2148] = {.lex_state = 155},
  [2149] = {.lex_state = 204},
  [2150] = {.lex_state = 188, .external_lex_state = 1},
  [2151] = {.lex_state = 188, .external_lex_state = 1},
  [2152] = {.lex_state = 226, .external_lex_state = 1},
  [2153] = {.lex_state = 222, .external_lex_state = 1},
  [2154] = {.lex_state = 159},
  [2155] = {.lex_state = 182, .external_lex_state = 1},
  [2156] = {.lex_state = 159},
  [2157] = {.lex_state = 155},
  [2158] = {.lex_state = 182, .external_lex_state = 1},
  [2159] = {.lex_state = 159},
  [2160] = {.lex_state = 155},
  [2161] = {.lex_state = 182, .external_lex_state = 1},
  [2162] = {.lex_state = 188, .external_lex_state = 1},
  [2163] = {.lex_state = 156},
  [2164] = {.lex_state = 156},
  [2165] = {.lex_state = 156},
  [2166] = {.lex_state = 156},
  [2167] = {.lex_state = 155},
  [2168] = {.lex_state = 155},
  [2169] = {.lex_state = 155},
  [2170] = {.lex_state = 155},
  [2171] = {.lex_state = 155},
  [2172] = {.lex_state = 195},
  [2173] = {.lex_state = 185},
  [2174] = {.lex_state = 195},
  [2175] = {.lex_state = 185},
  [2176] = {.lex_state = 188},
  [2177] = {.lex_state = 185},
  [2178] = {.lex_state = 188},
  [2179] = {.lex_state = 185},
  [2180] = {.lex_state = 188},
  [2181] = {.lex_state = 185},
  [2182] = {.lex_state = 185},
  [2183] = {.lex_state = 155},
  [2184] = {.lex_state = 185},
  [2185] = {.lex_state = 185},
  [2186] = {.lex_state = 155},
  [2187] = {.lex_state = 185},
  [2188] = {.lex_state = 185},
  [2189] = {.lex_state = 185},
  [2190] = {.lex_state = 159},
  [2191] = {.lex_state = 155},
  [2192] = {.lex_state = 185},
  [2193] = {.lex_state = 159},
  [2194] = {.lex_state = 155},
  [2195] = {.lex_state = 185},
  [2196] = {.lex_state = 185},
  [2197] = {.lex_state = 185},
  [2198] = {.lex_state = 155},
  [2199] = {.lex_state = 155},
  [2200] = {.lex_state = 155},
  [2201] = {.lex_state = 155},
  [2202] = {.lex_state = 135},
  [2203] = {.lex_state = 135},
  [2204] = {.lex_state = 135},
  [2205] = {.lex_state = 135},
  [2206] = {.lex_state = 135},
  [2207] = {.lex_state = 135},
  [2208] = {.lex_state = 135},
  [2209] = {.lex_state = 212},
  [2210] = {.lex_state = 188},
  [2211] = {.lex_state = 188},
  [2212] = {.lex_state = 212},
  [2213] = {.lex_state = 196},
  [2214] = {.lex_state = 196},
  [2215] = {.lex_state = 196},
  [2216] = {.lex_state = 196},
  [2217] = {.lex_state = 196},
  [2218] = {.lex_state = 196},
  [2219] = {.lex_state = 196},
  [2220] = {.lex_state = 196},
  [2221] = {.lex_state = 196},
  [2222] = {.lex_state = 196},
  [2223] = {.lex_state = 156},
  [2224] = {.lex_state = 204},
  [2225] = {.lex_state = 204},
  [2226] = {.lex_state = 204},
  [2227] = {.lex_state = 171},
  [2228] = {.lex_state = 209},
  [2229] = {.lex_state = 196},
  [2230] = {.lex_state = 135},
  [2231] = {.lex_state = 204},
  [2232] = {.lex_state = 204},
  [2233] = {.lex_state = 204},
  [2234] = {.lex_state = 159},
  [2235] = {.lex_state = 225},
  [2236] = {.lex_state = 135},
  [2237] = {.lex_state = 204},
  [2238] = {.lex_state = 204},
  [2239] = {.lex_state = 204},
  [2240] = {.lex_state = 204},
  [2241] = {.lex_state = 204},
  [2242] = {.lex_state = 227, .external_lex_state = 1},
  [2243] = {.lex_state = 222, .external_lex_state = 1},
  [2244] = {.lex_state = 213},
  [2245] = {.lex_state = 188, .external_lex_state = 1},
  [2246] = {.lex_state = 156},
  [2247] = {.lex_state = 156},
  [2248] = {.lex_state = 156},
  [2249] = {.lex_state = 171},
  [2250] = {.lex_state = 209},
  [2251] = {.lex_state = 171},
  [2252] = {.lex_state = 135},
  [2253] = {.lex_state = 135},
  [2254] = {.lex_state = 135},
  [2255] = {.lex_state = 156},
  [2256] = {.lex_state = 135},
  [2257] = {.lex_state = 206, .external_lex_state = 1},
  [2258] = {.lex_state = 159},
  [2259] = {.lex_state = 156},
  [2260] = {.lex_state = 188, .external_lex_state = 1},
  [2261] = {.lex_state = 159},
  [2262] = {.lex_state = 159},
  [2263] = {.lex_state = 188, .external_lex_state = 1},
  [2264] = {.lex_state = 208, .external_lex_state = 1},
  [2265] = {.lex_state = 159},
  [2266] = {.lex_state = 188, .external_lex_state = 1},
  [2267] = {.lex_state = 188, .external_lex_state = 1},
  [2268] = {.lex_state = 188, .external_lex_state = 1},
  [2269] = {.lex_state = 188, .external_lex_state = 1},
  [2270] = {.lex_state = 188, .external_lex_state = 1},
  [2271] = {.lex_state = 188, .external_lex_state = 1},
  [2272] = {.lex_state = 188, .external_lex_state = 1},
  [2273] = {.lex_state = 188, .external_lex_state = 1},
  [2274] = {.lex_state = 188, .external_lex_state = 1},
  [2275] = {.lex_state = 188, .external_lex_state = 1},
  [2276] = {.lex_state = 188, .external_lex_state = 1},
  [2277] = {.lex_state = 188, .external_lex_state = 1},
  [2278] = {.lex_state = 135},
  [2279] = {.lex_state = 135},
  [2280] = {.lex_state = 135},
  [2281] = {.lex_state = 135},
  [2282] = {.lex_state = 159},
  [2283] = {.lex_state = 159},
  [2284] = {.lex_state = 159},
  [2285] = {.lex_state = 159},
  [2286] = {.lex_state = 159},
  [2287] = {.lex_state = 155},
  [2288] = {.lex_state = 159},
  [2289] = {.lex_state = 226, .external_lex_state = 1},
  [2290] = {.lex_state = 222, .external_lex_state = 1},
  [2291] = {.lex_state = 159},
  [2292] = {.lex_state = 188, .external_lex_state = 1},
  [2293] = {.lex_state = 173},
  [2294] = {.lex_state = 206, .external_lex_state = 1},
  [2295] = {.lex_state = 135},
  [2296] = {.lex_state = 159},
  [2297] = {.lex_state = 159},
  [2298] = {.lex_state = 159},
  [2299] = {.lex_state = 159},
  [2300] = {.lex_state = 226, .external_lex_state = 1},
  [2301] = {.lex_state = 222, .external_lex_state = 1},
  [2302] = {.lex_state = 159},
  [2303] = {.lex_state = 188, .external_lex_state = 1},
  [2304] = {.lex_state = 226, .external_lex_state = 1},
  [2305] = {.lex_state = 222, .external_lex_state = 1},
  [2306] = {.lex_state = 159},
  [2307] = {.lex_state = 188, .external_lex_state = 1},
  [2308] = {.lex_state = 135},
  [2309] = {.lex_state = 156},
  [2310] = {.lex_state = 156},
  [2311] = {.lex_state = 156},
  [2312] = {.lex_state = 156},
  [2313] = {.lex_state = 156},
  [2314] = {.lex_state = 156},
  [2315] = {.lex_state = 156},
  [2316] = {.lex_state = 209, .external_lex_state = 1},
  [2317] = {.lex_state = 222, .external_lex_state = 1},
  [2318] = {.lex_state = 209},
  [2319] = {.lex_state = 188, .external_lex_state = 1},
  [2320] = {.lex_state = 181, .external_lex_state = 1},
  [2321] = {.lex_state = 159},
  [2322] = {.lex_state = 219, .external_lex_state = 1},
  [2323] = {.lex_state = 135},
  [2324] = {.lex_state = 181, .external_lex_state = 1},
  [2325] = {.lex_state = 181, .external_lex_state = 1},
  [2326] = {.lex_state = 209, .external_lex_state = 1},
  [2327] = {.lex_state = 181, .external_lex_state = 1},
  [2328] = {.lex_state = 0},
  [2329] = {.lex_state = 173},
  [2330] = {.lex_state = 173},
  [2331] = {.lex_state = 209},
  [2332] = {.lex_state = 209},
  [2333] = {.lex_state = 135},
  [2334] = {.lex_state = 135},
  [2335] = {.lex_state = 135},
  [2336] = {.lex_state = 135},
  [2337] = {.lex_state = 135},
  [2338] = {.lex_state = 135},
  [2339] = {.lex_state = 156},
  [2340] = {.lex_state = 156},
  [2341] = {.lex_state = 156},
  [2342] = {.lex_state = 135},
  [2343] = {.lex_state = 135},
  [2344] = {.lex_state = 0},
  [2345] = {.lex_state = 135},
  [2346] = {.lex_state = 223},
  [2347] = {.lex_state = 181, .external_lex_state = 1},
  [2348] = {.lex_state = 171},
  [2349] = {.lex_state = 159},
  [2350] = {.lex_state = 159},
  [2351] = {.lex_state = 171},
  [2352] = {.lex_state = 171},
  [2353] = {.lex_state = 0},
  [2354] = {.lex_state = 171},
  [2355] = {.lex_state = 0},
  [2356] = {.lex_state = 135},
  [2357] = {.lex_state = 135},
  [2358] = {.lex_state = 171},
  [2359] = {.lex_state = 0},
  [2360] = {.lex_state = 156},
  [2361] = {.lex_state = 156},
  [2362] = {.lex_state = 182, .external_lex_state = 1},
  [2363] = {.lex_state = 182, .external_lex_state = 1},
  [2364] = {.lex_state = 141},
  [2365] = {.lex_state = 220, .external_lex_state = 1},
  [2366] = {.lex_state = 183},
  [2367] = {.lex_state = 220, .external_lex_state = 1},
  [2368] = {.lex_state = 188},
  [2369] = {.lex_state = 188},
  [2370] = {.lex_state = 220, .external_lex_state = 1},
  [2371] = {.lex_state = 220, .external_lex_state = 1},
  [2372] = {.lex_state = 188},
  [2373] = {.lex_state = 188},
  [2374] = {.lex_state = 220, .external_lex_state = 1},
  [2375] = {.lex_state = 220, .external_lex_state = 1},
  [2376] = {.lex_state = 188},
  [2377] = {.lex_state = 188},
  [2378] = {.lex_state = 220, .external_lex_state = 1},
  [2379] = {.lex_state = 224, .external_lex_state = 1},
  [2380] = {.lex_state = 150},
  [2381] = {.lex_state = 220, .external_lex_state = 1},
  [2382] = {.lex_state = 220, .external_lex_state = 1},
  [2383] = {.lex_state = 220, .external_lex_state = 1},
  [2384] = {.lex_state = 141},
  [2385] = {.lex_state = 224, .external_lex_state = 1},
  [2386] = {.lex_state = 135},
  [2387] = {.lex_state = 135},
  [2388] = {.lex_state = 224, .external_lex_state = 1},
  [2389] = {.lex_state = 182, .external_lex_state = 1},
  [2390] = {.lex_state = 188, .external_lex_state = 1},
  [2391] = {.lex_state = 0},
  [2392] = {.lex_state = 188, .external_lex_state = 1},
  [2393] = {.lex_state = 173},
  [2394] = {.lex_state = 188, .external_lex_state = 1},
  [2395] = {.lex_state = 188, .external_lex_state = 1},
  [2396] = {.lex_state = 135},
  [2397] = {.lex_state = 188, .external_lex_state = 1},
  [2398] = {.lex_state = 224, .external_lex_state = 1},
  [2399] = {.lex_state = 159},
  [2400] = {.lex_state = 155},
  [2401] = {.lex_state = 224, .external_lex_state = 1},
  [2402] = {.lex_state = 224, .external_lex_state = 1},
  [2403] = {.lex_state = 155},
  [2404] = {.lex_state = 188, .external_lex_state = 1},
  [2405] = {.lex_state = 224, .external_lex_state = 1},
  [2406] = {.lex_state = 159},
  [2407] = {.lex_state = 155},
  [2408] = {.lex_state = 135},
  [2409] = {.lex_state = 135},
  [2410] = {.lex_state = 224, .external_lex_state = 1},
  [2411] = {.lex_state = 224, .external_lex_state = 1},
  [2412] = {.lex_state = 188},
  [2413] = {.lex_state = 188},
  [2414] = {.lex_state = 220, .external_lex_state = 1},
  [2415] = {.lex_state = 195},
  [2416] = {.lex_state = 155},
  [2417] = {.lex_state = 135},
  [2418] = {.lex_state = 220, .external_lex_state = 1},
  [2419] = {.lex_state = 213},
  [2420] = {.lex_state = 188, .external_lex_state = 1},
  [2421] = {.lex_state = 213},
  [2422] = {.lex_state = 188, .external_lex_state = 1},
  [2423] = {.lex_state = 211},
  [2424] = {.lex_state = 220, .external_lex_state = 1},
  [2425] = {.lex_state = 124},
  [2426] = {.lex_state = 213},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 188, .external_lex_state = 1},
  [2429] = {.lex_state = 159},
  [2430] = {.lex_state = 156},
  [2431] = {.lex_state = 220, .external_lex_state = 1},
  [2432] = {.lex_state = 220, .external_lex_state = 1},
  [2433] = {.lex_state = 159},
  [2434] = {.lex_state = 220, .external_lex_state = 1},
  [2435] = {.lex_state = 220, .external_lex_state = 1},
  [2436] = {.lex_state = 155},
  [2437] = {.lex_state = 188, .external_lex_state = 1},
  [2438] = {.lex_state = 155},
  [2439] = {.lex_state = 188, .external_lex_state = 1},
  [2440] = {.lex_state = 155},
  [2441] = {.lex_state = 182, .external_lex_state = 1},
  [2442] = {.lex_state = 182, .external_lex_state = 1},
  [2443] = {.lex_state = 182, .external_lex_state = 1},
  [2444] = {.lex_state = 182, .external_lex_state = 1},
  [2445] = {.lex_state = 182, .external_lex_state = 1},
  [2446] = {.lex_state = 182, .external_lex_state = 1},
  [2447] = {.lex_state = 182, .external_lex_state = 1},
  [2448] = {.lex_state = 188, .external_lex_state = 1},
  [2449] = {.lex_state = 156},
  [2450] = {.lex_state = 213},
  [2451] = {.lex_state = 208, .external_lex_state = 1},
  [2452] = {.lex_state = 213},
  [2453] = {.lex_state = 222, .external_lex_state = 1},
  [2454] = {.lex_state = 182, .external_lex_state = 1},
  [2455] = {.lex_state = 182, .external_lex_state = 1},
  [2456] = {.lex_state = 135},
  [2457] = {.lex_state = 0},
  [2458] = {.lex_state = 188, .external_lex_state = 1},
  [2459] = {.lex_state = 156},
  [2460] = {.lex_state = 0},
  [2461] = {.lex_state = 188, .external_lex_state = 1},
  [2462] = {.lex_state = 0},
  [2463] = {.lex_state = 188, .external_lex_state = 1},
  [2464] = {.lex_state = 155},
  [2465] = {.lex_state = 155},
  [2466] = {.lex_state = 135},
  [2467] = {.lex_state = 159},
  [2468] = {.lex_state = 182, .external_lex_state = 1},
  [2469] = {.lex_state = 159},
  [2470] = {.lex_state = 155},
  [2471] = {.lex_state = 213},
  [2472] = {.lex_state = 173},
  [2473] = {.lex_state = 213},
  [2474] = {.lex_state = 213},
  [2475] = {.lex_state = 213},
  [2476] = {.lex_state = 213},
  [2477] = {.lex_state = 213},
  [2478] = {.lex_state = 213},
  [2479] = {.lex_state = 213},
  [2480] = {.lex_state = 213},
  [2481] = {.lex_state = 213},
  [2482] = {.lex_state = 188, .external_lex_state = 1},
  [2483] = {.lex_state = 182, .external_lex_state = 1},
  [2484] = {.lex_state = 173},
  [2485] = {.lex_state = 159, .external_lex_state = 1},
  [2486] = {.lex_state = 222, .external_lex_state = 1},
  [2487] = {.lex_state = 173},
  [2488] = {.lex_state = 188, .external_lex_state = 1},
  [2489] = {.lex_state = 211},
  [2490] = {.lex_state = 211},
  [2491] = {.lex_state = 182, .external_lex_state = 1},
  [2492] = {.lex_state = 188, .external_lex_state = 1},
  [2493] = {.lex_state = 213},
  [2494] = {.lex_state = 188, .external_lex_state = 1},
  [2495] = {.lex_state = 135},
  [2496] = {.lex_state = 135},
  [2497] = {.lex_state = 135},
  [2498] = {.lex_state = 159},
  [2499] = {.lex_state = 155},
  [2500] = {.lex_state = 188, .external_lex_state = 1},
  [2501] = {.lex_state = 188, .external_lex_state = 1},
  [2502] = {.lex_state = 205, .external_lex_state = 1},
  [2503] = {.lex_state = 159},
  [2504] = {.lex_state = 188, .external_lex_state = 1},
  [2505] = {.lex_state = 188, .external_lex_state = 1},
  [2506] = {.lex_state = 213},
  [2507] = {.lex_state = 188, .external_lex_state = 1},
  [2508] = {.lex_state = 213},
  [2509] = {.lex_state = 205, .external_lex_state = 1},
  [2510] = {.lex_state = 204},
  [2511] = {.lex_state = 204},
  [2512] = {.lex_state = 188, .external_lex_state = 1},
  [2513] = {.lex_state = 204},
  [2514] = {.lex_state = 155},
  [2515] = {.lex_state = 159},
  [2516] = {.lex_state = 213},
  [2517] = {.lex_state = 159},
  [2518] = {.lex_state = 182, .external_lex_state = 1},
  [2519] = {.lex_state = 182, .external_lex_state = 1},
  [2520] = {.lex_state = 159},
  [2521] = {.lex_state = 156},
  [2522] = {.lex_state = 185},
  [2523] = {.lex_state = 185},
  [2524] = {.lex_state = 185},
  [2525] = {.lex_state = 185},
  [2526] = {.lex_state = 185},
  [2527] = {.lex_state = 185},
  [2528] = {.lex_state = 185},
  [2529] = {.lex_state = 185},
  [2530] = {.lex_state = 185},
  [2531] = {.lex_state = 135},
  [2532] = {.lex_state = 188},
  [2533] = {.lex_state = 188},
  [2534] = {.lex_state = 135},
  [2535] = {.lex_state = 204},
  [2536] = {.lex_state = 171},
  [2537] = {.lex_state = 204},
  [2538] = {.lex_state = 204},
  [2539] = {.lex_state = 204},
  [2540] = {.lex_state = 204},
  [2541] = {.lex_state = 204},
  [2542] = {.lex_state = 196},
  [2543] = {.lex_state = 225},
  [2544] = {.lex_state = 204},
  [2545] = {.lex_state = 204},
  [2546] = {.lex_state = 204},
  [2547] = {.lex_state = 204},
  [2548] = {.lex_state = 213},
  [2549] = {.lex_state = 213},
  [2550] = {.lex_state = 156},
  [2551] = {.lex_state = 171},
  [2552] = {.lex_state = 135},
  [2553] = {.lex_state = 135},
  [2554] = {.lex_state = 206, .external_lex_state = 1},
  [2555] = {.lex_state = 188, .external_lex_state = 1},
  [2556] = {.lex_state = 156},
  [2557] = {.lex_state = 159},
  [2558] = {.lex_state = 208, .external_lex_state = 1},
  [2559] = {.lex_state = 159},
  [2560] = {.lex_state = 222, .external_lex_state = 1},
  [2561] = {.lex_state = 159},
  [2562] = {.lex_state = 173},
  [2563] = {.lex_state = 159},
  [2564] = {.lex_state = 159},
  [2565] = {.lex_state = 159},
  [2566] = {.lex_state = 159},
  [2567] = {.lex_state = 159},
  [2568] = {.lex_state = 159},
  [2569] = {.lex_state = 159},
  [2570] = {.lex_state = 159},
  [2571] = {.lex_state = 159},
  [2572] = {.lex_state = 135},
  [2573] = {.lex_state = 135},
  [2574] = {.lex_state = 135},
  [2575] = {.lex_state = 135},
  [2576] = {.lex_state = 135},
  [2577] = {.lex_state = 159},
  [2578] = {.lex_state = 155},
  [2579] = {.lex_state = 159},
  [2580] = {.lex_state = 159},
  [2581] = {.lex_state = 159},
  [2582] = {.lex_state = 159},
  [2583] = {.lex_state = 159},
  [2584] = {.lex_state = 159},
  [2585] = {.lex_state = 159},
  [2586] = {.lex_state = 159},
  [2587] = {.lex_state = 156},
  [2588] = {.lex_state = 156},
  [2589] = {.lex_state = 156},
  [2590] = {.lex_state = 156},
  [2591] = {.lex_state = 156},
  [2592] = {.lex_state = 209},
  [2593] = {.lex_state = 209},
  [2594] = {.lex_state = 181, .external_lex_state = 1},
  [2595] = {.lex_state = 219, .external_lex_state = 1},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 135},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 171},
  [2601] = {.lex_state = 159},
  [2602] = {.lex_state = 171},
  [2603] = {.lex_state = 171},
  [2604] = {.lex_state = 135},
  [2605] = {.lex_state = 171},
  [2606] = {.lex_state = 195},
  [2607] = {.lex_state = 220, .external_lex_state = 1},
  [2608] = {.lex_state = 195},
  [2609] = {.lex_state = 220, .external_lex_state = 1},
  [2610] = {.lex_state = 220, .external_lex_state = 1},
  [2611] = {.lex_state = 220, .external_lex_state = 1},
  [2612] = {.lex_state = 188},
  [2613] = {.lex_state = 188},
  [2614] = {.lex_state = 220, .external_lex_state = 1},
  [2615] = {.lex_state = 220, .external_lex_state = 1},
  [2616] = {.lex_state = 220, .external_lex_state = 1},
  [2617] = {.lex_state = 188},
  [2618] = {.lex_state = 188},
  [2619] = {.lex_state = 220, .external_lex_state = 1},
  [2620] = {.lex_state = 220, .external_lex_state = 1},
  [2621] = {.lex_state = 220, .external_lex_state = 1},
  [2622] = {.lex_state = 188},
  [2623] = {.lex_state = 188},
  [2624] = {.lex_state = 141},
  [2625] = {.lex_state = 224, .external_lex_state = 1},
  [2626] = {.lex_state = 183},
  [2627] = {.lex_state = 224, .external_lex_state = 1},
  [2628] = {.lex_state = 188},
  [2629] = {.lex_state = 188},
  [2630] = {.lex_state = 220, .external_lex_state = 1},
  [2631] = {.lex_state = 224, .external_lex_state = 1},
  [2632] = {.lex_state = 188},
  [2633] = {.lex_state = 188},
  [2634] = {.lex_state = 220, .external_lex_state = 1},
  [2635] = {.lex_state = 224, .external_lex_state = 1},
  [2636] = {.lex_state = 188},
  [2637] = {.lex_state = 188},
  [2638] = {.lex_state = 220, .external_lex_state = 1},
  [2639] = {.lex_state = 195},
  [2640] = {.lex_state = 155},
  [2641] = {.lex_state = 135},
  [2642] = {.lex_state = 224, .external_lex_state = 1},
  [2643] = {.lex_state = 213},
  [2644] = {.lex_state = 188, .external_lex_state = 1},
  [2645] = {.lex_state = 213},
  [2646] = {.lex_state = 188, .external_lex_state = 1},
  [2647] = {.lex_state = 211},
  [2648] = {.lex_state = 224, .external_lex_state = 1},
  [2649] = {.lex_state = 124},
  [2650] = {.lex_state = 213},
  [2651] = {.lex_state = 0},
  [2652] = {.lex_state = 188, .external_lex_state = 1},
  [2653] = {.lex_state = 159},
  [2654] = {.lex_state = 156},
  [2655] = {.lex_state = 224, .external_lex_state = 1},
  [2656] = {.lex_state = 224, .external_lex_state = 1},
  [2657] = {.lex_state = 159},
  [2658] = {.lex_state = 224, .external_lex_state = 1},
  [2659] = {.lex_state = 224, .external_lex_state = 1},
  [2660] = {.lex_state = 155},
  [2661] = {.lex_state = 188, .external_lex_state = 1},
  [2662] = {.lex_state = 155},
  [2663] = {.lex_state = 188, .external_lex_state = 1},
  [2664] = {.lex_state = 155},
  [2665] = {.lex_state = 188},
  [2666] = {.lex_state = 188},
  [2667] = {.lex_state = 220, .external_lex_state = 1},
  [2668] = {.lex_state = 220, .external_lex_state = 1},
  [2669] = {.lex_state = 155},
  [2670] = {.lex_state = 188, .external_lex_state = 1},
  [2671] = {.lex_state = 213},
  [2672] = {.lex_state = 188, .external_lex_state = 1},
  [2673] = {.lex_state = 220, .external_lex_state = 1},
  [2674] = {.lex_state = 188, .external_lex_state = 1},
  [2675] = {.lex_state = 188, .external_lex_state = 1},
  [2676] = {.lex_state = 205, .external_lex_state = 1},
  [2677] = {.lex_state = 159},
  [2678] = {.lex_state = 188, .external_lex_state = 1},
  [2679] = {.lex_state = 188, .external_lex_state = 1},
  [2680] = {.lex_state = 220, .external_lex_state = 1},
  [2681] = {.lex_state = 159},
  [2682] = {.lex_state = 155},
  [2683] = {.lex_state = 220, .external_lex_state = 1},
  [2684] = {.lex_state = 159},
  [2685] = {.lex_state = 155},
  [2686] = {.lex_state = 220, .external_lex_state = 1},
  [2687] = {.lex_state = 227, .external_lex_state = 1},
  [2688] = {.lex_state = 222, .external_lex_state = 1},
  [2689] = {.lex_state = 213},
  [2690] = {.lex_state = 182, .external_lex_state = 1},
  [2691] = {.lex_state = 182, .external_lex_state = 1},
  [2692] = {.lex_state = 188, .external_lex_state = 1},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 188, .external_lex_state = 1},
  [2695] = {.lex_state = 173},
  [2696] = {.lex_state = 188, .external_lex_state = 1},
  [2697] = {.lex_state = 188, .external_lex_state = 1},
  [2698] = {.lex_state = 135},
  [2699] = {.lex_state = 188, .external_lex_state = 1},
  [2700] = {.lex_state = 182, .external_lex_state = 1},
  [2701] = {.lex_state = 159},
  [2702] = {.lex_state = 155},
  [2703] = {.lex_state = 182, .external_lex_state = 1},
  [2704] = {.lex_state = 182, .external_lex_state = 1},
  [2705] = {.lex_state = 155},
  [2706] = {.lex_state = 188, .external_lex_state = 1},
  [2707] = {.lex_state = 188, .external_lex_state = 1},
  [2708] = {.lex_state = 182, .external_lex_state = 1},
  [2709] = {.lex_state = 188, .external_lex_state = 1},
  [2710] = {.lex_state = 182, .external_lex_state = 1},
  [2711] = {.lex_state = 173},
  [2712] = {.lex_state = 173},
  [2713] = {.lex_state = 135},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 188, .external_lex_state = 1},
  [2716] = {.lex_state = 156},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 159},
  [2720] = {.lex_state = 135},
  [2721] = {.lex_state = 188, .external_lex_state = 1},
  [2722] = {.lex_state = 135},
  [2723] = {.lex_state = 155},
  [2724] = {.lex_state = 135},
  [2725] = {.lex_state = 135},
  [2726] = {.lex_state = 155},
  [2727] = {.lex_state = 135},
  [2728] = {.lex_state = 213},
  [2729] = {.lex_state = 188, .external_lex_state = 1},
  [2730] = {.lex_state = 213},
  [2731] = {.lex_state = 205, .external_lex_state = 1},
  [2732] = {.lex_state = 159},
  [2733] = {.lex_state = 213},
  [2734] = {.lex_state = 182, .external_lex_state = 1},
  [2735] = {.lex_state = 182, .external_lex_state = 1},
  [2736] = {.lex_state = 188, .external_lex_state = 1},
  [2737] = {.lex_state = 188, .external_lex_state = 1},
  [2738] = {.lex_state = 156},
  [2739] = {.lex_state = 213},
  [2740] = {.lex_state = 135},
  [2741] = {.lex_state = 204},
  [2742] = {.lex_state = 188, .external_lex_state = 1},
  [2743] = {.lex_state = 205, .external_lex_state = 1},
  [2744] = {.lex_state = 188, .external_lex_state = 1},
  [2745] = {.lex_state = 135},
  [2746] = {.lex_state = 135},
  [2747] = {.lex_state = 135},
  [2748] = {.lex_state = 135},
  [2749] = {.lex_state = 204},
  [2750] = {.lex_state = 204},
  [2751] = {.lex_state = 204},
  [2752] = {.lex_state = 204},
  [2753] = {.lex_state = 204},
  [2754] = {.lex_state = 204},
  [2755] = {.lex_state = 204},
  [2756] = {.lex_state = 204},
  [2757] = {.lex_state = 204},
  [2758] = {.lex_state = 135},
  [2759] = {.lex_state = 226, .external_lex_state = 1},
  [2760] = {.lex_state = 222, .external_lex_state = 1},
  [2761] = {.lex_state = 159},
  [2762] = {.lex_state = 188, .external_lex_state = 1},
  [2763] = {.lex_state = 135},
  [2764] = {.lex_state = 135},
  [2765] = {.lex_state = 135},
  [2766] = {.lex_state = 135},
  [2767] = {.lex_state = 156},
  [2768] = {.lex_state = 156},
  [2769] = {.lex_state = 156},
  [2770] = {.lex_state = 156},
  [2771] = {.lex_state = 171},
  [2772] = {.lex_state = 220, .external_lex_state = 1},
  [2773] = {.lex_state = 220, .external_lex_state = 1},
  [2774] = {.lex_state = 220, .external_lex_state = 1},
  [2775] = {.lex_state = 220, .external_lex_state = 1},
  [2776] = {.lex_state = 220, .external_lex_state = 1},
  [2777] = {.lex_state = 220, .external_lex_state = 1},
  [2778] = {.lex_state = 220, .external_lex_state = 1},
  [2779] = {.lex_state = 220, .external_lex_state = 1},
  [2780] = {.lex_state = 195},
  [2781] = {.lex_state = 224, .external_lex_state = 1},
  [2782] = {.lex_state = 195},
  [2783] = {.lex_state = 224, .external_lex_state = 1},
  [2784] = {.lex_state = 224, .external_lex_state = 1},
  [2785] = {.lex_state = 224, .external_lex_state = 1},
  [2786] = {.lex_state = 188},
  [2787] = {.lex_state = 188},
  [2788] = {.lex_state = 224, .external_lex_state = 1},
  [2789] = {.lex_state = 224, .external_lex_state = 1},
  [2790] = {.lex_state = 224, .external_lex_state = 1},
  [2791] = {.lex_state = 188},
  [2792] = {.lex_state = 188},
  [2793] = {.lex_state = 224, .external_lex_state = 1},
  [2794] = {.lex_state = 224, .external_lex_state = 1},
  [2795] = {.lex_state = 224, .external_lex_state = 1},
  [2796] = {.lex_state = 188},
  [2797] = {.lex_state = 188},
  [2798] = {.lex_state = 224, .external_lex_state = 1},
  [2799] = {.lex_state = 224, .external_lex_state = 1},
  [2800] = {.lex_state = 155},
  [2801] = {.lex_state = 188, .external_lex_state = 1},
  [2802] = {.lex_state = 213},
  [2803] = {.lex_state = 188, .external_lex_state = 1},
  [2804] = {.lex_state = 224, .external_lex_state = 1},
  [2805] = {.lex_state = 188, .external_lex_state = 1},
  [2806] = {.lex_state = 188, .external_lex_state = 1},
  [2807] = {.lex_state = 205, .external_lex_state = 1},
  [2808] = {.lex_state = 159},
  [2809] = {.lex_state = 188, .external_lex_state = 1},
  [2810] = {.lex_state = 188, .external_lex_state = 1},
  [2811] = {.lex_state = 224, .external_lex_state = 1},
  [2812] = {.lex_state = 159},
  [2813] = {.lex_state = 155},
  [2814] = {.lex_state = 224, .external_lex_state = 1},
  [2815] = {.lex_state = 159},
  [2816] = {.lex_state = 155},
  [2817] = {.lex_state = 224, .external_lex_state = 1},
  [2818] = {.lex_state = 220, .external_lex_state = 1},
  [2819] = {.lex_state = 220, .external_lex_state = 1},
  [2820] = {.lex_state = 182, .external_lex_state = 1},
  [2821] = {.lex_state = 135},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 188, .external_lex_state = 1},
  [2824] = {.lex_state = 156},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 188, .external_lex_state = 1},
  [2827] = {.lex_state = 0},
  [2828] = {.lex_state = 188, .external_lex_state = 1},
  [2829] = {.lex_state = 155},
  [2830] = {.lex_state = 155},
  [2831] = {.lex_state = 135},
  [2832] = {.lex_state = 159},
  [2833] = {.lex_state = 220, .external_lex_state = 1},
  [2834] = {.lex_state = 159},
  [2835] = {.lex_state = 155},
  [2836] = {.lex_state = 188, .external_lex_state = 1},
  [2837] = {.lex_state = 220, .external_lex_state = 1},
  [2838] = {.lex_state = 220, .external_lex_state = 1},
  [2839] = {.lex_state = 213},
  [2840] = {.lex_state = 188, .external_lex_state = 1},
  [2841] = {.lex_state = 213},
  [2842] = {.lex_state = 205, .external_lex_state = 1},
  [2843] = {.lex_state = 159},
  [2844] = {.lex_state = 213},
  [2845] = {.lex_state = 220, .external_lex_state = 1},
  [2846] = {.lex_state = 220, .external_lex_state = 1},
  [2847] = {.lex_state = 213},
  [2848] = {.lex_state = 182, .external_lex_state = 1},
  [2849] = {.lex_state = 213},
  [2850] = {.lex_state = 188, .external_lex_state = 1},
  [2851] = {.lex_state = 213},
  [2852] = {.lex_state = 188, .external_lex_state = 1},
  [2853] = {.lex_state = 135},
  [2854] = {.lex_state = 211},
  [2855] = {.lex_state = 182, .external_lex_state = 1},
  [2856] = {.lex_state = 124},
  [2857] = {.lex_state = 213},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 188, .external_lex_state = 1},
  [2860] = {.lex_state = 159},
  [2861] = {.lex_state = 156},
  [2862] = {.lex_state = 182, .external_lex_state = 1},
  [2863] = {.lex_state = 182, .external_lex_state = 1},
  [2864] = {.lex_state = 182, .external_lex_state = 1},
  [2865] = {.lex_state = 182, .external_lex_state = 1},
  [2866] = {.lex_state = 213},
  [2867] = {.lex_state = 188, .external_lex_state = 1},
  [2868] = {.lex_state = 188, .external_lex_state = 1},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 188, .external_lex_state = 1},
  [2871] = {.lex_state = 173},
  [2872] = {.lex_state = 188, .external_lex_state = 1},
  [2873] = {.lex_state = 188, .external_lex_state = 1},
  [2874] = {.lex_state = 188, .external_lex_state = 1},
  [2875] = {.lex_state = 188, .external_lex_state = 1},
  [2876] = {.lex_state = 188, .external_lex_state = 1},
  [2877] = {.lex_state = 135},
  [2878] = {.lex_state = 135},
  [2879] = {.lex_state = 155},
  [2880] = {.lex_state = 135},
  [2881] = {.lex_state = 135},
  [2882] = {.lex_state = 135},
  [2883] = {.lex_state = 188, .external_lex_state = 1},
  [2884] = {.lex_state = 156},
  [2885] = {.lex_state = 213},
  [2886] = {.lex_state = 205, .external_lex_state = 1},
  [2887] = {.lex_state = 188, .external_lex_state = 1},
  [2888] = {.lex_state = 213},
  [2889] = {.lex_state = 182, .external_lex_state = 1},
  [2890] = {.lex_state = 188, .external_lex_state = 1},
  [2891] = {.lex_state = 156},
  [2892] = {.lex_state = 156},
  [2893] = {.lex_state = 135},
  [2894] = {.lex_state = 204},
  [2895] = {.lex_state = 204},
  [2896] = {.lex_state = 204},
  [2897] = {.lex_state = 213},
  [2898] = {.lex_state = 182, .external_lex_state = 1},
  [2899] = {.lex_state = 204},
  [2900] = {.lex_state = 204},
  [2901] = {.lex_state = 204},
  [2902] = {.lex_state = 204},
  [2903] = {.lex_state = 204},
  [2904] = {.lex_state = 204},
  [2905] = {.lex_state = 204},
  [2906] = {.lex_state = 204},
  [2907] = {.lex_state = 204},
  [2908] = {.lex_state = 204},
  [2909] = {.lex_state = 159},
  [2910] = {.lex_state = 159},
  [2911] = {.lex_state = 135},
  [2912] = {.lex_state = 135},
  [2913] = {.lex_state = 156},
  [2914] = {.lex_state = 156},
  [2915] = {.lex_state = 224, .external_lex_state = 1},
  [2916] = {.lex_state = 224, .external_lex_state = 1},
  [2917] = {.lex_state = 224, .external_lex_state = 1},
  [2918] = {.lex_state = 224, .external_lex_state = 1},
  [2919] = {.lex_state = 224, .external_lex_state = 1},
  [2920] = {.lex_state = 224, .external_lex_state = 1},
  [2921] = {.lex_state = 224, .external_lex_state = 1},
  [2922] = {.lex_state = 224, .external_lex_state = 1},
  [2923] = {.lex_state = 224, .external_lex_state = 1},
  [2924] = {.lex_state = 224, .external_lex_state = 1},
  [2925] = {.lex_state = 182, .external_lex_state = 1},
  [2926] = {.lex_state = 135},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 188, .external_lex_state = 1},
  [2929] = {.lex_state = 156},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 188, .external_lex_state = 1},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 188, .external_lex_state = 1},
  [2934] = {.lex_state = 155},
  [2935] = {.lex_state = 155},
  [2936] = {.lex_state = 135},
  [2937] = {.lex_state = 159},
  [2938] = {.lex_state = 224, .external_lex_state = 1},
  [2939] = {.lex_state = 159},
  [2940] = {.lex_state = 155},
  [2941] = {.lex_state = 188, .external_lex_state = 1},
  [2942] = {.lex_state = 224, .external_lex_state = 1},
  [2943] = {.lex_state = 224, .external_lex_state = 1},
  [2944] = {.lex_state = 213},
  [2945] = {.lex_state = 188, .external_lex_state = 1},
  [2946] = {.lex_state = 213},
  [2947] = {.lex_state = 205, .external_lex_state = 1},
  [2948] = {.lex_state = 159},
  [2949] = {.lex_state = 213},
  [2950] = {.lex_state = 224, .external_lex_state = 1},
  [2951] = {.lex_state = 224, .external_lex_state = 1},
  [2952] = {.lex_state = 220, .external_lex_state = 1},
  [2953] = {.lex_state = 182, .external_lex_state = 1},
  [2954] = {.lex_state = 188, .external_lex_state = 1},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 188, .external_lex_state = 1},
  [2957] = {.lex_state = 173},
  [2958] = {.lex_state = 188, .external_lex_state = 1},
  [2959] = {.lex_state = 188, .external_lex_state = 1},
  [2960] = {.lex_state = 135},
  [2961] = {.lex_state = 188, .external_lex_state = 1},
  [2962] = {.lex_state = 220, .external_lex_state = 1},
  [2963] = {.lex_state = 159},
  [2964] = {.lex_state = 155},
  [2965] = {.lex_state = 220, .external_lex_state = 1},
  [2966] = {.lex_state = 220, .external_lex_state = 1},
  [2967] = {.lex_state = 155},
  [2968] = {.lex_state = 188, .external_lex_state = 1},
  [2969] = {.lex_state = 188, .external_lex_state = 1},
  [2970] = {.lex_state = 220, .external_lex_state = 1},
  [2971] = {.lex_state = 220, .external_lex_state = 1},
  [2972] = {.lex_state = 220, .external_lex_state = 1},
  [2973] = {.lex_state = 220, .external_lex_state = 1},
  [2974] = {.lex_state = 188, .external_lex_state = 1},
  [2975] = {.lex_state = 156},
  [2976] = {.lex_state = 213},
  [2977] = {.lex_state = 205, .external_lex_state = 1},
  [2978] = {.lex_state = 188, .external_lex_state = 1},
  [2979] = {.lex_state = 188, .external_lex_state = 1},
  [2980] = {.lex_state = 213},
  [2981] = {.lex_state = 188, .external_lex_state = 1},
  [2982] = {.lex_state = 182, .external_lex_state = 1},
  [2983] = {.lex_state = 135},
  [2984] = {.lex_state = 135},
  [2985] = {.lex_state = 159},
  [2986] = {.lex_state = 155},
  [2987] = {.lex_state = 188, .external_lex_state = 1},
  [2988] = {.lex_state = 188, .external_lex_state = 1},
  [2989] = {.lex_state = 205, .external_lex_state = 1},
  [2990] = {.lex_state = 159},
  [2991] = {.lex_state = 188, .external_lex_state = 1},
  [2992] = {.lex_state = 188, .external_lex_state = 1},
  [2993] = {.lex_state = 182, .external_lex_state = 1},
  [2994] = {.lex_state = 213},
  [2995] = {.lex_state = 188, .external_lex_state = 1},
  [2996] = {.lex_state = 213},
  [2997] = {.lex_state = 188, .external_lex_state = 1},
  [2998] = {.lex_state = 211},
  [2999] = {.lex_state = 213},
  [3000] = {.lex_state = 188, .external_lex_state = 1},
  [3001] = {.lex_state = 159},
  [3002] = {.lex_state = 156},
  [3003] = {.lex_state = 135},
  [3004] = {.lex_state = 188, .external_lex_state = 1},
  [3005] = {.lex_state = 135},
  [3006] = {.lex_state = 135},
  [3007] = {.lex_state = 188, .external_lex_state = 1},
  [3008] = {.lex_state = 156},
  [3009] = {.lex_state = 213},
  [3010] = {.lex_state = 135},
  [3011] = {.lex_state = 182, .external_lex_state = 1},
  [3012] = {.lex_state = 188, .external_lex_state = 1},
  [3013] = {.lex_state = 204},
  [3014] = {.lex_state = 204},
  [3015] = {.lex_state = 204},
  [3016] = {.lex_state = 204},
  [3017] = {.lex_state = 204},
  [3018] = {.lex_state = 156},
  [3019] = {.lex_state = 204},
  [3020] = {.lex_state = 204},
  [3021] = {.lex_state = 204},
  [3022] = {.lex_state = 204},
  [3023] = {.lex_state = 224, .external_lex_state = 1},
  [3024] = {.lex_state = 182, .external_lex_state = 1},
  [3025] = {.lex_state = 188, .external_lex_state = 1},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 188, .external_lex_state = 1},
  [3028] = {.lex_state = 173},
  [3029] = {.lex_state = 188, .external_lex_state = 1},
  [3030] = {.lex_state = 188, .external_lex_state = 1},
  [3031] = {.lex_state = 135},
  [3032] = {.lex_state = 188, .external_lex_state = 1},
  [3033] = {.lex_state = 224, .external_lex_state = 1},
  [3034] = {.lex_state = 159},
  [3035] = {.lex_state = 155},
  [3036] = {.lex_state = 224, .external_lex_state = 1},
  [3037] = {.lex_state = 224, .external_lex_state = 1},
  [3038] = {.lex_state = 155},
  [3039] = {.lex_state = 188, .external_lex_state = 1},
  [3040] = {.lex_state = 188, .external_lex_state = 1},
  [3041] = {.lex_state = 224, .external_lex_state = 1},
  [3042] = {.lex_state = 224, .external_lex_state = 1},
  [3043] = {.lex_state = 224, .external_lex_state = 1},
  [3044] = {.lex_state = 224, .external_lex_state = 1},
  [3045] = {.lex_state = 188, .external_lex_state = 1},
  [3046] = {.lex_state = 156},
  [3047] = {.lex_state = 213},
  [3048] = {.lex_state = 205, .external_lex_state = 1},
  [3049] = {.lex_state = 188, .external_lex_state = 1},
  [3050] = {.lex_state = 220, .external_lex_state = 1},
  [3051] = {.lex_state = 213},
  [3052] = {.lex_state = 188, .external_lex_state = 1},
  [3053] = {.lex_state = 213},
  [3054] = {.lex_state = 188, .external_lex_state = 1},
  [3055] = {.lex_state = 135},
  [3056] = {.lex_state = 211},
  [3057] = {.lex_state = 220, .external_lex_state = 1},
  [3058] = {.lex_state = 124},
  [3059] = {.lex_state = 213},
  [3060] = {.lex_state = 0},
  [3061] = {.lex_state = 188, .external_lex_state = 1},
  [3062] = {.lex_state = 159},
  [3063] = {.lex_state = 156},
  [3064] = {.lex_state = 220, .external_lex_state = 1},
  [3065] = {.lex_state = 220, .external_lex_state = 1},
  [3066] = {.lex_state = 220, .external_lex_state = 1},
  [3067] = {.lex_state = 220, .external_lex_state = 1},
  [3068] = {.lex_state = 188, .external_lex_state = 1},
  [3069] = {.lex_state = 220, .external_lex_state = 1},
  [3070] = {.lex_state = 188, .external_lex_state = 1},
  [3071] = {.lex_state = 156},
  [3072] = {.lex_state = 213},
  [3073] = {.lex_state = 220, .external_lex_state = 1},
  [3074] = {.lex_state = 182, .external_lex_state = 1},
  [3075] = {.lex_state = 188, .external_lex_state = 1},
  [3076] = {.lex_state = 182, .external_lex_state = 1},
  [3077] = {.lex_state = 155},
  [3078] = {.lex_state = 135},
  [3079] = {.lex_state = 182, .external_lex_state = 1},
  [3080] = {.lex_state = 155},
  [3081] = {.lex_state = 182, .external_lex_state = 1},
  [3082] = {.lex_state = 213},
  [3083] = {.lex_state = 188, .external_lex_state = 1},
  [3084] = {.lex_state = 213},
  [3085] = {.lex_state = 205, .external_lex_state = 1},
  [3086] = {.lex_state = 159},
  [3087] = {.lex_state = 213},
  [3088] = {.lex_state = 188, .external_lex_state = 1},
  [3089] = {.lex_state = 213},
  [3090] = {.lex_state = 188, .external_lex_state = 1},
  [3091] = {.lex_state = 188, .external_lex_state = 1},
  [3092] = {.lex_state = 205, .external_lex_state = 1},
  [3093] = {.lex_state = 159},
  [3094] = {.lex_state = 188, .external_lex_state = 1},
  [3095] = {.lex_state = 188, .external_lex_state = 1},
  [3096] = {.lex_state = 135},
  [3097] = {.lex_state = 135},
  [3098] = {.lex_state = 188, .external_lex_state = 1},
  [3099] = {.lex_state = 156},
  [3100] = {.lex_state = 182, .external_lex_state = 1},
  [3101] = {.lex_state = 204},
  [3102] = {.lex_state = 204},
  [3103] = {.lex_state = 204},
  [3104] = {.lex_state = 204},
  [3105] = {.lex_state = 188, .external_lex_state = 1},
  [3106] = {.lex_state = 204},
  [3107] = {.lex_state = 204},
  [3108] = {.lex_state = 224, .external_lex_state = 1},
  [3109] = {.lex_state = 213},
  [3110] = {.lex_state = 188, .external_lex_state = 1},
  [3111] = {.lex_state = 213},
  [3112] = {.lex_state = 188, .external_lex_state = 1},
  [3113] = {.lex_state = 135},
  [3114] = {.lex_state = 211},
  [3115] = {.lex_state = 224, .external_lex_state = 1},
  [3116] = {.lex_state = 124},
  [3117] = {.lex_state = 213},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 188, .external_lex_state = 1},
  [3120] = {.lex_state = 159},
  [3121] = {.lex_state = 156},
  [3122] = {.lex_state = 224, .external_lex_state = 1},
  [3123] = {.lex_state = 224, .external_lex_state = 1},
  [3124] = {.lex_state = 224, .external_lex_state = 1},
  [3125] = {.lex_state = 224, .external_lex_state = 1},
  [3126] = {.lex_state = 188, .external_lex_state = 1},
  [3127] = {.lex_state = 224, .external_lex_state = 1},
  [3128] = {.lex_state = 188, .external_lex_state = 1},
  [3129] = {.lex_state = 156},
  [3130] = {.lex_state = 213},
  [3131] = {.lex_state = 224, .external_lex_state = 1},
  [3132] = {.lex_state = 188, .external_lex_state = 1},
  [3133] = {.lex_state = 213},
  [3134] = {.lex_state = 188, .external_lex_state = 1},
  [3135] = {.lex_state = 220, .external_lex_state = 1},
  [3136] = {.lex_state = 135},
  [3137] = {.lex_state = 135},
  [3138] = {.lex_state = 159},
  [3139] = {.lex_state = 155},
  [3140] = {.lex_state = 188, .external_lex_state = 1},
  [3141] = {.lex_state = 188, .external_lex_state = 1},
  [3142] = {.lex_state = 205, .external_lex_state = 1},
  [3143] = {.lex_state = 159},
  [3144] = {.lex_state = 188, .external_lex_state = 1},
  [3145] = {.lex_state = 188, .external_lex_state = 1},
  [3146] = {.lex_state = 220, .external_lex_state = 1},
  [3147] = {.lex_state = 220, .external_lex_state = 1},
  [3148] = {.lex_state = 188, .external_lex_state = 1},
  [3149] = {.lex_state = 156},
  [3150] = {.lex_state = 188, .external_lex_state = 1},
  [3151] = {.lex_state = 182, .external_lex_state = 1},
  [3152] = {.lex_state = 182, .external_lex_state = 1},
  [3153] = {.lex_state = 155},
  [3154] = {.lex_state = 182, .external_lex_state = 1},
  [3155] = {.lex_state = 182, .external_lex_state = 1},
  [3156] = {.lex_state = 182, .external_lex_state = 1},
  [3157] = {.lex_state = 188, .external_lex_state = 1},
  [3158] = {.lex_state = 156},
  [3159] = {.lex_state = 213},
  [3160] = {.lex_state = 205, .external_lex_state = 1},
  [3161] = {.lex_state = 188, .external_lex_state = 1},
  [3162] = {.lex_state = 135},
  [3163] = {.lex_state = 188, .external_lex_state = 1},
  [3164] = {.lex_state = 188, .external_lex_state = 1},
  [3165] = {.lex_state = 213},
  [3166] = {.lex_state = 205, .external_lex_state = 1},
  [3167] = {.lex_state = 159},
  [3168] = {.lex_state = 213},
  [3169] = {.lex_state = 135},
  [3170] = {.lex_state = 188, .external_lex_state = 1},
  [3171] = {.lex_state = 204},
  [3172] = {.lex_state = 204},
  [3173] = {.lex_state = 182, .external_lex_state = 1},
  [3174] = {.lex_state = 188, .external_lex_state = 1},
  [3175] = {.lex_state = 213},
  [3176] = {.lex_state = 188, .external_lex_state = 1},
  [3177] = {.lex_state = 224, .external_lex_state = 1},
  [3178] = {.lex_state = 135},
  [3179] = {.lex_state = 135},
  [3180] = {.lex_state = 159},
  [3181] = {.lex_state = 155},
  [3182] = {.lex_state = 188, .external_lex_state = 1},
  [3183] = {.lex_state = 188, .external_lex_state = 1},
  [3184] = {.lex_state = 205, .external_lex_state = 1},
  [3185] = {.lex_state = 159},
  [3186] = {.lex_state = 188, .external_lex_state = 1},
  [3187] = {.lex_state = 188, .external_lex_state = 1},
  [3188] = {.lex_state = 224, .external_lex_state = 1},
  [3189] = {.lex_state = 224, .external_lex_state = 1},
  [3190] = {.lex_state = 188, .external_lex_state = 1},
  [3191] = {.lex_state = 156},
  [3192] = {.lex_state = 220, .external_lex_state = 1},
  [3193] = {.lex_state = 188, .external_lex_state = 1},
  [3194] = {.lex_state = 220, .external_lex_state = 1},
  [3195] = {.lex_state = 155},
  [3196] = {.lex_state = 135},
  [3197] = {.lex_state = 220, .external_lex_state = 1},
  [3198] = {.lex_state = 155},
  [3199] = {.lex_state = 220, .external_lex_state = 1},
  [3200] = {.lex_state = 213},
  [3201] = {.lex_state = 188, .external_lex_state = 1},
  [3202] = {.lex_state = 213},
  [3203] = {.lex_state = 205, .external_lex_state = 1},
  [3204] = {.lex_state = 159},
  [3205] = {.lex_state = 213},
  [3206] = {.lex_state = 220, .external_lex_state = 1},
  [3207] = {.lex_state = 188, .external_lex_state = 1},
  [3208] = {.lex_state = 182, .external_lex_state = 1},
  [3209] = {.lex_state = 188, .external_lex_state = 1},
  [3210] = {.lex_state = 182, .external_lex_state = 1},
  [3211] = {.lex_state = 182, .external_lex_state = 1},
  [3212] = {.lex_state = 188, .external_lex_state = 1},
  [3213] = {.lex_state = 156},
  [3214] = {.lex_state = 213},
  [3215] = {.lex_state = 182, .external_lex_state = 1},
  [3216] = {.lex_state = 188, .external_lex_state = 1},
  [3217] = {.lex_state = 135},
  [3218] = {.lex_state = 188, .external_lex_state = 1},
  [3219] = {.lex_state = 156},
  [3220] = {.lex_state = 213},
  [3221] = {.lex_state = 205, .external_lex_state = 1},
  [3222] = {.lex_state = 188, .external_lex_state = 1},
  [3223] = {.lex_state = 135},
  [3224] = {.lex_state = 224, .external_lex_state = 1},
  [3225] = {.lex_state = 188, .external_lex_state = 1},
  [3226] = {.lex_state = 224, .external_lex_state = 1},
  [3227] = {.lex_state = 155},
  [3228] = {.lex_state = 135},
  [3229] = {.lex_state = 224, .external_lex_state = 1},
  [3230] = {.lex_state = 155},
  [3231] = {.lex_state = 224, .external_lex_state = 1},
  [3232] = {.lex_state = 213},
  [3233] = {.lex_state = 188, .external_lex_state = 1},
  [3234] = {.lex_state = 213},
  [3235] = {.lex_state = 205, .external_lex_state = 1},
  [3236] = {.lex_state = 159},
  [3237] = {.lex_state = 213},
  [3238] = {.lex_state = 224, .external_lex_state = 1},
  [3239] = {.lex_state = 188, .external_lex_state = 1},
  [3240] = {.lex_state = 188, .external_lex_state = 1},
  [3241] = {.lex_state = 220, .external_lex_state = 1},
  [3242] = {.lex_state = 220, .external_lex_state = 1},
  [3243] = {.lex_state = 155},
  [3244] = {.lex_state = 220, .external_lex_state = 1},
  [3245] = {.lex_state = 220, .external_lex_state = 1},
  [3246] = {.lex_state = 220, .external_lex_state = 1},
  [3247] = {.lex_state = 188, .external_lex_state = 1},
  [3248] = {.lex_state = 156},
  [3249] = {.lex_state = 213},
  [3250] = {.lex_state = 205, .external_lex_state = 1},
  [3251] = {.lex_state = 188, .external_lex_state = 1},
  [3252] = {.lex_state = 220, .external_lex_state = 1},
  [3253] = {.lex_state = 182, .external_lex_state = 1},
  [3254] = {.lex_state = 182, .external_lex_state = 1},
  [3255] = {.lex_state = 188, .external_lex_state = 1},
  [3256] = {.lex_state = 156},
  [3257] = {.lex_state = 188, .external_lex_state = 1},
  [3258] = {.lex_state = 188, .external_lex_state = 1},
  [3259] = {.lex_state = 156},
  [3260] = {.lex_state = 213},
  [3261] = {.lex_state = 188, .external_lex_state = 1},
  [3262] = {.lex_state = 224, .external_lex_state = 1},
  [3263] = {.lex_state = 224, .external_lex_state = 1},
  [3264] = {.lex_state = 155},
  [3265] = {.lex_state = 224, .external_lex_state = 1},
  [3266] = {.lex_state = 224, .external_lex_state = 1},
  [3267] = {.lex_state = 224, .external_lex_state = 1},
  [3268] = {.lex_state = 188, .external_lex_state = 1},
  [3269] = {.lex_state = 156},
  [3270] = {.lex_state = 213},
  [3271] = {.lex_state = 205, .external_lex_state = 1},
  [3272] = {.lex_state = 188, .external_lex_state = 1},
  [3273] = {.lex_state = 224, .external_lex_state = 1},
  [3274] = {.lex_state = 220, .external_lex_state = 1},
  [3275] = {.lex_state = 188, .external_lex_state = 1},
  [3276] = {.lex_state = 220, .external_lex_state = 1},
  [3277] = {.lex_state = 220, .external_lex_state = 1},
  [3278] = {.lex_state = 188, .external_lex_state = 1},
  [3279] = {.lex_state = 156},
  [3280] = {.lex_state = 213},
  [3281] = {.lex_state = 220, .external_lex_state = 1},
  [3282] = {.lex_state = 182, .external_lex_state = 1},
  [3283] = {.lex_state = 188, .external_lex_state = 1},
  [3284] = {.lex_state = 188, .external_lex_state = 1},
  [3285] = {.lex_state = 156},
  [3286] = {.lex_state = 224, .external_lex_state = 1},
  [3287] = {.lex_state = 188, .external_lex_state = 1},
  [3288] = {.lex_state = 224, .external_lex_state = 1},
  [3289] = {.lex_state = 224, .external_lex_state = 1},
  [3290] = {.lex_state = 188, .external_lex_state = 1},
  [3291] = {.lex_state = 156},
  [3292] = {.lex_state = 213},
  [3293] = {.lex_state = 224, .external_lex_state = 1},
  [3294] = {.lex_state = 220, .external_lex_state = 1},
  [3295] = {.lex_state = 220, .external_lex_state = 1},
  [3296] = {.lex_state = 188, .external_lex_state = 1},
  [3297] = {.lex_state = 156},
  [3298] = {.lex_state = 182, .external_lex_state = 1},
  [3299] = {.lex_state = 188, .external_lex_state = 1},
  [3300] = {.lex_state = 224, .external_lex_state = 1},
  [3301] = {.lex_state = 224, .external_lex_state = 1},
  [3302] = {.lex_state = 188, .external_lex_state = 1},
  [3303] = {.lex_state = 156},
  [3304] = {.lex_state = 220, .external_lex_state = 1},
  [3305] = {.lex_state = 188, .external_lex_state = 1},
  [3306] = {.lex_state = 224, .external_lex_state = 1},
  [3307] = {.lex_state = 188, .external_lex_state = 1},
  [3308] = {.lex_state = 220, .external_lex_state = 1},
  [3309] = {.lex_state = 224, .external_lex_state = 1},
};

enum {
  ts_external_token_raw_string_literal,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_literal] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_raw_string_literal] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3),
    [sym_preproc_directive] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(3),
    [anon_sym_extern] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(3),
    [anon_sym_register] = ACTIONS(3),
    [anon_sym_inline] = ACTIONS(3),
    [anon_sym_const] = ACTIONS(3),
    [anon_sym_restrict] = ACTIONS(3),
    [anon_sym_volatile] = ACTIONS(3),
    [anon_sym__Atomic] = ACTIONS(3),
    [anon_sym_mutable] = ACTIONS(3),
    [anon_sym_explicit] = ACTIONS(3),
    [anon_sym_constexpr] = ACTIONS(3),
    [anon_sym_unsigned] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(3),
    [anon_sym_short] = ACTIONS(3),
    [sym_primitive_type] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(3),
    [anon_sym_struct] = ACTIONS(3),
    [anon_sym_union] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_switch] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_default] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_goto] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_null] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(3),
    [sym_virtual_specifier] = ACTIONS(3),
    [anon_sym_public] = ACTIONS(3),
    [sym_auto] = ACTIONS(3),
    [anon_sym_typename] = ACTIONS(3),
    [anon_sym_template] = ACTIONS(3),
    [anon_sym_friend] = ACTIONS(3),
    [anon_sym_private] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3),
    [sym_noexcept] = ACTIONS(3),
    [anon_sym_namespace] = ACTIONS(3),
    [anon_sym_using] = ACTIONS(3),
    [anon_sym_new] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(3),
    [sym_operator_name] = ACTIONS(1),
    [sym_nullptr] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(26),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(36),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(36),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [2] = {
    [sym_string_literal] = ACTIONS(65),
    [sym_system_lib_string] = ACTIONS(65),
    [sym_comment] = ACTIONS(49),
  },
  [3] = {
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(49),
  },
  [4] = {
    [sym__declarator] = STATE(45),
    [sym_pointer_declarator] = STATE(45),
    [sym_function_declarator] = STATE(45),
    [sym_array_declarator] = STATE(45),
    [sym_reference_declarator] = STATE(45),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(45),
    [sym_destructor_name] = STATE(45),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(79),
  },
  [5] = {
    [sym_preproc_arg] = ACTIONS(81),
    [sym_comment] = ACTIONS(83),
  },
  [6] = {
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(49),
  },
  [7] = {
    [sym_identifier] = ACTIONS(87),
    [sym_comment] = ACTIONS(49),
  },
  [8] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(89),
    [anon_sym_LF] = ACTIONS(91),
    [sym_comment] = ACTIONS(83),
  },
  [9] = {
    [sym_type_qualifier] = STATE(65),
    [sym__type_specifier] = STATE(61),
    [sym_sized_type_specifier] = STATE(61),
    [sym_enum_specifier] = STATE(61),
    [sym_struct_specifier] = STATE(61),
    [sym_union_specifier] = STATE(61),
    [sym_macro_type_specifier] = STATE(61),
    [sym_class_specifier] = STATE(61),
    [sym_dependent_type] = STATE(61),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(65),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(97),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(97),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [10] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(117),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [11] = {
    [sym__declarator] = STATE(68),
    [sym_pointer_declarator] = STATE(68),
    [sym_function_declarator] = STATE(68),
    [sym_array_declarator] = STATE(68),
    [sym_reference_declarator] = STATE(68),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(68),
    [sym_destructor_name] = STATE(68),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(119),
  },
  [12] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [13] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [sym_operator_name] = ACTIONS(121),
  },
  [14] = {
    [sym_enumerator_list] = STATE(71),
    [anon_sym_LBRACE] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(49),
  },
  [15] = {
    [sym_field_declaration_list] = STATE(77),
    [sym__class_name] = STATE(78),
    [sym_base_class_clause] = STATE(79),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(135),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [16] = {
    [sym_field_declaration_list] = STATE(84),
    [sym__class_name] = STATE(85),
    [sym_base_class_clause] = STATE(86),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(139),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [17] = {
    [sym__declarator] = STATE(68),
    [sym_pointer_declarator] = STATE(68),
    [sym_function_declarator] = STATE(68),
    [sym_array_declarator] = STATE(68),
    [sym_reference_declarator] = STATE(68),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(68),
    [sym_destructor_name] = STATE(68),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(119),
  },
  [18] = {
    [sym_identifier] = ACTIONS(141),
    [sym_comment] = ACTIONS(49),
  },
  [19] = {
    [sym_template_argument_list] = STATE(90),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(146),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(146),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(152),
    [sym_operator_name] = ACTIONS(146),
  },
  [20] = {
    [sym_field_declaration_list] = STATE(92),
    [sym__class_name] = STATE(93),
    [sym_base_class_clause] = STATE(94),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(154),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [21] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [22] = {
    [sym__declaration_specifiers] = STATE(108),
    [sym__declarator] = STATE(109),
    [sym_pointer_declarator] = STATE(109),
    [sym_function_declarator] = STATE(109),
    [sym_array_declarator] = STATE(109),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_parameter_list] = STATE(111),
    [sym_reference_declarator] = STATE(109),
    [sym_template_type] = STATE(112),
    [sym_template_function] = STATE(109),
    [sym_destructor_name] = STATE(109),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(113),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(176),
    [sym_identifier] = ACTIONS(178),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(182),
    [sym_operator_name] = ACTIONS(184),
  },
  [23] = {
    [sym_declaration_list] = STATE(118),
    [anon_sym_LBRACE] = ACTIONS(186),
    [sym_identifier] = ACTIONS(188),
    [sym_comment] = ACTIONS(49),
  },
  [24] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(123),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(190),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(192),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [25] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(196),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(198),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(200),
    [sym_comment] = ACTIONS(49),
  },
  [27] = {
    [sym__declarator] = STATE(130),
    [sym_pointer_declarator] = STATE(130),
    [sym_function_declarator] = STATE(130),
    [sym_array_declarator] = STATE(130),
    [sym_init_declarator] = STATE(131),
    [sym_reference_declarator] = STATE(130),
    [sym_structured_binding_reference_declarator] = STATE(132),
    [sym_structured_binding_declarator] = STATE(133),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(130),
    [sym_destructor_name] = STATE(130),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(202),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(212),
  },
  [28] = {
    [sym_parameter_list] = STATE(136),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [29] = {
    [sym_compound_statement] = STATE(139),
    [sym_field_initializer_list] = STATE(140),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [30] = {
    [sym_storage_class_specifier] = STATE(143),
    [sym_type_qualifier] = STATE(143),
    [aux_sym__declaration_specifiers_repeat1] = STATE(143),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(234),
    [anon_sym_LPAREN] = ACTIONS(232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(234),
    [sym_preproc_directive] = ACTIONS(234),
    [anon_sym_typedef] = ACTIONS(234),
    [anon_sym_extern] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(232),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_static] = ACTIONS(234),
    [anon_sym_register] = ACTIONS(234),
    [anon_sym_inline] = ACTIONS(234),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_restrict] = ACTIONS(234),
    [anon_sym_volatile] = ACTIONS(234),
    [anon_sym__Atomic] = ACTIONS(234),
    [anon_sym_mutable] = ACTIONS(234),
    [anon_sym_explicit] = ACTIONS(234),
    [anon_sym_constexpr] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(234),
    [anon_sym_enum] = ACTIONS(234),
    [anon_sym_struct] = ACTIONS(234),
    [anon_sym_union] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(232),
    [anon_sym_TILDE] = ACTIONS(232),
    [sym_identifier] = ACTIONS(234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(234),
    [sym_auto] = ACTIONS(234),
    [anon_sym_typename] = ACTIONS(234),
    [anon_sym_template] = ACTIONS(234),
    [anon_sym_namespace] = ACTIONS(234),
    [anon_sym_using] = ACTIONS(234),
    [anon_sym_COLON_COLON] = ACTIONS(232),
    [sym_operator_name] = ACTIONS(232),
  },
  [32] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(240),
    [sym_operator_name] = ACTIONS(236),
  },
  [33] = {
    [sym_template_argument_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_COMMA] = ACTIONS(218),
    [anon_sym_RPAREN] = ACTIONS(218),
    [anon_sym_SEMI] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_EQ] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [34] = {
    [sym_template_argument_list] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [sym_operator_name] = ACTIONS(236),
  },
  [35] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(240),
  },
  [36] = {
    [sym_preproc_include] = STATE(147),
    [sym_preproc_def] = STATE(147),
    [sym_preproc_function_def] = STATE(147),
    [sym_preproc_call] = STATE(147),
    [sym_preproc_if] = STATE(147),
    [sym_preproc_ifdef] = STATE(147),
    [sym_function_definition] = STATE(147),
    [sym_declaration] = STATE(147),
    [sym_type_definition] = STATE(147),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(147),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(147),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(147),
    [sym_template_declaration] = STATE(147),
    [sym_template_instantiation] = STATE(147),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(147),
    [sym_using_declaration] = STATE(147),
    [sym_alias_declaration] = STATE(147),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(147),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [37] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(148),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(150),
    [sym_type_qualifier] = STATE(150),
    [sym__type_specifier] = STATE(149),
    [sym_sized_type_specifier] = STATE(149),
    [sym_enum_specifier] = STATE(149),
    [sym_struct_specifier] = STATE(149),
    [sym_union_specifier] = STATE(149),
    [sym_macro_type_specifier] = STATE(149),
    [sym_class_specifier] = STATE(149),
    [sym_dependent_type] = STATE(149),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(150),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(244),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [38] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(153),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(250),
    [anon_sym_long] = ACTIONS(250),
    [anon_sym_short] = ACTIONS(250),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_template] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_using] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [sym_operator_name] = ACTIONS(257),
  },
  [40] = {
    [sym_preproc_params] = STATE(157),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(261),
    [anon_sym_LF] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [41] = {
    [sym__declarator] = STATE(158),
    [sym_pointer_declarator] = STATE(158),
    [sym_function_declarator] = STATE(158),
    [sym_array_declarator] = STATE(158),
    [sym_reference_declarator] = STATE(158),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(158),
    [sym_destructor_name] = STATE(158),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(267),
  },
  [42] = {
    [sym__declarator] = STATE(159),
    [sym_pointer_declarator] = STATE(159),
    [sym_function_declarator] = STATE(159),
    [sym_array_declarator] = STATE(159),
    [sym_reference_declarator] = STATE(159),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(159),
    [sym_destructor_name] = STATE(159),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(269),
  },
  [43] = {
    [sym_template_argument_list] = STATE(161),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_COMMA] = ACTIONS(218),
    [anon_sym_RPAREN] = ACTIONS(218),
    [anon_sym_SEMI] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_EQ] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(271),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(273),
  },
  [44] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(275),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(198),
  },
  [45] = {
    [sym_parameter_list] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [46] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(279),
  },
  [47] = {
    [sym_template_argument_list] = STATE(146),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [48] = {
    [sym_preproc_include] = STATE(184),
    [sym_preproc_def] = STATE(184),
    [sym_preproc_function_def] = STATE(184),
    [sym_preproc_call] = STATE(184),
    [sym_preproc_if] = STATE(184),
    [sym_preproc_ifdef] = STATE(184),
    [sym_preproc_else] = STATE(180),
    [sym_preproc_elif] = STATE(180),
    [sym_function_definition] = STATE(184),
    [sym_declaration] = STATE(184),
    [sym_type_definition] = STATE(184),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(184),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(184),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(184),
    [sym_template_declaration] = STATE(184),
    [sym_template_instantiation] = STATE(184),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(184),
    [sym_using_declaration] = STATE(184),
    [sym_alias_declaration] = STATE(184),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(184),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [49] = {
    [sym_preproc_include] = STATE(188),
    [sym_preproc_def] = STATE(188),
    [sym_preproc_function_def] = STATE(188),
    [sym_preproc_call] = STATE(188),
    [sym_preproc_if] = STATE(188),
    [sym_preproc_ifdef] = STATE(188),
    [sym_preproc_else] = STATE(187),
    [sym_preproc_elif] = STATE(187),
    [sym_function_definition] = STATE(188),
    [sym_declaration] = STATE(188),
    [sym_type_definition] = STATE(188),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(188),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(188),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(188),
    [sym_template_declaration] = STATE(188),
    [sym_template_instantiation] = STATE(188),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(188),
    [sym_using_declaration] = STATE(188),
    [sym_alias_declaration] = STATE(188),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(188),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(309),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [50] = {
    [sym_preproc_include] = STATE(191),
    [sym_preproc_def] = STATE(191),
    [sym_preproc_function_def] = STATE(191),
    [sym_preproc_call] = STATE(191),
    [sym_preproc_if] = STATE(191),
    [sym_preproc_ifdef] = STATE(191),
    [sym_preproc_else] = STATE(190),
    [sym_preproc_elif] = STATE(190),
    [sym_function_definition] = STATE(191),
    [sym_declaration] = STATE(191),
    [sym_type_definition] = STATE(191),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(191),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(191),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(191),
    [sym_template_declaration] = STATE(191),
    [sym_template_instantiation] = STATE(191),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(191),
    [sym_using_declaration] = STATE(191),
    [sym_alias_declaration] = STATE(191),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(191),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [51] = {
    [sym_preproc_arg] = ACTIONS(313),
    [sym_comment] = ACTIONS(83),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_RBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_namespace] = ACTIONS(317),
    [anon_sym_using] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [sym_operator_name] = ACTIONS(315),
  },
  [53] = {
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
  },
  [54] = {
    [sym_enumerator_list] = STATE(195),
    [anon_sym_LBRACE] = ACTIONS(319),
    [sym_identifier] = ACTIONS(321),
    [sym_comment] = ACTIONS(49),
  },
  [55] = {
    [sym_field_declaration_list] = STATE(200),
    [sym__class_name] = STATE(201),
    [sym_base_class_clause] = STATE(202),
    [sym_template_type] = STATE(203),
    [sym_scoped_type_identifier] = STATE(204),
    [sym_scoped_namespace_identifier] = STATE(205),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(327),
    [anon_sym_COLON_COLON] = ACTIONS(329),
  },
  [56] = {
    [sym_field_declaration_list] = STATE(207),
    [sym__class_name] = STATE(208),
    [sym_base_class_clause] = STATE(209),
    [sym_template_type] = STATE(203),
    [sym_scoped_type_identifier] = STATE(204),
    [sym_scoped_namespace_identifier] = STATE(205),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(331),
    [anon_sym_COLON_COLON] = ACTIONS(329),
  },
  [57] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(333),
    [sym_identifier] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(335),
  },
  [58] = {
    [sym_field_declaration_list] = STATE(214),
    [sym__class_name] = STATE(215),
    [sym_base_class_clause] = STATE(216),
    [sym_template_type] = STATE(203),
    [sym_scoped_type_identifier] = STATE(204),
    [sym_scoped_namespace_identifier] = STATE(205),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(337),
    [anon_sym_COLON_COLON] = ACTIONS(329),
  },
  [59] = {
    [sym__type_specifier] = STATE(217),
    [sym_sized_type_specifier] = STATE(217),
    [sym_enum_specifier] = STATE(217),
    [sym_struct_specifier] = STATE(217),
    [sym_union_specifier] = STATE(217),
    [sym_macro_type_specifier] = STATE(217),
    [sym_class_specifier] = STATE(217),
    [sym_dependent_type] = STATE(217),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(339),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(339),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [60] = {
    [sym_identifier] = ACTIONS(341),
    [sym_comment] = ACTIONS(49),
  },
  [61] = {
    [sym__type_declarator] = STATE(222),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [62] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [sym_identifier] = ACTIONS(236),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(349),
  },
  [63] = {
    [sym_template_argument_list] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(333),
    [sym_identifier] = ACTIONS(236),
    [sym_comment] = ACTIONS(49),
  },
  [64] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(349),
  },
  [65] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(228),
    [sym_sized_type_specifier] = STATE(228),
    [sym_enum_specifier] = STATE(228),
    [sym_struct_specifier] = STATE(228),
    [sym_union_specifier] = STATE(228),
    [sym_macro_type_specifier] = STATE(228),
    [sym_class_specifier] = STATE(228),
    [sym_dependent_type] = STATE(228),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(351),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(351),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [66] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [sym_primitive_type] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_comment] = ACTIONS(49),
  },
  [67] = {
    [sym_function_definition] = STATE(233),
    [sym_declaration] = STATE(233),
    [sym__declaration_specifiers] = STATE(234),
    [sym_declaration_list] = STATE(233),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(186),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [68] = {
    [sym_parameter_list] = STATE(235),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [69] = {
    [sym_enumerator] = STATE(239),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(362),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [70] = {
    [sym_enumerator_list] = STATE(240),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_COMMA] = ACTIONS(366),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_register] = ACTIONS(368),
    [anon_sym_inline] = ACTIONS(368),
    [anon_sym_const] = ACTIONS(368),
    [anon_sym_restrict] = ACTIONS(368),
    [anon_sym_volatile] = ACTIONS(368),
    [anon_sym__Atomic] = ACTIONS(368),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_explicit] = ACTIONS(368),
    [anon_sym_constexpr] = ACTIONS(368),
    [anon_sym_COLON] = ACTIONS(368),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_TILDE] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(366),
    [sym_identifier] = ACTIONS(368),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(366),
    [sym_operator_name] = ACTIONS(366),
  },
  [71] = {
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_COMMA] = ACTIONS(370),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_extern] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(372),
    [anon_sym_register] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(372),
    [anon_sym_const] = ACTIONS(372),
    [anon_sym_restrict] = ACTIONS(372),
    [anon_sym_volatile] = ACTIONS(372),
    [anon_sym__Atomic] = ACTIONS(372),
    [anon_sym_mutable] = ACTIONS(372),
    [anon_sym_explicit] = ACTIONS(372),
    [anon_sym_constexpr] = ACTIONS(372),
    [anon_sym_COLON] = ACTIONS(372),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_TILDE] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(370),
    [sym_identifier] = ACTIONS(372),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(370),
    [sym_operator_name] = ACTIONS(370),
  },
  [72] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(266),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(266),
    [sym_field_declaration] = STATE(266),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(266),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(266),
    [sym_access_specifier] = STATE(266),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(266),
    [sym_alias_declaration] = STATE(266),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(266),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [73] = {
    [sym__class_name] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
    [anon_sym_public] = ACTIONS(412),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [74] = {
    [sym_template_argument_list] = STATE(276),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_COMMA] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_extern] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(414),
    [anon_sym_static] = ACTIONS(416),
    [anon_sym_register] = ACTIONS(416),
    [anon_sym_inline] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(416),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(414),
    [sym_identifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(416),
    [anon_sym_COLON_COLON] = ACTIONS(420),
    [sym_operator_name] = ACTIONS(414),
  },
  [75] = {
    [sym_field_declaration_list] = STATE(277),
    [sym_base_class_clause] = STATE(278),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [76] = {
    [sym_identifier] = ACTIONS(424),
    [sym_comment] = ACTIONS(49),
  },
  [77] = {
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym_LBRACE] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_register] = ACTIONS(428),
    [anon_sym_inline] = ACTIONS(428),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(428),
    [anon_sym_volatile] = ACTIONS(428),
    [anon_sym__Atomic] = ACTIONS(428),
    [anon_sym_mutable] = ACTIONS(428),
    [anon_sym_explicit] = ACTIONS(428),
    [anon_sym_constexpr] = ACTIONS(428),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(426),
    [anon_sym_GT] = ACTIONS(426),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(426),
    [sym_operator_name] = ACTIONS(426),
  },
  [78] = {
    [sym_field_declaration_list] = STATE(277),
    [sym_base_class_clause] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_register] = ACTIONS(428),
    [anon_sym_inline] = ACTIONS(428),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(428),
    [anon_sym_volatile] = ACTIONS(428),
    [anon_sym__Atomic] = ACTIONS(428),
    [anon_sym_mutable] = ACTIONS(428),
    [anon_sym_explicit] = ACTIONS(428),
    [anon_sym_constexpr] = ACTIONS(428),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(426),
    [anon_sym_GT] = ACTIONS(426),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(430),
    [anon_sym_COLON_COLON] = ACTIONS(426),
    [sym_operator_name] = ACTIONS(426),
  },
  [79] = {
    [sym_field_declaration_list] = STATE(277),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [80] = {
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_register] = ACTIONS(434),
    [anon_sym_inline] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym__Atomic] = ACTIONS(434),
    [anon_sym_mutable] = ACTIONS(434),
    [anon_sym_explicit] = ACTIONS(434),
    [anon_sym_constexpr] = ACTIONS(434),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_GT] = ACTIONS(432),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
    [anon_sym_COLON_COLON] = ACTIONS(436),
    [sym_operator_name] = ACTIONS(432),
  },
  [81] = {
    [sym_template_argument_list] = STATE(282),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_register] = ACTIONS(434),
    [anon_sym_inline] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym__Atomic] = ACTIONS(434),
    [anon_sym_mutable] = ACTIONS(434),
    [anon_sym_explicit] = ACTIONS(434),
    [anon_sym_constexpr] = ACTIONS(434),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(432),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
    [anon_sym_COLON_COLON] = ACTIONS(432),
    [sym_operator_name] = ACTIONS(432),
  },
  [82] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(436),
  },
  [83] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [84] = {
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_register] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym__Atomic] = ACTIONS(440),
    [anon_sym_mutable] = ACTIONS(440),
    [anon_sym_explicit] = ACTIONS(440),
    [anon_sym_constexpr] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(438),
    [sym_operator_name] = ACTIONS(438),
  },
  [85] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_register] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym__Atomic] = ACTIONS(440),
    [anon_sym_mutable] = ACTIONS(440),
    [anon_sym_explicit] = ACTIONS(440),
    [anon_sym_constexpr] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(442),
    [anon_sym_COLON_COLON] = ACTIONS(438),
    [sym_operator_name] = ACTIONS(438),
  },
  [86] = {
    [sym_field_declaration_list] = STATE(283),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [87] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_COLON] = ACTIONS(444),
    [anon_sym_LT] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(444),
    [sym_comment] = ACTIONS(49),
  },
  [88] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(294),
    [sym_parenthesized_expression] = STATE(294),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(456),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [89] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(464),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [90] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [91] = {
    [sym_field_declaration_list] = STATE(299),
    [sym_base_class_clause] = STATE(300),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [92] = {
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_extern] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(477),
    [anon_sym_volatile] = ACTIONS(477),
    [anon_sym__Atomic] = ACTIONS(477),
    [anon_sym_mutable] = ACTIONS(477),
    [anon_sym_explicit] = ACTIONS(477),
    [anon_sym_constexpr] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(477),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(475),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(475),
    [sym_operator_name] = ACTIONS(475),
  },
  [93] = {
    [sym_field_declaration_list] = STATE(299),
    [sym_base_class_clause] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_extern] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(477),
    [anon_sym_volatile] = ACTIONS(477),
    [anon_sym__Atomic] = ACTIONS(477),
    [anon_sym_mutable] = ACTIONS(477),
    [anon_sym_explicit] = ACTIONS(477),
    [anon_sym_constexpr] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(475),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(479),
    [anon_sym_COLON_COLON] = ACTIONS(475),
    [sym_operator_name] = ACTIONS(475),
  },
  [94] = {
    [sym_field_declaration_list] = STATE(299),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [95] = {
    [sym_template_argument_list] = STATE(303),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_COMMA] = ACTIONS(146),
    [anon_sym_RPAREN] = ACTIONS(146),
    [anon_sym_SEMI] = ACTIONS(146),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(146),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(481),
    [sym_operator_name] = ACTIONS(146),
  },
  [96] = {
    [sym_identifier] = ACTIONS(483),
    [sym_comment] = ACTIONS(49),
  },
  [97] = {
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_RPAREN] = ACTIONS(485),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_extern] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_static] = ACTIONS(487),
    [anon_sym_register] = ACTIONS(487),
    [anon_sym_inline] = ACTIONS(487),
    [anon_sym_const] = ACTIONS(487),
    [anon_sym_restrict] = ACTIONS(487),
    [anon_sym_volatile] = ACTIONS(487),
    [anon_sym__Atomic] = ACTIONS(487),
    [anon_sym_mutable] = ACTIONS(487),
    [anon_sym_explicit] = ACTIONS(487),
    [anon_sym_constexpr] = ACTIONS(487),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(487),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_TILDE] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(485),
    [sym_identifier] = ACTIONS(487),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [sym_operator_name] = ACTIONS(485),
  },
  [98] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(489),
    [sym_operator_name] = ACTIONS(236),
  },
  [99] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(489),
  },
  [100] = {
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
  },
  [101] = {
    [sym__declarator] = STATE(306),
    [sym_pointer_declarator] = STATE(306),
    [sym_function_declarator] = STATE(306),
    [sym_array_declarator] = STATE(306),
    [sym_reference_declarator] = STATE(306),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(306),
    [sym_destructor_name] = STATE(306),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(491),
  },
  [102] = {
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(123),
    [anon_sym_enum] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_union] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(123),
    [sym_auto] = ACTIONS(123),
    [anon_sym_typename] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
  },
  [103] = {
    [sym__declarator] = STATE(307),
    [sym_pointer_declarator] = STATE(307),
    [sym_function_declarator] = STATE(307),
    [sym_array_declarator] = STATE(307),
    [sym_reference_declarator] = STATE(307),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(307),
    [sym_destructor_name] = STATE(307),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(493),
  },
  [104] = {
    [sym__declaration_specifiers] = STATE(310),
    [sym_storage_class_specifier] = STATE(313),
    [sym_type_qualifier] = STATE(313),
    [sym__type_specifier] = STATE(311),
    [sym_sized_type_specifier] = STATE(311),
    [sym_enum_specifier] = STATE(311),
    [sym_struct_specifier] = STATE(311),
    [sym_union_specifier] = STATE(311),
    [sym_parameter_declaration] = STATE(312),
    [sym_macro_type_specifier] = STATE(311),
    [sym_class_specifier] = STATE(311),
    [sym_dependent_type] = STATE(311),
    [sym_type_parameter_declaration] = STATE(312),
    [sym_optional_type_parameter_declaration] = STATE(312),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(313),
    [aux_sym_sized_type_specifier_repeat1] = STATE(314),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(497),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_GT] = ACTIONS(499),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(497),
    [anon_sym_typename] = ACTIONS(501),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [105] = {
    [sym_template_argument_list] = STATE(316),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(218),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(503),
    [sym_operator_name] = ACTIONS(146),
  },
  [106] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [107] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(505),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(198),
  },
  [108] = {
    [sym__declarator] = STATE(318),
    [sym_pointer_declarator] = STATE(318),
    [sym_function_declarator] = STATE(318),
    [sym_array_declarator] = STATE(318),
    [sym_reference_declarator] = STATE(318),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(318),
    [sym_destructor_name] = STATE(318),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(507),
  },
  [109] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [110] = {
    [sym_storage_class_specifier] = STATE(321),
    [sym_type_qualifier] = STATE(321),
    [aux_sym__declaration_specifiers_repeat1] = STATE(321),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [111] = {
    [sym_function_definition] = STATE(323),
    [sym_declaration] = STATE(323),
    [sym__declaration_specifiers] = STATE(324),
    [sym_storage_class_specifier] = STATE(326),
    [sym_type_qualifier] = STATE(326),
    [sym__type_specifier] = STATE(325),
    [sym_sized_type_specifier] = STATE(325),
    [sym_enum_specifier] = STATE(325),
    [sym_struct_specifier] = STATE(325),
    [sym_union_specifier] = STATE(325),
    [sym__empty_declaration] = STATE(323),
    [sym_macro_type_specifier] = STATE(325),
    [sym_class_specifier] = STATE(325),
    [sym_dependent_type] = STATE(325),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(326),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(513),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [112] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(517),
    [sym_operator_name] = ACTIONS(236),
  },
  [113] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(517),
  },
  [114] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(329),
    [sym_sized_type_specifier] = STATE(329),
    [sym_enum_specifier] = STATE(329),
    [sym_struct_specifier] = STATE(329),
    [sym_union_specifier] = STATE(329),
    [sym_macro_type_specifier] = STATE(329),
    [sym_class_specifier] = STATE(329),
    [sym_dependent_type] = STATE(329),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(519),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(519),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [115] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(331),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(521),
    [anon_sym_long] = ACTIONS(521),
    [anon_sym_short] = ACTIONS(521),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [116] = {
    [sym_preproc_include] = STATE(333),
    [sym_preproc_def] = STATE(333),
    [sym_preproc_function_def] = STATE(333),
    [sym_preproc_call] = STATE(333),
    [sym_preproc_if] = STATE(333),
    [sym_preproc_ifdef] = STATE(333),
    [sym_function_definition] = STATE(333),
    [sym_declaration] = STATE(333),
    [sym_type_definition] = STATE(333),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(333),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(333),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(333),
    [sym_template_declaration] = STATE(333),
    [sym_template_instantiation] = STATE(333),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(333),
    [sym_using_declaration] = STATE(333),
    [sym_alias_declaration] = STATE(333),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(333),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [117] = {
    [sym_declaration_list] = STATE(334),
    [anon_sym_LBRACE] = ACTIONS(186),
    [sym_comment] = ACTIONS(49),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(527),
    [sym_preproc_directive] = ACTIONS(527),
    [anon_sym_typedef] = ACTIONS(527),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_register] = ACTIONS(527),
    [anon_sym_inline] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_restrict] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym__Atomic] = ACTIONS(527),
    [anon_sym_mutable] = ACTIONS(527),
    [anon_sym_explicit] = ACTIONS(527),
    [anon_sym_constexpr] = ACTIONS(527),
    [anon_sym_unsigned] = ACTIONS(527),
    [anon_sym_long] = ACTIONS(527),
    [anon_sym_short] = ACTIONS(527),
    [sym_primitive_type] = ACTIONS(527),
    [anon_sym_enum] = ACTIONS(527),
    [anon_sym_struct] = ACTIONS(527),
    [anon_sym_union] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [sym_identifier] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(527),
    [sym_auto] = ACTIONS(527),
    [anon_sym_typename] = ACTIONS(527),
    [anon_sym_template] = ACTIONS(527),
    [anon_sym_namespace] = ACTIONS(527),
    [anon_sym_using] = ACTIONS(527),
    [anon_sym_COLON_COLON] = ACTIONS(525),
    [sym_operator_name] = ACTIONS(525),
  },
  [119] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [120] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(339),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(535),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [121] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(537),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(198),
  },
  [122] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(539),
  },
  [123] = {
    [anon_sym_SEMI] = ACTIONS(529),
    [sym_comment] = ACTIONS(49),
  },
  [124] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(541),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [125] = {
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_RBRACK] = ACTIONS(550),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_COLON] = ACTIONS(550),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(550),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(552),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_comment] = ACTIONS(49),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_template] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_using] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [sym_operator_name] = ACTIONS(554),
  },
  [127] = {
    [sym__declarator] = STATE(343),
    [sym_pointer_declarator] = STATE(343),
    [sym_function_declarator] = STATE(343),
    [sym_array_declarator] = STATE(343),
    [sym_reference_declarator] = STATE(343),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(343),
    [sym_destructor_name] = STATE(343),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(562),
  },
  [128] = {
    [sym_identifier] = ACTIONS(564),
    [sym_comment] = ACTIONS(49),
  },
  [129] = {
    [sym__declarator] = STATE(345),
    [sym_pointer_declarator] = STATE(345),
    [sym_function_declarator] = STATE(345),
    [sym_array_declarator] = STATE(345),
    [sym_reference_declarator] = STATE(345),
    [sym_structured_binding_declarator] = STATE(346),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(345),
    [sym_destructor_name] = STATE(345),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(566),
  },
  [130] = {
    [sym_compound_statement] = STATE(352),
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(355),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [131] = {
    [aux_sym_declaration_repeat1] = STATE(355),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(572),
    [sym_comment] = ACTIONS(49),
  },
  [132] = {
    [sym_argument_list] = STATE(359),
    [sym_initializer_list] = STATE(359),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(582),
    [sym_comment] = ACTIONS(49),
  },
  [133] = {
    [sym_argument_list] = STATE(361),
    [sym_initializer_list] = STATE(361),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(584),
    [sym_comment] = ACTIONS(49),
  },
  [134] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_declaration] = STATE(362),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [135] = {
    [sym__declaration_specifiers] = STATE(387),
    [sym_storage_class_specifier] = STATE(395),
    [sym_type_qualifier] = STATE(395),
    [sym__type_specifier] = STATE(388),
    [sym_sized_type_specifier] = STATE(388),
    [sym_enum_specifier] = STATE(388),
    [sym_struct_specifier] = STATE(388),
    [sym_union_specifier] = STATE(388),
    [sym__expression] = STATE(389),
    [sym_conditional_expression] = STATE(389),
    [sym_assignment_expression] = STATE(389),
    [sym_pointer_expression] = STATE(389),
    [sym_logical_expression] = STATE(389),
    [sym_bitwise_expression] = STATE(389),
    [sym_equality_expression] = STATE(389),
    [sym_relational_expression] = STATE(389),
    [sym_shift_expression] = STATE(389),
    [sym_math_expression] = STATE(389),
    [sym_cast_expression] = STATE(389),
    [sym_sizeof_expression] = STATE(389),
    [sym_subscript_expression] = STATE(389),
    [sym_call_expression] = STATE(389),
    [sym_field_expression] = STATE(389),
    [sym_compound_literal_expression] = STATE(389),
    [sym_parenthesized_expression] = STATE(389),
    [sym_concatenated_string] = STATE(389),
    [sym_macro_type_specifier] = STATE(388),
    [sym_class_specifier] = STATE(388),
    [sym_dependent_type] = STATE(388),
    [sym_template_type] = STATE(390),
    [sym_template_function] = STATE(389),
    [sym_new_expression] = STATE(389),
    [sym_delete_expression] = STATE(389),
    [sym_lambda_expression] = STATE(389),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(393),
    [sym_scoped_namespace_identifier] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [sym_raw_string_literal] = ACTIONS(596),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(604),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(596),
    [sym_char_literal] = ACTIONS(596),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(628),
    [sym_false] = ACTIONS(628),
    [sym_null] = ACTIONS(628),
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(608),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(628),
  },
  [136] = {
    [sym_type_qualifier] = STATE(399),
    [sym_trailing_return_type] = STATE(399),
    [aux_sym_function_declarator_repeat1] = STATE(399),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(648),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(650),
  },
  [137] = {
    [sym_preproc_include] = STATE(439),
    [sym_preproc_def] = STATE(439),
    [sym_preproc_function_def] = STATE(439),
    [sym_preproc_call] = STATE(439),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(439),
    [sym_type_definition] = STATE(439),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(439),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(439),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(439),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(439),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [138] = {
    [sym_field_initializer] = STATE(443),
    [sym_template_type] = STATE(444),
    [sym_scoped_field_identifier] = STATE(445),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(444),
    [sym_identifier] = ACTIONS(720),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(722),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(726),
    [sym_preproc_directive] = ACTIONS(726),
    [anon_sym_typedef] = ACTIONS(726),
    [anon_sym_extern] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_register] = ACTIONS(726),
    [anon_sym_inline] = ACTIONS(726),
    [anon_sym_const] = ACTIONS(726),
    [anon_sym_restrict] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym__Atomic] = ACTIONS(726),
    [anon_sym_mutable] = ACTIONS(726),
    [anon_sym_explicit] = ACTIONS(726),
    [anon_sym_constexpr] = ACTIONS(726),
    [anon_sym_unsigned] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [sym_primitive_type] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(726),
    [anon_sym_union] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(726),
    [sym_auto] = ACTIONS(726),
    [anon_sym_typename] = ACTIONS(726),
    [anon_sym_template] = ACTIONS(726),
    [anon_sym_namespace] = ACTIONS(726),
    [anon_sym_using] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(724),
    [sym_operator_name] = ACTIONS(724),
  },
  [140] = {
    [sym_compound_statement] = STATE(446),
    [anon_sym_LBRACE] = ACTIONS(220),
    [sym_comment] = ACTIONS(49),
  },
  [141] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_COLON] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [142] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_RPAREN] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_GT] = ACTIONS(121),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [sym_operator_name] = ACTIONS(121),
  },
  [143] = {
    [sym_storage_class_specifier] = STATE(447),
    [sym_type_qualifier] = STATE(447),
    [aux_sym__declaration_specifiers_repeat1] = STATE(447),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [144] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(732),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [145] = {
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_comment] = ACTIONS(49),
  },
  [146] = {
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_operator_name] = ACTIONS(740),
  },
  [147] = {
    [sym_preproc_include] = STATE(147),
    [sym_preproc_def] = STATE(147),
    [sym_preproc_function_def] = STATE(147),
    [sym_preproc_call] = STATE(147),
    [sym_preproc_if] = STATE(147),
    [sym_preproc_ifdef] = STATE(147),
    [sym_function_definition] = STATE(147),
    [sym_declaration] = STATE(147),
    [sym_type_definition] = STATE(147),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(147),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(147),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(147),
    [sym_template_declaration] = STATE(147),
    [sym_template_instantiation] = STATE(147),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(147),
    [sym_using_declaration] = STATE(147),
    [sym_alias_declaration] = STATE(147),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(147),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [ts_builtin_sym_end] = ACTIONS(744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(752),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(758),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(764),
    [anon_sym_typedef] = ACTIONS(767),
    [anon_sym_extern] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(776),
    [anon_sym_register] = ACTIONS(776),
    [anon_sym_inline] = ACTIONS(776),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_restrict] = ACTIONS(779),
    [anon_sym_volatile] = ACTIONS(779),
    [anon_sym__Atomic] = ACTIONS(779),
    [anon_sym_mutable] = ACTIONS(779),
    [anon_sym_explicit] = ACTIONS(779),
    [anon_sym_constexpr] = ACTIONS(779),
    [anon_sym_unsigned] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(803),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(809),
    [sym_auto] = ACTIONS(785),
    [anon_sym_typename] = ACTIONS(812),
    [anon_sym_template] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(818),
    [anon_sym_using] = ACTIONS(821),
    [anon_sym_COLON_COLON] = ACTIONS(824),
    [sym_operator_name] = ACTIONS(827),
  },
  [148] = {
    [sym_compound_statement] = STATE(446),
    [sym_field_initializer_list] = STATE(450),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [149] = {
    [sym_storage_class_specifier] = STATE(451),
    [sym_type_qualifier] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(451),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [150] = {
    [sym_storage_class_specifier] = STATE(150),
    [sym_type_qualifier] = STATE(150),
    [aux_sym__declaration_specifiers_repeat1] = STATE(150),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_register] = ACTIONS(832),
    [anon_sym_inline] = ACTIONS(832),
    [anon_sym_const] = ACTIONS(835),
    [anon_sym_restrict] = ACTIONS(835),
    [anon_sym_volatile] = ACTIONS(835),
    [anon_sym__Atomic] = ACTIONS(835),
    [anon_sym_mutable] = ACTIONS(835),
    [anon_sym_explicit] = ACTIONS(835),
    [anon_sym_constexpr] = ACTIONS(835),
    [anon_sym_unsigned] = ACTIONS(838),
    [anon_sym_long] = ACTIONS(838),
    [anon_sym_short] = ACTIONS(838),
    [sym_primitive_type] = ACTIONS(838),
    [anon_sym_enum] = ACTIONS(838),
    [anon_sym_struct] = ACTIONS(838),
    [anon_sym_union] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(838),
    [sym_auto] = ACTIONS(838),
    [anon_sym_typename] = ACTIONS(838),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [151] = {
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_extern] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_register] = ACTIONS(842),
    [anon_sym_inline] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(842),
    [anon_sym_restrict] = ACTIONS(842),
    [anon_sym_volatile] = ACTIONS(842),
    [anon_sym__Atomic] = ACTIONS(842),
    [anon_sym_mutable] = ACTIONS(842),
    [anon_sym_explicit] = ACTIONS(842),
    [anon_sym_constexpr] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [sym_identifier] = ACTIONS(842),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(840),
    [sym_operator_name] = ACTIONS(840),
  },
  [152] = {
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_extern] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(844),
    [anon_sym_static] = ACTIONS(846),
    [anon_sym_register] = ACTIONS(846),
    [anon_sym_inline] = ACTIONS(846),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_restrict] = ACTIONS(846),
    [anon_sym_volatile] = ACTIONS(846),
    [anon_sym__Atomic] = ACTIONS(846),
    [anon_sym_mutable] = ACTIONS(846),
    [anon_sym_explicit] = ACTIONS(846),
    [anon_sym_constexpr] = ACTIONS(846),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_AMP] = ACTIONS(846),
    [anon_sym_AMP_AMP] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [sym_identifier] = ACTIONS(846),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(844),
    [sym_operator_name] = ACTIONS(844),
  },
  [153] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(153),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(852),
    [anon_sym_long] = ACTIONS(852),
    [anon_sym_short] = ACTIONS(852),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [154] = {
    [sym_preproc_arg] = ACTIONS(855),
    [sym_comment] = ACTIONS(83),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [156] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(863),
    [sym_identifier] = ACTIONS(861),
    [sym_comment] = ACTIONS(49),
  },
  [157] = {
    [anon_sym_LF] = ACTIONS(865),
    [sym_preproc_arg] = ACTIONS(867),
    [sym_comment] = ACTIONS(83),
  },
  [158] = {
    [sym_parameter_list] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [159] = {
    [sym_parameter_list] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [160] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [161] = {
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(736),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [162] = {
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_EQ] = ACTIONS(550),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(550),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [163] = {
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_COLON] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [sym_comment] = ACTIONS(49),
  },
  [164] = {
    [sym_type_qualifier] = STATE(459),
    [sym_trailing_return_type] = STATE(459),
    [aux_sym_function_declarator_repeat1] = STATE(459),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(879),
  },
  [165] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(881),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [166] = {
    [sym_string_literal] = ACTIONS(883),
    [sym_system_lib_string] = ACTIONS(883),
    [sym_comment] = ACTIONS(49),
  },
  [167] = {
    [sym_identifier] = ACTIONS(885),
    [sym_comment] = ACTIONS(49),
  },
  [168] = {
    [sym_preproc_arg] = ACTIONS(887),
    [sym_comment] = ACTIONS(83),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(891),
    [sym_preproc_directive] = ACTIONS(891),
    [anon_sym_typedef] = ACTIONS(891),
    [anon_sym_extern] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_register] = ACTIONS(891),
    [anon_sym_inline] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_restrict] = ACTIONS(891),
    [anon_sym_volatile] = ACTIONS(891),
    [anon_sym__Atomic] = ACTIONS(891),
    [anon_sym_mutable] = ACTIONS(891),
    [anon_sym_explicit] = ACTIONS(891),
    [anon_sym_constexpr] = ACTIONS(891),
    [anon_sym_unsigned] = ACTIONS(891),
    [anon_sym_long] = ACTIONS(891),
    [anon_sym_short] = ACTIONS(891),
    [sym_primitive_type] = ACTIONS(891),
    [anon_sym_enum] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(891),
    [anon_sym_union] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(889),
    [sym_identifier] = ACTIONS(891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(891),
    [sym_auto] = ACTIONS(891),
    [anon_sym_typename] = ACTIONS(891),
    [anon_sym_template] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_using] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(889),
    [sym_operator_name] = ACTIONS(889),
  },
  [170] = {
    [sym_identifier] = ACTIONS(893),
    [sym_comment] = ACTIONS(49),
  },
  [171] = {
    [sym_identifier] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
  },
  [172] = {
    [sym_preproc_include] = STATE(480),
    [sym_preproc_def] = STATE(480),
    [sym_preproc_function_def] = STATE(480),
    [sym_preproc_call] = STATE(480),
    [sym_preproc_if] = STATE(480),
    [sym_preproc_ifdef] = STATE(480),
    [sym_function_definition] = STATE(480),
    [sym_declaration] = STATE(480),
    [sym_type_definition] = STATE(480),
    [sym__declaration_specifiers] = STATE(477),
    [sym_linkage_specification] = STATE(480),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(481),
    [sym_type_qualifier] = STATE(481),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(480),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(480),
    [sym_template_declaration] = STATE(480),
    [sym_template_instantiation] = STATE(480),
    [sym_constructor_or_destructor_definition] = STATE(479),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(480),
    [sym_using_declaration] = STATE(480),
    [sym_alias_declaration] = STATE(480),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(480),
    [aux_sym__declaration_specifiers_repeat1] = STATE(481),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(897),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(901),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(903),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(905),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(907),
    [sym_preproc_directive] = ACTIONS(909),
    [anon_sym_typedef] = ACTIONS(911),
    [anon_sym_extern] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(915),
    [anon_sym_namespace] = ACTIONS(917),
    [anon_sym_using] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [173] = {
    [sym_preproc_arg] = ACTIONS(921),
    [sym_comment] = ACTIONS(83),
  },
  [174] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(923),
    [anon_sym_LF] = ACTIONS(925),
    [sym_comment] = ACTIONS(83),
  },
  [175] = {
    [sym_type_qualifier] = STATE(486),
    [sym__type_specifier] = STATE(485),
    [sym_sized_type_specifier] = STATE(485),
    [sym_enum_specifier] = STATE(485),
    [sym_struct_specifier] = STATE(485),
    [sym_union_specifier] = STATE(485),
    [sym_macro_type_specifier] = STATE(485),
    [sym_class_specifier] = STATE(485),
    [sym_dependent_type] = STATE(485),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(486),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(927),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(927),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [176] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(929),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [177] = {
    [sym__declaration_specifiers] = STATE(488),
    [sym__declarator] = STATE(489),
    [sym_pointer_declarator] = STATE(489),
    [sym_function_declarator] = STATE(489),
    [sym_array_declarator] = STATE(489),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_parameter_list] = STATE(490),
    [sym_reference_declarator] = STATE(489),
    [sym_template_type] = STATE(112),
    [sym_template_function] = STATE(489),
    [sym_destructor_name] = STATE(489),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(113),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(176),
    [sym_identifier] = ACTIONS(178),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(182),
    [sym_operator_name] = ACTIONS(931),
  },
  [178] = {
    [sym_declaration_list] = STATE(493),
    [anon_sym_LBRACE] = ACTIONS(933),
    [sym_identifier] = ACTIONS(935),
    [sym_comment] = ACTIONS(49),
  },
  [179] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(496),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(939),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [180] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(941),
    [sym_comment] = ACTIONS(49),
  },
  [181] = {
    [sym__declarator] = STATE(499),
    [sym_pointer_declarator] = STATE(499),
    [sym_function_declarator] = STATE(499),
    [sym_array_declarator] = STATE(499),
    [sym_init_declarator] = STATE(500),
    [sym_reference_declarator] = STATE(499),
    [sym_structured_binding_reference_declarator] = STATE(501),
    [sym_structured_binding_declarator] = STATE(502),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(499),
    [sym_destructor_name] = STATE(499),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(945),
  },
  [182] = {
    [sym_compound_statement] = STATE(504),
    [sym_field_initializer_list] = STATE(505),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [183] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(234),
    [anon_sym_LPAREN] = ACTIONS(232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(234),
    [sym_preproc_directive] = ACTIONS(234),
    [anon_sym_typedef] = ACTIONS(234),
    [anon_sym_extern] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_static] = ACTIONS(234),
    [anon_sym_register] = ACTIONS(234),
    [anon_sym_inline] = ACTIONS(234),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_restrict] = ACTIONS(234),
    [anon_sym_volatile] = ACTIONS(234),
    [anon_sym__Atomic] = ACTIONS(234),
    [anon_sym_mutable] = ACTIONS(234),
    [anon_sym_explicit] = ACTIONS(234),
    [anon_sym_constexpr] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(234),
    [anon_sym_enum] = ACTIONS(234),
    [anon_sym_struct] = ACTIONS(234),
    [anon_sym_union] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(232),
    [anon_sym_TILDE] = ACTIONS(232),
    [sym_identifier] = ACTIONS(234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(234),
    [sym_auto] = ACTIONS(234),
    [anon_sym_typename] = ACTIONS(234),
    [anon_sym_template] = ACTIONS(234),
    [anon_sym_namespace] = ACTIONS(234),
    [anon_sym_using] = ACTIONS(234),
    [anon_sym_COLON_COLON] = ACTIONS(232),
    [sym_operator_name] = ACTIONS(232),
  },
  [184] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(506),
    [sym_preproc_elif] = STATE(506),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [185] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(508),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(150),
    [sym_type_qualifier] = STATE(150),
    [sym__type_specifier] = STATE(149),
    [sym_sized_type_specifier] = STATE(149),
    [sym_enum_specifier] = STATE(149),
    [sym_struct_specifier] = STATE(149),
    [sym_union_specifier] = STATE(149),
    [sym_macro_type_specifier] = STATE(149),
    [sym_class_specifier] = STATE(149),
    [sym_dependent_type] = STATE(149),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(150),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(244),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(953),
    [sym_preproc_directive] = ACTIONS(953),
    [anon_sym_typedef] = ACTIONS(953),
    [anon_sym_extern] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_register] = ACTIONS(953),
    [anon_sym_inline] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_restrict] = ACTIONS(953),
    [anon_sym_volatile] = ACTIONS(953),
    [anon_sym__Atomic] = ACTIONS(953),
    [anon_sym_mutable] = ACTIONS(953),
    [anon_sym_explicit] = ACTIONS(953),
    [anon_sym_constexpr] = ACTIONS(953),
    [anon_sym_unsigned] = ACTIONS(953),
    [anon_sym_long] = ACTIONS(953),
    [anon_sym_short] = ACTIONS(953),
    [sym_primitive_type] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [anon_sym_struct] = ACTIONS(953),
    [anon_sym_union] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(953),
    [sym_auto] = ACTIONS(953),
    [anon_sym_typename] = ACTIONS(953),
    [anon_sym_template] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(953),
    [anon_sym_using] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(951),
    [sym_operator_name] = ACTIONS(951),
  },
  [187] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(955),
    [sym_comment] = ACTIONS(49),
  },
  [188] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(510),
    [sym_preproc_elif] = STATE(510),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(957),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(961),
    [sym_preproc_directive] = ACTIONS(961),
    [anon_sym_typedef] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_static] = ACTIONS(961),
    [anon_sym_register] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_restrict] = ACTIONS(961),
    [anon_sym_volatile] = ACTIONS(961),
    [anon_sym__Atomic] = ACTIONS(961),
    [anon_sym_mutable] = ACTIONS(961),
    [anon_sym_explicit] = ACTIONS(961),
    [anon_sym_constexpr] = ACTIONS(961),
    [anon_sym_unsigned] = ACTIONS(961),
    [anon_sym_long] = ACTIONS(961),
    [anon_sym_short] = ACTIONS(961),
    [sym_primitive_type] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_identifier] = ACTIONS(961),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(961),
    [sym_auto] = ACTIONS(961),
    [anon_sym_typename] = ACTIONS(961),
    [anon_sym_template] = ACTIONS(961),
    [anon_sym_namespace] = ACTIONS(961),
    [anon_sym_using] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [sym_operator_name] = ACTIONS(959),
  },
  [190] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(963),
    [sym_comment] = ACTIONS(49),
  },
  [191] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(512),
    [sym_preproc_elif] = STATE(512),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(965),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [192] = {
    [anon_sym_LF] = ACTIONS(967),
    [sym_comment] = ACTIONS(83),
  },
  [193] = {
    [sym_enumerator] = STATE(516),
    [anon_sym_COMMA] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(971),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [194] = {
    [sym_enumerator_list] = STATE(517),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_STAR] = ACTIONS(366),
    [sym_identifier] = ACTIONS(366),
    [sym_comment] = ACTIONS(49),
  },
  [195] = {
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [sym_identifier] = ACTIONS(370),
    [sym_comment] = ACTIONS(49),
  },
  [196] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(519),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(519),
    [sym_field_declaration] = STATE(519),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(519),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(519),
    [sym_access_specifier] = STATE(519),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(519),
    [sym_alias_declaration] = STATE(519),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(519),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [197] = {
    [sym_template_argument_list] = STATE(522),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(414),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(975),
    [sym_identifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(416),
    [anon_sym_COLON_COLON] = ACTIONS(977),
  },
  [198] = {
    [sym_field_declaration_list] = STATE(523),
    [sym_base_class_clause] = STATE(524),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [199] = {
    [sym_identifier] = ACTIONS(979),
    [sym_comment] = ACTIONS(49),
  },
  [200] = {
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [sym_identifier] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
  },
  [201] = {
    [sym_field_declaration_list] = STATE(523),
    [sym_base_class_clause] = STATE(524),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(981),
  },
  [202] = {
    [sym_field_declaration_list] = STATE(523),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [203] = {
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(434),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
    [anon_sym_COLON_COLON] = ACTIONS(983),
  },
  [204] = {
    [sym_template_argument_list] = STATE(528),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(975),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
  },
  [205] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(983),
  },
  [206] = {
    [sym_field_declaration_list] = STATE(529),
    [sym_base_class_clause] = STATE(530),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [207] = {
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [sym_identifier] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
  },
  [208] = {
    [sym_field_declaration_list] = STATE(529),
    [sym_base_class_clause] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(985),
  },
  [209] = {
    [sym_field_declaration_list] = STATE(529),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [210] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(533),
    [sym_parenthesized_expression] = STATE(533),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(987),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [211] = {
    [sym_identifier] = ACTIONS(989),
    [sym_comment] = ACTIONS(49),
  },
  [212] = {
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [213] = {
    [sym_field_declaration_list] = STATE(535),
    [sym_base_class_clause] = STATE(536),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [214] = {
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [sym_identifier] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
  },
  [215] = {
    [sym_field_declaration_list] = STATE(535),
    [sym_base_class_clause] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(991),
  },
  [216] = {
    [sym_field_declaration_list] = STATE(535),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [217] = {
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_STAR] = ACTIONS(485),
    [sym_identifier] = ACTIONS(485),
    [sym_comment] = ACTIONS(49),
  },
  [218] = {
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [sym_identifier] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [219] = {
    [sym__type_declarator] = STATE(539),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(993),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [220] = {
    [sym__type_declarator] = STATE(540),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [221] = {
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(49),
  },
  [222] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [223] = {
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [sym_comment] = ACTIONS(49),
  },
  [224] = {
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(49),
  },
  [225] = {
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [sym_comment] = ACTIONS(49),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1007),
    [sym_comment] = ACTIONS(49),
  },
  [227] = {
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [sym_identifier] = ACTIONS(740),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(740),
  },
  [228] = {
    [sym__type_declarator] = STATE(545),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [229] = {
    [sym_type_qualifier] = STATE(229),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_restrict] = ACTIONS(1009),
    [anon_sym_volatile] = ACTIONS(1009),
    [anon_sym__Atomic] = ACTIONS(1009),
    [anon_sym_mutable] = ACTIONS(1009),
    [anon_sym_explicit] = ACTIONS(1009),
    [anon_sym_constexpr] = ACTIONS(1009),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [sym_primitive_type] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [sym_identifier] = ACTIONS(1012),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1012),
    [sym_auto] = ACTIONS(1012),
    [anon_sym_typename] = ACTIONS(1012),
    [anon_sym_COLON_COLON] = ACTIONS(1014),
  },
  [230] = {
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [sym_identifier] = ACTIONS(840),
    [sym_comment] = ACTIONS(49),
  },
  [231] = {
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [sym_identifier] = ACTIONS(844),
    [sym_comment] = ACTIONS(49),
  },
  [232] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [sym_primitive_type] = ACTIONS(850),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [sym_preproc_directive] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_register] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_restrict] = ACTIONS(1021),
    [anon_sym_volatile] = ACTIONS(1021),
    [anon_sym__Atomic] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1021),
    [anon_sym_explicit] = ACTIONS(1021),
    [anon_sym_constexpr] = ACTIONS(1021),
    [anon_sym_unsigned] = ACTIONS(1021),
    [anon_sym_long] = ACTIONS(1021),
    [anon_sym_short] = ACTIONS(1021),
    [sym_primitive_type] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1021),
    [sym_auto] = ACTIONS(1021),
    [anon_sym_typename] = ACTIONS(1021),
    [anon_sym_template] = ACTIONS(1021),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_using] = ACTIONS(1021),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [sym_operator_name] = ACTIONS(1019),
  },
  [234] = {
    [sym__declarator] = STATE(130),
    [sym_pointer_declarator] = STATE(130),
    [sym_function_declarator] = STATE(130),
    [sym_array_declarator] = STATE(130),
    [sym_init_declarator] = STATE(131),
    [sym_reference_declarator] = STATE(130),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(130),
    [sym_destructor_name] = STATE(130),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(212),
  },
  [235] = {
    [sym_type_qualifier] = STATE(547),
    [sym_trailing_return_type] = STATE(547),
    [aux_sym_function_declarator_repeat1] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1025),
  },
  [236] = {
    [anon_sym_RBRACE] = ACTIONS(1027),
    [sym_comment] = ACTIONS(49),
  },
  [237] = {
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_extern] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_register] = ACTIONS(1031),
    [anon_sym_inline] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_restrict] = ACTIONS(1031),
    [anon_sym_volatile] = ACTIONS(1031),
    [anon_sym__Atomic] = ACTIONS(1031),
    [anon_sym_mutable] = ACTIONS(1031),
    [anon_sym_explicit] = ACTIONS(1031),
    [anon_sym_constexpr] = ACTIONS(1031),
    [anon_sym_COLON] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1031),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1029),
    [sym_operator_name] = ACTIONS(1029),
  },
  [238] = {
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_EQ] = ACTIONS(1035),
    [sym_comment] = ACTIONS(49),
  },
  [239] = {
    [aux_sym_enumerator_list_repeat1] = STATE(551),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [sym_comment] = ACTIONS(49),
  },
  [240] = {
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_register] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_restrict] = ACTIONS(1041),
    [anon_sym_volatile] = ACTIONS(1041),
    [anon_sym__Atomic] = ACTIONS(1041),
    [anon_sym_mutable] = ACTIONS(1041),
    [anon_sym_explicit] = ACTIONS(1041),
    [anon_sym_constexpr] = ACTIONS(1041),
    [anon_sym_COLON] = ACTIONS(1041),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1039),
    [sym_operator_name] = ACTIONS(1039),
  },
  [241] = {
    [sym_preproc_arg] = ACTIONS(1043),
    [sym_comment] = ACTIONS(83),
  },
  [242] = {
    [sym_identifier] = ACTIONS(1045),
    [sym_comment] = ACTIONS(49),
  },
  [243] = {
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(49),
  },
  [244] = {
    [sym_type_qualifier] = STATE(556),
    [sym__type_specifier] = STATE(555),
    [sym_sized_type_specifier] = STATE(555),
    [sym_enum_specifier] = STATE(555),
    [sym_struct_specifier] = STATE(555),
    [sym_union_specifier] = STATE(555),
    [sym_macro_type_specifier] = STATE(555),
    [sym_class_specifier] = STATE(555),
    [sym_dependent_type] = STATE(555),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(556),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1049),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1049),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [245] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_extern] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_register] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_restrict] = ACTIONS(1053),
    [anon_sym_volatile] = ACTIONS(1053),
    [anon_sym__Atomic] = ACTIONS(1053),
    [anon_sym_mutable] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(1053),
    [anon_sym_constexpr] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1051),
    [sym_operator_name] = ACTIONS(1051),
  },
  [246] = {
    [sym_field_declaration_list] = STATE(77),
    [sym__class_name] = STATE(557),
    [sym_base_class_clause] = STATE(79),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(135),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [247] = {
    [sym_field_declaration_list] = STATE(84),
    [sym__class_name] = STATE(558),
    [sym_base_class_clause] = STATE(86),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(139),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [248] = {
    [sym_template_argument_list] = STATE(560),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(146),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [sym_operator_name] = ACTIONS(146),
  },
  [249] = {
    [sym_field_declaration_list] = STATE(92),
    [sym__class_name] = STATE(561),
    [sym_base_class_clause] = STATE(94),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(81),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(154),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [250] = {
    [anon_sym_COLON] = ACTIONS(1057),
    [sym_comment] = ACTIONS(49),
  },
  [251] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [252] = {
    [sym_template_parameter_list] = STATE(563),
    [anon_sym_LT] = ACTIONS(176),
    [sym_comment] = ACTIONS(49),
  },
  [253] = {
    [sym_function_definition] = STATE(564),
    [sym_declaration] = STATE(564),
    [sym__declaration_specifiers] = STATE(565),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(566),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [254] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(569),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(1059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [255] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1063),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(198),
  },
  [256] = {
    [anon_sym_LPAREN] = ACTIONS(1065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1067),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1065),
    [anon_sym_typedef] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_static] = ACTIONS(1067),
    [anon_sym_register] = ACTIONS(1067),
    [anon_sym_inline] = ACTIONS(1067),
    [anon_sym_const] = ACTIONS(1067),
    [anon_sym_restrict] = ACTIONS(1067),
    [anon_sym_volatile] = ACTIONS(1067),
    [anon_sym__Atomic] = ACTIONS(1067),
    [anon_sym_mutable] = ACTIONS(1067),
    [anon_sym_explicit] = ACTIONS(1067),
    [anon_sym_constexpr] = ACTIONS(1067),
    [anon_sym_unsigned] = ACTIONS(1067),
    [anon_sym_long] = ACTIONS(1067),
    [anon_sym_short] = ACTIONS(1067),
    [sym_primitive_type] = ACTIONS(1067),
    [anon_sym_enum] = ACTIONS(1067),
    [anon_sym_struct] = ACTIONS(1067),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1067),
    [anon_sym_public] = ACTIONS(1067),
    [sym_auto] = ACTIONS(1067),
    [anon_sym_typename] = ACTIONS(1067),
    [anon_sym_template] = ACTIONS(1067),
    [anon_sym_friend] = ACTIONS(1067),
    [anon_sym_private] = ACTIONS(1067),
    [anon_sym_protected] = ACTIONS(1067),
    [anon_sym_using] = ACTIONS(1067),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [sym_operator_name] = ACTIONS(1065),
  },
  [257] = {
    [anon_sym_LPAREN] = ACTIONS(1069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1071),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1069),
    [anon_sym_typedef] = ACTIONS(1071),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_unsigned] = ACTIONS(1071),
    [anon_sym_long] = ACTIONS(1071),
    [anon_sym_short] = ACTIONS(1071),
    [sym_primitive_type] = ACTIONS(1071),
    [anon_sym_enum] = ACTIONS(1071),
    [anon_sym_struct] = ACTIONS(1071),
    [anon_sym_union] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1071),
    [anon_sym_public] = ACTIONS(1071),
    [sym_auto] = ACTIONS(1071),
    [anon_sym_typename] = ACTIONS(1071),
    [anon_sym_template] = ACTIONS(1071),
    [anon_sym_friend] = ACTIONS(1071),
    [anon_sym_private] = ACTIONS(1071),
    [anon_sym_protected] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(1071),
    [anon_sym_COLON_COLON] = ACTIONS(1069),
    [sym_operator_name] = ACTIONS(1069),
  },
  [258] = {
    [sym__field_declarator] = STATE(578),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(578),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(1089),
  },
  [259] = {
    [sym_parameter_list] = STATE(585),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [260] = {
    [sym_compound_statement] = STATE(588),
    [sym_field_initializer_list] = STATE(589),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [261] = {
    [sym_storage_class_specifier] = STATE(590),
    [sym_type_qualifier] = STATE(590),
    [aux_sym__declaration_specifiers_repeat1] = STATE(590),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [262] = {
    [anon_sym_LPAREN] = ACTIONS(1095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1095),
    [anon_sym_typedef] = ACTIONS(1097),
    [anon_sym_extern] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_register] = ACTIONS(1097),
    [anon_sym_inline] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_restrict] = ACTIONS(1097),
    [anon_sym_volatile] = ACTIONS(1097),
    [anon_sym__Atomic] = ACTIONS(1097),
    [anon_sym_mutable] = ACTIONS(1097),
    [anon_sym_explicit] = ACTIONS(1097),
    [anon_sym_constexpr] = ACTIONS(1097),
    [anon_sym_unsigned] = ACTIONS(1097),
    [anon_sym_long] = ACTIONS(1097),
    [anon_sym_short] = ACTIONS(1097),
    [sym_primitive_type] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [anon_sym_struct] = ACTIONS(1097),
    [anon_sym_union] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [sym_auto] = ACTIONS(1097),
    [anon_sym_typename] = ACTIONS(1097),
    [anon_sym_template] = ACTIONS(1097),
    [anon_sym_friend] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_using] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [sym_operator_name] = ACTIONS(1095),
  },
  [263] = {
    [anon_sym_LPAREN] = ACTIONS(1099),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1101),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1099),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1099),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1099),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1099),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1099),
    [anon_sym_typedef] = ACTIONS(1101),
    [anon_sym_extern] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_static] = ACTIONS(1101),
    [anon_sym_register] = ACTIONS(1101),
    [anon_sym_inline] = ACTIONS(1101),
    [anon_sym_const] = ACTIONS(1101),
    [anon_sym_restrict] = ACTIONS(1101),
    [anon_sym_volatile] = ACTIONS(1101),
    [anon_sym__Atomic] = ACTIONS(1101),
    [anon_sym_mutable] = ACTIONS(1101),
    [anon_sym_explicit] = ACTIONS(1101),
    [anon_sym_constexpr] = ACTIONS(1101),
    [anon_sym_unsigned] = ACTIONS(1101),
    [anon_sym_long] = ACTIONS(1101),
    [anon_sym_short] = ACTIONS(1101),
    [sym_primitive_type] = ACTIONS(1101),
    [anon_sym_enum] = ACTIONS(1101),
    [anon_sym_struct] = ACTIONS(1101),
    [anon_sym_union] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1101),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_public] = ACTIONS(1101),
    [sym_auto] = ACTIONS(1101),
    [anon_sym_typename] = ACTIONS(1101),
    [anon_sym_template] = ACTIONS(1101),
    [anon_sym_friend] = ACTIONS(1101),
    [anon_sym_private] = ACTIONS(1101),
    [anon_sym_protected] = ACTIONS(1101),
    [anon_sym_using] = ACTIONS(1101),
    [anon_sym_COLON_COLON] = ACTIONS(1099),
    [sym_operator_name] = ACTIONS(1099),
  },
  [264] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1103),
    [sym_operator_name] = ACTIONS(236),
  },
  [265] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1103),
  },
  [266] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(593),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(593),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(593),
    [sym_access_specifier] = STATE(593),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(593),
    [sym_alias_declaration] = STATE(593),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [267] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(594),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(150),
    [sym_type_qualifier] = STATE(150),
    [sym__type_specifier] = STATE(595),
    [sym_sized_type_specifier] = STATE(595),
    [sym_enum_specifier] = STATE(595),
    [sym_struct_specifier] = STATE(595),
    [sym_union_specifier] = STATE(595),
    [sym_macro_type_specifier] = STATE(595),
    [sym_class_specifier] = STATE(595),
    [sym_dependent_type] = STATE(595),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym__declaration_specifiers_repeat1] = STATE(150),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(1107),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [sym_auto] = ACTIONS(1107),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(63),
  },
  [268] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(596),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(1109),
    [anon_sym_long] = ACTIONS(1109),
    [anon_sym_short] = ACTIONS(1109),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_COLON] = ACTIONS(248),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [269] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_COMMA] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(335),
  },
  [270] = {
    [sym__class_name] = STATE(597),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [271] = {
    [aux_sym_base_class_clause_repeat1] = STATE(599),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(49),
  },
  [272] = {
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(349),
  },
  [273] = {
    [sym_template_argument_list] = STATE(146),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [274] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(601),
    [sym_parenthesized_expression] = STATE(601),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(1117),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(49),
  },
  [276] = {
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [277] = {
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym_mutable] = ACTIONS(1123),
    [anon_sym_explicit] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [sym_identifier] = ACTIONS(1123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [sym_operator_name] = ACTIONS(1121),
  },
  [278] = {
    [sym_field_declaration_list] = STATE(603),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [279] = {
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [280] = {
    [sym_field_declaration_list] = STATE(603),
    [sym_base_class_clause] = STATE(604),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1125),
    [sym_comment] = ACTIONS(49),
  },
  [282] = {
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_operator_name] = ACTIONS(740),
  },
  [283] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym_mutable] = ACTIONS(1129),
    [anon_sym_explicit] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(1129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1127),
    [sym_operator_name] = ACTIONS(1127),
  },
  [284] = {
    [sym_field_declaration_list] = STATE(606),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [285] = {
    [sym_field_declaration_list] = STATE(606),
    [sym_base_class_clause] = STATE(607),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [286] = {
    [sym__expression] = STATE(618),
    [sym_comma_expression] = STATE(619),
    [sym_conditional_expression] = STATE(618),
    [sym_assignment_expression] = STATE(618),
    [sym_pointer_expression] = STATE(618),
    [sym_logical_expression] = STATE(618),
    [sym_bitwise_expression] = STATE(618),
    [sym_equality_expression] = STATE(618),
    [sym_relational_expression] = STATE(618),
    [sym_shift_expression] = STATE(618),
    [sym_math_expression] = STATE(618),
    [sym_cast_expression] = STATE(618),
    [sym_sizeof_expression] = STATE(618),
    [sym_subscript_expression] = STATE(618),
    [sym_call_expression] = STATE(618),
    [sym_field_expression] = STATE(618),
    [sym_compound_literal_expression] = STATE(618),
    [sym_parenthesized_expression] = STATE(618),
    [sym_concatenated_string] = STATE(618),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(618),
    [sym_new_expression] = STATE(618),
    [sym_delete_expression] = STATE(618),
    [sym_lambda_expression] = STATE(618),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1131),
    [sym_char_literal] = ACTIONS(1131),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1149),
  },
  [287] = {
    [sym_field_declaration_list] = STATE(77),
    [sym__class_name] = STATE(623),
    [sym_base_class_clause] = STATE(79),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(135),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [288] = {
    [sym_field_declaration_list] = STATE(84),
    [sym__class_name] = STATE(625),
    [sym_base_class_clause] = STATE(86),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(139),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [289] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [sym_operator_name] = ACTIONS(1157),
  },
  [290] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_COMMA] = ACTIONS(146),
    [anon_sym_RPAREN] = ACTIONS(146),
    [anon_sym_SEMI] = ACTIONS(146),
    [anon_sym_LBRACE] = ACTIONS(146),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(335),
  },
  [291] = {
    [sym_field_declaration_list] = STATE(92),
    [sym__class_name] = STATE(626),
    [sym_base_class_clause] = STATE(94),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(154),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [292] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [293] = {
    [sym__abstract_declarator] = STATE(631),
    [sym_abstract_pointer_declarator] = STATE(631),
    [sym_abstract_function_declarator] = STATE(631),
    [sym_abstract_array_declarator] = STATE(631),
    [sym_parameter_list] = STATE(632),
    [sym_abstract_reference_declarator] = STATE(631),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1163),
    [sym_comment] = ACTIONS(49),
  },
  [294] = {
    [aux_sym_template_argument_list_repeat1] = STATE(635),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1175),
    [sym_comment] = ACTIONS(49),
  },
  [295] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(636),
    [sym_sized_type_specifier] = STATE(636),
    [sym_enum_specifier] = STATE(636),
    [sym_struct_specifier] = STATE(636),
    [sym_union_specifier] = STATE(636),
    [sym_macro_type_specifier] = STATE(636),
    [sym_class_specifier] = STATE(636),
    [sym_dependent_type] = STATE(636),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1177),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [296] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(1179),
    [anon_sym_long] = ACTIONS(1179),
    [anon_sym_short] = ACTIONS(1179),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [297] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1183),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1183),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [298] = {
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_COLON] = ACTIONS(1192),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
  },
  [299] = {
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_RPAREN] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1196),
    [anon_sym_extern] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1198),
    [anon_sym_register] = ACTIONS(1198),
    [anon_sym_inline] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_restrict] = ACTIONS(1198),
    [anon_sym_volatile] = ACTIONS(1198),
    [anon_sym__Atomic] = ACTIONS(1198),
    [anon_sym_mutable] = ACTIONS(1198),
    [anon_sym_explicit] = ACTIONS(1198),
    [anon_sym_constexpr] = ACTIONS(1198),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_GT] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1198),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1196),
    [sym_operator_name] = ACTIONS(1196),
  },
  [300] = {
    [sym_field_declaration_list] = STATE(638),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [301] = {
    [sym_field_declaration_list] = STATE(638),
    [sym_base_class_clause] = STATE(639),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(49),
  },
  [303] = {
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [304] = {
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1202),
    [sym_comment] = ACTIONS(49),
  },
  [306] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [307] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [308] = {
    [anon_sym_extern] = ACTIONS(1204),
    [anon_sym_static] = ACTIONS(1204),
    [anon_sym_register] = ACTIONS(1204),
    [anon_sym_inline] = ACTIONS(1204),
    [anon_sym_const] = ACTIONS(1204),
    [anon_sym_restrict] = ACTIONS(1204),
    [anon_sym_volatile] = ACTIONS(1204),
    [anon_sym__Atomic] = ACTIONS(1204),
    [anon_sym_mutable] = ACTIONS(1204),
    [anon_sym_explicit] = ACTIONS(1204),
    [anon_sym_constexpr] = ACTIONS(1204),
    [anon_sym_unsigned] = ACTIONS(1204),
    [anon_sym_long] = ACTIONS(1204),
    [anon_sym_short] = ACTIONS(1204),
    [sym_primitive_type] = ACTIONS(1204),
    [anon_sym_enum] = ACTIONS(1204),
    [anon_sym_struct] = ACTIONS(1204),
    [anon_sym_union] = ACTIONS(1204),
    [sym_identifier] = ACTIONS(1204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1204),
    [sym_auto] = ACTIONS(1204),
    [anon_sym_typename] = ACTIONS(1204),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
  },
  [309] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(314),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(1208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [310] = {
    [sym__declarator] = STATE(649),
    [sym__abstract_declarator] = STATE(650),
    [sym_pointer_declarator] = STATE(649),
    [sym_abstract_pointer_declarator] = STATE(650),
    [sym_function_declarator] = STATE(649),
    [sym_abstract_function_declarator] = STATE(650),
    [sym_array_declarator] = STATE(649),
    [sym_abstract_array_declarator] = STATE(650),
    [sym_init_declarator] = STATE(651),
    [sym_parameter_list] = STATE(632),
    [sym_reference_declarator] = STATE(649),
    [sym_abstract_reference_declarator] = STATE(650),
    [sym_template_type] = STATE(652),
    [sym_template_function] = STATE(649),
    [sym_destructor_name] = STATE(649),
    [sym_scoped_identifier] = STATE(653),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(652),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1224),
    [sym_operator_name] = ACTIONS(1226),
  },
  [311] = {
    [sym_storage_class_specifier] = STATE(654),
    [sym_type_qualifier] = STATE(654),
    [aux_sym__declaration_specifiers_repeat1] = STATE(654),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_COMMA] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [anon_sym_GT] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [312] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(657),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_GT] = ACTIONS(1230),
    [sym_comment] = ACTIONS(49),
  },
  [313] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(658),
    [sym_sized_type_specifier] = STATE(658),
    [sym_enum_specifier] = STATE(658),
    [sym_struct_specifier] = STATE(658),
    [sym_union_specifier] = STATE(658),
    [sym_macro_type_specifier] = STATE(658),
    [sym_class_specifier] = STATE(658),
    [sym_dependent_type] = STATE(658),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(314),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(1232),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1232),
    [anon_sym_typename] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [314] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(659),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(1234),
    [anon_sym_long] = ACTIONS(1234),
    [anon_sym_short] = ACTIONS(1234),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [315] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1236),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [316] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [317] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(541),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [318] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1240),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1242),
    [sym_preproc_directive] = ACTIONS(1242),
    [anon_sym_typedef] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_register] = ACTIONS(1242),
    [anon_sym_inline] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_restrict] = ACTIONS(1242),
    [anon_sym_volatile] = ACTIONS(1242),
    [anon_sym__Atomic] = ACTIONS(1242),
    [anon_sym_mutable] = ACTIONS(1242),
    [anon_sym_explicit] = ACTIONS(1242),
    [anon_sym_constexpr] = ACTIONS(1242),
    [anon_sym_unsigned] = ACTIONS(1242),
    [anon_sym_long] = ACTIONS(1242),
    [anon_sym_short] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1242),
    [sym_auto] = ACTIONS(1242),
    [anon_sym_typename] = ACTIONS(1242),
    [anon_sym_template] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(1242),
    [anon_sym_using] = ACTIONS(1242),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [sym_operator_name] = ACTIONS(1240),
  },
  [320] = {
    [sym_type_qualifier] = STATE(663),
    [sym_trailing_return_type] = STATE(663),
    [aux_sym_function_declarator_repeat1] = STATE(663),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1244),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1246),
  },
  [321] = {
    [sym_storage_class_specifier] = STATE(664),
    [sym_type_qualifier] = STATE(664),
    [aux_sym__declaration_specifiers_repeat1] = STATE(664),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [322] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_typedef] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(1248),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_register] = ACTIONS(1250),
    [anon_sym_inline] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_restrict] = ACTIONS(1250),
    [anon_sym_volatile] = ACTIONS(1250),
    [anon_sym__Atomic] = ACTIONS(1250),
    [anon_sym_mutable] = ACTIONS(1250),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_constexpr] = ACTIONS(1250),
    [anon_sym_unsigned] = ACTIONS(1250),
    [anon_sym_long] = ACTIONS(1250),
    [anon_sym_short] = ACTIONS(1250),
    [sym_primitive_type] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1250),
    [sym_auto] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(1250),
    [anon_sym_template] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [sym_operator_name] = ACTIONS(1248),
  },
  [324] = {
    [sym__declarator] = STATE(130),
    [sym_pointer_declarator] = STATE(130),
    [sym_function_declarator] = STATE(130),
    [sym_array_declarator] = STATE(130),
    [sym_init_declarator] = STATE(131),
    [sym_reference_declarator] = STATE(130),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(130),
    [sym_destructor_name] = STATE(130),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(202),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(212),
  },
  [325] = {
    [sym_storage_class_specifier] = STATE(665),
    [sym_type_qualifier] = STATE(665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(665),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [326] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(666),
    [sym_sized_type_specifier] = STATE(666),
    [sym_enum_specifier] = STATE(666),
    [sym_struct_specifier] = STATE(666),
    [sym_union_specifier] = STATE(666),
    [sym_macro_type_specifier] = STATE(666),
    [sym_class_specifier] = STATE(666),
    [sym_dependent_type] = STATE(666),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(1252),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1252),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [327] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(667),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(1254),
    [anon_sym_long] = ACTIONS(1254),
    [anon_sym_short] = ACTIONS(1254),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [328] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1256),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [329] = {
    [sym_storage_class_specifier] = STATE(669),
    [sym_type_qualifier] = STATE(669),
    [aux_sym__declaration_specifiers_repeat1] = STATE(669),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [330] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [anon_sym_extern] = ACTIONS(1258),
    [anon_sym_static] = ACTIONS(1258),
    [anon_sym_register] = ACTIONS(1258),
    [anon_sym_inline] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym_mutable] = ACTIONS(1261),
    [anon_sym_explicit] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(838),
    [anon_sym_long] = ACTIONS(838),
    [anon_sym_short] = ACTIONS(838),
    [sym_primitive_type] = ACTIONS(838),
    [anon_sym_enum] = ACTIONS(838),
    [anon_sym_struct] = ACTIONS(838),
    [anon_sym_union] = ACTIONS(838),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(838),
    [sym_auto] = ACTIONS(838),
    [anon_sym_typename] = ACTIONS(838),
    [anon_sym_COLON_COLON] = ACTIONS(830),
  },
  [331] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(331),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(1264),
    [anon_sym_long] = ACTIONS(1264),
    [anon_sym_short] = ACTIONS(1264),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(1267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym_mutable] = ACTIONS(1269),
    [anon_sym_explicit] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1269),
    [sym_auto] = ACTIONS(1269),
    [anon_sym_typename] = ACTIONS(1269),
    [anon_sym_template] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_using] = ACTIONS(1269),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_operator_name] = ACTIONS(1267),
  },
  [333] = {
    [sym_preproc_include] = STATE(671),
    [sym_preproc_def] = STATE(671),
    [sym_preproc_function_def] = STATE(671),
    [sym_preproc_call] = STATE(671),
    [sym_preproc_if] = STATE(671),
    [sym_preproc_ifdef] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_type_definition] = STATE(671),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(671),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(671),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(671),
    [sym_template_declaration] = STATE(671),
    [sym_template_instantiation] = STATE(671),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(671),
    [sym_using_declaration] = STATE(671),
    [sym_alias_declaration] = STATE(671),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(671),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(1273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1275),
    [sym_preproc_directive] = ACTIONS(1275),
    [anon_sym_typedef] = ACTIONS(1275),
    [anon_sym_extern] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1275),
    [anon_sym_register] = ACTIONS(1275),
    [anon_sym_inline] = ACTIONS(1275),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_restrict] = ACTIONS(1275),
    [anon_sym_volatile] = ACTIONS(1275),
    [anon_sym__Atomic] = ACTIONS(1275),
    [anon_sym_mutable] = ACTIONS(1275),
    [anon_sym_explicit] = ACTIONS(1275),
    [anon_sym_constexpr] = ACTIONS(1275),
    [anon_sym_unsigned] = ACTIONS(1275),
    [anon_sym_long] = ACTIONS(1275),
    [anon_sym_short] = ACTIONS(1275),
    [sym_primitive_type] = ACTIONS(1275),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_struct] = ACTIONS(1275),
    [anon_sym_union] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_identifier] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1275),
    [sym_auto] = ACTIONS(1275),
    [anon_sym_typename] = ACTIONS(1275),
    [anon_sym_template] = ACTIONS(1275),
    [anon_sym_namespace] = ACTIONS(1275),
    [anon_sym_using] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1273),
    [sym_operator_name] = ACTIONS(1273),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1279),
    [sym_preproc_directive] = ACTIONS(1279),
    [anon_sym_typedef] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1279),
    [anon_sym_register] = ACTIONS(1279),
    [anon_sym_inline] = ACTIONS(1279),
    [anon_sym_const] = ACTIONS(1279),
    [anon_sym_restrict] = ACTIONS(1279),
    [anon_sym_volatile] = ACTIONS(1279),
    [anon_sym__Atomic] = ACTIONS(1279),
    [anon_sym_mutable] = ACTIONS(1279),
    [anon_sym_explicit] = ACTIONS(1279),
    [anon_sym_constexpr] = ACTIONS(1279),
    [anon_sym_unsigned] = ACTIONS(1279),
    [anon_sym_long] = ACTIONS(1279),
    [anon_sym_short] = ACTIONS(1279),
    [sym_primitive_type] = ACTIONS(1279),
    [anon_sym_enum] = ACTIONS(1279),
    [anon_sym_struct] = ACTIONS(1279),
    [anon_sym_union] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_TILDE] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1279),
    [sym_auto] = ACTIONS(1279),
    [anon_sym_typename] = ACTIONS(1279),
    [anon_sym_template] = ACTIONS(1279),
    [anon_sym_namespace] = ACTIONS(1279),
    [anon_sym_using] = ACTIONS(1279),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_operator_name] = ACTIONS(1277),
  },
  [336] = {
    [sym_type_qualifier] = STATE(675),
    [sym__type_specifier] = STATE(673),
    [sym_sized_type_specifier] = STATE(673),
    [sym_enum_specifier] = STATE(673),
    [sym_struct_specifier] = STATE(673),
    [sym_union_specifier] = STATE(673),
    [sym_type_descriptor] = STATE(674),
    [sym_macro_type_specifier] = STATE(673),
    [sym_class_specifier] = STATE(673),
    [sym_dependent_type] = STATE(673),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(675),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1283),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [337] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1287),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [338] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [339] = {
    [anon_sym_SEMI] = ACTIONS(1289),
    [sym_comment] = ACTIONS(49),
  },
  [340] = {
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [341] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1291),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [342] = {
    [sym__declarator] = STATE(345),
    [sym_pointer_declarator] = STATE(345),
    [sym_function_declarator] = STATE(345),
    [sym_array_declarator] = STATE(345),
    [sym_reference_declarator] = STATE(345),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(345),
    [sym_destructor_name] = STATE(345),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(566),
  },
  [343] = {
    [sym_parameter_list] = STATE(353),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(869),
    [sym_comment] = ACTIONS(49),
  },
  [344] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(682),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_RBRACK] = ACTIONS(1295),
    [sym_comment] = ACTIONS(49),
  },
  [345] = {
    [sym_parameter_list] = STATE(353),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(871),
    [sym_comment] = ACTIONS(49),
  },
  [346] = {
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_EQ] = ACTIONS(1297),
    [sym_comment] = ACTIONS(49),
  },
  [347] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_declaration] = STATE(362),
    [sym__expression] = STATE(686),
    [sym_conditional_expression] = STATE(686),
    [sym_assignment_expression] = STATE(686),
    [sym_pointer_expression] = STATE(686),
    [sym_logical_expression] = STATE(686),
    [sym_bitwise_expression] = STATE(686),
    [sym_equality_expression] = STATE(686),
    [sym_relational_expression] = STATE(686),
    [sym_shift_expression] = STATE(686),
    [sym_math_expression] = STATE(686),
    [sym_cast_expression] = STATE(686),
    [sym_sizeof_expression] = STATE(686),
    [sym_subscript_expression] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_field_expression] = STATE(686),
    [sym_compound_literal_expression] = STATE(686),
    [sym_parenthesized_expression] = STATE(686),
    [sym_initializer_list] = STATE(687),
    [sym_concatenated_string] = STATE(686),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_template_type] = STATE(688),
    [sym_template_function] = STATE(686),
    [sym_new_expression] = STATE(686),
    [sym_delete_expression] = STATE(686),
    [sym_lambda_expression] = STATE(686),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(689),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [sym_raw_string_literal] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1299),
    [sym_char_literal] = ACTIONS(1299),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_null] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1307),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1303),
  },
  [348] = {
    [sym__declarator] = STATE(690),
    [sym_pointer_declarator] = STATE(690),
    [sym_function_declarator] = STATE(690),
    [sym_array_declarator] = STATE(690),
    [sym_init_declarator] = STATE(691),
    [sym_reference_declarator] = STATE(690),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(690),
    [sym_destructor_name] = STATE(690),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1309),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_template] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [sym_operator_name] = ACTIONS(1311),
  },
  [350] = {
    [sym_preproc_include] = STATE(439),
    [sym_preproc_def] = STATE(439),
    [sym_preproc_function_def] = STATE(439),
    [sym_preproc_call] = STATE(439),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(439),
    [sym_type_definition] = STATE(439),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(706),
    [sym__empty_declaration] = STATE(439),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(439),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(706),
    [sym_for_range_loop] = STATE(439),
    [sym_new_expression] = STATE(706),
    [sym_delete_expression] = STATE(706),
    [sym_lambda_expression] = STATE(706),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(439),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1315),
    [sym_char_literal] = ACTIONS(1315),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1343),
  },
  [351] = {
    [sym__expression] = STATE(710),
    [sym_conditional_expression] = STATE(710),
    [sym_assignment_expression] = STATE(710),
    [sym_pointer_expression] = STATE(710),
    [sym_logical_expression] = STATE(710),
    [sym_bitwise_expression] = STATE(710),
    [sym_equality_expression] = STATE(710),
    [sym_relational_expression] = STATE(710),
    [sym_shift_expression] = STATE(710),
    [sym_math_expression] = STATE(710),
    [sym_cast_expression] = STATE(710),
    [sym_sizeof_expression] = STATE(710),
    [sym_subscript_expression] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_field_expression] = STATE(710),
    [sym_compound_literal_expression] = STATE(710),
    [sym_parenthesized_expression] = STATE(710),
    [sym_initializer_list] = STATE(711),
    [sym_concatenated_string] = STATE(710),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(710),
    [sym_new_expression] = STATE(710),
    [sym_delete_expression] = STATE(710),
    [sym_lambda_expression] = STATE(710),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1349),
    [sym_char_literal] = ACTIONS(1349),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1351),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym_mutable] = ACTIONS(1357),
    [anon_sym_explicit] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1357),
    [sym_auto] = ACTIONS(1357),
    [anon_sym_typename] = ACTIONS(1357),
    [anon_sym_template] = ACTIONS(1357),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_using] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1355),
    [sym_operator_name] = ACTIONS(1355),
  },
  [353] = {
    [sym_type_qualifier] = STATE(713),
    [sym_trailing_return_type] = STATE(713),
    [aux_sym_function_declarator_repeat1] = STATE(713),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1361),
  },
  [354] = {
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1363),
    [sym_comment] = ACTIONS(49),
  },
  [355] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(1365),
    [sym_comment] = ACTIONS(49),
  },
  [356] = {
    [sym__expression] = STATE(686),
    [sym_conditional_expression] = STATE(686),
    [sym_assignment_expression] = STATE(686),
    [sym_pointer_expression] = STATE(686),
    [sym_logical_expression] = STATE(686),
    [sym_bitwise_expression] = STATE(686),
    [sym_equality_expression] = STATE(686),
    [sym_relational_expression] = STATE(686),
    [sym_shift_expression] = STATE(686),
    [sym_math_expression] = STATE(686),
    [sym_cast_expression] = STATE(686),
    [sym_sizeof_expression] = STATE(686),
    [sym_subscript_expression] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_field_expression] = STATE(686),
    [sym_compound_literal_expression] = STATE(686),
    [sym_parenthesized_expression] = STATE(686),
    [sym_initializer_list] = STATE(687),
    [sym_concatenated_string] = STATE(686),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(686),
    [sym_new_expression] = STATE(686),
    [sym_delete_expression] = STATE(686),
    [sym_lambda_expression] = STATE(686),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1299),
    [sym_char_literal] = ACTIONS(1299),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_null] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1303),
  },
  [357] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(727),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(727),
    [sym_new_expression] = STATE(727),
    [sym_delete_expression] = STATE(727),
    [sym_lambda_expression] = STATE(727),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_COMMA] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1369),
    [sym_char_literal] = ACTIONS(1369),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_null] = ACTIONS(1389),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(1389),
  },
  [358] = {
    [sym__expression] = STATE(737),
    [sym_conditional_expression] = STATE(737),
    [sym_assignment_expression] = STATE(737),
    [sym_pointer_expression] = STATE(737),
    [sym_logical_expression] = STATE(737),
    [sym_bitwise_expression] = STATE(737),
    [sym_equality_expression] = STATE(737),
    [sym_relational_expression] = STATE(737),
    [sym_shift_expression] = STATE(737),
    [sym_math_expression] = STATE(737),
    [sym_cast_expression] = STATE(737),
    [sym_sizeof_expression] = STATE(737),
    [sym_subscript_expression] = STATE(737),
    [sym_call_expression] = STATE(737),
    [sym_field_expression] = STATE(737),
    [sym_compound_literal_expression] = STATE(737),
    [sym_parenthesized_expression] = STATE(737),
    [sym_initializer_list] = STATE(738),
    [sym_concatenated_string] = STATE(737),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(737),
    [sym_new_expression] = STATE(737),
    [sym_delete_expression] = STATE(737),
    [sym_lambda_expression] = STATE(737),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1395),
    [sym_char_literal] = ACTIONS(1395),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1413),
  },
  [359] = {
    [anon_sym_SEMI] = ACTIONS(1419),
    [sym_comment] = ACTIONS(49),
  },
  [360] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_initializer_list] = STATE(741),
    [sym_concatenated_string] = STATE(740),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(740),
    [sym_new_expression] = STATE(740),
    [sym_delete_expression] = STATE(740),
    [sym_lambda_expression] = STATE(740),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1421),
    [sym_char_literal] = ACTIONS(1421),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1423),
    [sym_false] = ACTIONS(1423),
    [sym_null] = ACTIONS(1423),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1423),
  },
  [361] = {
    [anon_sym_SEMI] = ACTIONS(1425),
    [sym_comment] = ACTIONS(49),
  },
  [362] = {
    [aux_sym_parameter_list_repeat1] = STATE(745),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(49),
  },
  [363] = {
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1431),
    [anon_sym_volatile] = ACTIONS(1431),
    [anon_sym__Atomic] = ACTIONS(1431),
    [anon_sym_mutable] = ACTIONS(1431),
    [anon_sym_explicit] = ACTIONS(1431),
    [anon_sym_constexpr] = ACTIONS(1431),
    [anon_sym_COLON] = ACTIONS(1431),
    [anon_sym_GT] = ACTIONS(1431),
    [anon_sym_DASH_GT] = ACTIONS(1431),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1431),
  },
  [364] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [365] = {
    [sym__declarator] = STATE(748),
    [sym__abstract_declarator] = STATE(749),
    [sym_pointer_declarator] = STATE(748),
    [sym_abstract_pointer_declarator] = STATE(749),
    [sym_function_declarator] = STATE(748),
    [sym_abstract_function_declarator] = STATE(749),
    [sym_array_declarator] = STATE(748),
    [sym_abstract_array_declarator] = STATE(749),
    [sym_init_declarator] = STATE(651),
    [sym_parameter_list] = STATE(750),
    [sym_reference_declarator] = STATE(748),
    [sym_abstract_reference_declarator] = STATE(749),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(748),
    [sym_destructor_name] = STATE(748),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_RPAREN] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1441),
  },
  [366] = {
    [sym_storage_class_specifier] = STATE(751),
    [sym_type_qualifier] = STATE(751),
    [aux_sym__declaration_specifiers_repeat1] = STATE(751),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_COMMA] = ACTIONS(224),
    [anon_sym_RPAREN] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_AMP_AMP] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [sym_operator_name] = ACTIONS(224),
  },
  [367] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(752),
    [sym_sized_type_specifier] = STATE(752),
    [sym_enum_specifier] = STATE(752),
    [sym_struct_specifier] = STATE(752),
    [sym_union_specifier] = STATE(752),
    [sym_macro_type_specifier] = STATE(752),
    [sym_class_specifier] = STATE(752),
    [sym_dependent_type] = STATE(752),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(1443),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [368] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(753),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(1445),
    [anon_sym_long] = ACTIONS(1445),
    [anon_sym_short] = ACTIONS(1445),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [sym_operator_name] = ACTIONS(246),
  },
  [369] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(760),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [370] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1463),
  },
  [371] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [372] = {
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1497),
    [anon_sym_RPAREN] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1497),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_COLON] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [sym_comment] = ACTIONS(49),
  },
  [373] = {
    [sym_enumerator_list] = STATE(781),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [sym_identifier] = ACTIONS(1501),
    [sym_comment] = ACTIONS(49),
  },
  [374] = {
    [sym_field_declaration_list] = STATE(786),
    [sym__class_name] = STATE(787),
    [sym_base_class_clause] = STATE(788),
    [sym_template_type] = STATE(789),
    [sym_scoped_type_identifier] = STATE(790),
    [sym_scoped_namespace_identifier] = STATE(791),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1505),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1507),
    [anon_sym_COLON_COLON] = ACTIONS(1509),
  },
  [375] = {
    [sym_field_declaration_list] = STATE(793),
    [sym__class_name] = STATE(794),
    [sym_base_class_clause] = STATE(795),
    [sym_template_type] = STATE(789),
    [sym_scoped_type_identifier] = STATE(790),
    [sym_scoped_namespace_identifier] = STATE(791),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1505),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1511),
    [anon_sym_COLON_COLON] = ACTIONS(1509),
  },
  [376] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1515),
  },
  [377] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1519),
  },
  [378] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1523),
  },
  [379] = {
    [sym__expression] = STATE(800),
    [sym_conditional_expression] = STATE(800),
    [sym_assignment_expression] = STATE(800),
    [sym_pointer_expression] = STATE(800),
    [sym_logical_expression] = STATE(800),
    [sym_bitwise_expression] = STATE(800),
    [sym_equality_expression] = STATE(800),
    [sym_relational_expression] = STATE(800),
    [sym_shift_expression] = STATE(800),
    [sym_math_expression] = STATE(800),
    [sym_cast_expression] = STATE(800),
    [sym_sizeof_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_call_expression] = STATE(800),
    [sym_field_expression] = STATE(800),
    [sym_compound_literal_expression] = STATE(800),
    [sym_parenthesized_expression] = STATE(800),
    [sym_concatenated_string] = STATE(800),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(800),
    [sym_new_expression] = STATE(800),
    [sym_delete_expression] = STATE(800),
    [sym_lambda_expression] = STATE(800),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1525),
    [sym_char_literal] = ACTIONS(1525),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1529),
  },
  [380] = {
    [aux_sym_concatenated_string_repeat1] = STATE(801),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(1535),
    [sym_comment] = ACTIONS(49),
  },
  [381] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(805),
    [sym_raw_string_literal] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_RBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(148),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_sizeof] = ACTIONS(148),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_number_literal] = ACTIONS(146),
    [sym_char_literal] = ACTIONS(146),
    [sym_string_literal] = ACTIONS(146),
    [sym_true] = ACTIONS(148),
    [sym_false] = ACTIONS(148),
    [sym_null] = ACTIONS(148),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(148),
    [anon_sym_COLON_COLON] = ACTIONS(1546),
    [anon_sym_delete] = ACTIONS(148),
    [sym_nullptr] = ACTIONS(148),
  },
  [382] = {
    [sym_field_declaration_list] = STATE(807),
    [sym__class_name] = STATE(808),
    [sym_base_class_clause] = STATE(809),
    [sym_template_type] = STATE(789),
    [sym_scoped_type_identifier] = STATE(790),
    [sym_scoped_namespace_identifier] = STATE(791),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1505),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1509),
  },
  [383] = {
    [sym__type_specifier] = STATE(812),
    [sym_sized_type_specifier] = STATE(812),
    [sym_enum_specifier] = STATE(812),
    [sym_struct_specifier] = STATE(812),
    [sym_union_specifier] = STATE(812),
    [sym_macro_type_specifier] = STATE(812),
    [sym_class_specifier] = STATE(812),
    [sym_dependent_type] = STATE(812),
    [sym_template_type] = STATE(813),
    [sym_scoped_type_identifier] = STATE(814),
    [sym_scoped_namespace_identifier] = STATE(815),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(1550),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [sym_identifier] = ACTIONS(1552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(1550),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_COLON_COLON] = ACTIONS(1554),
  },
  [384] = {
    [sym_parenthesized_expression] = STATE(817),
    [sym_template_type] = STATE(64),
    [sym_scoped_type_identifier] = STATE(818),
    [sym_scoped_namespace_identifier] = STATE(64),
    [anon_sym_LPAREN] = ACTIONS(446),
    [sym_identifier] = ACTIONS(1556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [385] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1560),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1562),
    [sym_operator_name] = ACTIONS(198),
  },
  [386] = {
    [sym__expression] = STATE(823),
    [sym_conditional_expression] = STATE(823),
    [sym_assignment_expression] = STATE(823),
    [sym_pointer_expression] = STATE(823),
    [sym_logical_expression] = STATE(823),
    [sym_bitwise_expression] = STATE(823),
    [sym_equality_expression] = STATE(823),
    [sym_relational_expression] = STATE(823),
    [sym_shift_expression] = STATE(823),
    [sym_math_expression] = STATE(823),
    [sym_cast_expression] = STATE(823),
    [sym_sizeof_expression] = STATE(823),
    [sym_subscript_expression] = STATE(823),
    [sym_call_expression] = STATE(823),
    [sym_field_expression] = STATE(823),
    [sym_compound_literal_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(823),
    [sym_concatenated_string] = STATE(823),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(823),
    [sym_new_expression] = STATE(823),
    [sym_delete_expression] = STATE(823),
    [sym_lambda_expression] = STATE(823),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1564),
    [sym_char_literal] = ACTIONS(1564),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1568),
  },
  [387] = {
    [sym__expression] = STATE(825),
    [sym_conditional_expression] = STATE(825),
    [sym_assignment_expression] = STATE(825),
    [sym_pointer_expression] = STATE(825),
    [sym_logical_expression] = STATE(825),
    [sym_bitwise_expression] = STATE(825),
    [sym_equality_expression] = STATE(825),
    [sym_relational_expression] = STATE(825),
    [sym_shift_expression] = STATE(825),
    [sym_math_expression] = STATE(825),
    [sym_cast_expression] = STATE(825),
    [sym_sizeof_expression] = STATE(825),
    [sym_subscript_expression] = STATE(825),
    [sym_call_expression] = STATE(825),
    [sym_field_expression] = STATE(825),
    [sym_compound_literal_expression] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym_concatenated_string] = STATE(825),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(825),
    [sym_new_expression] = STATE(825),
    [sym_delete_expression] = STATE(825),
    [sym_lambda_expression] = STATE(825),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(1570),
    [sym_char_literal] = ACTIONS(1570),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_null] = ACTIONS(1574),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(1574),
  },
  [388] = {
    [sym_storage_class_specifier] = STATE(828),
    [sym_type_qualifier] = STATE(828),
    [aux_sym__declaration_specifiers_repeat1] = STATE(828),
    [sym_raw_string_literal] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_RBRACK] = ACTIONS(224),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_register] = ACTIONS(1576),
    [anon_sym_inline] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_restrict] = ACTIONS(1578),
    [anon_sym_volatile] = ACTIONS(1578),
    [anon_sym__Atomic] = ACTIONS(1578),
    [anon_sym_mutable] = ACTIONS(1578),
    [anon_sym_explicit] = ACTIONS(1578),
    [anon_sym_constexpr] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(224),
    [anon_sym_BANG] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_DASH_DASH] = ACTIONS(224),
    [anon_sym_PLUS_PLUS] = ACTIONS(224),
    [anon_sym_sizeof] = ACTIONS(230),
    [sym_number_literal] = ACTIONS(224),
    [sym_char_literal] = ACTIONS(224),
    [sym_string_literal] = ACTIONS(224),
    [sym_true] = ACTIONS(230),
    [sym_false] = ACTIONS(230),
    [sym_null] = ACTIONS(230),
    [sym_identifier] = ACTIONS(230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(230),
    [anon_sym_COLON_COLON] = ACTIONS(224),
    [anon_sym_delete] = ACTIONS(230),
    [sym_nullptr] = ACTIONS(230),
  },
  [389] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [390] = {
    [sym_initializer_list] = STATE(846),
    [sym_raw_string_literal] = ACTIONS(236),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(236),
    [anon_sym_BANG] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_sizeof] = ACTIONS(238),
    [sym_number_literal] = ACTIONS(236),
    [sym_char_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(236),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_null] = ACTIONS(238),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(238),
    [sym_nullptr] = ACTIONS(238),
  },
  [391] = {
    [sym__abstract_declarator] = STATE(849),
    [sym_abstract_pointer_declarator] = STATE(849),
    [sym_abstract_function_declarator] = STATE(850),
    [sym_abstract_array_declarator] = STATE(849),
    [sym_parameter_list] = STATE(851),
    [sym_abstract_reference_declarator] = STATE(849),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1618),
    [anon_sym_AMP_AMP] = ACTIONS(1620),
    [sym_comment] = ACTIONS(49),
  },
  [392] = {
    [sym_template_argument_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
  },
  [393] = {
    [sym_initializer_list] = STATE(846),
    [sym_template_argument_list] = STATE(854),
    [sym_raw_string_literal] = ACTIONS(236),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(236),
    [anon_sym_BANG] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_sizeof] = ACTIONS(238),
    [sym_number_literal] = ACTIONS(236),
    [sym_char_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(236),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_null] = ACTIONS(238),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [anon_sym_delete] = ACTIONS(238),
    [sym_nullptr] = ACTIONS(238),
  },
  [394] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1614),
  },
  [395] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(855),
    [sym_sized_type_specifier] = STATE(855),
    [sym_enum_specifier] = STATE(855),
    [sym_struct_specifier] = STATE(855),
    [sym_union_specifier] = STATE(855),
    [sym_macro_type_specifier] = STATE(855),
    [sym_class_specifier] = STATE(855),
    [sym_dependent_type] = STATE(855),
    [sym_template_type] = STATE(813),
    [sym_scoped_type_identifier] = STATE(814),
    [sym_scoped_namespace_identifier] = STATE(815),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [sym_identifier] = ACTIONS(1552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(1627),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_COLON_COLON] = ACTIONS(1554),
  },
  [396] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(858),
    [sym_raw_string_literal] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_RBRACK] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_DASH_DASH] = ACTIONS(246),
    [anon_sym_PLUS_PLUS] = ACTIONS(246),
    [anon_sym_sizeof] = ACTIONS(248),
    [sym_number_literal] = ACTIONS(246),
    [sym_char_literal] = ACTIONS(246),
    [sym_string_literal] = ACTIONS(246),
    [sym_true] = ACTIONS(248),
    [sym_false] = ACTIONS(248),
    [sym_null] = ACTIONS(248),
    [sym_identifier] = ACTIONS(1633),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(248),
    [anon_sym_COLON_COLON] = ACTIONS(246),
    [anon_sym_delete] = ACTIONS(248),
    [sym_nullptr] = ACTIONS(248),
  },
  [397] = {
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_RPAREN] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_mutable] = ACTIONS(121),
    [anon_sym_explicit] = ACTIONS(121),
    [anon_sym_constexpr] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(121),
  },
  [398] = {
    [sym__type_specifier] = STATE(866),
    [sym_sized_type_specifier] = STATE(866),
    [sym_enum_specifier] = STATE(866),
    [sym_struct_specifier] = STATE(866),
    [sym_union_specifier] = STATE(866),
    [sym_macro_type_specifier] = STATE(866),
    [sym_class_specifier] = STATE(866),
    [sym_dependent_type] = STATE(866),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(870),
    [anon_sym_unsigned] = ACTIONS(1636),
    [anon_sym_long] = ACTIONS(1636),
    [anon_sym_short] = ACTIONS(1636),
    [sym_primitive_type] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(1638),
    [anon_sym_typename] = ACTIONS(1650),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [399] = {
    [sym_type_qualifier] = STATE(871),
    [sym_trailing_return_type] = STATE(871),
    [aux_sym_function_declarator_repeat1] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(1654),
    [anon_sym_DASH_GT] = ACTIONS(648),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1656),
  },
  [400] = {
    [sym_string_literal] = ACTIONS(1658),
    [sym_system_lib_string] = ACTIONS(1658),
    [sym_comment] = ACTIONS(49),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1660),
    [sym_comment] = ACTIONS(49),
  },
  [402] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(874),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [403] = {
    [sym_preproc_arg] = ACTIONS(1662),
    [sym_comment] = ACTIONS(83),
  },
  [404] = {
    [sym_identifier] = ACTIONS(1664),
    [sym_comment] = ACTIONS(49),
  },
  [405] = {
    [sym_identifier] = ACTIONS(1666),
    [sym_comment] = ACTIONS(49),
  },
  [406] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1668),
    [anon_sym_LF] = ACTIONS(1670),
    [sym_comment] = ACTIONS(83),
  },
  [407] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [408] = {
    [sym_type_qualifier] = STATE(881),
    [sym__type_specifier] = STATE(880),
    [sym_sized_type_specifier] = STATE(880),
    [sym_enum_specifier] = STATE(880),
    [sym_struct_specifier] = STATE(880),
    [sym_union_specifier] = STATE(880),
    [sym_macro_type_specifier] = STATE(880),
    [sym_class_specifier] = STATE(880),
    [sym_dependent_type] = STATE(880),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(881),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1676),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [409] = {
    [sym_preproc_include] = STATE(883),
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(883),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(883),
    [sym_expression_statement] = STATE(883),
    [sym_if_statement] = STATE(883),
    [sym_switch_statement] = STATE(883),
    [sym_case_statement] = STATE(883),
    [sym_while_statement] = STATE(883),
    [sym_do_statement] = STATE(883),
    [sym_for_statement] = STATE(883),
    [sym_return_statement] = STATE(883),
    [sym_break_statement] = STATE(883),
    [sym_continue_statement] = STATE(883),
    [sym_goto_statement] = STATE(883),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(883),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(883),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(883),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [411] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1463),
  },
  [412] = {
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_constexpr] = ACTIONS(1686),
    [sym_comment] = ACTIONS(49),
  },
  [413] = {
    [anon_sym_LPAREN] = ACTIONS(1688),
    [sym_comment] = ACTIONS(49),
  },
  [414] = {
    [sym__expression] = STATE(896),
    [sym_conditional_expression] = STATE(896),
    [sym_assignment_expression] = STATE(896),
    [sym_pointer_expression] = STATE(896),
    [sym_logical_expression] = STATE(896),
    [sym_bitwise_expression] = STATE(896),
    [sym_equality_expression] = STATE(896),
    [sym_relational_expression] = STATE(896),
    [sym_shift_expression] = STATE(896),
    [sym_math_expression] = STATE(896),
    [sym_cast_expression] = STATE(896),
    [sym_sizeof_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_call_expression] = STATE(896),
    [sym_field_expression] = STATE(896),
    [sym_compound_literal_expression] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym_concatenated_string] = STATE(896),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(896),
    [sym_new_expression] = STATE(896),
    [sym_delete_expression] = STATE(896),
    [sym_lambda_expression] = STATE(896),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(1690),
    [sym_char_literal] = ACTIONS(1690),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(1708),
    [sym_false] = ACTIONS(1708),
    [sym_null] = ACTIONS(1708),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(1708),
  },
  [415] = {
    [anon_sym_COLON] = ACTIONS(1714),
    [sym_comment] = ACTIONS(49),
  },
  [416] = {
    [anon_sym_LPAREN] = ACTIONS(1716),
    [sym_comment] = ACTIONS(49),
  },
  [417] = {
    [sym_compound_statement] = STATE(914),
    [sym_labeled_statement] = STATE(914),
    [sym_expression_statement] = STATE(914),
    [sym_if_statement] = STATE(914),
    [sym_switch_statement] = STATE(914),
    [sym_case_statement] = STATE(914),
    [sym_while_statement] = STATE(914),
    [sym_do_statement] = STATE(914),
    [sym_for_statement] = STATE(914),
    [sym_return_statement] = STATE(914),
    [sym_break_statement] = STATE(914),
    [sym_continue_statement] = STATE(914),
    [sym_goto_statement] = STATE(914),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(914),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [418] = {
    [anon_sym_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(49),
  },
  [419] = {
    [sym__expression] = STATE(919),
    [sym_conditional_expression] = STATE(919),
    [sym_assignment_expression] = STATE(919),
    [sym_pointer_expression] = STATE(919),
    [sym_logical_expression] = STATE(919),
    [sym_bitwise_expression] = STATE(919),
    [sym_equality_expression] = STATE(919),
    [sym_relational_expression] = STATE(919),
    [sym_shift_expression] = STATE(919),
    [sym_math_expression] = STATE(919),
    [sym_cast_expression] = STATE(919),
    [sym_sizeof_expression] = STATE(919),
    [sym_subscript_expression] = STATE(919),
    [sym_call_expression] = STATE(919),
    [sym_field_expression] = STATE(919),
    [sym_compound_literal_expression] = STATE(919),
    [sym_parenthesized_expression] = STATE(919),
    [sym_initializer_list] = STATE(920),
    [sym_concatenated_string] = STATE(919),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(919),
    [sym_new_expression] = STATE(919),
    [sym_delete_expression] = STATE(919),
    [sym_lambda_expression] = STATE(919),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1752),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1752),
    [sym_char_literal] = ACTIONS(1752),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1756),
    [sym_false] = ACTIONS(1756),
    [sym_null] = ACTIONS(1756),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1756),
  },
  [420] = {
    [anon_sym_SEMI] = ACTIONS(1758),
    [sym_comment] = ACTIONS(49),
  },
  [421] = {
    [anon_sym_SEMI] = ACTIONS(1760),
    [sym_comment] = ACTIONS(49),
  },
  [422] = {
    [sym_identifier] = ACTIONS(1762),
    [sym_comment] = ACTIONS(49),
  },
  [423] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1515),
  },
  [424] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1519),
  },
  [425] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1523),
  },
  [426] = {
    [sym__expression] = STATE(925),
    [sym_conditional_expression] = STATE(925),
    [sym_assignment_expression] = STATE(925),
    [sym_pointer_expression] = STATE(925),
    [sym_logical_expression] = STATE(925),
    [sym_bitwise_expression] = STATE(925),
    [sym_equality_expression] = STATE(925),
    [sym_relational_expression] = STATE(925),
    [sym_shift_expression] = STATE(925),
    [sym_math_expression] = STATE(925),
    [sym_cast_expression] = STATE(925),
    [sym_sizeof_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_call_expression] = STATE(925),
    [sym_field_expression] = STATE(925),
    [sym_compound_literal_expression] = STATE(925),
    [sym_parenthesized_expression] = STATE(925),
    [sym_concatenated_string] = STATE(925),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(925),
    [sym_new_expression] = STATE(925),
    [sym_delete_expression] = STATE(925),
    [sym_lambda_expression] = STATE(925),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1764),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1764),
    [sym_char_literal] = ACTIONS(1764),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1768),
    [sym_false] = ACTIONS(1768),
    [sym_null] = ACTIONS(1768),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1768),
  },
  [427] = {
    [aux_sym_concatenated_string_repeat1] = STATE(926),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(1770),
    [sym_comment] = ACTIONS(49),
  },
  [428] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
    [sym_operator_name] = ACTIONS(146),
  },
  [429] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1778),
    [sym_operator_name] = ACTIONS(198),
  },
  [430] = {
    [sym__expression] = STATE(933),
    [sym_conditional_expression] = STATE(933),
    [sym_assignment_expression] = STATE(933),
    [sym_pointer_expression] = STATE(933),
    [sym_logical_expression] = STATE(933),
    [sym_bitwise_expression] = STATE(933),
    [sym_equality_expression] = STATE(933),
    [sym_relational_expression] = STATE(933),
    [sym_shift_expression] = STATE(933),
    [sym_math_expression] = STATE(933),
    [sym_cast_expression] = STATE(933),
    [sym_sizeof_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_call_expression] = STATE(933),
    [sym_field_expression] = STATE(933),
    [sym_compound_literal_expression] = STATE(933),
    [sym_parenthesized_expression] = STATE(933),
    [sym_concatenated_string] = STATE(933),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(933),
    [sym_new_expression] = STATE(933),
    [sym_delete_expression] = STATE(933),
    [sym_lambda_expression] = STATE(933),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1780),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1780),
    [sym_char_literal] = ACTIONS(1780),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1784),
    [sym_false] = ACTIONS(1784),
    [sym_null] = ACTIONS(1784),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1784),
  },
  [431] = {
    [sym_raw_string_literal] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1788),
    [sym_preproc_directive] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1786),
    [anon_sym_typedef] = ACTIONS(1788),
    [anon_sym_extern] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1786),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_register] = ACTIONS(1788),
    [anon_sym_inline] = ACTIONS(1788),
    [anon_sym_const] = ACTIONS(1788),
    [anon_sym_restrict] = ACTIONS(1788),
    [anon_sym_volatile] = ACTIONS(1788),
    [anon_sym__Atomic] = ACTIONS(1788),
    [anon_sym_mutable] = ACTIONS(1788),
    [anon_sym_explicit] = ACTIONS(1788),
    [anon_sym_constexpr] = ACTIONS(1788),
    [anon_sym_unsigned] = ACTIONS(1788),
    [anon_sym_long] = ACTIONS(1788),
    [anon_sym_short] = ACTIONS(1788),
    [sym_primitive_type] = ACTIONS(1788),
    [anon_sym_enum] = ACTIONS(1788),
    [anon_sym_struct] = ACTIONS(1788),
    [anon_sym_union] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(1788),
    [anon_sym_case] = ACTIONS(1788),
    [anon_sym_default] = ACTIONS(1788),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_do] = ACTIONS(1788),
    [anon_sym_for] = ACTIONS(1788),
    [anon_sym_return] = ACTIONS(1788),
    [anon_sym_break] = ACTIONS(1788),
    [anon_sym_continue] = ACTIONS(1788),
    [anon_sym_goto] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_TILDE] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_sizeof] = ACTIONS(1788),
    [sym_number_literal] = ACTIONS(1786),
    [sym_char_literal] = ACTIONS(1786),
    [sym_string_literal] = ACTIONS(1786),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1788),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1788),
    [sym_auto] = ACTIONS(1788),
    [anon_sym_typename] = ACTIONS(1788),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_delete] = ACTIONS(1788),
    [sym_nullptr] = ACTIONS(1788),
  },
  [432] = {
    [sym_raw_string_literal] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1792),
    [sym_preproc_directive] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1792),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_RBRACE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_restrict] = ACTIONS(1792),
    [anon_sym_volatile] = ACTIONS(1792),
    [anon_sym__Atomic] = ACTIONS(1792),
    [anon_sym_mutable] = ACTIONS(1792),
    [anon_sym_explicit] = ACTIONS(1792),
    [anon_sym_constexpr] = ACTIONS(1792),
    [anon_sym_unsigned] = ACTIONS(1792),
    [anon_sym_long] = ACTIONS(1792),
    [anon_sym_short] = ACTIONS(1792),
    [sym_primitive_type] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(1792),
    [anon_sym_union] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_goto] = ACTIONS(1792),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1790),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1790),
    [anon_sym_sizeof] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1790),
    [sym_char_literal] = ACTIONS(1790),
    [sym_string_literal] = ACTIONS(1790),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(1792),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1792),
    [sym_auto] = ACTIONS(1792),
    [anon_sym_typename] = ACTIONS(1792),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_COLON_COLON] = ACTIONS(1790),
    [anon_sym_delete] = ACTIONS(1792),
    [sym_nullptr] = ACTIONS(1792),
  },
  [433] = {
    [sym__declarator] = STATE(935),
    [sym_pointer_declarator] = STATE(935),
    [sym_function_declarator] = STATE(935),
    [sym_array_declarator] = STATE(935),
    [sym_init_declarator] = STATE(936),
    [sym_reference_declarator] = STATE(935),
    [sym_structured_binding_reference_declarator] = STATE(937),
    [sym_structured_binding_declarator] = STATE(938),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(935),
    [sym_destructor_name] = STATE(935),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1796),
  },
  [434] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [435] = {
    [anon_sym_SEMI] = ACTIONS(1800),
    [sym_comment] = ACTIONS(49),
  },
  [436] = {
    [sym_initializer_list] = STATE(846),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1830),
    [sym_operator_name] = ACTIONS(236),
  },
  [437] = {
    [sym_initializer_list] = STATE(846),
    [sym_template_argument_list] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(150),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [sym_operator_name] = ACTIONS(236),
  },
  [438] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1830),
  },
  [439] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [440] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [sym__type_specifier] = STATE(149),
    [sym_sized_type_specifier] = STATE(149),
    [sym_enum_specifier] = STATE(149),
    [sym_struct_specifier] = STATE(149),
    [sym_union_specifier] = STATE(149),
    [sym_macro_type_specifier] = STATE(149),
    [sym_class_specifier] = STATE(149),
    [sym_dependent_type] = STATE(149),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(244),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [441] = {
    [sym_argument_list] = STATE(957),
    [sym_initializer_list] = STATE(957),
    [sym_template_argument_list] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1834),
  },
  [442] = {
    [sym_destructor_name] = STATE(959),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(1836),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(1838),
  },
  [443] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(961),
    [anon_sym_COMMA] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(49),
  },
  [444] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1844),
  },
  [445] = {
    [sym_argument_list] = STATE(963),
    [sym_initializer_list] = STATE(963),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1848),
    [sym_preproc_directive] = ACTIONS(1848),
    [anon_sym_typedef] = ACTIONS(1848),
    [anon_sym_extern] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_register] = ACTIONS(1848),
    [anon_sym_inline] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_restrict] = ACTIONS(1848),
    [anon_sym_volatile] = ACTIONS(1848),
    [anon_sym__Atomic] = ACTIONS(1848),
    [anon_sym_mutable] = ACTIONS(1848),
    [anon_sym_explicit] = ACTIONS(1848),
    [anon_sym_constexpr] = ACTIONS(1848),
    [anon_sym_unsigned] = ACTIONS(1848),
    [anon_sym_long] = ACTIONS(1848),
    [anon_sym_short] = ACTIONS(1848),
    [sym_primitive_type] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_struct] = ACTIONS(1848),
    [anon_sym_union] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1848),
    [sym_auto] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1848),
    [anon_sym_template] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1848),
    [anon_sym_using] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1846),
    [sym_operator_name] = ACTIONS(1846),
  },
  [447] = {
    [sym_storage_class_specifier] = STATE(447),
    [sym_type_qualifier] = STATE(447),
    [aux_sym__declaration_specifiers_repeat1] = STATE(447),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [448] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [449] = {
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_comment] = ACTIONS(49),
  },
  [450] = {
    [sym_compound_statement] = STATE(964),
    [anon_sym_LBRACE] = ACTIONS(220),
    [sym_comment] = ACTIONS(49),
  },
  [451] = {
    [sym_storage_class_specifier] = STATE(447),
    [sym_type_qualifier] = STATE(447),
    [aux_sym__declaration_specifiers_repeat1] = STATE(447),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [452] = {
    [anon_sym_LF] = ACTIONS(1873),
    [sym_comment] = ACTIONS(83),
  },
  [453] = {
    [aux_sym_preproc_params_repeat1] = STATE(968),
    [anon_sym_COMMA] = ACTIONS(1875),
    [anon_sym_RPAREN] = ACTIONS(1877),
    [sym_comment] = ACTIONS(49),
  },
  [454] = {
    [anon_sym_LF] = ACTIONS(1879),
    [sym_preproc_arg] = ACTIONS(1879),
    [sym_comment] = ACTIONS(83),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_template] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1883),
    [anon_sym_using] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [sym_operator_name] = ACTIONS(1881),
  },
  [456] = {
    [anon_sym_LF] = ACTIONS(1885),
    [sym_comment] = ACTIONS(83),
  },
  [457] = {
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1192),
    [anon_sym_COLON] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [458] = {
    [sym__type_specifier] = STATE(975),
    [sym_sized_type_specifier] = STATE(975),
    [sym_enum_specifier] = STATE(975),
    [sym_struct_specifier] = STATE(975),
    [sym_union_specifier] = STATE(975),
    [sym_macro_type_specifier] = STATE(975),
    [sym_class_specifier] = STATE(975),
    [sym_dependent_type] = STATE(975),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(976),
    [anon_sym_unsigned] = ACTIONS(1887),
    [anon_sym_long] = ACTIONS(1887),
    [anon_sym_short] = ACTIONS(1887),
    [sym_primitive_type] = ACTIONS(1889),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(1889),
    [anon_sym_typename] = ACTIONS(1899),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [459] = {
    [sym_type_qualifier] = STATE(977),
    [sym_trailing_return_type] = STATE(977),
    [aux_sym_function_declarator_repeat1] = STATE(977),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1901),
  },
  [460] = {
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1865),
    [anon_sym_COLON] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1856),
    [anon_sym_GT] = ACTIONS(1865),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [461] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_template] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_using] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [sym_operator_name] = ACTIONS(257),
  },
  [462] = {
    [sym_preproc_params] = STATE(980),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1903),
    [anon_sym_LF] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [463] = {
    [sym_preproc_include] = STATE(983),
    [sym_preproc_def] = STATE(983),
    [sym_preproc_function_def] = STATE(983),
    [sym_preproc_call] = STATE(983),
    [sym_preproc_if] = STATE(983),
    [sym_preproc_ifdef] = STATE(983),
    [sym_preproc_else] = STATE(982),
    [sym_preproc_elif] = STATE(982),
    [sym_function_definition] = STATE(983),
    [sym_declaration] = STATE(983),
    [sym_type_definition] = STATE(983),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(983),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(983),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(983),
    [sym_template_declaration] = STATE(983),
    [sym_template_instantiation] = STATE(983),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(983),
    [sym_using_declaration] = STATE(983),
    [sym_alias_declaration] = STATE(983),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(983),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1907),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [464] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if] = STATE(986),
    [sym_preproc_ifdef] = STATE(986),
    [sym_preproc_else] = STATE(985),
    [sym_preproc_elif] = STATE(985),
    [sym_function_definition] = STATE(986),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(986),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(986),
    [sym_template_declaration] = STATE(986),
    [sym_template_instantiation] = STATE(986),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(986),
    [sym_using_declaration] = STATE(986),
    [sym_alias_declaration] = STATE(986),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1909),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [465] = {
    [sym_preproc_include] = STATE(989),
    [sym_preproc_def] = STATE(989),
    [sym_preproc_function_def] = STATE(989),
    [sym_preproc_call] = STATE(989),
    [sym_preproc_if] = STATE(989),
    [sym_preproc_ifdef] = STATE(989),
    [sym_preproc_else] = STATE(988),
    [sym_preproc_elif] = STATE(988),
    [sym_function_definition] = STATE(989),
    [sym_declaration] = STATE(989),
    [sym_type_definition] = STATE(989),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(989),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(989),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(989),
    [sym_template_declaration] = STATE(989),
    [sym_template_instantiation] = STATE(989),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(989),
    [sym_using_declaration] = STATE(989),
    [sym_alias_declaration] = STATE(989),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(989),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [466] = {
    [sym_string_literal] = ACTIONS(1913),
    [sym_system_lib_string] = ACTIONS(1913),
    [sym_comment] = ACTIONS(49),
  },
  [467] = {
    [sym_identifier] = ACTIONS(1915),
    [sym_comment] = ACTIONS(49),
  },
  [468] = {
    [sym_preproc_arg] = ACTIONS(1917),
    [sym_comment] = ACTIONS(83),
  },
  [469] = {
    [sym_identifier] = ACTIONS(1919),
    [sym_comment] = ACTIONS(49),
  },
  [470] = {
    [sym_identifier] = ACTIONS(1921),
    [sym_comment] = ACTIONS(49),
  },
  [471] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1923),
    [anon_sym_LF] = ACTIONS(1925),
    [sym_comment] = ACTIONS(83),
  },
  [472] = {
    [sym_type_qualifier] = STATE(998),
    [sym__type_specifier] = STATE(997),
    [sym_sized_type_specifier] = STATE(997),
    [sym_enum_specifier] = STATE(997),
    [sym_struct_specifier] = STATE(997),
    [sym_union_specifier] = STATE(997),
    [sym_macro_type_specifier] = STATE(997),
    [sym_class_specifier] = STATE(997),
    [sym_dependent_type] = STATE(997),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(998),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1927),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [473] = {
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_unsigned] = ACTIONS(115),
    [anon_sym_long] = ACTIONS(115),
    [anon_sym_short] = ACTIONS(115),
    [sym_primitive_type] = ACTIONS(115),
    [anon_sym_enum] = ACTIONS(115),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_union] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(1929),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(115),
    [sym_auto] = ACTIONS(115),
    [anon_sym_typename] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [sym_operator_name] = ACTIONS(113),
  },
  [474] = {
    [sym__declaration_specifiers] = STATE(1000),
    [sym__declarator] = STATE(1001),
    [sym_pointer_declarator] = STATE(1001),
    [sym_function_declarator] = STATE(1001),
    [sym_array_declarator] = STATE(1001),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_parameter_list] = STATE(1002),
    [sym_reference_declarator] = STATE(1001),
    [sym_template_type] = STATE(112),
    [sym_template_function] = STATE(1001),
    [sym_destructor_name] = STATE(1001),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(113),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_LT] = ACTIONS(176),
    [sym_identifier] = ACTIONS(178),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(182),
    [sym_operator_name] = ACTIONS(1931),
  },
  [475] = {
    [sym_declaration_list] = STATE(1005),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [sym_identifier] = ACTIONS(1935),
    [sym_comment] = ACTIONS(49),
  },
  [476] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(1008),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(1937),
    [sym_comment] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(1939),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [477] = {
    [sym__declarator] = STATE(1010),
    [sym_pointer_declarator] = STATE(1010),
    [sym_function_declarator] = STATE(1010),
    [sym_array_declarator] = STATE(1010),
    [sym_init_declarator] = STATE(1011),
    [sym_reference_declarator] = STATE(1010),
    [sym_structured_binding_reference_declarator] = STATE(1012),
    [sym_structured_binding_declarator] = STATE(1013),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1010),
    [sym_destructor_name] = STATE(1010),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1943),
  },
  [478] = {
    [sym_compound_statement] = STATE(1015),
    [sym_field_initializer_list] = STATE(1016),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [479] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(234),
    [anon_sym_LPAREN] = ACTIONS(232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(234),
    [sym_preproc_directive] = ACTIONS(234),
    [anon_sym_typedef] = ACTIONS(234),
    [anon_sym_extern] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_static] = ACTIONS(234),
    [anon_sym_register] = ACTIONS(234),
    [anon_sym_inline] = ACTIONS(234),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_restrict] = ACTIONS(234),
    [anon_sym_volatile] = ACTIONS(234),
    [anon_sym__Atomic] = ACTIONS(234),
    [anon_sym_mutable] = ACTIONS(234),
    [anon_sym_explicit] = ACTIONS(234),
    [anon_sym_constexpr] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(234),
    [anon_sym_enum] = ACTIONS(234),
    [anon_sym_struct] = ACTIONS(234),
    [anon_sym_union] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(232),
    [anon_sym_TILDE] = ACTIONS(232),
    [sym_identifier] = ACTIONS(234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(234),
    [sym_auto] = ACTIONS(234),
    [anon_sym_typename] = ACTIONS(234),
    [anon_sym_template] = ACTIONS(234),
    [anon_sym_namespace] = ACTIONS(234),
    [anon_sym_using] = ACTIONS(234),
    [anon_sym_COLON_COLON] = ACTIONS(232),
    [sym_operator_name] = ACTIONS(232),
  },
  [480] = {
    [sym_preproc_include] = STATE(1017),
    [sym_preproc_def] = STATE(1017),
    [sym_preproc_function_def] = STATE(1017),
    [sym_preproc_call] = STATE(1017),
    [sym_preproc_if] = STATE(1017),
    [sym_preproc_ifdef] = STATE(1017),
    [sym_function_definition] = STATE(1017),
    [sym_declaration] = STATE(1017),
    [sym_type_definition] = STATE(1017),
    [sym__declaration_specifiers] = STATE(477),
    [sym_linkage_specification] = STATE(1017),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(481),
    [sym_type_qualifier] = STATE(481),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1017),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1017),
    [sym_template_declaration] = STATE(1017),
    [sym_template_instantiation] = STATE(1017),
    [sym_constructor_or_destructor_definition] = STATE(479),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1017),
    [sym_using_declaration] = STATE(1017),
    [sym_alias_declaration] = STATE(1017),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1017),
    [aux_sym__declaration_specifiers_repeat1] = STATE(481),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(897),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(901),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1947),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(905),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(907),
    [sym_preproc_directive] = ACTIONS(909),
    [anon_sym_typedef] = ACTIONS(911),
    [anon_sym_extern] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(915),
    [anon_sym_namespace] = ACTIONS(917),
    [anon_sym_using] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [481] = {
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(1018),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(150),
    [sym_type_qualifier] = STATE(150),
    [sym__type_specifier] = STATE(149),
    [sym_sized_type_specifier] = STATE(149),
    [sym_enum_specifier] = STATE(149),
    [sym_struct_specifier] = STATE(149),
    [sym_union_specifier] = STATE(149),
    [sym_macro_type_specifier] = STATE(149),
    [sym_class_specifier] = STATE(149),
    [sym_dependent_type] = STATE(149),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(150),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(244),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(244),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [482] = {
    [sym_preproc_include] = STATE(1020),
    [sym_preproc_def] = STATE(1020),
    [sym_preproc_function_def] = STATE(1020),
    [sym_preproc_call] = STATE(1020),
    [sym_preproc_if] = STATE(1020),
    [sym_preproc_ifdef] = STATE(1020),
    [sym_preproc_else] = STATE(1019),
    [sym_preproc_elif] = STATE(1019),
    [sym_function_definition] = STATE(1020),
    [sym_declaration] = STATE(1020),
    [sym_type_definition] = STATE(1020),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(1020),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1020),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1020),
    [sym_template_declaration] = STATE(1020),
    [sym_template_instantiation] = STATE(1020),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1020),
    [sym_using_declaration] = STATE(1020),
    [sym_alias_declaration] = STATE(1020),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1020),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [483] = {
    [sym_preproc_arg] = ACTIONS(1951),
    [sym_comment] = ACTIONS(83),
  },
  [484] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_namespace] = ACTIONS(317),
    [anon_sym_using] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [sym_operator_name] = ACTIONS(315),
  },
  [485] = {
    [sym__type_declarator] = STATE(1022),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [486] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1023),
    [sym_sized_type_specifier] = STATE(1023),
    [sym_enum_specifier] = STATE(1023),
    [sym_struct_specifier] = STATE(1023),
    [sym_union_specifier] = STATE(1023),
    [sym_macro_type_specifier] = STATE(1023),
    [sym_class_specifier] = STATE(1023),
    [sym_dependent_type] = STATE(1023),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [487] = {
    [sym_function_definition] = STATE(1024),
    [sym_declaration] = STATE(1024),
    [sym__declaration_specifiers] = STATE(1025),
    [sym_declaration_list] = STATE(1024),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [488] = {
    [sym__declarator] = STATE(1026),
    [sym_pointer_declarator] = STATE(1026),
    [sym_function_declarator] = STATE(1026),
    [sym_array_declarator] = STATE(1026),
    [sym_reference_declarator] = STATE(1026),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1026),
    [sym_destructor_name] = STATE(1026),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1955),
  },
  [489] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [490] = {
    [sym_function_definition] = STATE(1028),
    [sym_declaration] = STATE(1028),
    [sym__declaration_specifiers] = STATE(1029),
    [sym_storage_class_specifier] = STATE(326),
    [sym_type_qualifier] = STATE(326),
    [sym__type_specifier] = STATE(325),
    [sym_sized_type_specifier] = STATE(325),
    [sym_enum_specifier] = STATE(325),
    [sym_struct_specifier] = STATE(325),
    [sym_union_specifier] = STATE(325),
    [sym__empty_declaration] = STATE(1028),
    [sym_macro_type_specifier] = STATE(325),
    [sym_class_specifier] = STATE(325),
    [sym_dependent_type] = STATE(325),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(326),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(513),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [491] = {
    [sym_preproc_include] = STATE(1031),
    [sym_preproc_def] = STATE(1031),
    [sym_preproc_function_def] = STATE(1031),
    [sym_preproc_call] = STATE(1031),
    [sym_preproc_if] = STATE(1031),
    [sym_preproc_ifdef] = STATE(1031),
    [sym_function_definition] = STATE(1031),
    [sym_declaration] = STATE(1031),
    [sym_type_definition] = STATE(1031),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(1031),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1031),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1031),
    [sym_template_declaration] = STATE(1031),
    [sym_template_instantiation] = STATE(1031),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1031),
    [sym_using_declaration] = STATE(1031),
    [sym_alias_declaration] = STATE(1031),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1031),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [492] = {
    [sym_declaration_list] = STATE(1032),
    [anon_sym_LBRACE] = ACTIONS(933),
    [sym_comment] = ACTIONS(49),
  },
  [493] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(527),
    [sym_preproc_directive] = ACTIONS(527),
    [anon_sym_typedef] = ACTIONS(527),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_register] = ACTIONS(527),
    [anon_sym_inline] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_restrict] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym__Atomic] = ACTIONS(527),
    [anon_sym_mutable] = ACTIONS(527),
    [anon_sym_explicit] = ACTIONS(527),
    [anon_sym_constexpr] = ACTIONS(527),
    [anon_sym_unsigned] = ACTIONS(527),
    [anon_sym_long] = ACTIONS(527),
    [anon_sym_short] = ACTIONS(527),
    [sym_primitive_type] = ACTIONS(527),
    [anon_sym_enum] = ACTIONS(527),
    [anon_sym_struct] = ACTIONS(527),
    [anon_sym_union] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [sym_identifier] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(527),
    [sym_auto] = ACTIONS(527),
    [anon_sym_typename] = ACTIONS(527),
    [anon_sym_template] = ACTIONS(527),
    [anon_sym_namespace] = ACTIONS(527),
    [anon_sym_using] = ACTIONS(527),
    [anon_sym_COLON_COLON] = ACTIONS(525),
    [sym_operator_name] = ACTIONS(525),
  },
  [494] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [495] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(1036),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(1965),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [496] = {
    [anon_sym_SEMI] = ACTIONS(1961),
    [sym_comment] = ACTIONS(49),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1967),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1969),
    [sym_preproc_directive] = ACTIONS(1969),
    [anon_sym_typedef] = ACTIONS(1969),
    [anon_sym_extern] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1969),
    [anon_sym_register] = ACTIONS(1969),
    [anon_sym_inline] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1969),
    [anon_sym_restrict] = ACTIONS(1969),
    [anon_sym_volatile] = ACTIONS(1969),
    [anon_sym__Atomic] = ACTIONS(1969),
    [anon_sym_mutable] = ACTIONS(1969),
    [anon_sym_explicit] = ACTIONS(1969),
    [anon_sym_constexpr] = ACTIONS(1969),
    [anon_sym_unsigned] = ACTIONS(1969),
    [anon_sym_long] = ACTIONS(1969),
    [anon_sym_short] = ACTIONS(1969),
    [sym_primitive_type] = ACTIONS(1969),
    [anon_sym_enum] = ACTIONS(1969),
    [anon_sym_struct] = ACTIONS(1969),
    [anon_sym_union] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1969),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1969),
    [sym_auto] = ACTIONS(1969),
    [anon_sym_typename] = ACTIONS(1969),
    [anon_sym_template] = ACTIONS(1969),
    [anon_sym_namespace] = ACTIONS(1969),
    [anon_sym_using] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1967),
    [sym_operator_name] = ACTIONS(1967),
  },
  [498] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_template] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_using] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [sym_operator_name] = ACTIONS(554),
  },
  [499] = {
    [sym_compound_statement] = STATE(1039),
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(1040),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [500] = {
    [aux_sym_declaration_repeat1] = STATE(1040),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(1971),
    [sym_comment] = ACTIONS(49),
  },
  [501] = {
    [sym_argument_list] = STATE(1042),
    [sym_initializer_list] = STATE(1042),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(1975),
    [sym_comment] = ACTIONS(49),
  },
  [502] = {
    [sym_argument_list] = STATE(1044),
    [sym_initializer_list] = STATE(1044),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(1977),
    [sym_comment] = ACTIONS(49),
  },
  [503] = {
    [sym_preproc_include] = STATE(1046),
    [sym_preproc_def] = STATE(1046),
    [sym_preproc_function_def] = STATE(1046),
    [sym_preproc_call] = STATE(1046),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1046),
    [sym_type_definition] = STATE(1046),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1046),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_if_statement] = STATE(1046),
    [sym_switch_statement] = STATE(1046),
    [sym_case_statement] = STATE(1046),
    [sym_while_statement] = STATE(1046),
    [sym_do_statement] = STATE(1046),
    [sym_for_statement] = STATE(1046),
    [sym_return_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_goto_statement] = STATE(1046),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(1046),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1046),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1046),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1046),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [504] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(726),
    [sym_preproc_directive] = ACTIONS(726),
    [anon_sym_typedef] = ACTIONS(726),
    [anon_sym_extern] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_register] = ACTIONS(726),
    [anon_sym_inline] = ACTIONS(726),
    [anon_sym_const] = ACTIONS(726),
    [anon_sym_restrict] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym__Atomic] = ACTIONS(726),
    [anon_sym_mutable] = ACTIONS(726),
    [anon_sym_explicit] = ACTIONS(726),
    [anon_sym_constexpr] = ACTIONS(726),
    [anon_sym_unsigned] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [sym_primitive_type] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(726),
    [anon_sym_union] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(726),
    [sym_auto] = ACTIONS(726),
    [anon_sym_typename] = ACTIONS(726),
    [anon_sym_template] = ACTIONS(726),
    [anon_sym_namespace] = ACTIONS(726),
    [anon_sym_using] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(724),
    [sym_operator_name] = ACTIONS(724),
  },
  [505] = {
    [sym_compound_statement] = STATE(1047),
    [anon_sym_LBRACE] = ACTIONS(947),
    [sym_comment] = ACTIONS(49),
  },
  [506] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1981),
    [sym_comment] = ACTIONS(49),
  },
  [507] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1986),
    [anon_sym_LPAREN] = ACTIONS(752),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1997),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1992),
    [sym_preproc_directive] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2003),
    [anon_sym_extern] = ACTIONS(2006),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(776),
    [anon_sym_register] = ACTIONS(776),
    [anon_sym_inline] = ACTIONS(776),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_restrict] = ACTIONS(779),
    [anon_sym_volatile] = ACTIONS(779),
    [anon_sym__Atomic] = ACTIONS(779),
    [anon_sym_mutable] = ACTIONS(779),
    [anon_sym_explicit] = ACTIONS(779),
    [anon_sym_constexpr] = ACTIONS(779),
    [anon_sym_unsigned] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(803),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(809),
    [sym_auto] = ACTIONS(785),
    [anon_sym_typename] = ACTIONS(812),
    [anon_sym_template] = ACTIONS(2009),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_using] = ACTIONS(2015),
    [anon_sym_COLON_COLON] = ACTIONS(824),
    [sym_operator_name] = ACTIONS(827),
  },
  [508] = {
    [sym_compound_statement] = STATE(1047),
    [sym_field_initializer_list] = STATE(1049),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2020),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2020),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [sym_operator_name] = ACTIONS(2018),
  },
  [510] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2022),
    [sym_comment] = ACTIONS(49),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2026),
    [sym_preproc_directive] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(2026),
    [anon_sym_extern] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_register] = ACTIONS(2026),
    [anon_sym_inline] = ACTIONS(2026),
    [anon_sym_const] = ACTIONS(2026),
    [anon_sym_restrict] = ACTIONS(2026),
    [anon_sym_volatile] = ACTIONS(2026),
    [anon_sym__Atomic] = ACTIONS(2026),
    [anon_sym_mutable] = ACTIONS(2026),
    [anon_sym_explicit] = ACTIONS(2026),
    [anon_sym_constexpr] = ACTIONS(2026),
    [anon_sym_unsigned] = ACTIONS(2026),
    [anon_sym_long] = ACTIONS(2026),
    [anon_sym_short] = ACTIONS(2026),
    [sym_primitive_type] = ACTIONS(2026),
    [anon_sym_enum] = ACTIONS(2026),
    [anon_sym_struct] = ACTIONS(2026),
    [anon_sym_union] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_TILDE] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2026),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2026),
    [sym_auto] = ACTIONS(2026),
    [anon_sym_typename] = ACTIONS(2026),
    [anon_sym_template] = ACTIONS(2026),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_using] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2024),
    [sym_operator_name] = ACTIONS(2024),
  },
  [512] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2028),
    [sym_comment] = ACTIONS(49),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [sym_operator_name] = ACTIONS(2030),
  },
  [514] = {
    [anon_sym_RBRACE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(49),
  },
  [515] = {
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_comment] = ACTIONS(49),
  },
  [516] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1054),
    [anon_sym_COMMA] = ACTIONS(2036),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(49),
  },
  [517] = {
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1039),
    [sym_comment] = ACTIONS(49),
  },
  [518] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(49),
  },
  [519] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(593),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(593),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(593),
    [sym_access_specifier] = STATE(593),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(593),
    [sym_alias_declaration] = STATE(593),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [520] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1057),
    [sym_parenthesized_expression] = STATE(1057),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(2040),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(49),
  },
  [522] = {
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [523] = {
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1121),
    [sym_identifier] = ACTIONS(1121),
    [sym_comment] = ACTIONS(49),
  },
  [524] = {
    [sym_field_declaration_list] = STATE(1059),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [525] = {
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [526] = {
    [sym_field_declaration_list] = STATE(1059),
    [sym_base_class_clause] = STATE(1060),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2044),
    [sym_comment] = ACTIONS(49),
  },
  [528] = {
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
  },
  [529] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(1127),
    [sym_comment] = ACTIONS(49),
  },
  [530] = {
    [sym_field_declaration_list] = STATE(1062),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [531] = {
    [sym_field_declaration_list] = STATE(1062),
    [sym_base_class_clause] = STATE(1063),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [532] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [sym_identifier] = ACTIONS(1157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
  },
  [533] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1065),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(2046),
    [sym_comment] = ACTIONS(49),
  },
  [534] = {
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [535] = {
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1196),
    [sym_comment] = ACTIONS(49),
  },
  [536] = {
    [sym_field_declaration_list] = STATE(1066),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [537] = {
    [sym_field_declaration_list] = STATE(1066),
    [sym_base_class_clause] = STATE(1067),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [538] = {
    [sym__type_declarator] = STATE(540),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(993),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [539] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [540] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_template] = ACTIONS(2054),
    [anon_sym_namespace] = ACTIONS(2054),
    [anon_sym_using] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [sym_operator_name] = ACTIONS(2052),
  },
  [542] = {
    [sym__declaration_specifiers] = STATE(1070),
    [sym_storage_class_specifier] = STATE(395),
    [sym_type_qualifier] = STATE(395),
    [sym__type_specifier] = STATE(388),
    [sym_sized_type_specifier] = STATE(388),
    [sym_enum_specifier] = STATE(388),
    [sym_struct_specifier] = STATE(388),
    [sym_union_specifier] = STATE(388),
    [sym__expression] = STATE(1071),
    [sym_conditional_expression] = STATE(1071),
    [sym_assignment_expression] = STATE(1071),
    [sym_pointer_expression] = STATE(1071),
    [sym_logical_expression] = STATE(1071),
    [sym_bitwise_expression] = STATE(1071),
    [sym_equality_expression] = STATE(1071),
    [sym_relational_expression] = STATE(1071),
    [sym_shift_expression] = STATE(1071),
    [sym_math_expression] = STATE(1071),
    [sym_cast_expression] = STATE(1071),
    [sym_sizeof_expression] = STATE(1071),
    [sym_subscript_expression] = STATE(1071),
    [sym_call_expression] = STATE(1071),
    [sym_field_expression] = STATE(1071),
    [sym_compound_literal_expression] = STATE(1071),
    [sym_parenthesized_expression] = STATE(1071),
    [sym_concatenated_string] = STATE(1071),
    [sym_macro_type_specifier] = STATE(388),
    [sym_class_specifier] = STATE(388),
    [sym_dependent_type] = STATE(388),
    [sym_template_type] = STATE(390),
    [sym_template_function] = STATE(1071),
    [sym_new_expression] = STATE(1071),
    [sym_delete_expression] = STATE(1071),
    [sym_lambda_expression] = STATE(1071),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(393),
    [sym_scoped_namespace_identifier] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [sym_raw_string_literal] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2056),
    [sym_char_literal] = ACTIONS(2056),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(608),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2060),
  },
  [543] = {
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_comment] = ACTIONS(49),
  },
  [544] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [545] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [546] = {
    [sym__type_specifier] = STATE(1074),
    [sym_sized_type_specifier] = STATE(1074),
    [sym_enum_specifier] = STATE(1074),
    [sym_struct_specifier] = STATE(1074),
    [sym_union_specifier] = STATE(1074),
    [sym_macro_type_specifier] = STATE(1074),
    [sym_class_specifier] = STATE(1074),
    [sym_dependent_type] = STATE(1074),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1075),
    [anon_sym_unsigned] = ACTIONS(2066),
    [anon_sym_long] = ACTIONS(2066),
    [anon_sym_short] = ACTIONS(2066),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2070),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [547] = {
    [sym_type_qualifier] = STATE(1076),
    [sym_trailing_return_type] = STATE(1076),
    [aux_sym_function_declarator_repeat1] = STATE(1076),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2072),
  },
  [548] = {
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_COMMA] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_COLON] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [sym_operator_name] = ACTIONS(2074),
  },
  [549] = {
    [sym__expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1077),
    [sym_assignment_expression] = STATE(1077),
    [sym_pointer_expression] = STATE(1077),
    [sym_logical_expression] = STATE(1077),
    [sym_bitwise_expression] = STATE(1077),
    [sym_equality_expression] = STATE(1077),
    [sym_relational_expression] = STATE(1077),
    [sym_shift_expression] = STATE(1077),
    [sym_math_expression] = STATE(1077),
    [sym_cast_expression] = STATE(1077),
    [sym_sizeof_expression] = STATE(1077),
    [sym_subscript_expression] = STATE(1077),
    [sym_call_expression] = STATE(1077),
    [sym_field_expression] = STATE(1077),
    [sym_compound_literal_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_delete_expression] = STATE(1077),
    [sym_lambda_expression] = STATE(1077),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2078),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(2078),
    [sym_char_literal] = ACTIONS(2078),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(2080),
  },
  [550] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [551] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(2084),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(49),
  },
  [552] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1085),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1086),
    [sym_type_definition] = STATE(1087),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1087),
    [sym_field_declaration] = STATE(1087),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1087),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1087),
    [sym_access_specifier] = STATE(1087),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1087),
    [sym_alias_declaration] = STATE(1087),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1087),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2086),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [553] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1089),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1090),
    [sym_type_definition] = STATE(1091),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1091),
    [sym_field_declaration] = STATE(1091),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1091),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1091),
    [sym_access_specifier] = STATE(1091),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1091),
    [sym_alias_declaration] = STATE(1091),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1091),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [554] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1093),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1094),
    [sym_type_definition] = STATE(1095),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1095),
    [sym_field_declaration] = STATE(1095),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1095),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1095),
    [sym_access_specifier] = STATE(1095),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1095),
    [sym_alias_declaration] = STATE(1095),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1095),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2094),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [555] = {
    [sym__type_declarator] = STATE(1096),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [556] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1097),
    [sym_sized_type_specifier] = STATE(1097),
    [sym_enum_specifier] = STATE(1097),
    [sym_struct_specifier] = STATE(1097),
    [sym_union_specifier] = STATE(1097),
    [sym_macro_type_specifier] = STATE(1097),
    [sym_class_specifier] = STATE(1097),
    [sym_dependent_type] = STATE(1097),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(2096),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [557] = {
    [sym_field_declaration_list] = STATE(277),
    [sym_base_class_clause] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_register] = ACTIONS(428),
    [anon_sym_inline] = ACTIONS(428),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(428),
    [anon_sym_volatile] = ACTIONS(428),
    [anon_sym__Atomic] = ACTIONS(428),
    [anon_sym_mutable] = ACTIONS(428),
    [anon_sym_explicit] = ACTIONS(428),
    [anon_sym_constexpr] = ACTIONS(428),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(430),
    [anon_sym_COLON_COLON] = ACTIONS(426),
    [sym_operator_name] = ACTIONS(426),
  },
  [558] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_register] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym__Atomic] = ACTIONS(440),
    [anon_sym_mutable] = ACTIONS(440),
    [anon_sym_explicit] = ACTIONS(440),
    [anon_sym_constexpr] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(442),
    [anon_sym_COLON_COLON] = ACTIONS(438),
    [sym_operator_name] = ACTIONS(438),
  },
  [559] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2098),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [560] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [561] = {
    [sym_field_declaration_list] = STATE(299),
    [sym_base_class_clause] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_extern] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(477),
    [anon_sym_volatile] = ACTIONS(477),
    [anon_sym__Atomic] = ACTIONS(477),
    [anon_sym_mutable] = ACTIONS(477),
    [anon_sym_explicit] = ACTIONS(477),
    [anon_sym_constexpr] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(477),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(479),
    [anon_sym_COLON_COLON] = ACTIONS(475),
    [sym_operator_name] = ACTIONS(475),
  },
  [562] = {
    [anon_sym_LPAREN] = ACTIONS(2100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2102),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2100),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2100),
    [anon_sym_typedef] = ACTIONS(2102),
    [anon_sym_extern] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_register] = ACTIONS(2102),
    [anon_sym_inline] = ACTIONS(2102),
    [anon_sym_const] = ACTIONS(2102),
    [anon_sym_restrict] = ACTIONS(2102),
    [anon_sym_volatile] = ACTIONS(2102),
    [anon_sym__Atomic] = ACTIONS(2102),
    [anon_sym_mutable] = ACTIONS(2102),
    [anon_sym_explicit] = ACTIONS(2102),
    [anon_sym_constexpr] = ACTIONS(2102),
    [anon_sym_unsigned] = ACTIONS(2102),
    [anon_sym_long] = ACTIONS(2102),
    [anon_sym_short] = ACTIONS(2102),
    [sym_primitive_type] = ACTIONS(2102),
    [anon_sym_enum] = ACTIONS(2102),
    [anon_sym_struct] = ACTIONS(2102),
    [anon_sym_union] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2102),
    [anon_sym_AMP_AMP] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2100),
    [sym_identifier] = ACTIONS(2102),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [sym_auto] = ACTIONS(2102),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(2102),
    [anon_sym_friend] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_using] = ACTIONS(2102),
    [anon_sym_COLON_COLON] = ACTIONS(2100),
    [sym_operator_name] = ACTIONS(2100),
  },
  [563] = {
    [sym_function_definition] = STATE(1099),
    [sym_declaration] = STATE(1099),
    [sym__declaration_specifiers] = STATE(1100),
    [sym_storage_class_specifier] = STATE(326),
    [sym_type_qualifier] = STATE(326),
    [sym__type_specifier] = STATE(325),
    [sym_sized_type_specifier] = STATE(325),
    [sym_enum_specifier] = STATE(325),
    [sym_struct_specifier] = STATE(325),
    [sym_union_specifier] = STATE(325),
    [sym__empty_declaration] = STATE(1099),
    [sym_macro_type_specifier] = STATE(325),
    [sym_class_specifier] = STATE(325),
    [sym_dependent_type] = STATE(325),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(326),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(513),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [564] = {
    [anon_sym_LPAREN] = ACTIONS(2104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2106),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2104),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2104),
    [anon_sym_typedef] = ACTIONS(2106),
    [anon_sym_extern] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2104),
    [anon_sym_STAR] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2106),
    [anon_sym_register] = ACTIONS(2106),
    [anon_sym_inline] = ACTIONS(2106),
    [anon_sym_const] = ACTIONS(2106),
    [anon_sym_restrict] = ACTIONS(2106),
    [anon_sym_volatile] = ACTIONS(2106),
    [anon_sym__Atomic] = ACTIONS(2106),
    [anon_sym_mutable] = ACTIONS(2106),
    [anon_sym_explicit] = ACTIONS(2106),
    [anon_sym_constexpr] = ACTIONS(2106),
    [anon_sym_unsigned] = ACTIONS(2106),
    [anon_sym_long] = ACTIONS(2106),
    [anon_sym_short] = ACTIONS(2106),
    [sym_primitive_type] = ACTIONS(2106),
    [anon_sym_enum] = ACTIONS(2106),
    [anon_sym_struct] = ACTIONS(2106),
    [anon_sym_union] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2106),
    [anon_sym_AMP_AMP] = ACTIONS(2104),
    [anon_sym_TILDE] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(2106),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2106),
    [anon_sym_public] = ACTIONS(2106),
    [sym_auto] = ACTIONS(2106),
    [anon_sym_typename] = ACTIONS(2106),
    [anon_sym_template] = ACTIONS(2106),
    [anon_sym_friend] = ACTIONS(2106),
    [anon_sym_private] = ACTIONS(2106),
    [anon_sym_protected] = ACTIONS(2106),
    [anon_sym_using] = ACTIONS(2106),
    [anon_sym_COLON_COLON] = ACTIONS(2104),
    [sym_operator_name] = ACTIONS(2104),
  },
  [565] = {
    [sym__declarator] = STATE(1101),
    [sym_pointer_declarator] = STATE(1101),
    [sym_function_declarator] = STATE(1101),
    [sym_array_declarator] = STATE(1101),
    [sym_init_declarator] = STATE(1102),
    [sym_reference_declarator] = STATE(1101),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1101),
    [sym_destructor_name] = STATE(1101),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2108),
  },
  [566] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [sym_operator_name] = ACTIONS(236),
  },
  [567] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(2112),
    [anon_sym_EQ] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [568] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(1107),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [569] = {
    [anon_sym_SEMI] = ACTIONS(2112),
    [sym_comment] = ACTIONS(49),
  },
  [570] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(541),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [571] = {
    [sym__field_declarator] = STATE(1110),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1110),
    [sym_scoped_field_identifier] = STATE(1111),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(2124),
  },
  [572] = {
    [anon_sym_LPAREN] = ACTIONS(2126),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2128),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2126),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2126),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2126),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2126),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2128),
    [anon_sym_extern] = ACTIONS(2128),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_register] = ACTIONS(2128),
    [anon_sym_inline] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_restrict] = ACTIONS(2128),
    [anon_sym_volatile] = ACTIONS(2128),
    [anon_sym__Atomic] = ACTIONS(2128),
    [anon_sym_mutable] = ACTIONS(2128),
    [anon_sym_explicit] = ACTIONS(2128),
    [anon_sym_constexpr] = ACTIONS(2128),
    [anon_sym_unsigned] = ACTIONS(2128),
    [anon_sym_long] = ACTIONS(2128),
    [anon_sym_short] = ACTIONS(2128),
    [sym_primitive_type] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
    [anon_sym_struct] = ACTIONS(2128),
    [anon_sym_union] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2128),
    [anon_sym_public] = ACTIONS(2128),
    [sym_auto] = ACTIONS(2128),
    [anon_sym_typename] = ACTIONS(2128),
    [anon_sym_template] = ACTIONS(2128),
    [anon_sym_friend] = ACTIONS(2128),
    [anon_sym_private] = ACTIONS(2128),
    [anon_sym_protected] = ACTIONS(2128),
    [anon_sym_using] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [sym_operator_name] = ACTIONS(2126),
  },
  [573] = {
    [sym__field_declarator] = STATE(1112),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1112),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(2130),
  },
  [574] = {
    [sym__expression] = STATE(1113),
    [sym_conditional_expression] = STATE(1113),
    [sym_assignment_expression] = STATE(1113),
    [sym_pointer_expression] = STATE(1113),
    [sym_logical_expression] = STATE(1113),
    [sym_bitwise_expression] = STATE(1113),
    [sym_equality_expression] = STATE(1113),
    [sym_relational_expression] = STATE(1113),
    [sym_shift_expression] = STATE(1113),
    [sym_math_expression] = STATE(1113),
    [sym_cast_expression] = STATE(1113),
    [sym_sizeof_expression] = STATE(1113),
    [sym_subscript_expression] = STATE(1113),
    [sym_call_expression] = STATE(1113),
    [sym_field_expression] = STATE(1113),
    [sym_compound_literal_expression] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_concatenated_string] = STATE(1113),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1113),
    [sym_new_expression] = STATE(1113),
    [sym_delete_expression] = STATE(1113),
    [sym_lambda_expression] = STATE(1113),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(2132),
    [sym_char_literal] = ACTIONS(2132),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_null] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(2134),
  },
  [575] = {
    [sym__field_declarator] = STATE(1114),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1114),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(2136),
  },
  [576] = {
    [sym_template_argument_list] = STATE(1116),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_COMMA] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_COLON] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2142),
  },
  [577] = {
    [sym_destructor_name] = STATE(959),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2144),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(1838),
  },
  [578] = {
    [sym_compound_statement] = STATE(1122),
    [sym_parameter_list] = STATE(1123),
    [aux_sym_field_declaration_repeat1] = STATE(1124),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(2152),
    [sym_comment] = ACTIONS(49),
  },
  [579] = {
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RPAREN] = ACTIONS(2154),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_COLON] = ACTIONS(2154),
    [sym_comment] = ACTIONS(49),
  },
  [580] = {
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_COLON] = ACTIONS(2156),
    [sym_comment] = ACTIONS(49),
  },
  [581] = {
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_COLON] = ACTIONS(2158),
    [sym_comment] = ACTIONS(49),
  },
  [582] = {
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RPAREN] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2160),
    [sym_comment] = ACTIONS(49),
  },
  [583] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2162),
  },
  [584] = {
    [sym_template_argument_list] = STATE(1127),
    [anon_sym_LT] = ACTIONS(2164),
    [sym_comment] = ACTIONS(49),
  },
  [585] = {
    [sym_type_qualifier] = STATE(1129),
    [sym_trailing_return_type] = STATE(1129),
    [aux_sym_function_declarator_repeat1] = STATE(1129),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(2166),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2168),
  },
  [586] = {
    [anon_sym_LPAREN] = ACTIONS(2170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2170),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_TILDE] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_friend] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2170),
    [sym_operator_name] = ACTIONS(2170),
  },
  [587] = {
    [sym_preproc_include] = STATE(1131),
    [sym_preproc_def] = STATE(1131),
    [sym_preproc_function_def] = STATE(1131),
    [sym_preproc_call] = STATE(1131),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1131),
    [sym_type_definition] = STATE(1131),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1131),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1131),
    [sym_expression_statement] = STATE(1131),
    [sym_if_statement] = STATE(1131),
    [sym_switch_statement] = STATE(1131),
    [sym_case_statement] = STATE(1131),
    [sym_while_statement] = STATE(1131),
    [sym_do_statement] = STATE(1131),
    [sym_for_statement] = STATE(1131),
    [sym_return_statement] = STATE(1131),
    [sym_break_statement] = STATE(1131),
    [sym_continue_statement] = STATE(1131),
    [sym_goto_statement] = STATE(1131),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(1131),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1131),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1131),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1131),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [588] = {
    [anon_sym_LPAREN] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(724),
    [anon_sym_typedef] = ACTIONS(726),
    [anon_sym_extern] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_register] = ACTIONS(726),
    [anon_sym_inline] = ACTIONS(726),
    [anon_sym_const] = ACTIONS(726),
    [anon_sym_restrict] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym__Atomic] = ACTIONS(726),
    [anon_sym_mutable] = ACTIONS(726),
    [anon_sym_explicit] = ACTIONS(726),
    [anon_sym_constexpr] = ACTIONS(726),
    [anon_sym_unsigned] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [sym_primitive_type] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(726),
    [anon_sym_union] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_public] = ACTIONS(726),
    [sym_auto] = ACTIONS(726),
    [anon_sym_typename] = ACTIONS(726),
    [anon_sym_template] = ACTIONS(726),
    [anon_sym_friend] = ACTIONS(726),
    [anon_sym_private] = ACTIONS(726),
    [anon_sym_protected] = ACTIONS(726),
    [anon_sym_using] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(724),
    [sym_operator_name] = ACTIONS(724),
  },
  [589] = {
    [sym_compound_statement] = STATE(1132),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(49),
  },
  [590] = {
    [sym_storage_class_specifier] = STATE(1133),
    [sym_type_qualifier] = STATE(1133),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1133),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [591] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(2176),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [592] = {
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RPAREN] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_COLON] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [sym_operator_name] = ACTIONS(2178),
  },
  [593] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(593),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(593),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(593),
    [sym_access_specifier] = STATE(593),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(593),
    [sym_alias_declaration] = STATE(593),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2188),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_restrict] = ACTIONS(2205),
    [anon_sym_volatile] = ACTIONS(2205),
    [anon_sym__Atomic] = ACTIONS(2205),
    [anon_sym_mutable] = ACTIONS(2205),
    [anon_sym_explicit] = ACTIONS(2205),
    [anon_sym_constexpr] = ACTIONS(2205),
    [anon_sym_unsigned] = ACTIONS(2208),
    [anon_sym_long] = ACTIONS(2208),
    [anon_sym_short] = ACTIONS(2208),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2217),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2238),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2241),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_friend] = ACTIONS(2247),
    [anon_sym_private] = ACTIONS(2238),
    [anon_sym_protected] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [sym_operator_name] = ACTIONS(2256),
  },
  [594] = {
    [sym_compound_statement] = STATE(1132),
    [sym_field_initializer_list] = STATE(1135),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [595] = {
    [sym_storage_class_specifier] = STATE(1136),
    [sym_type_qualifier] = STATE(1136),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1136),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [596] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(596),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [597] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1137),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [sym_comment] = ACTIONS(49),
  },
  [598] = {
    [sym__class_name] = STATE(1139),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(410),
    [sym_comment] = ACTIONS(49),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [599] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1140),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [sym_comment] = ACTIONS(49),
  },
  [600] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [sym_operator_name] = ACTIONS(1157),
  },
  [601] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1142),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(49),
  },
  [602] = {
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1188),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [603] = {
    [anon_sym_LPAREN] = ACTIONS(2268),
    [anon_sym_COMMA] = ACTIONS(2268),
    [anon_sym_RPAREN] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_GT] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [sym_operator_name] = ACTIONS(2268),
  },
  [604] = {
    [sym_field_declaration_list] = STATE(1143),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [605] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [606] = {
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2272),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2272),
    [sym_identifier] = ACTIONS(2274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [sym_operator_name] = ACTIONS(2272),
  },
  [607] = {
    [sym_field_declaration_list] = STATE(1144),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [608] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1145),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [609] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1463),
  },
  [610] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1515),
  },
  [611] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1519),
  },
  [612] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1523),
  },
  [613] = {
    [sym__expression] = STATE(1147),
    [sym_conditional_expression] = STATE(1147),
    [sym_assignment_expression] = STATE(1147),
    [sym_pointer_expression] = STATE(1147),
    [sym_logical_expression] = STATE(1147),
    [sym_bitwise_expression] = STATE(1147),
    [sym_equality_expression] = STATE(1147),
    [sym_relational_expression] = STATE(1147),
    [sym_shift_expression] = STATE(1147),
    [sym_math_expression] = STATE(1147),
    [sym_cast_expression] = STATE(1147),
    [sym_sizeof_expression] = STATE(1147),
    [sym_subscript_expression] = STATE(1147),
    [sym_call_expression] = STATE(1147),
    [sym_field_expression] = STATE(1147),
    [sym_compound_literal_expression] = STATE(1147),
    [sym_parenthesized_expression] = STATE(1147),
    [sym_concatenated_string] = STATE(1147),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1147),
    [sym_new_expression] = STATE(1147),
    [sym_delete_expression] = STATE(1147),
    [sym_lambda_expression] = STATE(1147),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(2276),
    [sym_char_literal] = ACTIONS(2276),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(2280),
  },
  [614] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1148),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(2282),
    [sym_comment] = ACTIONS(49),
  },
  [615] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [616] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2288),
    [sym_operator_name] = ACTIONS(198),
  },
  [617] = {
    [sym__expression] = STATE(1154),
    [sym_conditional_expression] = STATE(1154),
    [sym_assignment_expression] = STATE(1154),
    [sym_pointer_expression] = STATE(1154),
    [sym_logical_expression] = STATE(1154),
    [sym_bitwise_expression] = STATE(1154),
    [sym_equality_expression] = STATE(1154),
    [sym_relational_expression] = STATE(1154),
    [sym_shift_expression] = STATE(1154),
    [sym_math_expression] = STATE(1154),
    [sym_cast_expression] = STATE(1154),
    [sym_sizeof_expression] = STATE(1154),
    [sym_subscript_expression] = STATE(1154),
    [sym_call_expression] = STATE(1154),
    [sym_field_expression] = STATE(1154),
    [sym_compound_literal_expression] = STATE(1154),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_concatenated_string] = STATE(1154),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1154),
    [sym_new_expression] = STATE(1154),
    [sym_delete_expression] = STATE(1154),
    [sym_lambda_expression] = STATE(1154),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(2294),
    [sym_false] = ACTIONS(2294),
    [sym_null] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(2294),
  },
  [618] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2296),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [619] = {
    [anon_sym_RPAREN] = ACTIONS(2298),
    [sym_comment] = ACTIONS(49),
  },
  [620] = {
    [sym_initializer_list] = STATE(846),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
  },
  [621] = {
    [sym_initializer_list] = STATE(846),
    [sym_template_argument_list] = STATE(146),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [622] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
  },
  [623] = {
    [sym_field_declaration_list] = STATE(277),
    [sym_base_class_clause] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2330),
  },
  [624] = {
    [sym_template_argument_list] = STATE(282),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(432),
    [anon_sym_AMP] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(432),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(432),
  },
  [625] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2332),
  },
  [626] = {
    [sym_field_declaration_list] = STATE(299),
    [sym_base_class_clause] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2334),
  },
  [627] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym__abstract_declarator] = STATE(1172),
    [sym_abstract_pointer_declarator] = STATE(1172),
    [sym_abstract_function_declarator] = STATE(1172),
    [sym_abstract_array_declarator] = STATE(1172),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_list] = STATE(1173),
    [sym_parameter_declaration] = STATE(362),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_abstract_reference_declarator] = STATE(1172),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [628] = {
    [sym__abstract_declarator] = STATE(1174),
    [sym_abstract_pointer_declarator] = STATE(1174),
    [sym_abstract_function_declarator] = STATE(1174),
    [sym_abstract_array_declarator] = STATE(1174),
    [sym_parameter_list] = STATE(632),
    [sym_abstract_reference_declarator] = STATE(1174),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
  },
  [629] = {
    [sym__declaration_specifiers] = STATE(1176),
    [sym_storage_class_specifier] = STATE(395),
    [sym_type_qualifier] = STATE(395),
    [sym__type_specifier] = STATE(388),
    [sym_sized_type_specifier] = STATE(388),
    [sym_enum_specifier] = STATE(388),
    [sym_struct_specifier] = STATE(388),
    [sym_union_specifier] = STATE(388),
    [sym__expression] = STATE(1177),
    [sym_conditional_expression] = STATE(1177),
    [sym_assignment_expression] = STATE(1177),
    [sym_pointer_expression] = STATE(1177),
    [sym_logical_expression] = STATE(1177),
    [sym_bitwise_expression] = STATE(1177),
    [sym_equality_expression] = STATE(1177),
    [sym_relational_expression] = STATE(1177),
    [sym_shift_expression] = STATE(1177),
    [sym_math_expression] = STATE(1177),
    [sym_cast_expression] = STATE(1177),
    [sym_sizeof_expression] = STATE(1177),
    [sym_subscript_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_compound_literal_expression] = STATE(1177),
    [sym_parenthesized_expression] = STATE(1177),
    [sym_concatenated_string] = STATE(1177),
    [sym_macro_type_specifier] = STATE(388),
    [sym_class_specifier] = STATE(388),
    [sym_dependent_type] = STATE(388),
    [sym_template_type] = STATE(390),
    [sym_template_function] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_delete_expression] = STATE(1177),
    [sym_lambda_expression] = STATE(1177),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(393),
    [sym_scoped_namespace_identifier] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [sym_raw_string_literal] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2344),
    [sym_char_literal] = ACTIONS(2344),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(608),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2348),
  },
  [630] = {
    [sym__abstract_declarator] = STATE(1178),
    [sym_abstract_pointer_declarator] = STATE(1178),
    [sym_abstract_function_declarator] = STATE(1178),
    [sym_abstract_array_declarator] = STATE(1178),
    [sym_parameter_list] = STATE(632),
    [sym_abstract_reference_declarator] = STATE(1178),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
  },
  [631] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2352),
    [sym_comment] = ACTIONS(49),
  },
  [632] = {
    [sym_type_qualifier] = STATE(1183),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1183),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2358),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2360),
  },
  [633] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1184),
    [sym_parenthesized_expression] = STATE(1184),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [634] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_GT] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [sym_operator_name] = ACTIONS(2362),
  },
  [635] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(2366),
    [sym_comment] = ACTIONS(49),
  },
  [636] = {
    [sym__abstract_declarator] = STATE(1187),
    [sym_abstract_pointer_declarator] = STATE(1187),
    [sym_abstract_function_declarator] = STATE(1187),
    [sym_abstract_array_declarator] = STATE(1187),
    [sym_parameter_list] = STATE(632),
    [sym_abstract_reference_declarator] = STATE(1187),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(2352),
    [sym_comment] = ACTIONS(49),
  },
  [637] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(637),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(2368),
    [anon_sym_long] = ACTIONS(2368),
    [anon_sym_short] = ACTIONS(2368),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [638] = {
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [sym_operator_name] = ACTIONS(2371),
  },
  [639] = {
    [sym_field_declaration_list] = STATE(1188),
    [anon_sym_LBRACE] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
  },
  [640] = {
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [641] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [642] = {
    [sym_template_argument_list] = STATE(303),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(481),
    [sym_operator_name] = ACTIONS(146),
  },
  [643] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym_sized_type_specifier_repeat1] = STATE(314),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [644] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym__declarator] = STATE(45),
    [sym__abstract_declarator] = STATE(1172),
    [sym_pointer_declarator] = STATE(45),
    [sym_abstract_pointer_declarator] = STATE(1172),
    [sym_function_declarator] = STATE(45),
    [sym_abstract_function_declarator] = STATE(1172),
    [sym_array_declarator] = STATE(45),
    [sym_abstract_array_declarator] = STATE(1172),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_list] = STATE(1173),
    [sym_parameter_declaration] = STATE(362),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_reference_declarator] = STATE(45),
    [sym_abstract_reference_declarator] = STATE(1172),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(45),
    [sym_destructor_name] = STATE(45),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(79),
  },
  [645] = {
    [sym__declarator] = STATE(1192),
    [sym__abstract_declarator] = STATE(1174),
    [sym_pointer_declarator] = STATE(1192),
    [sym_abstract_pointer_declarator] = STATE(1174),
    [sym_function_declarator] = STATE(1192),
    [sym_abstract_function_declarator] = STATE(1174),
    [sym_array_declarator] = STATE(1192),
    [sym_abstract_array_declarator] = STATE(1174),
    [sym_parameter_list] = STATE(632),
    [sym_reference_declarator] = STATE(1192),
    [sym_abstract_reference_declarator] = STATE(1174),
    [sym_template_type] = STATE(652),
    [sym_template_function] = STATE(1192),
    [sym_destructor_name] = STATE(1192),
    [sym_scoped_identifier] = STATE(653),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(652),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(1222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1224),
    [sym_operator_name] = ACTIONS(2385),
  },
  [646] = {
    [sym__declarator] = STATE(1193),
    [sym__abstract_declarator] = STATE(1178),
    [sym_pointer_declarator] = STATE(1193),
    [sym_abstract_pointer_declarator] = STATE(1178),
    [sym_function_declarator] = STATE(1193),
    [sym_abstract_function_declarator] = STATE(1178),
    [sym_array_declarator] = STATE(1193),
    [sym_abstract_array_declarator] = STATE(1178),
    [sym_parameter_list] = STATE(632),
    [sym_reference_declarator] = STATE(1193),
    [sym_abstract_reference_declarator] = STATE(1178),
    [sym_template_type] = STATE(652),
    [sym_template_function] = STATE(1193),
    [sym_destructor_name] = STATE(1193),
    [sym_scoped_identifier] = STATE(653),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(652),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(1222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1224),
    [sym_operator_name] = ACTIONS(2387),
  },
  [647] = {
    [sym_template_argument_list] = STATE(161),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_COMMA] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_EQ] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(218),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2389),
  },
  [648] = {
    [sym_destructor_name] = STATE(1195),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(275),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(2391),
  },
  [649] = {
    [sym_parameter_list] = STATE(1199),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [anon_sym_LPAREN] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2395),
    [sym_comment] = ACTIONS(49),
  },
  [650] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2395),
    [sym_comment] = ACTIONS(49),
  },
  [651] = {
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_GT] = ACTIONS(2395),
    [sym_comment] = ACTIONS(49),
  },
  [652] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2401),
  },
  [653] = {
    [sym_template_argument_list] = STATE(1201),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_COMMA] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_EQ] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(150),
    [anon_sym_GT] = ACTIONS(218),
    [sym_comment] = ACTIONS(49),
  },
  [654] = {
    [sym_storage_class_specifier] = STATE(1202),
    [sym_type_qualifier] = STATE(1202),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1202),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [655] = {
    [sym__declaration_specifiers] = STATE(310),
    [sym_storage_class_specifier] = STATE(313),
    [sym_type_qualifier] = STATE(313),
    [sym__type_specifier] = STATE(311),
    [sym_sized_type_specifier] = STATE(311),
    [sym_enum_specifier] = STATE(311),
    [sym_struct_specifier] = STATE(311),
    [sym_union_specifier] = STATE(311),
    [sym_parameter_declaration] = STATE(1203),
    [sym_macro_type_specifier] = STATE(311),
    [sym_class_specifier] = STATE(311),
    [sym_dependent_type] = STATE(311),
    [sym_type_parameter_declaration] = STATE(1203),
    [sym_optional_type_parameter_declaration] = STATE(1203),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(313),
    [aux_sym_sized_type_specifier_repeat1] = STATE(314),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(497),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(497),
    [anon_sym_typename] = ACTIONS(501),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [656] = {
    [anon_sym_extern] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_register] = ACTIONS(2403),
    [anon_sym_inline] = ACTIONS(2403),
    [anon_sym_const] = ACTIONS(2403),
    [anon_sym_restrict] = ACTIONS(2403),
    [anon_sym_volatile] = ACTIONS(2403),
    [anon_sym__Atomic] = ACTIONS(2403),
    [anon_sym_mutable] = ACTIONS(2403),
    [anon_sym_explicit] = ACTIONS(2403),
    [anon_sym_constexpr] = ACTIONS(2403),
    [anon_sym_unsigned] = ACTIONS(2403),
    [anon_sym_long] = ACTIONS(2403),
    [anon_sym_short] = ACTIONS(2403),
    [sym_primitive_type] = ACTIONS(2403),
    [anon_sym_enum] = ACTIONS(2403),
    [anon_sym_struct] = ACTIONS(2403),
    [anon_sym_union] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(2403),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2403),
    [sym_auto] = ACTIONS(2403),
    [anon_sym_typename] = ACTIONS(2403),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
  },
  [657] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(1205),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_GT] = ACTIONS(2407),
    [sym_comment] = ACTIONS(49),
  },
  [658] = {
    [sym_storage_class_specifier] = STATE(1206),
    [sym_type_qualifier] = STATE(1206),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1206),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [659] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(659),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [660] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1183),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(2412),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2414),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [sym_operator_name] = ACTIONS(2412),
  },
  [662] = {
    [sym__type_specifier] = STATE(1208),
    [sym_sized_type_specifier] = STATE(1208),
    [sym_enum_specifier] = STATE(1208),
    [sym_struct_specifier] = STATE(1208),
    [sym_union_specifier] = STATE(1208),
    [sym_macro_type_specifier] = STATE(1208),
    [sym_class_specifier] = STATE(1208),
    [sym_dependent_type] = STATE(1208),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1209),
    [anon_sym_unsigned] = ACTIONS(2416),
    [anon_sym_long] = ACTIONS(2416),
    [anon_sym_short] = ACTIONS(2416),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [663] = {
    [sym_type_qualifier] = STATE(1210),
    [sym_trailing_return_type] = STATE(1210),
    [aux_sym_function_declarator_repeat1] = STATE(1210),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1244),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2422),
  },
  [664] = {
    [sym_storage_class_specifier] = STATE(664),
    [sym_type_qualifier] = STATE(664),
    [aux_sym__declaration_specifiers_repeat1] = STATE(664),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [665] = {
    [sym_storage_class_specifier] = STATE(1211),
    [sym_type_qualifier] = STATE(1211),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1211),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [666] = {
    [sym_storage_class_specifier] = STATE(1212),
    [sym_type_qualifier] = STATE(1212),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1212),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [667] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(667),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(2424),
    [anon_sym_long] = ACTIONS(2424),
    [anon_sym_short] = ACTIONS(2424),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [668] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [669] = {
    [sym_storage_class_specifier] = STATE(664),
    [sym_type_qualifier] = STATE(664),
    [aux_sym__declaration_specifiers_repeat1] = STATE(664),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2429),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [sym_operator_name] = ACTIONS(2427),
  },
  [671] = {
    [sym_preproc_include] = STATE(671),
    [sym_preproc_def] = STATE(671),
    [sym_preproc_function_def] = STATE(671),
    [sym_preproc_call] = STATE(671),
    [sym_preproc_if] = STATE(671),
    [sym_preproc_ifdef] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_type_definition] = STATE(671),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(671),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(671),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(671),
    [sym_template_declaration] = STATE(671),
    [sym_template_instantiation] = STATE(671),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(671),
    [sym_using_declaration] = STATE(671),
    [sym_alias_declaration] = STATE(671),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(671),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(752),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(758),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(764),
    [anon_sym_typedef] = ACTIONS(767),
    [anon_sym_extern] = ACTIONS(770),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(776),
    [anon_sym_register] = ACTIONS(776),
    [anon_sym_inline] = ACTIONS(776),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_restrict] = ACTIONS(779),
    [anon_sym_volatile] = ACTIONS(779),
    [anon_sym__Atomic] = ACTIONS(779),
    [anon_sym_mutable] = ACTIONS(779),
    [anon_sym_explicit] = ACTIONS(779),
    [anon_sym_constexpr] = ACTIONS(779),
    [anon_sym_unsigned] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(803),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(809),
    [sym_auto] = ACTIONS(785),
    [anon_sym_typename] = ACTIONS(812),
    [anon_sym_template] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(818),
    [anon_sym_using] = ACTIONS(821),
    [anon_sym_COLON_COLON] = ACTIONS(824),
    [sym_operator_name] = ACTIONS(827),
  },
  [672] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [673] = {
    [sym__abstract_declarator] = STATE(1215),
    [sym_abstract_pointer_declarator] = STATE(1215),
    [sym_abstract_function_declarator] = STATE(1215),
    [sym_abstract_array_declarator] = STATE(1215),
    [sym_parameter_list] = STATE(1216),
    [sym_abstract_reference_declarator] = STATE(1215),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [sym_comment] = ACTIONS(49),
  },
  [674] = {
    [anon_sym_SEMI] = ACTIONS(2437),
    [sym_comment] = ACTIONS(49),
  },
  [675] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1218),
    [sym_sized_type_specifier] = STATE(1218),
    [sym_enum_specifier] = STATE(1218),
    [sym_struct_specifier] = STATE(1218),
    [sym_union_specifier] = STATE(1218),
    [sym_macro_type_specifier] = STATE(1218),
    [sym_class_specifier] = STATE(1218),
    [sym_dependent_type] = STATE(1218),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [676] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1219),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(2441),
    [anon_sym_long] = ACTIONS(2441),
    [anon_sym_short] = ACTIONS(2441),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [677] = {
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2445),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [sym_operator_name] = ACTIONS(2443),
  },
  [679] = {
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2447),
    [sym_comment] = ACTIONS(49),
  },
  [681] = {
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2449),
    [anon_sym_EQ] = ACTIONS(2449),
    [sym_comment] = ACTIONS(49),
  },
  [682] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(1222),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_RBRACK] = ACTIONS(2451),
    [sym_comment] = ACTIONS(49),
  },
  [683] = {
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1431),
    [anon_sym_volatile] = ACTIONS(1431),
    [anon_sym__Atomic] = ACTIONS(1431),
    [anon_sym_mutable] = ACTIONS(1431),
    [anon_sym_explicit] = ACTIONS(1431),
    [anon_sym_constexpr] = ACTIONS(1431),
    [anon_sym_COLON] = ACTIONS(1431),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_DASH_GT] = ACTIONS(1431),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1431),
  },
  [684] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1224),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1537),
    [anon_sym_RPAREN] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [sym_operator_name] = ACTIONS(146),
  },
  [685] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2288),
    [sym_operator_name] = ACTIONS(198),
  },
  [686] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_argument_list_repeat1] = STATE(1228),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [687] = {
    [aux_sym_argument_list_repeat1] = STATE(1228),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(49),
  },
  [688] = {
    [sym_initializer_list] = STATE(846),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [sym_operator_name] = ACTIONS(236),
  },
  [689] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
  },
  [690] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [691] = {
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [sym_comment] = ACTIONS(49),
  },
  [692] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1230),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [693] = {
    [anon_sym_RBRACE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(49),
  },
  [694] = {
    [sym_preproc_include] = STATE(883),
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(883),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(883),
    [sym_expression_statement] = STATE(883),
    [sym_if_statement] = STATE(883),
    [sym_switch_statement] = STATE(883),
    [sym_case_statement] = STATE(883),
    [sym_while_statement] = STATE(883),
    [sym_do_statement] = STATE(883),
    [sym_for_statement] = STATE(883),
    [sym_return_statement] = STATE(883),
    [sym_break_statement] = STATE(883),
    [sym_continue_statement] = STATE(883),
    [sym_goto_statement] = STATE(883),
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(706),
    [sym__empty_declaration] = STATE(883),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(883),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(706),
    [sym_for_range_loop] = STATE(883),
    [sym_new_expression] = STATE(706),
    [sym_delete_expression] = STATE(706),
    [sym_lambda_expression] = STATE(706),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1315),
    [sym_char_literal] = ACTIONS(1315),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1343),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(2472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [696] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1463),
  },
  [697] = {
    [sym__expression] = STATE(1234),
    [sym_conditional_expression] = STATE(1234),
    [sym_assignment_expression] = STATE(1234),
    [sym_pointer_expression] = STATE(1234),
    [sym_logical_expression] = STATE(1234),
    [sym_bitwise_expression] = STATE(1234),
    [sym_equality_expression] = STATE(1234),
    [sym_relational_expression] = STATE(1234),
    [sym_shift_expression] = STATE(1234),
    [sym_math_expression] = STATE(1234),
    [sym_cast_expression] = STATE(1234),
    [sym_sizeof_expression] = STATE(1234),
    [sym_subscript_expression] = STATE(1234),
    [sym_call_expression] = STATE(1234),
    [sym_field_expression] = STATE(1234),
    [sym_compound_literal_expression] = STATE(1234),
    [sym_parenthesized_expression] = STATE(1234),
    [sym_concatenated_string] = STATE(1234),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_delete_expression] = STATE(1234),
    [sym_lambda_expression] = STATE(1234),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(2476),
    [sym_char_literal] = ACTIONS(2476),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(2478),
  },
  [698] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1515),
  },
  [699] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1519),
  },
  [700] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1523),
  },
  [701] = {
    [sym__expression] = STATE(1236),
    [sym_conditional_expression] = STATE(1236),
    [sym_assignment_expression] = STATE(1236),
    [sym_pointer_expression] = STATE(1236),
    [sym_logical_expression] = STATE(1236),
    [sym_bitwise_expression] = STATE(1236),
    [sym_equality_expression] = STATE(1236),
    [sym_relational_expression] = STATE(1236),
    [sym_shift_expression] = STATE(1236),
    [sym_math_expression] = STATE(1236),
    [sym_cast_expression] = STATE(1236),
    [sym_sizeof_expression] = STATE(1236),
    [sym_subscript_expression] = STATE(1236),
    [sym_call_expression] = STATE(1236),
    [sym_field_expression] = STATE(1236),
    [sym_compound_literal_expression] = STATE(1236),
    [sym_parenthesized_expression] = STATE(1236),
    [sym_concatenated_string] = STATE(1236),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_delete_expression] = STATE(1236),
    [sym_lambda_expression] = STATE(1236),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(2480),
    [sym_char_literal] = ACTIONS(2480),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [sym_null] = ACTIONS(2484),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(2484),
  },
  [702] = {
    [sym_identifier] = ACTIONS(2486),
    [sym_comment] = ACTIONS(49),
  },
  [703] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1238),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(2488),
    [sym_comment] = ACTIONS(49),
  },
  [704] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2490),
    [sym_operator_name] = ACTIONS(198),
  },
  [705] = {
    [sym__expression] = STATE(1241),
    [sym_conditional_expression] = STATE(1241),
    [sym_assignment_expression] = STATE(1241),
    [sym_pointer_expression] = STATE(1241),
    [sym_logical_expression] = STATE(1241),
    [sym_bitwise_expression] = STATE(1241),
    [sym_equality_expression] = STATE(1241),
    [sym_relational_expression] = STATE(1241),
    [sym_shift_expression] = STATE(1241),
    [sym_math_expression] = STATE(1241),
    [sym_cast_expression] = STATE(1241),
    [sym_sizeof_expression] = STATE(1241),
    [sym_subscript_expression] = STATE(1241),
    [sym_call_expression] = STATE(1241),
    [sym_field_expression] = STATE(1241),
    [sym_compound_literal_expression] = STATE(1241),
    [sym_parenthesized_expression] = STATE(1241),
    [sym_concatenated_string] = STATE(1241),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_delete_expression] = STATE(1241),
    [sym_lambda_expression] = STATE(1241),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(2492),
    [sym_char_literal] = ACTIONS(2492),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [sym_null] = ACTIONS(2496),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(2496),
  },
  [706] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_initializer_list_repeat1] = STATE(1255),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2504),
    [anon_sym_STAR_EQ] = ACTIONS(2506),
    [anon_sym_SLASH_EQ] = ACTIONS(2506),
    [anon_sym_PERCENT_EQ] = ACTIONS(2506),
    [anon_sym_PLUS_EQ] = ACTIONS(2506),
    [anon_sym_DASH_EQ] = ACTIONS(2506),
    [anon_sym_LT_LT_EQ] = ACTIONS(2506),
    [anon_sym_GT_GT_EQ] = ACTIONS(2506),
    [anon_sym_AMP_EQ] = ACTIONS(2506),
    [anon_sym_CARET_EQ] = ACTIONS(2506),
    [anon_sym_PIPE_EQ] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [707] = {
    [aux_sym_initializer_list_repeat1] = STATE(1255),
    [anon_sym_COMMA] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(49),
  },
  [708] = {
    [sym_subscript_designator] = STATE(1259),
    [sym_field_designator] = STATE(1259),
    [aux_sym_initializer_pair_repeat1] = STATE(1259),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(2532),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
  },
  [709] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1778),
    [sym_operator_name] = ACTIONS(198),
  },
  [710] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [711] = {
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_GT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(49),
  },
  [712] = {
    [sym__type_specifier] = STATE(1264),
    [sym_sized_type_specifier] = STATE(1264),
    [sym_enum_specifier] = STATE(1264),
    [sym_struct_specifier] = STATE(1264),
    [sym_union_specifier] = STATE(1264),
    [sym_macro_type_specifier] = STATE(1264),
    [sym_class_specifier] = STATE(1264),
    [sym_dependent_type] = STATE(1264),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1265),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2538),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(2538),
    [anon_sym_typename] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [713] = {
    [sym_type_qualifier] = STATE(1266),
    [sym_trailing_return_type] = STATE(1266),
    [aux_sym_function_declarator_repeat1] = STATE(1266),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_COMMA] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2548),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [sym_operator_name] = ACTIONS(2550),
  },
  [715] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2466),
    [sym_comment] = ACTIONS(49),
  },
  [716] = {
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2557),
    [anon_sym_RPAREN] = ACTIONS(2557),
    [anon_sym_SEMI] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_RBRACE] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_RBRACK] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_STAR_EQ] = ACTIONS(2557),
    [anon_sym_SLASH_EQ] = ACTIONS(2557),
    [anon_sym_PERCENT_EQ] = ACTIONS(2557),
    [anon_sym_PLUS_EQ] = ACTIONS(2557),
    [anon_sym_DASH_EQ] = ACTIONS(2557),
    [anon_sym_LT_LT_EQ] = ACTIONS(2557),
    [anon_sym_GT_GT_EQ] = ACTIONS(2557),
    [anon_sym_AMP_EQ] = ACTIONS(2557),
    [anon_sym_CARET_EQ] = ACTIONS(2557),
    [anon_sym_PIPE_EQ] = ACTIONS(2557),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_PIPE] = ACTIONS(2559),
    [anon_sym_CARET] = ACTIONS(2559),
    [anon_sym_EQ_EQ] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_GT] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_LT] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2559),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_PLUS] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [sym_comment] = ACTIONS(49),
  },
  [717] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1267),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [718] = {
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_EQ] = ACTIONS(2561),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_STAR_EQ] = ACTIONS(2472),
    [anon_sym_SLASH_EQ] = ACTIONS(2472),
    [anon_sym_PERCENT_EQ] = ACTIONS(2472),
    [anon_sym_PLUS_EQ] = ACTIONS(2472),
    [anon_sym_DASH_EQ] = ACTIONS(2472),
    [anon_sym_LT_LT_EQ] = ACTIONS(2472),
    [anon_sym_GT_GT_EQ] = ACTIONS(2472),
    [anon_sym_AMP_EQ] = ACTIONS(2472),
    [anon_sym_CARET_EQ] = ACTIONS(2472),
    [anon_sym_PIPE_EQ] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2561),
    [anon_sym_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2561),
    [anon_sym_GT] = ACTIONS(2561),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2561),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_PERCENT] = ACTIONS(2561),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_DASH_GT] = ACTIONS(2472),
    [sym_comment] = ACTIONS(49),
  },
  [719] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(1463),
  },
  [720] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(1515),
  },
  [721] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(1519),
  },
  [722] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(1523),
  },
  [723] = {
    [sym__expression] = STATE(1269),
    [sym_conditional_expression] = STATE(1269),
    [sym_assignment_expression] = STATE(1269),
    [sym_pointer_expression] = STATE(1269),
    [sym_logical_expression] = STATE(1269),
    [sym_bitwise_expression] = STATE(1269),
    [sym_equality_expression] = STATE(1269),
    [sym_relational_expression] = STATE(1269),
    [sym_shift_expression] = STATE(1269),
    [sym_math_expression] = STATE(1269),
    [sym_cast_expression] = STATE(1269),
    [sym_sizeof_expression] = STATE(1269),
    [sym_subscript_expression] = STATE(1269),
    [sym_call_expression] = STATE(1269),
    [sym_field_expression] = STATE(1269),
    [sym_compound_literal_expression] = STATE(1269),
    [sym_parenthesized_expression] = STATE(1269),
    [sym_concatenated_string] = STATE(1269),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_delete_expression] = STATE(1269),
    [sym_lambda_expression] = STATE(1269),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2563),
    [anon_sym_LPAREN] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(2563),
    [sym_char_literal] = ACTIONS(2563),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(2567),
  },
  [724] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1270),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(2569),
    [sym_comment] = ACTIONS(49),
  },
  [725] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2571),
    [sym_operator_name] = ACTIONS(198),
  },
  [726] = {
    [sym__expression] = STATE(1273),
    [sym_conditional_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(1273),
    [sym_pointer_expression] = STATE(1273),
    [sym_logical_expression] = STATE(1273),
    [sym_bitwise_expression] = STATE(1273),
    [sym_equality_expression] = STATE(1273),
    [sym_relational_expression] = STATE(1273),
    [sym_shift_expression] = STATE(1273),
    [sym_math_expression] = STATE(1273),
    [sym_cast_expression] = STATE(1273),
    [sym_sizeof_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_field_expression] = STATE(1273),
    [sym_compound_literal_expression] = STATE(1273),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_concatenated_string] = STATE(1273),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_delete_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(1273),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(2573),
    [sym_char_literal] = ACTIONS(2573),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(2577),
    [sym_false] = ACTIONS(2577),
    [sym_null] = ACTIONS(2577),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(2577),
  },
  [727] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_initializer_list_repeat1] = STATE(1255),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [728] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1286),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [729] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1463),
  },
  [730] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1515),
  },
  [731] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1519),
  },
  [732] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(1523),
  },
  [733] = {
    [sym__expression] = STATE(1288),
    [sym_conditional_expression] = STATE(1288),
    [sym_assignment_expression] = STATE(1288),
    [sym_pointer_expression] = STATE(1288),
    [sym_logical_expression] = STATE(1288),
    [sym_bitwise_expression] = STATE(1288),
    [sym_equality_expression] = STATE(1288),
    [sym_relational_expression] = STATE(1288),
    [sym_shift_expression] = STATE(1288),
    [sym_math_expression] = STATE(1288),
    [sym_cast_expression] = STATE(1288),
    [sym_sizeof_expression] = STATE(1288),
    [sym_subscript_expression] = STATE(1288),
    [sym_call_expression] = STATE(1288),
    [sym_field_expression] = STATE(1288),
    [sym_compound_literal_expression] = STATE(1288),
    [sym_parenthesized_expression] = STATE(1288),
    [sym_concatenated_string] = STATE(1288),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_delete_expression] = STATE(1288),
    [sym_lambda_expression] = STATE(1288),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(2607),
    [sym_char_literal] = ACTIONS(2607),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(2611),
    [sym_false] = ACTIONS(2611),
    [sym_null] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(2611),
  },
  [734] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1289),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(2613),
    [sym_comment] = ACTIONS(49),
  },
  [735] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2615),
    [sym_operator_name] = ACTIONS(198),
  },
  [736] = {
    [sym__expression] = STATE(1292),
    [sym_conditional_expression] = STATE(1292),
    [sym_assignment_expression] = STATE(1292),
    [sym_pointer_expression] = STATE(1292),
    [sym_logical_expression] = STATE(1292),
    [sym_bitwise_expression] = STATE(1292),
    [sym_equality_expression] = STATE(1292),
    [sym_relational_expression] = STATE(1292),
    [sym_shift_expression] = STATE(1292),
    [sym_math_expression] = STATE(1292),
    [sym_cast_expression] = STATE(1292),
    [sym_sizeof_expression] = STATE(1292),
    [sym_subscript_expression] = STATE(1292),
    [sym_call_expression] = STATE(1292),
    [sym_field_expression] = STATE(1292),
    [sym_compound_literal_expression] = STATE(1292),
    [sym_parenthesized_expression] = STATE(1292),
    [sym_concatenated_string] = STATE(1292),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_delete_expression] = STATE(1292),
    [sym_lambda_expression] = STATE(1292),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2617),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(2617),
    [sym_char_literal] = ACTIONS(2617),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [sym_null] = ACTIONS(2621),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(2621),
  },
  [737] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [738] = {
    [anon_sym_SEMI] = ACTIONS(2623),
    [sym_comment] = ACTIONS(49),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [sym_operator_name] = ACTIONS(2653),
  },
  [740] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [741] = {
    [anon_sym_SEMI] = ACTIONS(2657),
    [sym_comment] = ACTIONS(49),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [sym_operator_name] = ACTIONS(2659),
  },
  [743] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_declaration] = STATE(1307),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [744] = {
    [anon_sym_LPAREN] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_RPAREN] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_EQ] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2667),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_COLON] = ACTIONS(2665),
    [anon_sym_GT] = ACTIONS(2665),
    [anon_sym_DASH_GT] = ACTIONS(2665),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2665),
  },
  [745] = {
    [aux_sym_parameter_list_repeat1] = STATE(1309),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [sym_comment] = ACTIONS(49),
  },
  [746] = {
    [sym__declarator] = STATE(1310),
    [sym__abstract_declarator] = STATE(1311),
    [sym_pointer_declarator] = STATE(1310),
    [sym_abstract_pointer_declarator] = STATE(1311),
    [sym_function_declarator] = STATE(1310),
    [sym_abstract_function_declarator] = STATE(1311),
    [sym_array_declarator] = STATE(1310),
    [sym_abstract_array_declarator] = STATE(1311),
    [sym_parameter_list] = STATE(750),
    [sym_reference_declarator] = STATE(1310),
    [sym_abstract_reference_declarator] = STATE(1311),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1310),
    [sym_destructor_name] = STATE(1310),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2671),
  },
  [747] = {
    [sym__declarator] = STATE(1312),
    [sym__abstract_declarator] = STATE(1313),
    [sym_pointer_declarator] = STATE(1312),
    [sym_abstract_pointer_declarator] = STATE(1313),
    [sym_function_declarator] = STATE(1312),
    [sym_abstract_function_declarator] = STATE(1313),
    [sym_array_declarator] = STATE(1312),
    [sym_abstract_array_declarator] = STATE(1313),
    [sym_parameter_list] = STATE(750),
    [sym_reference_declarator] = STATE(1312),
    [sym_abstract_reference_declarator] = STATE(1313),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1312),
    [sym_destructor_name] = STATE(1312),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2673),
  },
  [748] = {
    [sym_parameter_list] = STATE(1315),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(2675),
    [sym_comment] = ACTIONS(49),
  },
  [749] = {
    [sym_parameter_list] = STATE(1316),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [750] = {
    [sym_type_qualifier] = STATE(1318),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1318),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2677),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2679),
  },
  [751] = {
    [sym_storage_class_specifier] = STATE(1319),
    [sym_type_qualifier] = STATE(1319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1319),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [752] = {
    [sym_storage_class_specifier] = STATE(1320),
    [sym_type_qualifier] = STATE(1320),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1320),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [sym_operator_name] = ACTIONS(728),
  },
  [753] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(753),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [sym_operator_name] = ACTIONS(848),
  },
  [754] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
  },
  [755] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [756] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2288),
    [sym_operator_name] = ACTIONS(198),
  },
  [757] = {
    [sym__abstract_declarator] = STATE(1321),
    [sym_abstract_pointer_declarator] = STATE(1321),
    [sym_abstract_function_declarator] = STATE(1321),
    [sym_abstract_array_declarator] = STATE(1321),
    [sym_parameter_list] = STATE(1173),
    [sym_abstract_reference_declarator] = STATE(1321),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_comment] = ACTIONS(49),
  },
  [758] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2296),
    [anon_sym_RPAREN] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [759] = {
    [anon_sym_RPAREN] = ACTIONS(2684),
    [sym_comment] = ACTIONS(49),
  },
  [760] = {
    [anon_sym_RPAREN] = ACTIONS(2686),
    [sym_comment] = ACTIONS(49),
  },
  [761] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1324),
    [sym_sized_type_specifier] = STATE(1324),
    [sym_enum_specifier] = STATE(1324),
    [sym_struct_specifier] = STATE(1324),
    [sym_union_specifier] = STATE(1324),
    [sym_macro_type_specifier] = STATE(1324),
    [sym_class_specifier] = STATE(1324),
    [sym_dependent_type] = STATE(1324),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(2688),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [762] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1325),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(2690),
    [anon_sym_long] = ACTIONS(2690),
    [anon_sym_short] = ACTIONS(2690),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [763] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1562),
    [sym_operator_name] = ACTIONS(198),
  },
  [764] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_QMARK] = ACTIONS(2692),
    [anon_sym_STAR_EQ] = ACTIONS(2692),
    [anon_sym_SLASH_EQ] = ACTIONS(2692),
    [anon_sym_PERCENT_EQ] = ACTIONS(2692),
    [anon_sym_PLUS_EQ] = ACTIONS(2692),
    [anon_sym_DASH_EQ] = ACTIONS(2692),
    [anon_sym_LT_LT_EQ] = ACTIONS(2692),
    [anon_sym_GT_GT_EQ] = ACTIONS(2692),
    [anon_sym_AMP_EQ] = ACTIONS(2692),
    [anon_sym_CARET_EQ] = ACTIONS(2692),
    [anon_sym_PIPE_EQ] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_CARET] = ACTIONS(2694),
    [anon_sym_EQ_EQ] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_LT_EQ] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2694),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [765] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1326),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [766] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1463),
  },
  [767] = {
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [sym_comment] = ACTIONS(49),
  },
  [768] = {
    [anon_sym_RBRACK] = ACTIONS(2700),
    [sym_comment] = ACTIONS(49),
  },
  [769] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1463),
  },
  [770] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1515),
  },
  [771] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1519),
  },
  [772] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1523),
  },
  [773] = {
    [sym__expression] = STATE(1328),
    [sym_conditional_expression] = STATE(1328),
    [sym_assignment_expression] = STATE(1328),
    [sym_pointer_expression] = STATE(1328),
    [sym_logical_expression] = STATE(1328),
    [sym_bitwise_expression] = STATE(1328),
    [sym_equality_expression] = STATE(1328),
    [sym_relational_expression] = STATE(1328),
    [sym_shift_expression] = STATE(1328),
    [sym_math_expression] = STATE(1328),
    [sym_cast_expression] = STATE(1328),
    [sym_sizeof_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_field_expression] = STATE(1328),
    [sym_compound_literal_expression] = STATE(1328),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(1328),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_delete_expression] = STATE(1328),
    [sym_lambda_expression] = STATE(1328),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(2702),
    [sym_char_literal] = ACTIONS(2702),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(2706),
  },
  [774] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1329),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(2708),
    [sym_comment] = ACTIONS(49),
  },
  [775] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2710),
    [sym_operator_name] = ACTIONS(198),
  },
  [776] = {
    [sym__expression] = STATE(1332),
    [sym_conditional_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(1332),
    [sym_pointer_expression] = STATE(1332),
    [sym_logical_expression] = STATE(1332),
    [sym_bitwise_expression] = STATE(1332),
    [sym_equality_expression] = STATE(1332),
    [sym_relational_expression] = STATE(1332),
    [sym_shift_expression] = STATE(1332),
    [sym_math_expression] = STATE(1332),
    [sym_cast_expression] = STATE(1332),
    [sym_sizeof_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_call_expression] = STATE(1332),
    [sym_field_expression] = STATE(1332),
    [sym_compound_literal_expression] = STATE(1332),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_concatenated_string] = STATE(1332),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_delete_expression] = STATE(1332),
    [sym_lambda_expression] = STATE(1332),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(2712),
    [sym_char_literal] = ACTIONS(2712),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(2716),
  },
  [777] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2722),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_STAR_EQ] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2728),
    [anon_sym_GT_GT_EQ] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [778] = {
    [anon_sym_RBRACK] = ACTIONS(2722),
    [sym_comment] = ACTIONS(49),
  },
  [779] = {
    [sym_enumerator] = STATE(1350),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [780] = {
    [sym_enumerator_list] = STATE(1351),
    [sym_raw_string_literal] = ACTIONS(366),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_RBRACK] = ACTIONS(366),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_register] = ACTIONS(368),
    [anon_sym_inline] = ACTIONS(368),
    [anon_sym_const] = ACTIONS(368),
    [anon_sym_restrict] = ACTIONS(368),
    [anon_sym_volatile] = ACTIONS(368),
    [anon_sym__Atomic] = ACTIONS(368),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_explicit] = ACTIONS(368),
    [anon_sym_constexpr] = ACTIONS(368),
    [anon_sym_AMP] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(366),
    [anon_sym_TILDE] = ACTIONS(366),
    [anon_sym_PLUS] = ACTIONS(368),
    [anon_sym_DASH] = ACTIONS(368),
    [anon_sym_DASH_DASH] = ACTIONS(366),
    [anon_sym_PLUS_PLUS] = ACTIONS(366),
    [anon_sym_sizeof] = ACTIONS(368),
    [sym_number_literal] = ACTIONS(366),
    [sym_char_literal] = ACTIONS(366),
    [sym_string_literal] = ACTIONS(366),
    [sym_true] = ACTIONS(368),
    [sym_false] = ACTIONS(368),
    [sym_null] = ACTIONS(368),
    [sym_identifier] = ACTIONS(368),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(366),
    [anon_sym_delete] = ACTIONS(368),
    [sym_nullptr] = ACTIONS(368),
  },
  [781] = {
    [sym_raw_string_literal] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_extern] = ACTIONS(372),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_RBRACK] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(372),
    [anon_sym_register] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(372),
    [anon_sym_const] = ACTIONS(372),
    [anon_sym_restrict] = ACTIONS(372),
    [anon_sym_volatile] = ACTIONS(372),
    [anon_sym__Atomic] = ACTIONS(372),
    [anon_sym_mutable] = ACTIONS(372),
    [anon_sym_explicit] = ACTIONS(372),
    [anon_sym_constexpr] = ACTIONS(372),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(370),
    [anon_sym_TILDE] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_DASH_DASH] = ACTIONS(370),
    [anon_sym_PLUS_PLUS] = ACTIONS(370),
    [anon_sym_sizeof] = ACTIONS(372),
    [sym_number_literal] = ACTIONS(370),
    [sym_char_literal] = ACTIONS(370),
    [sym_string_literal] = ACTIONS(370),
    [sym_true] = ACTIONS(372),
    [sym_false] = ACTIONS(372),
    [sym_null] = ACTIONS(372),
    [sym_identifier] = ACTIONS(372),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(372),
    [anon_sym_COLON_COLON] = ACTIONS(370),
    [anon_sym_delete] = ACTIONS(372),
    [sym_nullptr] = ACTIONS(372),
  },
  [782] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(1353),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1353),
    [sym_field_declaration] = STATE(1353),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1353),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1353),
    [sym_access_specifier] = STATE(1353),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1353),
    [sym_alias_declaration] = STATE(1353),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1353),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [783] = {
    [sym_template_argument_list] = STATE(1356),
    [sym_raw_string_literal] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_extern] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(414),
    [anon_sym_RBRACK] = ACTIONS(414),
    [anon_sym_static] = ACTIONS(416),
    [anon_sym_register] = ACTIONS(416),
    [anon_sym_inline] = ACTIONS(416),
    [anon_sym_const] = ACTIONS(416),
    [anon_sym_restrict] = ACTIONS(416),
    [anon_sym_volatile] = ACTIONS(416),
    [anon_sym__Atomic] = ACTIONS(416),
    [anon_sym_mutable] = ACTIONS(416),
    [anon_sym_explicit] = ACTIONS(416),
    [anon_sym_constexpr] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(414),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(414),
    [anon_sym_PLUS_PLUS] = ACTIONS(414),
    [anon_sym_sizeof] = ACTIONS(416),
    [sym_number_literal] = ACTIONS(414),
    [sym_char_literal] = ACTIONS(414),
    [sym_string_literal] = ACTIONS(414),
    [sym_true] = ACTIONS(416),
    [sym_false] = ACTIONS(416),
    [sym_null] = ACTIONS(416),
    [sym_identifier] = ACTIONS(416),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(416),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_delete] = ACTIONS(416),
    [sym_nullptr] = ACTIONS(416),
  },
  [784] = {
    [sym_field_declaration_list] = STATE(1357),
    [sym_base_class_clause] = STATE(1358),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2760),
    [sym_comment] = ACTIONS(49),
  },
  [786] = {
    [sym_raw_string_literal] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_RBRACK] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_register] = ACTIONS(428),
    [anon_sym_inline] = ACTIONS(428),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(428),
    [anon_sym_volatile] = ACTIONS(428),
    [anon_sym__Atomic] = ACTIONS(428),
    [anon_sym_mutable] = ACTIONS(428),
    [anon_sym_explicit] = ACTIONS(428),
    [anon_sym_constexpr] = ACTIONS(428),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(428),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(426),
    [anon_sym_sizeof] = ACTIONS(428),
    [sym_number_literal] = ACTIONS(426),
    [sym_char_literal] = ACTIONS(426),
    [sym_string_literal] = ACTIONS(426),
    [sym_true] = ACTIONS(428),
    [sym_false] = ACTIONS(428),
    [sym_null] = ACTIONS(428),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(428),
    [anon_sym_COLON_COLON] = ACTIONS(426),
    [anon_sym_delete] = ACTIONS(428),
    [sym_nullptr] = ACTIONS(428),
  },
  [787] = {
    [sym_field_declaration_list] = STATE(1357),
    [sym_base_class_clause] = STATE(1358),
    [sym_raw_string_literal] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_RBRACK] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_register] = ACTIONS(428),
    [anon_sym_inline] = ACTIONS(428),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(428),
    [anon_sym_volatile] = ACTIONS(428),
    [anon_sym__Atomic] = ACTIONS(428),
    [anon_sym_mutable] = ACTIONS(428),
    [anon_sym_explicit] = ACTIONS(428),
    [anon_sym_constexpr] = ACTIONS(428),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(428),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(426),
    [anon_sym_sizeof] = ACTIONS(428),
    [sym_number_literal] = ACTIONS(426),
    [sym_char_literal] = ACTIONS(426),
    [sym_string_literal] = ACTIONS(426),
    [sym_true] = ACTIONS(428),
    [sym_false] = ACTIONS(428),
    [sym_null] = ACTIONS(428),
    [sym_identifier] = ACTIONS(428),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(428),
    [anon_sym_COLON_COLON] = ACTIONS(426),
    [anon_sym_delete] = ACTIONS(428),
    [sym_nullptr] = ACTIONS(428),
  },
  [788] = {
    [sym_field_declaration_list] = STATE(1357),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [789] = {
    [sym_raw_string_literal] = ACTIONS(432),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_RBRACK] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_register] = ACTIONS(434),
    [anon_sym_inline] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym__Atomic] = ACTIONS(434),
    [anon_sym_mutable] = ACTIONS(434),
    [anon_sym_explicit] = ACTIONS(434),
    [anon_sym_constexpr] = ACTIONS(434),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(432),
    [anon_sym_BANG] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(432),
    [anon_sym_sizeof] = ACTIONS(434),
    [sym_number_literal] = ACTIONS(432),
    [sym_char_literal] = ACTIONS(432),
    [sym_string_literal] = ACTIONS(432),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_COLON_COLON] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(434),
    [sym_nullptr] = ACTIONS(434),
  },
  [790] = {
    [sym_template_argument_list] = STATE(1362),
    [sym_raw_string_literal] = ACTIONS(432),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_RBRACK] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_register] = ACTIONS(434),
    [anon_sym_inline] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym__Atomic] = ACTIONS(434),
    [anon_sym_mutable] = ACTIONS(434),
    [anon_sym_explicit] = ACTIONS(434),
    [anon_sym_constexpr] = ACTIONS(434),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(432),
    [anon_sym_BANG] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(432),
    [anon_sym_sizeof] = ACTIONS(434),
    [sym_number_literal] = ACTIONS(432),
    [sym_char_literal] = ACTIONS(432),
    [sym_string_literal] = ACTIONS(432),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_identifier] = ACTIONS(434),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(434),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_COLON_COLON] = ACTIONS(432),
    [anon_sym_delete] = ACTIONS(434),
    [sym_nullptr] = ACTIONS(434),
  },
  [791] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2764),
  },
  [792] = {
    [sym_field_declaration_list] = STATE(1363),
    [sym_base_class_clause] = STATE(1364),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [793] = {
    [sym_raw_string_literal] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_RBRACK] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_register] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym__Atomic] = ACTIONS(440),
    [anon_sym_mutable] = ACTIONS(440),
    [anon_sym_explicit] = ACTIONS(440),
    [anon_sym_constexpr] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_DASH_DASH] = ACTIONS(438),
    [anon_sym_PLUS_PLUS] = ACTIONS(438),
    [anon_sym_sizeof] = ACTIONS(440),
    [sym_number_literal] = ACTIONS(438),
    [sym_char_literal] = ACTIONS(438),
    [sym_string_literal] = ACTIONS(438),
    [sym_true] = ACTIONS(440),
    [sym_false] = ACTIONS(440),
    [sym_null] = ACTIONS(440),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(440),
    [anon_sym_COLON_COLON] = ACTIONS(438),
    [anon_sym_delete] = ACTIONS(440),
    [sym_nullptr] = ACTIONS(440),
  },
  [794] = {
    [sym_field_declaration_list] = STATE(1363),
    [sym_base_class_clause] = STATE(1364),
    [sym_raw_string_literal] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_RBRACK] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_register] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym__Atomic] = ACTIONS(440),
    [anon_sym_mutable] = ACTIONS(440),
    [anon_sym_explicit] = ACTIONS(440),
    [anon_sym_constexpr] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_DASH_DASH] = ACTIONS(438),
    [anon_sym_PLUS_PLUS] = ACTIONS(438),
    [anon_sym_sizeof] = ACTIONS(440),
    [sym_number_literal] = ACTIONS(438),
    [sym_char_literal] = ACTIONS(438),
    [sym_string_literal] = ACTIONS(438),
    [sym_true] = ACTIONS(440),
    [sym_false] = ACTIONS(440),
    [sym_null] = ACTIONS(440),
    [sym_identifier] = ACTIONS(440),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2766),
    [anon_sym_new] = ACTIONS(440),
    [anon_sym_COLON_COLON] = ACTIONS(438),
    [anon_sym_delete] = ACTIONS(440),
    [sym_nullptr] = ACTIONS(440),
  },
  [795] = {
    [sym_field_declaration_list] = STATE(1363),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [796] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_RPAREN] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [anon_sym_STAR] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_STAR_EQ] = ACTIONS(2768),
    [anon_sym_SLASH_EQ] = ACTIONS(2768),
    [anon_sym_PERCENT_EQ] = ACTIONS(2768),
    [anon_sym_PLUS_EQ] = ACTIONS(2768),
    [anon_sym_DASH_EQ] = ACTIONS(2768),
    [anon_sym_LT_LT_EQ] = ACTIONS(2768),
    [anon_sym_GT_GT_EQ] = ACTIONS(2768),
    [anon_sym_AMP_EQ] = ACTIONS(2768),
    [anon_sym_CARET_EQ] = ACTIONS(2768),
    [anon_sym_PIPE_EQ] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2770),
    [anon_sym_CARET] = ACTIONS(2770),
    [anon_sym_EQ_EQ] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_LT_EQ] = ACTIONS(2768),
    [anon_sym_GT_EQ] = ACTIONS(2768),
    [anon_sym_LT_LT] = ACTIONS(2770),
    [anon_sym_GT_GT] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [797] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [anon_sym_EQ] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2772),
    [anon_sym_STAR_EQ] = ACTIONS(2772),
    [anon_sym_SLASH_EQ] = ACTIONS(2772),
    [anon_sym_PERCENT_EQ] = ACTIONS(2772),
    [anon_sym_PLUS_EQ] = ACTIONS(2772),
    [anon_sym_DASH_EQ] = ACTIONS(2772),
    [anon_sym_LT_LT_EQ] = ACTIONS(2772),
    [anon_sym_GT_GT_EQ] = ACTIONS(2772),
    [anon_sym_AMP_EQ] = ACTIONS(2772),
    [anon_sym_CARET_EQ] = ACTIONS(2772),
    [anon_sym_PIPE_EQ] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_CARET] = ACTIONS(2774),
    [anon_sym_EQ_EQ] = ACTIONS(2772),
    [anon_sym_BANG_EQ] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_LT_EQ] = ACTIONS(2772),
    [anon_sym_GT_EQ] = ACTIONS(2772),
    [anon_sym_LT_LT] = ACTIONS(2774),
    [anon_sym_GT_GT] = ACTIONS(2774),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [798] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2776),
    [anon_sym_RPAREN] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_STAR] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2776),
    [anon_sym_EQ] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2776),
    [anon_sym_STAR_EQ] = ACTIONS(2776),
    [anon_sym_SLASH_EQ] = ACTIONS(2776),
    [anon_sym_PERCENT_EQ] = ACTIONS(2776),
    [anon_sym_PLUS_EQ] = ACTIONS(2776),
    [anon_sym_DASH_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_GT_EQ] = ACTIONS(2776),
    [anon_sym_AMP_EQ] = ACTIONS(2776),
    [anon_sym_CARET_EQ] = ACTIONS(2776),
    [anon_sym_PIPE_EQ] = ACTIONS(2776),
    [anon_sym_AMP] = ACTIONS(2778),
    [anon_sym_PIPE_PIPE] = ACTIONS(2776),
    [anon_sym_AMP_AMP] = ACTIONS(2776),
    [anon_sym_PIPE] = ACTIONS(2778),
    [anon_sym_CARET] = ACTIONS(2778),
    [anon_sym_EQ_EQ] = ACTIONS(2776),
    [anon_sym_BANG_EQ] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_GT] = ACTIONS(2778),
    [anon_sym_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT] = ACTIONS(2778),
    [anon_sym_GT_GT] = ACTIONS(2778),
    [anon_sym_PLUS] = ACTIONS(2778),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_PERCENT] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [799] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1366),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [800] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [801] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1367),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(2788),
    [sym_comment] = ACTIONS(49),
  },
  [802] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1369),
    [sym_parenthesized_expression] = STATE(1369),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [803] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2792),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [804] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_RPAREN] = ACTIONS(2794),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_STAR] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_RBRACK] = ACTIONS(2794),
    [anon_sym_EQ] = ACTIONS(2796),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_QMARK] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2796),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2796),
    [anon_sym_CARET] = ACTIONS(2796),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2796),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_PERCENT] = ACTIONS(2796),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DOT] = ACTIONS(2794),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [sym_comment] = ACTIONS(49),
  },
  [805] = {
    [sym_raw_string_literal] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(2798),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(468),
    [anon_sym_PLUS_PLUS] = ACTIONS(468),
    [anon_sym_sizeof] = ACTIONS(473),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_number_literal] = ACTIONS(471),
    [sym_char_literal] = ACTIONS(471),
    [sym_string_literal] = ACTIONS(471),
    [sym_true] = ACTIONS(473),
    [sym_false] = ACTIONS(473),
    [sym_null] = ACTIONS(473),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(473),
    [sym_nullptr] = ACTIONS(473),
  },
  [806] = {
    [sym_field_declaration_list] = STATE(1371),
    [sym_base_class_clause] = STATE(1372),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [807] = {
    [sym_raw_string_literal] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_extern] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_RBRACK] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(477),
    [anon_sym_volatile] = ACTIONS(477),
    [anon_sym__Atomic] = ACTIONS(477),
    [anon_sym_mutable] = ACTIONS(477),
    [anon_sym_explicit] = ACTIONS(477),
    [anon_sym_constexpr] = ACTIONS(477),
    [anon_sym_AMP] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(475),
    [anon_sym_PLUS_PLUS] = ACTIONS(475),
    [anon_sym_sizeof] = ACTIONS(477),
    [sym_number_literal] = ACTIONS(475),
    [sym_char_literal] = ACTIONS(475),
    [sym_string_literal] = ACTIONS(475),
    [sym_true] = ACTIONS(477),
    [sym_false] = ACTIONS(477),
    [sym_null] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(477),
    [anon_sym_COLON_COLON] = ACTIONS(475),
    [anon_sym_delete] = ACTIONS(477),
    [sym_nullptr] = ACTIONS(477),
  },
  [808] = {
    [sym_field_declaration_list] = STATE(1371),
    [sym_base_class_clause] = STATE(1372),
    [sym_raw_string_literal] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_extern] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_RBRACK] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(477),
    [anon_sym_volatile] = ACTIONS(477),
    [anon_sym__Atomic] = ACTIONS(477),
    [anon_sym_mutable] = ACTIONS(477),
    [anon_sym_explicit] = ACTIONS(477),
    [anon_sym_constexpr] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(475),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(475),
    [anon_sym_PLUS_PLUS] = ACTIONS(475),
    [anon_sym_sizeof] = ACTIONS(477),
    [sym_number_literal] = ACTIONS(475),
    [sym_char_literal] = ACTIONS(475),
    [sym_string_literal] = ACTIONS(475),
    [sym_true] = ACTIONS(477),
    [sym_false] = ACTIONS(477),
    [sym_null] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(477),
    [anon_sym_COLON_COLON] = ACTIONS(475),
    [anon_sym_delete] = ACTIONS(477),
    [sym_nullptr] = ACTIONS(477),
  },
  [809] = {
    [sym_field_declaration_list] = STATE(1371),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [810] = {
    [sym_template_argument_list] = STATE(1375),
    [sym_raw_string_literal] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_RBRACK] = ACTIONS(146),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(146),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_PLUS] = ACTIONS(148),
    [anon_sym_DASH] = ACTIONS(148),
    [anon_sym_DASH_DASH] = ACTIONS(146),
    [anon_sym_PLUS_PLUS] = ACTIONS(146),
    [anon_sym_sizeof] = ACTIONS(148),
    [sym_number_literal] = ACTIONS(146),
    [sym_char_literal] = ACTIONS(146),
    [sym_string_literal] = ACTIONS(146),
    [sym_true] = ACTIONS(148),
    [sym_false] = ACTIONS(148),
    [sym_null] = ACTIONS(148),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(148),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(148),
    [sym_nullptr] = ACTIONS(148),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2805),
    [sym_comment] = ACTIONS(49),
  },
  [812] = {
    [sym_raw_string_literal] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_extern] = ACTIONS(487),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(485),
    [anon_sym_static] = ACTIONS(487),
    [anon_sym_register] = ACTIONS(487),
    [anon_sym_inline] = ACTIONS(487),
    [anon_sym_const] = ACTIONS(487),
    [anon_sym_restrict] = ACTIONS(487),
    [anon_sym_volatile] = ACTIONS(487),
    [anon_sym__Atomic] = ACTIONS(487),
    [anon_sym_mutable] = ACTIONS(487),
    [anon_sym_explicit] = ACTIONS(487),
    [anon_sym_constexpr] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(485),
    [anon_sym_BANG] = ACTIONS(485),
    [anon_sym_TILDE] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_sizeof] = ACTIONS(487),
    [sym_number_literal] = ACTIONS(485),
    [sym_char_literal] = ACTIONS(485),
    [sym_string_literal] = ACTIONS(485),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(487),
    [sym_identifier] = ACTIONS(487),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(487),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym_delete] = ACTIONS(487),
    [sym_nullptr] = ACTIONS(487),
  },
  [813] = {
    [sym_raw_string_literal] = ACTIONS(236),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(236),
    [anon_sym_BANG] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_sizeof] = ACTIONS(238),
    [sym_number_literal] = ACTIONS(236),
    [sym_char_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(236),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_null] = ACTIONS(238),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(238),
    [sym_nullptr] = ACTIONS(238),
  },
  [814] = {
    [sym_template_argument_list] = STATE(854),
    [sym_raw_string_literal] = ACTIONS(236),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(236),
    [anon_sym_BANG] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_sizeof] = ACTIONS(238),
    [sym_number_literal] = ACTIONS(236),
    [sym_char_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(236),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_null] = ACTIONS(238),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [anon_sym_delete] = ACTIONS(238),
    [sym_nullptr] = ACTIONS(238),
  },
  [815] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
  },
  [816] = {
    [sym_argument_list] = STATE(1379),
    [sym_initializer_list] = STATE(1379),
    [sym_template_argument_list] = STATE(212),
    [sym_new_declarator] = STATE(1380),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(335),
  },
  [817] = {
    [sym_template_type] = STATE(64),
    [sym_scoped_type_identifier] = STATE(1382),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(2811),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [818] = {
    [sym_argument_list] = STATE(1383),
    [sym_initializer_list] = STATE(1383),
    [sym_template_argument_list] = STATE(146),
    [sym_new_declarator] = STATE(1384),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [819] = {
    [sym_identifier] = ACTIONS(2813),
    [sym_comment] = ACTIONS(49),
  },
  [820] = {
    [sym_raw_string_literal] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(550),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_sizeof] = ACTIONS(546),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_number_literal] = ACTIONS(544),
    [sym_char_literal] = ACTIONS(544),
    [sym_string_literal] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_null] = ACTIONS(546),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [anon_sym_delete] = ACTIONS(546),
    [sym_nullptr] = ACTIONS(546),
  },
  [821] = {
    [sym__expression] = STATE(1387),
    [sym_conditional_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(1387),
    [sym_pointer_expression] = STATE(1387),
    [sym_logical_expression] = STATE(1387),
    [sym_bitwise_expression] = STATE(1387),
    [sym_equality_expression] = STATE(1387),
    [sym_relational_expression] = STATE(1387),
    [sym_shift_expression] = STATE(1387),
    [sym_math_expression] = STATE(1387),
    [sym_cast_expression] = STATE(1387),
    [sym_sizeof_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_call_expression] = STATE(1387),
    [sym_field_expression] = STATE(1387),
    [sym_compound_literal_expression] = STATE(1387),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_concatenated_string] = STATE(1387),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1387),
    [sym_new_expression] = STATE(1387),
    [sym_delete_expression] = STATE(1387),
    [sym_lambda_expression] = STATE(1387),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2818),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2818),
    [sym_char_literal] = ACTIONS(2818),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2822),
    [sym_false] = ACTIONS(2822),
    [sym_null] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2822),
  },
  [822] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [823] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [824] = {
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(2830),
    [anon_sym_COLON] = ACTIONS(2830),
    [anon_sym_GT] = ACTIONS(2830),
    [sym_comment] = ACTIONS(49),
  },
  [825] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2832),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [826] = {
    [sym_raw_string_literal] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_static] = ACTIONS(115),
    [anon_sym_register] = ACTIONS(115),
    [anon_sym_inline] = ACTIONS(115),
    [anon_sym_const] = ACTIONS(115),
    [anon_sym_restrict] = ACTIONS(115),
    [anon_sym_volatile] = ACTIONS(115),
    [anon_sym__Atomic] = ACTIONS(115),
    [anon_sym_mutable] = ACTIONS(115),
    [anon_sym_explicit] = ACTIONS(115),
    [anon_sym_constexpr] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_TILDE] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(113),
    [anon_sym_sizeof] = ACTIONS(115),
    [sym_number_literal] = ACTIONS(113),
    [sym_char_literal] = ACTIONS(113),
    [sym_string_literal] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_null] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_delete] = ACTIONS(115),
    [sym_nullptr] = ACTIONS(115),
  },
  [827] = {
    [sym_raw_string_literal] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(121),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(121),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_register] = ACTIONS(123),
    [anon_sym_inline] = ACTIONS(123),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_restrict] = ACTIONS(123),
    [anon_sym_volatile] = ACTIONS(123),
    [anon_sym__Atomic] = ACTIONS(123),
    [anon_sym_mutable] = ACTIONS(123),
    [anon_sym_explicit] = ACTIONS(123),
    [anon_sym_constexpr] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_DASH_DASH] = ACTIONS(121),
    [anon_sym_PLUS_PLUS] = ACTIONS(121),
    [anon_sym_sizeof] = ACTIONS(123),
    [sym_number_literal] = ACTIONS(121),
    [sym_char_literal] = ACTIONS(121),
    [sym_string_literal] = ACTIONS(121),
    [sym_true] = ACTIONS(123),
    [sym_false] = ACTIONS(123),
    [sym_null] = ACTIONS(123),
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(123),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_delete] = ACTIONS(123),
    [sym_nullptr] = ACTIONS(123),
  },
  [828] = {
    [sym_storage_class_specifier] = STATE(1390),
    [sym_type_qualifier] = STATE(1390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1390),
    [sym_raw_string_literal] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_RBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_register] = ACTIONS(1576),
    [anon_sym_inline] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_restrict] = ACTIONS(1578),
    [anon_sym_volatile] = ACTIONS(1578),
    [anon_sym__Atomic] = ACTIONS(1578),
    [anon_sym_mutable] = ACTIONS(1578),
    [anon_sym_explicit] = ACTIONS(1578),
    [anon_sym_constexpr] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_DASH_DASH] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(728),
    [anon_sym_sizeof] = ACTIONS(730),
    [sym_number_literal] = ACTIONS(728),
    [sym_char_literal] = ACTIONS(728),
    [sym_string_literal] = ACTIONS(728),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [anon_sym_delete] = ACTIONS(730),
    [sym_nullptr] = ACTIONS(730),
  },
  [829] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2836),
  },
  [830] = {
    [sym__expression] = STATE(1392),
    [sym_conditional_expression] = STATE(1392),
    [sym_assignment_expression] = STATE(1392),
    [sym_pointer_expression] = STATE(1392),
    [sym_logical_expression] = STATE(1392),
    [sym_bitwise_expression] = STATE(1392),
    [sym_equality_expression] = STATE(1392),
    [sym_relational_expression] = STATE(1392),
    [sym_shift_expression] = STATE(1392),
    [sym_math_expression] = STATE(1392),
    [sym_cast_expression] = STATE(1392),
    [sym_sizeof_expression] = STATE(1392),
    [sym_subscript_expression] = STATE(1392),
    [sym_call_expression] = STATE(1392),
    [sym_field_expression] = STATE(1392),
    [sym_compound_literal_expression] = STATE(1392),
    [sym_parenthesized_expression] = STATE(1392),
    [sym_concatenated_string] = STATE(1392),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_delete_expression] = STATE(1392),
    [sym_lambda_expression] = STATE(1392),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2838),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2838),
    [sym_char_literal] = ACTIONS(2838),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2840),
  },
  [831] = {
    [sym__expression] = STATE(1393),
    [sym_conditional_expression] = STATE(1393),
    [sym_assignment_expression] = STATE(1393),
    [sym_pointer_expression] = STATE(1393),
    [sym_logical_expression] = STATE(1393),
    [sym_bitwise_expression] = STATE(1393),
    [sym_equality_expression] = STATE(1393),
    [sym_relational_expression] = STATE(1393),
    [sym_shift_expression] = STATE(1393),
    [sym_math_expression] = STATE(1393),
    [sym_cast_expression] = STATE(1393),
    [sym_sizeof_expression] = STATE(1393),
    [sym_subscript_expression] = STATE(1393),
    [sym_call_expression] = STATE(1393),
    [sym_field_expression] = STATE(1393),
    [sym_compound_literal_expression] = STATE(1393),
    [sym_parenthesized_expression] = STATE(1393),
    [sym_concatenated_string] = STATE(1393),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1393),
    [sym_new_expression] = STATE(1393),
    [sym_delete_expression] = STATE(1393),
    [sym_lambda_expression] = STATE(1393),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2842),
    [sym_char_literal] = ACTIONS(2842),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2844),
  },
  [832] = {
    [sym__expression] = STATE(1394),
    [sym_conditional_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_pointer_expression] = STATE(1394),
    [sym_logical_expression] = STATE(1394),
    [sym_bitwise_expression] = STATE(1394),
    [sym_equality_expression] = STATE(1394),
    [sym_relational_expression] = STATE(1394),
    [sym_shift_expression] = STATE(1394),
    [sym_math_expression] = STATE(1394),
    [sym_cast_expression] = STATE(1394),
    [sym_sizeof_expression] = STATE(1394),
    [sym_subscript_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_field_expression] = STATE(1394),
    [sym_compound_literal_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_concatenated_string] = STATE(1394),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1394),
    [sym_new_expression] = STATE(1394),
    [sym_delete_expression] = STATE(1394),
    [sym_lambda_expression] = STATE(1394),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2846),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(2846),
    [sym_char_literal] = ACTIONS(2846),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(2848),
  },
  [833] = {
    [sym__expression] = STATE(1395),
    [sym_conditional_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1395),
    [sym_pointer_expression] = STATE(1395),
    [sym_logical_expression] = STATE(1395),
    [sym_bitwise_expression] = STATE(1395),
    [sym_equality_expression] = STATE(1395),
    [sym_relational_expression] = STATE(1395),
    [sym_shift_expression] = STATE(1395),
    [sym_math_expression] = STATE(1395),
    [sym_cast_expression] = STATE(1395),
    [sym_sizeof_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_call_expression] = STATE(1395),
    [sym_field_expression] = STATE(1395),
    [sym_compound_literal_expression] = STATE(1395),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_concatenated_string] = STATE(1395),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1395),
    [sym_new_expression] = STATE(1395),
    [sym_delete_expression] = STATE(1395),
    [sym_lambda_expression] = STATE(1395),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2850),
    [sym_char_literal] = ACTIONS(2850),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2852),
  },
  [834] = {
    [sym__expression] = STATE(1396),
    [sym_conditional_expression] = STATE(1396),
    [sym_assignment_expression] = STATE(1396),
    [sym_pointer_expression] = STATE(1396),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1396),
    [sym_equality_expression] = STATE(1396),
    [sym_relational_expression] = STATE(1396),
    [sym_shift_expression] = STATE(1396),
    [sym_math_expression] = STATE(1396),
    [sym_cast_expression] = STATE(1396),
    [sym_sizeof_expression] = STATE(1396),
    [sym_subscript_expression] = STATE(1396),
    [sym_call_expression] = STATE(1396),
    [sym_field_expression] = STATE(1396),
    [sym_compound_literal_expression] = STATE(1396),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_concatenated_string] = STATE(1396),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1396),
    [sym_new_expression] = STATE(1396),
    [sym_delete_expression] = STATE(1396),
    [sym_lambda_expression] = STATE(1396),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2854),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2854),
    [sym_char_literal] = ACTIONS(2854),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2856),
  },
  [835] = {
    [sym__expression] = STATE(1397),
    [sym_conditional_expression] = STATE(1397),
    [sym_assignment_expression] = STATE(1397),
    [sym_pointer_expression] = STATE(1397),
    [sym_logical_expression] = STATE(1397),
    [sym_bitwise_expression] = STATE(1397),
    [sym_equality_expression] = STATE(1397),
    [sym_relational_expression] = STATE(1397),
    [sym_shift_expression] = STATE(1397),
    [sym_math_expression] = STATE(1397),
    [sym_cast_expression] = STATE(1397),
    [sym_sizeof_expression] = STATE(1397),
    [sym_subscript_expression] = STATE(1397),
    [sym_call_expression] = STATE(1397),
    [sym_field_expression] = STATE(1397),
    [sym_compound_literal_expression] = STATE(1397),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_concatenated_string] = STATE(1397),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1397),
    [sym_new_expression] = STATE(1397),
    [sym_delete_expression] = STATE(1397),
    [sym_lambda_expression] = STATE(1397),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2858),
    [sym_char_literal] = ACTIONS(2858),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2860),
  },
  [836] = {
    [sym__expression] = STATE(1398),
    [sym_conditional_expression] = STATE(1398),
    [sym_assignment_expression] = STATE(1398),
    [sym_pointer_expression] = STATE(1398),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1398),
    [sym_equality_expression] = STATE(1398),
    [sym_relational_expression] = STATE(1398),
    [sym_shift_expression] = STATE(1398),
    [sym_math_expression] = STATE(1398),
    [sym_cast_expression] = STATE(1398),
    [sym_sizeof_expression] = STATE(1398),
    [sym_subscript_expression] = STATE(1398),
    [sym_call_expression] = STATE(1398),
    [sym_field_expression] = STATE(1398),
    [sym_compound_literal_expression] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1398),
    [sym_concatenated_string] = STATE(1398),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1398),
    [sym_new_expression] = STATE(1398),
    [sym_delete_expression] = STATE(1398),
    [sym_lambda_expression] = STATE(1398),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2862),
    [sym_char_literal] = ACTIONS(2862),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2864),
  },
  [837] = {
    [sym__expression] = STATE(1399),
    [sym_conditional_expression] = STATE(1399),
    [sym_assignment_expression] = STATE(1399),
    [sym_pointer_expression] = STATE(1399),
    [sym_logical_expression] = STATE(1399),
    [sym_bitwise_expression] = STATE(1399),
    [sym_equality_expression] = STATE(1399),
    [sym_relational_expression] = STATE(1399),
    [sym_shift_expression] = STATE(1399),
    [sym_math_expression] = STATE(1399),
    [sym_cast_expression] = STATE(1399),
    [sym_sizeof_expression] = STATE(1399),
    [sym_subscript_expression] = STATE(1399),
    [sym_call_expression] = STATE(1399),
    [sym_field_expression] = STATE(1399),
    [sym_compound_literal_expression] = STATE(1399),
    [sym_parenthesized_expression] = STATE(1399),
    [sym_concatenated_string] = STATE(1399),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1399),
    [sym_new_expression] = STATE(1399),
    [sym_delete_expression] = STATE(1399),
    [sym_lambda_expression] = STATE(1399),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2866),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2866),
    [sym_char_literal] = ACTIONS(2866),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2868),
  },
  [838] = {
    [sym__expression] = STATE(1400),
    [sym_conditional_expression] = STATE(1400),
    [sym_assignment_expression] = STATE(1400),
    [sym_pointer_expression] = STATE(1400),
    [sym_logical_expression] = STATE(1400),
    [sym_bitwise_expression] = STATE(1400),
    [sym_equality_expression] = STATE(1400),
    [sym_relational_expression] = STATE(1400),
    [sym_shift_expression] = STATE(1400),
    [sym_math_expression] = STATE(1400),
    [sym_cast_expression] = STATE(1400),
    [sym_sizeof_expression] = STATE(1400),
    [sym_subscript_expression] = STATE(1400),
    [sym_call_expression] = STATE(1400),
    [sym_field_expression] = STATE(1400),
    [sym_compound_literal_expression] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1400),
    [sym_concatenated_string] = STATE(1400),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1400),
    [sym_new_expression] = STATE(1400),
    [sym_delete_expression] = STATE(1400),
    [sym_lambda_expression] = STATE(1400),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2870),
    [sym_char_literal] = ACTIONS(2870),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2872),
  },
  [839] = {
    [sym__expression] = STATE(1401),
    [sym_conditional_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(1401),
    [sym_pointer_expression] = STATE(1401),
    [sym_logical_expression] = STATE(1401),
    [sym_bitwise_expression] = STATE(1401),
    [sym_equality_expression] = STATE(1401),
    [sym_relational_expression] = STATE(1401),
    [sym_shift_expression] = STATE(1401),
    [sym_math_expression] = STATE(1401),
    [sym_cast_expression] = STATE(1401),
    [sym_sizeof_expression] = STATE(1401),
    [sym_subscript_expression] = STATE(1401),
    [sym_call_expression] = STATE(1401),
    [sym_field_expression] = STATE(1401),
    [sym_compound_literal_expression] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1401),
    [sym_concatenated_string] = STATE(1401),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1401),
    [sym_new_expression] = STATE(1401),
    [sym_delete_expression] = STATE(1401),
    [sym_lambda_expression] = STATE(1401),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2874),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2874),
    [sym_char_literal] = ACTIONS(2874),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2876),
  },
  [840] = {
    [sym__expression] = STATE(1402),
    [sym_conditional_expression] = STATE(1402),
    [sym_assignment_expression] = STATE(1402),
    [sym_pointer_expression] = STATE(1402),
    [sym_logical_expression] = STATE(1402),
    [sym_bitwise_expression] = STATE(1402),
    [sym_equality_expression] = STATE(1402),
    [sym_relational_expression] = STATE(1402),
    [sym_shift_expression] = STATE(1402),
    [sym_math_expression] = STATE(1402),
    [sym_cast_expression] = STATE(1402),
    [sym_sizeof_expression] = STATE(1402),
    [sym_subscript_expression] = STATE(1402),
    [sym_call_expression] = STATE(1402),
    [sym_field_expression] = STATE(1402),
    [sym_compound_literal_expression] = STATE(1402),
    [sym_parenthesized_expression] = STATE(1402),
    [sym_concatenated_string] = STATE(1402),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1402),
    [sym_new_expression] = STATE(1402),
    [sym_delete_expression] = STATE(1402),
    [sym_lambda_expression] = STATE(1402),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2878),
    [sym_char_literal] = ACTIONS(2878),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2880),
    [sym_false] = ACTIONS(2880),
    [sym_null] = ACTIONS(2880),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2880),
  },
  [841] = {
    [sym__expression] = STATE(1403),
    [sym_conditional_expression] = STATE(1403),
    [sym_assignment_expression] = STATE(1403),
    [sym_pointer_expression] = STATE(1403),
    [sym_logical_expression] = STATE(1403),
    [sym_bitwise_expression] = STATE(1403),
    [sym_equality_expression] = STATE(1403),
    [sym_relational_expression] = STATE(1403),
    [sym_shift_expression] = STATE(1403),
    [sym_math_expression] = STATE(1403),
    [sym_cast_expression] = STATE(1403),
    [sym_sizeof_expression] = STATE(1403),
    [sym_subscript_expression] = STATE(1403),
    [sym_call_expression] = STATE(1403),
    [sym_field_expression] = STATE(1403),
    [sym_compound_literal_expression] = STATE(1403),
    [sym_parenthesized_expression] = STATE(1403),
    [sym_concatenated_string] = STATE(1403),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1403),
    [sym_new_expression] = STATE(1403),
    [sym_delete_expression] = STATE(1403),
    [sym_lambda_expression] = STATE(1403),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(2882),
    [sym_char_literal] = ACTIONS(2882),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(2884),
    [sym_false] = ACTIONS(2884),
    [sym_null] = ACTIONS(2884),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(2884),
  },
  [842] = {
    [anon_sym_LPAREN] = ACTIONS(2776),
    [anon_sym_COMMA] = ACTIONS(2776),
    [anon_sym_RPAREN] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_STAR] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(2776),
    [anon_sym_RBRACK] = ACTIONS(2776),
    [anon_sym_EQ] = ACTIONS(2778),
    [anon_sym_COLON] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2776),
    [anon_sym_STAR_EQ] = ACTIONS(2776),
    [anon_sym_SLASH_EQ] = ACTIONS(2776),
    [anon_sym_PERCENT_EQ] = ACTIONS(2776),
    [anon_sym_PLUS_EQ] = ACTIONS(2776),
    [anon_sym_DASH_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_GT_EQ] = ACTIONS(2776),
    [anon_sym_AMP_EQ] = ACTIONS(2776),
    [anon_sym_CARET_EQ] = ACTIONS(2776),
    [anon_sym_PIPE_EQ] = ACTIONS(2776),
    [anon_sym_AMP] = ACTIONS(2778),
    [anon_sym_PIPE_PIPE] = ACTIONS(2776),
    [anon_sym_AMP_AMP] = ACTIONS(2776),
    [anon_sym_PIPE] = ACTIONS(2778),
    [anon_sym_CARET] = ACTIONS(2778),
    [anon_sym_EQ_EQ] = ACTIONS(2776),
    [anon_sym_BANG_EQ] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_GT] = ACTIONS(2778),
    [anon_sym_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT] = ACTIONS(2778),
    [anon_sym_GT_GT] = ACTIONS(2778),
    [anon_sym_PLUS] = ACTIONS(2778),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_PERCENT] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2776),
    [anon_sym_DOT] = ACTIONS(2776),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_comment] = ACTIONS(49),
  },
  [843] = {
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1405),
    [sym_destructor_name] = STATE(1405),
    [sym_scoped_field_identifier] = STATE(1406),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2886),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
  },
  [844] = {
    [anon_sym_LPAREN] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2888),
    [anon_sym_RPAREN] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_STAR] = ACTIONS(2890),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2890),
    [anon_sym_COLON] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2888),
    [anon_sym_STAR_EQ] = ACTIONS(2888),
    [anon_sym_SLASH_EQ] = ACTIONS(2888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2888),
    [anon_sym_DASH_EQ] = ACTIONS(2888),
    [anon_sym_LT_LT_EQ] = ACTIONS(2888),
    [anon_sym_GT_GT_EQ] = ACTIONS(2888),
    [anon_sym_AMP_EQ] = ACTIONS(2888),
    [anon_sym_CARET_EQ] = ACTIONS(2888),
    [anon_sym_PIPE_EQ] = ACTIONS(2888),
    [anon_sym_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2888),
    [anon_sym_AMP_AMP] = ACTIONS(2888),
    [anon_sym_PIPE] = ACTIONS(2890),
    [anon_sym_CARET] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2888),
    [anon_sym_BANG_EQ] = ACTIONS(2888),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_LT_EQ] = ACTIONS(2888),
    [anon_sym_GT_EQ] = ACTIONS(2888),
    [anon_sym_LT_LT] = ACTIONS(2890),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2890),
    [anon_sym_DASH] = ACTIONS(2890),
    [anon_sym_SLASH] = ACTIONS(2890),
    [anon_sym_PERCENT] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2888),
    [anon_sym_DOT] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2888),
    [sym_comment] = ACTIONS(49),
  },
  [845] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2892),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [846] = {
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_CARET] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_SLASH] = ACTIONS(2896),
    [anon_sym_PERCENT] = ACTIONS(2896),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DOT] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [sym_comment] = ACTIONS(49),
  },
  [847] = {
    [sym__abstract_declarator] = STATE(1408),
    [sym_abstract_pointer_declarator] = STATE(1408),
    [sym_abstract_function_declarator] = STATE(1408),
    [sym_abstract_array_declarator] = STATE(1408),
    [sym_parameter_list] = STATE(1409),
    [sym_abstract_reference_declarator] = STATE(1408),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1618),
    [anon_sym_AMP_AMP] = ACTIONS(1620),
    [sym_comment] = ACTIONS(49),
  },
  [848] = {
    [sym__abstract_declarator] = STATE(1408),
    [sym_abstract_pointer_declarator] = STATE(1408),
    [sym_abstract_function_declarator] = STATE(1408),
    [sym_abstract_array_declarator] = STATE(1408),
    [sym_parameter_list] = STATE(1409),
    [sym_abstract_reference_declarator] = STATE(1408),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1618),
    [anon_sym_AMP_AMP] = ACTIONS(1620),
    [sym_comment] = ACTIONS(49),
  },
  [849] = {
    [sym_parameter_list] = STATE(1410),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [850] = {
    [sym_compound_statement] = STATE(1411),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [sym_comment] = ACTIONS(49),
  },
  [851] = {
    [sym_type_qualifier] = STATE(1413),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1413),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2900),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2902),
  },
  [852] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1415),
    [sym_parenthesized_expression] = STATE(1415),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(2904),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [853] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1417),
    [sym_parenthesized_expression] = STATE(1417),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(2906),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [854] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [sym_string_literal] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [anon_sym_delete] = ACTIONS(742),
    [sym_nullptr] = ACTIONS(742),
  },
  [855] = {
    [sym_storage_class_specifier] = STATE(1418),
    [sym_type_qualifier] = STATE(1418),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1418),
    [sym_raw_string_literal] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_extern] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_RBRACK] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_register] = ACTIONS(1576),
    [anon_sym_inline] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_restrict] = ACTIONS(1578),
    [anon_sym_volatile] = ACTIONS(1578),
    [anon_sym__Atomic] = ACTIONS(1578),
    [anon_sym_mutable] = ACTIONS(1578),
    [anon_sym_explicit] = ACTIONS(1578),
    [anon_sym_constexpr] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_DASH_DASH] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(728),
    [anon_sym_sizeof] = ACTIONS(730),
    [sym_number_literal] = ACTIONS(728),
    [sym_char_literal] = ACTIONS(728),
    [sym_string_literal] = ACTIONS(728),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_identifier] = ACTIONS(730),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [anon_sym_delete] = ACTIONS(730),
    [sym_nullptr] = ACTIONS(730),
  },
  [856] = {
    [sym_raw_string_literal] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_extern] = ACTIONS(842),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_RBRACK] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_register] = ACTIONS(842),
    [anon_sym_inline] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(842),
    [anon_sym_restrict] = ACTIONS(842),
    [anon_sym_volatile] = ACTIONS(842),
    [anon_sym__Atomic] = ACTIONS(842),
    [anon_sym_mutable] = ACTIONS(842),
    [anon_sym_explicit] = ACTIONS(842),
    [anon_sym_constexpr] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(840),
    [anon_sym_sizeof] = ACTIONS(842),
    [sym_number_literal] = ACTIONS(840),
    [sym_char_literal] = ACTIONS(840),
    [sym_string_literal] = ACTIONS(840),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_null] = ACTIONS(842),
    [sym_identifier] = ACTIONS(842),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(842),
    [anon_sym_COLON_COLON] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(842),
    [sym_nullptr] = ACTIONS(842),
  },
  [857] = {
    [sym_raw_string_literal] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_extern] = ACTIONS(846),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(844),
    [anon_sym_RBRACK] = ACTIONS(844),
    [anon_sym_static] = ACTIONS(846),
    [anon_sym_register] = ACTIONS(846),
    [anon_sym_inline] = ACTIONS(846),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_restrict] = ACTIONS(846),
    [anon_sym_volatile] = ACTIONS(846),
    [anon_sym__Atomic] = ACTIONS(846),
    [anon_sym_mutable] = ACTIONS(846),
    [anon_sym_explicit] = ACTIONS(846),
    [anon_sym_constexpr] = ACTIONS(846),
    [anon_sym_AMP] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(844),
    [sym_char_literal] = ACTIONS(844),
    [sym_string_literal] = ACTIONS(844),
    [sym_true] = ACTIONS(846),
    [sym_false] = ACTIONS(846),
    [sym_null] = ACTIONS(846),
    [sym_identifier] = ACTIONS(846),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(846),
    [anon_sym_COLON_COLON] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(846),
    [sym_nullptr] = ACTIONS(846),
  },
  [858] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(858),
    [sym_raw_string_literal] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_RBRACK] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_register] = ACTIONS(850),
    [anon_sym_inline] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(2908),
    [anon_sym_long] = ACTIONS(2908),
    [anon_sym_short] = ACTIONS(2908),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(848),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_DASH_DASH] = ACTIONS(848),
    [anon_sym_PLUS_PLUS] = ACTIONS(848),
    [anon_sym_sizeof] = ACTIONS(850),
    [sym_number_literal] = ACTIONS(848),
    [sym_char_literal] = ACTIONS(848),
    [sym_string_literal] = ACTIONS(848),
    [sym_true] = ACTIONS(850),
    [sym_false] = ACTIONS(850),
    [sym_null] = ACTIONS(850),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(850),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [anon_sym_delete] = ACTIONS(850),
    [sym_nullptr] = ACTIONS(850),
  },
  [859] = {
    [sym_enumerator_list] = STATE(1421),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2913),
    [sym_comment] = ACTIONS(49),
  },
  [860] = {
    [sym_field_declaration_list] = STATE(1425),
    [sym__class_name] = STATE(1426),
    [sym_base_class_clause] = STATE(1427),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [861] = {
    [sym_field_declaration_list] = STATE(1431),
    [sym__class_name] = STATE(1432),
    [sym_base_class_clause] = STATE(1433),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [862] = {
    [sym_template_argument_list] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(146),
    [anon_sym_COMMA] = ACTIONS(146),
    [anon_sym_RPAREN] = ACTIONS(146),
    [anon_sym_SEMI] = ACTIONS(146),
    [anon_sym_LBRACE] = ACTIONS(146),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_EQ] = ACTIONS(146),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(146),
    [anon_sym_volatile] = ACTIONS(146),
    [anon_sym__Atomic] = ACTIONS(146),
    [anon_sym_mutable] = ACTIONS(146),
    [anon_sym_explicit] = ACTIONS(146),
    [anon_sym_constexpr] = ACTIONS(146),
    [anon_sym_COLON] = ACTIONS(148),
    [anon_sym_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(146),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(146),
    [anon_sym_DASH_GT] = ACTIONS(146),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(146),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
  },
  [863] = {
    [sym_field_declaration_list] = STATE(1438),
    [sym__class_name] = STATE(1439),
    [sym_base_class_clause] = STATE(1440),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [864] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(870),
    [anon_sym_unsigned] = ACTIONS(1636),
    [anon_sym_long] = ACTIONS(1636),
    [anon_sym_short] = ACTIONS(1636),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(1650),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [865] = {
    [sym_identifier] = ACTIONS(2931),
    [sym_comment] = ACTIONS(49),
  },
  [866] = {
    [sym__abstract_declarator] = STATE(1445),
    [sym_abstract_pointer_declarator] = STATE(1445),
    [sym_abstract_function_declarator] = STATE(1445),
    [sym_abstract_array_declarator] = STATE(1445),
    [sym_parameter_list] = STATE(1446),
    [sym_abstract_reference_declarator] = STATE(1445),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [867] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(236),
    [anon_sym_volatile] = ACTIONS(236),
    [anon_sym__Atomic] = ACTIONS(236),
    [anon_sym_mutable] = ACTIONS(236),
    [anon_sym_explicit] = ACTIONS(236),
    [anon_sym_constexpr] = ACTIONS(236),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_DASH_GT] = ACTIONS(236),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(236),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
  },
  [868] = {
    [sym_template_argument_list] = STATE(1448),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(236),
    [anon_sym_volatile] = ACTIONS(236),
    [anon_sym__Atomic] = ACTIONS(236),
    [anon_sym_mutable] = ACTIONS(236),
    [anon_sym_explicit] = ACTIONS(236),
    [anon_sym_constexpr] = ACTIONS(236),
    [anon_sym_COLON] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_DASH_GT] = ACTIONS(236),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(236),
  },
  [869] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
  },
  [870] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [871] = {
    [sym_type_qualifier] = STATE(871),
    [sym_trailing_return_type] = STATE(871),
    [aux_sym_function_declarator_repeat1] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2962),
  },
  [872] = {
    [sym_raw_string_literal] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(257),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_if] = ACTIONS(259),
    [anon_sym_switch] = ACTIONS(259),
    [anon_sym_case] = ACTIONS(259),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_while] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_for] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(259),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(259),
    [anon_sym_goto] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(257),
    [anon_sym_PLUS_PLUS] = ACTIONS(257),
    [anon_sym_sizeof] = ACTIONS(259),
    [sym_number_literal] = ACTIONS(257),
    [sym_char_literal] = ACTIONS(257),
    [sym_string_literal] = ACTIONS(257),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_new] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [anon_sym_delete] = ACTIONS(259),
    [sym_nullptr] = ACTIONS(259),
  },
  [873] = {
    [sym_preproc_params] = STATE(1454),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(2965),
    [anon_sym_LF] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [874] = {
    [anon_sym_RPAREN] = ACTIONS(2969),
    [sym_comment] = ACTIONS(49),
  },
  [875] = {
    [sym_preproc_include] = STATE(1487),
    [sym_preproc_def] = STATE(1487),
    [sym_preproc_function_def] = STATE(1487),
    [sym_preproc_call] = STATE(1487),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(1482),
    [sym_preproc_elif_in_compound_statement] = STATE(1483),
    [sym_declaration] = STATE(1487),
    [sym_type_definition] = STATE(1487),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(1487),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1487),
    [sym_expression_statement] = STATE(1487),
    [sym_if_statement] = STATE(1487),
    [sym_switch_statement] = STATE(1487),
    [sym_case_statement] = STATE(1487),
    [sym_while_statement] = STATE(1487),
    [sym_do_statement] = STATE(1487),
    [sym_for_statement] = STATE(1487),
    [sym_return_statement] = STATE(1487),
    [sym_break_statement] = STATE(1487),
    [sym_continue_statement] = STATE(1487),
    [sym_goto_statement] = STATE(1487),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(1487),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1487),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(1487),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1487),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2979),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [876] = {
    [sym_preproc_include] = STATE(1491),
    [sym_preproc_def] = STATE(1491),
    [sym_preproc_function_def] = STATE(1491),
    [sym_preproc_call] = STATE(1491),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(1489),
    [sym_preproc_elif_in_compound_statement] = STATE(1490),
    [sym_declaration] = STATE(1491),
    [sym_type_definition] = STATE(1491),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(1491),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1491),
    [sym_expression_statement] = STATE(1491),
    [sym_if_statement] = STATE(1491),
    [sym_switch_statement] = STATE(1491),
    [sym_case_statement] = STATE(1491),
    [sym_while_statement] = STATE(1491),
    [sym_do_statement] = STATE(1491),
    [sym_for_statement] = STATE(1491),
    [sym_return_statement] = STATE(1491),
    [sym_break_statement] = STATE(1491),
    [sym_continue_statement] = STATE(1491),
    [sym_goto_statement] = STATE(1491),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(1491),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1491),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(1491),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1491),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3023),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [877] = {
    [sym_preproc_include] = STATE(1495),
    [sym_preproc_def] = STATE(1495),
    [sym_preproc_function_def] = STATE(1495),
    [sym_preproc_call] = STATE(1495),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(1493),
    [sym_preproc_elif_in_compound_statement] = STATE(1494),
    [sym_declaration] = STATE(1495),
    [sym_type_definition] = STATE(1495),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(1495),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1495),
    [sym_expression_statement] = STATE(1495),
    [sym_if_statement] = STATE(1495),
    [sym_switch_statement] = STATE(1495),
    [sym_case_statement] = STATE(1495),
    [sym_while_statement] = STATE(1495),
    [sym_do_statement] = STATE(1495),
    [sym_for_statement] = STATE(1495),
    [sym_return_statement] = STATE(1495),
    [sym_break_statement] = STATE(1495),
    [sym_continue_statement] = STATE(1495),
    [sym_goto_statement] = STATE(1495),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(1495),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1495),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(1495),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1495),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3025),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [878] = {
    [sym_preproc_arg] = ACTIONS(3027),
    [sym_comment] = ACTIONS(83),
  },
  [879] = {
    [sym_raw_string_literal] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_RBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_switch] = ACTIONS(317),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_while] = ACTIONS(317),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(317),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(317),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_DASH_DASH] = ACTIONS(315),
    [anon_sym_PLUS_PLUS] = ACTIONS(315),
    [anon_sym_sizeof] = ACTIONS(317),
    [sym_number_literal] = ACTIONS(315),
    [sym_char_literal] = ACTIONS(315),
    [sym_string_literal] = ACTIONS(315),
    [sym_true] = ACTIONS(317),
    [sym_false] = ACTIONS(317),
    [sym_null] = ACTIONS(317),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [anon_sym_delete] = ACTIONS(317),
    [sym_nullptr] = ACTIONS(317),
  },
  [880] = {
    [sym__type_declarator] = STATE(1497),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [881] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1498),
    [sym_sized_type_specifier] = STATE(1498),
    [sym_enum_specifier] = STATE(1498),
    [sym_struct_specifier] = STATE(1498),
    [sym_union_specifier] = STATE(1498),
    [sym_macro_type_specifier] = STATE(1498),
    [sym_class_specifier] = STATE(1498),
    [sym_dependent_type] = STATE(1498),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(3029),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(3029),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [882] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [883] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [884] = {
    [sym__expression] = STATE(1509),
    [sym_conditional_expression] = STATE(1509),
    [sym_assignment_expression] = STATE(1509),
    [sym_pointer_expression] = STATE(1509),
    [sym_logical_expression] = STATE(1509),
    [sym_bitwise_expression] = STATE(1509),
    [sym_equality_expression] = STATE(1509),
    [sym_relational_expression] = STATE(1509),
    [sym_shift_expression] = STATE(1509),
    [sym_math_expression] = STATE(1509),
    [sym_cast_expression] = STATE(1509),
    [sym_sizeof_expression] = STATE(1509),
    [sym_subscript_expression] = STATE(1509),
    [sym_call_expression] = STATE(1509),
    [sym_field_expression] = STATE(1509),
    [sym_compound_literal_expression] = STATE(1509),
    [sym_parenthesized_expression] = STATE(1509),
    [sym_concatenated_string] = STATE(1509),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1509),
    [sym_new_expression] = STATE(1509),
    [sym_delete_expression] = STATE(1509),
    [sym_lambda_expression] = STATE(1509),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(3033),
    [sym_char_literal] = ACTIONS(3033),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(3051),
    [sym_false] = ACTIONS(3051),
    [sym_null] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(3051),
  },
  [885] = {
    [anon_sym_LPAREN] = ACTIONS(3057),
    [sym_comment] = ACTIONS(49),
  },
  [886] = {
    [sym__expression] = STATE(1511),
    [sym_conditional_expression] = STATE(1511),
    [sym_assignment_expression] = STATE(1511),
    [sym_pointer_expression] = STATE(1511),
    [sym_logical_expression] = STATE(1511),
    [sym_bitwise_expression] = STATE(1511),
    [sym_equality_expression] = STATE(1511),
    [sym_relational_expression] = STATE(1511),
    [sym_shift_expression] = STATE(1511),
    [sym_math_expression] = STATE(1511),
    [sym_cast_expression] = STATE(1511),
    [sym_sizeof_expression] = STATE(1511),
    [sym_subscript_expression] = STATE(1511),
    [sym_call_expression] = STATE(1511),
    [sym_field_expression] = STATE(1511),
    [sym_compound_literal_expression] = STATE(1511),
    [sym_parenthesized_expression] = STATE(1511),
    [sym_concatenated_string] = STATE(1511),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1511),
    [sym_new_expression] = STATE(1511),
    [sym_delete_expression] = STATE(1511),
    [sym_lambda_expression] = STATE(1511),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(3059),
    [sym_char_literal] = ACTIONS(3059),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_null] = ACTIONS(3061),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(3061),
  },
  [887] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1512),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [888] = {
    [sym__expression] = STATE(1513),
    [sym_conditional_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1513),
    [sym_pointer_expression] = STATE(1513),
    [sym_logical_expression] = STATE(1513),
    [sym_bitwise_expression] = STATE(1513),
    [sym_equality_expression] = STATE(1513),
    [sym_relational_expression] = STATE(1513),
    [sym_shift_expression] = STATE(1513),
    [sym_math_expression] = STATE(1513),
    [sym_cast_expression] = STATE(1513),
    [sym_sizeof_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_call_expression] = STATE(1513),
    [sym_field_expression] = STATE(1513),
    [sym_compound_literal_expression] = STATE(1513),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_concatenated_string] = STATE(1513),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1513),
    [sym_new_expression] = STATE(1513),
    [sym_delete_expression] = STATE(1513),
    [sym_lambda_expression] = STATE(1513),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3063),
    [sym_char_literal] = ACTIONS(3063),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3065),
  },
  [889] = {
    [sym__expression] = STATE(1514),
    [sym_conditional_expression] = STATE(1514),
    [sym_assignment_expression] = STATE(1514),
    [sym_pointer_expression] = STATE(1514),
    [sym_logical_expression] = STATE(1514),
    [sym_bitwise_expression] = STATE(1514),
    [sym_equality_expression] = STATE(1514),
    [sym_relational_expression] = STATE(1514),
    [sym_shift_expression] = STATE(1514),
    [sym_math_expression] = STATE(1514),
    [sym_cast_expression] = STATE(1514),
    [sym_sizeof_expression] = STATE(1514),
    [sym_subscript_expression] = STATE(1514),
    [sym_call_expression] = STATE(1514),
    [sym_field_expression] = STATE(1514),
    [sym_compound_literal_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1514),
    [sym_concatenated_string] = STATE(1514),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1514),
    [sym_new_expression] = STATE(1514),
    [sym_delete_expression] = STATE(1514),
    [sym_lambda_expression] = STATE(1514),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3067),
    [sym_char_literal] = ACTIONS(3067),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_null] = ACTIONS(3069),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3069),
  },
  [890] = {
    [sym__expression] = STATE(1515),
    [sym_conditional_expression] = STATE(1515),
    [sym_assignment_expression] = STATE(1515),
    [sym_pointer_expression] = STATE(1515),
    [sym_logical_expression] = STATE(1515),
    [sym_bitwise_expression] = STATE(1515),
    [sym_equality_expression] = STATE(1515),
    [sym_relational_expression] = STATE(1515),
    [sym_shift_expression] = STATE(1515),
    [sym_math_expression] = STATE(1515),
    [sym_cast_expression] = STATE(1515),
    [sym_sizeof_expression] = STATE(1515),
    [sym_subscript_expression] = STATE(1515),
    [sym_call_expression] = STATE(1515),
    [sym_field_expression] = STATE(1515),
    [sym_compound_literal_expression] = STATE(1515),
    [sym_parenthesized_expression] = STATE(1515),
    [sym_concatenated_string] = STATE(1515),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1515),
    [sym_new_expression] = STATE(1515),
    [sym_delete_expression] = STATE(1515),
    [sym_lambda_expression] = STATE(1515),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3071),
    [sym_char_literal] = ACTIONS(3071),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_null] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3073),
  },
  [891] = {
    [sym__expression] = STATE(1516),
    [sym_conditional_expression] = STATE(1516),
    [sym_assignment_expression] = STATE(1516),
    [sym_pointer_expression] = STATE(1516),
    [sym_logical_expression] = STATE(1516),
    [sym_bitwise_expression] = STATE(1516),
    [sym_equality_expression] = STATE(1516),
    [sym_relational_expression] = STATE(1516),
    [sym_shift_expression] = STATE(1516),
    [sym_math_expression] = STATE(1516),
    [sym_cast_expression] = STATE(1516),
    [sym_sizeof_expression] = STATE(1516),
    [sym_subscript_expression] = STATE(1516),
    [sym_call_expression] = STATE(1516),
    [sym_field_expression] = STATE(1516),
    [sym_compound_literal_expression] = STATE(1516),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_concatenated_string] = STATE(1516),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1516),
    [sym_new_expression] = STATE(1516),
    [sym_delete_expression] = STATE(1516),
    [sym_lambda_expression] = STATE(1516),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3075),
    [sym_char_literal] = ACTIONS(3075),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3077),
    [sym_false] = ACTIONS(3077),
    [sym_null] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3077),
  },
  [892] = {
    [sym__expression] = STATE(1518),
    [sym_conditional_expression] = STATE(1518),
    [sym_assignment_expression] = STATE(1518),
    [sym_pointer_expression] = STATE(1518),
    [sym_logical_expression] = STATE(1518),
    [sym_bitwise_expression] = STATE(1518),
    [sym_equality_expression] = STATE(1518),
    [sym_relational_expression] = STATE(1518),
    [sym_shift_expression] = STATE(1518),
    [sym_math_expression] = STATE(1518),
    [sym_cast_expression] = STATE(1518),
    [sym_sizeof_expression] = STATE(1518),
    [sym_subscript_expression] = STATE(1518),
    [sym_call_expression] = STATE(1518),
    [sym_field_expression] = STATE(1518),
    [sym_compound_literal_expression] = STATE(1518),
    [sym_parenthesized_expression] = STATE(1518),
    [sym_concatenated_string] = STATE(1518),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1518),
    [sym_new_expression] = STATE(1518),
    [sym_delete_expression] = STATE(1518),
    [sym_lambda_expression] = STATE(1518),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3079),
    [sym_char_literal] = ACTIONS(3079),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [sym_null] = ACTIONS(3083),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3083),
  },
  [893] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1519),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(3085),
    [sym_comment] = ACTIONS(49),
  },
  [894] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(3087),
    [sym_operator_name] = ACTIONS(198),
  },
  [895] = {
    [sym__expression] = STATE(1522),
    [sym_conditional_expression] = STATE(1522),
    [sym_assignment_expression] = STATE(1522),
    [sym_pointer_expression] = STATE(1522),
    [sym_logical_expression] = STATE(1522),
    [sym_bitwise_expression] = STATE(1522),
    [sym_equality_expression] = STATE(1522),
    [sym_relational_expression] = STATE(1522),
    [sym_shift_expression] = STATE(1522),
    [sym_math_expression] = STATE(1522),
    [sym_cast_expression] = STATE(1522),
    [sym_sizeof_expression] = STATE(1522),
    [sym_subscript_expression] = STATE(1522),
    [sym_call_expression] = STATE(1522),
    [sym_field_expression] = STATE(1522),
    [sym_compound_literal_expression] = STATE(1522),
    [sym_parenthesized_expression] = STATE(1522),
    [sym_concatenated_string] = STATE(1522),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1522),
    [sym_new_expression] = STATE(1522),
    [sym_delete_expression] = STATE(1522),
    [sym_lambda_expression] = STATE(1522),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3089),
    [sym_char_literal] = ACTIONS(3089),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [sym_null] = ACTIONS(3093),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3093),
  },
  [896] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [897] = {
    [sym_template_argument_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
  },
  [898] = {
    [sym_declaration] = STATE(1539),
    [sym_type_definition] = STATE(1539),
    [sym__declaration_specifiers] = STATE(1540),
    [sym_compound_statement] = STATE(1539),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1539),
    [sym_expression_statement] = STATE(1539),
    [sym_if_statement] = STATE(1539),
    [sym_switch_statement] = STATE(1539),
    [sym_case_statement] = STATE(1539),
    [sym_while_statement] = STATE(1539),
    [sym_do_statement] = STATE(1539),
    [sym_for_statement] = STATE(1539),
    [sym_return_statement] = STATE(1539),
    [sym_break_statement] = STATE(1539),
    [sym_continue_statement] = STATE(1539),
    [sym_goto_statement] = STATE(1539),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1539),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3130),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [899] = {
    [sym__expression] = STATE(1543),
    [sym_conditional_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(1543),
    [sym_pointer_expression] = STATE(1543),
    [sym_logical_expression] = STATE(1543),
    [sym_bitwise_expression] = STATE(1543),
    [sym_equality_expression] = STATE(1543),
    [sym_relational_expression] = STATE(1543),
    [sym_shift_expression] = STATE(1543),
    [sym_math_expression] = STATE(1543),
    [sym_cast_expression] = STATE(1543),
    [sym_sizeof_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_call_expression] = STATE(1543),
    [sym_field_expression] = STATE(1543),
    [sym_compound_literal_expression] = STATE(1543),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_concatenated_string] = STATE(1543),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1543),
    [sym_new_expression] = STATE(1543),
    [sym_delete_expression] = STATE(1543),
    [sym_lambda_expression] = STATE(1543),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(3134),
    [sym_char_literal] = ACTIONS(3134),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(3136),
  },
  [900] = {
    [anon_sym_else] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [sym_comment] = ACTIONS(49),
  },
  [901] = {
    [sym_preproc_include] = STATE(1545),
    [sym_preproc_def] = STATE(1545),
    [sym_preproc_function_def] = STATE(1545),
    [sym_preproc_call] = STATE(1545),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1545),
    [sym_type_definition] = STATE(1545),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1545),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1545),
    [sym_expression_statement] = STATE(1545),
    [sym_if_statement] = STATE(1545),
    [sym_switch_statement] = STATE(1545),
    [sym_case_statement] = STATE(1545),
    [sym_while_statement] = STATE(1545),
    [sym_do_statement] = STATE(1545),
    [sym_for_statement] = STATE(1545),
    [sym_return_statement] = STATE(1545),
    [sym_break_statement] = STATE(1545),
    [sym_continue_statement] = STATE(1545),
    [sym_goto_statement] = STATE(1545),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(1545),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1545),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1545),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1545),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [902] = {
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_constexpr] = ACTIONS(3142),
    [sym_comment] = ACTIONS(49),
  },
  [903] = {
    [anon_sym_LPAREN] = ACTIONS(3144),
    [sym_comment] = ACTIONS(49),
  },
  [904] = {
    [sym__expression] = STATE(1549),
    [sym_conditional_expression] = STATE(1549),
    [sym_assignment_expression] = STATE(1549),
    [sym_pointer_expression] = STATE(1549),
    [sym_logical_expression] = STATE(1549),
    [sym_bitwise_expression] = STATE(1549),
    [sym_equality_expression] = STATE(1549),
    [sym_relational_expression] = STATE(1549),
    [sym_shift_expression] = STATE(1549),
    [sym_math_expression] = STATE(1549),
    [sym_cast_expression] = STATE(1549),
    [sym_sizeof_expression] = STATE(1549),
    [sym_subscript_expression] = STATE(1549),
    [sym_call_expression] = STATE(1549),
    [sym_field_expression] = STATE(1549),
    [sym_compound_literal_expression] = STATE(1549),
    [sym_parenthesized_expression] = STATE(1549),
    [sym_concatenated_string] = STATE(1549),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1549),
    [sym_new_expression] = STATE(1549),
    [sym_delete_expression] = STATE(1549),
    [sym_lambda_expression] = STATE(1549),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3146),
    [sym_char_literal] = ACTIONS(3146),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3148),
  },
  [905] = {
    [anon_sym_COLON] = ACTIONS(3150),
    [sym_comment] = ACTIONS(49),
  },
  [906] = {
    [anon_sym_LPAREN] = ACTIONS(3152),
    [sym_comment] = ACTIONS(49),
  },
  [907] = {
    [sym_compound_statement] = STATE(1552),
    [sym_labeled_statement] = STATE(1552),
    [sym_expression_statement] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_switch_statement] = STATE(1552),
    [sym_case_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_do_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_return_statement] = STATE(1552),
    [sym_break_statement] = STATE(1552),
    [sym_continue_statement] = STATE(1552),
    [sym_goto_statement] = STATE(1552),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(1552),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [908] = {
    [anon_sym_LPAREN] = ACTIONS(3154),
    [sym_comment] = ACTIONS(49),
  },
  [909] = {
    [sym__expression] = STATE(1555),
    [sym_conditional_expression] = STATE(1555),
    [sym_assignment_expression] = STATE(1555),
    [sym_pointer_expression] = STATE(1555),
    [sym_logical_expression] = STATE(1555),
    [sym_bitwise_expression] = STATE(1555),
    [sym_equality_expression] = STATE(1555),
    [sym_relational_expression] = STATE(1555),
    [sym_shift_expression] = STATE(1555),
    [sym_math_expression] = STATE(1555),
    [sym_cast_expression] = STATE(1555),
    [sym_sizeof_expression] = STATE(1555),
    [sym_subscript_expression] = STATE(1555),
    [sym_call_expression] = STATE(1555),
    [sym_field_expression] = STATE(1555),
    [sym_compound_literal_expression] = STATE(1555),
    [sym_parenthesized_expression] = STATE(1555),
    [sym_initializer_list] = STATE(1556),
    [sym_concatenated_string] = STATE(1555),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1555),
    [sym_new_expression] = STATE(1555),
    [sym_delete_expression] = STATE(1555),
    [sym_lambda_expression] = STATE(1555),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(3156),
    [sym_char_literal] = ACTIONS(3156),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(3160),
  },
  [910] = {
    [anon_sym_SEMI] = ACTIONS(3162),
    [sym_comment] = ACTIONS(49),
  },
  [911] = {
    [anon_sym_SEMI] = ACTIONS(3164),
    [sym_comment] = ACTIONS(49),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3166),
    [sym_comment] = ACTIONS(49),
  },
  [913] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(3168),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [914] = {
    [anon_sym_while] = ACTIONS(3170),
    [sym_comment] = ACTIONS(49),
  },
  [915] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [916] = {
    [anon_sym_SEMI] = ACTIONS(3172),
    [sym_comment] = ACTIONS(49),
  },
  [917] = {
    [sym_declaration] = STATE(1563),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1567),
    [sym_conditional_expression] = STATE(1567),
    [sym_assignment_expression] = STATE(1567),
    [sym_pointer_expression] = STATE(1567),
    [sym_logical_expression] = STATE(1567),
    [sym_bitwise_expression] = STATE(1567),
    [sym_equality_expression] = STATE(1567),
    [sym_relational_expression] = STATE(1567),
    [sym_shift_expression] = STATE(1567),
    [sym_math_expression] = STATE(1567),
    [sym_cast_expression] = STATE(1567),
    [sym_sizeof_expression] = STATE(1567),
    [sym_subscript_expression] = STATE(1567),
    [sym_call_expression] = STATE(1567),
    [sym_field_expression] = STATE(1567),
    [sym_compound_literal_expression] = STATE(1567),
    [sym_parenthesized_expression] = STATE(1567),
    [sym_concatenated_string] = STATE(1567),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(1567),
    [sym_for_range_declaration] = STATE(1568),
    [sym_new_expression] = STATE(1567),
    [sym_delete_expression] = STATE(1567),
    [sym_lambda_expression] = STATE(1567),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(3174),
    [sym_char_literal] = ACTIONS(3174),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(3178),
  },
  [918] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [919] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [920] = {
    [anon_sym_SEMI] = ACTIONS(3188),
    [sym_comment] = ACTIONS(49),
  },
  [921] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [922] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [923] = {
    [anon_sym_SEMI] = ACTIONS(3198),
    [sym_comment] = ACTIONS(49),
  },
  [924] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1571),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [925] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [926] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1572),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(3200),
    [sym_comment] = ACTIONS(49),
  },
  [927] = {
    [sym_compound_statement] = STATE(1574),
    [sym_labeled_statement] = STATE(1574),
    [sym_expression_statement] = STATE(1574),
    [sym_if_statement] = STATE(1574),
    [sym_switch_statement] = STATE(1574),
    [sym_case_statement] = STATE(1574),
    [sym_while_statement] = STATE(1574),
    [sym_do_statement] = STATE(1574),
    [sym_for_statement] = STATE(1574),
    [sym_return_statement] = STATE(1574),
    [sym_break_statement] = STATE(1574),
    [sym_continue_statement] = STATE(1574),
    [sym_goto_statement] = STATE(1574),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1574),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [928] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3204),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [929] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [930] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(541),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [931] = {
    [sym__expression] = STATE(1577),
    [sym_conditional_expression] = STATE(1577),
    [sym_assignment_expression] = STATE(1577),
    [sym_pointer_expression] = STATE(1577),
    [sym_logical_expression] = STATE(1577),
    [sym_bitwise_expression] = STATE(1577),
    [sym_equality_expression] = STATE(1577),
    [sym_relational_expression] = STATE(1577),
    [sym_shift_expression] = STATE(1577),
    [sym_math_expression] = STATE(1577),
    [sym_cast_expression] = STATE(1577),
    [sym_sizeof_expression] = STATE(1577),
    [sym_subscript_expression] = STATE(1577),
    [sym_call_expression] = STATE(1577),
    [sym_field_expression] = STATE(1577),
    [sym_compound_literal_expression] = STATE(1577),
    [sym_parenthesized_expression] = STATE(1577),
    [sym_concatenated_string] = STATE(1577),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1577),
    [sym_new_expression] = STATE(1577),
    [sym_delete_expression] = STATE(1577),
    [sym_lambda_expression] = STATE(1577),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3206),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3206),
    [sym_char_literal] = ACTIONS(3206),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3210),
  },
  [932] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [933] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [934] = {
    [sym_raw_string_literal] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_goto] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_sizeof] = ACTIONS(556),
    [sym_number_literal] = ACTIONS(554),
    [sym_char_literal] = ACTIONS(554),
    [sym_string_literal] = ACTIONS(554),
    [sym_true] = ACTIONS(556),
    [sym_false] = ACTIONS(556),
    [sym_null] = ACTIONS(556),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_delete] = ACTIONS(556),
    [sym_nullptr] = ACTIONS(556),
  },
  [935] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(1580),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [936] = {
    [aux_sym_declaration_repeat1] = STATE(1580),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3214),
    [sym_comment] = ACTIONS(49),
  },
  [937] = {
    [sym_argument_list] = STATE(1582),
    [sym_initializer_list] = STATE(1582),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(3216),
    [sym_comment] = ACTIONS(49),
  },
  [938] = {
    [sym_argument_list] = STATE(1584),
    [sym_initializer_list] = STATE(1584),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(3218),
    [sym_comment] = ACTIONS(49),
  },
  [939] = {
    [sym__expression] = STATE(1585),
    [sym_comma_expression] = STATE(1586),
    [sym_conditional_expression] = STATE(1585),
    [sym_assignment_expression] = STATE(1585),
    [sym_pointer_expression] = STATE(1585),
    [sym_logical_expression] = STATE(1585),
    [sym_bitwise_expression] = STATE(1585),
    [sym_equality_expression] = STATE(1585),
    [sym_relational_expression] = STATE(1585),
    [sym_shift_expression] = STATE(1585),
    [sym_math_expression] = STATE(1585),
    [sym_cast_expression] = STATE(1585),
    [sym_sizeof_expression] = STATE(1585),
    [sym_subscript_expression] = STATE(1585),
    [sym_call_expression] = STATE(1585),
    [sym_field_expression] = STATE(1585),
    [sym_compound_literal_expression] = STATE(1585),
    [sym_parenthesized_expression] = STATE(1585),
    [sym_concatenated_string] = STATE(1585),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1585),
    [sym_new_expression] = STATE(1585),
    [sym_delete_expression] = STATE(1585),
    [sym_lambda_expression] = STATE(1585),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3220),
    [sym_char_literal] = ACTIONS(3220),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3222),
  },
  [940] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [941] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(2836),
  },
  [942] = {
    [sym__expression] = STATE(1587),
    [sym_conditional_expression] = STATE(1587),
    [sym_assignment_expression] = STATE(1587),
    [sym_pointer_expression] = STATE(1587),
    [sym_logical_expression] = STATE(1587),
    [sym_bitwise_expression] = STATE(1587),
    [sym_equality_expression] = STATE(1587),
    [sym_relational_expression] = STATE(1587),
    [sym_shift_expression] = STATE(1587),
    [sym_math_expression] = STATE(1587),
    [sym_cast_expression] = STATE(1587),
    [sym_sizeof_expression] = STATE(1587),
    [sym_subscript_expression] = STATE(1587),
    [sym_call_expression] = STATE(1587),
    [sym_field_expression] = STATE(1587),
    [sym_compound_literal_expression] = STATE(1587),
    [sym_parenthesized_expression] = STATE(1587),
    [sym_concatenated_string] = STATE(1587),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1587),
    [sym_new_expression] = STATE(1587),
    [sym_delete_expression] = STATE(1587),
    [sym_lambda_expression] = STATE(1587),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3228),
    [sym_char_literal] = ACTIONS(3228),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [sym_null] = ACTIONS(3230),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3230),
  },
  [943] = {
    [sym__expression] = STATE(1588),
    [sym_conditional_expression] = STATE(1588),
    [sym_assignment_expression] = STATE(1588),
    [sym_pointer_expression] = STATE(1588),
    [sym_logical_expression] = STATE(1588),
    [sym_bitwise_expression] = STATE(1588),
    [sym_equality_expression] = STATE(1588),
    [sym_relational_expression] = STATE(1588),
    [sym_shift_expression] = STATE(1588),
    [sym_math_expression] = STATE(1588),
    [sym_cast_expression] = STATE(1588),
    [sym_sizeof_expression] = STATE(1588),
    [sym_subscript_expression] = STATE(1588),
    [sym_call_expression] = STATE(1588),
    [sym_field_expression] = STATE(1588),
    [sym_compound_literal_expression] = STATE(1588),
    [sym_parenthesized_expression] = STATE(1588),
    [sym_concatenated_string] = STATE(1588),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1588),
    [sym_new_expression] = STATE(1588),
    [sym_delete_expression] = STATE(1588),
    [sym_lambda_expression] = STATE(1588),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3232),
    [sym_char_literal] = ACTIONS(3232),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [sym_null] = ACTIONS(3234),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3234),
  },
  [944] = {
    [sym__expression] = STATE(1589),
    [sym_conditional_expression] = STATE(1589),
    [sym_assignment_expression] = STATE(1589),
    [sym_pointer_expression] = STATE(1589),
    [sym_logical_expression] = STATE(1589),
    [sym_bitwise_expression] = STATE(1589),
    [sym_equality_expression] = STATE(1589),
    [sym_relational_expression] = STATE(1589),
    [sym_shift_expression] = STATE(1589),
    [sym_math_expression] = STATE(1589),
    [sym_cast_expression] = STATE(1589),
    [sym_sizeof_expression] = STATE(1589),
    [sym_subscript_expression] = STATE(1589),
    [sym_call_expression] = STATE(1589),
    [sym_field_expression] = STATE(1589),
    [sym_compound_literal_expression] = STATE(1589),
    [sym_parenthesized_expression] = STATE(1589),
    [sym_concatenated_string] = STATE(1589),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1589),
    [sym_new_expression] = STATE(1589),
    [sym_delete_expression] = STATE(1589),
    [sym_lambda_expression] = STATE(1589),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3236),
    [sym_char_literal] = ACTIONS(3236),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [sym_null] = ACTIONS(3238),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3238),
  },
  [945] = {
    [sym__expression] = STATE(1590),
    [sym_conditional_expression] = STATE(1590),
    [sym_assignment_expression] = STATE(1590),
    [sym_pointer_expression] = STATE(1590),
    [sym_logical_expression] = STATE(1590),
    [sym_bitwise_expression] = STATE(1590),
    [sym_equality_expression] = STATE(1590),
    [sym_relational_expression] = STATE(1590),
    [sym_shift_expression] = STATE(1590),
    [sym_math_expression] = STATE(1590),
    [sym_cast_expression] = STATE(1590),
    [sym_sizeof_expression] = STATE(1590),
    [sym_subscript_expression] = STATE(1590),
    [sym_call_expression] = STATE(1590),
    [sym_field_expression] = STATE(1590),
    [sym_compound_literal_expression] = STATE(1590),
    [sym_parenthesized_expression] = STATE(1590),
    [sym_concatenated_string] = STATE(1590),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1590),
    [sym_new_expression] = STATE(1590),
    [sym_delete_expression] = STATE(1590),
    [sym_lambda_expression] = STATE(1590),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3240),
    [sym_char_literal] = ACTIONS(3240),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3242),
    [sym_false] = ACTIONS(3242),
    [sym_null] = ACTIONS(3242),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3242),
  },
  [946] = {
    [sym__expression] = STATE(1591),
    [sym_conditional_expression] = STATE(1591),
    [sym_assignment_expression] = STATE(1591),
    [sym_pointer_expression] = STATE(1591),
    [sym_logical_expression] = STATE(1591),
    [sym_bitwise_expression] = STATE(1591),
    [sym_equality_expression] = STATE(1591),
    [sym_relational_expression] = STATE(1591),
    [sym_shift_expression] = STATE(1591),
    [sym_math_expression] = STATE(1591),
    [sym_cast_expression] = STATE(1591),
    [sym_sizeof_expression] = STATE(1591),
    [sym_subscript_expression] = STATE(1591),
    [sym_call_expression] = STATE(1591),
    [sym_field_expression] = STATE(1591),
    [sym_compound_literal_expression] = STATE(1591),
    [sym_parenthesized_expression] = STATE(1591),
    [sym_concatenated_string] = STATE(1591),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_delete_expression] = STATE(1591),
    [sym_lambda_expression] = STATE(1591),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3244),
    [sym_char_literal] = ACTIONS(3244),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3246),
    [sym_false] = ACTIONS(3246),
    [sym_null] = ACTIONS(3246),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3246),
  },
  [947] = {
    [sym__expression] = STATE(1592),
    [sym_conditional_expression] = STATE(1592),
    [sym_assignment_expression] = STATE(1592),
    [sym_pointer_expression] = STATE(1592),
    [sym_logical_expression] = STATE(1592),
    [sym_bitwise_expression] = STATE(1592),
    [sym_equality_expression] = STATE(1592),
    [sym_relational_expression] = STATE(1592),
    [sym_shift_expression] = STATE(1592),
    [sym_math_expression] = STATE(1592),
    [sym_cast_expression] = STATE(1592),
    [sym_sizeof_expression] = STATE(1592),
    [sym_subscript_expression] = STATE(1592),
    [sym_call_expression] = STATE(1592),
    [sym_field_expression] = STATE(1592),
    [sym_compound_literal_expression] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1592),
    [sym_new_expression] = STATE(1592),
    [sym_delete_expression] = STATE(1592),
    [sym_lambda_expression] = STATE(1592),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3248),
    [sym_char_literal] = ACTIONS(3248),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3250),
  },
  [948] = {
    [sym__expression] = STATE(1593),
    [sym_conditional_expression] = STATE(1593),
    [sym_assignment_expression] = STATE(1593),
    [sym_pointer_expression] = STATE(1593),
    [sym_logical_expression] = STATE(1593),
    [sym_bitwise_expression] = STATE(1593),
    [sym_equality_expression] = STATE(1593),
    [sym_relational_expression] = STATE(1593),
    [sym_shift_expression] = STATE(1593),
    [sym_math_expression] = STATE(1593),
    [sym_cast_expression] = STATE(1593),
    [sym_sizeof_expression] = STATE(1593),
    [sym_subscript_expression] = STATE(1593),
    [sym_call_expression] = STATE(1593),
    [sym_field_expression] = STATE(1593),
    [sym_compound_literal_expression] = STATE(1593),
    [sym_parenthesized_expression] = STATE(1593),
    [sym_concatenated_string] = STATE(1593),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1593),
    [sym_new_expression] = STATE(1593),
    [sym_delete_expression] = STATE(1593),
    [sym_lambda_expression] = STATE(1593),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [sym_null] = ACTIONS(3254),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3254),
  },
  [949] = {
    [sym__expression] = STATE(1594),
    [sym_conditional_expression] = STATE(1594),
    [sym_assignment_expression] = STATE(1594),
    [sym_pointer_expression] = STATE(1594),
    [sym_logical_expression] = STATE(1594),
    [sym_bitwise_expression] = STATE(1594),
    [sym_equality_expression] = STATE(1594),
    [sym_relational_expression] = STATE(1594),
    [sym_shift_expression] = STATE(1594),
    [sym_math_expression] = STATE(1594),
    [sym_cast_expression] = STATE(1594),
    [sym_sizeof_expression] = STATE(1594),
    [sym_subscript_expression] = STATE(1594),
    [sym_call_expression] = STATE(1594),
    [sym_field_expression] = STATE(1594),
    [sym_compound_literal_expression] = STATE(1594),
    [sym_parenthesized_expression] = STATE(1594),
    [sym_concatenated_string] = STATE(1594),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1594),
    [sym_new_expression] = STATE(1594),
    [sym_delete_expression] = STATE(1594),
    [sym_lambda_expression] = STATE(1594),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3256),
    [sym_char_literal] = ACTIONS(3256),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3258),
  },
  [950] = {
    [sym__expression] = STATE(1595),
    [sym_conditional_expression] = STATE(1595),
    [sym_assignment_expression] = STATE(1595),
    [sym_pointer_expression] = STATE(1595),
    [sym_logical_expression] = STATE(1595),
    [sym_bitwise_expression] = STATE(1595),
    [sym_equality_expression] = STATE(1595),
    [sym_relational_expression] = STATE(1595),
    [sym_shift_expression] = STATE(1595),
    [sym_math_expression] = STATE(1595),
    [sym_cast_expression] = STATE(1595),
    [sym_sizeof_expression] = STATE(1595),
    [sym_subscript_expression] = STATE(1595),
    [sym_call_expression] = STATE(1595),
    [sym_field_expression] = STATE(1595),
    [sym_compound_literal_expression] = STATE(1595),
    [sym_parenthesized_expression] = STATE(1595),
    [sym_concatenated_string] = STATE(1595),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1595),
    [sym_new_expression] = STATE(1595),
    [sym_delete_expression] = STATE(1595),
    [sym_lambda_expression] = STATE(1595),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3260),
    [sym_char_literal] = ACTIONS(3260),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3262),
  },
  [951] = {
    [sym__expression] = STATE(1596),
    [sym_conditional_expression] = STATE(1596),
    [sym_assignment_expression] = STATE(1596),
    [sym_pointer_expression] = STATE(1596),
    [sym_logical_expression] = STATE(1596),
    [sym_bitwise_expression] = STATE(1596),
    [sym_equality_expression] = STATE(1596),
    [sym_relational_expression] = STATE(1596),
    [sym_shift_expression] = STATE(1596),
    [sym_math_expression] = STATE(1596),
    [sym_cast_expression] = STATE(1596),
    [sym_sizeof_expression] = STATE(1596),
    [sym_subscript_expression] = STATE(1596),
    [sym_call_expression] = STATE(1596),
    [sym_field_expression] = STATE(1596),
    [sym_compound_literal_expression] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1596),
    [sym_concatenated_string] = STATE(1596),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1596),
    [sym_new_expression] = STATE(1596),
    [sym_delete_expression] = STATE(1596),
    [sym_lambda_expression] = STATE(1596),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3264),
    [sym_char_literal] = ACTIONS(3264),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3266),
  },
  [952] = {
    [sym__expression] = STATE(1597),
    [sym_conditional_expression] = STATE(1597),
    [sym_assignment_expression] = STATE(1597),
    [sym_pointer_expression] = STATE(1597),
    [sym_logical_expression] = STATE(1597),
    [sym_bitwise_expression] = STATE(1597),
    [sym_equality_expression] = STATE(1597),
    [sym_relational_expression] = STATE(1597),
    [sym_shift_expression] = STATE(1597),
    [sym_math_expression] = STATE(1597),
    [sym_cast_expression] = STATE(1597),
    [sym_sizeof_expression] = STATE(1597),
    [sym_subscript_expression] = STATE(1597),
    [sym_call_expression] = STATE(1597),
    [sym_field_expression] = STATE(1597),
    [sym_compound_literal_expression] = STATE(1597),
    [sym_parenthesized_expression] = STATE(1597),
    [sym_concatenated_string] = STATE(1597),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_delete_expression] = STATE(1597),
    [sym_lambda_expression] = STATE(1597),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(3268),
    [sym_char_literal] = ACTIONS(3268),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3270),
    [sym_false] = ACTIONS(3270),
    [sym_null] = ACTIONS(3270),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3270),
  },
  [953] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3272),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [954] = {
    [ts_builtin_sym_end] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [sym_operator_name] = ACTIONS(3274),
  },
  [955] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(3278),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3296),
    [sym_preproc_directive] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_typedef] = ACTIONS(3305),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3325),
    [anon_sym_long] = ACTIONS(3325),
    [anon_sym_short] = ACTIONS(3325),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3334),
    [anon_sym_union] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3352),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3364),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_sizeof] = ACTIONS(3385),
    [sym_number_literal] = ACTIONS(3278),
    [sym_char_literal] = ACTIONS(3278),
    [sym_string_literal] = ACTIONS(3388),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_identifier] = ACTIONS(3394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3397),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3409),
    [sym_nullptr] = ACTIONS(3391),
  },
  [956] = {
    [sym_destructor_name] = STATE(1600),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3412),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3414),
  },
  [957] = {
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [sym_comment] = ACTIONS(49),
  },
  [958] = {
    [anon_sym_LPAREN] = ACTIONS(3418),
    [anon_sym_LBRACE] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [959] = {
    [anon_sym_LPAREN] = ACTIONS(3420),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_LT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(49),
  },
  [960] = {
    [sym_field_initializer] = STATE(1601),
    [sym_template_type] = STATE(444),
    [sym_scoped_field_identifier] = STATE(445),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(444),
    [sym_identifier] = ACTIONS(720),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(722),
  },
  [961] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1602),
    [anon_sym_COMMA] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(3422),
    [sym_comment] = ACTIONS(49),
  },
  [962] = {
    [sym_destructor_name] = STATE(1604),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3424),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3426),
  },
  [963] = {
    [anon_sym_COMMA] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3428),
    [sym_comment] = ACTIONS(49),
  },
  [964] = {
    [ts_builtin_sym_end] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3432),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3432),
    [sym_preproc_directive] = ACTIONS(3432),
    [anon_sym_typedef] = ACTIONS(3432),
    [anon_sym_extern] = ACTIONS(3432),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_STAR] = ACTIONS(3430),
    [anon_sym_static] = ACTIONS(3432),
    [anon_sym_register] = ACTIONS(3432),
    [anon_sym_inline] = ACTIONS(3432),
    [anon_sym_const] = ACTIONS(3432),
    [anon_sym_restrict] = ACTIONS(3432),
    [anon_sym_volatile] = ACTIONS(3432),
    [anon_sym__Atomic] = ACTIONS(3432),
    [anon_sym_mutable] = ACTIONS(3432),
    [anon_sym_explicit] = ACTIONS(3432),
    [anon_sym_constexpr] = ACTIONS(3432),
    [anon_sym_unsigned] = ACTIONS(3432),
    [anon_sym_long] = ACTIONS(3432),
    [anon_sym_short] = ACTIONS(3432),
    [sym_primitive_type] = ACTIONS(3432),
    [anon_sym_enum] = ACTIONS(3432),
    [anon_sym_struct] = ACTIONS(3432),
    [anon_sym_union] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_TILDE] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3432),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3432),
    [sym_auto] = ACTIONS(3432),
    [anon_sym_typename] = ACTIONS(3432),
    [anon_sym_template] = ACTIONS(3432),
    [anon_sym_namespace] = ACTIONS(3432),
    [anon_sym_using] = ACTIONS(3432),
    [anon_sym_COLON_COLON] = ACTIONS(3430),
    [sym_operator_name] = ACTIONS(3430),
  },
  [965] = {
    [ts_builtin_sym_end] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_template] = ACTIONS(3436),
    [anon_sym_namespace] = ACTIONS(3436),
    [anon_sym_using] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [sym_operator_name] = ACTIONS(3434),
  },
  [966] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3438),
    [sym_identifier] = ACTIONS(3438),
    [sym_comment] = ACTIONS(49),
  },
  [967] = {
    [anon_sym_LF] = ACTIONS(3440),
    [sym_preproc_arg] = ACTIONS(3440),
    [sym_comment] = ACTIONS(83),
  },
  [968] = {
    [aux_sym_preproc_params_repeat1] = STATE(1607),
    [anon_sym_COMMA] = ACTIONS(1875),
    [anon_sym_RPAREN] = ACTIONS(3442),
    [sym_comment] = ACTIONS(49),
  },
  [969] = {
    [ts_builtin_sym_end] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_template] = ACTIONS(3446),
    [anon_sym_namespace] = ACTIONS(3446),
    [anon_sym_using] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [sym_operator_name] = ACTIONS(3444),
  },
  [970] = {
    [sym_enumerator_list] = STATE(1421),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(3448),
    [sym_comment] = ACTIONS(49),
  },
  [971] = {
    [sym_field_declaration_list] = STATE(1425),
    [sym__class_name] = STATE(1609),
    [sym_base_class_clause] = STATE(1427),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [972] = {
    [sym_field_declaration_list] = STATE(1431),
    [sym__class_name] = STATE(1610),
    [sym_base_class_clause] = STATE(1433),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [973] = {
    [sym_field_declaration_list] = STATE(1438),
    [sym__class_name] = STATE(1611),
    [sym_base_class_clause] = STATE(1440),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [974] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(976),
    [anon_sym_unsigned] = ACTIONS(1887),
    [anon_sym_long] = ACTIONS(1887),
    [anon_sym_short] = ACTIONS(1887),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(1899),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [975] = {
    [sym__abstract_declarator] = STATE(1614),
    [sym_abstract_pointer_declarator] = STATE(1614),
    [sym_abstract_function_declarator] = STATE(1614),
    [sym_abstract_array_declarator] = STATE(1614),
    [sym_parameter_list] = STATE(1615),
    [sym_abstract_reference_declarator] = STATE(1614),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [976] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1616),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [977] = {
    [sym_type_qualifier] = STATE(977),
    [sym_trailing_return_type] = STATE(977),
    [aux_sym_function_declarator_repeat1] = STATE(977),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3461),
  },
  [978] = {
    [sym_preproc_arg] = ACTIONS(3464),
    [sym_comment] = ACTIONS(83),
  },
  [979] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [980] = {
    [anon_sym_LF] = ACTIONS(3466),
    [sym_preproc_arg] = ACTIONS(3468),
    [sym_comment] = ACTIONS(83),
  },
  [981] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(891),
    [sym_preproc_directive] = ACTIONS(891),
    [anon_sym_typedef] = ACTIONS(891),
    [anon_sym_extern] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_register] = ACTIONS(891),
    [anon_sym_inline] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_restrict] = ACTIONS(891),
    [anon_sym_volatile] = ACTIONS(891),
    [anon_sym__Atomic] = ACTIONS(891),
    [anon_sym_mutable] = ACTIONS(891),
    [anon_sym_explicit] = ACTIONS(891),
    [anon_sym_constexpr] = ACTIONS(891),
    [anon_sym_unsigned] = ACTIONS(891),
    [anon_sym_long] = ACTIONS(891),
    [anon_sym_short] = ACTIONS(891),
    [sym_primitive_type] = ACTIONS(891),
    [anon_sym_enum] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(891),
    [anon_sym_union] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(889),
    [sym_identifier] = ACTIONS(891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(891),
    [sym_auto] = ACTIONS(891),
    [anon_sym_typename] = ACTIONS(891),
    [anon_sym_template] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_using] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(889),
    [sym_operator_name] = ACTIONS(889),
  },
  [982] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3470),
    [sym_comment] = ACTIONS(49),
  },
  [983] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(1621),
    [sym_preproc_elif] = STATE(1621),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [984] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(953),
    [sym_preproc_directive] = ACTIONS(953),
    [anon_sym_typedef] = ACTIONS(953),
    [anon_sym_extern] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_register] = ACTIONS(953),
    [anon_sym_inline] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_restrict] = ACTIONS(953),
    [anon_sym_volatile] = ACTIONS(953),
    [anon_sym__Atomic] = ACTIONS(953),
    [anon_sym_mutable] = ACTIONS(953),
    [anon_sym_explicit] = ACTIONS(953),
    [anon_sym_constexpr] = ACTIONS(953),
    [anon_sym_unsigned] = ACTIONS(953),
    [anon_sym_long] = ACTIONS(953),
    [anon_sym_short] = ACTIONS(953),
    [sym_primitive_type] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [anon_sym_struct] = ACTIONS(953),
    [anon_sym_union] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(953),
    [sym_auto] = ACTIONS(953),
    [anon_sym_typename] = ACTIONS(953),
    [anon_sym_template] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(953),
    [anon_sym_using] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(951),
    [sym_operator_name] = ACTIONS(951),
  },
  [985] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3474),
    [sym_comment] = ACTIONS(49),
  },
  [986] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(1623),
    [sym_preproc_elif] = STATE(1623),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3476),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [987] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(961),
    [sym_preproc_directive] = ACTIONS(961),
    [anon_sym_typedef] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_static] = ACTIONS(961),
    [anon_sym_register] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_restrict] = ACTIONS(961),
    [anon_sym_volatile] = ACTIONS(961),
    [anon_sym__Atomic] = ACTIONS(961),
    [anon_sym_mutable] = ACTIONS(961),
    [anon_sym_explicit] = ACTIONS(961),
    [anon_sym_constexpr] = ACTIONS(961),
    [anon_sym_unsigned] = ACTIONS(961),
    [anon_sym_long] = ACTIONS(961),
    [anon_sym_short] = ACTIONS(961),
    [sym_primitive_type] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_identifier] = ACTIONS(961),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(961),
    [sym_auto] = ACTIONS(961),
    [anon_sym_typename] = ACTIONS(961),
    [anon_sym_template] = ACTIONS(961),
    [anon_sym_namespace] = ACTIONS(961),
    [anon_sym_using] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [sym_operator_name] = ACTIONS(959),
  },
  [988] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(49),
  },
  [989] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(1625),
    [sym_preproc_elif] = STATE(1625),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [990] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_template] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_using] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [sym_operator_name] = ACTIONS(257),
  },
  [991] = {
    [sym_preproc_params] = STATE(1628),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(3482),
    [anon_sym_LF] = ACTIONS(3484),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [992] = {
    [sym_preproc_include] = STATE(1631),
    [sym_preproc_def] = STATE(1631),
    [sym_preproc_function_def] = STATE(1631),
    [sym_preproc_call] = STATE(1631),
    [sym_preproc_if] = STATE(1631),
    [sym_preproc_ifdef] = STATE(1631),
    [sym_preproc_else] = STATE(1630),
    [sym_preproc_elif] = STATE(1630),
    [sym_function_definition] = STATE(1631),
    [sym_declaration] = STATE(1631),
    [sym_type_definition] = STATE(1631),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(1631),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1631),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1631),
    [sym_template_declaration] = STATE(1631),
    [sym_template_instantiation] = STATE(1631),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1631),
    [sym_using_declaration] = STATE(1631),
    [sym_alias_declaration] = STATE(1631),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1631),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3486),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [993] = {
    [sym_preproc_include] = STATE(1634),
    [sym_preproc_def] = STATE(1634),
    [sym_preproc_function_def] = STATE(1634),
    [sym_preproc_call] = STATE(1634),
    [sym_preproc_if] = STATE(1634),
    [sym_preproc_ifdef] = STATE(1634),
    [sym_preproc_else] = STATE(1633),
    [sym_preproc_elif] = STATE(1633),
    [sym_function_definition] = STATE(1634),
    [sym_declaration] = STATE(1634),
    [sym_type_definition] = STATE(1634),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(1634),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1634),
    [sym_template_declaration] = STATE(1634),
    [sym_template_instantiation] = STATE(1634),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1634),
    [sym_using_declaration] = STATE(1634),
    [sym_alias_declaration] = STATE(1634),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3488),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [994] = {
    [sym_preproc_include] = STATE(1637),
    [sym_preproc_def] = STATE(1637),
    [sym_preproc_function_def] = STATE(1637),
    [sym_preproc_call] = STATE(1637),
    [sym_preproc_if] = STATE(1637),
    [sym_preproc_ifdef] = STATE(1637),
    [sym_preproc_else] = STATE(1636),
    [sym_preproc_elif] = STATE(1636),
    [sym_function_definition] = STATE(1637),
    [sym_declaration] = STATE(1637),
    [sym_type_definition] = STATE(1637),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(1637),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1637),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1637),
    [sym_template_declaration] = STATE(1637),
    [sym_template_instantiation] = STATE(1637),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1637),
    [sym_using_declaration] = STATE(1637),
    [sym_alias_declaration] = STATE(1637),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3490),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [995] = {
    [sym_preproc_arg] = ACTIONS(3492),
    [sym_comment] = ACTIONS(83),
  },
  [996] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_namespace] = ACTIONS(317),
    [anon_sym_using] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [sym_operator_name] = ACTIONS(315),
  },
  [997] = {
    [sym__type_declarator] = STATE(1639),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [998] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(1640),
    [sym_sized_type_specifier] = STATE(1640),
    [sym_enum_specifier] = STATE(1640),
    [sym_struct_specifier] = STATE(1640),
    [sym_union_specifier] = STATE(1640),
    [sym_macro_type_specifier] = STATE(1640),
    [sym_class_specifier] = STATE(1640),
    [sym_dependent_type] = STATE(1640),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [999] = {
    [sym_function_definition] = STATE(1641),
    [sym_declaration] = STATE(1641),
    [sym__declaration_specifiers] = STATE(1642),
    [sym_declaration_list] = STATE(1641),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [1000] = {
    [sym__declarator] = STATE(1643),
    [sym_pointer_declarator] = STATE(1643),
    [sym_function_declarator] = STATE(1643),
    [sym_array_declarator] = STATE(1643),
    [sym_reference_declarator] = STATE(1643),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1643),
    [sym_destructor_name] = STATE(1643),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(3496),
  },
  [1001] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [1002] = {
    [sym_function_definition] = STATE(1645),
    [sym_declaration] = STATE(1645),
    [sym__declaration_specifiers] = STATE(1646),
    [sym_storage_class_specifier] = STATE(326),
    [sym_type_qualifier] = STATE(326),
    [sym__type_specifier] = STATE(325),
    [sym_sized_type_specifier] = STATE(325),
    [sym_enum_specifier] = STATE(325),
    [sym_struct_specifier] = STATE(325),
    [sym_union_specifier] = STATE(325),
    [sym__empty_declaration] = STATE(1645),
    [sym_macro_type_specifier] = STATE(325),
    [sym_class_specifier] = STATE(325),
    [sym_dependent_type] = STATE(325),
    [sym_template_type] = STATE(98),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(99),
    [aux_sym__declaration_specifiers_repeat1] = STATE(326),
    [aux_sym_sized_type_specifier_repeat1] = STATE(327),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(511),
    [anon_sym_long] = ACTIONS(511),
    [anon_sym_short] = ACTIONS(511),
    [sym_primitive_type] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [sym_identifier] = ACTIONS(158),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(513),
    [anon_sym_typename] = ACTIONS(515),
    [anon_sym_COLON_COLON] = ACTIONS(160),
  },
  [1003] = {
    [sym_preproc_include] = STATE(1648),
    [sym_preproc_def] = STATE(1648),
    [sym_preproc_function_def] = STATE(1648),
    [sym_preproc_call] = STATE(1648),
    [sym_preproc_if] = STATE(1648),
    [sym_preproc_ifdef] = STATE(1648),
    [sym_function_definition] = STATE(1648),
    [sym_declaration] = STATE(1648),
    [sym_type_definition] = STATE(1648),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(1648),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1648),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1648),
    [sym_template_declaration] = STATE(1648),
    [sym_template_instantiation] = STATE(1648),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1648),
    [sym_using_declaration] = STATE(1648),
    [sym_alias_declaration] = STATE(1648),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1648),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1004] = {
    [sym_declaration_list] = STATE(1649),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [sym_comment] = ACTIONS(49),
  },
  [1005] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(527),
    [sym_preproc_directive] = ACTIONS(527),
    [anon_sym_typedef] = ACTIONS(527),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_register] = ACTIONS(527),
    [anon_sym_inline] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_restrict] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym__Atomic] = ACTIONS(527),
    [anon_sym_mutable] = ACTIONS(527),
    [anon_sym_explicit] = ACTIONS(527),
    [anon_sym_constexpr] = ACTIONS(527),
    [anon_sym_unsigned] = ACTIONS(527),
    [anon_sym_long] = ACTIONS(527),
    [anon_sym_short] = ACTIONS(527),
    [sym_primitive_type] = ACTIONS(527),
    [anon_sym_enum] = ACTIONS(527),
    [anon_sym_struct] = ACTIONS(527),
    [anon_sym_union] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [sym_identifier] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(527),
    [sym_auto] = ACTIONS(527),
    [anon_sym_typename] = ACTIONS(527),
    [anon_sym_template] = ACTIONS(527),
    [anon_sym_namespace] = ACTIONS(527),
    [anon_sym_using] = ACTIONS(527),
    [anon_sym_COLON_COLON] = ACTIONS(525),
    [sym_operator_name] = ACTIONS(525),
  },
  [1006] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [1007] = {
    [sym_template_type] = STATE(122),
    [sym_scoped_identifier] = STATE(1653),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(122),
    [sym_identifier] = ACTIONS(3506),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(194),
  },
  [1008] = {
    [anon_sym_SEMI] = ACTIONS(3502),
    [sym_comment] = ACTIONS(49),
  },
  [1009] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_template] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_using] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [sym_operator_name] = ACTIONS(554),
  },
  [1010] = {
    [sym_compound_statement] = STATE(1656),
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(1657),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [1011] = {
    [aux_sym_declaration_repeat1] = STATE(1657),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3508),
    [sym_comment] = ACTIONS(49),
  },
  [1012] = {
    [sym_argument_list] = STATE(1659),
    [sym_initializer_list] = STATE(1659),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(3512),
    [sym_comment] = ACTIONS(49),
  },
  [1013] = {
    [sym_argument_list] = STATE(1661),
    [sym_initializer_list] = STATE(1661),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(3514),
    [sym_comment] = ACTIONS(49),
  },
  [1014] = {
    [sym_preproc_include] = STATE(1663),
    [sym_preproc_def] = STATE(1663),
    [sym_preproc_function_def] = STATE(1663),
    [sym_preproc_call] = STATE(1663),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1663),
    [sym_type_definition] = STATE(1663),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1663),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1663),
    [sym_expression_statement] = STATE(1663),
    [sym_if_statement] = STATE(1663),
    [sym_switch_statement] = STATE(1663),
    [sym_case_statement] = STATE(1663),
    [sym_while_statement] = STATE(1663),
    [sym_do_statement] = STATE(1663),
    [sym_for_statement] = STATE(1663),
    [sym_return_statement] = STATE(1663),
    [sym_break_statement] = STATE(1663),
    [sym_continue_statement] = STATE(1663),
    [sym_goto_statement] = STATE(1663),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(1663),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1663),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(1663),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1663),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1015] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(726),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(726),
    [sym_preproc_directive] = ACTIONS(726),
    [anon_sym_typedef] = ACTIONS(726),
    [anon_sym_extern] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_register] = ACTIONS(726),
    [anon_sym_inline] = ACTIONS(726),
    [anon_sym_const] = ACTIONS(726),
    [anon_sym_restrict] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym__Atomic] = ACTIONS(726),
    [anon_sym_mutable] = ACTIONS(726),
    [anon_sym_explicit] = ACTIONS(726),
    [anon_sym_constexpr] = ACTIONS(726),
    [anon_sym_unsigned] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [sym_primitive_type] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(726),
    [anon_sym_union] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(726),
    [sym_auto] = ACTIONS(726),
    [anon_sym_typename] = ACTIONS(726),
    [anon_sym_template] = ACTIONS(726),
    [anon_sym_namespace] = ACTIONS(726),
    [anon_sym_using] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(724),
    [sym_operator_name] = ACTIONS(724),
  },
  [1016] = {
    [sym_compound_statement] = STATE(1664),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(49),
  },
  [1017] = {
    [sym_preproc_include] = STATE(1017),
    [sym_preproc_def] = STATE(1017),
    [sym_preproc_function_def] = STATE(1017),
    [sym_preproc_call] = STATE(1017),
    [sym_preproc_if] = STATE(1017),
    [sym_preproc_ifdef] = STATE(1017),
    [sym_function_definition] = STATE(1017),
    [sym_declaration] = STATE(1017),
    [sym_type_definition] = STATE(1017),
    [sym__declaration_specifiers] = STATE(477),
    [sym_linkage_specification] = STATE(1017),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(478),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(481),
    [sym_type_qualifier] = STATE(481),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(1017),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1017),
    [sym_template_declaration] = STATE(1017),
    [sym_template_instantiation] = STATE(1017),
    [sym_constructor_or_destructor_definition] = STATE(479),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(1017),
    [sym_using_declaration] = STATE(1017),
    [sym_alias_declaration] = STATE(1017),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(1017),
    [aux_sym__declaration_specifiers_repeat1] = STATE(481),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3518),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(752),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3530),
    [sym_preproc_directive] = ACTIONS(3533),
    [anon_sym_typedef] = ACTIONS(3536),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(776),
    [anon_sym_register] = ACTIONS(776),
    [anon_sym_inline] = ACTIONS(776),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_restrict] = ACTIONS(779),
    [anon_sym_volatile] = ACTIONS(779),
    [anon_sym__Atomic] = ACTIONS(779),
    [anon_sym_mutable] = ACTIONS(779),
    [anon_sym_explicit] = ACTIONS(779),
    [anon_sym_constexpr] = ACTIONS(779),
    [anon_sym_unsigned] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(803),
    [sym_identifier] = ACTIONS(806),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(809),
    [sym_auto] = ACTIONS(785),
    [anon_sym_typename] = ACTIONS(812),
    [anon_sym_template] = ACTIONS(3542),
    [anon_sym_namespace] = ACTIONS(3545),
    [anon_sym_using] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(824),
    [sym_operator_name] = ACTIONS(827),
  },
  [1018] = {
    [sym_compound_statement] = STATE(1664),
    [sym_field_initializer_list] = STATE(1665),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(222),
    [sym_comment] = ACTIONS(49),
  },
  [1019] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3551),
    [sym_comment] = ACTIONS(49),
  },
  [1020] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(1666),
    [sym_preproc_elif] = STATE(1666),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3553),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1021] = {
    [anon_sym_LF] = ACTIONS(3555),
    [sym_comment] = ACTIONS(83),
  },
  [1022] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1023] = {
    [sym__type_declarator] = STATE(1669),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [1024] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1021),
    [sym_preproc_directive] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_register] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_restrict] = ACTIONS(1021),
    [anon_sym_volatile] = ACTIONS(1021),
    [anon_sym__Atomic] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1021),
    [anon_sym_explicit] = ACTIONS(1021),
    [anon_sym_constexpr] = ACTIONS(1021),
    [anon_sym_unsigned] = ACTIONS(1021),
    [anon_sym_long] = ACTIONS(1021),
    [anon_sym_short] = ACTIONS(1021),
    [sym_primitive_type] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1021),
    [sym_auto] = ACTIONS(1021),
    [anon_sym_typename] = ACTIONS(1021),
    [anon_sym_template] = ACTIONS(1021),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_using] = ACTIONS(1021),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [sym_operator_name] = ACTIONS(1019),
  },
  [1025] = {
    [sym__declarator] = STATE(499),
    [sym_pointer_declarator] = STATE(499),
    [sym_function_declarator] = STATE(499),
    [sym_array_declarator] = STATE(499),
    [sym_init_declarator] = STATE(500),
    [sym_reference_declarator] = STATE(499),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(499),
    [sym_destructor_name] = STATE(499),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(945),
  },
  [1026] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [1027] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1242),
    [sym_preproc_directive] = ACTIONS(1242),
    [anon_sym_typedef] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_register] = ACTIONS(1242),
    [anon_sym_inline] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_restrict] = ACTIONS(1242),
    [anon_sym_volatile] = ACTIONS(1242),
    [anon_sym__Atomic] = ACTIONS(1242),
    [anon_sym_mutable] = ACTIONS(1242),
    [anon_sym_explicit] = ACTIONS(1242),
    [anon_sym_constexpr] = ACTIONS(1242),
    [anon_sym_unsigned] = ACTIONS(1242),
    [anon_sym_long] = ACTIONS(1242),
    [anon_sym_short] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1242),
    [sym_auto] = ACTIONS(1242),
    [anon_sym_typename] = ACTIONS(1242),
    [anon_sym_template] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(1242),
    [anon_sym_using] = ACTIONS(1242),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [sym_operator_name] = ACTIONS(1240),
  },
  [1028] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_typedef] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1248),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_register] = ACTIONS(1250),
    [anon_sym_inline] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_restrict] = ACTIONS(1250),
    [anon_sym_volatile] = ACTIONS(1250),
    [anon_sym__Atomic] = ACTIONS(1250),
    [anon_sym_mutable] = ACTIONS(1250),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_constexpr] = ACTIONS(1250),
    [anon_sym_unsigned] = ACTIONS(1250),
    [anon_sym_long] = ACTIONS(1250),
    [anon_sym_short] = ACTIONS(1250),
    [sym_primitive_type] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1250),
    [sym_auto] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(1250),
    [anon_sym_template] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [sym_operator_name] = ACTIONS(1248),
  },
  [1029] = {
    [sym__declarator] = STATE(499),
    [sym_pointer_declarator] = STATE(499),
    [sym_function_declarator] = STATE(499),
    [sym_array_declarator] = STATE(499),
    [sym_init_declarator] = STATE(500),
    [sym_reference_declarator] = STATE(499),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(499),
    [sym_destructor_name] = STATE(499),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(945),
  },
  [1030] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym_mutable] = ACTIONS(1269),
    [anon_sym_explicit] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1269),
    [sym_auto] = ACTIONS(1269),
    [anon_sym_typename] = ACTIONS(1269),
    [anon_sym_template] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_using] = ACTIONS(1269),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_operator_name] = ACTIONS(1267),
  },
  [1031] = {
    [sym_preproc_include] = STATE(671),
    [sym_preproc_def] = STATE(671),
    [sym_preproc_function_def] = STATE(671),
    [sym_preproc_call] = STATE(671),
    [sym_preproc_if] = STATE(671),
    [sym_preproc_ifdef] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_type_definition] = STATE(671),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(671),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(671),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(671),
    [sym_template_declaration] = STATE(671),
    [sym_template_instantiation] = STATE(671),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(671),
    [sym_using_declaration] = STATE(671),
    [sym_alias_declaration] = STATE(671),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(671),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1032] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1275),
    [sym_preproc_directive] = ACTIONS(1275),
    [anon_sym_typedef] = ACTIONS(1275),
    [anon_sym_extern] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1275),
    [anon_sym_register] = ACTIONS(1275),
    [anon_sym_inline] = ACTIONS(1275),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_restrict] = ACTIONS(1275),
    [anon_sym_volatile] = ACTIONS(1275),
    [anon_sym__Atomic] = ACTIONS(1275),
    [anon_sym_mutable] = ACTIONS(1275),
    [anon_sym_explicit] = ACTIONS(1275),
    [anon_sym_constexpr] = ACTIONS(1275),
    [anon_sym_unsigned] = ACTIONS(1275),
    [anon_sym_long] = ACTIONS(1275),
    [anon_sym_short] = ACTIONS(1275),
    [sym_primitive_type] = ACTIONS(1275),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_struct] = ACTIONS(1275),
    [anon_sym_union] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_identifier] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1275),
    [sym_auto] = ACTIONS(1275),
    [anon_sym_typename] = ACTIONS(1275),
    [anon_sym_template] = ACTIONS(1275),
    [anon_sym_namespace] = ACTIONS(1275),
    [anon_sym_using] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1273),
    [sym_operator_name] = ACTIONS(1273),
  },
  [1033] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1279),
    [sym_preproc_directive] = ACTIONS(1279),
    [anon_sym_typedef] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1279),
    [anon_sym_register] = ACTIONS(1279),
    [anon_sym_inline] = ACTIONS(1279),
    [anon_sym_const] = ACTIONS(1279),
    [anon_sym_restrict] = ACTIONS(1279),
    [anon_sym_volatile] = ACTIONS(1279),
    [anon_sym__Atomic] = ACTIONS(1279),
    [anon_sym_mutable] = ACTIONS(1279),
    [anon_sym_explicit] = ACTIONS(1279),
    [anon_sym_constexpr] = ACTIONS(1279),
    [anon_sym_unsigned] = ACTIONS(1279),
    [anon_sym_long] = ACTIONS(1279),
    [anon_sym_short] = ACTIONS(1279),
    [sym_primitive_type] = ACTIONS(1279),
    [anon_sym_enum] = ACTIONS(1279),
    [anon_sym_struct] = ACTIONS(1279),
    [anon_sym_union] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_TILDE] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1279),
    [sym_auto] = ACTIONS(1279),
    [anon_sym_typename] = ACTIONS(1279),
    [anon_sym_template] = ACTIONS(1279),
    [anon_sym_namespace] = ACTIONS(1279),
    [anon_sym_using] = ACTIONS(1279),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_operator_name] = ACTIONS(1277),
  },
  [1034] = {
    [sym_type_qualifier] = STATE(675),
    [sym__type_specifier] = STATE(673),
    [sym_sized_type_specifier] = STATE(673),
    [sym_enum_specifier] = STATE(673),
    [sym_struct_specifier] = STATE(673),
    [sym_union_specifier] = STATE(673),
    [sym_type_descriptor] = STATE(1672),
    [sym_macro_type_specifier] = STATE(673),
    [sym_class_specifier] = STATE(673),
    [sym_dependent_type] = STATE(673),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(675),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1283),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1035] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [1036] = {
    [anon_sym_SEMI] = ACTIONS(3563),
    [sym_comment] = ACTIONS(49),
  },
  [1037] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_template] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [sym_operator_name] = ACTIONS(1311),
  },
  [1038] = {
    [sym_preproc_include] = STATE(1046),
    [sym_preproc_def] = STATE(1046),
    [sym_preproc_function_def] = STATE(1046),
    [sym_preproc_call] = STATE(1046),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1046),
    [sym_type_definition] = STATE(1046),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1046),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_if_statement] = STATE(1046),
    [sym_switch_statement] = STATE(1046),
    [sym_case_statement] = STATE(1046),
    [sym_while_statement] = STATE(1046),
    [sym_do_statement] = STATE(1046),
    [sym_for_statement] = STATE(1046),
    [sym_return_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_goto_statement] = STATE(1046),
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(706),
    [sym__empty_declaration] = STATE(1046),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1046),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(706),
    [sym_for_range_loop] = STATE(1046),
    [sym_new_expression] = STATE(706),
    [sym_delete_expression] = STATE(706),
    [sym_lambda_expression] = STATE(706),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1046),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1315),
    [sym_char_literal] = ACTIONS(1315),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1343),
  },
  [1039] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym_mutable] = ACTIONS(1357),
    [anon_sym_explicit] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1357),
    [sym_auto] = ACTIONS(1357),
    [anon_sym_typename] = ACTIONS(1357),
    [anon_sym_template] = ACTIONS(1357),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_using] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1355),
    [sym_operator_name] = ACTIONS(1355),
  },
  [1040] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3567),
    [sym_comment] = ACTIONS(49),
  },
  [1041] = {
    [sym__expression] = STATE(1676),
    [sym_conditional_expression] = STATE(1676),
    [sym_assignment_expression] = STATE(1676),
    [sym_pointer_expression] = STATE(1676),
    [sym_logical_expression] = STATE(1676),
    [sym_bitwise_expression] = STATE(1676),
    [sym_equality_expression] = STATE(1676),
    [sym_relational_expression] = STATE(1676),
    [sym_shift_expression] = STATE(1676),
    [sym_math_expression] = STATE(1676),
    [sym_cast_expression] = STATE(1676),
    [sym_sizeof_expression] = STATE(1676),
    [sym_subscript_expression] = STATE(1676),
    [sym_call_expression] = STATE(1676),
    [sym_field_expression] = STATE(1676),
    [sym_compound_literal_expression] = STATE(1676),
    [sym_parenthesized_expression] = STATE(1676),
    [sym_initializer_list] = STATE(1677),
    [sym_concatenated_string] = STATE(1676),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1676),
    [sym_new_expression] = STATE(1676),
    [sym_delete_expression] = STATE(1676),
    [sym_lambda_expression] = STATE(1676),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(3569),
    [sym_char_literal] = ACTIONS(3569),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [sym_null] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(3571),
  },
  [1042] = {
    [anon_sym_SEMI] = ACTIONS(3573),
    [sym_comment] = ACTIONS(49),
  },
  [1043] = {
    [sym__expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_assignment_expression] = STATE(1679),
    [sym_pointer_expression] = STATE(1679),
    [sym_logical_expression] = STATE(1679),
    [sym_bitwise_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_math_expression] = STATE(1679),
    [sym_cast_expression] = STATE(1679),
    [sym_sizeof_expression] = STATE(1679),
    [sym_subscript_expression] = STATE(1679),
    [sym_call_expression] = STATE(1679),
    [sym_field_expression] = STATE(1679),
    [sym_compound_literal_expression] = STATE(1679),
    [sym_parenthesized_expression] = STATE(1679),
    [sym_initializer_list] = STATE(1680),
    [sym_concatenated_string] = STATE(1679),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1679),
    [sym_new_expression] = STATE(1679),
    [sym_delete_expression] = STATE(1679),
    [sym_lambda_expression] = STATE(1679),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(3575),
    [sym_char_literal] = ACTIONS(3575),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(3577),
    [sym_false] = ACTIONS(3577),
    [sym_null] = ACTIONS(3577),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(3577),
  },
  [1044] = {
    [anon_sym_SEMI] = ACTIONS(3579),
    [sym_comment] = ACTIONS(49),
  },
  [1045] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [1046] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1047] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1848),
    [sym_preproc_directive] = ACTIONS(1848),
    [anon_sym_typedef] = ACTIONS(1848),
    [anon_sym_extern] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_register] = ACTIONS(1848),
    [anon_sym_inline] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_restrict] = ACTIONS(1848),
    [anon_sym_volatile] = ACTIONS(1848),
    [anon_sym__Atomic] = ACTIONS(1848),
    [anon_sym_mutable] = ACTIONS(1848),
    [anon_sym_explicit] = ACTIONS(1848),
    [anon_sym_constexpr] = ACTIONS(1848),
    [anon_sym_unsigned] = ACTIONS(1848),
    [anon_sym_long] = ACTIONS(1848),
    [anon_sym_short] = ACTIONS(1848),
    [sym_primitive_type] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_struct] = ACTIONS(1848),
    [anon_sym_union] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1848),
    [sym_auto] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1848),
    [anon_sym_template] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1848),
    [anon_sym_using] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1846),
    [sym_operator_name] = ACTIONS(1846),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(3583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3585),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3585),
    [sym_auto] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [sym_operator_name] = ACTIONS(3583),
  },
  [1049] = {
    [sym_compound_statement] = STATE(1683),
    [anon_sym_LBRACE] = ACTIONS(947),
    [sym_comment] = ACTIONS(49),
  },
  [1050] = {
    [ts_builtin_sym_end] = ACTIONS(3587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3589),
    [sym_preproc_directive] = ACTIONS(3589),
    [anon_sym_typedef] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_register] = ACTIONS(3589),
    [anon_sym_inline] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_restrict] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym__Atomic] = ACTIONS(3589),
    [anon_sym_mutable] = ACTIONS(3589),
    [anon_sym_explicit] = ACTIONS(3589),
    [anon_sym_constexpr] = ACTIONS(3589),
    [anon_sym_unsigned] = ACTIONS(3589),
    [anon_sym_long] = ACTIONS(3589),
    [anon_sym_short] = ACTIONS(3589),
    [sym_primitive_type] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_union] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3589),
    [sym_auto] = ACTIONS(3589),
    [anon_sym_typename] = ACTIONS(3589),
    [anon_sym_template] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [sym_operator_name] = ACTIONS(3587),
  },
  [1051] = {
    [ts_builtin_sym_end] = ACTIONS(3591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3593),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3593),
    [sym_auto] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3591),
    [sym_operator_name] = ACTIONS(3591),
  },
  [1052] = {
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2074),
    [sym_comment] = ACTIONS(49),
  },
  [1053] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1054] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(49),
  },
  [1055] = {
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2178),
    [sym_comment] = ACTIONS(49),
  },
  [1056] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
  },
  [1057] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1687),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(3599),
    [sym_comment] = ACTIONS(49),
  },
  [1058] = {
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_LT] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1188),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [1059] = {
    [anon_sym_LPAREN] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
  },
  [1060] = {
    [sym_field_declaration_list] = STATE(1688),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [1061] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [1062] = {
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [sym_identifier] = ACTIONS(2272),
    [sym_comment] = ACTIONS(49),
  },
  [1063] = {
    [sym_field_declaration_list] = STATE(1689),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [1064] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2362),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
  },
  [1065] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(3601),
    [sym_comment] = ACTIONS(49),
  },
  [1066] = {
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2371),
    [sym_comment] = ACTIONS(49),
  },
  [1067] = {
    [sym_field_declaration_list] = STATE(1691),
    [anon_sym_LBRACE] = ACTIONS(323),
    [sym_comment] = ACTIONS(49),
  },
  [1068] = {
    [anon_sym_LPAREN] = ACTIONS(3603),
    [anon_sym_RPAREN] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [sym_comment] = ACTIONS(49),
  },
  [1069] = {
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_RPAREN] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [sym_comment] = ACTIONS(49),
  },
  [1070] = {
    [sym__expression] = STATE(1693),
    [sym_conditional_expression] = STATE(1693),
    [sym_assignment_expression] = STATE(1693),
    [sym_pointer_expression] = STATE(1693),
    [sym_logical_expression] = STATE(1693),
    [sym_bitwise_expression] = STATE(1693),
    [sym_equality_expression] = STATE(1693),
    [sym_relational_expression] = STATE(1693),
    [sym_shift_expression] = STATE(1693),
    [sym_math_expression] = STATE(1693),
    [sym_cast_expression] = STATE(1693),
    [sym_sizeof_expression] = STATE(1693),
    [sym_subscript_expression] = STATE(1693),
    [sym_call_expression] = STATE(1693),
    [sym_field_expression] = STATE(1693),
    [sym_compound_literal_expression] = STATE(1693),
    [sym_parenthesized_expression] = STATE(1693),
    [sym_concatenated_string] = STATE(1693),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1693),
    [sym_new_expression] = STATE(1693),
    [sym_delete_expression] = STATE(1693),
    [sym_lambda_expression] = STATE(1693),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3607),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [sym_null] = ACTIONS(3611),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(3611),
  },
  [1071] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(3609),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [sym_operator_name] = ACTIONS(3613),
  },
  [1073] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1075),
    [anon_sym_unsigned] = ACTIONS(2066),
    [anon_sym_long] = ACTIONS(2066),
    [anon_sym_short] = ACTIONS(2066),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2070),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1074] = {
    [sym__abstract_declarator] = STATE(1696),
    [sym_abstract_pointer_declarator] = STATE(1696),
    [sym_abstract_function_declarator] = STATE(1696),
    [sym_abstract_array_declarator] = STATE(1696),
    [sym_parameter_list] = STATE(1697),
    [sym_abstract_reference_declarator] = STATE(1696),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [1075] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1698),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [1076] = {
    [sym_type_qualifier] = STATE(1076),
    [sym_trailing_return_type] = STATE(1076),
    [aux_sym_function_declarator_repeat1] = STATE(1076),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_DASH_GT] = ACTIONS(3625),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3628),
  },
  [1077] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1078] = {
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RPAREN] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_COLON] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [sym_operator_name] = ACTIONS(3633),
  },
  [1079] = {
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [sym_comment] = ACTIONS(49),
  },
  [1080] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1081] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [sym_comment] = ACTIONS(49),
  },
  [1082] = {
    [anon_sym_LPAREN] = ACTIONS(3644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3646),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3644),
    [anon_sym_typedef] = ACTIONS(3646),
    [anon_sym_extern] = ACTIONS(3646),
    [anon_sym_RBRACE] = ACTIONS(3644),
    [anon_sym_STAR] = ACTIONS(3644),
    [anon_sym_static] = ACTIONS(3646),
    [anon_sym_register] = ACTIONS(3646),
    [anon_sym_inline] = ACTIONS(3646),
    [anon_sym_const] = ACTIONS(3646),
    [anon_sym_restrict] = ACTIONS(3646),
    [anon_sym_volatile] = ACTIONS(3646),
    [anon_sym__Atomic] = ACTIONS(3646),
    [anon_sym_mutable] = ACTIONS(3646),
    [anon_sym_explicit] = ACTIONS(3646),
    [anon_sym_constexpr] = ACTIONS(3646),
    [anon_sym_unsigned] = ACTIONS(3646),
    [anon_sym_long] = ACTIONS(3646),
    [anon_sym_short] = ACTIONS(3646),
    [sym_primitive_type] = ACTIONS(3646),
    [anon_sym_enum] = ACTIONS(3646),
    [anon_sym_struct] = ACTIONS(3646),
    [anon_sym_union] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3644),
    [anon_sym_TILDE] = ACTIONS(3644),
    [sym_identifier] = ACTIONS(3646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3646),
    [anon_sym_public] = ACTIONS(3646),
    [sym_auto] = ACTIONS(3646),
    [anon_sym_typename] = ACTIONS(3646),
    [anon_sym_template] = ACTIONS(3646),
    [anon_sym_friend] = ACTIONS(3646),
    [anon_sym_private] = ACTIONS(3646),
    [anon_sym_protected] = ACTIONS(3646),
    [anon_sym_using] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [sym_operator_name] = ACTIONS(3644),
  },
  [1083] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(1701),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1701),
    [sym_field_declaration] = STATE(1701),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1701),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1701),
    [sym_access_specifier] = STATE(1701),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1701),
    [sym_alias_declaration] = STATE(1701),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3648),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1084] = {
    [sym_preproc_arg] = ACTIONS(3650),
    [sym_comment] = ACTIONS(83),
  },
  [1085] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3652),
    [sym_comment] = ACTIONS(49),
  },
  [1086] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3654),
    [sym_comment] = ACTIONS(49),
  },
  [1087] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1706),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1707),
    [sym_type_definition] = STATE(1708),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1708),
    [sym_field_declaration] = STATE(1708),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1708),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1708),
    [sym_access_specifier] = STATE(1708),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1708),
    [sym_alias_declaration] = STATE(1708),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1708),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3656),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1088] = {
    [anon_sym_LPAREN] = ACTIONS(3658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3658),
    [anon_sym_typedef] = ACTIONS(3660),
    [anon_sym_extern] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(3658),
    [anon_sym_static] = ACTIONS(3660),
    [anon_sym_register] = ACTIONS(3660),
    [anon_sym_inline] = ACTIONS(3660),
    [anon_sym_const] = ACTIONS(3660),
    [anon_sym_restrict] = ACTIONS(3660),
    [anon_sym_volatile] = ACTIONS(3660),
    [anon_sym__Atomic] = ACTIONS(3660),
    [anon_sym_mutable] = ACTIONS(3660),
    [anon_sym_explicit] = ACTIONS(3660),
    [anon_sym_constexpr] = ACTIONS(3660),
    [anon_sym_unsigned] = ACTIONS(3660),
    [anon_sym_long] = ACTIONS(3660),
    [anon_sym_short] = ACTIONS(3660),
    [sym_primitive_type] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3660),
    [anon_sym_struct] = ACTIONS(3660),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3660),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3660),
    [anon_sym_public] = ACTIONS(3660),
    [sym_auto] = ACTIONS(3660),
    [anon_sym_typename] = ACTIONS(3660),
    [anon_sym_template] = ACTIONS(3660),
    [anon_sym_friend] = ACTIONS(3660),
    [anon_sym_private] = ACTIONS(3660),
    [anon_sym_protected] = ACTIONS(3660),
    [anon_sym_using] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [sym_operator_name] = ACTIONS(3658),
  },
  [1089] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3662),
    [sym_comment] = ACTIONS(49),
  },
  [1090] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3664),
    [sym_comment] = ACTIONS(49),
  },
  [1091] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1712),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1713),
    [sym_type_definition] = STATE(1708),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1708),
    [sym_field_declaration] = STATE(1708),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1708),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1708),
    [sym_access_specifier] = STATE(1708),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1708),
    [sym_alias_declaration] = STATE(1708),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1708),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3666),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1092] = {
    [anon_sym_LPAREN] = ACTIONS(3668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3668),
    [anon_sym_typedef] = ACTIONS(3670),
    [anon_sym_extern] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_static] = ACTIONS(3670),
    [anon_sym_register] = ACTIONS(3670),
    [anon_sym_inline] = ACTIONS(3670),
    [anon_sym_const] = ACTIONS(3670),
    [anon_sym_restrict] = ACTIONS(3670),
    [anon_sym_volatile] = ACTIONS(3670),
    [anon_sym__Atomic] = ACTIONS(3670),
    [anon_sym_mutable] = ACTIONS(3670),
    [anon_sym_explicit] = ACTIONS(3670),
    [anon_sym_constexpr] = ACTIONS(3670),
    [anon_sym_unsigned] = ACTIONS(3670),
    [anon_sym_long] = ACTIONS(3670),
    [anon_sym_short] = ACTIONS(3670),
    [sym_primitive_type] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(3670),
    [anon_sym_union] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_TILDE] = ACTIONS(3668),
    [sym_identifier] = ACTIONS(3670),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3670),
    [anon_sym_public] = ACTIONS(3670),
    [sym_auto] = ACTIONS(3670),
    [anon_sym_typename] = ACTIONS(3670),
    [anon_sym_template] = ACTIONS(3670),
    [anon_sym_friend] = ACTIONS(3670),
    [anon_sym_private] = ACTIONS(3670),
    [anon_sym_protected] = ACTIONS(3670),
    [anon_sym_using] = ACTIONS(3670),
    [anon_sym_COLON_COLON] = ACTIONS(3668),
    [sym_operator_name] = ACTIONS(3668),
  },
  [1093] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3672),
    [sym_comment] = ACTIONS(49),
  },
  [1094] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(49),
  },
  [1095] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(1717),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1718),
    [sym_type_definition] = STATE(1708),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1708),
    [sym_field_declaration] = STATE(1708),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1708),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1708),
    [sym_access_specifier] = STATE(1708),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1708),
    [sym_alias_declaration] = STATE(1708),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1708),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3676),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1096] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1097] = {
    [sym__type_declarator] = STATE(1720),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [1098] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1183),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [1099] = {
    [anon_sym_LPAREN] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1248),
    [anon_sym_typedef] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(1248),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_register] = ACTIONS(1250),
    [anon_sym_inline] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_restrict] = ACTIONS(1250),
    [anon_sym_volatile] = ACTIONS(1250),
    [anon_sym__Atomic] = ACTIONS(1250),
    [anon_sym_mutable] = ACTIONS(1250),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_constexpr] = ACTIONS(1250),
    [anon_sym_unsigned] = ACTIONS(1250),
    [anon_sym_long] = ACTIONS(1250),
    [anon_sym_short] = ACTIONS(1250),
    [sym_primitive_type] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1250),
    [anon_sym_public] = ACTIONS(1250),
    [sym_auto] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(1250),
    [anon_sym_template] = ACTIONS(1250),
    [anon_sym_friend] = ACTIONS(1250),
    [anon_sym_private] = ACTIONS(1250),
    [anon_sym_protected] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [sym_operator_name] = ACTIONS(1248),
  },
  [1100] = {
    [sym__declarator] = STATE(1101),
    [sym_pointer_declarator] = STATE(1101),
    [sym_function_declarator] = STATE(1101),
    [sym_array_declarator] = STATE(1101),
    [sym_init_declarator] = STATE(1102),
    [sym_reference_declarator] = STATE(1101),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1101),
    [sym_destructor_name] = STATE(1101),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(2108),
  },
  [1101] = {
    [sym_compound_statement] = STATE(1724),
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(1725),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3682),
    [anon_sym_LBRACE] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [1102] = {
    [aux_sym_declaration_repeat1] = STATE(1725),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(3682),
    [sym_comment] = ACTIONS(49),
  },
  [1103] = {
    [anon_sym_LPAREN] = ACTIONS(3686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3686),
    [anon_sym_typedef] = ACTIONS(3688),
    [anon_sym_extern] = ACTIONS(3688),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_static] = ACTIONS(3688),
    [anon_sym_register] = ACTIONS(3688),
    [anon_sym_inline] = ACTIONS(3688),
    [anon_sym_const] = ACTIONS(3688),
    [anon_sym_restrict] = ACTIONS(3688),
    [anon_sym_volatile] = ACTIONS(3688),
    [anon_sym__Atomic] = ACTIONS(3688),
    [anon_sym_mutable] = ACTIONS(3688),
    [anon_sym_explicit] = ACTIONS(3688),
    [anon_sym_constexpr] = ACTIONS(3688),
    [anon_sym_unsigned] = ACTIONS(3688),
    [anon_sym_long] = ACTIONS(3688),
    [anon_sym_short] = ACTIONS(3688),
    [sym_primitive_type] = ACTIONS(3688),
    [anon_sym_enum] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(3688),
    [anon_sym_union] = ACTIONS(3688),
    [anon_sym_AMP] = ACTIONS(3688),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_TILDE] = ACTIONS(3686),
    [sym_identifier] = ACTIONS(3688),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3688),
    [anon_sym_public] = ACTIONS(3688),
    [sym_auto] = ACTIONS(3688),
    [anon_sym_typename] = ACTIONS(3688),
    [anon_sym_template] = ACTIONS(3688),
    [anon_sym_friend] = ACTIONS(3688),
    [anon_sym_private] = ACTIONS(3688),
    [anon_sym_protected] = ACTIONS(3688),
    [anon_sym_using] = ACTIONS(3688),
    [anon_sym_COLON_COLON] = ACTIONS(3686),
    [sym_operator_name] = ACTIONS(3686),
  },
  [1104] = {
    [anon_sym_LPAREN] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1279),
    [anon_sym_register] = ACTIONS(1279),
    [anon_sym_inline] = ACTIONS(1279),
    [anon_sym_const] = ACTIONS(1279),
    [anon_sym_restrict] = ACTIONS(1279),
    [anon_sym_volatile] = ACTIONS(1279),
    [anon_sym__Atomic] = ACTIONS(1279),
    [anon_sym_mutable] = ACTIONS(1279),
    [anon_sym_explicit] = ACTIONS(1279),
    [anon_sym_constexpr] = ACTIONS(1279),
    [anon_sym_unsigned] = ACTIONS(1279),
    [anon_sym_long] = ACTIONS(1279),
    [anon_sym_short] = ACTIONS(1279),
    [sym_primitive_type] = ACTIONS(1279),
    [anon_sym_enum] = ACTIONS(1279),
    [anon_sym_struct] = ACTIONS(1279),
    [anon_sym_union] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_TILDE] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1279),
    [anon_sym_public] = ACTIONS(1279),
    [sym_auto] = ACTIONS(1279),
    [anon_sym_typename] = ACTIONS(1279),
    [anon_sym_template] = ACTIONS(1279),
    [anon_sym_friend] = ACTIONS(1279),
    [anon_sym_private] = ACTIONS(1279),
    [anon_sym_protected] = ACTIONS(1279),
    [anon_sym_using] = ACTIONS(1279),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_operator_name] = ACTIONS(1277),
  },
  [1105] = {
    [sym_type_qualifier] = STATE(675),
    [sym__type_specifier] = STATE(673),
    [sym_sized_type_specifier] = STATE(673),
    [sym_enum_specifier] = STATE(673),
    [sym_struct_specifier] = STATE(673),
    [sym_union_specifier] = STATE(673),
    [sym_type_descriptor] = STATE(1726),
    [sym_macro_type_specifier] = STATE(673),
    [sym_class_specifier] = STATE(673),
    [sym_dependent_type] = STATE(673),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(675),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1283),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1106] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(3690),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [1107] = {
    [anon_sym_SEMI] = ACTIONS(3690),
    [sym_comment] = ACTIONS(49),
  },
  [1108] = {
    [sym__field_declarator] = STATE(1728),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1728),
    [sym_scoped_field_identifier] = STATE(1111),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(3692),
  },
  [1109] = {
    [sym__field_declarator] = STATE(1729),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1729),
    [sym_scoped_field_identifier] = STATE(1111),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(3694),
  },
  [1110] = {
    [sym_parameter_list] = STATE(1731),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3696),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [sym_comment] = ACTIONS(49),
  },
  [1111] = {
    [sym_template_argument_list] = STATE(1127),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [1112] = {
    [sym_parameter_list] = STATE(1123),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(3698),
    [sym_comment] = ACTIONS(49),
  },
  [1113] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1114] = {
    [sym_parameter_list] = STATE(1123),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3702),
    [anon_sym_SEMI] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(3702),
    [sym_comment] = ACTIONS(49),
  },
  [1115] = {
    [sym_destructor_name] = STATE(1600),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3704),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3414),
  },
  [1116] = {
    [anon_sym_LPAREN] = ACTIONS(3706),
    [anon_sym_COMMA] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(3706),
    [anon_sym_SEMI] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3706),
    [anon_sym_RBRACE] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3708),
    [anon_sym_LBRACK] = ACTIONS(3706),
    [anon_sym_RBRACK] = ACTIONS(3706),
    [anon_sym_EQ] = ACTIONS(3708),
    [anon_sym_COLON] = ACTIONS(3708),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_STAR_EQ] = ACTIONS(3706),
    [anon_sym_SLASH_EQ] = ACTIONS(3706),
    [anon_sym_PERCENT_EQ] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3706),
    [anon_sym_DASH_EQ] = ACTIONS(3706),
    [anon_sym_LT_LT_EQ] = ACTIONS(3706),
    [anon_sym_GT_GT_EQ] = ACTIONS(3706),
    [anon_sym_AMP_EQ] = ACTIONS(3706),
    [anon_sym_CARET_EQ] = ACTIONS(3706),
    [anon_sym_PIPE_EQ] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3708),
    [anon_sym_PIPE_PIPE] = ACTIONS(3706),
    [anon_sym_AMP_AMP] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_EQ_EQ] = ACTIONS(3706),
    [anon_sym_BANG_EQ] = ACTIONS(3706),
    [anon_sym_LT] = ACTIONS(3708),
    [anon_sym_GT] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3706),
    [anon_sym_GT_EQ] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3708),
    [anon_sym_GT_GT] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3708),
    [anon_sym_DASH] = ACTIONS(3708),
    [anon_sym_SLASH] = ACTIONS(3708),
    [anon_sym_PERCENT] = ACTIONS(3708),
    [anon_sym_DASH_DASH] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3706),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [1117] = {
    [anon_sym_LT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1118] = {
    [sym__field_declarator] = STATE(1736),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1736),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(3719),
  },
  [1119] = {
    [anon_sym_LPAREN] = ACTIONS(3721),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3723),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3721),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3721),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3721),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3721),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3721),
    [anon_sym_typedef] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_register] = ACTIONS(3723),
    [anon_sym_inline] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_restrict] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym__Atomic] = ACTIONS(3723),
    [anon_sym_mutable] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_constexpr] = ACTIONS(3723),
    [anon_sym_unsigned] = ACTIONS(3723),
    [anon_sym_long] = ACTIONS(3723),
    [anon_sym_short] = ACTIONS(3723),
    [sym_primitive_type] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_union] = ACTIONS(3723),
    [anon_sym_AMP] = ACTIONS(3723),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [sym_identifier] = ACTIONS(3723),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_public] = ACTIONS(3723),
    [sym_auto] = ACTIONS(3723),
    [anon_sym_typename] = ACTIONS(3723),
    [anon_sym_template] = ACTIONS(3723),
    [anon_sym_friend] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(3723),
    [anon_sym_protected] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [sym_operator_name] = ACTIONS(3721),
  },
  [1120] = {
    [sym__declaration_specifiers] = STATE(1738),
    [sym_storage_class_specifier] = STATE(395),
    [sym_type_qualifier] = STATE(395),
    [sym__type_specifier] = STATE(388),
    [sym_sized_type_specifier] = STATE(388),
    [sym_enum_specifier] = STATE(388),
    [sym_struct_specifier] = STATE(388),
    [sym_union_specifier] = STATE(388),
    [sym__expression] = STATE(1739),
    [sym_conditional_expression] = STATE(1739),
    [sym_assignment_expression] = STATE(1739),
    [sym_pointer_expression] = STATE(1739),
    [sym_logical_expression] = STATE(1739),
    [sym_bitwise_expression] = STATE(1739),
    [sym_equality_expression] = STATE(1739),
    [sym_relational_expression] = STATE(1739),
    [sym_shift_expression] = STATE(1739),
    [sym_math_expression] = STATE(1739),
    [sym_cast_expression] = STATE(1739),
    [sym_sizeof_expression] = STATE(1739),
    [sym_subscript_expression] = STATE(1739),
    [sym_call_expression] = STATE(1739),
    [sym_field_expression] = STATE(1739),
    [sym_compound_literal_expression] = STATE(1739),
    [sym_parenthesized_expression] = STATE(1739),
    [sym_concatenated_string] = STATE(1739),
    [sym_macro_type_specifier] = STATE(388),
    [sym_class_specifier] = STATE(388),
    [sym_dependent_type] = STATE(388),
    [sym_template_type] = STATE(390),
    [sym_template_function] = STATE(1739),
    [sym_new_expression] = STATE(1739),
    [sym_delete_expression] = STATE(1739),
    [sym_lambda_expression] = STATE(1739),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(393),
    [sym_scoped_namespace_identifier] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [sym_raw_string_literal] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(3725),
    [sym_char_literal] = ACTIONS(3725),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(3729),
    [sym_false] = ACTIONS(3729),
    [sym_null] = ACTIONS(3729),
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(608),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(3729),
  },
  [1121] = {
    [sym__expression] = STATE(1740),
    [sym_conditional_expression] = STATE(1740),
    [sym_assignment_expression] = STATE(1740),
    [sym_pointer_expression] = STATE(1740),
    [sym_logical_expression] = STATE(1740),
    [sym_bitwise_expression] = STATE(1740),
    [sym_equality_expression] = STATE(1740),
    [sym_relational_expression] = STATE(1740),
    [sym_shift_expression] = STATE(1740),
    [sym_math_expression] = STATE(1740),
    [sym_cast_expression] = STATE(1740),
    [sym_sizeof_expression] = STATE(1740),
    [sym_subscript_expression] = STATE(1740),
    [sym_call_expression] = STATE(1740),
    [sym_field_expression] = STATE(1740),
    [sym_compound_literal_expression] = STATE(1740),
    [sym_parenthesized_expression] = STATE(1740),
    [sym_concatenated_string] = STATE(1740),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1740),
    [sym_new_expression] = STATE(1740),
    [sym_delete_expression] = STATE(1740),
    [sym_lambda_expression] = STATE(1740),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(3731),
    [sym_char_literal] = ACTIONS(3731),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(3733),
    [sym_false] = ACTIONS(3733),
    [sym_null] = ACTIONS(3733),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(3733),
  },
  [1122] = {
    [anon_sym_LPAREN] = ACTIONS(3735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3737),
    [anon_sym_extern] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3737),
    [anon_sym_register] = ACTIONS(3737),
    [anon_sym_inline] = ACTIONS(3737),
    [anon_sym_const] = ACTIONS(3737),
    [anon_sym_restrict] = ACTIONS(3737),
    [anon_sym_volatile] = ACTIONS(3737),
    [anon_sym__Atomic] = ACTIONS(3737),
    [anon_sym_mutable] = ACTIONS(3737),
    [anon_sym_explicit] = ACTIONS(3737),
    [anon_sym_constexpr] = ACTIONS(3737),
    [anon_sym_unsigned] = ACTIONS(3737),
    [anon_sym_long] = ACTIONS(3737),
    [anon_sym_short] = ACTIONS(3737),
    [sym_primitive_type] = ACTIONS(3737),
    [anon_sym_enum] = ACTIONS(3737),
    [anon_sym_struct] = ACTIONS(3737),
    [anon_sym_union] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3735),
    [anon_sym_TILDE] = ACTIONS(3735),
    [sym_identifier] = ACTIONS(3737),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3737),
    [anon_sym_public] = ACTIONS(3737),
    [sym_auto] = ACTIONS(3737),
    [anon_sym_typename] = ACTIONS(3737),
    [anon_sym_template] = ACTIONS(3737),
    [anon_sym_friend] = ACTIONS(3737),
    [anon_sym_private] = ACTIONS(3737),
    [anon_sym_protected] = ACTIONS(3737),
    [anon_sym_using] = ACTIONS(3737),
    [anon_sym_COLON_COLON] = ACTIONS(3735),
    [sym_operator_name] = ACTIONS(3735),
  },
  [1123] = {
    [sym_type_qualifier] = STATE(1742),
    [sym_trailing_return_type] = STATE(1742),
    [aux_sym_function_declarator_repeat1] = STATE(1742),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3739),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3743),
  },
  [1124] = {
    [aux_sym_field_declaration_repeat1] = STATE(1744),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(3700),
    [anon_sym_COLON] = ACTIONS(3745),
    [sym_comment] = ACTIONS(49),
  },
  [1125] = {
    [sym_destructor_name] = STATE(1604),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3747),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3426),
  },
  [1126] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1747),
    [sym_parenthesized_expression] = STATE(1747),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(3749),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1127] = {
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_RPAREN] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3751),
    [anon_sym_RBRACE] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3751),
    [anon_sym_RBRACK] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3751),
    [anon_sym_QMARK] = ACTIONS(3751),
    [anon_sym_STAR_EQ] = ACTIONS(3751),
    [anon_sym_SLASH_EQ] = ACTIONS(3751),
    [anon_sym_PERCENT_EQ] = ACTIONS(3751),
    [anon_sym_PLUS_EQ] = ACTIONS(3751),
    [anon_sym_DASH_EQ] = ACTIONS(3751),
    [anon_sym_LT_LT_EQ] = ACTIONS(3751),
    [anon_sym_GT_GT_EQ] = ACTIONS(3751),
    [anon_sym_AMP_EQ] = ACTIONS(3751),
    [anon_sym_CARET_EQ] = ACTIONS(3751),
    [anon_sym_PIPE_EQ] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3751),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3753),
    [anon_sym_EQ_EQ] = ACTIONS(3751),
    [anon_sym_BANG_EQ] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3753),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_LT_EQ] = ACTIONS(3751),
    [anon_sym_GT_EQ] = ACTIONS(3751),
    [anon_sym_LT_LT] = ACTIONS(3753),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_DASH_DASH] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3751),
    [anon_sym_DOT] = ACTIONS(3751),
    [anon_sym_DASH_GT] = ACTIONS(3751),
    [sym_comment] = ACTIONS(49),
  },
  [1128] = {
    [sym__type_specifier] = STATE(1749),
    [sym_sized_type_specifier] = STATE(1749),
    [sym_enum_specifier] = STATE(1749),
    [sym_struct_specifier] = STATE(1749),
    [sym_union_specifier] = STATE(1749),
    [sym_macro_type_specifier] = STATE(1749),
    [sym_class_specifier] = STATE(1749),
    [sym_dependent_type] = STATE(1749),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1750),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(3757),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(3757),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1129] = {
    [sym_type_qualifier] = STATE(1751),
    [sym_trailing_return_type] = STATE(1751),
    [aux_sym_function_declarator_repeat1] = STATE(1751),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(1654),
    [anon_sym_DASH_GT] = ACTIONS(2166),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3761),
  },
  [1130] = {
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [anon_sym_public] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_friend] = ACTIONS(1682),
    [anon_sym_private] = ACTIONS(1682),
    [anon_sym_protected] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [1131] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1132] = {
    [anon_sym_LPAREN] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1846),
    [anon_sym_typedef] = ACTIONS(1848),
    [anon_sym_extern] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_register] = ACTIONS(1848),
    [anon_sym_inline] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_restrict] = ACTIONS(1848),
    [anon_sym_volatile] = ACTIONS(1848),
    [anon_sym__Atomic] = ACTIONS(1848),
    [anon_sym_mutable] = ACTIONS(1848),
    [anon_sym_explicit] = ACTIONS(1848),
    [anon_sym_constexpr] = ACTIONS(1848),
    [anon_sym_unsigned] = ACTIONS(1848),
    [anon_sym_long] = ACTIONS(1848),
    [anon_sym_short] = ACTIONS(1848),
    [sym_primitive_type] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_struct] = ACTIONS(1848),
    [anon_sym_union] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [sym_auto] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1848),
    [anon_sym_template] = ACTIONS(1848),
    [anon_sym_friend] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_using] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1846),
    [sym_operator_name] = ACTIONS(1846),
  },
  [1133] = {
    [sym_storage_class_specifier] = STATE(1133),
    [sym_type_qualifier] = STATE(1133),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1133),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [1134] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [1135] = {
    [sym_compound_statement] = STATE(1753),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(49),
  },
  [1136] = {
    [sym_storage_class_specifier] = STATE(1133),
    [sym_type_qualifier] = STATE(1133),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1133),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_COLON] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [1137] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1140),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [sym_comment] = ACTIONS(49),
  },
  [1138] = {
    [sym__class_name] = STATE(1754),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(64),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1139] = {
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [sym_comment] = ACTIONS(49),
  },
  [1140] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1140),
    [anon_sym_COMMA] = ACTIONS(3769),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [sym_comment] = ACTIONS(49),
  },
  [1141] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_GT] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [sym_operator_name] = ACTIONS(2362),
  },
  [1142] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(3772),
    [sym_comment] = ACTIONS(49),
  },
  [1143] = {
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_register] = ACTIONS(3776),
    [anon_sym_inline] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_restrict] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym__Atomic] = ACTIONS(3776),
    [anon_sym_mutable] = ACTIONS(3776),
    [anon_sym_explicit] = ACTIONS(3776),
    [anon_sym_constexpr] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_GT] = ACTIONS(3774),
    [sym_identifier] = ACTIONS(3776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3774),
    [sym_operator_name] = ACTIONS(3774),
  },
  [1144] = {
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_RPAREN] = ACTIONS(3778),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3780),
    [anon_sym_register] = ACTIONS(3780),
    [anon_sym_inline] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_restrict] = ACTIONS(3780),
    [anon_sym_volatile] = ACTIONS(3780),
    [anon_sym__Atomic] = ACTIONS(3780),
    [anon_sym_mutable] = ACTIONS(3780),
    [anon_sym_explicit] = ACTIONS(3780),
    [anon_sym_constexpr] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3780),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3780),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [sym_operator_name] = ACTIONS(3778),
  },
  [1145] = {
    [anon_sym_RPAREN] = ACTIONS(3782),
    [sym_comment] = ACTIONS(49),
  },
  [1146] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1757),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1147] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1148] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1758),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(3784),
    [sym_comment] = ACTIONS(49),
  },
  [1149] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3786),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [1150] = {
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [1151] = {
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_STAR] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_RBRACK] = ACTIONS(550),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(550),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1152] = {
    [sym__expression] = STATE(1761),
    [sym_conditional_expression] = STATE(1761),
    [sym_assignment_expression] = STATE(1761),
    [sym_pointer_expression] = STATE(1761),
    [sym_logical_expression] = STATE(1761),
    [sym_bitwise_expression] = STATE(1761),
    [sym_equality_expression] = STATE(1761),
    [sym_relational_expression] = STATE(1761),
    [sym_shift_expression] = STATE(1761),
    [sym_math_expression] = STATE(1761),
    [sym_cast_expression] = STATE(1761),
    [sym_sizeof_expression] = STATE(1761),
    [sym_subscript_expression] = STATE(1761),
    [sym_call_expression] = STATE(1761),
    [sym_field_expression] = STATE(1761),
    [sym_compound_literal_expression] = STATE(1761),
    [sym_parenthesized_expression] = STATE(1761),
    [sym_concatenated_string] = STATE(1761),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1761),
    [sym_new_expression] = STATE(1761),
    [sym_delete_expression] = STATE(1761),
    [sym_lambda_expression] = STATE(1761),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3788),
    [sym_char_literal] = ACTIONS(3788),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [sym_null] = ACTIONS(3792),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3792),
  },
  [1153] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1154] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1155] = {
    [sym__expression] = STATE(1763),
    [sym_comma_expression] = STATE(1586),
    [sym_conditional_expression] = STATE(1763),
    [sym_assignment_expression] = STATE(1763),
    [sym_pointer_expression] = STATE(1763),
    [sym_logical_expression] = STATE(1763),
    [sym_bitwise_expression] = STATE(1763),
    [sym_equality_expression] = STATE(1763),
    [sym_relational_expression] = STATE(1763),
    [sym_shift_expression] = STATE(1763),
    [sym_math_expression] = STATE(1763),
    [sym_cast_expression] = STATE(1763),
    [sym_sizeof_expression] = STATE(1763),
    [sym_subscript_expression] = STATE(1763),
    [sym_call_expression] = STATE(1763),
    [sym_field_expression] = STATE(1763),
    [sym_compound_literal_expression] = STATE(1763),
    [sym_parenthesized_expression] = STATE(1763),
    [sym_concatenated_string] = STATE(1763),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1763),
    [sym_new_expression] = STATE(1763),
    [sym_delete_expression] = STATE(1763),
    [sym_lambda_expression] = STATE(1763),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3796),
    [sym_char_literal] = ACTIONS(3796),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3798),
    [sym_false] = ACTIONS(3798),
    [sym_null] = ACTIONS(3798),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3798),
  },
  [1156] = {
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_GT] = ACTIONS(3800),
    [sym_identifier] = ACTIONS(3800),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
  },
  [1157] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(2836),
  },
  [1158] = {
    [sym__expression] = STATE(1764),
    [sym_conditional_expression] = STATE(1764),
    [sym_assignment_expression] = STATE(1764),
    [sym_pointer_expression] = STATE(1764),
    [sym_logical_expression] = STATE(1764),
    [sym_bitwise_expression] = STATE(1764),
    [sym_equality_expression] = STATE(1764),
    [sym_relational_expression] = STATE(1764),
    [sym_shift_expression] = STATE(1764),
    [sym_math_expression] = STATE(1764),
    [sym_cast_expression] = STATE(1764),
    [sym_sizeof_expression] = STATE(1764),
    [sym_subscript_expression] = STATE(1764),
    [sym_call_expression] = STATE(1764),
    [sym_field_expression] = STATE(1764),
    [sym_compound_literal_expression] = STATE(1764),
    [sym_parenthesized_expression] = STATE(1764),
    [sym_concatenated_string] = STATE(1764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1764),
    [sym_new_expression] = STATE(1764),
    [sym_delete_expression] = STATE(1764),
    [sym_lambda_expression] = STATE(1764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3802),
    [sym_char_literal] = ACTIONS(3802),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3804),
    [sym_false] = ACTIONS(3804),
    [sym_null] = ACTIONS(3804),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3804),
  },
  [1159] = {
    [sym__expression] = STATE(1765),
    [sym_conditional_expression] = STATE(1765),
    [sym_assignment_expression] = STATE(1765),
    [sym_pointer_expression] = STATE(1765),
    [sym_logical_expression] = STATE(1765),
    [sym_bitwise_expression] = STATE(1765),
    [sym_equality_expression] = STATE(1765),
    [sym_relational_expression] = STATE(1765),
    [sym_shift_expression] = STATE(1765),
    [sym_math_expression] = STATE(1765),
    [sym_cast_expression] = STATE(1765),
    [sym_sizeof_expression] = STATE(1765),
    [sym_subscript_expression] = STATE(1765),
    [sym_call_expression] = STATE(1765),
    [sym_field_expression] = STATE(1765),
    [sym_compound_literal_expression] = STATE(1765),
    [sym_parenthesized_expression] = STATE(1765),
    [sym_concatenated_string] = STATE(1765),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1765),
    [sym_new_expression] = STATE(1765),
    [sym_delete_expression] = STATE(1765),
    [sym_lambda_expression] = STATE(1765),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(3806),
    [sym_char_literal] = ACTIONS(3806),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(3808),
    [sym_false] = ACTIONS(3808),
    [sym_null] = ACTIONS(3808),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(3808),
  },
  [1160] = {
    [sym__expression] = STATE(1766),
    [sym_conditional_expression] = STATE(1766),
    [sym_assignment_expression] = STATE(1766),
    [sym_pointer_expression] = STATE(1766),
    [sym_logical_expression] = STATE(1766),
    [sym_bitwise_expression] = STATE(1766),
    [sym_equality_expression] = STATE(1766),
    [sym_relational_expression] = STATE(1766),
    [sym_shift_expression] = STATE(1766),
    [sym_math_expression] = STATE(1766),
    [sym_cast_expression] = STATE(1766),
    [sym_sizeof_expression] = STATE(1766),
    [sym_subscript_expression] = STATE(1766),
    [sym_call_expression] = STATE(1766),
    [sym_field_expression] = STATE(1766),
    [sym_compound_literal_expression] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1766),
    [sym_concatenated_string] = STATE(1766),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1766),
    [sym_new_expression] = STATE(1766),
    [sym_delete_expression] = STATE(1766),
    [sym_lambda_expression] = STATE(1766),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3810),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3810),
    [sym_char_literal] = ACTIONS(3810),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3812),
  },
  [1161] = {
    [sym__expression] = STATE(1767),
    [sym_conditional_expression] = STATE(1767),
    [sym_assignment_expression] = STATE(1767),
    [sym_pointer_expression] = STATE(1767),
    [sym_logical_expression] = STATE(1767),
    [sym_bitwise_expression] = STATE(1767),
    [sym_equality_expression] = STATE(1767),
    [sym_relational_expression] = STATE(1767),
    [sym_shift_expression] = STATE(1767),
    [sym_math_expression] = STATE(1767),
    [sym_cast_expression] = STATE(1767),
    [sym_sizeof_expression] = STATE(1767),
    [sym_subscript_expression] = STATE(1767),
    [sym_call_expression] = STATE(1767),
    [sym_field_expression] = STATE(1767),
    [sym_compound_literal_expression] = STATE(1767),
    [sym_parenthesized_expression] = STATE(1767),
    [sym_concatenated_string] = STATE(1767),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1767),
    [sym_new_expression] = STATE(1767),
    [sym_delete_expression] = STATE(1767),
    [sym_lambda_expression] = STATE(1767),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3814),
    [sym_char_literal] = ACTIONS(3814),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3816),
    [sym_false] = ACTIONS(3816),
    [sym_null] = ACTIONS(3816),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3816),
  },
  [1162] = {
    [sym__expression] = STATE(1768),
    [sym_conditional_expression] = STATE(1768),
    [sym_assignment_expression] = STATE(1768),
    [sym_pointer_expression] = STATE(1768),
    [sym_logical_expression] = STATE(1768),
    [sym_bitwise_expression] = STATE(1768),
    [sym_equality_expression] = STATE(1768),
    [sym_relational_expression] = STATE(1768),
    [sym_shift_expression] = STATE(1768),
    [sym_math_expression] = STATE(1768),
    [sym_cast_expression] = STATE(1768),
    [sym_sizeof_expression] = STATE(1768),
    [sym_subscript_expression] = STATE(1768),
    [sym_call_expression] = STATE(1768),
    [sym_field_expression] = STATE(1768),
    [sym_compound_literal_expression] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1768),
    [sym_concatenated_string] = STATE(1768),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1768),
    [sym_new_expression] = STATE(1768),
    [sym_delete_expression] = STATE(1768),
    [sym_lambda_expression] = STATE(1768),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3818),
    [sym_char_literal] = ACTIONS(3818),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [sym_null] = ACTIONS(3820),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3820),
  },
  [1163] = {
    [sym__expression] = STATE(1769),
    [sym_conditional_expression] = STATE(1769),
    [sym_assignment_expression] = STATE(1769),
    [sym_pointer_expression] = STATE(1769),
    [sym_logical_expression] = STATE(1769),
    [sym_bitwise_expression] = STATE(1769),
    [sym_equality_expression] = STATE(1769),
    [sym_relational_expression] = STATE(1769),
    [sym_shift_expression] = STATE(1769),
    [sym_math_expression] = STATE(1769),
    [sym_cast_expression] = STATE(1769),
    [sym_sizeof_expression] = STATE(1769),
    [sym_subscript_expression] = STATE(1769),
    [sym_call_expression] = STATE(1769),
    [sym_field_expression] = STATE(1769),
    [sym_compound_literal_expression] = STATE(1769),
    [sym_parenthesized_expression] = STATE(1769),
    [sym_concatenated_string] = STATE(1769),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1769),
    [sym_new_expression] = STATE(1769),
    [sym_delete_expression] = STATE(1769),
    [sym_lambda_expression] = STATE(1769),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3822),
    [sym_char_literal] = ACTIONS(3822),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [sym_null] = ACTIONS(3824),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3824),
  },
  [1164] = {
    [sym__expression] = STATE(1770),
    [sym_conditional_expression] = STATE(1770),
    [sym_assignment_expression] = STATE(1770),
    [sym_pointer_expression] = STATE(1770),
    [sym_logical_expression] = STATE(1770),
    [sym_bitwise_expression] = STATE(1770),
    [sym_equality_expression] = STATE(1770),
    [sym_relational_expression] = STATE(1770),
    [sym_shift_expression] = STATE(1770),
    [sym_math_expression] = STATE(1770),
    [sym_cast_expression] = STATE(1770),
    [sym_sizeof_expression] = STATE(1770),
    [sym_subscript_expression] = STATE(1770),
    [sym_call_expression] = STATE(1770),
    [sym_field_expression] = STATE(1770),
    [sym_compound_literal_expression] = STATE(1770),
    [sym_parenthesized_expression] = STATE(1770),
    [sym_concatenated_string] = STATE(1770),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1770),
    [sym_new_expression] = STATE(1770),
    [sym_delete_expression] = STATE(1770),
    [sym_lambda_expression] = STATE(1770),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3826),
    [sym_char_literal] = ACTIONS(3826),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3828),
    [sym_false] = ACTIONS(3828),
    [sym_null] = ACTIONS(3828),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3828),
  },
  [1165] = {
    [sym__expression] = STATE(1771),
    [sym_conditional_expression] = STATE(1771),
    [sym_assignment_expression] = STATE(1771),
    [sym_pointer_expression] = STATE(1771),
    [sym_logical_expression] = STATE(1771),
    [sym_bitwise_expression] = STATE(1771),
    [sym_equality_expression] = STATE(1771),
    [sym_relational_expression] = STATE(1771),
    [sym_shift_expression] = STATE(1771),
    [sym_math_expression] = STATE(1771),
    [sym_cast_expression] = STATE(1771),
    [sym_sizeof_expression] = STATE(1771),
    [sym_subscript_expression] = STATE(1771),
    [sym_call_expression] = STATE(1771),
    [sym_field_expression] = STATE(1771),
    [sym_compound_literal_expression] = STATE(1771),
    [sym_parenthesized_expression] = STATE(1771),
    [sym_concatenated_string] = STATE(1771),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1771),
    [sym_new_expression] = STATE(1771),
    [sym_delete_expression] = STATE(1771),
    [sym_lambda_expression] = STATE(1771),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3830),
    [sym_char_literal] = ACTIONS(3830),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [sym_null] = ACTIONS(3832),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3832),
  },
  [1166] = {
    [sym__expression] = STATE(1772),
    [sym_conditional_expression] = STATE(1772),
    [sym_assignment_expression] = STATE(1772),
    [sym_pointer_expression] = STATE(1772),
    [sym_logical_expression] = STATE(1772),
    [sym_bitwise_expression] = STATE(1772),
    [sym_equality_expression] = STATE(1772),
    [sym_relational_expression] = STATE(1772),
    [sym_shift_expression] = STATE(1772),
    [sym_math_expression] = STATE(1772),
    [sym_cast_expression] = STATE(1772),
    [sym_sizeof_expression] = STATE(1772),
    [sym_subscript_expression] = STATE(1772),
    [sym_call_expression] = STATE(1772),
    [sym_field_expression] = STATE(1772),
    [sym_compound_literal_expression] = STATE(1772),
    [sym_parenthesized_expression] = STATE(1772),
    [sym_concatenated_string] = STATE(1772),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1772),
    [sym_new_expression] = STATE(1772),
    [sym_delete_expression] = STATE(1772),
    [sym_lambda_expression] = STATE(1772),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3834),
    [sym_char_literal] = ACTIONS(3834),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3836),
    [sym_false] = ACTIONS(3836),
    [sym_null] = ACTIONS(3836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3836),
  },
  [1167] = {
    [sym__expression] = STATE(1773),
    [sym_conditional_expression] = STATE(1773),
    [sym_assignment_expression] = STATE(1773),
    [sym_pointer_expression] = STATE(1773),
    [sym_logical_expression] = STATE(1773),
    [sym_bitwise_expression] = STATE(1773),
    [sym_equality_expression] = STATE(1773),
    [sym_relational_expression] = STATE(1773),
    [sym_shift_expression] = STATE(1773),
    [sym_math_expression] = STATE(1773),
    [sym_cast_expression] = STATE(1773),
    [sym_sizeof_expression] = STATE(1773),
    [sym_subscript_expression] = STATE(1773),
    [sym_call_expression] = STATE(1773),
    [sym_field_expression] = STATE(1773),
    [sym_compound_literal_expression] = STATE(1773),
    [sym_parenthesized_expression] = STATE(1773),
    [sym_concatenated_string] = STATE(1773),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1773),
    [sym_new_expression] = STATE(1773),
    [sym_delete_expression] = STATE(1773),
    [sym_lambda_expression] = STATE(1773),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3838),
    [sym_char_literal] = ACTIONS(3838),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3840),
    [sym_false] = ACTIONS(3840),
    [sym_null] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3840),
  },
  [1168] = {
    [sym__expression] = STATE(1774),
    [sym_conditional_expression] = STATE(1774),
    [sym_assignment_expression] = STATE(1774),
    [sym_pointer_expression] = STATE(1774),
    [sym_logical_expression] = STATE(1774),
    [sym_bitwise_expression] = STATE(1774),
    [sym_equality_expression] = STATE(1774),
    [sym_relational_expression] = STATE(1774),
    [sym_shift_expression] = STATE(1774),
    [sym_math_expression] = STATE(1774),
    [sym_cast_expression] = STATE(1774),
    [sym_sizeof_expression] = STATE(1774),
    [sym_subscript_expression] = STATE(1774),
    [sym_call_expression] = STATE(1774),
    [sym_field_expression] = STATE(1774),
    [sym_compound_literal_expression] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1774),
    [sym_concatenated_string] = STATE(1774),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1774),
    [sym_new_expression] = STATE(1774),
    [sym_delete_expression] = STATE(1774),
    [sym_lambda_expression] = STATE(1774),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3842),
    [sym_char_literal] = ACTIONS(3842),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3844),
    [sym_false] = ACTIONS(3844),
    [sym_null] = ACTIONS(3844),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3844),
  },
  [1169] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3846),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [1170] = {
    [sym__abstract_declarator] = STATE(1776),
    [sym_abstract_pointer_declarator] = STATE(1776),
    [sym_abstract_function_declarator] = STATE(1776),
    [sym_abstract_array_declarator] = STATE(1776),
    [sym_parameter_list] = STATE(1173),
    [sym_abstract_reference_declarator] = STATE(1776),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_comment] = ACTIONS(49),
  },
  [1171] = {
    [sym__abstract_declarator] = STATE(1777),
    [sym_abstract_pointer_declarator] = STATE(1777),
    [sym_abstract_function_declarator] = STATE(1777),
    [sym_abstract_array_declarator] = STATE(1777),
    [sym_parameter_list] = STATE(1173),
    [sym_abstract_reference_declarator] = STATE(1777),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_comment] = ACTIONS(49),
  },
  [1172] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1173] = {
    [sym_type_qualifier] = STATE(1781),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1781),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3852),
  },
  [1174] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
  },
  [1175] = {
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3856),
    [anon_sym_RPAREN] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3856),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3856),
    [anon_sym_const] = ACTIONS(3858),
    [anon_sym_restrict] = ACTIONS(3856),
    [anon_sym_volatile] = ACTIONS(3856),
    [anon_sym__Atomic] = ACTIONS(3856),
    [anon_sym_mutable] = ACTIONS(3856),
    [anon_sym_explicit] = ACTIONS(3856),
    [anon_sym_constexpr] = ACTIONS(3856),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_GT] = ACTIONS(3856),
    [anon_sym_DASH_GT] = ACTIONS(3856),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3856),
  },
  [1176] = {
    [sym__expression] = STATE(1783),
    [sym_conditional_expression] = STATE(1783),
    [sym_assignment_expression] = STATE(1783),
    [sym_pointer_expression] = STATE(1783),
    [sym_logical_expression] = STATE(1783),
    [sym_bitwise_expression] = STATE(1783),
    [sym_equality_expression] = STATE(1783),
    [sym_relational_expression] = STATE(1783),
    [sym_shift_expression] = STATE(1783),
    [sym_math_expression] = STATE(1783),
    [sym_cast_expression] = STATE(1783),
    [sym_sizeof_expression] = STATE(1783),
    [sym_subscript_expression] = STATE(1783),
    [sym_call_expression] = STATE(1783),
    [sym_field_expression] = STATE(1783),
    [sym_compound_literal_expression] = STATE(1783),
    [sym_parenthesized_expression] = STATE(1783),
    [sym_concatenated_string] = STATE(1783),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1783),
    [sym_new_expression] = STATE(1783),
    [sym_delete_expression] = STATE(1783),
    [sym_lambda_expression] = STATE(1783),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3862),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(3860),
    [sym_char_literal] = ACTIONS(3860),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(3864),
    [sym_false] = ACTIONS(3864),
    [sym_null] = ACTIONS(3864),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(3864),
  },
  [1177] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(3862),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1178] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
  },
  [1179] = {
    [sym__declaration_specifiers] = STATE(1784),
    [sym_storage_class_specifier] = STATE(395),
    [sym_type_qualifier] = STATE(395),
    [sym__type_specifier] = STATE(388),
    [sym_sized_type_specifier] = STATE(388),
    [sym_enum_specifier] = STATE(388),
    [sym_struct_specifier] = STATE(388),
    [sym_union_specifier] = STATE(388),
    [sym__expression] = STATE(1783),
    [sym_conditional_expression] = STATE(1783),
    [sym_assignment_expression] = STATE(1783),
    [sym_pointer_expression] = STATE(1783),
    [sym_logical_expression] = STATE(1783),
    [sym_bitwise_expression] = STATE(1783),
    [sym_equality_expression] = STATE(1783),
    [sym_relational_expression] = STATE(1783),
    [sym_shift_expression] = STATE(1783),
    [sym_math_expression] = STATE(1783),
    [sym_cast_expression] = STATE(1783),
    [sym_sizeof_expression] = STATE(1783),
    [sym_subscript_expression] = STATE(1783),
    [sym_call_expression] = STATE(1783),
    [sym_field_expression] = STATE(1783),
    [sym_compound_literal_expression] = STATE(1783),
    [sym_parenthesized_expression] = STATE(1783),
    [sym_concatenated_string] = STATE(1783),
    [sym_macro_type_specifier] = STATE(388),
    [sym_class_specifier] = STATE(388),
    [sym_dependent_type] = STATE(388),
    [sym_template_type] = STATE(390),
    [sym_template_function] = STATE(1783),
    [sym_new_expression] = STATE(1783),
    [sym_delete_expression] = STATE(1783),
    [sym_lambda_expression] = STATE(1783),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(393),
    [sym_scoped_namespace_identifier] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(395),
    [aux_sym_sized_type_specifier_repeat1] = STATE(396),
    [sym_raw_string_literal] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [sym_primitive_type] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_union] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(3860),
    [sym_char_literal] = ACTIONS(3860),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(3864),
    [sym_false] = ACTIONS(3864),
    [sym_null] = ACTIONS(3864),
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(632),
    [sym_auto] = ACTIONS(608),
    [anon_sym_typename] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(3864),
  },
  [1180] = {
    [sym_type_qualifier] = STATE(1786),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1786),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(2358),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3870),
  },
  [1181] = {
    [sym__type_specifier] = STATE(1787),
    [sym_sized_type_specifier] = STATE(1787),
    [sym_enum_specifier] = STATE(1787),
    [sym_struct_specifier] = STATE(1787),
    [sym_union_specifier] = STATE(1787),
    [sym_macro_type_specifier] = STATE(1787),
    [sym_class_specifier] = STATE(1787),
    [sym_dependent_type] = STATE(1787),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(3872),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1182] = {
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [1183] = {
    [sym_type_qualifier] = STATE(1788),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1788),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(2358),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3876),
  },
  [1184] = {
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_GT] = ACTIONS(3878),
    [sym_comment] = ACTIONS(49),
  },
  [1185] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_GT] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [sym_operator_name] = ACTIONS(3880),
  },
  [1186] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_GT] = ACTIONS(3878),
    [sym_comment] = ACTIONS(49),
  },
  [1187] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(3887),
    [sym_comment] = ACTIONS(49),
  },
  [1188] = {
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_RPAREN] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3891),
    [anon_sym_register] = ACTIONS(3891),
    [anon_sym_inline] = ACTIONS(3891),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_restrict] = ACTIONS(3891),
    [anon_sym_volatile] = ACTIONS(3891),
    [anon_sym__Atomic] = ACTIONS(3891),
    [anon_sym_mutable] = ACTIONS(3891),
    [anon_sym_explicit] = ACTIONS(3891),
    [anon_sym_constexpr] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3889),
    [anon_sym_GT] = ACTIONS(3889),
    [sym_identifier] = ACTIONS(3891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3889),
    [sym_operator_name] = ACTIONS(3889),
  },
  [1189] = {
    [sym__type_specifier] = STATE(1790),
    [sym_sized_type_specifier] = STATE(1790),
    [sym_enum_specifier] = STATE(1790),
    [sym_struct_specifier] = STATE(1790),
    [sym_union_specifier] = STATE(1790),
    [sym_macro_type_specifier] = STATE(1790),
    [sym_class_specifier] = STATE(1790),
    [sym_dependent_type] = STATE(1790),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1791),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3895),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(3895),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1190] = {
    [sym__declarator] = STATE(158),
    [sym__abstract_declarator] = STATE(1776),
    [sym_pointer_declarator] = STATE(158),
    [sym_abstract_pointer_declarator] = STATE(1776),
    [sym_function_declarator] = STATE(158),
    [sym_abstract_function_declarator] = STATE(1776),
    [sym_array_declarator] = STATE(158),
    [sym_abstract_array_declarator] = STATE(1776),
    [sym_parameter_list] = STATE(1173),
    [sym_reference_declarator] = STATE(158),
    [sym_abstract_reference_declarator] = STATE(1776),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(158),
    [sym_destructor_name] = STATE(158),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(267),
  },
  [1191] = {
    [sym__declarator] = STATE(159),
    [sym__abstract_declarator] = STATE(1777),
    [sym_pointer_declarator] = STATE(159),
    [sym_abstract_pointer_declarator] = STATE(1777),
    [sym_function_declarator] = STATE(159),
    [sym_abstract_function_declarator] = STATE(1777),
    [sym_array_declarator] = STATE(159),
    [sym_abstract_array_declarator] = STATE(1777),
    [sym_parameter_list] = STATE(1173),
    [sym_reference_declarator] = STATE(159),
    [sym_abstract_reference_declarator] = STATE(1777),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(159),
    [sym_destructor_name] = STATE(159),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(269),
  },
  [1192] = {
    [sym_parameter_list] = STATE(1199),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(869),
    [anon_sym_GT] = ACTIONS(869),
    [sym_comment] = ACTIONS(49),
  },
  [1193] = {
    [sym_parameter_list] = STATE(1199),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [sym_comment] = ACTIONS(49),
  },
  [1194] = {
    [sym_destructor_name] = STATE(1792),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3899),
  },
  [1195] = {
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [sym_comment] = ACTIONS(49),
  },
  [1196] = {
    [sym__declaration_specifiers] = STATE(365),
    [sym_storage_class_specifier] = STATE(367),
    [sym_type_qualifier] = STATE(367),
    [sym__type_specifier] = STATE(366),
    [sym_sized_type_specifier] = STATE(366),
    [sym_enum_specifier] = STATE(366),
    [sym_struct_specifier] = STATE(366),
    [sym_union_specifier] = STATE(366),
    [sym_parameter_declaration] = STATE(362),
    [sym__expression] = STATE(1793),
    [sym_conditional_expression] = STATE(1793),
    [sym_assignment_expression] = STATE(1793),
    [sym_pointer_expression] = STATE(1793),
    [sym_logical_expression] = STATE(1793),
    [sym_bitwise_expression] = STATE(1793),
    [sym_equality_expression] = STATE(1793),
    [sym_relational_expression] = STATE(1793),
    [sym_shift_expression] = STATE(1793),
    [sym_math_expression] = STATE(1793),
    [sym_cast_expression] = STATE(1793),
    [sym_sizeof_expression] = STATE(1793),
    [sym_subscript_expression] = STATE(1793),
    [sym_call_expression] = STATE(1793),
    [sym_field_expression] = STATE(1793),
    [sym_compound_literal_expression] = STATE(1793),
    [sym_parenthesized_expression] = STATE(1793),
    [sym_initializer_list] = STATE(1794),
    [sym_concatenated_string] = STATE(1793),
    [sym_macro_type_specifier] = STATE(366),
    [sym_class_specifier] = STATE(366),
    [sym_dependent_type] = STATE(366),
    [sym_template_type] = STATE(688),
    [sym_template_function] = STATE(1793),
    [sym_new_expression] = STATE(1793),
    [sym_delete_expression] = STATE(1793),
    [sym_lambda_expression] = STATE(1793),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(689),
    [aux_sym__declaration_specifiers_repeat1] = STATE(367),
    [aux_sym_sized_type_specifier_repeat1] = STATE(368),
    [sym_raw_string_literal] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(590),
    [anon_sym_long] = ACTIONS(590),
    [anon_sym_short] = ACTIONS(590),
    [sym_primitive_type] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3901),
    [sym_char_literal] = ACTIONS(3901),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3903),
    [sym_false] = ACTIONS(3903),
    [sym_null] = ACTIONS(3903),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(592),
    [anon_sym_typename] = ACTIONS(594),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1307),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3903),
  },
  [1197] = {
    [sym__expression] = STATE(1797),
    [sym_conditional_expression] = STATE(1797),
    [sym_assignment_expression] = STATE(1797),
    [sym_pointer_expression] = STATE(1797),
    [sym_logical_expression] = STATE(1797),
    [sym_bitwise_expression] = STATE(1797),
    [sym_equality_expression] = STATE(1797),
    [sym_relational_expression] = STATE(1797),
    [sym_shift_expression] = STATE(1797),
    [sym_math_expression] = STATE(1797),
    [sym_cast_expression] = STATE(1797),
    [sym_sizeof_expression] = STATE(1797),
    [sym_subscript_expression] = STATE(1797),
    [sym_call_expression] = STATE(1797),
    [sym_field_expression] = STATE(1797),
    [sym_compound_literal_expression] = STATE(1797),
    [sym_parenthesized_expression] = STATE(1797),
    [sym_initializer_list] = STATE(1798),
    [sym_initializer_pair] = STATE(1798),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1797),
    [sym_new_expression] = STATE(1797),
    [sym_delete_expression] = STATE(1797),
    [sym_lambda_expression] = STATE(1797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_COMMA] = ACTIONS(3907),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(3905),
    [sym_char_literal] = ACTIONS(3905),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(3911),
  },
  [1198] = {
    [sym__expression] = STATE(1808),
    [sym_conditional_expression] = STATE(1808),
    [sym_assignment_expression] = STATE(1808),
    [sym_pointer_expression] = STATE(1808),
    [sym_logical_expression] = STATE(1808),
    [sym_bitwise_expression] = STATE(1808),
    [sym_equality_expression] = STATE(1808),
    [sym_relational_expression] = STATE(1808),
    [sym_shift_expression] = STATE(1808),
    [sym_math_expression] = STATE(1808),
    [sym_cast_expression] = STATE(1808),
    [sym_sizeof_expression] = STATE(1808),
    [sym_subscript_expression] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_field_expression] = STATE(1808),
    [sym_compound_literal_expression] = STATE(1808),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_initializer_list] = STATE(711),
    [sym_concatenated_string] = STATE(1808),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1808),
    [sym_new_expression] = STATE(1808),
    [sym_delete_expression] = STATE(1808),
    [sym_lambda_expression] = STATE(1808),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3913),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(3913),
    [sym_char_literal] = ACTIONS(3913),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(3931),
    [sym_false] = ACTIONS(3931),
    [sym_null] = ACTIONS(3931),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(3931),
  },
  [1199] = {
    [sym_type_qualifier] = STATE(1810),
    [sym_trailing_return_type] = STATE(1810),
    [aux_sym_function_declarator_repeat1] = STATE(1810),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3939),
  },
  [1200] = {
    [sym_destructor_name] = STATE(1811),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(881),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(3941),
  },
  [1201] = {
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [sym_comment] = ACTIONS(49),
  },
  [1202] = {
    [sym_storage_class_specifier] = STATE(1202),
    [sym_type_qualifier] = STATE(1202),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1202),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [1203] = {
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3943),
    [sym_comment] = ACTIONS(49),
  },
  [1204] = {
    [anon_sym_extern] = ACTIONS(3945),
    [anon_sym_static] = ACTIONS(3945),
    [anon_sym_register] = ACTIONS(3945),
    [anon_sym_inline] = ACTIONS(3945),
    [anon_sym_const] = ACTIONS(3945),
    [anon_sym_restrict] = ACTIONS(3945),
    [anon_sym_volatile] = ACTIONS(3945),
    [anon_sym__Atomic] = ACTIONS(3945),
    [anon_sym_mutable] = ACTIONS(3945),
    [anon_sym_explicit] = ACTIONS(3945),
    [anon_sym_constexpr] = ACTIONS(3945),
    [anon_sym_unsigned] = ACTIONS(3945),
    [anon_sym_long] = ACTIONS(3945),
    [anon_sym_short] = ACTIONS(3945),
    [sym_primitive_type] = ACTIONS(3945),
    [anon_sym_enum] = ACTIONS(3945),
    [anon_sym_struct] = ACTIONS(3945),
    [anon_sym_union] = ACTIONS(3945),
    [sym_identifier] = ACTIONS(3945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3945),
    [sym_auto] = ACTIONS(3945),
    [anon_sym_typename] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
  },
  [1205] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(1205),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3943),
    [sym_comment] = ACTIONS(49),
  },
  [1206] = {
    [sym_storage_class_specifier] = STATE(1202),
    [sym_type_qualifier] = STATE(1202),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1202),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [1207] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1209),
    [anon_sym_unsigned] = ACTIONS(2416),
    [anon_sym_long] = ACTIONS(2416),
    [anon_sym_short] = ACTIONS(2416),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1893),
    [anon_sym_union] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1897),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1208] = {
    [sym__abstract_declarator] = STATE(1814),
    [sym_abstract_pointer_declarator] = STATE(1814),
    [sym_abstract_function_declarator] = STATE(1814),
    [sym_abstract_array_declarator] = STATE(1814),
    [sym_parameter_list] = STATE(1815),
    [sym_abstract_reference_declarator] = STATE(1814),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [1209] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1816),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(3958),
    [anon_sym_long] = ACTIONS(3958),
    [anon_sym_short] = ACTIONS(3958),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [1210] = {
    [sym_type_qualifier] = STATE(1210),
    [sym_trailing_return_type] = STATE(1210),
    [aux_sym_function_declarator_repeat1] = STATE(1210),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3963),
  },
  [1211] = {
    [sym_storage_class_specifier] = STATE(1211),
    [sym_type_qualifier] = STATE(1211),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1211),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [1212] = {
    [sym_storage_class_specifier] = STATE(1211),
    [sym_type_qualifier] = STATE(1211),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1211),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [1213] = {
    [sym__abstract_declarator] = STATE(1817),
    [sym_abstract_pointer_declarator] = STATE(1817),
    [sym_abstract_function_declarator] = STATE(1817),
    [sym_abstract_array_declarator] = STATE(1817),
    [sym_parameter_list] = STATE(1216),
    [sym_abstract_reference_declarator] = STATE(1817),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [sym_comment] = ACTIONS(49),
  },
  [1214] = {
    [sym__abstract_declarator] = STATE(1818),
    [sym_abstract_pointer_declarator] = STATE(1818),
    [sym_abstract_function_declarator] = STATE(1818),
    [sym_abstract_array_declarator] = STATE(1818),
    [sym_parameter_list] = STATE(1216),
    [sym_abstract_reference_declarator] = STATE(1818),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [sym_comment] = ACTIONS(49),
  },
  [1215] = {
    [sym_parameter_list] = STATE(1819),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1216] = {
    [sym_type_qualifier] = STATE(1821),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1821),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3966),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3968),
  },
  [1217] = {
    [ts_builtin_sym_end] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3972),
    [sym_preproc_directive] = ACTIONS(3972),
    [anon_sym_typedef] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3972),
    [anon_sym_RBRACE] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_register] = ACTIONS(3972),
    [anon_sym_inline] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3972),
    [anon_sym_restrict] = ACTIONS(3972),
    [anon_sym_volatile] = ACTIONS(3972),
    [anon_sym__Atomic] = ACTIONS(3972),
    [anon_sym_mutable] = ACTIONS(3972),
    [anon_sym_explicit] = ACTIONS(3972),
    [anon_sym_constexpr] = ACTIONS(3972),
    [anon_sym_unsigned] = ACTIONS(3972),
    [anon_sym_long] = ACTIONS(3972),
    [anon_sym_short] = ACTIONS(3972),
    [sym_primitive_type] = ACTIONS(3972),
    [anon_sym_enum] = ACTIONS(3972),
    [anon_sym_struct] = ACTIONS(3972),
    [anon_sym_union] = ACTIONS(3972),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3970),
    [anon_sym_TILDE] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3972),
    [sym_auto] = ACTIONS(3972),
    [anon_sym_typename] = ACTIONS(3972),
    [anon_sym_template] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_using] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [sym_operator_name] = ACTIONS(3970),
  },
  [1218] = {
    [sym__abstract_declarator] = STATE(1822),
    [sym_abstract_pointer_declarator] = STATE(1822),
    [sym_abstract_function_declarator] = STATE(1822),
    [sym_abstract_array_declarator] = STATE(1822),
    [sym_parameter_list] = STATE(1216),
    [sym_abstract_reference_declarator] = STATE(1822),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [sym_comment] = ACTIONS(49),
  },
  [1219] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1219),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(3974),
    [anon_sym_long] = ACTIONS(3974),
    [anon_sym_short] = ACTIONS(3974),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [1220] = {
    [anon_sym_COMMA] = ACTIONS(3977),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [sym_comment] = ACTIONS(49),
  },
  [1221] = {
    [anon_sym_LPAREN] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3979),
    [sym_comment] = ACTIONS(49),
  },
  [1222] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(1222),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [sym_comment] = ACTIONS(49),
  },
  [1223] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3984),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [1224] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [1225] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [1226] = {
    [sym__expression] = STATE(1824),
    [sym_conditional_expression] = STATE(1824),
    [sym_assignment_expression] = STATE(1824),
    [sym_pointer_expression] = STATE(1824),
    [sym_logical_expression] = STATE(1824),
    [sym_bitwise_expression] = STATE(1824),
    [sym_equality_expression] = STATE(1824),
    [sym_relational_expression] = STATE(1824),
    [sym_shift_expression] = STATE(1824),
    [sym_math_expression] = STATE(1824),
    [sym_cast_expression] = STATE(1824),
    [sym_sizeof_expression] = STATE(1824),
    [sym_subscript_expression] = STATE(1824),
    [sym_call_expression] = STATE(1824),
    [sym_field_expression] = STATE(1824),
    [sym_compound_literal_expression] = STATE(1824),
    [sym_parenthesized_expression] = STATE(1824),
    [sym_initializer_list] = STATE(1825),
    [sym_concatenated_string] = STATE(1824),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1824),
    [sym_new_expression] = STATE(1824),
    [sym_delete_expression] = STATE(1824),
    [sym_lambda_expression] = STATE(1824),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(3986),
    [sym_char_literal] = ACTIONS(3986),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(3988),
    [sym_false] = ACTIONS(3988),
    [sym_null] = ACTIONS(3988),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(3988),
  },
  [1227] = {
    [anon_sym_LPAREN] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3990),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(49),
  },
  [1228] = {
    [aux_sym_argument_list_repeat1] = STATE(1827),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [sym_comment] = ACTIONS(49),
  },
  [1229] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(3996),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [1230] = {
    [anon_sym_RPAREN] = ACTIONS(3998),
    [sym_comment] = ACTIONS(49),
  },
  [1231] = {
    [anon_sym_LPAREN] = ACTIONS(4000),
    [anon_sym_COMMA] = ACTIONS(4000),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_SEMI] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4000),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4000),
    [anon_sym_RBRACK] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4002),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4000),
    [anon_sym_STAR_EQ] = ACTIONS(4000),
    [anon_sym_SLASH_EQ] = ACTIONS(4000),
    [anon_sym_PERCENT_EQ] = ACTIONS(4000),
    [anon_sym_PLUS_EQ] = ACTIONS(4000),
    [anon_sym_DASH_EQ] = ACTIONS(4000),
    [anon_sym_LT_LT_EQ] = ACTIONS(4000),
    [anon_sym_GT_GT_EQ] = ACTIONS(4000),
    [anon_sym_AMP_EQ] = ACTIONS(4000),
    [anon_sym_CARET_EQ] = ACTIONS(4000),
    [anon_sym_PIPE_EQ] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_CARET] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4000),
    [anon_sym_BANG_EQ] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4000),
    [anon_sym_GT_EQ] = ACTIONS(4000),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_PLUS] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4002),
    [anon_sym_SLASH] = ACTIONS(4002),
    [anon_sym_PERCENT] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4000),
    [anon_sym_PLUS_PLUS] = ACTIONS(4000),
    [anon_sym_DOT] = ACTIONS(4000),
    [anon_sym_DASH_GT] = ACTIONS(4000),
    [sym_comment] = ACTIONS(49),
  },
  [1232] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(2472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [1233] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2490),
    [sym_operator_name] = ACTIONS(198),
  },
  [1234] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(1347),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_STAR_EQ] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2728),
    [anon_sym_GT_GT_EQ] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1235] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1831),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1236] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1237] = {
    [anon_sym_LBRACK] = ACTIONS(4006),
    [anon_sym_EQ] = ACTIONS(4006),
    [anon_sym_DOT] = ACTIONS(4006),
    [sym_comment] = ACTIONS(49),
  },
  [1238] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1832),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(4008),
    [sym_comment] = ACTIONS(49),
  },
  [1239] = {
    [sym__expression] = STATE(1834),
    [sym_conditional_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_pointer_expression] = STATE(1834),
    [sym_logical_expression] = STATE(1834),
    [sym_bitwise_expression] = STATE(1834),
    [sym_equality_expression] = STATE(1834),
    [sym_relational_expression] = STATE(1834),
    [sym_shift_expression] = STATE(1834),
    [sym_math_expression] = STATE(1834),
    [sym_cast_expression] = STATE(1834),
    [sym_sizeof_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_field_expression] = STATE(1834),
    [sym_compound_literal_expression] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1834),
    [sym_concatenated_string] = STATE(1834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_delete_expression] = STATE(1834),
    [sym_lambda_expression] = STATE(1834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4010),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4010),
    [sym_char_literal] = ACTIONS(4010),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_null] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4014),
  },
  [1240] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1241] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1242] = {
    [sym__expression] = STATE(1837),
    [sym_comma_expression] = STATE(1586),
    [sym_conditional_expression] = STATE(1837),
    [sym_assignment_expression] = STATE(1837),
    [sym_pointer_expression] = STATE(1837),
    [sym_logical_expression] = STATE(1837),
    [sym_bitwise_expression] = STATE(1837),
    [sym_equality_expression] = STATE(1837),
    [sym_relational_expression] = STATE(1837),
    [sym_shift_expression] = STATE(1837),
    [sym_math_expression] = STATE(1837),
    [sym_cast_expression] = STATE(1837),
    [sym_sizeof_expression] = STATE(1837),
    [sym_subscript_expression] = STATE(1837),
    [sym_call_expression] = STATE(1837),
    [sym_field_expression] = STATE(1837),
    [sym_compound_literal_expression] = STATE(1837),
    [sym_parenthesized_expression] = STATE(1837),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1837),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1837),
    [sym_new_expression] = STATE(1837),
    [sym_delete_expression] = STATE(1837),
    [sym_lambda_expression] = STATE(1837),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4018),
    [sym_char_literal] = ACTIONS(4018),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4022),
    [sym_false] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4022),
  },
  [1243] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(2836),
  },
  [1244] = {
    [sym__expression] = STATE(1839),
    [sym_conditional_expression] = STATE(1839),
    [sym_assignment_expression] = STATE(1839),
    [sym_pointer_expression] = STATE(1839),
    [sym_logical_expression] = STATE(1839),
    [sym_bitwise_expression] = STATE(1839),
    [sym_equality_expression] = STATE(1839),
    [sym_relational_expression] = STATE(1839),
    [sym_shift_expression] = STATE(1839),
    [sym_math_expression] = STATE(1839),
    [sym_cast_expression] = STATE(1839),
    [sym_sizeof_expression] = STATE(1839),
    [sym_subscript_expression] = STATE(1839),
    [sym_call_expression] = STATE(1839),
    [sym_field_expression] = STATE(1839),
    [sym_compound_literal_expression] = STATE(1839),
    [sym_parenthesized_expression] = STATE(1839),
    [sym_concatenated_string] = STATE(1839),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1839),
    [sym_new_expression] = STATE(1839),
    [sym_delete_expression] = STATE(1839),
    [sym_lambda_expression] = STATE(1839),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4024),
    [sym_char_literal] = ACTIONS(4024),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4026),
    [sym_false] = ACTIONS(4026),
    [sym_null] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4026),
  },
  [1245] = {
    [sym__expression] = STATE(1840),
    [sym_conditional_expression] = STATE(1840),
    [sym_assignment_expression] = STATE(1840),
    [sym_pointer_expression] = STATE(1840),
    [sym_logical_expression] = STATE(1840),
    [sym_bitwise_expression] = STATE(1840),
    [sym_equality_expression] = STATE(1840),
    [sym_relational_expression] = STATE(1840),
    [sym_shift_expression] = STATE(1840),
    [sym_math_expression] = STATE(1840),
    [sym_cast_expression] = STATE(1840),
    [sym_sizeof_expression] = STATE(1840),
    [sym_subscript_expression] = STATE(1840),
    [sym_call_expression] = STATE(1840),
    [sym_field_expression] = STATE(1840),
    [sym_compound_literal_expression] = STATE(1840),
    [sym_parenthesized_expression] = STATE(1840),
    [sym_concatenated_string] = STATE(1840),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1840),
    [sym_new_expression] = STATE(1840),
    [sym_delete_expression] = STATE(1840),
    [sym_lambda_expression] = STATE(1840),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4028),
    [sym_char_literal] = ACTIONS(4028),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4030),
    [sym_false] = ACTIONS(4030),
    [sym_null] = ACTIONS(4030),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4030),
  },
  [1246] = {
    [sym__expression] = STATE(1841),
    [sym_conditional_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(1841),
    [sym_pointer_expression] = STATE(1841),
    [sym_logical_expression] = STATE(1841),
    [sym_bitwise_expression] = STATE(1841),
    [sym_equality_expression] = STATE(1841),
    [sym_relational_expression] = STATE(1841),
    [sym_shift_expression] = STATE(1841),
    [sym_math_expression] = STATE(1841),
    [sym_cast_expression] = STATE(1841),
    [sym_sizeof_expression] = STATE(1841),
    [sym_subscript_expression] = STATE(1841),
    [sym_call_expression] = STATE(1841),
    [sym_field_expression] = STATE(1841),
    [sym_compound_literal_expression] = STATE(1841),
    [sym_parenthesized_expression] = STATE(1841),
    [sym_concatenated_string] = STATE(1841),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1841),
    [sym_new_expression] = STATE(1841),
    [sym_delete_expression] = STATE(1841),
    [sym_lambda_expression] = STATE(1841),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4032),
    [sym_char_literal] = ACTIONS(4032),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4034),
    [sym_false] = ACTIONS(4034),
    [sym_null] = ACTIONS(4034),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4034),
  },
  [1247] = {
    [sym__expression] = STATE(1842),
    [sym_conditional_expression] = STATE(1842),
    [sym_assignment_expression] = STATE(1842),
    [sym_pointer_expression] = STATE(1842),
    [sym_logical_expression] = STATE(1842),
    [sym_bitwise_expression] = STATE(1842),
    [sym_equality_expression] = STATE(1842),
    [sym_relational_expression] = STATE(1842),
    [sym_shift_expression] = STATE(1842),
    [sym_math_expression] = STATE(1842),
    [sym_cast_expression] = STATE(1842),
    [sym_sizeof_expression] = STATE(1842),
    [sym_subscript_expression] = STATE(1842),
    [sym_call_expression] = STATE(1842),
    [sym_field_expression] = STATE(1842),
    [sym_compound_literal_expression] = STATE(1842),
    [sym_parenthesized_expression] = STATE(1842),
    [sym_concatenated_string] = STATE(1842),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1842),
    [sym_new_expression] = STATE(1842),
    [sym_delete_expression] = STATE(1842),
    [sym_lambda_expression] = STATE(1842),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4036),
    [sym_char_literal] = ACTIONS(4036),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4038),
  },
  [1248] = {
    [sym__expression] = STATE(1843),
    [sym_conditional_expression] = STATE(1843),
    [sym_assignment_expression] = STATE(1843),
    [sym_pointer_expression] = STATE(1843),
    [sym_logical_expression] = STATE(1843),
    [sym_bitwise_expression] = STATE(1843),
    [sym_equality_expression] = STATE(1843),
    [sym_relational_expression] = STATE(1843),
    [sym_shift_expression] = STATE(1843),
    [sym_math_expression] = STATE(1843),
    [sym_cast_expression] = STATE(1843),
    [sym_sizeof_expression] = STATE(1843),
    [sym_subscript_expression] = STATE(1843),
    [sym_call_expression] = STATE(1843),
    [sym_field_expression] = STATE(1843),
    [sym_compound_literal_expression] = STATE(1843),
    [sym_parenthesized_expression] = STATE(1843),
    [sym_concatenated_string] = STATE(1843),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1843),
    [sym_new_expression] = STATE(1843),
    [sym_delete_expression] = STATE(1843),
    [sym_lambda_expression] = STATE(1843),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4040),
    [sym_char_literal] = ACTIONS(4040),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_null] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4042),
  },
  [1249] = {
    [sym__expression] = STATE(1844),
    [sym_conditional_expression] = STATE(1844),
    [sym_assignment_expression] = STATE(1844),
    [sym_pointer_expression] = STATE(1844),
    [sym_logical_expression] = STATE(1844),
    [sym_bitwise_expression] = STATE(1844),
    [sym_equality_expression] = STATE(1844),
    [sym_relational_expression] = STATE(1844),
    [sym_shift_expression] = STATE(1844),
    [sym_math_expression] = STATE(1844),
    [sym_cast_expression] = STATE(1844),
    [sym_sizeof_expression] = STATE(1844),
    [sym_subscript_expression] = STATE(1844),
    [sym_call_expression] = STATE(1844),
    [sym_field_expression] = STATE(1844),
    [sym_compound_literal_expression] = STATE(1844),
    [sym_parenthesized_expression] = STATE(1844),
    [sym_concatenated_string] = STATE(1844),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1844),
    [sym_new_expression] = STATE(1844),
    [sym_delete_expression] = STATE(1844),
    [sym_lambda_expression] = STATE(1844),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4044),
    [sym_char_literal] = ACTIONS(4044),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4046),
    [sym_false] = ACTIONS(4046),
    [sym_null] = ACTIONS(4046),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4046),
  },
  [1250] = {
    [sym__expression] = STATE(1845),
    [sym_conditional_expression] = STATE(1845),
    [sym_assignment_expression] = STATE(1845),
    [sym_pointer_expression] = STATE(1845),
    [sym_logical_expression] = STATE(1845),
    [sym_bitwise_expression] = STATE(1845),
    [sym_equality_expression] = STATE(1845),
    [sym_relational_expression] = STATE(1845),
    [sym_shift_expression] = STATE(1845),
    [sym_math_expression] = STATE(1845),
    [sym_cast_expression] = STATE(1845),
    [sym_sizeof_expression] = STATE(1845),
    [sym_subscript_expression] = STATE(1845),
    [sym_call_expression] = STATE(1845),
    [sym_field_expression] = STATE(1845),
    [sym_compound_literal_expression] = STATE(1845),
    [sym_parenthesized_expression] = STATE(1845),
    [sym_concatenated_string] = STATE(1845),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1845),
    [sym_new_expression] = STATE(1845),
    [sym_delete_expression] = STATE(1845),
    [sym_lambda_expression] = STATE(1845),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4048),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4048),
    [sym_char_literal] = ACTIONS(4048),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4050),
    [sym_false] = ACTIONS(4050),
    [sym_null] = ACTIONS(4050),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4050),
  },
  [1251] = {
    [sym__expression] = STATE(1846),
    [sym_conditional_expression] = STATE(1846),
    [sym_assignment_expression] = STATE(1846),
    [sym_pointer_expression] = STATE(1846),
    [sym_logical_expression] = STATE(1846),
    [sym_bitwise_expression] = STATE(1846),
    [sym_equality_expression] = STATE(1846),
    [sym_relational_expression] = STATE(1846),
    [sym_shift_expression] = STATE(1846),
    [sym_math_expression] = STATE(1846),
    [sym_cast_expression] = STATE(1846),
    [sym_sizeof_expression] = STATE(1846),
    [sym_subscript_expression] = STATE(1846),
    [sym_call_expression] = STATE(1846),
    [sym_field_expression] = STATE(1846),
    [sym_compound_literal_expression] = STATE(1846),
    [sym_parenthesized_expression] = STATE(1846),
    [sym_concatenated_string] = STATE(1846),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1846),
    [sym_new_expression] = STATE(1846),
    [sym_delete_expression] = STATE(1846),
    [sym_lambda_expression] = STATE(1846),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4052),
    [sym_char_literal] = ACTIONS(4052),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4054),
    [sym_false] = ACTIONS(4054),
    [sym_null] = ACTIONS(4054),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4054),
  },
  [1252] = {
    [sym__expression] = STATE(1847),
    [sym_conditional_expression] = STATE(1847),
    [sym_assignment_expression] = STATE(1847),
    [sym_pointer_expression] = STATE(1847),
    [sym_logical_expression] = STATE(1847),
    [sym_bitwise_expression] = STATE(1847),
    [sym_equality_expression] = STATE(1847),
    [sym_relational_expression] = STATE(1847),
    [sym_shift_expression] = STATE(1847),
    [sym_math_expression] = STATE(1847),
    [sym_cast_expression] = STATE(1847),
    [sym_sizeof_expression] = STATE(1847),
    [sym_subscript_expression] = STATE(1847),
    [sym_call_expression] = STATE(1847),
    [sym_field_expression] = STATE(1847),
    [sym_compound_literal_expression] = STATE(1847),
    [sym_parenthesized_expression] = STATE(1847),
    [sym_concatenated_string] = STATE(1847),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1847),
    [sym_new_expression] = STATE(1847),
    [sym_delete_expression] = STATE(1847),
    [sym_lambda_expression] = STATE(1847),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4056),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4056),
    [sym_char_literal] = ACTIONS(4056),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4058),
    [sym_false] = ACTIONS(4058),
    [sym_null] = ACTIONS(4058),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4058),
  },
  [1253] = {
    [sym__expression] = STATE(1848),
    [sym_conditional_expression] = STATE(1848),
    [sym_assignment_expression] = STATE(1848),
    [sym_pointer_expression] = STATE(1848),
    [sym_logical_expression] = STATE(1848),
    [sym_bitwise_expression] = STATE(1848),
    [sym_equality_expression] = STATE(1848),
    [sym_relational_expression] = STATE(1848),
    [sym_shift_expression] = STATE(1848),
    [sym_math_expression] = STATE(1848),
    [sym_cast_expression] = STATE(1848),
    [sym_sizeof_expression] = STATE(1848),
    [sym_subscript_expression] = STATE(1848),
    [sym_call_expression] = STATE(1848),
    [sym_field_expression] = STATE(1848),
    [sym_compound_literal_expression] = STATE(1848),
    [sym_parenthesized_expression] = STATE(1848),
    [sym_concatenated_string] = STATE(1848),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1848),
    [sym_new_expression] = STATE(1848),
    [sym_delete_expression] = STATE(1848),
    [sym_lambda_expression] = STATE(1848),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4060),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4060),
    [sym_char_literal] = ACTIONS(4060),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4062),
    [sym_false] = ACTIONS(4062),
    [sym_null] = ACTIONS(4062),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4062),
  },
  [1254] = {
    [sym__expression] = STATE(1849),
    [sym_conditional_expression] = STATE(1849),
    [sym_assignment_expression] = STATE(1849),
    [sym_pointer_expression] = STATE(1849),
    [sym_logical_expression] = STATE(1849),
    [sym_bitwise_expression] = STATE(1849),
    [sym_equality_expression] = STATE(1849),
    [sym_relational_expression] = STATE(1849),
    [sym_shift_expression] = STATE(1849),
    [sym_math_expression] = STATE(1849),
    [sym_cast_expression] = STATE(1849),
    [sym_sizeof_expression] = STATE(1849),
    [sym_subscript_expression] = STATE(1849),
    [sym_call_expression] = STATE(1849),
    [sym_field_expression] = STATE(1849),
    [sym_compound_literal_expression] = STATE(1849),
    [sym_parenthesized_expression] = STATE(1849),
    [sym_concatenated_string] = STATE(1849),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1849),
    [sym_new_expression] = STATE(1849),
    [sym_delete_expression] = STATE(1849),
    [sym_lambda_expression] = STATE(1849),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4064),
    [sym_char_literal] = ACTIONS(4064),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_null] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4066),
  },
  [1255] = {
    [aux_sym_initializer_list_repeat1] = STATE(1851),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [sym_comment] = ACTIONS(49),
  },
  [1256] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4070),
    [sym_char_literal] = ACTIONS(4070),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4072),
  },
  [1257] = {
    [sym__expression] = STATE(1853),
    [sym_conditional_expression] = STATE(1853),
    [sym_assignment_expression] = STATE(1853),
    [sym_pointer_expression] = STATE(1853),
    [sym_logical_expression] = STATE(1853),
    [sym_bitwise_expression] = STATE(1853),
    [sym_equality_expression] = STATE(1853),
    [sym_relational_expression] = STATE(1853),
    [sym_shift_expression] = STATE(1853),
    [sym_math_expression] = STATE(1853),
    [sym_cast_expression] = STATE(1853),
    [sym_sizeof_expression] = STATE(1853),
    [sym_subscript_expression] = STATE(1853),
    [sym_call_expression] = STATE(1853),
    [sym_field_expression] = STATE(1853),
    [sym_compound_literal_expression] = STATE(1853),
    [sym_parenthesized_expression] = STATE(1853),
    [sym_concatenated_string] = STATE(1853),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1853),
    [sym_new_expression] = STATE(1853),
    [sym_delete_expression] = STATE(1853),
    [sym_lambda_expression] = STATE(1853),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4074),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(4074),
    [sym_char_literal] = ACTIONS(4074),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(4076),
    [sym_false] = ACTIONS(4076),
    [sym_null] = ACTIONS(4076),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(4076),
  },
  [1258] = {
    [sym__expression] = STATE(1854),
    [sym_conditional_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_pointer_expression] = STATE(1854),
    [sym_logical_expression] = STATE(1854),
    [sym_bitwise_expression] = STATE(1854),
    [sym_equality_expression] = STATE(1854),
    [sym_relational_expression] = STATE(1854),
    [sym_shift_expression] = STATE(1854),
    [sym_math_expression] = STATE(1854),
    [sym_cast_expression] = STATE(1854),
    [sym_sizeof_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_field_expression] = STATE(1854),
    [sym_compound_literal_expression] = STATE(1854),
    [sym_parenthesized_expression] = STATE(1854),
    [sym_initializer_list] = STATE(1855),
    [sym_concatenated_string] = STATE(1854),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_delete_expression] = STATE(1854),
    [sym_lambda_expression] = STATE(1854),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4078),
    [sym_char_literal] = ACTIONS(4078),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4080),
    [sym_false] = ACTIONS(4080),
    [sym_null] = ACTIONS(4080),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4080),
  },
  [1259] = {
    [sym_subscript_designator] = STATE(1259),
    [sym_field_designator] = STATE(1259),
    [aux_sym_initializer_pair_repeat1] = STATE(1259),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [sym_comment] = ACTIONS(49),
  },
  [1260] = {
    [sym_field_declaration_list] = STATE(1425),
    [sym__class_name] = STATE(1856),
    [sym_base_class_clause] = STATE(1427),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1261] = {
    [sym_field_declaration_list] = STATE(1431),
    [sym__class_name] = STATE(1857),
    [sym_base_class_clause] = STATE(1433),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1262] = {
    [sym_field_declaration_list] = STATE(1438),
    [sym__class_name] = STATE(1858),
    [sym_base_class_clause] = STATE(1440),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1263] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1265),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1264] = {
    [sym__abstract_declarator] = STATE(1861),
    [sym_abstract_pointer_declarator] = STATE(1861),
    [sym_abstract_function_declarator] = STATE(1861),
    [sym_abstract_array_declarator] = STATE(1861),
    [sym_parameter_list] = STATE(1862),
    [sym_abstract_reference_declarator] = STATE(1861),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(4092),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [1265] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1863),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_EQ] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(4096),
    [anon_sym_long] = ACTIONS(4096),
    [anon_sym_short] = ACTIONS(4096),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [1266] = {
    [sym_type_qualifier] = STATE(1266),
    [sym_trailing_return_type] = STATE(1266),
    [aux_sym_function_declarator_repeat1] = STATE(1266),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_DASH_GT] = ACTIONS(4098),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4101),
  },
  [1267] = {
    [anon_sym_RPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(49),
  },
  [1268] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1865),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1269] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1270] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1866),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(4106),
    [sym_comment] = ACTIONS(49),
  },
  [1271] = {
    [sym__expression] = STATE(1868),
    [sym_conditional_expression] = STATE(1868),
    [sym_assignment_expression] = STATE(1868),
    [sym_pointer_expression] = STATE(1868),
    [sym_logical_expression] = STATE(1868),
    [sym_bitwise_expression] = STATE(1868),
    [sym_equality_expression] = STATE(1868),
    [sym_relational_expression] = STATE(1868),
    [sym_shift_expression] = STATE(1868),
    [sym_math_expression] = STATE(1868),
    [sym_cast_expression] = STATE(1868),
    [sym_sizeof_expression] = STATE(1868),
    [sym_subscript_expression] = STATE(1868),
    [sym_call_expression] = STATE(1868),
    [sym_field_expression] = STATE(1868),
    [sym_compound_literal_expression] = STATE(1868),
    [sym_parenthesized_expression] = STATE(1868),
    [sym_concatenated_string] = STATE(1868),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1868),
    [sym_new_expression] = STATE(1868),
    [sym_delete_expression] = STATE(1868),
    [sym_lambda_expression] = STATE(1868),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4108),
    [sym_char_literal] = ACTIONS(4108),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4112),
    [sym_false] = ACTIONS(4112),
    [sym_null] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4112),
  },
  [1272] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1273] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1274] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(2836),
  },
  [1275] = {
    [sym__expression] = STATE(1870),
    [sym_conditional_expression] = STATE(1870),
    [sym_assignment_expression] = STATE(1870),
    [sym_pointer_expression] = STATE(1870),
    [sym_logical_expression] = STATE(1870),
    [sym_bitwise_expression] = STATE(1870),
    [sym_equality_expression] = STATE(1870),
    [sym_relational_expression] = STATE(1870),
    [sym_shift_expression] = STATE(1870),
    [sym_math_expression] = STATE(1870),
    [sym_cast_expression] = STATE(1870),
    [sym_sizeof_expression] = STATE(1870),
    [sym_subscript_expression] = STATE(1870),
    [sym_call_expression] = STATE(1870),
    [sym_field_expression] = STATE(1870),
    [sym_compound_literal_expression] = STATE(1870),
    [sym_parenthesized_expression] = STATE(1870),
    [sym_concatenated_string] = STATE(1870),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1870),
    [sym_new_expression] = STATE(1870),
    [sym_delete_expression] = STATE(1870),
    [sym_lambda_expression] = STATE(1870),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4116),
    [sym_char_literal] = ACTIONS(4116),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4118),
    [sym_false] = ACTIONS(4118),
    [sym_null] = ACTIONS(4118),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4118),
  },
  [1276] = {
    [sym__expression] = STATE(1871),
    [sym_conditional_expression] = STATE(1871),
    [sym_assignment_expression] = STATE(1871),
    [sym_pointer_expression] = STATE(1871),
    [sym_logical_expression] = STATE(1871),
    [sym_bitwise_expression] = STATE(1871),
    [sym_equality_expression] = STATE(1871),
    [sym_relational_expression] = STATE(1871),
    [sym_shift_expression] = STATE(1871),
    [sym_math_expression] = STATE(1871),
    [sym_cast_expression] = STATE(1871),
    [sym_sizeof_expression] = STATE(1871),
    [sym_subscript_expression] = STATE(1871),
    [sym_call_expression] = STATE(1871),
    [sym_field_expression] = STATE(1871),
    [sym_compound_literal_expression] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1871),
    [sym_concatenated_string] = STATE(1871),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1871),
    [sym_new_expression] = STATE(1871),
    [sym_delete_expression] = STATE(1871),
    [sym_lambda_expression] = STATE(1871),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4120),
    [sym_char_literal] = ACTIONS(4120),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4122),
    [sym_false] = ACTIONS(4122),
    [sym_null] = ACTIONS(4122),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4122),
  },
  [1277] = {
    [sym__expression] = STATE(1872),
    [sym_conditional_expression] = STATE(1872),
    [sym_assignment_expression] = STATE(1872),
    [sym_pointer_expression] = STATE(1872),
    [sym_logical_expression] = STATE(1872),
    [sym_bitwise_expression] = STATE(1872),
    [sym_equality_expression] = STATE(1872),
    [sym_relational_expression] = STATE(1872),
    [sym_shift_expression] = STATE(1872),
    [sym_math_expression] = STATE(1872),
    [sym_cast_expression] = STATE(1872),
    [sym_sizeof_expression] = STATE(1872),
    [sym_subscript_expression] = STATE(1872),
    [sym_call_expression] = STATE(1872),
    [sym_field_expression] = STATE(1872),
    [sym_compound_literal_expression] = STATE(1872),
    [sym_parenthesized_expression] = STATE(1872),
    [sym_concatenated_string] = STATE(1872),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1872),
    [sym_new_expression] = STATE(1872),
    [sym_delete_expression] = STATE(1872),
    [sym_lambda_expression] = STATE(1872),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4124),
    [sym_char_literal] = ACTIONS(4124),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4126),
    [sym_false] = ACTIONS(4126),
    [sym_null] = ACTIONS(4126),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4126),
  },
  [1278] = {
    [sym__expression] = STATE(1873),
    [sym_conditional_expression] = STATE(1873),
    [sym_assignment_expression] = STATE(1873),
    [sym_pointer_expression] = STATE(1873),
    [sym_logical_expression] = STATE(1873),
    [sym_bitwise_expression] = STATE(1873),
    [sym_equality_expression] = STATE(1873),
    [sym_relational_expression] = STATE(1873),
    [sym_shift_expression] = STATE(1873),
    [sym_math_expression] = STATE(1873),
    [sym_cast_expression] = STATE(1873),
    [sym_sizeof_expression] = STATE(1873),
    [sym_subscript_expression] = STATE(1873),
    [sym_call_expression] = STATE(1873),
    [sym_field_expression] = STATE(1873),
    [sym_compound_literal_expression] = STATE(1873),
    [sym_parenthesized_expression] = STATE(1873),
    [sym_concatenated_string] = STATE(1873),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1873),
    [sym_new_expression] = STATE(1873),
    [sym_delete_expression] = STATE(1873),
    [sym_lambda_expression] = STATE(1873),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4128),
    [sym_char_literal] = ACTIONS(4128),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4130),
    [sym_false] = ACTIONS(4130),
    [sym_null] = ACTIONS(4130),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4130),
  },
  [1279] = {
    [sym__expression] = STATE(1874),
    [sym_conditional_expression] = STATE(1874),
    [sym_assignment_expression] = STATE(1874),
    [sym_pointer_expression] = STATE(1874),
    [sym_logical_expression] = STATE(1874),
    [sym_bitwise_expression] = STATE(1874),
    [sym_equality_expression] = STATE(1874),
    [sym_relational_expression] = STATE(1874),
    [sym_shift_expression] = STATE(1874),
    [sym_math_expression] = STATE(1874),
    [sym_cast_expression] = STATE(1874),
    [sym_sizeof_expression] = STATE(1874),
    [sym_subscript_expression] = STATE(1874),
    [sym_call_expression] = STATE(1874),
    [sym_field_expression] = STATE(1874),
    [sym_compound_literal_expression] = STATE(1874),
    [sym_parenthesized_expression] = STATE(1874),
    [sym_concatenated_string] = STATE(1874),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1874),
    [sym_new_expression] = STATE(1874),
    [sym_delete_expression] = STATE(1874),
    [sym_lambda_expression] = STATE(1874),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4132),
    [sym_char_literal] = ACTIONS(4132),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4134),
    [sym_false] = ACTIONS(4134),
    [sym_null] = ACTIONS(4134),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4134),
  },
  [1280] = {
    [sym__expression] = STATE(1875),
    [sym_conditional_expression] = STATE(1875),
    [sym_assignment_expression] = STATE(1875),
    [sym_pointer_expression] = STATE(1875),
    [sym_logical_expression] = STATE(1875),
    [sym_bitwise_expression] = STATE(1875),
    [sym_equality_expression] = STATE(1875),
    [sym_relational_expression] = STATE(1875),
    [sym_shift_expression] = STATE(1875),
    [sym_math_expression] = STATE(1875),
    [sym_cast_expression] = STATE(1875),
    [sym_sizeof_expression] = STATE(1875),
    [sym_subscript_expression] = STATE(1875),
    [sym_call_expression] = STATE(1875),
    [sym_field_expression] = STATE(1875),
    [sym_compound_literal_expression] = STATE(1875),
    [sym_parenthesized_expression] = STATE(1875),
    [sym_concatenated_string] = STATE(1875),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1875),
    [sym_new_expression] = STATE(1875),
    [sym_delete_expression] = STATE(1875),
    [sym_lambda_expression] = STATE(1875),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4136),
    [sym_char_literal] = ACTIONS(4136),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4138),
    [sym_false] = ACTIONS(4138),
    [sym_null] = ACTIONS(4138),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4138),
  },
  [1281] = {
    [sym__expression] = STATE(1876),
    [sym_conditional_expression] = STATE(1876),
    [sym_assignment_expression] = STATE(1876),
    [sym_pointer_expression] = STATE(1876),
    [sym_logical_expression] = STATE(1876),
    [sym_bitwise_expression] = STATE(1876),
    [sym_equality_expression] = STATE(1876),
    [sym_relational_expression] = STATE(1876),
    [sym_shift_expression] = STATE(1876),
    [sym_math_expression] = STATE(1876),
    [sym_cast_expression] = STATE(1876),
    [sym_sizeof_expression] = STATE(1876),
    [sym_subscript_expression] = STATE(1876),
    [sym_call_expression] = STATE(1876),
    [sym_field_expression] = STATE(1876),
    [sym_compound_literal_expression] = STATE(1876),
    [sym_parenthesized_expression] = STATE(1876),
    [sym_concatenated_string] = STATE(1876),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1876),
    [sym_new_expression] = STATE(1876),
    [sym_delete_expression] = STATE(1876),
    [sym_lambda_expression] = STATE(1876),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4140),
    [sym_char_literal] = ACTIONS(4140),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4142),
    [sym_false] = ACTIONS(4142),
    [sym_null] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4142),
  },
  [1282] = {
    [sym__expression] = STATE(1877),
    [sym_conditional_expression] = STATE(1877),
    [sym_assignment_expression] = STATE(1877),
    [sym_pointer_expression] = STATE(1877),
    [sym_logical_expression] = STATE(1877),
    [sym_bitwise_expression] = STATE(1877),
    [sym_equality_expression] = STATE(1877),
    [sym_relational_expression] = STATE(1877),
    [sym_shift_expression] = STATE(1877),
    [sym_math_expression] = STATE(1877),
    [sym_cast_expression] = STATE(1877),
    [sym_sizeof_expression] = STATE(1877),
    [sym_subscript_expression] = STATE(1877),
    [sym_call_expression] = STATE(1877),
    [sym_field_expression] = STATE(1877),
    [sym_compound_literal_expression] = STATE(1877),
    [sym_parenthesized_expression] = STATE(1877),
    [sym_concatenated_string] = STATE(1877),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1877),
    [sym_new_expression] = STATE(1877),
    [sym_delete_expression] = STATE(1877),
    [sym_lambda_expression] = STATE(1877),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4144),
    [sym_char_literal] = ACTIONS(4144),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4146),
    [sym_false] = ACTIONS(4146),
    [sym_null] = ACTIONS(4146),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4146),
  },
  [1283] = {
    [sym__expression] = STATE(1878),
    [sym_conditional_expression] = STATE(1878),
    [sym_assignment_expression] = STATE(1878),
    [sym_pointer_expression] = STATE(1878),
    [sym_logical_expression] = STATE(1878),
    [sym_bitwise_expression] = STATE(1878),
    [sym_equality_expression] = STATE(1878),
    [sym_relational_expression] = STATE(1878),
    [sym_shift_expression] = STATE(1878),
    [sym_math_expression] = STATE(1878),
    [sym_cast_expression] = STATE(1878),
    [sym_sizeof_expression] = STATE(1878),
    [sym_subscript_expression] = STATE(1878),
    [sym_call_expression] = STATE(1878),
    [sym_field_expression] = STATE(1878),
    [sym_compound_literal_expression] = STATE(1878),
    [sym_parenthesized_expression] = STATE(1878),
    [sym_concatenated_string] = STATE(1878),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1878),
    [sym_new_expression] = STATE(1878),
    [sym_delete_expression] = STATE(1878),
    [sym_lambda_expression] = STATE(1878),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4148),
    [sym_char_literal] = ACTIONS(4148),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [sym_null] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4150),
  },
  [1284] = {
    [sym__expression] = STATE(1879),
    [sym_conditional_expression] = STATE(1879),
    [sym_assignment_expression] = STATE(1879),
    [sym_pointer_expression] = STATE(1879),
    [sym_logical_expression] = STATE(1879),
    [sym_bitwise_expression] = STATE(1879),
    [sym_equality_expression] = STATE(1879),
    [sym_relational_expression] = STATE(1879),
    [sym_shift_expression] = STATE(1879),
    [sym_math_expression] = STATE(1879),
    [sym_cast_expression] = STATE(1879),
    [sym_sizeof_expression] = STATE(1879),
    [sym_subscript_expression] = STATE(1879),
    [sym_call_expression] = STATE(1879),
    [sym_field_expression] = STATE(1879),
    [sym_compound_literal_expression] = STATE(1879),
    [sym_parenthesized_expression] = STATE(1879),
    [sym_concatenated_string] = STATE(1879),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1879),
    [sym_new_expression] = STATE(1879),
    [sym_delete_expression] = STATE(1879),
    [sym_lambda_expression] = STATE(1879),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4152),
    [sym_char_literal] = ACTIONS(4152),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4154),
    [sym_false] = ACTIONS(4154),
    [sym_null] = ACTIONS(4154),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4154),
  },
  [1285] = {
    [sym__expression] = STATE(1880),
    [sym_conditional_expression] = STATE(1880),
    [sym_assignment_expression] = STATE(1880),
    [sym_pointer_expression] = STATE(1880),
    [sym_logical_expression] = STATE(1880),
    [sym_bitwise_expression] = STATE(1880),
    [sym_equality_expression] = STATE(1880),
    [sym_relational_expression] = STATE(1880),
    [sym_shift_expression] = STATE(1880),
    [sym_math_expression] = STATE(1880),
    [sym_cast_expression] = STATE(1880),
    [sym_sizeof_expression] = STATE(1880),
    [sym_subscript_expression] = STATE(1880),
    [sym_call_expression] = STATE(1880),
    [sym_field_expression] = STATE(1880),
    [sym_compound_literal_expression] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_concatenated_string] = STATE(1880),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1880),
    [sym_new_expression] = STATE(1880),
    [sym_delete_expression] = STATE(1880),
    [sym_lambda_expression] = STATE(1880),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4156),
    [sym_char_literal] = ACTIONS(4156),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4158),
    [sym_false] = ACTIONS(4158),
    [sym_null] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4158),
  },
  [1286] = {
    [anon_sym_RPAREN] = ACTIONS(4160),
    [sym_comment] = ACTIONS(49),
  },
  [1287] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1882),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1288] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1289] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1883),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(4162),
    [sym_comment] = ACTIONS(49),
  },
  [1290] = {
    [sym__expression] = STATE(1885),
    [sym_conditional_expression] = STATE(1885),
    [sym_assignment_expression] = STATE(1885),
    [sym_pointer_expression] = STATE(1885),
    [sym_logical_expression] = STATE(1885),
    [sym_bitwise_expression] = STATE(1885),
    [sym_equality_expression] = STATE(1885),
    [sym_relational_expression] = STATE(1885),
    [sym_shift_expression] = STATE(1885),
    [sym_math_expression] = STATE(1885),
    [sym_cast_expression] = STATE(1885),
    [sym_sizeof_expression] = STATE(1885),
    [sym_subscript_expression] = STATE(1885),
    [sym_call_expression] = STATE(1885),
    [sym_field_expression] = STATE(1885),
    [sym_compound_literal_expression] = STATE(1885),
    [sym_parenthesized_expression] = STATE(1885),
    [sym_concatenated_string] = STATE(1885),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1885),
    [sym_new_expression] = STATE(1885),
    [sym_delete_expression] = STATE(1885),
    [sym_lambda_expression] = STATE(1885),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4164),
    [sym_char_literal] = ACTIONS(4164),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4168),
  },
  [1291] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1292] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1293] = {
    [ts_builtin_sym_end] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_template] = ACTIONS(4174),
    [anon_sym_namespace] = ACTIONS(4174),
    [anon_sym_using] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [sym_operator_name] = ACTIONS(4172),
  },
  [1294] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(2836),
  },
  [1295] = {
    [sym__expression] = STATE(1887),
    [sym_conditional_expression] = STATE(1887),
    [sym_assignment_expression] = STATE(1887),
    [sym_pointer_expression] = STATE(1887),
    [sym_logical_expression] = STATE(1887),
    [sym_bitwise_expression] = STATE(1887),
    [sym_equality_expression] = STATE(1887),
    [sym_relational_expression] = STATE(1887),
    [sym_shift_expression] = STATE(1887),
    [sym_math_expression] = STATE(1887),
    [sym_cast_expression] = STATE(1887),
    [sym_sizeof_expression] = STATE(1887),
    [sym_subscript_expression] = STATE(1887),
    [sym_call_expression] = STATE(1887),
    [sym_field_expression] = STATE(1887),
    [sym_compound_literal_expression] = STATE(1887),
    [sym_parenthesized_expression] = STATE(1887),
    [sym_concatenated_string] = STATE(1887),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1887),
    [sym_new_expression] = STATE(1887),
    [sym_delete_expression] = STATE(1887),
    [sym_lambda_expression] = STATE(1887),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4176),
    [sym_char_literal] = ACTIONS(4176),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [sym_null] = ACTIONS(4178),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4178),
  },
  [1296] = {
    [sym__expression] = STATE(1888),
    [sym_conditional_expression] = STATE(1888),
    [sym_assignment_expression] = STATE(1888),
    [sym_pointer_expression] = STATE(1888),
    [sym_logical_expression] = STATE(1888),
    [sym_bitwise_expression] = STATE(1888),
    [sym_equality_expression] = STATE(1888),
    [sym_relational_expression] = STATE(1888),
    [sym_shift_expression] = STATE(1888),
    [sym_math_expression] = STATE(1888),
    [sym_cast_expression] = STATE(1888),
    [sym_sizeof_expression] = STATE(1888),
    [sym_subscript_expression] = STATE(1888),
    [sym_call_expression] = STATE(1888),
    [sym_field_expression] = STATE(1888),
    [sym_compound_literal_expression] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1888),
    [sym_concatenated_string] = STATE(1888),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1888),
    [sym_new_expression] = STATE(1888),
    [sym_delete_expression] = STATE(1888),
    [sym_lambda_expression] = STATE(1888),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4180),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4180),
    [sym_char_literal] = ACTIONS(4180),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4182),
  },
  [1297] = {
    [sym__expression] = STATE(1889),
    [sym_conditional_expression] = STATE(1889),
    [sym_assignment_expression] = STATE(1889),
    [sym_pointer_expression] = STATE(1889),
    [sym_logical_expression] = STATE(1889),
    [sym_bitwise_expression] = STATE(1889),
    [sym_equality_expression] = STATE(1889),
    [sym_relational_expression] = STATE(1889),
    [sym_shift_expression] = STATE(1889),
    [sym_math_expression] = STATE(1889),
    [sym_cast_expression] = STATE(1889),
    [sym_sizeof_expression] = STATE(1889),
    [sym_subscript_expression] = STATE(1889),
    [sym_call_expression] = STATE(1889),
    [sym_field_expression] = STATE(1889),
    [sym_compound_literal_expression] = STATE(1889),
    [sym_parenthesized_expression] = STATE(1889),
    [sym_concatenated_string] = STATE(1889),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1889),
    [sym_new_expression] = STATE(1889),
    [sym_delete_expression] = STATE(1889),
    [sym_lambda_expression] = STATE(1889),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4184),
    [sym_char_literal] = ACTIONS(4184),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4186),
    [sym_false] = ACTIONS(4186),
    [sym_null] = ACTIONS(4186),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4186),
  },
  [1298] = {
    [sym__expression] = STATE(1890),
    [sym_conditional_expression] = STATE(1890),
    [sym_assignment_expression] = STATE(1890),
    [sym_pointer_expression] = STATE(1890),
    [sym_logical_expression] = STATE(1890),
    [sym_bitwise_expression] = STATE(1890),
    [sym_equality_expression] = STATE(1890),
    [sym_relational_expression] = STATE(1890),
    [sym_shift_expression] = STATE(1890),
    [sym_math_expression] = STATE(1890),
    [sym_cast_expression] = STATE(1890),
    [sym_sizeof_expression] = STATE(1890),
    [sym_subscript_expression] = STATE(1890),
    [sym_call_expression] = STATE(1890),
    [sym_field_expression] = STATE(1890),
    [sym_compound_literal_expression] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1890),
    [sym_concatenated_string] = STATE(1890),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1890),
    [sym_new_expression] = STATE(1890),
    [sym_delete_expression] = STATE(1890),
    [sym_lambda_expression] = STATE(1890),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4188),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4188),
    [sym_char_literal] = ACTIONS(4188),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4190),
  },
  [1299] = {
    [sym__expression] = STATE(1891),
    [sym_conditional_expression] = STATE(1891),
    [sym_assignment_expression] = STATE(1891),
    [sym_pointer_expression] = STATE(1891),
    [sym_logical_expression] = STATE(1891),
    [sym_bitwise_expression] = STATE(1891),
    [sym_equality_expression] = STATE(1891),
    [sym_relational_expression] = STATE(1891),
    [sym_shift_expression] = STATE(1891),
    [sym_math_expression] = STATE(1891),
    [sym_cast_expression] = STATE(1891),
    [sym_sizeof_expression] = STATE(1891),
    [sym_subscript_expression] = STATE(1891),
    [sym_call_expression] = STATE(1891),
    [sym_field_expression] = STATE(1891),
    [sym_compound_literal_expression] = STATE(1891),
    [sym_parenthesized_expression] = STATE(1891),
    [sym_concatenated_string] = STATE(1891),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1891),
    [sym_new_expression] = STATE(1891),
    [sym_delete_expression] = STATE(1891),
    [sym_lambda_expression] = STATE(1891),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4192),
    [sym_char_literal] = ACTIONS(4192),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4194),
    [sym_false] = ACTIONS(4194),
    [sym_null] = ACTIONS(4194),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4194),
  },
  [1300] = {
    [sym__expression] = STATE(1892),
    [sym_conditional_expression] = STATE(1892),
    [sym_assignment_expression] = STATE(1892),
    [sym_pointer_expression] = STATE(1892),
    [sym_logical_expression] = STATE(1892),
    [sym_bitwise_expression] = STATE(1892),
    [sym_equality_expression] = STATE(1892),
    [sym_relational_expression] = STATE(1892),
    [sym_shift_expression] = STATE(1892),
    [sym_math_expression] = STATE(1892),
    [sym_cast_expression] = STATE(1892),
    [sym_sizeof_expression] = STATE(1892),
    [sym_subscript_expression] = STATE(1892),
    [sym_call_expression] = STATE(1892),
    [sym_field_expression] = STATE(1892),
    [sym_compound_literal_expression] = STATE(1892),
    [sym_parenthesized_expression] = STATE(1892),
    [sym_concatenated_string] = STATE(1892),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1892),
    [sym_new_expression] = STATE(1892),
    [sym_delete_expression] = STATE(1892),
    [sym_lambda_expression] = STATE(1892),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4196),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4196),
    [sym_char_literal] = ACTIONS(4196),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4198),
    [sym_false] = ACTIONS(4198),
    [sym_null] = ACTIONS(4198),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4198),
  },
  [1301] = {
    [sym__expression] = STATE(1893),
    [sym_conditional_expression] = STATE(1893),
    [sym_assignment_expression] = STATE(1893),
    [sym_pointer_expression] = STATE(1893),
    [sym_logical_expression] = STATE(1893),
    [sym_bitwise_expression] = STATE(1893),
    [sym_equality_expression] = STATE(1893),
    [sym_relational_expression] = STATE(1893),
    [sym_shift_expression] = STATE(1893),
    [sym_math_expression] = STATE(1893),
    [sym_cast_expression] = STATE(1893),
    [sym_sizeof_expression] = STATE(1893),
    [sym_subscript_expression] = STATE(1893),
    [sym_call_expression] = STATE(1893),
    [sym_field_expression] = STATE(1893),
    [sym_compound_literal_expression] = STATE(1893),
    [sym_parenthesized_expression] = STATE(1893),
    [sym_concatenated_string] = STATE(1893),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1893),
    [sym_new_expression] = STATE(1893),
    [sym_delete_expression] = STATE(1893),
    [sym_lambda_expression] = STATE(1893),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4200),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4200),
    [sym_char_literal] = ACTIONS(4200),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4202),
    [sym_false] = ACTIONS(4202),
    [sym_null] = ACTIONS(4202),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4202),
  },
  [1302] = {
    [sym__expression] = STATE(1894),
    [sym_conditional_expression] = STATE(1894),
    [sym_assignment_expression] = STATE(1894),
    [sym_pointer_expression] = STATE(1894),
    [sym_logical_expression] = STATE(1894),
    [sym_bitwise_expression] = STATE(1894),
    [sym_equality_expression] = STATE(1894),
    [sym_relational_expression] = STATE(1894),
    [sym_shift_expression] = STATE(1894),
    [sym_math_expression] = STATE(1894),
    [sym_cast_expression] = STATE(1894),
    [sym_sizeof_expression] = STATE(1894),
    [sym_subscript_expression] = STATE(1894),
    [sym_call_expression] = STATE(1894),
    [sym_field_expression] = STATE(1894),
    [sym_compound_literal_expression] = STATE(1894),
    [sym_parenthesized_expression] = STATE(1894),
    [sym_concatenated_string] = STATE(1894),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1894),
    [sym_new_expression] = STATE(1894),
    [sym_delete_expression] = STATE(1894),
    [sym_lambda_expression] = STATE(1894),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4204),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4204),
    [sym_char_literal] = ACTIONS(4204),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4206),
    [sym_false] = ACTIONS(4206),
    [sym_null] = ACTIONS(4206),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4206),
  },
  [1303] = {
    [sym__expression] = STATE(1895),
    [sym_conditional_expression] = STATE(1895),
    [sym_assignment_expression] = STATE(1895),
    [sym_pointer_expression] = STATE(1895),
    [sym_logical_expression] = STATE(1895),
    [sym_bitwise_expression] = STATE(1895),
    [sym_equality_expression] = STATE(1895),
    [sym_relational_expression] = STATE(1895),
    [sym_shift_expression] = STATE(1895),
    [sym_math_expression] = STATE(1895),
    [sym_cast_expression] = STATE(1895),
    [sym_sizeof_expression] = STATE(1895),
    [sym_subscript_expression] = STATE(1895),
    [sym_call_expression] = STATE(1895),
    [sym_field_expression] = STATE(1895),
    [sym_compound_literal_expression] = STATE(1895),
    [sym_parenthesized_expression] = STATE(1895),
    [sym_concatenated_string] = STATE(1895),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1895),
    [sym_new_expression] = STATE(1895),
    [sym_delete_expression] = STATE(1895),
    [sym_lambda_expression] = STATE(1895),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4208),
    [sym_char_literal] = ACTIONS(4208),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4210),
    [sym_false] = ACTIONS(4210),
    [sym_null] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4210),
  },
  [1304] = {
    [sym__expression] = STATE(1896),
    [sym_conditional_expression] = STATE(1896),
    [sym_assignment_expression] = STATE(1896),
    [sym_pointer_expression] = STATE(1896),
    [sym_logical_expression] = STATE(1896),
    [sym_bitwise_expression] = STATE(1896),
    [sym_equality_expression] = STATE(1896),
    [sym_relational_expression] = STATE(1896),
    [sym_shift_expression] = STATE(1896),
    [sym_math_expression] = STATE(1896),
    [sym_cast_expression] = STATE(1896),
    [sym_sizeof_expression] = STATE(1896),
    [sym_subscript_expression] = STATE(1896),
    [sym_call_expression] = STATE(1896),
    [sym_field_expression] = STATE(1896),
    [sym_compound_literal_expression] = STATE(1896),
    [sym_parenthesized_expression] = STATE(1896),
    [sym_concatenated_string] = STATE(1896),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1896),
    [sym_new_expression] = STATE(1896),
    [sym_delete_expression] = STATE(1896),
    [sym_lambda_expression] = STATE(1896),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4212),
    [sym_char_literal] = ACTIONS(4212),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4214),
    [sym_false] = ACTIONS(4214),
    [sym_null] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4214),
  },
  [1305] = {
    [sym__expression] = STATE(1897),
    [sym_conditional_expression] = STATE(1897),
    [sym_assignment_expression] = STATE(1897),
    [sym_pointer_expression] = STATE(1897),
    [sym_logical_expression] = STATE(1897),
    [sym_bitwise_expression] = STATE(1897),
    [sym_equality_expression] = STATE(1897),
    [sym_relational_expression] = STATE(1897),
    [sym_shift_expression] = STATE(1897),
    [sym_math_expression] = STATE(1897),
    [sym_cast_expression] = STATE(1897),
    [sym_sizeof_expression] = STATE(1897),
    [sym_subscript_expression] = STATE(1897),
    [sym_call_expression] = STATE(1897),
    [sym_field_expression] = STATE(1897),
    [sym_compound_literal_expression] = STATE(1897),
    [sym_parenthesized_expression] = STATE(1897),
    [sym_concatenated_string] = STATE(1897),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1897),
    [sym_new_expression] = STATE(1897),
    [sym_delete_expression] = STATE(1897),
    [sym_lambda_expression] = STATE(1897),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4216),
    [sym_char_literal] = ACTIONS(4216),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4218),
    [sym_false] = ACTIONS(4218),
    [sym_null] = ACTIONS(4218),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4218),
  },
  [1306] = {
    [ts_builtin_sym_end] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_RBRACE] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4222),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_template] = ACTIONS(4222),
    [anon_sym_namespace] = ACTIONS(4222),
    [anon_sym_using] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [sym_operator_name] = ACTIONS(4220),
  },
  [1307] = {
    [anon_sym_COMMA] = ACTIONS(4224),
    [anon_sym_RPAREN] = ACTIONS(4224),
    [sym_comment] = ACTIONS(49),
  },
  [1308] = {
    [anon_sym_LPAREN] = ACTIONS(4226),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_RPAREN] = ACTIONS(4226),
    [anon_sym_SEMI] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4226),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_const] = ACTIONS(4228),
    [anon_sym_restrict] = ACTIONS(4226),
    [anon_sym_volatile] = ACTIONS(4226),
    [anon_sym__Atomic] = ACTIONS(4226),
    [anon_sym_mutable] = ACTIONS(4226),
    [anon_sym_explicit] = ACTIONS(4226),
    [anon_sym_constexpr] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4226),
    [anon_sym_DASH_GT] = ACTIONS(4226),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4226),
  },
  [1309] = {
    [aux_sym_parameter_list_repeat1] = STATE(1309),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4224),
    [sym_comment] = ACTIONS(49),
  },
  [1310] = {
    [sym_parameter_list] = STATE(1315),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(869),
    [sym_comment] = ACTIONS(49),
  },
  [1311] = {
    [sym_parameter_list] = STATE(1316),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1312] = {
    [sym_parameter_list] = STATE(1315),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(871),
    [sym_comment] = ACTIONS(49),
  },
  [1313] = {
    [sym_parameter_list] = STATE(1316),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1314] = {
    [sym__expression] = STATE(1898),
    [sym_conditional_expression] = STATE(1898),
    [sym_assignment_expression] = STATE(1898),
    [sym_pointer_expression] = STATE(1898),
    [sym_logical_expression] = STATE(1898),
    [sym_bitwise_expression] = STATE(1898),
    [sym_equality_expression] = STATE(1898),
    [sym_relational_expression] = STATE(1898),
    [sym_shift_expression] = STATE(1898),
    [sym_math_expression] = STATE(1898),
    [sym_cast_expression] = STATE(1898),
    [sym_sizeof_expression] = STATE(1898),
    [sym_subscript_expression] = STATE(1898),
    [sym_call_expression] = STATE(1898),
    [sym_field_expression] = STATE(1898),
    [sym_compound_literal_expression] = STATE(1898),
    [sym_parenthesized_expression] = STATE(1898),
    [sym_initializer_list] = STATE(711),
    [sym_concatenated_string] = STATE(1898),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1898),
    [sym_new_expression] = STATE(1898),
    [sym_delete_expression] = STATE(1898),
    [sym_lambda_expression] = STATE(1898),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(4233),
    [sym_char_literal] = ACTIONS(4233),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(4235),
    [sym_false] = ACTIONS(4235),
    [sym_null] = ACTIONS(4235),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(4235),
  },
  [1315] = {
    [sym_type_qualifier] = STATE(1900),
    [sym_trailing_return_type] = STATE(1900),
    [aux_sym_function_declarator_repeat1] = STATE(1900),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4237),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4239),
  },
  [1316] = {
    [sym_type_qualifier] = STATE(1901),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1901),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2677),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4241),
  },
  [1317] = {
    [sym__type_specifier] = STATE(1903),
    [sym_sized_type_specifier] = STATE(1903),
    [sym_enum_specifier] = STATE(1903),
    [sym_struct_specifier] = STATE(1903),
    [sym_union_specifier] = STATE(1903),
    [sym_macro_type_specifier] = STATE(1903),
    [sym_class_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(1903),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1904),
    [anon_sym_unsigned] = ACTIONS(4243),
    [anon_sym_long] = ACTIONS(4243),
    [anon_sym_short] = ACTIONS(4243),
    [sym_primitive_type] = ACTIONS(4245),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(4245),
    [anon_sym_typename] = ACTIONS(4247),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1318] = {
    [sym_type_qualifier] = STATE(1905),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1905),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2677),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4249),
  },
  [1319] = {
    [sym_storage_class_specifier] = STATE(1319),
    [sym_type_qualifier] = STATE(1319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1319),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_register] = ACTIONS(1850),
    [anon_sym_inline] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_restrict] = ACTIONS(1853),
    [anon_sym_volatile] = ACTIONS(1853),
    [anon_sym__Atomic] = ACTIONS(1853),
    [anon_sym_mutable] = ACTIONS(1853),
    [anon_sym_explicit] = ACTIONS(1853),
    [anon_sym_constexpr] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [sym_operator_name] = ACTIONS(830),
  },
  [1320] = {
    [sym_storage_class_specifier] = STATE(1319),
    [sym_type_qualifier] = STATE(1319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1319),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_RPAREN] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(226),
    [anon_sym_register] = ACTIONS(226),
    [anon_sym_inline] = ACTIONS(226),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_restrict] = ACTIONS(228),
    [anon_sym_volatile] = ACTIONS(228),
    [anon_sym__Atomic] = ACTIONS(228),
    [anon_sym_mutable] = ACTIONS(228),
    [anon_sym_explicit] = ACTIONS(228),
    [anon_sym_constexpr] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [sym_operator_name] = ACTIONS(1869),
  },
  [1321] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1322] = {
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_RPAREN] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3800),
    [anon_sym_RBRACE] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(4251),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_RBRACK] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_STAR_EQ] = ACTIONS(3800),
    [anon_sym_SLASH_EQ] = ACTIONS(3800),
    [anon_sym_PERCENT_EQ] = ACTIONS(3800),
    [anon_sym_PLUS_EQ] = ACTIONS(3800),
    [anon_sym_DASH_EQ] = ACTIONS(3800),
    [anon_sym_LT_LT_EQ] = ACTIONS(3800),
    [anon_sym_GT_GT_EQ] = ACTIONS(3800),
    [anon_sym_AMP_EQ] = ACTIONS(3800),
    [anon_sym_CARET_EQ] = ACTIONS(3800),
    [anon_sym_PIPE_EQ] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(4251),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_PIPE] = ACTIONS(4251),
    [anon_sym_CARET] = ACTIONS(4251),
    [anon_sym_EQ_EQ] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(4251),
    [anon_sym_GT] = ACTIONS(4251),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(4251),
    [anon_sym_GT_GT] = ACTIONS(4251),
    [anon_sym_PLUS] = ACTIONS(4251),
    [anon_sym_DASH] = ACTIONS(4251),
    [anon_sym_SLASH] = ACTIONS(4251),
    [anon_sym_PERCENT] = ACTIONS(4251),
    [anon_sym_DASH_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_PLUS] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DASH_GT] = ACTIONS(3800),
    [sym_comment] = ACTIONS(49),
  },
  [1323] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1324] = {
    [sym__abstract_declarator] = STATE(1908),
    [sym_abstract_pointer_declarator] = STATE(1908),
    [sym_abstract_function_declarator] = STATE(1908),
    [sym_abstract_array_declarator] = STATE(1908),
    [sym_parameter_list] = STATE(1173),
    [sym_abstract_reference_declarator] = STATE(1908),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_comment] = ACTIONS(49),
  },
  [1325] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1325),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(4257),
    [anon_sym_long] = ACTIONS(4257),
    [anon_sym_short] = ACTIONS(4257),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [1326] = {
    [anon_sym_RPAREN] = ACTIONS(4260),
    [sym_comment] = ACTIONS(49),
  },
  [1327] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(1910),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1328] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1329] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1911),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(4262),
    [sym_comment] = ACTIONS(49),
  },
  [1330] = {
    [sym__expression] = STATE(1913),
    [sym_conditional_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(1913),
    [sym_pointer_expression] = STATE(1913),
    [sym_logical_expression] = STATE(1913),
    [sym_bitwise_expression] = STATE(1913),
    [sym_equality_expression] = STATE(1913),
    [sym_relational_expression] = STATE(1913),
    [sym_shift_expression] = STATE(1913),
    [sym_math_expression] = STATE(1913),
    [sym_cast_expression] = STATE(1913),
    [sym_sizeof_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_call_expression] = STATE(1913),
    [sym_field_expression] = STATE(1913),
    [sym_compound_literal_expression] = STATE(1913),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_concatenated_string] = STATE(1913),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1913),
    [sym_new_expression] = STATE(1913),
    [sym_delete_expression] = STATE(1913),
    [sym_lambda_expression] = STATE(1913),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4264),
    [sym_char_literal] = ACTIONS(4264),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4268),
    [sym_false] = ACTIONS(4268),
    [sym_null] = ACTIONS(4268),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4268),
  },
  [1331] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4270),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1332] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1333] = {
    [sym__expression] = STATE(1915),
    [sym_conditional_expression] = STATE(1915),
    [sym_assignment_expression] = STATE(1915),
    [sym_pointer_expression] = STATE(1915),
    [sym_logical_expression] = STATE(1915),
    [sym_bitwise_expression] = STATE(1915),
    [sym_equality_expression] = STATE(1915),
    [sym_relational_expression] = STATE(1915),
    [sym_shift_expression] = STATE(1915),
    [sym_math_expression] = STATE(1915),
    [sym_cast_expression] = STATE(1915),
    [sym_sizeof_expression] = STATE(1915),
    [sym_subscript_expression] = STATE(1915),
    [sym_call_expression] = STATE(1915),
    [sym_field_expression] = STATE(1915),
    [sym_compound_literal_expression] = STATE(1915),
    [sym_parenthesized_expression] = STATE(1915),
    [sym_concatenated_string] = STATE(1915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1915),
    [sym_new_expression] = STATE(1915),
    [sym_delete_expression] = STATE(1915),
    [sym_lambda_expression] = STATE(1915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4272),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4272),
    [sym_char_literal] = ACTIONS(4272),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4274),
    [sym_false] = ACTIONS(4274),
    [sym_null] = ACTIONS(4274),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4274),
  },
  [1334] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(2836),
  },
  [1335] = {
    [anon_sym_LPAREN] = ACTIONS(4276),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_AMP] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4276),
    [sym_comment] = ACTIONS(49),
  },
  [1336] = {
    [sym__expression] = STATE(1916),
    [sym_conditional_expression] = STATE(1916),
    [sym_assignment_expression] = STATE(1916),
    [sym_pointer_expression] = STATE(1916),
    [sym_logical_expression] = STATE(1916),
    [sym_bitwise_expression] = STATE(1916),
    [sym_equality_expression] = STATE(1916),
    [sym_relational_expression] = STATE(1916),
    [sym_shift_expression] = STATE(1916),
    [sym_math_expression] = STATE(1916),
    [sym_cast_expression] = STATE(1916),
    [sym_sizeof_expression] = STATE(1916),
    [sym_subscript_expression] = STATE(1916),
    [sym_call_expression] = STATE(1916),
    [sym_field_expression] = STATE(1916),
    [sym_compound_literal_expression] = STATE(1916),
    [sym_parenthesized_expression] = STATE(1916),
    [sym_concatenated_string] = STATE(1916),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1916),
    [sym_new_expression] = STATE(1916),
    [sym_delete_expression] = STATE(1916),
    [sym_lambda_expression] = STATE(1916),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4280),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4280),
    [sym_char_literal] = ACTIONS(4280),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4282),
    [sym_false] = ACTIONS(4282),
    [sym_null] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4282),
  },
  [1337] = {
    [sym__expression] = STATE(1917),
    [sym_conditional_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(1917),
    [sym_pointer_expression] = STATE(1917),
    [sym_logical_expression] = STATE(1917),
    [sym_bitwise_expression] = STATE(1917),
    [sym_equality_expression] = STATE(1917),
    [sym_relational_expression] = STATE(1917),
    [sym_shift_expression] = STATE(1917),
    [sym_math_expression] = STATE(1917),
    [sym_cast_expression] = STATE(1917),
    [sym_sizeof_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_call_expression] = STATE(1917),
    [sym_field_expression] = STATE(1917),
    [sym_compound_literal_expression] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_concatenated_string] = STATE(1917),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1917),
    [sym_new_expression] = STATE(1917),
    [sym_delete_expression] = STATE(1917),
    [sym_lambda_expression] = STATE(1917),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4284),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4284),
    [sym_char_literal] = ACTIONS(4284),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4286),
    [sym_false] = ACTIONS(4286),
    [sym_null] = ACTIONS(4286),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4286),
  },
  [1338] = {
    [sym__expression] = STATE(1918),
    [sym_conditional_expression] = STATE(1918),
    [sym_assignment_expression] = STATE(1918),
    [sym_pointer_expression] = STATE(1918),
    [sym_logical_expression] = STATE(1918),
    [sym_bitwise_expression] = STATE(1918),
    [sym_equality_expression] = STATE(1918),
    [sym_relational_expression] = STATE(1918),
    [sym_shift_expression] = STATE(1918),
    [sym_math_expression] = STATE(1918),
    [sym_cast_expression] = STATE(1918),
    [sym_sizeof_expression] = STATE(1918),
    [sym_subscript_expression] = STATE(1918),
    [sym_call_expression] = STATE(1918),
    [sym_field_expression] = STATE(1918),
    [sym_compound_literal_expression] = STATE(1918),
    [sym_parenthesized_expression] = STATE(1918),
    [sym_concatenated_string] = STATE(1918),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1918),
    [sym_new_expression] = STATE(1918),
    [sym_delete_expression] = STATE(1918),
    [sym_lambda_expression] = STATE(1918),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4288),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4288),
    [sym_char_literal] = ACTIONS(4288),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4290),
    [sym_false] = ACTIONS(4290),
    [sym_null] = ACTIONS(4290),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4290),
  },
  [1339] = {
    [sym__expression] = STATE(1919),
    [sym_conditional_expression] = STATE(1919),
    [sym_assignment_expression] = STATE(1919),
    [sym_pointer_expression] = STATE(1919),
    [sym_logical_expression] = STATE(1919),
    [sym_bitwise_expression] = STATE(1919),
    [sym_equality_expression] = STATE(1919),
    [sym_relational_expression] = STATE(1919),
    [sym_shift_expression] = STATE(1919),
    [sym_math_expression] = STATE(1919),
    [sym_cast_expression] = STATE(1919),
    [sym_sizeof_expression] = STATE(1919),
    [sym_subscript_expression] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_field_expression] = STATE(1919),
    [sym_compound_literal_expression] = STATE(1919),
    [sym_parenthesized_expression] = STATE(1919),
    [sym_concatenated_string] = STATE(1919),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1919),
    [sym_new_expression] = STATE(1919),
    [sym_delete_expression] = STATE(1919),
    [sym_lambda_expression] = STATE(1919),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4292),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4292),
    [sym_char_literal] = ACTIONS(4292),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4294),
    [sym_false] = ACTIONS(4294),
    [sym_null] = ACTIONS(4294),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4294),
  },
  [1340] = {
    [sym__expression] = STATE(1920),
    [sym_conditional_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_pointer_expression] = STATE(1920),
    [sym_logical_expression] = STATE(1920),
    [sym_bitwise_expression] = STATE(1920),
    [sym_equality_expression] = STATE(1920),
    [sym_relational_expression] = STATE(1920),
    [sym_shift_expression] = STATE(1920),
    [sym_math_expression] = STATE(1920),
    [sym_cast_expression] = STATE(1920),
    [sym_sizeof_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_field_expression] = STATE(1920),
    [sym_compound_literal_expression] = STATE(1920),
    [sym_parenthesized_expression] = STATE(1920),
    [sym_concatenated_string] = STATE(1920),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_delete_expression] = STATE(1920),
    [sym_lambda_expression] = STATE(1920),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4296),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4296),
    [sym_char_literal] = ACTIONS(4296),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4298),
    [sym_false] = ACTIONS(4298),
    [sym_null] = ACTIONS(4298),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4298),
  },
  [1341] = {
    [sym__expression] = STATE(1921),
    [sym_conditional_expression] = STATE(1921),
    [sym_assignment_expression] = STATE(1921),
    [sym_pointer_expression] = STATE(1921),
    [sym_logical_expression] = STATE(1921),
    [sym_bitwise_expression] = STATE(1921),
    [sym_equality_expression] = STATE(1921),
    [sym_relational_expression] = STATE(1921),
    [sym_shift_expression] = STATE(1921),
    [sym_math_expression] = STATE(1921),
    [sym_cast_expression] = STATE(1921),
    [sym_sizeof_expression] = STATE(1921),
    [sym_subscript_expression] = STATE(1921),
    [sym_call_expression] = STATE(1921),
    [sym_field_expression] = STATE(1921),
    [sym_compound_literal_expression] = STATE(1921),
    [sym_parenthesized_expression] = STATE(1921),
    [sym_concatenated_string] = STATE(1921),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1921),
    [sym_new_expression] = STATE(1921),
    [sym_delete_expression] = STATE(1921),
    [sym_lambda_expression] = STATE(1921),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4300),
    [sym_char_literal] = ACTIONS(4300),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4302),
    [sym_false] = ACTIONS(4302),
    [sym_null] = ACTIONS(4302),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4302),
  },
  [1342] = {
    [sym__expression] = STATE(1922),
    [sym_conditional_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(1922),
    [sym_pointer_expression] = STATE(1922),
    [sym_logical_expression] = STATE(1922),
    [sym_bitwise_expression] = STATE(1922),
    [sym_equality_expression] = STATE(1922),
    [sym_relational_expression] = STATE(1922),
    [sym_shift_expression] = STATE(1922),
    [sym_math_expression] = STATE(1922),
    [sym_cast_expression] = STATE(1922),
    [sym_sizeof_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_call_expression] = STATE(1922),
    [sym_field_expression] = STATE(1922),
    [sym_compound_literal_expression] = STATE(1922),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_concatenated_string] = STATE(1922),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1922),
    [sym_new_expression] = STATE(1922),
    [sym_delete_expression] = STATE(1922),
    [sym_lambda_expression] = STATE(1922),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4304),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4304),
    [sym_char_literal] = ACTIONS(4304),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4306),
    [sym_false] = ACTIONS(4306),
    [sym_null] = ACTIONS(4306),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4306),
  },
  [1343] = {
    [sym__expression] = STATE(1923),
    [sym_conditional_expression] = STATE(1923),
    [sym_assignment_expression] = STATE(1923),
    [sym_pointer_expression] = STATE(1923),
    [sym_logical_expression] = STATE(1923),
    [sym_bitwise_expression] = STATE(1923),
    [sym_equality_expression] = STATE(1923),
    [sym_relational_expression] = STATE(1923),
    [sym_shift_expression] = STATE(1923),
    [sym_math_expression] = STATE(1923),
    [sym_cast_expression] = STATE(1923),
    [sym_sizeof_expression] = STATE(1923),
    [sym_subscript_expression] = STATE(1923),
    [sym_call_expression] = STATE(1923),
    [sym_field_expression] = STATE(1923),
    [sym_compound_literal_expression] = STATE(1923),
    [sym_parenthesized_expression] = STATE(1923),
    [sym_concatenated_string] = STATE(1923),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1923),
    [sym_new_expression] = STATE(1923),
    [sym_delete_expression] = STATE(1923),
    [sym_lambda_expression] = STATE(1923),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4308),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4308),
    [sym_char_literal] = ACTIONS(4308),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4310),
    [sym_false] = ACTIONS(4310),
    [sym_null] = ACTIONS(4310),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4310),
  },
  [1344] = {
    [sym__expression] = STATE(1924),
    [sym_conditional_expression] = STATE(1924),
    [sym_assignment_expression] = STATE(1924),
    [sym_pointer_expression] = STATE(1924),
    [sym_logical_expression] = STATE(1924),
    [sym_bitwise_expression] = STATE(1924),
    [sym_equality_expression] = STATE(1924),
    [sym_relational_expression] = STATE(1924),
    [sym_shift_expression] = STATE(1924),
    [sym_math_expression] = STATE(1924),
    [sym_cast_expression] = STATE(1924),
    [sym_sizeof_expression] = STATE(1924),
    [sym_subscript_expression] = STATE(1924),
    [sym_call_expression] = STATE(1924),
    [sym_field_expression] = STATE(1924),
    [sym_compound_literal_expression] = STATE(1924),
    [sym_parenthesized_expression] = STATE(1924),
    [sym_concatenated_string] = STATE(1924),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1924),
    [sym_new_expression] = STATE(1924),
    [sym_delete_expression] = STATE(1924),
    [sym_lambda_expression] = STATE(1924),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4312),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4312),
    [sym_char_literal] = ACTIONS(4312),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4314),
    [sym_false] = ACTIONS(4314),
    [sym_null] = ACTIONS(4314),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4314),
  },
  [1345] = {
    [sym__expression] = STATE(1925),
    [sym_conditional_expression] = STATE(1925),
    [sym_assignment_expression] = STATE(1925),
    [sym_pointer_expression] = STATE(1925),
    [sym_logical_expression] = STATE(1925),
    [sym_bitwise_expression] = STATE(1925),
    [sym_equality_expression] = STATE(1925),
    [sym_relational_expression] = STATE(1925),
    [sym_shift_expression] = STATE(1925),
    [sym_math_expression] = STATE(1925),
    [sym_cast_expression] = STATE(1925),
    [sym_sizeof_expression] = STATE(1925),
    [sym_subscript_expression] = STATE(1925),
    [sym_call_expression] = STATE(1925),
    [sym_field_expression] = STATE(1925),
    [sym_compound_literal_expression] = STATE(1925),
    [sym_parenthesized_expression] = STATE(1925),
    [sym_concatenated_string] = STATE(1925),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1925),
    [sym_new_expression] = STATE(1925),
    [sym_delete_expression] = STATE(1925),
    [sym_lambda_expression] = STATE(1925),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4316),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4316),
    [sym_char_literal] = ACTIONS(4316),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4318),
    [sym_false] = ACTIONS(4318),
    [sym_null] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4318),
  },
  [1346] = {
    [sym__expression] = STATE(1926),
    [sym_conditional_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(1926),
    [sym_pointer_expression] = STATE(1926),
    [sym_logical_expression] = STATE(1926),
    [sym_bitwise_expression] = STATE(1926),
    [sym_equality_expression] = STATE(1926),
    [sym_relational_expression] = STATE(1926),
    [sym_shift_expression] = STATE(1926),
    [sym_math_expression] = STATE(1926),
    [sym_cast_expression] = STATE(1926),
    [sym_sizeof_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_call_expression] = STATE(1926),
    [sym_field_expression] = STATE(1926),
    [sym_compound_literal_expression] = STATE(1926),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_concatenated_string] = STATE(1926),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1926),
    [sym_new_expression] = STATE(1926),
    [sym_delete_expression] = STATE(1926),
    [sym_lambda_expression] = STATE(1926),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4320),
    [sym_char_literal] = ACTIONS(4320),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4322),
    [sym_false] = ACTIONS(4322),
    [sym_null] = ACTIONS(4322),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4322),
  },
  [1347] = {
    [aux_sym_for_statement_repeat1] = STATE(1928),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_RBRACK] = ACTIONS(4324),
    [sym_comment] = ACTIONS(49),
  },
  [1348] = {
    [anon_sym_RBRACE] = ACTIONS(4326),
    [sym_comment] = ACTIONS(49),
  },
  [1349] = {
    [sym_raw_string_literal] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_extern] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_register] = ACTIONS(1031),
    [anon_sym_inline] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_restrict] = ACTIONS(1031),
    [anon_sym_volatile] = ACTIONS(1031),
    [anon_sym__Atomic] = ACTIONS(1031),
    [anon_sym_mutable] = ACTIONS(1031),
    [anon_sym_explicit] = ACTIONS(1031),
    [anon_sym_constexpr] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_sizeof] = ACTIONS(1031),
    [sym_number_literal] = ACTIONS(1029),
    [sym_char_literal] = ACTIONS(1029),
    [sym_string_literal] = ACTIONS(1029),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_identifier] = ACTIONS(1031),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(1029),
    [anon_sym_delete] = ACTIONS(1031),
    [sym_nullptr] = ACTIONS(1031),
  },
  [1350] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1931),
    [anon_sym_COMMA] = ACTIONS(4328),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [sym_comment] = ACTIONS(49),
  },
  [1351] = {
    [sym_raw_string_literal] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_register] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_restrict] = ACTIONS(1041),
    [anon_sym_volatile] = ACTIONS(1041),
    [anon_sym__Atomic] = ACTIONS(1041),
    [anon_sym_mutable] = ACTIONS(1041),
    [anon_sym_explicit] = ACTIONS(1041),
    [anon_sym_constexpr] = ACTIONS(1041),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1041),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_identifier] = ACTIONS(1041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(1039),
    [anon_sym_delete] = ACTIONS(1041),
    [sym_nullptr] = ACTIONS(1041),
  },
  [1352] = {
    [sym_raw_string_literal] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_extern] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_RBRACK] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_register] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_restrict] = ACTIONS(1053),
    [anon_sym_volatile] = ACTIONS(1053),
    [anon_sym__Atomic] = ACTIONS(1053),
    [anon_sym_mutable] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(1053),
    [anon_sym_constexpr] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_sizeof] = ACTIONS(1053),
    [sym_number_literal] = ACTIONS(1051),
    [sym_char_literal] = ACTIONS(1051),
    [sym_string_literal] = ACTIONS(1051),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_identifier] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1053),
    [sym_nullptr] = ACTIONS(1053),
  },
  [1353] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(593),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(593),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(593),
    [sym_access_specifier] = STATE(593),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(593),
    [sym_alias_declaration] = STATE(593),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1354] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1934),
    [sym_parenthesized_expression] = STATE(1934),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(4332),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1355] = {
    [sym_identifier] = ACTIONS(4334),
    [sym_comment] = ACTIONS(49),
  },
  [1356] = {
    [sym_raw_string_literal] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_sizeof] = ACTIONS(473),
    [sym_number_literal] = ACTIONS(471),
    [sym_char_literal] = ACTIONS(471),
    [sym_string_literal] = ACTIONS(471),
    [sym_true] = ACTIONS(473),
    [sym_false] = ACTIONS(473),
    [sym_null] = ACTIONS(473),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(473),
    [anon_sym_new] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(473),
    [sym_nullptr] = ACTIONS(473),
  },
  [1357] = {
    [sym_raw_string_literal] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_RBRACK] = ACTIONS(1121),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym_mutable] = ACTIONS(1123),
    [anon_sym_explicit] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_sizeof] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1121),
    [sym_char_literal] = ACTIONS(1121),
    [sym_string_literal] = ACTIONS(1121),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_null] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(1123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [anon_sym_delete] = ACTIONS(1123),
    [sym_nullptr] = ACTIONS(1123),
  },
  [1358] = {
    [sym_field_declaration_list] = STATE(1936),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1359] = {
    [sym_raw_string_literal] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_RBRACK] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(546),
    [anon_sym_DASH] = ACTIONS(546),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_sizeof] = ACTIONS(546),
    [sym_number_literal] = ACTIONS(544),
    [sym_char_literal] = ACTIONS(544),
    [sym_string_literal] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_null] = ACTIONS(546),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(546),
    [anon_sym_new] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [anon_sym_delete] = ACTIONS(546),
    [sym_nullptr] = ACTIONS(546),
  },
  [1360] = {
    [sym_field_declaration_list] = STATE(1936),
    [sym_base_class_clause] = STATE(1937),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1361] = {
    [sym_identifier] = ACTIONS(4336),
    [sym_comment] = ACTIONS(49),
  },
  [1362] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [sym_string_literal] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [anon_sym_delete] = ACTIONS(742),
    [sym_nullptr] = ACTIONS(742),
  },
  [1363] = {
    [sym_raw_string_literal] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1127),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym_mutable] = ACTIONS(1129),
    [anon_sym_explicit] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_sizeof] = ACTIONS(1129),
    [sym_number_literal] = ACTIONS(1127),
    [sym_char_literal] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1127),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [sym_null] = ACTIONS(1129),
    [sym_identifier] = ACTIONS(1129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1129),
    [anon_sym_COLON_COLON] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1129),
    [sym_nullptr] = ACTIONS(1129),
  },
  [1364] = {
    [sym_field_declaration_list] = STATE(1939),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1365] = {
    [sym_field_declaration_list] = STATE(1939),
    [sym_base_class_clause] = STATE(1940),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1366] = {
    [anon_sym_RPAREN] = ACTIONS(4338),
    [sym_comment] = ACTIONS(49),
  },
  [1367] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1367),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_RBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(4344),
    [sym_comment] = ACTIONS(49),
  },
  [1368] = {
    [sym_raw_string_literal] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_EQ] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_STAR_EQ] = ACTIONS(1157),
    [anon_sym_SLASH_EQ] = ACTIONS(1157),
    [anon_sym_PERCENT_EQ] = ACTIONS(1157),
    [anon_sym_PLUS_EQ] = ACTIONS(1157),
    [anon_sym_DASH_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_GT_EQ] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(1157),
    [anon_sym_CARET_EQ] = ACTIONS(1157),
    [anon_sym_PIPE_EQ] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1159),
    [anon_sym_GT] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1159),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(1159),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_sizeof] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [sym_number_literal] = ACTIONS(1157),
    [sym_char_literal] = ACTIONS(1157),
    [sym_string_literal] = ACTIONS(1157),
    [sym_true] = ACTIONS(1159),
    [sym_false] = ACTIONS(1159),
    [sym_null] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1159),
    [sym_nullptr] = ACTIONS(1159),
  },
  [1369] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1943),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(4347),
    [sym_comment] = ACTIONS(49),
  },
  [1370] = {
    [sym_raw_string_literal] = ACTIONS(1186),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(1183),
    [anon_sym_RBRACK] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(4349),
    [anon_sym_DASH] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1183),
    [anon_sym_sizeof] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_number_literal] = ACTIONS(1186),
    [sym_char_literal] = ACTIONS(1186),
    [sym_string_literal] = ACTIONS(1186),
    [sym_true] = ACTIONS(1188),
    [sym_false] = ACTIONS(1188),
    [sym_null] = ACTIONS(1188),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [anon_sym_delete] = ACTIONS(1188),
    [sym_nullptr] = ACTIONS(1188),
  },
  [1371] = {
    [sym_raw_string_literal] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_extern] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_RBRACK] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1198),
    [anon_sym_register] = ACTIONS(1198),
    [anon_sym_inline] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_restrict] = ACTIONS(1198),
    [anon_sym_volatile] = ACTIONS(1198),
    [anon_sym__Atomic] = ACTIONS(1198),
    [anon_sym_mutable] = ACTIONS(1198),
    [anon_sym_explicit] = ACTIONS(1198),
    [anon_sym_constexpr] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_BANG] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_DASH_DASH] = ACTIONS(1196),
    [anon_sym_PLUS_PLUS] = ACTIONS(1196),
    [anon_sym_sizeof] = ACTIONS(1198),
    [sym_number_literal] = ACTIONS(1196),
    [sym_char_literal] = ACTIONS(1196),
    [sym_string_literal] = ACTIONS(1196),
    [sym_true] = ACTIONS(1198),
    [sym_false] = ACTIONS(1198),
    [sym_null] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1198),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1198),
    [anon_sym_COLON_COLON] = ACTIONS(1196),
    [anon_sym_delete] = ACTIONS(1198),
    [sym_nullptr] = ACTIONS(1198),
  },
  [1372] = {
    [sym_field_declaration_list] = STATE(1944),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1373] = {
    [sym_field_declaration_list] = STATE(1944),
    [sym_base_class_clause] = STATE(1945),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1374] = {
    [sym_identifier] = ACTIONS(4352),
    [sym_comment] = ACTIONS(49),
  },
  [1375] = {
    [sym_raw_string_literal] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(471),
    [anon_sym_sizeof] = ACTIONS(473),
    [sym_number_literal] = ACTIONS(471),
    [sym_char_literal] = ACTIONS(471),
    [sym_string_literal] = ACTIONS(471),
    [sym_true] = ACTIONS(473),
    [sym_false] = ACTIONS(473),
    [sym_null] = ACTIONS(473),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(473),
    [sym_nullptr] = ACTIONS(473),
  },
  [1376] = {
    [sym_raw_string_literal] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_RBRACK] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(546),
    [anon_sym_DASH] = ACTIONS(546),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_sizeof] = ACTIONS(546),
    [sym_number_literal] = ACTIONS(544),
    [sym_char_literal] = ACTIONS(544),
    [sym_string_literal] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_null] = ACTIONS(546),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [anon_sym_delete] = ACTIONS(546),
    [sym_nullptr] = ACTIONS(546),
  },
  [1377] = {
    [sym_identifier] = ACTIONS(4354),
    [sym_comment] = ACTIONS(49),
  },
  [1378] = {
    [sym__expression] = STATE(1948),
    [sym_conditional_expression] = STATE(1948),
    [sym_assignment_expression] = STATE(1948),
    [sym_pointer_expression] = STATE(1948),
    [sym_logical_expression] = STATE(1948),
    [sym_bitwise_expression] = STATE(1948),
    [sym_equality_expression] = STATE(1948),
    [sym_relational_expression] = STATE(1948),
    [sym_shift_expression] = STATE(1948),
    [sym_math_expression] = STATE(1948),
    [sym_cast_expression] = STATE(1948),
    [sym_sizeof_expression] = STATE(1948),
    [sym_subscript_expression] = STATE(1948),
    [sym_call_expression] = STATE(1948),
    [sym_field_expression] = STATE(1948),
    [sym_compound_literal_expression] = STATE(1948),
    [sym_parenthesized_expression] = STATE(1948),
    [sym_concatenated_string] = STATE(1948),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1948),
    [sym_new_expression] = STATE(1948),
    [sym_delete_expression] = STATE(1948),
    [sym_lambda_expression] = STATE(1948),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4356),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(4356),
    [sym_char_literal] = ACTIONS(4356),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(4358),
    [sym_false] = ACTIONS(4358),
    [sym_null] = ACTIONS(4358),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(4358),
  },
  [1379] = {
    [anon_sym_LPAREN] = ACTIONS(4360),
    [anon_sym_COMMA] = ACTIONS(4360),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_STAR] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [anon_sym_RBRACK] = ACTIONS(4360),
    [anon_sym_EQ] = ACTIONS(4362),
    [anon_sym_COLON] = ACTIONS(4360),
    [anon_sym_QMARK] = ACTIONS(4360),
    [anon_sym_STAR_EQ] = ACTIONS(4360),
    [anon_sym_SLASH_EQ] = ACTIONS(4360),
    [anon_sym_PERCENT_EQ] = ACTIONS(4360),
    [anon_sym_PLUS_EQ] = ACTIONS(4360),
    [anon_sym_DASH_EQ] = ACTIONS(4360),
    [anon_sym_LT_LT_EQ] = ACTIONS(4360),
    [anon_sym_GT_GT_EQ] = ACTIONS(4360),
    [anon_sym_AMP_EQ] = ACTIONS(4360),
    [anon_sym_CARET_EQ] = ACTIONS(4360),
    [anon_sym_PIPE_EQ] = ACTIONS(4360),
    [anon_sym_AMP] = ACTIONS(4362),
    [anon_sym_PIPE_PIPE] = ACTIONS(4360),
    [anon_sym_AMP_AMP] = ACTIONS(4360),
    [anon_sym_PIPE] = ACTIONS(4362),
    [anon_sym_CARET] = ACTIONS(4362),
    [anon_sym_EQ_EQ] = ACTIONS(4360),
    [anon_sym_BANG_EQ] = ACTIONS(4360),
    [anon_sym_LT] = ACTIONS(4362),
    [anon_sym_GT] = ACTIONS(4362),
    [anon_sym_LT_EQ] = ACTIONS(4360),
    [anon_sym_GT_EQ] = ACTIONS(4360),
    [anon_sym_LT_LT] = ACTIONS(4362),
    [anon_sym_GT_GT] = ACTIONS(4362),
    [anon_sym_PLUS] = ACTIONS(4362),
    [anon_sym_DASH] = ACTIONS(4362),
    [anon_sym_SLASH] = ACTIONS(4362),
    [anon_sym_PERCENT] = ACTIONS(4362),
    [anon_sym_DASH_DASH] = ACTIONS(4360),
    [anon_sym_PLUS_PLUS] = ACTIONS(4360),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_DASH_GT] = ACTIONS(4360),
    [sym_comment] = ACTIONS(49),
  },
  [1380] = {
    [sym_argument_list] = STATE(1949),
    [sym_initializer_list] = STATE(1949),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
  },
  [1381] = {
    [sym_argument_list] = STATE(1950),
    [sym_initializer_list] = STATE(1950),
    [sym_template_argument_list] = STATE(212),
    [sym_new_declarator] = STATE(1951),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(335),
  },
  [1382] = {
    [sym_argument_list] = STATE(1952),
    [sym_initializer_list] = STATE(1952),
    [sym_template_argument_list] = STATE(146),
    [sym_new_declarator] = STATE(1953),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
  },
  [1383] = {
    [anon_sym_LPAREN] = ACTIONS(4364),
    [anon_sym_COMMA] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(4364),
    [anon_sym_RBRACK] = ACTIONS(4364),
    [anon_sym_EQ] = ACTIONS(4366),
    [anon_sym_COLON] = ACTIONS(4364),
    [anon_sym_QMARK] = ACTIONS(4364),
    [anon_sym_STAR_EQ] = ACTIONS(4364),
    [anon_sym_SLASH_EQ] = ACTIONS(4364),
    [anon_sym_PERCENT_EQ] = ACTIONS(4364),
    [anon_sym_PLUS_EQ] = ACTIONS(4364),
    [anon_sym_DASH_EQ] = ACTIONS(4364),
    [anon_sym_LT_LT_EQ] = ACTIONS(4364),
    [anon_sym_GT_GT_EQ] = ACTIONS(4364),
    [anon_sym_AMP_EQ] = ACTIONS(4364),
    [anon_sym_CARET_EQ] = ACTIONS(4364),
    [anon_sym_PIPE_EQ] = ACTIONS(4364),
    [anon_sym_AMP] = ACTIONS(4366),
    [anon_sym_PIPE_PIPE] = ACTIONS(4364),
    [anon_sym_AMP_AMP] = ACTIONS(4364),
    [anon_sym_PIPE] = ACTIONS(4366),
    [anon_sym_CARET] = ACTIONS(4366),
    [anon_sym_EQ_EQ] = ACTIONS(4364),
    [anon_sym_BANG_EQ] = ACTIONS(4364),
    [anon_sym_LT] = ACTIONS(4366),
    [anon_sym_GT] = ACTIONS(4366),
    [anon_sym_LT_EQ] = ACTIONS(4364),
    [anon_sym_GT_EQ] = ACTIONS(4364),
    [anon_sym_LT_LT] = ACTIONS(4366),
    [anon_sym_GT_GT] = ACTIONS(4366),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_SLASH] = ACTIONS(4366),
    [anon_sym_PERCENT] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4364),
    [anon_sym_PLUS_PLUS] = ACTIONS(4364),
    [anon_sym_DOT] = ACTIONS(4364),
    [anon_sym_DASH_GT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(49),
  },
  [1384] = {
    [sym_argument_list] = STATE(1952),
    [sym_initializer_list] = STATE(1952),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
  },
  [1385] = {
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(4368),
    [anon_sym_COLON] = ACTIONS(444),
    [anon_sym_QMARK] = ACTIONS(444),
    [anon_sym_STAR_EQ] = ACTIONS(444),
    [anon_sym_SLASH_EQ] = ACTIONS(444),
    [anon_sym_PERCENT_EQ] = ACTIONS(444),
    [anon_sym_PLUS_EQ] = ACTIONS(444),
    [anon_sym_DASH_EQ] = ACTIONS(444),
    [anon_sym_LT_LT_EQ] = ACTIONS(444),
    [anon_sym_GT_GT_EQ] = ACTIONS(444),
    [anon_sym_AMP_EQ] = ACTIONS(444),
    [anon_sym_CARET_EQ] = ACTIONS(444),
    [anon_sym_PIPE_EQ] = ACTIONS(444),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_PIPE_PIPE] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(4368),
    [anon_sym_CARET] = ACTIONS(4368),
    [anon_sym_EQ_EQ] = ACTIONS(444),
    [anon_sym_BANG_EQ] = ACTIONS(444),
    [anon_sym_LT] = ACTIONS(4368),
    [anon_sym_GT] = ACTIONS(4368),
    [anon_sym_LT_EQ] = ACTIONS(444),
    [anon_sym_GT_EQ] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(4368),
    [anon_sym_GT_GT] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4368),
    [anon_sym_SLASH] = ACTIONS(4368),
    [anon_sym_PERCENT] = ACTIONS(4368),
    [anon_sym_DASH_DASH] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(444),
    [anon_sym_DOT] = ACTIONS(444),
    [anon_sym_DASH_GT] = ACTIONS(444),
    [sym_comment] = ACTIONS(49),
  },
  [1386] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4370),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1387] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4372),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1388] = {
    [sym__expression] = STATE(1955),
    [sym_conditional_expression] = STATE(1955),
    [sym_assignment_expression] = STATE(1955),
    [sym_pointer_expression] = STATE(1955),
    [sym_logical_expression] = STATE(1955),
    [sym_bitwise_expression] = STATE(1955),
    [sym_equality_expression] = STATE(1955),
    [sym_relational_expression] = STATE(1955),
    [sym_shift_expression] = STATE(1955),
    [sym_math_expression] = STATE(1955),
    [sym_cast_expression] = STATE(1955),
    [sym_sizeof_expression] = STATE(1955),
    [sym_subscript_expression] = STATE(1955),
    [sym_call_expression] = STATE(1955),
    [sym_field_expression] = STATE(1955),
    [sym_compound_literal_expression] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1955),
    [sym_concatenated_string] = STATE(1955),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1955),
    [sym_new_expression] = STATE(1955),
    [sym_delete_expression] = STATE(1955),
    [sym_lambda_expression] = STATE(1955),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4376),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(4376),
    [sym_char_literal] = ACTIONS(4376),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(4378),
    [sym_false] = ACTIONS(4378),
    [sym_null] = ACTIONS(4378),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(4378),
  },
  [1389] = {
    [anon_sym_LPAREN] = ACTIONS(4380),
    [anon_sym_COMMA] = ACTIONS(4380),
    [anon_sym_RPAREN] = ACTIONS(4380),
    [anon_sym_SEMI] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_EQ] = ACTIONS(4380),
    [anon_sym_COLON] = ACTIONS(4380),
    [anon_sym_GT] = ACTIONS(4380),
    [sym_comment] = ACTIONS(49),
  },
  [1390] = {
    [sym_storage_class_specifier] = STATE(1390),
    [sym_type_qualifier] = STATE(1390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1390),
    [sym_raw_string_literal] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(4382),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_RBRACK] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(4382),
    [anon_sym_register] = ACTIONS(4382),
    [anon_sym_inline] = ACTIONS(4382),
    [anon_sym_const] = ACTIONS(4385),
    [anon_sym_restrict] = ACTIONS(4385),
    [anon_sym_volatile] = ACTIONS(4385),
    [anon_sym__Atomic] = ACTIONS(4385),
    [anon_sym_mutable] = ACTIONS(4385),
    [anon_sym_explicit] = ACTIONS(4385),
    [anon_sym_constexpr] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_sizeof] = ACTIONS(838),
    [sym_number_literal] = ACTIONS(830),
    [sym_char_literal] = ACTIONS(830),
    [sym_string_literal] = ACTIONS(830),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(838),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_COLON_COLON] = ACTIONS(830),
    [anon_sym_delete] = ACTIONS(838),
    [sym_nullptr] = ACTIONS(838),
  },
  [1391] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_RPAREN] = ACTIONS(4388),
    [anon_sym_SEMI] = ACTIONS(4388),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(4390),
    [anon_sym_PERCENT] = ACTIONS(4390),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1392] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4392),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1393] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4394),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1394] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(4396),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1395] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1396] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1397] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1398] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1399] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1400] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1401] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1402] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4414),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1403] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1404] = {
    [sym_template_argument_list] = STATE(1116),
    [anon_sym_LPAREN] = ACTIONS(4418),
    [anon_sym_COMMA] = ACTIONS(4418),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_RBRACK] = ACTIONS(4418),
    [anon_sym_EQ] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_STAR_EQ] = ACTIONS(4418),
    [anon_sym_SLASH_EQ] = ACTIONS(4418),
    [anon_sym_PERCENT_EQ] = ACTIONS(4418),
    [anon_sym_PLUS_EQ] = ACTIONS(4418),
    [anon_sym_DASH_EQ] = ACTIONS(4418),
    [anon_sym_LT_LT_EQ] = ACTIONS(4418),
    [anon_sym_GT_GT_EQ] = ACTIONS(4418),
    [anon_sym_AMP_EQ] = ACTIONS(4418),
    [anon_sym_CARET_EQ] = ACTIONS(4418),
    [anon_sym_PIPE_EQ] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_PIPE] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4418),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4418),
    [anon_sym_GT_EQ] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_DASH_GT] = ACTIONS(4418),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2142),
  },
  [1405] = {
    [anon_sym_LPAREN] = ACTIONS(4425),
    [anon_sym_COMMA] = ACTIONS(4425),
    [anon_sym_RPAREN] = ACTIONS(4425),
    [anon_sym_SEMI] = ACTIONS(4425),
    [anon_sym_RBRACE] = ACTIONS(4425),
    [anon_sym_STAR] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(4425),
    [anon_sym_RBRACK] = ACTIONS(4425),
    [anon_sym_EQ] = ACTIONS(4427),
    [anon_sym_COLON] = ACTIONS(4425),
    [anon_sym_QMARK] = ACTIONS(4425),
    [anon_sym_STAR_EQ] = ACTIONS(4425),
    [anon_sym_SLASH_EQ] = ACTIONS(4425),
    [anon_sym_PERCENT_EQ] = ACTIONS(4425),
    [anon_sym_PLUS_EQ] = ACTIONS(4425),
    [anon_sym_DASH_EQ] = ACTIONS(4425),
    [anon_sym_LT_LT_EQ] = ACTIONS(4425),
    [anon_sym_GT_GT_EQ] = ACTIONS(4425),
    [anon_sym_AMP_EQ] = ACTIONS(4425),
    [anon_sym_CARET_EQ] = ACTIONS(4425),
    [anon_sym_PIPE_EQ] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4427),
    [anon_sym_PIPE_PIPE] = ACTIONS(4425),
    [anon_sym_AMP_AMP] = ACTIONS(4425),
    [anon_sym_PIPE] = ACTIONS(4427),
    [anon_sym_CARET] = ACTIONS(4427),
    [anon_sym_EQ_EQ] = ACTIONS(4425),
    [anon_sym_BANG_EQ] = ACTIONS(4425),
    [anon_sym_LT] = ACTIONS(4427),
    [anon_sym_GT] = ACTIONS(4427),
    [anon_sym_LT_EQ] = ACTIONS(4425),
    [anon_sym_GT_EQ] = ACTIONS(4425),
    [anon_sym_LT_LT] = ACTIONS(4427),
    [anon_sym_GT_GT] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4427),
    [anon_sym_DASH] = ACTIONS(4427),
    [anon_sym_SLASH] = ACTIONS(4427),
    [anon_sym_PERCENT] = ACTIONS(4427),
    [anon_sym_DASH_DASH] = ACTIONS(4425),
    [anon_sym_PLUS_PLUS] = ACTIONS(4425),
    [anon_sym_DOT] = ACTIONS(4425),
    [anon_sym_DASH_GT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(49),
  },
  [1406] = {
    [sym_template_argument_list] = STATE(1127),
    [anon_sym_LT] = ACTIONS(4429),
    [sym_comment] = ACTIONS(49),
  },
  [1407] = {
    [sym_raw_string_literal] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_RBRACK] = ACTIONS(1856),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(4431),
    [anon_sym_DASH] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_sizeof] = ACTIONS(1861),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1859),
    [sym_char_literal] = ACTIONS(1859),
    [sym_string_literal] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [anon_sym_delete] = ACTIONS(1861),
    [sym_nullptr] = ACTIONS(1861),
  },
  [1408] = {
    [sym_parameter_list] = STATE(1958),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1409] = {
    [sym_type_qualifier] = STATE(1960),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1960),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4436),
  },
  [1410] = {
    [sym_type_qualifier] = STATE(1961),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1961),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2900),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4438),
  },
  [1411] = {
    [anon_sym_LPAREN] = ACTIONS(4440),
    [anon_sym_COMMA] = ACTIONS(4440),
    [anon_sym_RPAREN] = ACTIONS(4440),
    [anon_sym_SEMI] = ACTIONS(4440),
    [anon_sym_RBRACE] = ACTIONS(4440),
    [anon_sym_STAR] = ACTIONS(4442),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_RBRACK] = ACTIONS(4440),
    [anon_sym_EQ] = ACTIONS(4442),
    [anon_sym_COLON] = ACTIONS(4440),
    [anon_sym_QMARK] = ACTIONS(4440),
    [anon_sym_STAR_EQ] = ACTIONS(4440),
    [anon_sym_SLASH_EQ] = ACTIONS(4440),
    [anon_sym_PERCENT_EQ] = ACTIONS(4440),
    [anon_sym_PLUS_EQ] = ACTIONS(4440),
    [anon_sym_DASH_EQ] = ACTIONS(4440),
    [anon_sym_LT_LT_EQ] = ACTIONS(4440),
    [anon_sym_GT_GT_EQ] = ACTIONS(4440),
    [anon_sym_AMP_EQ] = ACTIONS(4440),
    [anon_sym_CARET_EQ] = ACTIONS(4440),
    [anon_sym_PIPE_EQ] = ACTIONS(4440),
    [anon_sym_AMP] = ACTIONS(4442),
    [anon_sym_PIPE_PIPE] = ACTIONS(4440),
    [anon_sym_AMP_AMP] = ACTIONS(4440),
    [anon_sym_PIPE] = ACTIONS(4442),
    [anon_sym_CARET] = ACTIONS(4442),
    [anon_sym_EQ_EQ] = ACTIONS(4440),
    [anon_sym_BANG_EQ] = ACTIONS(4440),
    [anon_sym_LT] = ACTIONS(4442),
    [anon_sym_GT] = ACTIONS(4442),
    [anon_sym_LT_EQ] = ACTIONS(4440),
    [anon_sym_GT_EQ] = ACTIONS(4440),
    [anon_sym_LT_LT] = ACTIONS(4442),
    [anon_sym_GT_GT] = ACTIONS(4442),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_DASH] = ACTIONS(4442),
    [anon_sym_SLASH] = ACTIONS(4442),
    [anon_sym_PERCENT] = ACTIONS(4442),
    [anon_sym_DASH_DASH] = ACTIONS(4440),
    [anon_sym_PLUS_PLUS] = ACTIONS(4440),
    [anon_sym_DOT] = ACTIONS(4440),
    [anon_sym_DASH_GT] = ACTIONS(4440),
    [sym_comment] = ACTIONS(49),
  },
  [1412] = {
    [sym__type_specifier] = STATE(1967),
    [sym_sized_type_specifier] = STATE(1967),
    [sym_enum_specifier] = STATE(1967),
    [sym_struct_specifier] = STATE(1967),
    [sym_union_specifier] = STATE(1967),
    [sym_macro_type_specifier] = STATE(1967),
    [sym_class_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(1967),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1968),
    [anon_sym_unsigned] = ACTIONS(4444),
    [anon_sym_long] = ACTIONS(4444),
    [anon_sym_short] = ACTIONS(4444),
    [sym_primitive_type] = ACTIONS(4446),
    [anon_sym_enum] = ACTIONS(4448),
    [anon_sym_struct] = ACTIONS(4450),
    [anon_sym_union] = ACTIONS(4452),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4454),
    [sym_auto] = ACTIONS(4446),
    [anon_sym_typename] = ACTIONS(4456),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1413] = {
    [sym_type_qualifier] = STATE(1969),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1969),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2900),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4458),
  },
  [1414] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_EQ] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_STAR_EQ] = ACTIONS(1157),
    [anon_sym_SLASH_EQ] = ACTIONS(1157),
    [anon_sym_PERCENT_EQ] = ACTIONS(1157),
    [anon_sym_PLUS_EQ] = ACTIONS(1157),
    [anon_sym_DASH_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_GT_EQ] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(1157),
    [anon_sym_CARET_EQ] = ACTIONS(1157),
    [anon_sym_PIPE_EQ] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1159),
    [anon_sym_GT] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1159),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(1159),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [sym_operator_name] = ACTIONS(1157),
  },
  [1415] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1971),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(4460),
    [sym_comment] = ACTIONS(49),
  },
  [1416] = {
    [sym_raw_string_literal] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_sizeof] = ACTIONS(1159),
    [sym_number_literal] = ACTIONS(1157),
    [sym_char_literal] = ACTIONS(1157),
    [sym_string_literal] = ACTIONS(1157),
    [sym_true] = ACTIONS(1159),
    [sym_false] = ACTIONS(1159),
    [sym_null] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1159),
    [sym_nullptr] = ACTIONS(1159),
  },
  [1417] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1973),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(4462),
    [sym_comment] = ACTIONS(49),
  },
  [1418] = {
    [sym_storage_class_specifier] = STATE(1390),
    [sym_type_qualifier] = STATE(1390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1390),
    [sym_raw_string_literal] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_register] = ACTIONS(1576),
    [anon_sym_inline] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_restrict] = ACTIONS(1578),
    [anon_sym_volatile] = ACTIONS(1578),
    [anon_sym__Atomic] = ACTIONS(1578),
    [anon_sym_mutable] = ACTIONS(1578),
    [anon_sym_explicit] = ACTIONS(1578),
    [anon_sym_constexpr] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_PLUS] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1869),
    [anon_sym_PLUS_PLUS] = ACTIONS(1869),
    [anon_sym_sizeof] = ACTIONS(1871),
    [sym_number_literal] = ACTIONS(1869),
    [sym_char_literal] = ACTIONS(1869),
    [sym_string_literal] = ACTIONS(1869),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [anon_sym_delete] = ACTIONS(1871),
    [sym_nullptr] = ACTIONS(1871),
  },
  [1419] = {
    [sym_enumerator] = STATE(1976),
    [anon_sym_COMMA] = ACTIONS(4464),
    [anon_sym_RBRACE] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1420] = {
    [sym_enumerator_list] = STATE(1977),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_COMMA] = ACTIONS(366),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LBRACE] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_EQ] = ACTIONS(366),
    [anon_sym_const] = ACTIONS(368),
    [anon_sym_restrict] = ACTIONS(366),
    [anon_sym_volatile] = ACTIONS(366),
    [anon_sym__Atomic] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(366),
    [anon_sym_explicit] = ACTIONS(366),
    [anon_sym_constexpr] = ACTIONS(366),
    [anon_sym_COLON] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(366),
    [anon_sym_DASH_GT] = ACTIONS(366),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(366),
  },
  [1421] = {
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_COMMA] = ACTIONS(370),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_const] = ACTIONS(372),
    [anon_sym_restrict] = ACTIONS(370),
    [anon_sym_volatile] = ACTIONS(370),
    [anon_sym__Atomic] = ACTIONS(370),
    [anon_sym_mutable] = ACTIONS(370),
    [anon_sym_explicit] = ACTIONS(370),
    [anon_sym_constexpr] = ACTIONS(370),
    [anon_sym_COLON] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_DASH_GT] = ACTIONS(370),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(370),
  },
  [1422] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(1979),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1979),
    [sym_field_declaration] = STATE(1979),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1979),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1979),
    [sym_access_specifier] = STATE(1979),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1979),
    [sym_alias_declaration] = STATE(1979),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1979),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1423] = {
    [sym_template_argument_list] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_COMMA] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(414),
    [anon_sym_EQ] = ACTIONS(414),
    [anon_sym_const] = ACTIONS(416),
    [anon_sym_restrict] = ACTIONS(414),
    [anon_sym_volatile] = ACTIONS(414),
    [anon_sym__Atomic] = ACTIONS(414),
    [anon_sym_mutable] = ACTIONS(414),
    [anon_sym_explicit] = ACTIONS(414),
    [anon_sym_constexpr] = ACTIONS(414),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_DASH_GT] = ACTIONS(414),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(414),
    [sym_noexcept] = ACTIONS(414),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
  },
  [1424] = {
    [sym_field_declaration_list] = STATE(1980),
    [sym_base_class_clause] = STATE(1981),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1425] = {
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_EQ] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym__Atomic] = ACTIONS(426),
    [anon_sym_mutable] = ACTIONS(426),
    [anon_sym_explicit] = ACTIONS(426),
    [anon_sym_constexpr] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(426),
  },
  [1426] = {
    [sym_field_declaration_list] = STATE(1980),
    [sym_base_class_clause] = STATE(1981),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_EQ] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym__Atomic] = ACTIONS(426),
    [anon_sym_mutable] = ACTIONS(426),
    [anon_sym_explicit] = ACTIONS(426),
    [anon_sym_constexpr] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4470),
    [sym_noexcept] = ACTIONS(426),
  },
  [1427] = {
    [sym_field_declaration_list] = STATE(1980),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1428] = {
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_EQ] = ACTIONS(432),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(432),
    [anon_sym_volatile] = ACTIONS(432),
    [anon_sym__Atomic] = ACTIONS(432),
    [anon_sym_mutable] = ACTIONS(432),
    [anon_sym_explicit] = ACTIONS(432),
    [anon_sym_constexpr] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(432),
    [anon_sym_GT] = ACTIONS(432),
    [anon_sym_DASH_GT] = ACTIONS(432),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(432),
    [sym_noexcept] = ACTIONS(432),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
  },
  [1429] = {
    [sym_template_argument_list] = STATE(1448),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(432),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_EQ] = ACTIONS(432),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_restrict] = ACTIONS(432),
    [anon_sym_volatile] = ACTIONS(432),
    [anon_sym__Atomic] = ACTIONS(432),
    [anon_sym_mutable] = ACTIONS(432),
    [anon_sym_explicit] = ACTIONS(432),
    [anon_sym_constexpr] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(432),
    [anon_sym_AMP] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(432),
    [anon_sym_DASH_GT] = ACTIONS(432),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(432),
    [sym_noexcept] = ACTIONS(432),
  },
  [1430] = {
    [sym_field_declaration_list] = STATE(1983),
    [sym_base_class_clause] = STATE(1984),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1431] = {
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym__Atomic] = ACTIONS(438),
    [anon_sym_mutable] = ACTIONS(438),
    [anon_sym_explicit] = ACTIONS(438),
    [anon_sym_constexpr] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_DASH_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(438),
  },
  [1432] = {
    [sym_field_declaration_list] = STATE(1983),
    [sym_base_class_clause] = STATE(1984),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym__Atomic] = ACTIONS(438),
    [anon_sym_mutable] = ACTIONS(438),
    [anon_sym_explicit] = ACTIONS(438),
    [anon_sym_constexpr] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_DASH_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4472),
    [sym_noexcept] = ACTIONS(438),
  },
  [1433] = {
    [sym_field_declaration_list] = STATE(1983),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1434] = {
    [sym_type_qualifier] = STATE(295),
    [sym__type_specifier] = STATE(293),
    [sym_sized_type_specifier] = STATE(293),
    [sym_enum_specifier] = STATE(293),
    [sym_struct_specifier] = STATE(293),
    [sym_union_specifier] = STATE(293),
    [sym_type_descriptor] = STATE(1987),
    [sym_parenthesized_expression] = STATE(1987),
    [sym_macro_type_specifier] = STATE(293),
    [sym_class_specifier] = STATE(293),
    [sym_dependent_type] = STATE(293),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(295),
    [aux_sym_sized_type_specifier_repeat1] = STATE(296),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [sym_primitive_type] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(4474),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(450),
    [anon_sym_typename] = ACTIONS(462),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1435] = {
    [sym_identifier] = ACTIONS(4476),
    [sym_comment] = ACTIONS(49),
  },
  [1436] = {
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(471),
    [anon_sym_volatile] = ACTIONS(471),
    [anon_sym__Atomic] = ACTIONS(471),
    [anon_sym_mutable] = ACTIONS(471),
    [anon_sym_explicit] = ACTIONS(471),
    [anon_sym_constexpr] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_DASH_GT] = ACTIONS(471),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(471),
    [sym_noexcept] = ACTIONS(471),
    [anon_sym_COLON_COLON] = ACTIONS(471),
  },
  [1437] = {
    [sym_field_declaration_list] = STATE(1989),
    [sym_base_class_clause] = STATE(1990),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1438] = {
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_mutable] = ACTIONS(475),
    [anon_sym_explicit] = ACTIONS(475),
    [anon_sym_constexpr] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(475),
  },
  [1439] = {
    [sym_field_declaration_list] = STATE(1989),
    [sym_base_class_clause] = STATE(1990),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_mutable] = ACTIONS(475),
    [anon_sym_explicit] = ACTIONS(475),
    [anon_sym_constexpr] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4478),
    [sym_noexcept] = ACTIONS(475),
  },
  [1440] = {
    [sym_field_declaration_list] = STATE(1989),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1441] = {
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_RPAREN] = ACTIONS(485),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(485),
    [anon_sym_const] = ACTIONS(487),
    [anon_sym_restrict] = ACTIONS(485),
    [anon_sym_volatile] = ACTIONS(485),
    [anon_sym__Atomic] = ACTIONS(485),
    [anon_sym_mutable] = ACTIONS(485),
    [anon_sym_explicit] = ACTIONS(485),
    [anon_sym_constexpr] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_AMP] = ACTIONS(487),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(485),
    [anon_sym_DASH_GT] = ACTIONS(485),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(485),
  },
  [1442] = {
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_EQ] = ACTIONS(544),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(544),
    [anon_sym_volatile] = ACTIONS(544),
    [anon_sym__Atomic] = ACTIONS(544),
    [anon_sym_mutable] = ACTIONS(544),
    [anon_sym_explicit] = ACTIONS(544),
    [anon_sym_constexpr] = ACTIONS(544),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_DASH_GT] = ACTIONS(544),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(544),
    [sym_noexcept] = ACTIONS(544),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1443] = {
    [sym__abstract_declarator] = STATE(1992),
    [sym_abstract_pointer_declarator] = STATE(1992),
    [sym_abstract_function_declarator] = STATE(1992),
    [sym_abstract_array_declarator] = STATE(1992),
    [sym_parameter_list] = STATE(1446),
    [sym_abstract_reference_declarator] = STATE(1992),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [1444] = {
    [sym__abstract_declarator] = STATE(1993),
    [sym_abstract_pointer_declarator] = STATE(1993),
    [sym_abstract_function_declarator] = STATE(1993),
    [sym_abstract_array_declarator] = STATE(1993),
    [sym_parameter_list] = STATE(1446),
    [sym_abstract_reference_declarator] = STATE(1993),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [1445] = {
    [sym_parameter_list] = STATE(1994),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [1446] = {
    [sym_type_qualifier] = STATE(1995),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1995),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [1447] = {
    [sym_identifier] = ACTIONS(4490),
    [sym_comment] = ACTIONS(49),
  },
  [1448] = {
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(740),
    [anon_sym_volatile] = ACTIONS(740),
    [anon_sym__Atomic] = ACTIONS(740),
    [anon_sym_mutable] = ACTIONS(740),
    [anon_sym_explicit] = ACTIONS(740),
    [anon_sym_constexpr] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_GT] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(740),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(740),
    [sym_noexcept] = ACTIONS(740),
    [anon_sym_COLON_COLON] = ACTIONS(740),
  },
  [1449] = {
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(842),
    [anon_sym_restrict] = ACTIONS(840),
    [anon_sym_volatile] = ACTIONS(840),
    [anon_sym__Atomic] = ACTIONS(840),
    [anon_sym_mutable] = ACTIONS(840),
    [anon_sym_explicit] = ACTIONS(840),
    [anon_sym_constexpr] = ACTIONS(840),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_DASH_GT] = ACTIONS(840),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(840),
  },
  [1450] = {
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(844),
    [anon_sym_EQ] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_restrict] = ACTIONS(844),
    [anon_sym_volatile] = ACTIONS(844),
    [anon_sym__Atomic] = ACTIONS(844),
    [anon_sym_mutable] = ACTIONS(844),
    [anon_sym_explicit] = ACTIONS(844),
    [anon_sym_constexpr] = ACTIONS(844),
    [anon_sym_COLON] = ACTIONS(844),
    [anon_sym_AMP] = ACTIONS(846),
    [anon_sym_AMP_AMP] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_DASH_GT] = ACTIONS(844),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(844),
  },
  [1451] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(4492),
    [anon_sym_long] = ACTIONS(4492),
    [anon_sym_short] = ACTIONS(4492),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [1452] = {
    [sym_preproc_arg] = ACTIONS(4495),
    [sym_comment] = ACTIONS(83),
  },
  [1453] = {
    [sym_raw_string_literal] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_sizeof] = ACTIONS(859),
    [sym_number_literal] = ACTIONS(857),
    [sym_char_literal] = ACTIONS(857),
    [sym_string_literal] = ACTIONS(857),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [anon_sym_delete] = ACTIONS(859),
    [sym_nullptr] = ACTIONS(859),
  },
  [1454] = {
    [anon_sym_LF] = ACTIONS(4497),
    [sym_preproc_arg] = ACTIONS(4499),
    [sym_comment] = ACTIONS(83),
  },
  [1455] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1456] = {
    [sym_string_literal] = ACTIONS(4501),
    [sym_system_lib_string] = ACTIONS(4501),
    [sym_comment] = ACTIONS(49),
  },
  [1457] = {
    [sym_identifier] = ACTIONS(4503),
    [sym_comment] = ACTIONS(49),
  },
  [1458] = {
    [sym_preproc_arg] = ACTIONS(4505),
    [sym_comment] = ACTIONS(83),
  },
  [1459] = {
    [sym_raw_string_literal] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4509),
    [sym_preproc_directive] = ACTIONS(4509),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_typedef] = ACTIONS(4509),
    [anon_sym_extern] = ACTIONS(4509),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_RBRACE] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(4507),
    [anon_sym_static] = ACTIONS(4509),
    [anon_sym_register] = ACTIONS(4509),
    [anon_sym_inline] = ACTIONS(4509),
    [anon_sym_const] = ACTIONS(4509),
    [anon_sym_restrict] = ACTIONS(4509),
    [anon_sym_volatile] = ACTIONS(4509),
    [anon_sym__Atomic] = ACTIONS(4509),
    [anon_sym_mutable] = ACTIONS(4509),
    [anon_sym_explicit] = ACTIONS(4509),
    [anon_sym_constexpr] = ACTIONS(4509),
    [anon_sym_unsigned] = ACTIONS(4509),
    [anon_sym_long] = ACTIONS(4509),
    [anon_sym_short] = ACTIONS(4509),
    [sym_primitive_type] = ACTIONS(4509),
    [anon_sym_enum] = ACTIONS(4509),
    [anon_sym_struct] = ACTIONS(4509),
    [anon_sym_union] = ACTIONS(4509),
    [anon_sym_if] = ACTIONS(4509),
    [anon_sym_switch] = ACTIONS(4509),
    [anon_sym_case] = ACTIONS(4509),
    [anon_sym_default] = ACTIONS(4509),
    [anon_sym_while] = ACTIONS(4509),
    [anon_sym_do] = ACTIONS(4509),
    [anon_sym_for] = ACTIONS(4509),
    [anon_sym_return] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4509),
    [anon_sym_continue] = ACTIONS(4509),
    [anon_sym_goto] = ACTIONS(4509),
    [anon_sym_AMP] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_PLUS] = ACTIONS(4509),
    [anon_sym_DASH] = ACTIONS(4509),
    [anon_sym_DASH_DASH] = ACTIONS(4507),
    [anon_sym_PLUS_PLUS] = ACTIONS(4507),
    [anon_sym_sizeof] = ACTIONS(4509),
    [sym_number_literal] = ACTIONS(4507),
    [sym_char_literal] = ACTIONS(4507),
    [sym_string_literal] = ACTIONS(4507),
    [sym_true] = ACTIONS(4509),
    [sym_false] = ACTIONS(4509),
    [sym_null] = ACTIONS(4509),
    [sym_identifier] = ACTIONS(4509),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4509),
    [sym_auto] = ACTIONS(4509),
    [anon_sym_typename] = ACTIONS(4509),
    [anon_sym_new] = ACTIONS(4509),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_delete] = ACTIONS(4509),
    [sym_nullptr] = ACTIONS(4509),
  },
  [1460] = {
    [sym_identifier] = ACTIONS(4511),
    [sym_comment] = ACTIONS(49),
  },
  [1461] = {
    [sym_identifier] = ACTIONS(4513),
    [sym_comment] = ACTIONS(49),
  },
  [1462] = {
    [sym_preproc_include] = STATE(2031),
    [sym_preproc_def] = STATE(2031),
    [sym_preproc_function_def] = STATE(2031),
    [sym_preproc_call] = STATE(2031),
    [sym_preproc_if_in_compound_statement] = STATE(2026),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2027),
    [sym_declaration] = STATE(2031),
    [sym_type_definition] = STATE(2031),
    [sym__declaration_specifiers] = STATE(2028),
    [sym_compound_statement] = STATE(2031),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2031),
    [sym_expression_statement] = STATE(2031),
    [sym_if_statement] = STATE(2031),
    [sym_switch_statement] = STATE(2031),
    [sym_case_statement] = STATE(2031),
    [sym_while_statement] = STATE(2031),
    [sym_do_statement] = STATE(2031),
    [sym_for_statement] = STATE(2031),
    [sym_return_statement] = STATE(2031),
    [sym_break_statement] = STATE(2031),
    [sym_continue_statement] = STATE(2031),
    [sym_goto_statement] = STATE(2031),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym__empty_declaration] = STATE(2031),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2031),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2031),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2031),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4517),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4527),
    [sym_preproc_directive] = ACTIONS(4529),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_typedef] = ACTIONS(4533),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(4561),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [1463] = {
    [sym_preproc_arg] = ACTIONS(4563),
    [sym_comment] = ACTIONS(83),
  },
  [1464] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(4565),
    [anon_sym_LF] = ACTIONS(4567),
    [sym_comment] = ACTIONS(83),
  },
  [1465] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [1466] = {
    [sym_type_qualifier] = STATE(2036),
    [sym__type_specifier] = STATE(2035),
    [sym_sized_type_specifier] = STATE(2035),
    [sym_enum_specifier] = STATE(2035),
    [sym_struct_specifier] = STATE(2035),
    [sym_union_specifier] = STATE(2035),
    [sym_macro_type_specifier] = STATE(2035),
    [sym_class_specifier] = STATE(2035),
    [sym_dependent_type] = STATE(2035),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(4569),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(4569),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1467] = {
    [sym_preproc_include] = STATE(2038),
    [sym_preproc_def] = STATE(2038),
    [sym_preproc_function_def] = STATE(2038),
    [sym_preproc_call] = STATE(2038),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(2038),
    [sym_type_definition] = STATE(2038),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(2038),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2038),
    [sym_expression_statement] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_switch_statement] = STATE(2038),
    [sym_case_statement] = STATE(2038),
    [sym_while_statement] = STATE(2038),
    [sym_do_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_return_statement] = STATE(2038),
    [sym_break_statement] = STATE(2038),
    [sym_continue_statement] = STATE(2038),
    [sym_goto_statement] = STATE(2038),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(2038),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2038),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2038),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2038),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1468] = {
    [anon_sym_LPAREN] = ACTIONS(4573),
    [anon_sym_constexpr] = ACTIONS(4575),
    [sym_comment] = ACTIONS(49),
  },
  [1469] = {
    [anon_sym_LPAREN] = ACTIONS(4577),
    [sym_comment] = ACTIONS(49),
  },
  [1470] = {
    [sym__expression] = STATE(2042),
    [sym_conditional_expression] = STATE(2042),
    [sym_assignment_expression] = STATE(2042),
    [sym_pointer_expression] = STATE(2042),
    [sym_logical_expression] = STATE(2042),
    [sym_bitwise_expression] = STATE(2042),
    [sym_equality_expression] = STATE(2042),
    [sym_relational_expression] = STATE(2042),
    [sym_shift_expression] = STATE(2042),
    [sym_math_expression] = STATE(2042),
    [sym_cast_expression] = STATE(2042),
    [sym_sizeof_expression] = STATE(2042),
    [sym_subscript_expression] = STATE(2042),
    [sym_call_expression] = STATE(2042),
    [sym_field_expression] = STATE(2042),
    [sym_compound_literal_expression] = STATE(2042),
    [sym_parenthesized_expression] = STATE(2042),
    [sym_concatenated_string] = STATE(2042),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2042),
    [sym_new_expression] = STATE(2042),
    [sym_delete_expression] = STATE(2042),
    [sym_lambda_expression] = STATE(2042),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4579),
    [sym_char_literal] = ACTIONS(4579),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4581),
    [sym_false] = ACTIONS(4581),
    [sym_null] = ACTIONS(4581),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4581),
  },
  [1471] = {
    [anon_sym_COLON] = ACTIONS(4583),
    [sym_comment] = ACTIONS(49),
  },
  [1472] = {
    [anon_sym_LPAREN] = ACTIONS(4585),
    [sym_comment] = ACTIONS(49),
  },
  [1473] = {
    [sym_compound_statement] = STATE(2045),
    [sym_labeled_statement] = STATE(2045),
    [sym_expression_statement] = STATE(2045),
    [sym_if_statement] = STATE(2045),
    [sym_switch_statement] = STATE(2045),
    [sym_case_statement] = STATE(2045),
    [sym_while_statement] = STATE(2045),
    [sym_do_statement] = STATE(2045),
    [sym_for_statement] = STATE(2045),
    [sym_return_statement] = STATE(2045),
    [sym_break_statement] = STATE(2045),
    [sym_continue_statement] = STATE(2045),
    [sym_goto_statement] = STATE(2045),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2045),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [1474] = {
    [anon_sym_LPAREN] = ACTIONS(4587),
    [sym_comment] = ACTIONS(49),
  },
  [1475] = {
    [sym__expression] = STATE(2048),
    [sym_conditional_expression] = STATE(2048),
    [sym_assignment_expression] = STATE(2048),
    [sym_pointer_expression] = STATE(2048),
    [sym_logical_expression] = STATE(2048),
    [sym_bitwise_expression] = STATE(2048),
    [sym_equality_expression] = STATE(2048),
    [sym_relational_expression] = STATE(2048),
    [sym_shift_expression] = STATE(2048),
    [sym_math_expression] = STATE(2048),
    [sym_cast_expression] = STATE(2048),
    [sym_sizeof_expression] = STATE(2048),
    [sym_subscript_expression] = STATE(2048),
    [sym_call_expression] = STATE(2048),
    [sym_field_expression] = STATE(2048),
    [sym_compound_literal_expression] = STATE(2048),
    [sym_parenthesized_expression] = STATE(2048),
    [sym_initializer_list] = STATE(2049),
    [sym_concatenated_string] = STATE(2048),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2048),
    [sym_new_expression] = STATE(2048),
    [sym_delete_expression] = STATE(2048),
    [sym_lambda_expression] = STATE(2048),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4589),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(4591),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4589),
    [sym_char_literal] = ACTIONS(4589),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4593),
    [sym_false] = ACTIONS(4593),
    [sym_null] = ACTIONS(4593),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4593),
  },
  [1476] = {
    [anon_sym_SEMI] = ACTIONS(4595),
    [sym_comment] = ACTIONS(49),
  },
  [1477] = {
    [anon_sym_SEMI] = ACTIONS(4597),
    [sym_comment] = ACTIONS(49),
  },
  [1478] = {
    [sym_identifier] = ACTIONS(4599),
    [sym_comment] = ACTIONS(49),
  },
  [1479] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(4601),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
    [sym_operator_name] = ACTIONS(146),
  },
  [1480] = {
    [sym_raw_string_literal] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1788),
    [sym_preproc_directive] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1786),
    [anon_sym_typedef] = ACTIONS(1788),
    [anon_sym_extern] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1786),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_register] = ACTIONS(1788),
    [anon_sym_inline] = ACTIONS(1788),
    [anon_sym_const] = ACTIONS(1788),
    [anon_sym_restrict] = ACTIONS(1788),
    [anon_sym_volatile] = ACTIONS(1788),
    [anon_sym__Atomic] = ACTIONS(1788),
    [anon_sym_mutable] = ACTIONS(1788),
    [anon_sym_explicit] = ACTIONS(1788),
    [anon_sym_constexpr] = ACTIONS(1788),
    [anon_sym_unsigned] = ACTIONS(1788),
    [anon_sym_long] = ACTIONS(1788),
    [anon_sym_short] = ACTIONS(1788),
    [sym_primitive_type] = ACTIONS(1788),
    [anon_sym_enum] = ACTIONS(1788),
    [anon_sym_struct] = ACTIONS(1788),
    [anon_sym_union] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(1788),
    [anon_sym_case] = ACTIONS(1788),
    [anon_sym_default] = ACTIONS(1788),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_do] = ACTIONS(1788),
    [anon_sym_for] = ACTIONS(1788),
    [anon_sym_return] = ACTIONS(1788),
    [anon_sym_break] = ACTIONS(1788),
    [anon_sym_continue] = ACTIONS(1788),
    [anon_sym_goto] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_TILDE] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_sizeof] = ACTIONS(1788),
    [sym_number_literal] = ACTIONS(1786),
    [sym_char_literal] = ACTIONS(1786),
    [sym_string_literal] = ACTIONS(1786),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1788),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1788),
    [sym_auto] = ACTIONS(1788),
    [anon_sym_typename] = ACTIONS(1788),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_delete] = ACTIONS(1788),
    [sym_nullptr] = ACTIONS(1788),
  },
  [1481] = {
    [sym_raw_string_literal] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1792),
    [sym_preproc_directive] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1792),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_restrict] = ACTIONS(1792),
    [anon_sym_volatile] = ACTIONS(1792),
    [anon_sym__Atomic] = ACTIONS(1792),
    [anon_sym_mutable] = ACTIONS(1792),
    [anon_sym_explicit] = ACTIONS(1792),
    [anon_sym_constexpr] = ACTIONS(1792),
    [anon_sym_unsigned] = ACTIONS(1792),
    [anon_sym_long] = ACTIONS(1792),
    [anon_sym_short] = ACTIONS(1792),
    [sym_primitive_type] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(1792),
    [anon_sym_union] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_goto] = ACTIONS(1792),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1790),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1790),
    [anon_sym_sizeof] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1790),
    [sym_char_literal] = ACTIONS(1790),
    [sym_string_literal] = ACTIONS(1790),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(1792),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1792),
    [sym_auto] = ACTIONS(1792),
    [anon_sym_typename] = ACTIONS(1792),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_COLON_COLON] = ACTIONS(1790),
    [anon_sym_delete] = ACTIONS(1792),
    [sym_nullptr] = ACTIONS(1792),
  },
  [1482] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4603),
    [sym_comment] = ACTIONS(49),
  },
  [1483] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4605),
    [sym_comment] = ACTIONS(49),
  },
  [1484] = {
    [sym__declarator] = STATE(2057),
    [sym_pointer_declarator] = STATE(2057),
    [sym_function_declarator] = STATE(2057),
    [sym_array_declarator] = STATE(2057),
    [sym_init_declarator] = STATE(2058),
    [sym_reference_declarator] = STATE(2057),
    [sym_structured_binding_reference_declarator] = STATE(2059),
    [sym_structured_binding_declarator] = STATE(2060),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2057),
    [sym_destructor_name] = STATE(2057),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(4607),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4609),
  },
  [1485] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(4611),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1486] = {
    [anon_sym_SEMI] = ACTIONS(4611),
    [sym_comment] = ACTIONS(49),
  },
  [1487] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2063),
    [sym_preproc_elif_in_compound_statement] = STATE(2064),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [1488] = {
    [sym_raw_string_literal] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4617),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4617),
    [sym_preproc_directive] = ACTIONS(4617),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_typedef] = ACTIONS(4617),
    [anon_sym_extern] = ACTIONS(4617),
    [anon_sym_LBRACE] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_static] = ACTIONS(4617),
    [anon_sym_register] = ACTIONS(4617),
    [anon_sym_inline] = ACTIONS(4617),
    [anon_sym_const] = ACTIONS(4617),
    [anon_sym_restrict] = ACTIONS(4617),
    [anon_sym_volatile] = ACTIONS(4617),
    [anon_sym__Atomic] = ACTIONS(4617),
    [anon_sym_mutable] = ACTIONS(4617),
    [anon_sym_explicit] = ACTIONS(4617),
    [anon_sym_constexpr] = ACTIONS(4617),
    [anon_sym_unsigned] = ACTIONS(4617),
    [anon_sym_long] = ACTIONS(4617),
    [anon_sym_short] = ACTIONS(4617),
    [sym_primitive_type] = ACTIONS(4617),
    [anon_sym_enum] = ACTIONS(4617),
    [anon_sym_struct] = ACTIONS(4617),
    [anon_sym_union] = ACTIONS(4617),
    [anon_sym_if] = ACTIONS(4617),
    [anon_sym_switch] = ACTIONS(4617),
    [anon_sym_case] = ACTIONS(4617),
    [anon_sym_default] = ACTIONS(4617),
    [anon_sym_while] = ACTIONS(4617),
    [anon_sym_do] = ACTIONS(4617),
    [anon_sym_for] = ACTIONS(4617),
    [anon_sym_return] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4617),
    [anon_sym_continue] = ACTIONS(4617),
    [anon_sym_goto] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_BANG] = ACTIONS(4615),
    [anon_sym_TILDE] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_sizeof] = ACTIONS(4617),
    [sym_number_literal] = ACTIONS(4615),
    [sym_char_literal] = ACTIONS(4615),
    [sym_string_literal] = ACTIONS(4615),
    [sym_true] = ACTIONS(4617),
    [sym_false] = ACTIONS(4617),
    [sym_null] = ACTIONS(4617),
    [sym_identifier] = ACTIONS(4617),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4617),
    [sym_auto] = ACTIONS(4617),
    [anon_sym_typename] = ACTIONS(4617),
    [anon_sym_new] = ACTIONS(4617),
    [anon_sym_COLON_COLON] = ACTIONS(4615),
    [anon_sym_delete] = ACTIONS(4617),
    [sym_nullptr] = ACTIONS(4617),
  },
  [1489] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4619),
    [sym_comment] = ACTIONS(49),
  },
  [1490] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4621),
    [sym_comment] = ACTIONS(49),
  },
  [1491] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2069),
    [sym_preproc_elif_in_compound_statement] = STATE(2070),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [1492] = {
    [sym_raw_string_literal] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4627),
    [sym_preproc_directive] = ACTIONS(4627),
    [anon_sym_SEMI] = ACTIONS(4625),
    [anon_sym_typedef] = ACTIONS(4627),
    [anon_sym_extern] = ACTIONS(4627),
    [anon_sym_LBRACE] = ACTIONS(4625),
    [anon_sym_RBRACE] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4625),
    [anon_sym_static] = ACTIONS(4627),
    [anon_sym_register] = ACTIONS(4627),
    [anon_sym_inline] = ACTIONS(4627),
    [anon_sym_const] = ACTIONS(4627),
    [anon_sym_restrict] = ACTIONS(4627),
    [anon_sym_volatile] = ACTIONS(4627),
    [anon_sym__Atomic] = ACTIONS(4627),
    [anon_sym_mutable] = ACTIONS(4627),
    [anon_sym_explicit] = ACTIONS(4627),
    [anon_sym_constexpr] = ACTIONS(4627),
    [anon_sym_unsigned] = ACTIONS(4627),
    [anon_sym_long] = ACTIONS(4627),
    [anon_sym_short] = ACTIONS(4627),
    [sym_primitive_type] = ACTIONS(4627),
    [anon_sym_enum] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_union] = ACTIONS(4627),
    [anon_sym_if] = ACTIONS(4627),
    [anon_sym_switch] = ACTIONS(4627),
    [anon_sym_case] = ACTIONS(4627),
    [anon_sym_default] = ACTIONS(4627),
    [anon_sym_while] = ACTIONS(4627),
    [anon_sym_do] = ACTIONS(4627),
    [anon_sym_for] = ACTIONS(4627),
    [anon_sym_return] = ACTIONS(4627),
    [anon_sym_break] = ACTIONS(4627),
    [anon_sym_continue] = ACTIONS(4627),
    [anon_sym_goto] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4625),
    [anon_sym_sizeof] = ACTIONS(4627),
    [sym_number_literal] = ACTIONS(4625),
    [sym_char_literal] = ACTIONS(4625),
    [sym_string_literal] = ACTIONS(4625),
    [sym_true] = ACTIONS(4627),
    [sym_false] = ACTIONS(4627),
    [sym_null] = ACTIONS(4627),
    [sym_identifier] = ACTIONS(4627),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4627),
    [sym_auto] = ACTIONS(4627),
    [anon_sym_typename] = ACTIONS(4627),
    [anon_sym_new] = ACTIONS(4627),
    [anon_sym_COLON_COLON] = ACTIONS(4625),
    [anon_sym_delete] = ACTIONS(4627),
    [sym_nullptr] = ACTIONS(4627),
  },
  [1493] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4629),
    [sym_comment] = ACTIONS(49),
  },
  [1494] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4631),
    [sym_comment] = ACTIONS(49),
  },
  [1495] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2074),
    [sym_preproc_elif_in_compound_statement] = STATE(2075),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4633),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [1496] = {
    [anon_sym_LF] = ACTIONS(4635),
    [sym_comment] = ACTIONS(83),
  },
  [1497] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1498] = {
    [sym__type_declarator] = STATE(2078),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [1499] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [1500] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(2079),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1501] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(1463),
  },
  [1502] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(1515),
  },
  [1503] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(1519),
  },
  [1504] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(1523),
  },
  [1505] = {
    [sym__expression] = STATE(2081),
    [sym_conditional_expression] = STATE(2081),
    [sym_assignment_expression] = STATE(2081),
    [sym_pointer_expression] = STATE(2081),
    [sym_logical_expression] = STATE(2081),
    [sym_bitwise_expression] = STATE(2081),
    [sym_equality_expression] = STATE(2081),
    [sym_relational_expression] = STATE(2081),
    [sym_shift_expression] = STATE(2081),
    [sym_math_expression] = STATE(2081),
    [sym_cast_expression] = STATE(2081),
    [sym_sizeof_expression] = STATE(2081),
    [sym_subscript_expression] = STATE(2081),
    [sym_call_expression] = STATE(2081),
    [sym_field_expression] = STATE(2081),
    [sym_compound_literal_expression] = STATE(2081),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_concatenated_string] = STATE(2081),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2081),
    [sym_new_expression] = STATE(2081),
    [sym_delete_expression] = STATE(2081),
    [sym_lambda_expression] = STATE(2081),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4639),
    [sym_char_literal] = ACTIONS(4639),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4643),
    [sym_false] = ACTIONS(4643),
    [sym_null] = ACTIONS(4643),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4643),
  },
  [1506] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2082),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(4645),
    [sym_comment] = ACTIONS(49),
  },
  [1507] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(4647),
    [sym_operator_name] = ACTIONS(198),
  },
  [1508] = {
    [sym__expression] = STATE(2085),
    [sym_conditional_expression] = STATE(2085),
    [sym_assignment_expression] = STATE(2085),
    [sym_pointer_expression] = STATE(2085),
    [sym_logical_expression] = STATE(2085),
    [sym_bitwise_expression] = STATE(2085),
    [sym_equality_expression] = STATE(2085),
    [sym_relational_expression] = STATE(2085),
    [sym_shift_expression] = STATE(2085),
    [sym_math_expression] = STATE(2085),
    [sym_cast_expression] = STATE(2085),
    [sym_sizeof_expression] = STATE(2085),
    [sym_subscript_expression] = STATE(2085),
    [sym_call_expression] = STATE(2085),
    [sym_field_expression] = STATE(2085),
    [sym_compound_literal_expression] = STATE(2085),
    [sym_parenthesized_expression] = STATE(2085),
    [sym_concatenated_string] = STATE(2085),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2085),
    [sym_new_expression] = STATE(2085),
    [sym_delete_expression] = STATE(2085),
    [sym_lambda_expression] = STATE(2085),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4649),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(4651),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4649),
    [sym_char_literal] = ACTIONS(4649),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4653),
    [sym_false] = ACTIONS(4653),
    [sym_null] = ACTIONS(4653),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4653),
  },
  [1509] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4655),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1510] = {
    [sym__expression] = STATE(2099),
    [sym_conditional_expression] = STATE(2099),
    [sym_assignment_expression] = STATE(2099),
    [sym_pointer_expression] = STATE(2099),
    [sym_logical_expression] = STATE(2099),
    [sym_bitwise_expression] = STATE(2099),
    [sym_equality_expression] = STATE(2099),
    [sym_relational_expression] = STATE(2099),
    [sym_shift_expression] = STATE(2099),
    [sym_math_expression] = STATE(2099),
    [sym_cast_expression] = STATE(2099),
    [sym_sizeof_expression] = STATE(2099),
    [sym_subscript_expression] = STATE(2099),
    [sym_call_expression] = STATE(2099),
    [sym_field_expression] = STATE(2099),
    [sym_compound_literal_expression] = STATE(2099),
    [sym_parenthesized_expression] = STATE(2099),
    [sym_concatenated_string] = STATE(2099),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2099),
    [sym_new_expression] = STATE(2099),
    [sym_delete_expression] = STATE(2099),
    [sym_lambda_expression] = STATE(2099),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4685),
    [sym_char_literal] = ACTIONS(4685),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4687),
    [sym_false] = ACTIONS(4687),
    [sym_null] = ACTIONS(4687),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4687),
  },
  [1511] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4689),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1512] = {
    [anon_sym_RPAREN] = ACTIONS(4691),
    [sym_comment] = ACTIONS(49),
  },
  [1513] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_QMARK] = ACTIONS(2692),
    [anon_sym_STAR_EQ] = ACTIONS(2692),
    [anon_sym_SLASH_EQ] = ACTIONS(2692),
    [anon_sym_PERCENT_EQ] = ACTIONS(2692),
    [anon_sym_PLUS_EQ] = ACTIONS(2692),
    [anon_sym_DASH_EQ] = ACTIONS(2692),
    [anon_sym_LT_LT_EQ] = ACTIONS(2692),
    [anon_sym_GT_GT_EQ] = ACTIONS(2692),
    [anon_sym_AMP_EQ] = ACTIONS(2692),
    [anon_sym_CARET_EQ] = ACTIONS(2692),
    [anon_sym_PIPE_EQ] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_CARET] = ACTIONS(2694),
    [anon_sym_EQ_EQ] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_LT_EQ] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2694),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1514] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_STAR_EQ] = ACTIONS(2768),
    [anon_sym_SLASH_EQ] = ACTIONS(2768),
    [anon_sym_PERCENT_EQ] = ACTIONS(2768),
    [anon_sym_PLUS_EQ] = ACTIONS(2768),
    [anon_sym_DASH_EQ] = ACTIONS(2768),
    [anon_sym_LT_LT_EQ] = ACTIONS(2768),
    [anon_sym_GT_GT_EQ] = ACTIONS(2768),
    [anon_sym_AMP_EQ] = ACTIONS(2768),
    [anon_sym_CARET_EQ] = ACTIONS(2768),
    [anon_sym_PIPE_EQ] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2770),
    [anon_sym_CARET] = ACTIONS(2770),
    [anon_sym_EQ_EQ] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_LT_EQ] = ACTIONS(2768),
    [anon_sym_GT_EQ] = ACTIONS(2768),
    [anon_sym_LT_LT] = ACTIONS(2770),
    [anon_sym_GT_GT] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1515] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2774),
    [anon_sym_COLON] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2772),
    [anon_sym_STAR_EQ] = ACTIONS(2772),
    [anon_sym_SLASH_EQ] = ACTIONS(2772),
    [anon_sym_PERCENT_EQ] = ACTIONS(2772),
    [anon_sym_PLUS_EQ] = ACTIONS(2772),
    [anon_sym_DASH_EQ] = ACTIONS(2772),
    [anon_sym_LT_LT_EQ] = ACTIONS(2772),
    [anon_sym_GT_GT_EQ] = ACTIONS(2772),
    [anon_sym_AMP_EQ] = ACTIONS(2772),
    [anon_sym_CARET_EQ] = ACTIONS(2772),
    [anon_sym_PIPE_EQ] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_CARET] = ACTIONS(2774),
    [anon_sym_EQ_EQ] = ACTIONS(2772),
    [anon_sym_BANG_EQ] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_LT_EQ] = ACTIONS(2772),
    [anon_sym_GT_EQ] = ACTIONS(2772),
    [anon_sym_LT_LT] = ACTIONS(2774),
    [anon_sym_GT_GT] = ACTIONS(2774),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1516] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2778),
    [anon_sym_COLON] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2776),
    [anon_sym_STAR_EQ] = ACTIONS(2776),
    [anon_sym_SLASH_EQ] = ACTIONS(2776),
    [anon_sym_PERCENT_EQ] = ACTIONS(2776),
    [anon_sym_PLUS_EQ] = ACTIONS(2776),
    [anon_sym_DASH_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_GT_EQ] = ACTIONS(2776),
    [anon_sym_AMP_EQ] = ACTIONS(2776),
    [anon_sym_CARET_EQ] = ACTIONS(2776),
    [anon_sym_PIPE_EQ] = ACTIONS(2776),
    [anon_sym_AMP] = ACTIONS(2778),
    [anon_sym_PIPE_PIPE] = ACTIONS(2776),
    [anon_sym_AMP_AMP] = ACTIONS(2776),
    [anon_sym_PIPE] = ACTIONS(2778),
    [anon_sym_CARET] = ACTIONS(2778),
    [anon_sym_EQ_EQ] = ACTIONS(2776),
    [anon_sym_BANG_EQ] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_GT] = ACTIONS(2778),
    [anon_sym_LT_EQ] = ACTIONS(2776),
    [anon_sym_GT_EQ] = ACTIONS(2776),
    [anon_sym_LT_LT] = ACTIONS(2778),
    [anon_sym_GT_GT] = ACTIONS(2778),
    [anon_sym_PLUS] = ACTIONS(2778),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_PERCENT] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1517] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(2102),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1518] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1519] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2103),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_COLON] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(4693),
    [sym_comment] = ACTIONS(49),
  },
  [1520] = {
    [sym__expression] = STATE(2105),
    [sym_conditional_expression] = STATE(2105),
    [sym_assignment_expression] = STATE(2105),
    [sym_pointer_expression] = STATE(2105),
    [sym_logical_expression] = STATE(2105),
    [sym_bitwise_expression] = STATE(2105),
    [sym_equality_expression] = STATE(2105),
    [sym_relational_expression] = STATE(2105),
    [sym_shift_expression] = STATE(2105),
    [sym_math_expression] = STATE(2105),
    [sym_cast_expression] = STATE(2105),
    [sym_sizeof_expression] = STATE(2105),
    [sym_subscript_expression] = STATE(2105),
    [sym_call_expression] = STATE(2105),
    [sym_field_expression] = STATE(2105),
    [sym_compound_literal_expression] = STATE(2105),
    [sym_parenthesized_expression] = STATE(2105),
    [sym_concatenated_string] = STATE(2105),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2105),
    [sym_new_expression] = STATE(2105),
    [sym_delete_expression] = STATE(2105),
    [sym_lambda_expression] = STATE(2105),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4695),
    [sym_char_literal] = ACTIONS(4695),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4699),
    [sym_false] = ACTIONS(4699),
    [sym_null] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4699),
  },
  [1521] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1522] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_COLON] = ACTIONS(2826),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1523] = {
    [sym__expression] = STATE(2107),
    [sym_conditional_expression] = STATE(2107),
    [sym_assignment_expression] = STATE(2107),
    [sym_pointer_expression] = STATE(2107),
    [sym_logical_expression] = STATE(2107),
    [sym_bitwise_expression] = STATE(2107),
    [sym_equality_expression] = STATE(2107),
    [sym_relational_expression] = STATE(2107),
    [sym_shift_expression] = STATE(2107),
    [sym_math_expression] = STATE(2107),
    [sym_cast_expression] = STATE(2107),
    [sym_sizeof_expression] = STATE(2107),
    [sym_subscript_expression] = STATE(2107),
    [sym_call_expression] = STATE(2107),
    [sym_field_expression] = STATE(2107),
    [sym_compound_literal_expression] = STATE(2107),
    [sym_parenthesized_expression] = STATE(2107),
    [sym_concatenated_string] = STATE(2107),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2107),
    [sym_new_expression] = STATE(2107),
    [sym_delete_expression] = STATE(2107),
    [sym_lambda_expression] = STATE(2107),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4703),
    [sym_char_literal] = ACTIONS(4703),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4705),
    [sym_false] = ACTIONS(4705),
    [sym_null] = ACTIONS(4705),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4705),
  },
  [1524] = {
    [sym__expression] = STATE(2108),
    [sym_conditional_expression] = STATE(2108),
    [sym_assignment_expression] = STATE(2108),
    [sym_pointer_expression] = STATE(2108),
    [sym_logical_expression] = STATE(2108),
    [sym_bitwise_expression] = STATE(2108),
    [sym_equality_expression] = STATE(2108),
    [sym_relational_expression] = STATE(2108),
    [sym_shift_expression] = STATE(2108),
    [sym_math_expression] = STATE(2108),
    [sym_cast_expression] = STATE(2108),
    [sym_sizeof_expression] = STATE(2108),
    [sym_subscript_expression] = STATE(2108),
    [sym_call_expression] = STATE(2108),
    [sym_field_expression] = STATE(2108),
    [sym_compound_literal_expression] = STATE(2108),
    [sym_parenthesized_expression] = STATE(2108),
    [sym_concatenated_string] = STATE(2108),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2108),
    [sym_new_expression] = STATE(2108),
    [sym_delete_expression] = STATE(2108),
    [sym_lambda_expression] = STATE(2108),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4707),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4707),
    [sym_char_literal] = ACTIONS(4707),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4709),
    [sym_false] = ACTIONS(4709),
    [sym_null] = ACTIONS(4709),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4709),
  },
  [1525] = {
    [sym_declaration] = STATE(2109),
    [sym_type_definition] = STATE(2109),
    [sym__declaration_specifiers] = STATE(1540),
    [sym_compound_statement] = STATE(2109),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_case_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_break_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_goto_statement] = STATE(2109),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2109),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3130),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1526] = {
    [sym__expression] = STATE(2110),
    [sym_conditional_expression] = STATE(2110),
    [sym_assignment_expression] = STATE(2110),
    [sym_pointer_expression] = STATE(2110),
    [sym_logical_expression] = STATE(2110),
    [sym_bitwise_expression] = STATE(2110),
    [sym_equality_expression] = STATE(2110),
    [sym_relational_expression] = STATE(2110),
    [sym_shift_expression] = STATE(2110),
    [sym_math_expression] = STATE(2110),
    [sym_cast_expression] = STATE(2110),
    [sym_sizeof_expression] = STATE(2110),
    [sym_subscript_expression] = STATE(2110),
    [sym_call_expression] = STATE(2110),
    [sym_field_expression] = STATE(2110),
    [sym_compound_literal_expression] = STATE(2110),
    [sym_parenthesized_expression] = STATE(2110),
    [sym_concatenated_string] = STATE(2110),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2110),
    [sym_new_expression] = STATE(2110),
    [sym_delete_expression] = STATE(2110),
    [sym_lambda_expression] = STATE(2110),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4711),
    [sym_char_literal] = ACTIONS(4711),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4713),
    [sym_false] = ACTIONS(4713),
    [sym_null] = ACTIONS(4713),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4713),
  },
  [1527] = {
    [sym__expression] = STATE(2111),
    [sym_conditional_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2111),
    [sym_pointer_expression] = STATE(2111),
    [sym_logical_expression] = STATE(2111),
    [sym_bitwise_expression] = STATE(2111),
    [sym_equality_expression] = STATE(2111),
    [sym_relational_expression] = STATE(2111),
    [sym_shift_expression] = STATE(2111),
    [sym_math_expression] = STATE(2111),
    [sym_cast_expression] = STATE(2111),
    [sym_sizeof_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_call_expression] = STATE(2111),
    [sym_field_expression] = STATE(2111),
    [sym_compound_literal_expression] = STATE(2111),
    [sym_parenthesized_expression] = STATE(2111),
    [sym_concatenated_string] = STATE(2111),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2111),
    [sym_new_expression] = STATE(2111),
    [sym_delete_expression] = STATE(2111),
    [sym_lambda_expression] = STATE(2111),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4715),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4715),
    [sym_char_literal] = ACTIONS(4715),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4717),
    [sym_false] = ACTIONS(4717),
    [sym_null] = ACTIONS(4717),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4717),
  },
  [1528] = {
    [sym__expression] = STATE(2112),
    [sym_conditional_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_pointer_expression] = STATE(2112),
    [sym_logical_expression] = STATE(2112),
    [sym_bitwise_expression] = STATE(2112),
    [sym_equality_expression] = STATE(2112),
    [sym_relational_expression] = STATE(2112),
    [sym_shift_expression] = STATE(2112),
    [sym_math_expression] = STATE(2112),
    [sym_cast_expression] = STATE(2112),
    [sym_sizeof_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_call_expression] = STATE(2112),
    [sym_field_expression] = STATE(2112),
    [sym_compound_literal_expression] = STATE(2112),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_concatenated_string] = STATE(2112),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2112),
    [sym_new_expression] = STATE(2112),
    [sym_delete_expression] = STATE(2112),
    [sym_lambda_expression] = STATE(2112),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4719),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4719),
    [sym_char_literal] = ACTIONS(4719),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4721),
    [sym_false] = ACTIONS(4721),
    [sym_null] = ACTIONS(4721),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4721),
  },
  [1529] = {
    [sym__expression] = STATE(2113),
    [sym_conditional_expression] = STATE(2113),
    [sym_assignment_expression] = STATE(2113),
    [sym_pointer_expression] = STATE(2113),
    [sym_logical_expression] = STATE(2113),
    [sym_bitwise_expression] = STATE(2113),
    [sym_equality_expression] = STATE(2113),
    [sym_relational_expression] = STATE(2113),
    [sym_shift_expression] = STATE(2113),
    [sym_math_expression] = STATE(2113),
    [sym_cast_expression] = STATE(2113),
    [sym_sizeof_expression] = STATE(2113),
    [sym_subscript_expression] = STATE(2113),
    [sym_call_expression] = STATE(2113),
    [sym_field_expression] = STATE(2113),
    [sym_compound_literal_expression] = STATE(2113),
    [sym_parenthesized_expression] = STATE(2113),
    [sym_concatenated_string] = STATE(2113),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2113),
    [sym_new_expression] = STATE(2113),
    [sym_delete_expression] = STATE(2113),
    [sym_lambda_expression] = STATE(2113),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4723),
    [sym_char_literal] = ACTIONS(4723),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4725),
    [sym_false] = ACTIONS(4725),
    [sym_null] = ACTIONS(4725),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4725),
  },
  [1530] = {
    [sym__expression] = STATE(2114),
    [sym_conditional_expression] = STATE(2114),
    [sym_assignment_expression] = STATE(2114),
    [sym_pointer_expression] = STATE(2114),
    [sym_logical_expression] = STATE(2114),
    [sym_bitwise_expression] = STATE(2114),
    [sym_equality_expression] = STATE(2114),
    [sym_relational_expression] = STATE(2114),
    [sym_shift_expression] = STATE(2114),
    [sym_math_expression] = STATE(2114),
    [sym_cast_expression] = STATE(2114),
    [sym_sizeof_expression] = STATE(2114),
    [sym_subscript_expression] = STATE(2114),
    [sym_call_expression] = STATE(2114),
    [sym_field_expression] = STATE(2114),
    [sym_compound_literal_expression] = STATE(2114),
    [sym_parenthesized_expression] = STATE(2114),
    [sym_concatenated_string] = STATE(2114),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2114),
    [sym_new_expression] = STATE(2114),
    [sym_delete_expression] = STATE(2114),
    [sym_lambda_expression] = STATE(2114),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4727),
    [sym_char_literal] = ACTIONS(4727),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4729),
    [sym_false] = ACTIONS(4729),
    [sym_null] = ACTIONS(4729),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4729),
  },
  [1531] = {
    [sym__expression] = STATE(2115),
    [sym_conditional_expression] = STATE(2115),
    [sym_assignment_expression] = STATE(2115),
    [sym_pointer_expression] = STATE(2115),
    [sym_logical_expression] = STATE(2115),
    [sym_bitwise_expression] = STATE(2115),
    [sym_equality_expression] = STATE(2115),
    [sym_relational_expression] = STATE(2115),
    [sym_shift_expression] = STATE(2115),
    [sym_math_expression] = STATE(2115),
    [sym_cast_expression] = STATE(2115),
    [sym_sizeof_expression] = STATE(2115),
    [sym_subscript_expression] = STATE(2115),
    [sym_call_expression] = STATE(2115),
    [sym_field_expression] = STATE(2115),
    [sym_compound_literal_expression] = STATE(2115),
    [sym_parenthesized_expression] = STATE(2115),
    [sym_concatenated_string] = STATE(2115),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2115),
    [sym_new_expression] = STATE(2115),
    [sym_delete_expression] = STATE(2115),
    [sym_lambda_expression] = STATE(2115),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4731),
    [sym_char_literal] = ACTIONS(4731),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4733),
    [sym_false] = ACTIONS(4733),
    [sym_null] = ACTIONS(4733),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4733),
  },
  [1532] = {
    [sym__expression] = STATE(2116),
    [sym_conditional_expression] = STATE(2116),
    [sym_assignment_expression] = STATE(2116),
    [sym_pointer_expression] = STATE(2116),
    [sym_logical_expression] = STATE(2116),
    [sym_bitwise_expression] = STATE(2116),
    [sym_equality_expression] = STATE(2116),
    [sym_relational_expression] = STATE(2116),
    [sym_shift_expression] = STATE(2116),
    [sym_math_expression] = STATE(2116),
    [sym_cast_expression] = STATE(2116),
    [sym_sizeof_expression] = STATE(2116),
    [sym_subscript_expression] = STATE(2116),
    [sym_call_expression] = STATE(2116),
    [sym_field_expression] = STATE(2116),
    [sym_compound_literal_expression] = STATE(2116),
    [sym_parenthesized_expression] = STATE(2116),
    [sym_concatenated_string] = STATE(2116),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2116),
    [sym_new_expression] = STATE(2116),
    [sym_delete_expression] = STATE(2116),
    [sym_lambda_expression] = STATE(2116),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4735),
    [sym_char_literal] = ACTIONS(4735),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4737),
    [sym_false] = ACTIONS(4737),
    [sym_null] = ACTIONS(4737),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4737),
  },
  [1533] = {
    [sym__expression] = STATE(2117),
    [sym_conditional_expression] = STATE(2117),
    [sym_assignment_expression] = STATE(2117),
    [sym_pointer_expression] = STATE(2117),
    [sym_logical_expression] = STATE(2117),
    [sym_bitwise_expression] = STATE(2117),
    [sym_equality_expression] = STATE(2117),
    [sym_relational_expression] = STATE(2117),
    [sym_shift_expression] = STATE(2117),
    [sym_math_expression] = STATE(2117),
    [sym_cast_expression] = STATE(2117),
    [sym_sizeof_expression] = STATE(2117),
    [sym_subscript_expression] = STATE(2117),
    [sym_call_expression] = STATE(2117),
    [sym_field_expression] = STATE(2117),
    [sym_compound_literal_expression] = STATE(2117),
    [sym_parenthesized_expression] = STATE(2117),
    [sym_concatenated_string] = STATE(2117),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2117),
    [sym_new_expression] = STATE(2117),
    [sym_delete_expression] = STATE(2117),
    [sym_lambda_expression] = STATE(2117),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4739),
    [sym_char_literal] = ACTIONS(4739),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4741),
    [sym_false] = ACTIONS(4741),
    [sym_null] = ACTIONS(4741),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4741),
  },
  [1534] = {
    [sym__expression] = STATE(2118),
    [sym_conditional_expression] = STATE(2118),
    [sym_assignment_expression] = STATE(2118),
    [sym_pointer_expression] = STATE(2118),
    [sym_logical_expression] = STATE(2118),
    [sym_bitwise_expression] = STATE(2118),
    [sym_equality_expression] = STATE(2118),
    [sym_relational_expression] = STATE(2118),
    [sym_shift_expression] = STATE(2118),
    [sym_math_expression] = STATE(2118),
    [sym_cast_expression] = STATE(2118),
    [sym_sizeof_expression] = STATE(2118),
    [sym_subscript_expression] = STATE(2118),
    [sym_call_expression] = STATE(2118),
    [sym_field_expression] = STATE(2118),
    [sym_compound_literal_expression] = STATE(2118),
    [sym_parenthesized_expression] = STATE(2118),
    [sym_concatenated_string] = STATE(2118),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2118),
    [sym_new_expression] = STATE(2118),
    [sym_delete_expression] = STATE(2118),
    [sym_lambda_expression] = STATE(2118),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4743),
    [sym_char_literal] = ACTIONS(4743),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4745),
    [sym_false] = ACTIONS(4745),
    [sym_null] = ACTIONS(4745),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4745),
  },
  [1535] = {
    [sym__expression] = STATE(2119),
    [sym_conditional_expression] = STATE(2119),
    [sym_assignment_expression] = STATE(2119),
    [sym_pointer_expression] = STATE(2119),
    [sym_logical_expression] = STATE(2119),
    [sym_bitwise_expression] = STATE(2119),
    [sym_equality_expression] = STATE(2119),
    [sym_relational_expression] = STATE(2119),
    [sym_shift_expression] = STATE(2119),
    [sym_math_expression] = STATE(2119),
    [sym_cast_expression] = STATE(2119),
    [sym_sizeof_expression] = STATE(2119),
    [sym_subscript_expression] = STATE(2119),
    [sym_call_expression] = STATE(2119),
    [sym_field_expression] = STATE(2119),
    [sym_compound_literal_expression] = STATE(2119),
    [sym_parenthesized_expression] = STATE(2119),
    [sym_concatenated_string] = STATE(2119),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2119),
    [sym_new_expression] = STATE(2119),
    [sym_delete_expression] = STATE(2119),
    [sym_lambda_expression] = STATE(2119),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4747),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(4747),
    [sym_char_literal] = ACTIONS(4747),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(4749),
    [sym_false] = ACTIONS(4749),
    [sym_null] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(4749),
  },
  [1536] = {
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(1405),
    [sym_destructor_name] = STATE(1405),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2886),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
  },
  [1537] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [1538] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(4753),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(1778),
    [sym_operator_name] = ACTIONS(198),
  },
  [1539] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [1540] = {
    [sym__declarator] = STATE(935),
    [sym_pointer_declarator] = STATE(935),
    [sym_function_declarator] = STATE(935),
    [sym_array_declarator] = STATE(935),
    [sym_init_declarator] = STATE(936),
    [sym_reference_declarator] = STATE(935),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(935),
    [sym_destructor_name] = STATE(935),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1796),
  },
  [1541] = {
    [sym_initializer_list] = STATE(846),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_mutable] = ACTIONS(238),
    [anon_sym_explicit] = ACTIONS(238),
    [anon_sym_constexpr] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4759),
    [sym_operator_name] = ACTIONS(236),
  },
  [1542] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4759),
  },
  [1543] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1544] = {
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_RBRACK] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1682),
    [anon_sym_COLON] = ACTIONS(1680),
    [anon_sym_else] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1680),
    [anon_sym_STAR_EQ] = ACTIONS(1680),
    [anon_sym_SLASH_EQ] = ACTIONS(1680),
    [anon_sym_PERCENT_EQ] = ACTIONS(1680),
    [anon_sym_PLUS_EQ] = ACTIONS(1680),
    [anon_sym_DASH_EQ] = ACTIONS(1680),
    [anon_sym_LT_LT_EQ] = ACTIONS(1680),
    [anon_sym_GT_GT_EQ] = ACTIONS(1680),
    [anon_sym_AMP_EQ] = ACTIONS(1680),
    [anon_sym_CARET_EQ] = ACTIONS(1680),
    [anon_sym_PIPE_EQ] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1680),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_CARET] = ACTIONS(1682),
    [anon_sym_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_PERCENT] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_DASH_GT] = ACTIONS(1680),
    [sym_comment] = ACTIONS(49),
  },
  [1545] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1546] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4765),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4765),
    [sym_char_literal] = ACTIONS(4765),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4767),
    [sym_false] = ACTIONS(4767),
    [sym_null] = ACTIONS(4767),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4767),
  },
  [1547] = {
    [anon_sym_LPAREN] = ACTIONS(4769),
    [sym_comment] = ACTIONS(49),
  },
  [1548] = {
    [sym__expression] = STATE(2128),
    [sym_conditional_expression] = STATE(2128),
    [sym_assignment_expression] = STATE(2128),
    [sym_pointer_expression] = STATE(2128),
    [sym_logical_expression] = STATE(2128),
    [sym_bitwise_expression] = STATE(2128),
    [sym_equality_expression] = STATE(2128),
    [sym_relational_expression] = STATE(2128),
    [sym_shift_expression] = STATE(2128),
    [sym_math_expression] = STATE(2128),
    [sym_cast_expression] = STATE(2128),
    [sym_sizeof_expression] = STATE(2128),
    [sym_subscript_expression] = STATE(2128),
    [sym_call_expression] = STATE(2128),
    [sym_field_expression] = STATE(2128),
    [sym_compound_literal_expression] = STATE(2128),
    [sym_parenthesized_expression] = STATE(2128),
    [sym_concatenated_string] = STATE(2128),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2128),
    [sym_new_expression] = STATE(2128),
    [sym_delete_expression] = STATE(2128),
    [sym_lambda_expression] = STATE(2128),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4771),
    [sym_char_literal] = ACTIONS(4771),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4773),
    [sym_false] = ACTIONS(4773),
    [sym_null] = ACTIONS(4773),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4773),
  },
  [1549] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(4775),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1550] = {
    [sym_declaration] = STATE(2132),
    [sym_type_definition] = STATE(2132),
    [sym__declaration_specifiers] = STATE(2133),
    [sym_compound_statement] = STATE(2132),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2132),
    [sym_expression_statement] = STATE(2132),
    [sym_if_statement] = STATE(2132),
    [sym_switch_statement] = STATE(2132),
    [sym_case_statement] = STATE(2132),
    [sym_while_statement] = STATE(2132),
    [sym_do_statement] = STATE(2132),
    [sym_for_statement] = STATE(2132),
    [sym_return_statement] = STATE(2132),
    [sym_break_statement] = STATE(2132),
    [sym_continue_statement] = STATE(2132),
    [sym_goto_statement] = STATE(2132),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2132),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_typedef] = ACTIONS(4777),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(4779),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [1551] = {
    [sym__expression] = STATE(2134),
    [sym_conditional_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2134),
    [sym_pointer_expression] = STATE(2134),
    [sym_logical_expression] = STATE(2134),
    [sym_bitwise_expression] = STATE(2134),
    [sym_equality_expression] = STATE(2134),
    [sym_relational_expression] = STATE(2134),
    [sym_shift_expression] = STATE(2134),
    [sym_math_expression] = STATE(2134),
    [sym_cast_expression] = STATE(2134),
    [sym_sizeof_expression] = STATE(2134),
    [sym_subscript_expression] = STATE(2134),
    [sym_call_expression] = STATE(2134),
    [sym_field_expression] = STATE(2134),
    [sym_compound_literal_expression] = STATE(2134),
    [sym_parenthesized_expression] = STATE(2134),
    [sym_concatenated_string] = STATE(2134),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2134),
    [sym_new_expression] = STATE(2134),
    [sym_delete_expression] = STATE(2134),
    [sym_lambda_expression] = STATE(2134),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4781),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4781),
    [sym_char_literal] = ACTIONS(4781),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4783),
    [sym_false] = ACTIONS(4783),
    [sym_null] = ACTIONS(4783),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4783),
  },
  [1552] = {
    [anon_sym_while] = ACTIONS(4785),
    [sym_comment] = ACTIONS(49),
  },
  [1553] = {
    [sym_declaration] = STATE(2136),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(2137),
    [sym_conditional_expression] = STATE(2137),
    [sym_assignment_expression] = STATE(2137),
    [sym_pointer_expression] = STATE(2137),
    [sym_logical_expression] = STATE(2137),
    [sym_bitwise_expression] = STATE(2137),
    [sym_equality_expression] = STATE(2137),
    [sym_relational_expression] = STATE(2137),
    [sym_shift_expression] = STATE(2137),
    [sym_math_expression] = STATE(2137),
    [sym_cast_expression] = STATE(2137),
    [sym_sizeof_expression] = STATE(2137),
    [sym_subscript_expression] = STATE(2137),
    [sym_call_expression] = STATE(2137),
    [sym_field_expression] = STATE(2137),
    [sym_compound_literal_expression] = STATE(2137),
    [sym_parenthesized_expression] = STATE(2137),
    [sym_concatenated_string] = STATE(2137),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2137),
    [sym_for_range_declaration] = STATE(2138),
    [sym_new_expression] = STATE(2137),
    [sym_delete_expression] = STATE(2137),
    [sym_lambda_expression] = STATE(2137),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(4789),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4787),
    [sym_char_literal] = ACTIONS(4787),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4791),
    [sym_false] = ACTIONS(4791),
    [sym_null] = ACTIONS(4791),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4791),
  },
  [1554] = {
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [sym_comment] = ACTIONS(49),
  },
  [1555] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4793),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1556] = {
    [anon_sym_SEMI] = ACTIONS(4793),
    [sym_comment] = ACTIONS(49),
  },
  [1557] = {
    [anon_sym_else] = ACTIONS(3190),
    [anon_sym_while] = ACTIONS(3190),
    [sym_comment] = ACTIONS(49),
  },
  [1558] = {
    [anon_sym_else] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [sym_comment] = ACTIONS(49),
  },
  [1559] = {
    [anon_sym_SEMI] = ACTIONS(4795),
    [sym_comment] = ACTIONS(49),
  },
  [1560] = {
    [sym_compound_statement] = STATE(2141),
    [sym_labeled_statement] = STATE(2141),
    [sym_expression_statement] = STATE(2141),
    [sym_if_statement] = STATE(2141),
    [sym_switch_statement] = STATE(2141),
    [sym_case_statement] = STATE(2141),
    [sym_while_statement] = STATE(2141),
    [sym_do_statement] = STATE(2141),
    [sym_for_statement] = STATE(2141),
    [sym_return_statement] = STATE(2141),
    [sym_break_statement] = STATE(2141),
    [sym_continue_statement] = STATE(2141),
    [sym_goto_statement] = STATE(2141),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2141),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [1561] = {
    [anon_sym_LPAREN] = ACTIONS(4797),
    [sym_comment] = ACTIONS(49),
  },
  [1562] = {
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [sym_comment] = ACTIONS(49),
  },
  [1563] = {
    [sym__expression] = STATE(2144),
    [sym_conditional_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2144),
    [sym_pointer_expression] = STATE(2144),
    [sym_logical_expression] = STATE(2144),
    [sym_bitwise_expression] = STATE(2144),
    [sym_equality_expression] = STATE(2144),
    [sym_relational_expression] = STATE(2144),
    [sym_shift_expression] = STATE(2144),
    [sym_math_expression] = STATE(2144),
    [sym_cast_expression] = STATE(2144),
    [sym_sizeof_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_call_expression] = STATE(2144),
    [sym_field_expression] = STATE(2144),
    [sym_compound_literal_expression] = STATE(2144),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_concatenated_string] = STATE(2144),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2144),
    [sym_new_expression] = STATE(2144),
    [sym_delete_expression] = STATE(2144),
    [sym_lambda_expression] = STATE(2144),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(4801),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4799),
    [sym_char_literal] = ACTIONS(4799),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4803),
    [sym_false] = ACTIONS(4803),
    [sym_null] = ACTIONS(4803),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4803),
  },
  [1564] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [1565] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(4753),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(2615),
    [sym_operator_name] = ACTIONS(198),
  },
  [1566] = {
    [sym__declarator] = STATE(2147),
    [sym_pointer_declarator] = STATE(2147),
    [sym_function_declarator] = STATE(2147),
    [sym_array_declarator] = STATE(2147),
    [sym_init_declarator] = STATE(2148),
    [sym_reference_declarator] = STATE(2147),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2147),
    [sym_destructor_name] = STATE(2147),
    [sym_scoped_identifier] = STATE(2149),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_AMP_AMP] = ACTIONS(4809),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4811),
  },
  [1567] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4813),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1568] = {
    [anon_sym_COLON] = ACTIONS(4815),
    [sym_comment] = ACTIONS(49),
  },
  [1569] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_RBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [1570] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [1571] = {
    [anon_sym_RPAREN] = ACTIONS(4825),
    [sym_comment] = ACTIONS(49),
  },
  [1572] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1572),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(4827),
    [sym_comment] = ACTIONS(49),
  },
  [1573] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [1574] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [1575] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [1576] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(4834),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1577] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1578] = {
    [sym__expression] = STATE(2154),
    [sym_conditional_expression] = STATE(2154),
    [sym_assignment_expression] = STATE(2154),
    [sym_pointer_expression] = STATE(2154),
    [sym_logical_expression] = STATE(2154),
    [sym_bitwise_expression] = STATE(2154),
    [sym_equality_expression] = STATE(2154),
    [sym_relational_expression] = STATE(2154),
    [sym_shift_expression] = STATE(2154),
    [sym_math_expression] = STATE(2154),
    [sym_cast_expression] = STATE(2154),
    [sym_sizeof_expression] = STATE(2154),
    [sym_subscript_expression] = STATE(2154),
    [sym_call_expression] = STATE(2154),
    [sym_field_expression] = STATE(2154),
    [sym_compound_literal_expression] = STATE(2154),
    [sym_parenthesized_expression] = STATE(2154),
    [sym_concatenated_string] = STATE(2154),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2154),
    [sym_new_expression] = STATE(2154),
    [sym_delete_expression] = STATE(2154),
    [sym_lambda_expression] = STATE(2154),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4836),
    [sym_char_literal] = ACTIONS(4836),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4838),
    [sym_false] = ACTIONS(4838),
    [sym_null] = ACTIONS(4838),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4838),
  },
  [1579] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [1580] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(4840),
    [sym_comment] = ACTIONS(49),
  },
  [1581] = {
    [sym__expression] = STATE(2156),
    [sym_conditional_expression] = STATE(2156),
    [sym_assignment_expression] = STATE(2156),
    [sym_pointer_expression] = STATE(2156),
    [sym_logical_expression] = STATE(2156),
    [sym_bitwise_expression] = STATE(2156),
    [sym_equality_expression] = STATE(2156),
    [sym_relational_expression] = STATE(2156),
    [sym_shift_expression] = STATE(2156),
    [sym_math_expression] = STATE(2156),
    [sym_cast_expression] = STATE(2156),
    [sym_sizeof_expression] = STATE(2156),
    [sym_subscript_expression] = STATE(2156),
    [sym_call_expression] = STATE(2156),
    [sym_field_expression] = STATE(2156),
    [sym_compound_literal_expression] = STATE(2156),
    [sym_parenthesized_expression] = STATE(2156),
    [sym_initializer_list] = STATE(2157),
    [sym_concatenated_string] = STATE(2156),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2156),
    [sym_new_expression] = STATE(2156),
    [sym_delete_expression] = STATE(2156),
    [sym_lambda_expression] = STATE(2156),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4842),
    [sym_char_literal] = ACTIONS(4842),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4844),
    [sym_false] = ACTIONS(4844),
    [sym_null] = ACTIONS(4844),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4844),
  },
  [1582] = {
    [anon_sym_SEMI] = ACTIONS(4846),
    [sym_comment] = ACTIONS(49),
  },
  [1583] = {
    [sym__expression] = STATE(2159),
    [sym_conditional_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(2159),
    [sym_pointer_expression] = STATE(2159),
    [sym_logical_expression] = STATE(2159),
    [sym_bitwise_expression] = STATE(2159),
    [sym_equality_expression] = STATE(2159),
    [sym_relational_expression] = STATE(2159),
    [sym_shift_expression] = STATE(2159),
    [sym_math_expression] = STATE(2159),
    [sym_cast_expression] = STATE(2159),
    [sym_sizeof_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_call_expression] = STATE(2159),
    [sym_field_expression] = STATE(2159),
    [sym_compound_literal_expression] = STATE(2159),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_initializer_list] = STATE(2160),
    [sym_concatenated_string] = STATE(2159),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2159),
    [sym_new_expression] = STATE(2159),
    [sym_delete_expression] = STATE(2159),
    [sym_lambda_expression] = STATE(2159),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4848),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4848),
    [sym_char_literal] = ACTIONS(4848),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4850),
    [sym_false] = ACTIONS(4850),
    [sym_null] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4850),
  },
  [1584] = {
    [anon_sym_SEMI] = ACTIONS(4852),
    [sym_comment] = ACTIONS(49),
  },
  [1585] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(4854),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1586] = {
    [anon_sym_RPAREN] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(4854),
    [sym_comment] = ACTIONS(49),
  },
  [1587] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1588] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(4856),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1589] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1590] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1591] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1592] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1593] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1594] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1595] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1596] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1597] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_SEMI] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1598] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [1599] = {
    [anon_sym_LPAREN] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(4858),
    [anon_sym_LT] = ACTIONS(1186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [1600] = {
    [anon_sym_LPAREN] = ACTIONS(4860),
    [anon_sym_LBRACE] = ACTIONS(4860),
    [anon_sym_LT] = ACTIONS(4860),
    [sym_comment] = ACTIONS(49),
  },
  [1601] = {
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(49),
  },
  [1602] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1602),
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(49),
  },
  [1603] = {
    [anon_sym_LPAREN] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_LT] = ACTIONS(1859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [1604] = {
    [anon_sym_LPAREN] = ACTIONS(4869),
    [anon_sym_LBRACE] = ACTIONS(4869),
    [anon_sym_LT] = ACTIONS(4869),
    [sym_comment] = ACTIONS(49),
  },
  [1605] = {
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [sym_comment] = ACTIONS(49),
  },
  [1606] = {
    [anon_sym_LF] = ACTIONS(4873),
    [sym_preproc_arg] = ACTIONS(4873),
    [sym_comment] = ACTIONS(83),
  },
  [1607] = {
    [aux_sym_preproc_params_repeat1] = STATE(1607),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [sym_comment] = ACTIONS(49),
  },
  [1608] = {
    [sym_enumerator_list] = STATE(1977),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_COMMA] = ACTIONS(366),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_const] = ACTIONS(368),
    [anon_sym_restrict] = ACTIONS(366),
    [anon_sym_volatile] = ACTIONS(366),
    [anon_sym__Atomic] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(366),
    [anon_sym_explicit] = ACTIONS(366),
    [anon_sym_constexpr] = ACTIONS(366),
    [anon_sym_COLON] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_DASH_GT] = ACTIONS(366),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(366),
  },
  [1609] = {
    [sym_field_declaration_list] = STATE(1980),
    [sym_base_class_clause] = STATE(1981),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym__Atomic] = ACTIONS(426),
    [anon_sym_mutable] = ACTIONS(426),
    [anon_sym_explicit] = ACTIONS(426),
    [anon_sym_constexpr] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4470),
    [sym_noexcept] = ACTIONS(426),
  },
  [1610] = {
    [sym_field_declaration_list] = STATE(1983),
    [sym_base_class_clause] = STATE(1984),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym__Atomic] = ACTIONS(438),
    [anon_sym_mutable] = ACTIONS(438),
    [anon_sym_explicit] = ACTIONS(438),
    [anon_sym_constexpr] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_DASH_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4472),
    [sym_noexcept] = ACTIONS(438),
  },
  [1611] = {
    [sym_field_declaration_list] = STATE(1989),
    [sym_base_class_clause] = STATE(1990),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_mutable] = ACTIONS(475),
    [anon_sym_explicit] = ACTIONS(475),
    [anon_sym_constexpr] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4478),
    [sym_noexcept] = ACTIONS(475),
  },
  [1612] = {
    [sym__abstract_declarator] = STATE(2163),
    [sym_abstract_pointer_declarator] = STATE(2163),
    [sym_abstract_function_declarator] = STATE(2163),
    [sym_abstract_array_declarator] = STATE(2163),
    [sym_parameter_list] = STATE(1615),
    [sym_abstract_reference_declarator] = STATE(2163),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [1613] = {
    [sym__abstract_declarator] = STATE(2164),
    [sym_abstract_pointer_declarator] = STATE(2164),
    [sym_abstract_function_declarator] = STATE(2164),
    [sym_abstract_array_declarator] = STATE(2164),
    [sym_parameter_list] = STATE(1615),
    [sym_abstract_reference_declarator] = STATE(2164),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [1614] = {
    [sym_parameter_list] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [1615] = {
    [sym_type_qualifier] = STATE(2166),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2166),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [1616] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1616),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(4878),
    [anon_sym_long] = ACTIONS(4878),
    [anon_sym_short] = ACTIONS(4878),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [1617] = {
    [anon_sym_LF] = ACTIONS(4881),
    [sym_comment] = ACTIONS(83),
  },
  [1618] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_template] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1883),
    [anon_sym_using] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [sym_operator_name] = ACTIONS(1881),
  },
  [1619] = {
    [anon_sym_LF] = ACTIONS(4883),
    [sym_comment] = ACTIONS(83),
  },
  [1620] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1969),
    [sym_preproc_directive] = ACTIONS(1969),
    [anon_sym_typedef] = ACTIONS(1969),
    [anon_sym_extern] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1969),
    [anon_sym_register] = ACTIONS(1969),
    [anon_sym_inline] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1969),
    [anon_sym_restrict] = ACTIONS(1969),
    [anon_sym_volatile] = ACTIONS(1969),
    [anon_sym__Atomic] = ACTIONS(1969),
    [anon_sym_mutable] = ACTIONS(1969),
    [anon_sym_explicit] = ACTIONS(1969),
    [anon_sym_constexpr] = ACTIONS(1969),
    [anon_sym_unsigned] = ACTIONS(1969),
    [anon_sym_long] = ACTIONS(1969),
    [anon_sym_short] = ACTIONS(1969),
    [sym_primitive_type] = ACTIONS(1969),
    [anon_sym_enum] = ACTIONS(1969),
    [anon_sym_struct] = ACTIONS(1969),
    [anon_sym_union] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1969),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1969),
    [sym_auto] = ACTIONS(1969),
    [anon_sym_typename] = ACTIONS(1969),
    [anon_sym_template] = ACTIONS(1969),
    [anon_sym_namespace] = ACTIONS(1969),
    [anon_sym_using] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1967),
    [sym_operator_name] = ACTIONS(1967),
  },
  [1621] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4885),
    [sym_comment] = ACTIONS(49),
  },
  [1622] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2020),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2020),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [sym_operator_name] = ACTIONS(2018),
  },
  [1623] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4887),
    [sym_comment] = ACTIONS(49),
  },
  [1624] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2026),
    [sym_preproc_directive] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(2026),
    [anon_sym_extern] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_register] = ACTIONS(2026),
    [anon_sym_inline] = ACTIONS(2026),
    [anon_sym_const] = ACTIONS(2026),
    [anon_sym_restrict] = ACTIONS(2026),
    [anon_sym_volatile] = ACTIONS(2026),
    [anon_sym__Atomic] = ACTIONS(2026),
    [anon_sym_mutable] = ACTIONS(2026),
    [anon_sym_explicit] = ACTIONS(2026),
    [anon_sym_constexpr] = ACTIONS(2026),
    [anon_sym_unsigned] = ACTIONS(2026),
    [anon_sym_long] = ACTIONS(2026),
    [anon_sym_short] = ACTIONS(2026),
    [sym_primitive_type] = ACTIONS(2026),
    [anon_sym_enum] = ACTIONS(2026),
    [anon_sym_struct] = ACTIONS(2026),
    [anon_sym_union] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_TILDE] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2026),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2026),
    [sym_auto] = ACTIONS(2026),
    [anon_sym_typename] = ACTIONS(2026),
    [anon_sym_template] = ACTIONS(2026),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_using] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2024),
    [sym_operator_name] = ACTIONS(2024),
  },
  [1625] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4889),
    [sym_comment] = ACTIONS(49),
  },
  [1626] = {
    [sym_preproc_arg] = ACTIONS(4891),
    [sym_comment] = ACTIONS(83),
  },
  [1627] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_using] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [sym_operator_name] = ACTIONS(857),
  },
  [1628] = {
    [anon_sym_LF] = ACTIONS(4893),
    [sym_preproc_arg] = ACTIONS(4895),
    [sym_comment] = ACTIONS(83),
  },
  [1629] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(891),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(891),
    [sym_preproc_directive] = ACTIONS(891),
    [anon_sym_typedef] = ACTIONS(891),
    [anon_sym_extern] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_register] = ACTIONS(891),
    [anon_sym_inline] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_restrict] = ACTIONS(891),
    [anon_sym_volatile] = ACTIONS(891),
    [anon_sym__Atomic] = ACTIONS(891),
    [anon_sym_mutable] = ACTIONS(891),
    [anon_sym_explicit] = ACTIONS(891),
    [anon_sym_constexpr] = ACTIONS(891),
    [anon_sym_unsigned] = ACTIONS(891),
    [anon_sym_long] = ACTIONS(891),
    [anon_sym_short] = ACTIONS(891),
    [sym_primitive_type] = ACTIONS(891),
    [anon_sym_enum] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(891),
    [anon_sym_union] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(889),
    [sym_identifier] = ACTIONS(891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(891),
    [sym_auto] = ACTIONS(891),
    [anon_sym_typename] = ACTIONS(891),
    [anon_sym_template] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_using] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(889),
    [sym_operator_name] = ACTIONS(889),
  },
  [1630] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4897),
    [sym_comment] = ACTIONS(49),
  },
  [1631] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(2176),
    [sym_preproc_elif] = STATE(2176),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4899),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1632] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(953),
    [sym_preproc_directive] = ACTIONS(953),
    [anon_sym_typedef] = ACTIONS(953),
    [anon_sym_extern] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_register] = ACTIONS(953),
    [anon_sym_inline] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_restrict] = ACTIONS(953),
    [anon_sym_volatile] = ACTIONS(953),
    [anon_sym__Atomic] = ACTIONS(953),
    [anon_sym_mutable] = ACTIONS(953),
    [anon_sym_explicit] = ACTIONS(953),
    [anon_sym_constexpr] = ACTIONS(953),
    [anon_sym_unsigned] = ACTIONS(953),
    [anon_sym_long] = ACTIONS(953),
    [anon_sym_short] = ACTIONS(953),
    [sym_primitive_type] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [anon_sym_struct] = ACTIONS(953),
    [anon_sym_union] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(953),
    [sym_auto] = ACTIONS(953),
    [anon_sym_typename] = ACTIONS(953),
    [anon_sym_template] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(953),
    [anon_sym_using] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(951),
    [sym_operator_name] = ACTIONS(951),
  },
  [1633] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4901),
    [sym_comment] = ACTIONS(49),
  },
  [1634] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(2178),
    [sym_preproc_elif] = STATE(2178),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4903),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1635] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(961),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(961),
    [sym_preproc_directive] = ACTIONS(961),
    [anon_sym_typedef] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_static] = ACTIONS(961),
    [anon_sym_register] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_restrict] = ACTIONS(961),
    [anon_sym_volatile] = ACTIONS(961),
    [anon_sym__Atomic] = ACTIONS(961),
    [anon_sym_mutable] = ACTIONS(961),
    [anon_sym_explicit] = ACTIONS(961),
    [anon_sym_constexpr] = ACTIONS(961),
    [anon_sym_unsigned] = ACTIONS(961),
    [anon_sym_long] = ACTIONS(961),
    [anon_sym_short] = ACTIONS(961),
    [sym_primitive_type] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_identifier] = ACTIONS(961),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(961),
    [sym_auto] = ACTIONS(961),
    [anon_sym_typename] = ACTIONS(961),
    [anon_sym_template] = ACTIONS(961),
    [anon_sym_namespace] = ACTIONS(961),
    [anon_sym_using] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [sym_operator_name] = ACTIONS(959),
  },
  [1636] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4905),
    [sym_comment] = ACTIONS(49),
  },
  [1637] = {
    [sym_preproc_include] = STATE(507),
    [sym_preproc_def] = STATE(507),
    [sym_preproc_function_def] = STATE(507),
    [sym_preproc_call] = STATE(507),
    [sym_preproc_if] = STATE(507),
    [sym_preproc_ifdef] = STATE(507),
    [sym_preproc_else] = STATE(2180),
    [sym_preproc_elif] = STATE(2180),
    [sym_function_definition] = STATE(507),
    [sym_declaration] = STATE(507),
    [sym_type_definition] = STATE(507),
    [sym__declaration_specifiers] = STATE(181),
    [sym_linkage_specification] = STATE(507),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(182),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(185),
    [sym_type_qualifier] = STATE(185),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(507),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(507),
    [sym_template_declaration] = STATE(507),
    [sym_template_instantiation] = STATE(507),
    [sym_constructor_or_destructor_definition] = STATE(183),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(507),
    [sym_using_declaration] = STATE(507),
    [sym_alias_declaration] = STATE(507),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(507),
    [aux_sym__declaration_specifiers_repeat1] = STATE(185),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(285),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4907),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(295),
    [sym_preproc_directive] = ACTIONS(297),
    [anon_sym_typedef] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(303),
    [anon_sym_namespace] = ACTIONS(305),
    [anon_sym_using] = ACTIONS(307),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1638] = {
    [anon_sym_LF] = ACTIONS(4909),
    [sym_comment] = ACTIONS(83),
  },
  [1639] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1640] = {
    [sym__type_declarator] = STATE(2183),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [1641] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [sym_preproc_directive] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_register] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_restrict] = ACTIONS(1021),
    [anon_sym_volatile] = ACTIONS(1021),
    [anon_sym__Atomic] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1021),
    [anon_sym_explicit] = ACTIONS(1021),
    [anon_sym_constexpr] = ACTIONS(1021),
    [anon_sym_unsigned] = ACTIONS(1021),
    [anon_sym_long] = ACTIONS(1021),
    [anon_sym_short] = ACTIONS(1021),
    [sym_primitive_type] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1021),
    [sym_auto] = ACTIONS(1021),
    [anon_sym_typename] = ACTIONS(1021),
    [anon_sym_template] = ACTIONS(1021),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_using] = ACTIONS(1021),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [sym_operator_name] = ACTIONS(1019),
  },
  [1642] = {
    [sym__declarator] = STATE(1010),
    [sym_pointer_declarator] = STATE(1010),
    [sym_function_declarator] = STATE(1010),
    [sym_array_declarator] = STATE(1010),
    [sym_init_declarator] = STATE(1011),
    [sym_reference_declarator] = STATE(1010),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1010),
    [sym_destructor_name] = STATE(1010),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1943),
  },
  [1643] = {
    [sym_parameter_list] = STATE(320),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(216),
    [sym_comment] = ACTIONS(49),
  },
  [1644] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1242),
    [sym_preproc_directive] = ACTIONS(1242),
    [anon_sym_typedef] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_register] = ACTIONS(1242),
    [anon_sym_inline] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_restrict] = ACTIONS(1242),
    [anon_sym_volatile] = ACTIONS(1242),
    [anon_sym__Atomic] = ACTIONS(1242),
    [anon_sym_mutable] = ACTIONS(1242),
    [anon_sym_explicit] = ACTIONS(1242),
    [anon_sym_constexpr] = ACTIONS(1242),
    [anon_sym_unsigned] = ACTIONS(1242),
    [anon_sym_long] = ACTIONS(1242),
    [anon_sym_short] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1242),
    [sym_auto] = ACTIONS(1242),
    [anon_sym_typename] = ACTIONS(1242),
    [anon_sym_template] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(1242),
    [anon_sym_using] = ACTIONS(1242),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [sym_operator_name] = ACTIONS(1240),
  },
  [1645] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_typedef] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1248),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_register] = ACTIONS(1250),
    [anon_sym_inline] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_restrict] = ACTIONS(1250),
    [anon_sym_volatile] = ACTIONS(1250),
    [anon_sym__Atomic] = ACTIONS(1250),
    [anon_sym_mutable] = ACTIONS(1250),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_constexpr] = ACTIONS(1250),
    [anon_sym_unsigned] = ACTIONS(1250),
    [anon_sym_long] = ACTIONS(1250),
    [anon_sym_short] = ACTIONS(1250),
    [sym_primitive_type] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1250),
    [sym_auto] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(1250),
    [anon_sym_template] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [sym_operator_name] = ACTIONS(1248),
  },
  [1646] = {
    [sym__declarator] = STATE(1010),
    [sym_pointer_declarator] = STATE(1010),
    [sym_function_declarator] = STATE(1010),
    [sym_array_declarator] = STATE(1010),
    [sym_init_declarator] = STATE(1011),
    [sym_reference_declarator] = STATE(1010),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(1010),
    [sym_destructor_name] = STATE(1010),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(1943),
  },
  [1647] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym_mutable] = ACTIONS(1269),
    [anon_sym_explicit] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1269),
    [sym_auto] = ACTIONS(1269),
    [anon_sym_typename] = ACTIONS(1269),
    [anon_sym_template] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_using] = ACTIONS(1269),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_operator_name] = ACTIONS(1267),
  },
  [1648] = {
    [sym_preproc_include] = STATE(671),
    [sym_preproc_def] = STATE(671),
    [sym_preproc_function_def] = STATE(671),
    [sym_preproc_call] = STATE(671),
    [sym_preproc_if] = STATE(671),
    [sym_preproc_ifdef] = STATE(671),
    [sym_function_definition] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_type_definition] = STATE(671),
    [sym__declaration_specifiers] = STATE(27),
    [sym_linkage_specification] = STATE(671),
    [sym__declarator] = STATE(28),
    [sym_pointer_declarator] = STATE(28),
    [sym_function_declarator] = STATE(29),
    [sym_array_declarator] = STATE(28),
    [sym_storage_class_specifier] = STATE(37),
    [sym_type_qualifier] = STATE(37),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym__empty_declaration] = STATE(671),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(671),
    [sym_template_declaration] = STATE(671),
    [sym_template_instantiation] = STATE(671),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(28),
    [sym_template_type] = STATE(32),
    [sym_template_function] = STATE(28),
    [sym_namespace_definition] = STATE(671),
    [sym_using_declaration] = STATE(671),
    [sym_alias_declaration] = STATE(671),
    [sym_destructor_name] = STATE(28),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(35),
    [aux_sym_translation_unit_repeat1] = STATE(671),
    [aux_sym__declaration_specifiers_repeat1] = STATE(37),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_template] = ACTIONS(55),
    [anon_sym_namespace] = ACTIONS(57),
    [anon_sym_using] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [sym_operator_name] = ACTIONS(63),
  },
  [1649] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1275),
    [sym_preproc_directive] = ACTIONS(1275),
    [anon_sym_typedef] = ACTIONS(1275),
    [anon_sym_extern] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1275),
    [anon_sym_register] = ACTIONS(1275),
    [anon_sym_inline] = ACTIONS(1275),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_restrict] = ACTIONS(1275),
    [anon_sym_volatile] = ACTIONS(1275),
    [anon_sym__Atomic] = ACTIONS(1275),
    [anon_sym_mutable] = ACTIONS(1275),
    [anon_sym_explicit] = ACTIONS(1275),
    [anon_sym_constexpr] = ACTIONS(1275),
    [anon_sym_unsigned] = ACTIONS(1275),
    [anon_sym_long] = ACTIONS(1275),
    [anon_sym_short] = ACTIONS(1275),
    [sym_primitive_type] = ACTIONS(1275),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_struct] = ACTIONS(1275),
    [anon_sym_union] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_identifier] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1275),
    [sym_auto] = ACTIONS(1275),
    [anon_sym_typename] = ACTIONS(1275),
    [anon_sym_template] = ACTIONS(1275),
    [anon_sym_namespace] = ACTIONS(1275),
    [anon_sym_using] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1273),
    [sym_operator_name] = ACTIONS(1273),
  },
  [1650] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1279),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1279),
    [sym_preproc_directive] = ACTIONS(1279),
    [anon_sym_typedef] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1279),
    [anon_sym_register] = ACTIONS(1279),
    [anon_sym_inline] = ACTIONS(1279),
    [anon_sym_const] = ACTIONS(1279),
    [anon_sym_restrict] = ACTIONS(1279),
    [anon_sym_volatile] = ACTIONS(1279),
    [anon_sym__Atomic] = ACTIONS(1279),
    [anon_sym_mutable] = ACTIONS(1279),
    [anon_sym_explicit] = ACTIONS(1279),
    [anon_sym_constexpr] = ACTIONS(1279),
    [anon_sym_unsigned] = ACTIONS(1279),
    [anon_sym_long] = ACTIONS(1279),
    [anon_sym_short] = ACTIONS(1279),
    [sym_primitive_type] = ACTIONS(1279),
    [anon_sym_enum] = ACTIONS(1279),
    [anon_sym_struct] = ACTIONS(1279),
    [anon_sym_union] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_TILDE] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1279),
    [sym_auto] = ACTIONS(1279),
    [anon_sym_typename] = ACTIONS(1279),
    [anon_sym_template] = ACTIONS(1279),
    [anon_sym_namespace] = ACTIONS(1279),
    [anon_sym_using] = ACTIONS(1279),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_operator_name] = ACTIONS(1277),
  },
  [1651] = {
    [sym_type_qualifier] = STATE(675),
    [sym__type_specifier] = STATE(673),
    [sym_sized_type_specifier] = STATE(673),
    [sym_enum_specifier] = STATE(673),
    [sym_struct_specifier] = STATE(673),
    [sym_union_specifier] = STATE(673),
    [sym_type_descriptor] = STATE(2186),
    [sym_macro_type_specifier] = STATE(673),
    [sym_class_specifier] = STATE(673),
    [sym_dependent_type] = STATE(673),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(675),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1283),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1652] = {
    [sym_template_argument_list] = STATE(212),
    [anon_sym_SEMI] = ACTIONS(4917),
    [anon_sym_LT] = ACTIONS(150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(533),
  },
  [1653] = {
    [anon_sym_SEMI] = ACTIONS(4917),
    [sym_comment] = ACTIONS(49),
  },
  [1654] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_template] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [sym_operator_name] = ACTIONS(1311),
  },
  [1655] = {
    [sym_preproc_include] = STATE(1663),
    [sym_preproc_def] = STATE(1663),
    [sym_preproc_function_def] = STATE(1663),
    [sym_preproc_call] = STATE(1663),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1663),
    [sym_type_definition] = STATE(1663),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1663),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1663),
    [sym_expression_statement] = STATE(1663),
    [sym_if_statement] = STATE(1663),
    [sym_switch_statement] = STATE(1663),
    [sym_case_statement] = STATE(1663),
    [sym_while_statement] = STATE(1663),
    [sym_do_statement] = STATE(1663),
    [sym_for_statement] = STATE(1663),
    [sym_return_statement] = STATE(1663),
    [sym_break_statement] = STATE(1663),
    [sym_continue_statement] = STATE(1663),
    [sym_goto_statement] = STATE(1663),
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(706),
    [sym__empty_declaration] = STATE(1663),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1663),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(706),
    [sym_for_range_loop] = STATE(1663),
    [sym_new_expression] = STATE(706),
    [sym_delete_expression] = STATE(706),
    [sym_lambda_expression] = STATE(706),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1663),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1315),
    [sym_char_literal] = ACTIONS(1315),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1343),
  },
  [1656] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym_mutable] = ACTIONS(1357),
    [anon_sym_explicit] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1357),
    [sym_auto] = ACTIONS(1357),
    [anon_sym_typename] = ACTIONS(1357),
    [anon_sym_template] = ACTIONS(1357),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_using] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1355),
    [sym_operator_name] = ACTIONS(1355),
  },
  [1657] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(4921),
    [sym_comment] = ACTIONS(49),
  },
  [1658] = {
    [sym__expression] = STATE(2190),
    [sym_conditional_expression] = STATE(2190),
    [sym_assignment_expression] = STATE(2190),
    [sym_pointer_expression] = STATE(2190),
    [sym_logical_expression] = STATE(2190),
    [sym_bitwise_expression] = STATE(2190),
    [sym_equality_expression] = STATE(2190),
    [sym_relational_expression] = STATE(2190),
    [sym_shift_expression] = STATE(2190),
    [sym_math_expression] = STATE(2190),
    [sym_cast_expression] = STATE(2190),
    [sym_sizeof_expression] = STATE(2190),
    [sym_subscript_expression] = STATE(2190),
    [sym_call_expression] = STATE(2190),
    [sym_field_expression] = STATE(2190),
    [sym_compound_literal_expression] = STATE(2190),
    [sym_parenthesized_expression] = STATE(2190),
    [sym_initializer_list] = STATE(2191),
    [sym_concatenated_string] = STATE(2190),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2190),
    [sym_new_expression] = STATE(2190),
    [sym_delete_expression] = STATE(2190),
    [sym_lambda_expression] = STATE(2190),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4923),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4923),
    [sym_char_literal] = ACTIONS(4923),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4925),
    [sym_false] = ACTIONS(4925),
    [sym_null] = ACTIONS(4925),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4925),
  },
  [1659] = {
    [anon_sym_SEMI] = ACTIONS(4927),
    [sym_comment] = ACTIONS(49),
  },
  [1660] = {
    [sym__expression] = STATE(2193),
    [sym_conditional_expression] = STATE(2193),
    [sym_assignment_expression] = STATE(2193),
    [sym_pointer_expression] = STATE(2193),
    [sym_logical_expression] = STATE(2193),
    [sym_bitwise_expression] = STATE(2193),
    [sym_equality_expression] = STATE(2193),
    [sym_relational_expression] = STATE(2193),
    [sym_shift_expression] = STATE(2193),
    [sym_math_expression] = STATE(2193),
    [sym_cast_expression] = STATE(2193),
    [sym_sizeof_expression] = STATE(2193),
    [sym_subscript_expression] = STATE(2193),
    [sym_call_expression] = STATE(2193),
    [sym_field_expression] = STATE(2193),
    [sym_compound_literal_expression] = STATE(2193),
    [sym_parenthesized_expression] = STATE(2193),
    [sym_initializer_list] = STATE(2194),
    [sym_concatenated_string] = STATE(2193),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2193),
    [sym_new_expression] = STATE(2193),
    [sym_delete_expression] = STATE(2193),
    [sym_lambda_expression] = STATE(2193),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4929),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4929),
    [sym_char_literal] = ACTIONS(4929),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4931),
    [sym_false] = ACTIONS(4931),
    [sym_null] = ACTIONS(4931),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4931),
  },
  [1661] = {
    [anon_sym_SEMI] = ACTIONS(4933),
    [sym_comment] = ACTIONS(49),
  },
  [1662] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [1663] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [1664] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1848),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1848),
    [sym_preproc_directive] = ACTIONS(1848),
    [anon_sym_typedef] = ACTIONS(1848),
    [anon_sym_extern] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_register] = ACTIONS(1848),
    [anon_sym_inline] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_restrict] = ACTIONS(1848),
    [anon_sym_volatile] = ACTIONS(1848),
    [anon_sym__Atomic] = ACTIONS(1848),
    [anon_sym_mutable] = ACTIONS(1848),
    [anon_sym_explicit] = ACTIONS(1848),
    [anon_sym_constexpr] = ACTIONS(1848),
    [anon_sym_unsigned] = ACTIONS(1848),
    [anon_sym_long] = ACTIONS(1848),
    [anon_sym_short] = ACTIONS(1848),
    [sym_primitive_type] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_struct] = ACTIONS(1848),
    [anon_sym_union] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1848),
    [sym_auto] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1848),
    [anon_sym_template] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1848),
    [anon_sym_using] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1846),
    [sym_operator_name] = ACTIONS(1846),
  },
  [1665] = {
    [sym_compound_statement] = STATE(2197),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(49),
  },
  [1666] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4937),
    [sym_comment] = ACTIONS(49),
  },
  [1667] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [sym_operator_name] = ACTIONS(2030),
  },
  [1668] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_template] = ACTIONS(2054),
    [anon_sym_namespace] = ACTIONS(2054),
    [anon_sym_using] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [sym_operator_name] = ACTIONS(2052),
  },
  [1669] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1670] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2414),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [sym_operator_name] = ACTIONS(2412),
  },
  [1671] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2429),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [sym_operator_name] = ACTIONS(2427),
  },
  [1672] = {
    [anon_sym_SEMI] = ACTIONS(4941),
    [sym_comment] = ACTIONS(49),
  },
  [1673] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2445),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [sym_operator_name] = ACTIONS(2443),
  },
  [1674] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(2472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [1675] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [sym_operator_name] = ACTIONS(2550),
  },
  [1676] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1677] = {
    [anon_sym_SEMI] = ACTIONS(4943),
    [sym_comment] = ACTIONS(49),
  },
  [1678] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [sym_operator_name] = ACTIONS(2653),
  },
  [1679] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1680] = {
    [anon_sym_SEMI] = ACTIONS(4945),
    [sym_comment] = ACTIONS(49),
  },
  [1681] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [sym_operator_name] = ACTIONS(2659),
  },
  [1682] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [sym_operator_name] = ACTIONS(3274),
  },
  [1683] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3432),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3432),
    [sym_preproc_directive] = ACTIONS(3432),
    [anon_sym_typedef] = ACTIONS(3432),
    [anon_sym_extern] = ACTIONS(3432),
    [anon_sym_STAR] = ACTIONS(3430),
    [anon_sym_static] = ACTIONS(3432),
    [anon_sym_register] = ACTIONS(3432),
    [anon_sym_inline] = ACTIONS(3432),
    [anon_sym_const] = ACTIONS(3432),
    [anon_sym_restrict] = ACTIONS(3432),
    [anon_sym_volatile] = ACTIONS(3432),
    [anon_sym__Atomic] = ACTIONS(3432),
    [anon_sym_mutable] = ACTIONS(3432),
    [anon_sym_explicit] = ACTIONS(3432),
    [anon_sym_constexpr] = ACTIONS(3432),
    [anon_sym_unsigned] = ACTIONS(3432),
    [anon_sym_long] = ACTIONS(3432),
    [anon_sym_short] = ACTIONS(3432),
    [sym_primitive_type] = ACTIONS(3432),
    [anon_sym_enum] = ACTIONS(3432),
    [anon_sym_struct] = ACTIONS(3432),
    [anon_sym_union] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_TILDE] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3432),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3432),
    [sym_auto] = ACTIONS(3432),
    [anon_sym_typename] = ACTIONS(3432),
    [anon_sym_template] = ACTIONS(3432),
    [anon_sym_namespace] = ACTIONS(3432),
    [anon_sym_using] = ACTIONS(3432),
    [anon_sym_COLON_COLON] = ACTIONS(3430),
    [sym_operator_name] = ACTIONS(3430),
  },
  [1684] = {
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3633),
    [sym_comment] = ACTIONS(49),
  },
  [1685] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1686] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_COLON] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
  },
  [1687] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(4949),
    [sym_comment] = ACTIONS(49),
  },
  [1688] = {
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_STAR] = ACTIONS(3774),
    [sym_identifier] = ACTIONS(3774),
    [sym_comment] = ACTIONS(49),
  },
  [1689] = {
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
  },
  [1690] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3880),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
  },
  [1691] = {
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3889),
    [sym_identifier] = ACTIONS(3889),
    [sym_comment] = ACTIONS(49),
  },
  [1692] = {
    [anon_sym_LPAREN] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [sym_comment] = ACTIONS(49),
  },
  [1693] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1694] = {
    [sym__abstract_declarator] = STATE(2205),
    [sym_abstract_pointer_declarator] = STATE(2205),
    [sym_abstract_function_declarator] = STATE(2205),
    [sym_abstract_array_declarator] = STATE(2205),
    [sym_parameter_list] = STATE(1697),
    [sym_abstract_reference_declarator] = STATE(2205),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [1695] = {
    [sym__abstract_declarator] = STATE(2206),
    [sym_abstract_pointer_declarator] = STATE(2206),
    [sym_abstract_function_declarator] = STATE(2206),
    [sym_abstract_array_declarator] = STATE(2206),
    [sym_parameter_list] = STATE(1697),
    [sym_abstract_reference_declarator] = STATE(2206),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [1696] = {
    [sym_parameter_list] = STATE(2207),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [1697] = {
    [sym_type_qualifier] = STATE(2208),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2208),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [1698] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1698),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(4955),
    [anon_sym_long] = ACTIONS(4955),
    [anon_sym_short] = ACTIONS(4955),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [1699] = {
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_RPAREN] = ACTIONS(4958),
    [anon_sym_SEMI] = ACTIONS(4958),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_COLON] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_GT] = ACTIONS(4958),
    [sym_identifier] = ACTIONS(4960),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [sym_operator_name] = ACTIONS(4958),
  },
  [1700] = {
    [sym_enumerator] = STATE(1079),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1701] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(2209),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(2209),
    [sym_field_declaration] = STATE(2209),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(2209),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(2209),
    [sym_access_specifier] = STATE(2209),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(2209),
    [sym_alias_declaration] = STATE(2209),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2209),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4962),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1702] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(2210),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2211),
    [sym_type_definition] = STATE(2212),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(2212),
    [sym_field_declaration] = STATE(2212),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(2212),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(2212),
    [sym_access_specifier] = STATE(2212),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(2212),
    [sym_alias_declaration] = STATE(2212),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2212),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4964),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1703] = {
    [anon_sym_LPAREN] = ACTIONS(4966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4968),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4966),
    [anon_sym_typedef] = ACTIONS(4968),
    [anon_sym_extern] = ACTIONS(4968),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_STAR] = ACTIONS(4966),
    [anon_sym_static] = ACTIONS(4968),
    [anon_sym_register] = ACTIONS(4968),
    [anon_sym_inline] = ACTIONS(4968),
    [anon_sym_const] = ACTIONS(4968),
    [anon_sym_restrict] = ACTIONS(4968),
    [anon_sym_volatile] = ACTIONS(4968),
    [anon_sym__Atomic] = ACTIONS(4968),
    [anon_sym_mutable] = ACTIONS(4968),
    [anon_sym_explicit] = ACTIONS(4968),
    [anon_sym_constexpr] = ACTIONS(4968),
    [anon_sym_unsigned] = ACTIONS(4968),
    [anon_sym_long] = ACTIONS(4968),
    [anon_sym_short] = ACTIONS(4968),
    [sym_primitive_type] = ACTIONS(4968),
    [anon_sym_enum] = ACTIONS(4968),
    [anon_sym_struct] = ACTIONS(4968),
    [anon_sym_union] = ACTIONS(4968),
    [anon_sym_AMP] = ACTIONS(4968),
    [anon_sym_AMP_AMP] = ACTIONS(4966),
    [anon_sym_TILDE] = ACTIONS(4966),
    [sym_identifier] = ACTIONS(4968),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4968),
    [anon_sym_public] = ACTIONS(4968),
    [sym_auto] = ACTIONS(4968),
    [anon_sym_typename] = ACTIONS(4968),
    [anon_sym_template] = ACTIONS(4968),
    [anon_sym_friend] = ACTIONS(4968),
    [anon_sym_private] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(4968),
    [anon_sym_using] = ACTIONS(4968),
    [anon_sym_COLON_COLON] = ACTIONS(4966),
    [sym_operator_name] = ACTIONS(4966),
  },
  [1704] = {
    [anon_sym_LPAREN] = ACTIONS(4970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4970),
    [anon_sym_typedef] = ACTIONS(4972),
    [anon_sym_extern] = ACTIONS(4972),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_STAR] = ACTIONS(4970),
    [anon_sym_static] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4972),
    [anon_sym_inline] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4972),
    [anon_sym_restrict] = ACTIONS(4972),
    [anon_sym_volatile] = ACTIONS(4972),
    [anon_sym__Atomic] = ACTIONS(4972),
    [anon_sym_mutable] = ACTIONS(4972),
    [anon_sym_explicit] = ACTIONS(4972),
    [anon_sym_constexpr] = ACTIONS(4972),
    [anon_sym_unsigned] = ACTIONS(4972),
    [anon_sym_long] = ACTIONS(4972),
    [anon_sym_short] = ACTIONS(4972),
    [sym_primitive_type] = ACTIONS(4972),
    [anon_sym_enum] = ACTIONS(4972),
    [anon_sym_struct] = ACTIONS(4972),
    [anon_sym_union] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4970),
    [sym_identifier] = ACTIONS(4972),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4972),
    [anon_sym_public] = ACTIONS(4972),
    [sym_auto] = ACTIONS(4972),
    [anon_sym_typename] = ACTIONS(4972),
    [anon_sym_template] = ACTIONS(4972),
    [anon_sym_friend] = ACTIONS(4972),
    [anon_sym_private] = ACTIONS(4972),
    [anon_sym_protected] = ACTIONS(4972),
    [anon_sym_using] = ACTIONS(4972),
    [anon_sym_COLON_COLON] = ACTIONS(4970),
    [sym_operator_name] = ACTIONS(4970),
  },
  [1705] = {
    [anon_sym_LPAREN] = ACTIONS(4974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4976),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4974),
    [anon_sym_typedef] = ACTIONS(4976),
    [anon_sym_extern] = ACTIONS(4976),
    [anon_sym_RBRACE] = ACTIONS(4974),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4976),
    [anon_sym_register] = ACTIONS(4976),
    [anon_sym_inline] = ACTIONS(4976),
    [anon_sym_const] = ACTIONS(4976),
    [anon_sym_restrict] = ACTIONS(4976),
    [anon_sym_volatile] = ACTIONS(4976),
    [anon_sym__Atomic] = ACTIONS(4976),
    [anon_sym_mutable] = ACTIONS(4976),
    [anon_sym_explicit] = ACTIONS(4976),
    [anon_sym_constexpr] = ACTIONS(4976),
    [anon_sym_unsigned] = ACTIONS(4976),
    [anon_sym_long] = ACTIONS(4976),
    [anon_sym_short] = ACTIONS(4976),
    [sym_primitive_type] = ACTIONS(4976),
    [anon_sym_enum] = ACTIONS(4976),
    [anon_sym_struct] = ACTIONS(4976),
    [anon_sym_union] = ACTIONS(4976),
    [anon_sym_AMP] = ACTIONS(4976),
    [anon_sym_AMP_AMP] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4976),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4976),
    [anon_sym_public] = ACTIONS(4976),
    [sym_auto] = ACTIONS(4976),
    [anon_sym_typename] = ACTIONS(4976),
    [anon_sym_template] = ACTIONS(4976),
    [anon_sym_friend] = ACTIONS(4976),
    [anon_sym_private] = ACTIONS(4976),
    [anon_sym_protected] = ACTIONS(4976),
    [anon_sym_using] = ACTIONS(4976),
    [anon_sym_COLON_COLON] = ACTIONS(4974),
    [sym_operator_name] = ACTIONS(4974),
  },
  [1706] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4978),
    [sym_comment] = ACTIONS(49),
  },
  [1707] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4980),
    [sym_comment] = ACTIONS(49),
  },
  [1708] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(1708),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1708),
    [sym_field_declaration] = STATE(1708),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1708),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1708),
    [sym_access_specifier] = STATE(1708),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1708),
    [sym_alias_declaration] = STATE(1708),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1708),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2188),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2191),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2200),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_restrict] = ACTIONS(2205),
    [anon_sym_volatile] = ACTIONS(2205),
    [anon_sym__Atomic] = ACTIONS(2205),
    [anon_sym_mutable] = ACTIONS(2205),
    [anon_sym_explicit] = ACTIONS(2205),
    [anon_sym_constexpr] = ACTIONS(2205),
    [anon_sym_unsigned] = ACTIONS(2208),
    [anon_sym_long] = ACTIONS(2208),
    [anon_sym_short] = ACTIONS(2208),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2217),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2238),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2241),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_friend] = ACTIONS(2247),
    [anon_sym_private] = ACTIONS(2238),
    [anon_sym_protected] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [sym_operator_name] = ACTIONS(2256),
  },
  [1709] = {
    [anon_sym_LPAREN] = ACTIONS(4982),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4984),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4982),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4982),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4982),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4982),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4982),
    [anon_sym_typedef] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_explicit] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [sym_primitive_type] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4984),
    [anon_sym_union] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4984),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_public] = ACTIONS(4984),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_friend] = ACTIONS(4984),
    [anon_sym_private] = ACTIONS(4984),
    [anon_sym_protected] = ACTIONS(4984),
    [anon_sym_using] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [sym_operator_name] = ACTIONS(4982),
  },
  [1710] = {
    [anon_sym_LPAREN] = ACTIONS(4986),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4988),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4986),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4986),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4986),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4986),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4986),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [sym_primitive_type] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [sym_operator_name] = ACTIONS(4986),
  },
  [1711] = {
    [anon_sym_LPAREN] = ACTIONS(4990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4990),
    [anon_sym_typedef] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_explicit] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [sym_primitive_type] = ACTIONS(4992),
    [anon_sym_enum] = ACTIONS(4992),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [sym_identifier] = ACTIONS(4992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4992),
    [anon_sym_public] = ACTIONS(4992),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_typename] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_friend] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_using] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [sym_operator_name] = ACTIONS(4990),
  },
  [1712] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4994),
    [sym_comment] = ACTIONS(49),
  },
  [1713] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4996),
    [sym_comment] = ACTIONS(49),
  },
  [1714] = {
    [anon_sym_LPAREN] = ACTIONS(4998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5000),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4998),
    [anon_sym_typedef] = ACTIONS(5000),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_STAR] = ACTIONS(4998),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(5000),
    [anon_sym_restrict] = ACTIONS(5000),
    [anon_sym_volatile] = ACTIONS(5000),
    [anon_sym__Atomic] = ACTIONS(5000),
    [anon_sym_mutable] = ACTIONS(5000),
    [anon_sym_explicit] = ACTIONS(5000),
    [anon_sym_constexpr] = ACTIONS(5000),
    [anon_sym_unsigned] = ACTIONS(5000),
    [anon_sym_long] = ACTIONS(5000),
    [anon_sym_short] = ACTIONS(5000),
    [sym_primitive_type] = ACTIONS(5000),
    [anon_sym_enum] = ACTIONS(5000),
    [anon_sym_struct] = ACTIONS(5000),
    [anon_sym_union] = ACTIONS(5000),
    [anon_sym_AMP] = ACTIONS(5000),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_TILDE] = ACTIONS(4998),
    [sym_identifier] = ACTIONS(5000),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(5000),
    [sym_auto] = ACTIONS(5000),
    [anon_sym_typename] = ACTIONS(5000),
    [anon_sym_template] = ACTIONS(5000),
    [anon_sym_friend] = ACTIONS(5000),
    [anon_sym_private] = ACTIONS(5000),
    [anon_sym_protected] = ACTIONS(5000),
    [anon_sym_using] = ACTIONS(5000),
    [anon_sym_COLON_COLON] = ACTIONS(4998),
    [sym_operator_name] = ACTIONS(4998),
  },
  [1715] = {
    [anon_sym_LPAREN] = ACTIONS(5002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5004),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5002),
    [anon_sym_typedef] = ACTIONS(5004),
    [anon_sym_extern] = ACTIONS(5004),
    [anon_sym_RBRACE] = ACTIONS(5002),
    [anon_sym_STAR] = ACTIONS(5002),
    [anon_sym_static] = ACTIONS(5004),
    [anon_sym_register] = ACTIONS(5004),
    [anon_sym_inline] = ACTIONS(5004),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5004),
    [anon_sym_volatile] = ACTIONS(5004),
    [anon_sym__Atomic] = ACTIONS(5004),
    [anon_sym_mutable] = ACTIONS(5004),
    [anon_sym_explicit] = ACTIONS(5004),
    [anon_sym_constexpr] = ACTIONS(5004),
    [anon_sym_unsigned] = ACTIONS(5004),
    [anon_sym_long] = ACTIONS(5004),
    [anon_sym_short] = ACTIONS(5004),
    [sym_primitive_type] = ACTIONS(5004),
    [anon_sym_enum] = ACTIONS(5004),
    [anon_sym_struct] = ACTIONS(5004),
    [anon_sym_union] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(5004),
    [anon_sym_AMP_AMP] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_identifier] = ACTIONS(5004),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5004),
    [anon_sym_public] = ACTIONS(5004),
    [sym_auto] = ACTIONS(5004),
    [anon_sym_typename] = ACTIONS(5004),
    [anon_sym_template] = ACTIONS(5004),
    [anon_sym_friend] = ACTIONS(5004),
    [anon_sym_private] = ACTIONS(5004),
    [anon_sym_protected] = ACTIONS(5004),
    [anon_sym_using] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5002),
    [sym_operator_name] = ACTIONS(5002),
  },
  [1716] = {
    [anon_sym_LPAREN] = ACTIONS(5006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5008),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5006),
    [anon_sym_typedef] = ACTIONS(5008),
    [anon_sym_extern] = ACTIONS(5008),
    [anon_sym_RBRACE] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_static] = ACTIONS(5008),
    [anon_sym_register] = ACTIONS(5008),
    [anon_sym_inline] = ACTIONS(5008),
    [anon_sym_const] = ACTIONS(5008),
    [anon_sym_restrict] = ACTIONS(5008),
    [anon_sym_volatile] = ACTIONS(5008),
    [anon_sym__Atomic] = ACTIONS(5008),
    [anon_sym_mutable] = ACTIONS(5008),
    [anon_sym_explicit] = ACTIONS(5008),
    [anon_sym_constexpr] = ACTIONS(5008),
    [anon_sym_unsigned] = ACTIONS(5008),
    [anon_sym_long] = ACTIONS(5008),
    [anon_sym_short] = ACTIONS(5008),
    [sym_primitive_type] = ACTIONS(5008),
    [anon_sym_enum] = ACTIONS(5008),
    [anon_sym_struct] = ACTIONS(5008),
    [anon_sym_union] = ACTIONS(5008),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_AMP_AMP] = ACTIONS(5006),
    [anon_sym_TILDE] = ACTIONS(5006),
    [sym_identifier] = ACTIONS(5008),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5008),
    [anon_sym_public] = ACTIONS(5008),
    [sym_auto] = ACTIONS(5008),
    [anon_sym_typename] = ACTIONS(5008),
    [anon_sym_template] = ACTIONS(5008),
    [anon_sym_friend] = ACTIONS(5008),
    [anon_sym_private] = ACTIONS(5008),
    [anon_sym_protected] = ACTIONS(5008),
    [anon_sym_using] = ACTIONS(5008),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [sym_operator_name] = ACTIONS(5006),
  },
  [1717] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5010),
    [sym_comment] = ACTIONS(49),
  },
  [1718] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5012),
    [sym_comment] = ACTIONS(49),
  },
  [1719] = {
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [anon_sym_public] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_template] = ACTIONS(2054),
    [anon_sym_friend] = ACTIONS(2054),
    [anon_sym_private] = ACTIONS(2054),
    [anon_sym_protected] = ACTIONS(2054),
    [anon_sym_using] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [sym_operator_name] = ACTIONS(2052),
  },
  [1720] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(5014),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [1721] = {
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(554),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [anon_sym_public] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_template] = ACTIONS(556),
    [anon_sym_friend] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_using] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [sym_operator_name] = ACTIONS(554),
  },
  [1722] = {
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [anon_sym_public] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_template] = ACTIONS(1313),
    [anon_sym_friend] = ACTIONS(1313),
    [anon_sym_private] = ACTIONS(1313),
    [anon_sym_protected] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [sym_operator_name] = ACTIONS(1311),
  },
  [1723] = {
    [sym_preproc_include] = STATE(1131),
    [sym_preproc_def] = STATE(1131),
    [sym_preproc_function_def] = STATE(1131),
    [sym_preproc_call] = STATE(1131),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(1131),
    [sym_type_definition] = STATE(1131),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(1131),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(1131),
    [sym_expression_statement] = STATE(1131),
    [sym_if_statement] = STATE(1131),
    [sym_switch_statement] = STATE(1131),
    [sym_case_statement] = STATE(1131),
    [sym_while_statement] = STATE(1131),
    [sym_do_statement] = STATE(1131),
    [sym_for_statement] = STATE(1131),
    [sym_return_statement] = STATE(1131),
    [sym_break_statement] = STATE(1131),
    [sym_continue_statement] = STATE(1131),
    [sym_goto_statement] = STATE(1131),
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_initializer_list] = STATE(707),
    [sym_initializer_pair] = STATE(707),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(706),
    [sym__empty_declaration] = STATE(1131),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(1131),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(706),
    [sym_for_range_loop] = STATE(1131),
    [sym_new_expression] = STATE(706),
    [sym_delete_expression] = STATE(706),
    [sym_lambda_expression] = STATE(706),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1131),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(1315),
    [sym_char_literal] = ACTIONS(1315),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(1343),
  },
  [1724] = {
    [anon_sym_LPAREN] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1355),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1355),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym_mutable] = ACTIONS(1357),
    [anon_sym_explicit] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1357),
    [anon_sym_public] = ACTIONS(1357),
    [sym_auto] = ACTIONS(1357),
    [anon_sym_typename] = ACTIONS(1357),
    [anon_sym_template] = ACTIONS(1357),
    [anon_sym_friend] = ACTIONS(1357),
    [anon_sym_private] = ACTIONS(1357),
    [anon_sym_protected] = ACTIONS(1357),
    [anon_sym_using] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1355),
    [sym_operator_name] = ACTIONS(1355),
  },
  [1725] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(5018),
    [sym_comment] = ACTIONS(49),
  },
  [1726] = {
    [anon_sym_SEMI] = ACTIONS(5020),
    [sym_comment] = ACTIONS(49),
  },
  [1727] = {
    [anon_sym_LPAREN] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2443),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_public] = ACTIONS(2445),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_friend] = ACTIONS(2445),
    [anon_sym_private] = ACTIONS(2445),
    [anon_sym_protected] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [sym_operator_name] = ACTIONS(2443),
  },
  [1728] = {
    [sym_parameter_list] = STATE(1731),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [sym_comment] = ACTIONS(49),
  },
  [1729] = {
    [sym_parameter_list] = STATE(1731),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [sym_comment] = ACTIONS(49),
  },
  [1730] = {
    [anon_sym_LPAREN] = ACTIONS(5022),
    [anon_sym_COMMA] = ACTIONS(5022),
    [anon_sym_RPAREN] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5022),
    [anon_sym_LBRACE] = ACTIONS(5022),
    [anon_sym_LBRACK] = ACTIONS(5022),
    [anon_sym_COLON] = ACTIONS(5022),
    [sym_comment] = ACTIONS(49),
  },
  [1731] = {
    [sym_type_qualifier] = STATE(2223),
    [sym_trailing_return_type] = STATE(2223),
    [aux_sym_function_declarator_repeat1] = STATE(2223),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_RPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5024),
  },
  [1732] = {
    [anon_sym_LPAREN] = ACTIONS(5026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5026),
    [anon_sym_typedef] = ACTIONS(5028),
    [anon_sym_extern] = ACTIONS(5028),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_static] = ACTIONS(5028),
    [anon_sym_register] = ACTIONS(5028),
    [anon_sym_inline] = ACTIONS(5028),
    [anon_sym_const] = ACTIONS(5028),
    [anon_sym_restrict] = ACTIONS(5028),
    [anon_sym_volatile] = ACTIONS(5028),
    [anon_sym__Atomic] = ACTIONS(5028),
    [anon_sym_mutable] = ACTIONS(5028),
    [anon_sym_explicit] = ACTIONS(5028),
    [anon_sym_constexpr] = ACTIONS(5028),
    [anon_sym_unsigned] = ACTIONS(5028),
    [anon_sym_long] = ACTIONS(5028),
    [anon_sym_short] = ACTIONS(5028),
    [sym_primitive_type] = ACTIONS(5028),
    [anon_sym_enum] = ACTIONS(5028),
    [anon_sym_struct] = ACTIONS(5028),
    [anon_sym_union] = ACTIONS(5028),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5026),
    [sym_identifier] = ACTIONS(5028),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5028),
    [anon_sym_public] = ACTIONS(5028),
    [sym_auto] = ACTIONS(5028),
    [anon_sym_typename] = ACTIONS(5028),
    [anon_sym_template] = ACTIONS(5028),
    [anon_sym_friend] = ACTIONS(5028),
    [anon_sym_private] = ACTIONS(5028),
    [anon_sym_protected] = ACTIONS(5028),
    [anon_sym_using] = ACTIONS(5028),
    [anon_sym_COLON_COLON] = ACTIONS(5026),
    [sym_operator_name] = ACTIONS(5026),
  },
  [1733] = {
    [anon_sym_LT] = ACTIONS(5030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [1734] = {
    [sym__field_declarator] = STATE(2224),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(2224),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(5033),
  },
  [1735] = {
    [sym__field_declarator] = STATE(2225),
    [sym_pointer_field_declarator] = STATE(579),
    [sym_function_field_declarator] = STATE(580),
    [sym_array_field_declarator] = STATE(581),
    [sym_reference_field_declarator] = STATE(582),
    [sym_template_type] = STATE(583),
    [sym_template_method] = STATE(2225),
    [sym_scoped_field_identifier] = STATE(584),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(583),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [sym_identifier] = ACTIONS(1085),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1087),
    [sym_operator_name] = ACTIONS(5035),
  },
  [1736] = {
    [sym_parameter_list] = STATE(2226),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5037),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(5037),
    [sym_comment] = ACTIONS(49),
  },
  [1737] = {
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_RPAREN] = ACTIONS(5039),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COLON] = ACTIONS(5039),
    [sym_comment] = ACTIONS(49),
  },
  [1738] = {
    [sym__expression] = STATE(2228),
    [sym_conditional_expression] = STATE(2228),
    [sym_assignment_expression] = STATE(2228),
    [sym_pointer_expression] = STATE(2228),
    [sym_logical_expression] = STATE(2228),
    [sym_bitwise_expression] = STATE(2228),
    [sym_equality_expression] = STATE(2228),
    [sym_relational_expression] = STATE(2228),
    [sym_shift_expression] = STATE(2228),
    [sym_math_expression] = STATE(2228),
    [sym_cast_expression] = STATE(2228),
    [sym_sizeof_expression] = STATE(2228),
    [sym_subscript_expression] = STATE(2228),
    [sym_call_expression] = STATE(2228),
    [sym_field_expression] = STATE(2228),
    [sym_compound_literal_expression] = STATE(2228),
    [sym_parenthesized_expression] = STATE(2228),
    [sym_concatenated_string] = STATE(2228),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2228),
    [sym_new_expression] = STATE(2228),
    [sym_delete_expression] = STATE(2228),
    [sym_lambda_expression] = STATE(2228),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5041),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(5041),
    [sym_char_literal] = ACTIONS(5041),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(5045),
    [sym_false] = ACTIONS(5045),
    [sym_null] = ACTIONS(5045),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(5045),
  },
  [1739] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1740] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1741] = {
    [sym__type_specifier] = STATE(2231),
    [sym_sized_type_specifier] = STATE(2231),
    [sym_enum_specifier] = STATE(2231),
    [sym_struct_specifier] = STATE(2231),
    [sym_union_specifier] = STATE(2231),
    [sym_macro_type_specifier] = STATE(2231),
    [sym_class_specifier] = STATE(2231),
    [sym_dependent_type] = STATE(2231),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2232),
    [anon_sym_unsigned] = ACTIONS(5049),
    [anon_sym_long] = ACTIONS(5049),
    [anon_sym_short] = ACTIONS(5049),
    [sym_primitive_type] = ACTIONS(5051),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(5051),
    [anon_sym_typename] = ACTIONS(5053),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1742] = {
    [sym_type_qualifier] = STATE(2233),
    [sym_trailing_return_type] = STATE(2233),
    [aux_sym_function_declarator_repeat1] = STATE(2233),
    [anon_sym_LPAREN] = ACTIONS(5055),
    [anon_sym_COMMA] = ACTIONS(5055),
    [anon_sym_SEMI] = ACTIONS(5055),
    [anon_sym_LBRACE] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5055),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5057),
  },
  [1743] = {
    [sym__expression] = STATE(2234),
    [sym_conditional_expression] = STATE(2234),
    [sym_assignment_expression] = STATE(2234),
    [sym_pointer_expression] = STATE(2234),
    [sym_logical_expression] = STATE(2234),
    [sym_bitwise_expression] = STATE(2234),
    [sym_equality_expression] = STATE(2234),
    [sym_relational_expression] = STATE(2234),
    [sym_shift_expression] = STATE(2234),
    [sym_math_expression] = STATE(2234),
    [sym_cast_expression] = STATE(2234),
    [sym_sizeof_expression] = STATE(2234),
    [sym_subscript_expression] = STATE(2234),
    [sym_call_expression] = STATE(2234),
    [sym_field_expression] = STATE(2234),
    [sym_compound_literal_expression] = STATE(2234),
    [sym_parenthesized_expression] = STATE(2234),
    [sym_concatenated_string] = STATE(2234),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2234),
    [sym_new_expression] = STATE(2234),
    [sym_delete_expression] = STATE(2234),
    [sym_lambda_expression] = STATE(2234),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5059),
    [sym_char_literal] = ACTIONS(5059),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5061),
    [sym_false] = ACTIONS(5061),
    [sym_null] = ACTIONS(5061),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5061),
  },
  [1744] = {
    [aux_sym_field_declaration_repeat1] = STATE(1744),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_SEMI] = ACTIONS(5037),
    [anon_sym_COLON] = ACTIONS(5037),
    [sym_comment] = ACTIONS(49),
  },
  [1745] = {
    [anon_sym_LT] = ACTIONS(5066),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [1746] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_EQ] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_STAR_EQ] = ACTIONS(1157),
    [anon_sym_SLASH_EQ] = ACTIONS(1157),
    [anon_sym_PERCENT_EQ] = ACTIONS(1157),
    [anon_sym_PLUS_EQ] = ACTIONS(1157),
    [anon_sym_DASH_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_GT_EQ] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(1157),
    [anon_sym_CARET_EQ] = ACTIONS(1157),
    [anon_sym_PIPE_EQ] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1159),
    [anon_sym_GT] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1159),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(1159),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [sym_comment] = ACTIONS(49),
  },
  [1747] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2236),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5069),
    [sym_comment] = ACTIONS(49),
  },
  [1748] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1750),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1749] = {
    [sym__abstract_declarator] = STATE(2239),
    [sym_abstract_pointer_declarator] = STATE(2239),
    [sym_abstract_function_declarator] = STATE(2239),
    [sym_abstract_array_declarator] = STATE(2239),
    [sym_parameter_list] = STATE(2240),
    [sym_abstract_reference_declarator] = STATE(2239),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5075),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [1750] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2241),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(5077),
    [anon_sym_long] = ACTIONS(5077),
    [anon_sym_short] = ACTIONS(5077),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [1751] = {
    [sym_type_qualifier] = STATE(1751),
    [sym_trailing_return_type] = STATE(1751),
    [aux_sym_function_declarator_repeat1] = STATE(1751),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(5079),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5082),
  },
  [1752] = {
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_public] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_friend] = ACTIONS(3276),
    [anon_sym_private] = ACTIONS(3276),
    [anon_sym_protected] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [sym_operator_name] = ACTIONS(3274),
  },
  [1753] = {
    [anon_sym_LPAREN] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3430),
    [anon_sym_typedef] = ACTIONS(3432),
    [anon_sym_extern] = ACTIONS(3432),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_STAR] = ACTIONS(3430),
    [anon_sym_static] = ACTIONS(3432),
    [anon_sym_register] = ACTIONS(3432),
    [anon_sym_inline] = ACTIONS(3432),
    [anon_sym_const] = ACTIONS(3432),
    [anon_sym_restrict] = ACTIONS(3432),
    [anon_sym_volatile] = ACTIONS(3432),
    [anon_sym__Atomic] = ACTIONS(3432),
    [anon_sym_mutable] = ACTIONS(3432),
    [anon_sym_explicit] = ACTIONS(3432),
    [anon_sym_constexpr] = ACTIONS(3432),
    [anon_sym_unsigned] = ACTIONS(3432),
    [anon_sym_long] = ACTIONS(3432),
    [anon_sym_short] = ACTIONS(3432),
    [sym_primitive_type] = ACTIONS(3432),
    [anon_sym_enum] = ACTIONS(3432),
    [anon_sym_struct] = ACTIONS(3432),
    [anon_sym_union] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_TILDE] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3432),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3432),
    [anon_sym_public] = ACTIONS(3432),
    [sym_auto] = ACTIONS(3432),
    [anon_sym_typename] = ACTIONS(3432),
    [anon_sym_template] = ACTIONS(3432),
    [anon_sym_friend] = ACTIONS(3432),
    [anon_sym_private] = ACTIONS(3432),
    [anon_sym_protected] = ACTIONS(3432),
    [anon_sym_using] = ACTIONS(3432),
    [anon_sym_COLON_COLON] = ACTIONS(3430),
    [sym_operator_name] = ACTIONS(3430),
  },
  [1754] = {
    [anon_sym_COMMA] = ACTIONS(5085),
    [anon_sym_LBRACE] = ACTIONS(5085),
    [sym_comment] = ACTIONS(49),
  },
  [1755] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_GT] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(3882),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [sym_operator_name] = ACTIONS(3880),
  },
  [1756] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1757] = {
    [anon_sym_RPAREN] = ACTIONS(5087),
    [sym_comment] = ACTIONS(49),
  },
  [1758] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1758),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5089),
    [sym_comment] = ACTIONS(49),
  },
  [1759] = {
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_COLON] = ACTIONS(1194),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [1760] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5092),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1761] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_RPAREN] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1762] = {
    [sym__expression] = STATE(2244),
    [sym_conditional_expression] = STATE(2244),
    [sym_assignment_expression] = STATE(2244),
    [sym_pointer_expression] = STATE(2244),
    [sym_logical_expression] = STATE(2244),
    [sym_bitwise_expression] = STATE(2244),
    [sym_equality_expression] = STATE(2244),
    [sym_relational_expression] = STATE(2244),
    [sym_shift_expression] = STATE(2244),
    [sym_math_expression] = STATE(2244),
    [sym_cast_expression] = STATE(2244),
    [sym_sizeof_expression] = STATE(2244),
    [sym_subscript_expression] = STATE(2244),
    [sym_call_expression] = STATE(2244),
    [sym_field_expression] = STATE(2244),
    [sym_compound_literal_expression] = STATE(2244),
    [sym_parenthesized_expression] = STATE(2244),
    [sym_concatenated_string] = STATE(2244),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2244),
    [sym_new_expression] = STATE(2244),
    [sym_delete_expression] = STATE(2244),
    [sym_lambda_expression] = STATE(2244),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(5094),
    [sym_char_literal] = ACTIONS(5094),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(5096),
    [sym_false] = ACTIONS(5096),
    [sym_null] = ACTIONS(5096),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(5096),
  },
  [1763] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2296),
    [anon_sym_RPAREN] = ACTIONS(4854),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1764] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_RPAREN] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1765] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5098),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1766] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1767] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1768] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1769] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1770] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1771] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1772] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1773] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1774] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_RPAREN] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1775] = {
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_COLON] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [1776] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1777] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1778] = {
    [anon_sym_LPAREN] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_SEMI] = ACTIONS(5100),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_const] = ACTIONS(5102),
    [anon_sym_restrict] = ACTIONS(5100),
    [anon_sym_volatile] = ACTIONS(5100),
    [anon_sym__Atomic] = ACTIONS(5100),
    [anon_sym_mutable] = ACTIONS(5100),
    [anon_sym_explicit] = ACTIONS(5100),
    [anon_sym_constexpr] = ACTIONS(5100),
    [anon_sym_COLON] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5100),
  },
  [1779] = {
    [sym_type_qualifier] = STATE(2246),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2246),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5104),
  },
  [1780] = {
    [sym__type_specifier] = STATE(2247),
    [sym_sized_type_specifier] = STATE(2247),
    [sym_enum_specifier] = STATE(2247),
    [sym_struct_specifier] = STATE(2247),
    [sym_union_specifier] = STATE(2247),
    [sym_macro_type_specifier] = STATE(2247),
    [sym_class_specifier] = STATE(2247),
    [sym_dependent_type] = STATE(2247),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(5106),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(5106),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1781] = {
    [sym_type_qualifier] = STATE(2248),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2248),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5108),
  },
  [1782] = {
    [anon_sym_LPAREN] = ACTIONS(5110),
    [anon_sym_COMMA] = ACTIONS(5110),
    [anon_sym_RPAREN] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5110),
    [anon_sym_LBRACE] = ACTIONS(5110),
    [anon_sym_LBRACK] = ACTIONS(5110),
    [anon_sym_EQ] = ACTIONS(5110),
    [anon_sym_const] = ACTIONS(5112),
    [anon_sym_restrict] = ACTIONS(5110),
    [anon_sym_volatile] = ACTIONS(5110),
    [anon_sym__Atomic] = ACTIONS(5110),
    [anon_sym_mutable] = ACTIONS(5110),
    [anon_sym_explicit] = ACTIONS(5110),
    [anon_sym_constexpr] = ACTIONS(5110),
    [anon_sym_COLON] = ACTIONS(5110),
    [anon_sym_GT] = ACTIONS(5110),
    [anon_sym_DASH_GT] = ACTIONS(5110),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5110),
  },
  [1783] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5114),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1784] = {
    [sym__expression] = STATE(2250),
    [sym_conditional_expression] = STATE(2250),
    [sym_assignment_expression] = STATE(2250),
    [sym_pointer_expression] = STATE(2250),
    [sym_logical_expression] = STATE(2250),
    [sym_bitwise_expression] = STATE(2250),
    [sym_equality_expression] = STATE(2250),
    [sym_relational_expression] = STATE(2250),
    [sym_shift_expression] = STATE(2250),
    [sym_math_expression] = STATE(2250),
    [sym_cast_expression] = STATE(2250),
    [sym_sizeof_expression] = STATE(2250),
    [sym_subscript_expression] = STATE(2250),
    [sym_call_expression] = STATE(2250),
    [sym_field_expression] = STATE(2250),
    [sym_compound_literal_expression] = STATE(2250),
    [sym_parenthesized_expression] = STATE(2250),
    [sym_concatenated_string] = STATE(2250),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2250),
    [sym_new_expression] = STATE(2250),
    [sym_delete_expression] = STATE(2250),
    [sym_lambda_expression] = STATE(2250),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5114),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(5116),
    [sym_char_literal] = ACTIONS(5116),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [sym_null] = ACTIONS(5118),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(5118),
  },
  [1785] = {
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(5122),
    [anon_sym_restrict] = ACTIONS(5120),
    [anon_sym_volatile] = ACTIONS(5120),
    [anon_sym__Atomic] = ACTIONS(5120),
    [anon_sym_mutable] = ACTIONS(5120),
    [anon_sym_explicit] = ACTIONS(5120),
    [anon_sym_constexpr] = ACTIONS(5120),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_GT] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(5120),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5120),
  },
  [1786] = {
    [sym_type_qualifier] = STATE(1788),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1788),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(2358),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3876),
  },
  [1787] = {
    [sym__abstract_declarator] = STATE(2252),
    [sym_abstract_pointer_declarator] = STATE(2252),
    [sym_abstract_function_declarator] = STATE(2252),
    [sym_abstract_array_declarator] = STATE(2252),
    [sym_parameter_list] = STATE(632),
    [sym_abstract_reference_declarator] = STATE(2252),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
  },
  [1788] = {
    [sym_type_qualifier] = STATE(1788),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1788),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5132),
  },
  [1789] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1791),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1790] = {
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5135),
    [sym_comment] = ACTIONS(49),
  },
  [1791] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2253),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(5137),
    [anon_sym_long] = ACTIONS(5137),
    [anon_sym_short] = ACTIONS(5137),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [1792] = {
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1192),
    [sym_comment] = ACTIONS(49),
  },
  [1793] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_argument_list_repeat1] = STATE(2255),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1794] = {
    [aux_sym_argument_list_repeat1] = STATE(2255),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [sym_comment] = ACTIONS(49),
  },
  [1795] = {
    [anon_sym_RBRACE] = ACTIONS(5141),
    [sym_comment] = ACTIONS(49),
  },
  [1796] = {
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [sym_comment] = ACTIONS(49),
  },
  [1797] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_initializer_list_repeat1] = STATE(2258),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5143),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1798] = {
    [aux_sym_initializer_list_repeat1] = STATE(2258),
    [anon_sym_COMMA] = ACTIONS(5143),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [sym_comment] = ACTIONS(49),
  },
  [1799] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(2259),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [1800] = {
    [sym__expression] = STATE(764),
    [sym_conditional_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_pointer_expression] = STATE(764),
    [sym_logical_expression] = STATE(764),
    [sym_bitwise_expression] = STATE(764),
    [sym_equality_expression] = STATE(764),
    [sym_relational_expression] = STATE(764),
    [sym_shift_expression] = STATE(764),
    [sym_math_expression] = STATE(764),
    [sym_cast_expression] = STATE(764),
    [sym_sizeof_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_field_expression] = STATE(764),
    [sym_compound_literal_expression] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_delete_expression] = STATE(764),
    [sym_lambda_expression] = STATE(764),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(1461),
    [sym_char_literal] = ACTIONS(1461),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(1463),
  },
  [1801] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(796),
    [sym_new_expression] = STATE(796),
    [sym_delete_expression] = STATE(796),
    [sym_lambda_expression] = STATE(796),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(1515),
  },
  [1802] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(797),
    [sym_new_expression] = STATE(797),
    [sym_delete_expression] = STATE(797),
    [sym_lambda_expression] = STATE(797),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(1519),
  },
  [1803] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(798),
    [sym_new_expression] = STATE(798),
    [sym_delete_expression] = STATE(798),
    [sym_lambda_expression] = STATE(798),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(1523),
  },
  [1804] = {
    [sym__expression] = STATE(2261),
    [sym_conditional_expression] = STATE(2261),
    [sym_assignment_expression] = STATE(2261),
    [sym_pointer_expression] = STATE(2261),
    [sym_logical_expression] = STATE(2261),
    [sym_bitwise_expression] = STATE(2261),
    [sym_equality_expression] = STATE(2261),
    [sym_relational_expression] = STATE(2261),
    [sym_shift_expression] = STATE(2261),
    [sym_math_expression] = STATE(2261),
    [sym_cast_expression] = STATE(2261),
    [sym_sizeof_expression] = STATE(2261),
    [sym_subscript_expression] = STATE(2261),
    [sym_call_expression] = STATE(2261),
    [sym_field_expression] = STATE(2261),
    [sym_compound_literal_expression] = STATE(2261),
    [sym_parenthesized_expression] = STATE(2261),
    [sym_concatenated_string] = STATE(2261),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2261),
    [sym_new_expression] = STATE(2261),
    [sym_delete_expression] = STATE(2261),
    [sym_lambda_expression] = STATE(2261),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5145),
    [sym_char_literal] = ACTIONS(5145),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5149),
    [sym_false] = ACTIONS(5149),
    [sym_null] = ACTIONS(5149),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5149),
  },
  [1805] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2262),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_string_literal] = ACTIONS(5151),
    [sym_comment] = ACTIONS(49),
  },
  [1806] = {
    [sym_destructor_name] = STATE(125),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(49),
    [anon_sym_delete] = ACTIONS(5153),
    [sym_operator_name] = ACTIONS(198),
  },
  [1807] = {
    [sym__expression] = STATE(2265),
    [sym_conditional_expression] = STATE(2265),
    [sym_assignment_expression] = STATE(2265),
    [sym_pointer_expression] = STATE(2265),
    [sym_logical_expression] = STATE(2265),
    [sym_bitwise_expression] = STATE(2265),
    [sym_equality_expression] = STATE(2265),
    [sym_relational_expression] = STATE(2265),
    [sym_shift_expression] = STATE(2265),
    [sym_math_expression] = STATE(2265),
    [sym_cast_expression] = STATE(2265),
    [sym_sizeof_expression] = STATE(2265),
    [sym_subscript_expression] = STATE(2265),
    [sym_call_expression] = STATE(2265),
    [sym_field_expression] = STATE(2265),
    [sym_compound_literal_expression] = STATE(2265),
    [sym_parenthesized_expression] = STATE(2265),
    [sym_concatenated_string] = STATE(2265),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2265),
    [sym_new_expression] = STATE(2265),
    [sym_delete_expression] = STATE(2265),
    [sym_lambda_expression] = STATE(2265),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5155),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(5157),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5155),
    [sym_char_literal] = ACTIONS(5155),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5159),
    [sym_false] = ACTIONS(5159),
    [sym_null] = ACTIONS(5159),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5159),
  },
  [1808] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_STAR_EQ] = ACTIONS(5167),
    [anon_sym_SLASH_EQ] = ACTIONS(5167),
    [anon_sym_PERCENT_EQ] = ACTIONS(5167),
    [anon_sym_PLUS_EQ] = ACTIONS(5167),
    [anon_sym_DASH_EQ] = ACTIONS(5167),
    [anon_sym_LT_LT_EQ] = ACTIONS(5167),
    [anon_sym_GT_GT_EQ] = ACTIONS(5167),
    [anon_sym_AMP_EQ] = ACTIONS(5167),
    [anon_sym_CARET_EQ] = ACTIONS(5167),
    [anon_sym_PIPE_EQ] = ACTIONS(5167),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1809] = {
    [sym__type_specifier] = STATE(2279),
    [sym_sized_type_specifier] = STATE(2279),
    [sym_enum_specifier] = STATE(2279),
    [sym_struct_specifier] = STATE(2279),
    [sym_union_specifier] = STATE(2279),
    [sym_macro_type_specifier] = STATE(2279),
    [sym_class_specifier] = STATE(2279),
    [sym_dependent_type] = STATE(2279),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2280),
    [anon_sym_unsigned] = ACTIONS(5189),
    [anon_sym_long] = ACTIONS(5189),
    [anon_sym_short] = ACTIONS(5189),
    [sym_primitive_type] = ACTIONS(5191),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(5191),
    [anon_sym_typename] = ACTIONS(5193),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1810] = {
    [sym_type_qualifier] = STATE(2281),
    [sym_trailing_return_type] = STATE(2281),
    [aux_sym_function_declarator_repeat1] = STATE(2281),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_COMMA] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5195),
  },
  [1811] = {
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1865),
    [sym_comment] = ACTIONS(49),
  },
  [1812] = {
    [sym__abstract_declarator] = STATE(2282),
    [sym_abstract_pointer_declarator] = STATE(2282),
    [sym_abstract_function_declarator] = STATE(2282),
    [sym_abstract_array_declarator] = STATE(2282),
    [sym_parameter_list] = STATE(1815),
    [sym_abstract_reference_declarator] = STATE(2282),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [1813] = {
    [sym__abstract_declarator] = STATE(2283),
    [sym_abstract_pointer_declarator] = STATE(2283),
    [sym_abstract_function_declarator] = STATE(2283),
    [sym_abstract_array_declarator] = STATE(2283),
    [sym_parameter_list] = STATE(1815),
    [sym_abstract_reference_declarator] = STATE(2283),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [1814] = {
    [sym_parameter_list] = STATE(2284),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [1815] = {
    [sym_type_qualifier] = STATE(2285),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2285),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [1816] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1816),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(5197),
    [anon_sym_long] = ACTIONS(5197),
    [anon_sym_short] = ACTIONS(5197),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [1817] = {
    [sym_parameter_list] = STATE(1819),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1818] = {
    [sym_parameter_list] = STATE(1819),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1819] = {
    [sym_type_qualifier] = STATE(2286),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2286),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3966),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5200),
  },
  [1820] = {
    [sym__type_specifier] = STATE(2287),
    [sym_sized_type_specifier] = STATE(2287),
    [sym_enum_specifier] = STATE(2287),
    [sym_struct_specifier] = STATE(2287),
    [sym_union_specifier] = STATE(2287),
    [sym_macro_type_specifier] = STATE(2287),
    [sym_class_specifier] = STATE(2287),
    [sym_dependent_type] = STATE(2287),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(676),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(5202),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(5202),
    [anon_sym_typename] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1821] = {
    [sym_type_qualifier] = STATE(2288),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2288),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3966),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5204),
  },
  [1822] = {
    [sym_parameter_list] = STATE(1819),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1823] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [1824] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5206),
    [anon_sym_RPAREN] = ACTIONS(5206),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1825] = {
    [anon_sym_COMMA] = ACTIONS(5206),
    [anon_sym_RPAREN] = ACTIONS(5206),
    [sym_comment] = ACTIONS(49),
  },
  [1826] = {
    [anon_sym_LPAREN] = ACTIONS(5208),
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_RPAREN] = ACTIONS(5208),
    [anon_sym_SEMI] = ACTIONS(5208),
    [anon_sym_LBRACE] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_STAR] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(5208),
    [anon_sym_RBRACK] = ACTIONS(5208),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_COLON] = ACTIONS(5208),
    [anon_sym_QMARK] = ACTIONS(5208),
    [anon_sym_STAR_EQ] = ACTIONS(5208),
    [anon_sym_SLASH_EQ] = ACTIONS(5208),
    [anon_sym_PERCENT_EQ] = ACTIONS(5208),
    [anon_sym_PLUS_EQ] = ACTIONS(5208),
    [anon_sym_DASH_EQ] = ACTIONS(5208),
    [anon_sym_LT_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT_GT_EQ] = ACTIONS(5208),
    [anon_sym_AMP_EQ] = ACTIONS(5208),
    [anon_sym_CARET_EQ] = ACTIONS(5208),
    [anon_sym_PIPE_EQ] = ACTIONS(5208),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PIPE_PIPE] = ACTIONS(5208),
    [anon_sym_AMP_AMP] = ACTIONS(5208),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5208),
    [anon_sym_BANG_EQ] = ACTIONS(5208),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5208),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_DASH_DASH] = ACTIONS(5208),
    [anon_sym_PLUS_PLUS] = ACTIONS(5208),
    [anon_sym_DOT] = ACTIONS(5208),
    [anon_sym_DASH_GT] = ACTIONS(5208),
    [sym_comment] = ACTIONS(49),
  },
  [1827] = {
    [aux_sym_argument_list_repeat1] = STATE(1827),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5206),
    [sym_comment] = ACTIONS(49),
  },
  [1828] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1856),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [1829] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1830] = {
    [anon_sym_LPAREN] = ACTIONS(4276),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(5215),
    [anon_sym_AMP] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4276),
    [anon_sym_DOT] = ACTIONS(5215),
    [sym_comment] = ACTIONS(49),
  },
  [1831] = {
    [anon_sym_RPAREN] = ACTIONS(5217),
    [sym_comment] = ACTIONS(49),
  },
  [1832] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1832),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5219),
    [sym_comment] = ACTIONS(49),
  },
  [1833] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1834] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_RBRACE] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1835] = {
    [sym__expression] = STATE(2291),
    [sym_conditional_expression] = STATE(2291),
    [sym_assignment_expression] = STATE(2291),
    [sym_pointer_expression] = STATE(2291),
    [sym_logical_expression] = STATE(2291),
    [sym_bitwise_expression] = STATE(2291),
    [sym_equality_expression] = STATE(2291),
    [sym_relational_expression] = STATE(2291),
    [sym_shift_expression] = STATE(2291),
    [sym_math_expression] = STATE(2291),
    [sym_cast_expression] = STATE(2291),
    [sym_sizeof_expression] = STATE(2291),
    [sym_subscript_expression] = STATE(2291),
    [sym_call_expression] = STATE(2291),
    [sym_field_expression] = STATE(2291),
    [sym_compound_literal_expression] = STATE(2291),
    [sym_parenthesized_expression] = STATE(2291),
    [sym_concatenated_string] = STATE(2291),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2291),
    [sym_new_expression] = STATE(2291),
    [sym_delete_expression] = STATE(2291),
    [sym_lambda_expression] = STATE(2291),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5224),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(5224),
    [sym_char_literal] = ACTIONS(5224),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(5226),
    [sym_false] = ACTIONS(5226),
    [sym_null] = ACTIONS(5226),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(5226),
  },
  [1836] = {
    [anon_sym_LPAREN] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym_LBRACE] = ACTIONS(5228),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5230),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_RBRACK] = ACTIONS(5228),
    [anon_sym_EQ] = ACTIONS(5230),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_STAR_EQ] = ACTIONS(5228),
    [anon_sym_SLASH_EQ] = ACTIONS(5228),
    [anon_sym_PERCENT_EQ] = ACTIONS(5228),
    [anon_sym_PLUS_EQ] = ACTIONS(5228),
    [anon_sym_DASH_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_GT_EQ] = ACTIONS(5228),
    [anon_sym_AMP_EQ] = ACTIONS(5228),
    [anon_sym_CARET_EQ] = ACTIONS(5228),
    [anon_sym_PIPE_EQ] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_PIPE_PIPE] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_CARET] = ACTIONS(5230),
    [anon_sym_EQ_EQ] = ACTIONS(5228),
    [anon_sym_BANG_EQ] = ACTIONS(5228),
    [anon_sym_LT] = ACTIONS(5230),
    [anon_sym_GT] = ACTIONS(5230),
    [anon_sym_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5230),
    [anon_sym_GT_GT] = ACTIONS(5230),
    [anon_sym_PLUS] = ACTIONS(5230),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_SLASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5230),
    [anon_sym_DASH_DASH] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5228),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_DASH_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(49),
  },
  [1837] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_SEMI] = ACTIONS(4854),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2504),
    [anon_sym_STAR_EQ] = ACTIONS(2506),
    [anon_sym_SLASH_EQ] = ACTIONS(2506),
    [anon_sym_PERCENT_EQ] = ACTIONS(2506),
    [anon_sym_PLUS_EQ] = ACTIONS(2506),
    [anon_sym_DASH_EQ] = ACTIONS(2506),
    [anon_sym_LT_LT_EQ] = ACTIONS(2506),
    [anon_sym_GT_GT_EQ] = ACTIONS(2506),
    [anon_sym_AMP_EQ] = ACTIONS(2506),
    [anon_sym_CARET_EQ] = ACTIONS(2506),
    [anon_sym_PIPE_EQ] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1838] = {
    [anon_sym_COMMA] = ACTIONS(5235),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [sym_comment] = ACTIONS(49),
  },
  [1839] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(2506),
    [anon_sym_SLASH_EQ] = ACTIONS(2506),
    [anon_sym_PERCENT_EQ] = ACTIONS(2506),
    [anon_sym_PLUS_EQ] = ACTIONS(2506),
    [anon_sym_DASH_EQ] = ACTIONS(2506),
    [anon_sym_LT_LT_EQ] = ACTIONS(2506),
    [anon_sym_GT_GT_EQ] = ACTIONS(2506),
    [anon_sym_AMP_EQ] = ACTIONS(2506),
    [anon_sym_CARET_EQ] = ACTIONS(2506),
    [anon_sym_PIPE_EQ] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1840] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5237),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1841] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1842] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1843] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1844] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1845] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1846] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1847] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1848] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1849] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_SEMI] = ACTIONS(4388),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1850] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(5239),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4070),
    [sym_char_literal] = ACTIONS(4070),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4072),
  },
  [1851] = {
    [aux_sym_initializer_list_repeat1] = STATE(1851),
    [anon_sym_COMMA] = ACTIONS(5241),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [sym_comment] = ACTIONS(49),
  },
  [1852] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5235),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1853] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5244),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1854] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1855] = {
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [sym_comment] = ACTIONS(49),
  },
  [1856] = {
    [sym_field_declaration_list] = STATE(1980),
    [sym_base_class_clause] = STATE(1981),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_EQ] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym__Atomic] = ACTIONS(426),
    [anon_sym_mutable] = ACTIONS(426),
    [anon_sym_explicit] = ACTIONS(426),
    [anon_sym_constexpr] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4470),
    [sym_noexcept] = ACTIONS(426),
  },
  [1857] = {
    [sym_field_declaration_list] = STATE(1983),
    [sym_base_class_clause] = STATE(1984),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym__Atomic] = ACTIONS(438),
    [anon_sym_mutable] = ACTIONS(438),
    [anon_sym_explicit] = ACTIONS(438),
    [anon_sym_constexpr] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_DASH_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4472),
    [sym_noexcept] = ACTIONS(438),
  },
  [1858] = {
    [sym_field_declaration_list] = STATE(1989),
    [sym_base_class_clause] = STATE(1990),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_mutable] = ACTIONS(475),
    [anon_sym_explicit] = ACTIONS(475),
    [anon_sym_constexpr] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4478),
    [sym_noexcept] = ACTIONS(475),
  },
  [1859] = {
    [sym__abstract_declarator] = STATE(2296),
    [sym_abstract_pointer_declarator] = STATE(2296),
    [sym_abstract_function_declarator] = STATE(2296),
    [sym_abstract_array_declarator] = STATE(2296),
    [sym_parameter_list] = STATE(1862),
    [sym_abstract_reference_declarator] = STATE(2296),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(4092),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [1860] = {
    [sym__abstract_declarator] = STATE(2297),
    [sym_abstract_pointer_declarator] = STATE(2297),
    [sym_abstract_function_declarator] = STATE(2297),
    [sym_abstract_array_declarator] = STATE(2297),
    [sym_parameter_list] = STATE(1862),
    [sym_abstract_reference_declarator] = STATE(2297),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(4092),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [1861] = {
    [sym_parameter_list] = STATE(2298),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [1862] = {
    [sym_type_qualifier] = STATE(2299),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2299),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [1863] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1863),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(5248),
    [anon_sym_long] = ACTIONS(5248),
    [anon_sym_short] = ACTIONS(5248),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [1864] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1865] = {
    [anon_sym_RPAREN] = ACTIONS(5251),
    [sym_comment] = ACTIONS(49),
  },
  [1866] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1866),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5253),
    [sym_comment] = ACTIONS(49),
  },
  [1867] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5256),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1868] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_RBRACE] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1869] = {
    [sym__expression] = STATE(2302),
    [sym_conditional_expression] = STATE(2302),
    [sym_assignment_expression] = STATE(2302),
    [sym_pointer_expression] = STATE(2302),
    [sym_logical_expression] = STATE(2302),
    [sym_bitwise_expression] = STATE(2302),
    [sym_equality_expression] = STATE(2302),
    [sym_relational_expression] = STATE(2302),
    [sym_shift_expression] = STATE(2302),
    [sym_math_expression] = STATE(2302),
    [sym_cast_expression] = STATE(2302),
    [sym_sizeof_expression] = STATE(2302),
    [sym_subscript_expression] = STATE(2302),
    [sym_call_expression] = STATE(2302),
    [sym_field_expression] = STATE(2302),
    [sym_compound_literal_expression] = STATE(2302),
    [sym_parenthesized_expression] = STATE(2302),
    [sym_concatenated_string] = STATE(2302),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2302),
    [sym_new_expression] = STATE(2302),
    [sym_delete_expression] = STATE(2302),
    [sym_lambda_expression] = STATE(2302),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5258),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(5258),
    [sym_char_literal] = ACTIONS(5258),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(5260),
    [sym_false] = ACTIONS(5260),
    [sym_null] = ACTIONS(5260),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(5260),
  },
  [1870] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1871] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5262),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1872] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1873] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1874] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1875] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1876] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1877] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1878] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1879] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1880] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1881] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1882] = {
    [anon_sym_RPAREN] = ACTIONS(5264),
    [sym_comment] = ACTIONS(49),
  },
  [1883] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1883),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5266),
    [sym_comment] = ACTIONS(49),
  },
  [1884] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5269),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1885] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1886] = {
    [sym__expression] = STATE(2306),
    [sym_conditional_expression] = STATE(2306),
    [sym_assignment_expression] = STATE(2306),
    [sym_pointer_expression] = STATE(2306),
    [sym_logical_expression] = STATE(2306),
    [sym_bitwise_expression] = STATE(2306),
    [sym_equality_expression] = STATE(2306),
    [sym_relational_expression] = STATE(2306),
    [sym_shift_expression] = STATE(2306),
    [sym_math_expression] = STATE(2306),
    [sym_cast_expression] = STATE(2306),
    [sym_sizeof_expression] = STATE(2306),
    [sym_subscript_expression] = STATE(2306),
    [sym_call_expression] = STATE(2306),
    [sym_field_expression] = STATE(2306),
    [sym_compound_literal_expression] = STATE(2306),
    [sym_parenthesized_expression] = STATE(2306),
    [sym_concatenated_string] = STATE(2306),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2306),
    [sym_new_expression] = STATE(2306),
    [sym_delete_expression] = STATE(2306),
    [sym_lambda_expression] = STATE(2306),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5271),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5271),
    [sym_char_literal] = ACTIONS(5271),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5273),
    [sym_false] = ACTIONS(5273),
    [sym_null] = ACTIONS(5273),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5273),
  },
  [1887] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1888] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5275),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1889] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1890] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1891] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1892] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1893] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1894] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1895] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1896] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1897] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1898] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1899] = {
    [sym__type_specifier] = STATE(2309),
    [sym_sized_type_specifier] = STATE(2309),
    [sym_enum_specifier] = STATE(2309),
    [sym_struct_specifier] = STATE(2309),
    [sym_union_specifier] = STATE(2309),
    [sym_macro_type_specifier] = STATE(2309),
    [sym_class_specifier] = STATE(2309),
    [sym_dependent_type] = STATE(2309),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2310),
    [anon_sym_unsigned] = ACTIONS(5277),
    [anon_sym_long] = ACTIONS(5277),
    [anon_sym_short] = ACTIONS(5277),
    [sym_primitive_type] = ACTIONS(5279),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(5279),
    [anon_sym_typename] = ACTIONS(5281),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [1900] = {
    [sym_type_qualifier] = STATE(2311),
    [sym_trailing_return_type] = STATE(2311),
    [aux_sym_function_declarator_repeat1] = STATE(2311),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_COMMA] = ACTIONS(1654),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4237),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5283),
  },
  [1901] = {
    [sym_type_qualifier] = STATE(1905),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1905),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2677),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4249),
  },
  [1902] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1904),
    [anon_sym_unsigned] = ACTIONS(4243),
    [anon_sym_long] = ACTIONS(4243),
    [anon_sym_short] = ACTIONS(4243),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(4247),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1903] = {
    [sym__abstract_declarator] = STATE(2314),
    [sym_abstract_pointer_declarator] = STATE(2314),
    [sym_abstract_function_declarator] = STATE(2314),
    [sym_abstract_array_declarator] = STATE(2314),
    [sym_parameter_list] = STATE(750),
    [sym_abstract_reference_declarator] = STATE(2314),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(5285),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5289),
    [sym_comment] = ACTIONS(49),
  },
  [1904] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(5291),
    [anon_sym_long] = ACTIONS(5291),
    [anon_sym_short] = ACTIONS(5291),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [1905] = {
    [sym_type_qualifier] = STATE(1905),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1905),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5293),
  },
  [1906] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5296),
    [anon_sym_RPAREN] = ACTIONS(5296),
    [anon_sym_SEMI] = ACTIONS(5296),
    [anon_sym_RBRACE] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5296),
    [anon_sym_EQ] = ACTIONS(5298),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_STAR_EQ] = ACTIONS(5296),
    [anon_sym_SLASH_EQ] = ACTIONS(5296),
    [anon_sym_PERCENT_EQ] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5296),
    [anon_sym_DASH_EQ] = ACTIONS(5296),
    [anon_sym_LT_LT_EQ] = ACTIONS(5296),
    [anon_sym_GT_GT_EQ] = ACTIONS(5296),
    [anon_sym_AMP_EQ] = ACTIONS(5296),
    [anon_sym_CARET_EQ] = ACTIONS(5296),
    [anon_sym_PIPE_EQ] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5298),
    [anon_sym_PIPE_PIPE] = ACTIONS(5296),
    [anon_sym_AMP_AMP] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5298),
    [anon_sym_CARET] = ACTIONS(5298),
    [anon_sym_EQ_EQ] = ACTIONS(5296),
    [anon_sym_BANG_EQ] = ACTIONS(5296),
    [anon_sym_LT] = ACTIONS(5298),
    [anon_sym_GT] = ACTIONS(5298),
    [anon_sym_LT_EQ] = ACTIONS(5296),
    [anon_sym_GT_EQ] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5298),
    [anon_sym_GT_GT] = ACTIONS(5298),
    [anon_sym_PLUS] = ACTIONS(5298),
    [anon_sym_DASH] = ACTIONS(5298),
    [anon_sym_SLASH] = ACTIONS(5298),
    [anon_sym_PERCENT] = ACTIONS(5298),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1907] = {
    [anon_sym_LPAREN] = ACTIONS(5300),
    [anon_sym_COMMA] = ACTIONS(5300),
    [anon_sym_RPAREN] = ACTIONS(5300),
    [anon_sym_SEMI] = ACTIONS(5300),
    [anon_sym_RBRACE] = ACTIONS(5300),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_LBRACK] = ACTIONS(5300),
    [anon_sym_RBRACK] = ACTIONS(5300),
    [anon_sym_EQ] = ACTIONS(5302),
    [anon_sym_COLON] = ACTIONS(5300),
    [anon_sym_QMARK] = ACTIONS(5300),
    [anon_sym_STAR_EQ] = ACTIONS(5300),
    [anon_sym_SLASH_EQ] = ACTIONS(5300),
    [anon_sym_PERCENT_EQ] = ACTIONS(5300),
    [anon_sym_PLUS_EQ] = ACTIONS(5300),
    [anon_sym_DASH_EQ] = ACTIONS(5300),
    [anon_sym_LT_LT_EQ] = ACTIONS(5300),
    [anon_sym_GT_GT_EQ] = ACTIONS(5300),
    [anon_sym_AMP_EQ] = ACTIONS(5300),
    [anon_sym_CARET_EQ] = ACTIONS(5300),
    [anon_sym_PIPE_EQ] = ACTIONS(5300),
    [anon_sym_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5300),
    [anon_sym_AMP_AMP] = ACTIONS(5300),
    [anon_sym_PIPE] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5300),
    [anon_sym_BANG_EQ] = ACTIONS(5300),
    [anon_sym_LT] = ACTIONS(5302),
    [anon_sym_GT] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5300),
    [anon_sym_GT_EQ] = ACTIONS(5300),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5302),
    [anon_sym_DASH] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5302),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5300),
    [anon_sym_PLUS_PLUS] = ACTIONS(5300),
    [anon_sym_DOT] = ACTIONS(5300),
    [anon_sym_DASH_GT] = ACTIONS(5300),
    [sym_comment] = ACTIONS(49),
  },
  [1908] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [1909] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1910] = {
    [anon_sym_RPAREN] = ACTIONS(5304),
    [sym_comment] = ACTIONS(49),
  },
  [1911] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1911),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_RBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5306),
    [sym_comment] = ACTIONS(49),
  },
  [1912] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5309),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [1913] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4372),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1914] = {
    [sym__expression] = STATE(2318),
    [sym_conditional_expression] = STATE(2318),
    [sym_assignment_expression] = STATE(2318),
    [sym_pointer_expression] = STATE(2318),
    [sym_logical_expression] = STATE(2318),
    [sym_bitwise_expression] = STATE(2318),
    [sym_equality_expression] = STATE(2318),
    [sym_relational_expression] = STATE(2318),
    [sym_shift_expression] = STATE(2318),
    [sym_math_expression] = STATE(2318),
    [sym_cast_expression] = STATE(2318),
    [sym_sizeof_expression] = STATE(2318),
    [sym_subscript_expression] = STATE(2318),
    [sym_call_expression] = STATE(2318),
    [sym_field_expression] = STATE(2318),
    [sym_compound_literal_expression] = STATE(2318),
    [sym_parenthesized_expression] = STATE(2318),
    [sym_concatenated_string] = STATE(2318),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2318),
    [sym_new_expression] = STATE(2318),
    [sym_delete_expression] = STATE(2318),
    [sym_lambda_expression] = STATE(2318),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(5311),
    [sym_char_literal] = ACTIONS(5311),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(5313),
    [sym_false] = ACTIONS(5313),
    [sym_null] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(5313),
  },
  [1915] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_STAR_EQ] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2728),
    [anon_sym_GT_GT_EQ] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1916] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4394),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2728),
    [anon_sym_GT_GT_EQ] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1917] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5317),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [1918] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1919] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1920] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1921] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1922] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1923] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1924] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1925] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4414),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1926] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(4388),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1927] = {
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [sym_comment] = ACTIONS(49),
  },
  [1928] = {
    [aux_sym_for_statement_repeat1] = STATE(1928),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [sym_comment] = ACTIONS(49),
  },
  [1929] = {
    [sym_raw_string_literal] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_RBRACK] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2074),
    [sym_char_literal] = ACTIONS(2074),
    [sym_string_literal] = ACTIONS(2074),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_identifier] = ACTIONS(2076),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(2076),
    [sym_nullptr] = ACTIONS(2076),
  },
  [1930] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(5326),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [1931] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(5328),
    [anon_sym_RBRACE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(49),
  },
  [1932] = {
    [sym_raw_string_literal] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_RBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_sizeof] = ACTIONS(2180),
    [sym_number_literal] = ACTIONS(2178),
    [sym_char_literal] = ACTIONS(2178),
    [sym_string_literal] = ACTIONS(2178),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2180),
    [sym_nullptr] = ACTIONS(2180),
  },
  [1933] = {
    [sym_raw_string_literal] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1159),
    [anon_sym_register] = ACTIONS(1159),
    [anon_sym_inline] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1159),
    [anon_sym_volatile] = ACTIONS(1159),
    [anon_sym__Atomic] = ACTIONS(1159),
    [anon_sym_mutable] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1159),
    [anon_sym_constexpr] = ACTIONS(1159),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_sizeof] = ACTIONS(1159),
    [sym_number_literal] = ACTIONS(1157),
    [sym_char_literal] = ACTIONS(1157),
    [sym_string_literal] = ACTIONS(1157),
    [sym_true] = ACTIONS(1159),
    [sym_false] = ACTIONS(1159),
    [sym_null] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1159),
    [anon_sym_new] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1159),
    [sym_nullptr] = ACTIONS(1159),
  },
  [1934] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2323),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(49),
  },
  [1935] = {
    [sym_raw_string_literal] = ACTIONS(1186),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [anon_sym_sizeof] = ACTIONS(1188),
    [sym_number_literal] = ACTIONS(1186),
    [sym_char_literal] = ACTIONS(1186),
    [sym_string_literal] = ACTIONS(1186),
    [sym_true] = ACTIONS(1188),
    [sym_false] = ACTIONS(1188),
    [sym_null] = ACTIONS(1188),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [anon_sym_delete] = ACTIONS(1188),
    [sym_nullptr] = ACTIONS(1188),
  },
  [1936] = {
    [sym_raw_string_literal] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_RBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2268),
    [sym_char_literal] = ACTIONS(2268),
    [sym_string_literal] = ACTIONS(2268),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [sym_null] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2270),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2270),
    [sym_nullptr] = ACTIONS(2270),
  },
  [1937] = {
    [sym_field_declaration_list] = STATE(2324),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1938] = {
    [sym_raw_string_literal] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_RBRACK] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_sizeof] = ACTIONS(1861),
    [sym_number_literal] = ACTIONS(1859),
    [sym_char_literal] = ACTIONS(1859),
    [sym_string_literal] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1861),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [anon_sym_delete] = ACTIONS(1861),
    [sym_nullptr] = ACTIONS(1861),
  },
  [1939] = {
    [sym_raw_string_literal] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_RBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2272),
    [sym_char_literal] = ACTIONS(2272),
    [sym_string_literal] = ACTIONS(2272),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [sym_null] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2274),
    [sym_nullptr] = ACTIONS(2274),
  },
  [1940] = {
    [sym_field_declaration_list] = STATE(2325),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1941] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5334),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5332),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(4255),
  },
  [1942] = {
    [sym_raw_string_literal] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(2362),
    [anon_sym_STAR_EQ] = ACTIONS(2362),
    [anon_sym_SLASH_EQ] = ACTIONS(2362),
    [anon_sym_PERCENT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_GT_EQ] = ACTIONS(2362),
    [anon_sym_AMP_EQ] = ACTIONS(2362),
    [anon_sym_CARET_EQ] = ACTIONS(2362),
    [anon_sym_PIPE_EQ] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_CARET] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_PERCENT] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym_DOT] = ACTIONS(2362),
    [anon_sym_DASH_GT] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2362),
    [sym_char_literal] = ACTIONS(2362),
    [sym_string_literal] = ACTIONS(2362),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2364),
    [sym_nullptr] = ACTIONS(2364),
  },
  [1943] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5340),
    [sym_comment] = ACTIONS(49),
  },
  [1944] = {
    [sym_raw_string_literal] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_extern] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_register] = ACTIONS(2373),
    [anon_sym_inline] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2373),
    [anon_sym_volatile] = ACTIONS(2373),
    [anon_sym__Atomic] = ACTIONS(2373),
    [anon_sym_mutable] = ACTIONS(2373),
    [anon_sym_explicit] = ACTIONS(2373),
    [anon_sym_constexpr] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_sizeof] = ACTIONS(2373),
    [sym_number_literal] = ACTIONS(2371),
    [sym_char_literal] = ACTIONS(2371),
    [sym_string_literal] = ACTIONS(2371),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_null] = ACTIONS(2373),
    [sym_identifier] = ACTIONS(2373),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_COLON_COLON] = ACTIONS(2371),
    [anon_sym_delete] = ACTIONS(2373),
    [sym_nullptr] = ACTIONS(2373),
  },
  [1945] = {
    [sym_field_declaration_list] = STATE(2327),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(49),
  },
  [1946] = {
    [sym_raw_string_literal] = ACTIONS(1186),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [anon_sym_sizeof] = ACTIONS(1188),
    [sym_number_literal] = ACTIONS(1186),
    [sym_char_literal] = ACTIONS(1186),
    [sym_string_literal] = ACTIONS(1186),
    [sym_true] = ACTIONS(1188),
    [sym_false] = ACTIONS(1188),
    [sym_null] = ACTIONS(1188),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [anon_sym_delete] = ACTIONS(1188),
    [sym_nullptr] = ACTIONS(1188),
  },
  [1947] = {
    [sym_raw_string_literal] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_RBRACK] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_sizeof] = ACTIONS(1861),
    [sym_number_literal] = ACTIONS(1859),
    [sym_char_literal] = ACTIONS(1859),
    [sym_string_literal] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [anon_sym_delete] = ACTIONS(1861),
    [sym_nullptr] = ACTIONS(1861),
  },
  [1948] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1949] = {
    [anon_sym_LPAREN] = ACTIONS(5344),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_RPAREN] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_RBRACE] = ACTIONS(5344),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_LBRACK] = ACTIONS(5344),
    [anon_sym_RBRACK] = ACTIONS(5344),
    [anon_sym_EQ] = ACTIONS(5346),
    [anon_sym_COLON] = ACTIONS(5344),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_STAR_EQ] = ACTIONS(5344),
    [anon_sym_SLASH_EQ] = ACTIONS(5344),
    [anon_sym_PERCENT_EQ] = ACTIONS(5344),
    [anon_sym_PLUS_EQ] = ACTIONS(5344),
    [anon_sym_DASH_EQ] = ACTIONS(5344),
    [anon_sym_LT_LT_EQ] = ACTIONS(5344),
    [anon_sym_GT_GT_EQ] = ACTIONS(5344),
    [anon_sym_AMP_EQ] = ACTIONS(5344),
    [anon_sym_CARET_EQ] = ACTIONS(5344),
    [anon_sym_PIPE_EQ] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(5346),
    [anon_sym_PIPE_PIPE] = ACTIONS(5344),
    [anon_sym_AMP_AMP] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_CARET] = ACTIONS(5346),
    [anon_sym_EQ_EQ] = ACTIONS(5344),
    [anon_sym_BANG_EQ] = ACTIONS(5344),
    [anon_sym_LT] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5344),
    [anon_sym_GT_EQ] = ACTIONS(5344),
    [anon_sym_LT_LT] = ACTIONS(5346),
    [anon_sym_GT_GT] = ACTIONS(5346),
    [anon_sym_PLUS] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5346),
    [anon_sym_SLASH] = ACTIONS(5346),
    [anon_sym_PERCENT] = ACTIONS(5346),
    [anon_sym_DASH_DASH] = ACTIONS(5344),
    [anon_sym_PLUS_PLUS] = ACTIONS(5344),
    [anon_sym_DOT] = ACTIONS(5344),
    [anon_sym_DASH_GT] = ACTIONS(5344),
    [sym_comment] = ACTIONS(49),
  },
  [1950] = {
    [anon_sym_LPAREN] = ACTIONS(5348),
    [anon_sym_COMMA] = ACTIONS(5348),
    [anon_sym_RPAREN] = ACTIONS(5348),
    [anon_sym_SEMI] = ACTIONS(5348),
    [anon_sym_RBRACE] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5348),
    [anon_sym_RBRACK] = ACTIONS(5348),
    [anon_sym_EQ] = ACTIONS(5350),
    [anon_sym_COLON] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5348),
    [anon_sym_STAR_EQ] = ACTIONS(5348),
    [anon_sym_SLASH_EQ] = ACTIONS(5348),
    [anon_sym_PERCENT_EQ] = ACTIONS(5348),
    [anon_sym_PLUS_EQ] = ACTIONS(5348),
    [anon_sym_DASH_EQ] = ACTIONS(5348),
    [anon_sym_LT_LT_EQ] = ACTIONS(5348),
    [anon_sym_GT_GT_EQ] = ACTIONS(5348),
    [anon_sym_AMP_EQ] = ACTIONS(5348),
    [anon_sym_CARET_EQ] = ACTIONS(5348),
    [anon_sym_PIPE_EQ] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5348),
    [anon_sym_BANG_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_GT] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [anon_sym_DASH_DASH] = ACTIONS(5348),
    [anon_sym_PLUS_PLUS] = ACTIONS(5348),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DASH_GT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(49),
  },
  [1951] = {
    [sym_argument_list] = STATE(2329),
    [sym_initializer_list] = STATE(2329),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
  },
  [1952] = {
    [anon_sym_LPAREN] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_RPAREN] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5352),
    [anon_sym_RBRACE] = ACTIONS(5352),
    [anon_sym_STAR] = ACTIONS(5354),
    [anon_sym_LBRACK] = ACTIONS(5352),
    [anon_sym_RBRACK] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5354),
    [anon_sym_COLON] = ACTIONS(5352),
    [anon_sym_QMARK] = ACTIONS(5352),
    [anon_sym_STAR_EQ] = ACTIONS(5352),
    [anon_sym_SLASH_EQ] = ACTIONS(5352),
    [anon_sym_PERCENT_EQ] = ACTIONS(5352),
    [anon_sym_PLUS_EQ] = ACTIONS(5352),
    [anon_sym_DASH_EQ] = ACTIONS(5352),
    [anon_sym_LT_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT_GT_EQ] = ACTIONS(5352),
    [anon_sym_AMP_EQ] = ACTIONS(5352),
    [anon_sym_CARET_EQ] = ACTIONS(5352),
    [anon_sym_PIPE_EQ] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5354),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_PIPE] = ACTIONS(5354),
    [anon_sym_CARET] = ACTIONS(5354),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5354),
    [anon_sym_GT] = ACTIONS(5354),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5352),
    [anon_sym_LT_LT] = ACTIONS(5354),
    [anon_sym_GT_GT] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5354),
    [anon_sym_DASH] = ACTIONS(5354),
    [anon_sym_SLASH] = ACTIONS(5354),
    [anon_sym_PERCENT] = ACTIONS(5354),
    [anon_sym_DASH_DASH] = ACTIONS(5352),
    [anon_sym_PLUS_PLUS] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_DASH_GT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(49),
  },
  [1953] = {
    [sym_argument_list] = STATE(2330),
    [sym_initializer_list] = STATE(2330),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(49),
  },
  [1954] = {
    [sym__expression] = STATE(2331),
    [sym_conditional_expression] = STATE(2331),
    [sym_assignment_expression] = STATE(2331),
    [sym_pointer_expression] = STATE(2331),
    [sym_logical_expression] = STATE(2331),
    [sym_bitwise_expression] = STATE(2331),
    [sym_equality_expression] = STATE(2331),
    [sym_relational_expression] = STATE(2331),
    [sym_shift_expression] = STATE(2331),
    [sym_math_expression] = STATE(2331),
    [sym_cast_expression] = STATE(2331),
    [sym_sizeof_expression] = STATE(2331),
    [sym_subscript_expression] = STATE(2331),
    [sym_call_expression] = STATE(2331),
    [sym_field_expression] = STATE(2331),
    [sym_compound_literal_expression] = STATE(2331),
    [sym_parenthesized_expression] = STATE(2331),
    [sym_concatenated_string] = STATE(2331),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2331),
    [sym_new_expression] = STATE(2331),
    [sym_delete_expression] = STATE(2331),
    [sym_lambda_expression] = STATE(2331),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5356),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(5356),
    [sym_char_literal] = ACTIONS(5356),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(5358),
    [sym_false] = ACTIONS(5358),
    [sym_null] = ACTIONS(5358),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(5358),
  },
  [1955] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5360),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [1956] = {
    [anon_sym_LPAREN] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_EQ] = ACTIONS(5366),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_QMARK] = ACTIONS(5364),
    [anon_sym_STAR_EQ] = ACTIONS(5364),
    [anon_sym_SLASH_EQ] = ACTIONS(5364),
    [anon_sym_PERCENT_EQ] = ACTIONS(5364),
    [anon_sym_PLUS_EQ] = ACTIONS(5364),
    [anon_sym_DASH_EQ] = ACTIONS(5364),
    [anon_sym_LT_LT_EQ] = ACTIONS(5364),
    [anon_sym_GT_GT_EQ] = ACTIONS(5364),
    [anon_sym_AMP_EQ] = ACTIONS(5364),
    [anon_sym_CARET_EQ] = ACTIONS(5364),
    [anon_sym_PIPE_EQ] = ACTIONS(5364),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_CARET] = ACTIONS(5366),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_LT_EQ] = ACTIONS(5364),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_LT] = ACTIONS(5366),
    [anon_sym_GT_GT] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5366),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [sym_comment] = ACTIONS(49),
  },
  [1957] = {
    [sym__expression] = STATE(2332),
    [sym_conditional_expression] = STATE(2332),
    [sym_assignment_expression] = STATE(2332),
    [sym_pointer_expression] = STATE(2332),
    [sym_logical_expression] = STATE(2332),
    [sym_bitwise_expression] = STATE(2332),
    [sym_equality_expression] = STATE(2332),
    [sym_relational_expression] = STATE(2332),
    [sym_shift_expression] = STATE(2332),
    [sym_math_expression] = STATE(2332),
    [sym_cast_expression] = STATE(2332),
    [sym_sizeof_expression] = STATE(2332),
    [sym_subscript_expression] = STATE(2332),
    [sym_call_expression] = STATE(2332),
    [sym_field_expression] = STATE(2332),
    [sym_compound_literal_expression] = STATE(2332),
    [sym_parenthesized_expression] = STATE(2332),
    [sym_concatenated_string] = STATE(2332),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2332),
    [sym_new_expression] = STATE(2332),
    [sym_delete_expression] = STATE(2332),
    [sym_lambda_expression] = STATE(2332),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5368),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_sizeof] = ACTIONS(624),
    [sym_number_literal] = ACTIONS(5368),
    [sym_char_literal] = ACTIONS(5368),
    [sym_string_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(5370),
    [sym_false] = ACTIONS(5370),
    [sym_null] = ACTIONS(5370),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(640),
    [sym_nullptr] = ACTIONS(5370),
  },
  [1958] = {
    [sym_type_qualifier] = STATE(2333),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2333),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5372),
  },
  [1959] = {
    [sym__type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2335),
    [sym_enum_specifier] = STATE(2335),
    [sym_struct_specifier] = STATE(2335),
    [sym_union_specifier] = STATE(2335),
    [sym_macro_type_specifier] = STATE(2335),
    [sym_class_specifier] = STATE(2335),
    [sym_dependent_type] = STATE(2335),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2336),
    [anon_sym_unsigned] = ACTIONS(5374),
    [anon_sym_long] = ACTIONS(5374),
    [anon_sym_short] = ACTIONS(5374),
    [sym_primitive_type] = ACTIONS(5376),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(5376),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1960] = {
    [sym_type_qualifier] = STATE(2337),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2337),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5380),
  },
  [1961] = {
    [sym_type_qualifier] = STATE(1969),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1969),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(2900),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4458),
  },
  [1962] = {
    [sym_enumerator_list] = STATE(71),
    [anon_sym_LBRACE] = ACTIONS(125),
    [sym_identifier] = ACTIONS(5382),
    [sym_comment] = ACTIONS(49),
  },
  [1963] = {
    [sym_field_declaration_list] = STATE(77),
    [sym__class_name] = STATE(2339),
    [sym_base_class_clause] = STATE(79),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(135),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [1964] = {
    [sym_field_declaration_list] = STATE(84),
    [sym__class_name] = STATE(2340),
    [sym_base_class_clause] = STATE(86),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(139),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [1965] = {
    [sym_field_declaration_list] = STATE(92),
    [sym__class_name] = STATE(2341),
    [sym_base_class_clause] = STATE(94),
    [sym_template_type] = STATE(80),
    [sym_scoped_type_identifier] = STATE(624),
    [sym_scoped_namespace_identifier] = STATE(82),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(154),
    [anon_sym_COLON_COLON] = ACTIONS(137),
  },
  [1966] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1968),
    [anon_sym_unsigned] = ACTIONS(4444),
    [anon_sym_long] = ACTIONS(4444),
    [anon_sym_short] = ACTIONS(4444),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(4448),
    [anon_sym_struct] = ACTIONS(4450),
    [anon_sym_union] = ACTIONS(4452),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4454),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(4456),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [1967] = {
    [sym__abstract_declarator] = STATE(2344),
    [sym_abstract_pointer_declarator] = STATE(2344),
    [sym_abstract_function_declarator] = STATE(2344),
    [sym_abstract_array_declarator] = STATE(2344),
    [sym_parameter_list] = STATE(851),
    [sym_abstract_reference_declarator] = STATE(2344),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [sym_comment] = ACTIONS(49),
  },
  [1968] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2345),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(5390),
    [anon_sym_long] = ACTIONS(5390),
    [anon_sym_short] = ACTIONS(5390),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [1969] = {
    [sym_type_qualifier] = STATE(1969),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1969),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5392),
  },
  [1970] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(2362),
    [anon_sym_STAR_EQ] = ACTIONS(2362),
    [anon_sym_SLASH_EQ] = ACTIONS(2362),
    [anon_sym_PERCENT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_GT_EQ] = ACTIONS(2362),
    [anon_sym_AMP_EQ] = ACTIONS(2362),
    [anon_sym_CARET_EQ] = ACTIONS(2362),
    [anon_sym_PIPE_EQ] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_CARET] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_PERCENT] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DOT] = ACTIONS(2362),
    [anon_sym_DASH_GT] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [sym_operator_name] = ACTIONS(2362),
  },
  [1971] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5395),
    [sym_comment] = ACTIONS(49),
  },
  [1972] = {
    [sym_raw_string_literal] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [sym_number_literal] = ACTIONS(2362),
    [sym_char_literal] = ACTIONS(2362),
    [sym_string_literal] = ACTIONS(2362),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2364),
    [sym_nullptr] = ACTIONS(2364),
  },
  [1973] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5397),
    [sym_comment] = ACTIONS(49),
  },
  [1974] = {
    [anon_sym_RBRACE] = ACTIONS(5399),
    [sym_comment] = ACTIONS(49),
  },
  [1975] = {
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_EQ] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_restrict] = ACTIONS(1029),
    [anon_sym_volatile] = ACTIONS(1029),
    [anon_sym__Atomic] = ACTIONS(1029),
    [anon_sym_mutable] = ACTIONS(1029),
    [anon_sym_explicit] = ACTIONS(1029),
    [anon_sym_constexpr] = ACTIONS(1029),
    [anon_sym_COLON] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1029),
  },
  [1976] = {
    [aux_sym_enumerator_list_repeat1] = STATE(2350),
    [anon_sym_COMMA] = ACTIONS(5401),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [sym_comment] = ACTIONS(49),
  },
  [1977] = {
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_EQ] = ACTIONS(1039),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_restrict] = ACTIONS(1039),
    [anon_sym_volatile] = ACTIONS(1039),
    [anon_sym__Atomic] = ACTIONS(1039),
    [anon_sym_mutable] = ACTIONS(1039),
    [anon_sym_explicit] = ACTIONS(1039),
    [anon_sym_constexpr] = ACTIONS(1039),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_DASH_GT] = ACTIONS(1039),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1039),
  },
  [1978] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_EQ] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_restrict] = ACTIONS(1051),
    [anon_sym_volatile] = ACTIONS(1051),
    [anon_sym__Atomic] = ACTIONS(1051),
    [anon_sym_mutable] = ACTIONS(1051),
    [anon_sym_explicit] = ACTIONS(1051),
    [anon_sym_constexpr] = ACTIONS(1051),
    [anon_sym_COLON] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(1051),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1051),
  },
  [1979] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(593),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(593),
    [sym_field_declaration] = STATE(593),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(593),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(593),
    [sym_access_specifier] = STATE(593),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(593),
    [sym_alias_declaration] = STATE(593),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(593),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [1980] = {
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1121),
    [anon_sym_volatile] = ACTIONS(1121),
    [anon_sym__Atomic] = ACTIONS(1121),
    [anon_sym_mutable] = ACTIONS(1121),
    [anon_sym_explicit] = ACTIONS(1121),
    [anon_sym_constexpr] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_DASH_GT] = ACTIONS(1121),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1121),
  },
  [1981] = {
    [sym_field_declaration_list] = STATE(2352),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1982] = {
    [sym_field_declaration_list] = STATE(2352),
    [sym_base_class_clause] = STATE(2353),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1983] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1127),
    [anon_sym_volatile] = ACTIONS(1127),
    [anon_sym__Atomic] = ACTIONS(1127),
    [anon_sym_mutable] = ACTIONS(1127),
    [anon_sym_explicit] = ACTIONS(1127),
    [anon_sym_constexpr] = ACTIONS(1127),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1127),
  },
  [1984] = {
    [sym_field_declaration_list] = STATE(2354),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1985] = {
    [sym_field_declaration_list] = STATE(2354),
    [sym_base_class_clause] = STATE(2355),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1986] = {
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1159),
    [anon_sym_restrict] = ACTIONS(1157),
    [anon_sym_volatile] = ACTIONS(1157),
    [anon_sym__Atomic] = ACTIONS(1157),
    [anon_sym_mutable] = ACTIONS(1157),
    [anon_sym_explicit] = ACTIONS(1157),
    [anon_sym_constexpr] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1157),
    [sym_noexcept] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
  },
  [1987] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2357),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5405),
    [sym_comment] = ACTIONS(49),
  },
  [1988] = {
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_EQ] = ACTIONS(1186),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1186),
    [anon_sym_volatile] = ACTIONS(1186),
    [anon_sym__Atomic] = ACTIONS(1186),
    [anon_sym_mutable] = ACTIONS(1186),
    [anon_sym_explicit] = ACTIONS(1186),
    [anon_sym_constexpr] = ACTIONS(1186),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_DASH_GT] = ACTIONS(1186),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1186),
    [sym_noexcept] = ACTIONS(1186),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
  },
  [1989] = {
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_RPAREN] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_restrict] = ACTIONS(1196),
    [anon_sym_volatile] = ACTIONS(1196),
    [anon_sym__Atomic] = ACTIONS(1196),
    [anon_sym_mutable] = ACTIONS(1196),
    [anon_sym_explicit] = ACTIONS(1196),
    [anon_sym_constexpr] = ACTIONS(1196),
    [anon_sym_COLON] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_DASH_GT] = ACTIONS(1196),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1196),
  },
  [1990] = {
    [sym_field_declaration_list] = STATE(2358),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [1991] = {
    [sym_field_declaration_list] = STATE(2358),
    [sym_base_class_clause] = STATE(2359),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(422),
    [sym_comment] = ACTIONS(49),
  },
  [1992] = {
    [sym_parameter_list] = STATE(1994),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [1993] = {
    [sym_parameter_list] = STATE(1994),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_COLON] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [1994] = {
    [sym_type_qualifier] = STATE(2360),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2360),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [1995] = {
    [sym_type_qualifier] = STATE(2361),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2361),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(648),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5411),
  },
  [1996] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_EQ] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1859),
    [anon_sym_volatile] = ACTIONS(1859),
    [anon_sym__Atomic] = ACTIONS(1859),
    [anon_sym_mutable] = ACTIONS(1859),
    [anon_sym_explicit] = ACTIONS(1859),
    [anon_sym_constexpr] = ACTIONS(1859),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [anon_sym_DASH_GT] = ACTIONS(1859),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(1859),
    [sym_noexcept] = ACTIONS(1859),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
  },
  [1997] = {
    [anon_sym_LF] = ACTIONS(5413),
    [sym_comment] = ACTIONS(83),
  },
  [1998] = {
    [sym_raw_string_literal] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1881),
    [anon_sym_RBRACE] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_switch] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1883),
    [anon_sym_default] = ACTIONS(1883),
    [anon_sym_while] = ACTIONS(1883),
    [anon_sym_do] = ACTIONS(1883),
    [anon_sym_for] = ACTIONS(1883),
    [anon_sym_return] = ACTIONS(1883),
    [anon_sym_break] = ACTIONS(1883),
    [anon_sym_continue] = ACTIONS(1883),
    [anon_sym_goto] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1881),
    [anon_sym_sizeof] = ACTIONS(1883),
    [sym_number_literal] = ACTIONS(1881),
    [sym_char_literal] = ACTIONS(1881),
    [sym_string_literal] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [sym_null] = ACTIONS(1883),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1883),
    [sym_nullptr] = ACTIONS(1883),
  },
  [1999] = {
    [anon_sym_LF] = ACTIONS(5415),
    [sym_comment] = ACTIONS(83),
  },
  [2000] = {
    [sym_raw_string_literal] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_if] = ACTIONS(259),
    [anon_sym_switch] = ACTIONS(259),
    [anon_sym_case] = ACTIONS(259),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_while] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_for] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(259),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(259),
    [anon_sym_goto] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(257),
    [anon_sym_PLUS_PLUS] = ACTIONS(257),
    [anon_sym_sizeof] = ACTIONS(259),
    [sym_number_literal] = ACTIONS(257),
    [sym_char_literal] = ACTIONS(257),
    [sym_string_literal] = ACTIONS(257),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_new] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [anon_sym_delete] = ACTIONS(259),
    [sym_nullptr] = ACTIONS(259),
  },
  [2001] = {
    [sym_preproc_params] = STATE(2366),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(5417),
    [anon_sym_LF] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [2002] = {
    [sym_preproc_include] = STATE(2370),
    [sym_preproc_def] = STATE(2370),
    [sym_preproc_function_def] = STATE(2370),
    [sym_preproc_call] = STATE(2370),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2368),
    [sym_preproc_elif_in_compound_statement] = STATE(2369),
    [sym_declaration] = STATE(2370),
    [sym_type_definition] = STATE(2370),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2370),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2370),
    [sym_expression_statement] = STATE(2370),
    [sym_if_statement] = STATE(2370),
    [sym_switch_statement] = STATE(2370),
    [sym_case_statement] = STATE(2370),
    [sym_while_statement] = STATE(2370),
    [sym_do_statement] = STATE(2370),
    [sym_for_statement] = STATE(2370),
    [sym_return_statement] = STATE(2370),
    [sym_break_statement] = STATE(2370),
    [sym_continue_statement] = STATE(2370),
    [sym_goto_statement] = STATE(2370),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2370),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2370),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2370),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2003] = {
    [sym_preproc_include] = STATE(2374),
    [sym_preproc_def] = STATE(2374),
    [sym_preproc_function_def] = STATE(2374),
    [sym_preproc_call] = STATE(2374),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2372),
    [sym_preproc_elif_in_compound_statement] = STATE(2373),
    [sym_declaration] = STATE(2374),
    [sym_type_definition] = STATE(2374),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2374),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2374),
    [sym_expression_statement] = STATE(2374),
    [sym_if_statement] = STATE(2374),
    [sym_switch_statement] = STATE(2374),
    [sym_case_statement] = STATE(2374),
    [sym_while_statement] = STATE(2374),
    [sym_do_statement] = STATE(2374),
    [sym_for_statement] = STATE(2374),
    [sym_return_statement] = STATE(2374),
    [sym_break_statement] = STATE(2374),
    [sym_continue_statement] = STATE(2374),
    [sym_goto_statement] = STATE(2374),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2374),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2374),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2374),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5423),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2004] = {
    [sym_preproc_include] = STATE(2378),
    [sym_preproc_def] = STATE(2378),
    [sym_preproc_function_def] = STATE(2378),
    [sym_preproc_call] = STATE(2378),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2376),
    [sym_preproc_elif_in_compound_statement] = STATE(2377),
    [sym_declaration] = STATE(2378),
    [sym_type_definition] = STATE(2378),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2378),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2378),
    [sym_expression_statement] = STATE(2378),
    [sym_if_statement] = STATE(2378),
    [sym_switch_statement] = STATE(2378),
    [sym_case_statement] = STATE(2378),
    [sym_while_statement] = STATE(2378),
    [sym_do_statement] = STATE(2378),
    [sym_for_statement] = STATE(2378),
    [sym_return_statement] = STATE(2378),
    [sym_break_statement] = STATE(2378),
    [sym_continue_statement] = STATE(2378),
    [sym_goto_statement] = STATE(2378),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2378),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2378),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2378),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2378),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5425),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2005] = {
    [sym_string_literal] = ACTIONS(5427),
    [sym_system_lib_string] = ACTIONS(5427),
    [sym_comment] = ACTIONS(49),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(5429),
    [sym_comment] = ACTIONS(49),
  },
  [2007] = {
    [sym_preproc_arg] = ACTIONS(5431),
    [sym_comment] = ACTIONS(83),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(5433),
    [sym_comment] = ACTIONS(49),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(5435),
    [sym_comment] = ACTIONS(49),
  },
  [2010] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(5437),
    [anon_sym_LF] = ACTIONS(5439),
    [sym_comment] = ACTIONS(83),
  },
  [2011] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [2012] = {
    [sym_type_qualifier] = STATE(2387),
    [sym__type_specifier] = STATE(2386),
    [sym_sized_type_specifier] = STATE(2386),
    [sym_enum_specifier] = STATE(2386),
    [sym_struct_specifier] = STATE(2386),
    [sym_union_specifier] = STATE(2386),
    [sym_macro_type_specifier] = STATE(2386),
    [sym_class_specifier] = STATE(2386),
    [sym_dependent_type] = STATE(2386),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2387),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5441),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5441),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2013] = {
    [sym_preproc_include] = STATE(2389),
    [sym_preproc_def] = STATE(2389),
    [sym_preproc_function_def] = STATE(2389),
    [sym_preproc_call] = STATE(2389),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(2389),
    [sym_type_definition] = STATE(2389),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(2389),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2389),
    [sym_expression_statement] = STATE(2389),
    [sym_if_statement] = STATE(2389),
    [sym_switch_statement] = STATE(2389),
    [sym_case_statement] = STATE(2389),
    [sym_while_statement] = STATE(2389),
    [sym_do_statement] = STATE(2389),
    [sym_for_statement] = STATE(2389),
    [sym_return_statement] = STATE(2389),
    [sym_break_statement] = STATE(2389),
    [sym_continue_statement] = STATE(2389),
    [sym_goto_statement] = STATE(2389),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(2389),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2389),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2389),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2389),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2014] = {
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_constexpr] = ACTIONS(5447),
    [sym_comment] = ACTIONS(49),
  },
  [2015] = {
    [anon_sym_LPAREN] = ACTIONS(5449),
    [sym_comment] = ACTIONS(49),
  },
  [2016] = {
    [sym__expression] = STATE(2393),
    [sym_conditional_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_pointer_expression] = STATE(2393),
    [sym_logical_expression] = STATE(2393),
    [sym_bitwise_expression] = STATE(2393),
    [sym_equality_expression] = STATE(2393),
    [sym_relational_expression] = STATE(2393),
    [sym_shift_expression] = STATE(2393),
    [sym_math_expression] = STATE(2393),
    [sym_cast_expression] = STATE(2393),
    [sym_sizeof_expression] = STATE(2393),
    [sym_subscript_expression] = STATE(2393),
    [sym_call_expression] = STATE(2393),
    [sym_field_expression] = STATE(2393),
    [sym_compound_literal_expression] = STATE(2393),
    [sym_parenthesized_expression] = STATE(2393),
    [sym_concatenated_string] = STATE(2393),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2393),
    [sym_new_expression] = STATE(2393),
    [sym_delete_expression] = STATE(2393),
    [sym_lambda_expression] = STATE(2393),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5451),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(5451),
    [sym_char_literal] = ACTIONS(5451),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5453),
    [sym_false] = ACTIONS(5453),
    [sym_null] = ACTIONS(5453),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5453),
  },
  [2017] = {
    [anon_sym_COLON] = ACTIONS(5455),
    [sym_comment] = ACTIONS(49),
  },
  [2018] = {
    [anon_sym_LPAREN] = ACTIONS(5457),
    [sym_comment] = ACTIONS(49),
  },
  [2019] = {
    [sym_compound_statement] = STATE(2396),
    [sym_labeled_statement] = STATE(2396),
    [sym_expression_statement] = STATE(2396),
    [sym_if_statement] = STATE(2396),
    [sym_switch_statement] = STATE(2396),
    [sym_case_statement] = STATE(2396),
    [sym_while_statement] = STATE(2396),
    [sym_do_statement] = STATE(2396),
    [sym_for_statement] = STATE(2396),
    [sym_return_statement] = STATE(2396),
    [sym_break_statement] = STATE(2396),
    [sym_continue_statement] = STATE(2396),
    [sym_goto_statement] = STATE(2396),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2396),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2020] = {
    [anon_sym_LPAREN] = ACTIONS(5459),
    [sym_comment] = ACTIONS(49),
  },
  [2021] = {
    [sym__expression] = STATE(2399),
    [sym_conditional_expression] = STATE(2399),
    [sym_assignment_expression] = STATE(2399),
    [sym_pointer_expression] = STATE(2399),
    [sym_logical_expression] = STATE(2399),
    [sym_bitwise_expression] = STATE(2399),
    [sym_equality_expression] = STATE(2399),
    [sym_relational_expression] = STATE(2399),
    [sym_shift_expression] = STATE(2399),
    [sym_math_expression] = STATE(2399),
    [sym_cast_expression] = STATE(2399),
    [sym_sizeof_expression] = STATE(2399),
    [sym_subscript_expression] = STATE(2399),
    [sym_call_expression] = STATE(2399),
    [sym_field_expression] = STATE(2399),
    [sym_compound_literal_expression] = STATE(2399),
    [sym_parenthesized_expression] = STATE(2399),
    [sym_initializer_list] = STATE(2400),
    [sym_concatenated_string] = STATE(2399),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2399),
    [sym_new_expression] = STATE(2399),
    [sym_delete_expression] = STATE(2399),
    [sym_lambda_expression] = STATE(2399),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5461),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(5463),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5461),
    [sym_char_literal] = ACTIONS(5461),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5465),
    [sym_false] = ACTIONS(5465),
    [sym_null] = ACTIONS(5465),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5465),
  },
  [2022] = {
    [anon_sym_SEMI] = ACTIONS(5467),
    [sym_comment] = ACTIONS(49),
  },
  [2023] = {
    [anon_sym_SEMI] = ACTIONS(5469),
    [sym_comment] = ACTIONS(49),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(5471),
    [sym_comment] = ACTIONS(49),
  },
  [2025] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(5473),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
    [sym_operator_name] = ACTIONS(146),
  },
  [2026] = {
    [sym_raw_string_literal] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1788),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1788),
    [sym_preproc_directive] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1786),
    [anon_sym_typedef] = ACTIONS(1788),
    [anon_sym_extern] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1786),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_register] = ACTIONS(1788),
    [anon_sym_inline] = ACTIONS(1788),
    [anon_sym_const] = ACTIONS(1788),
    [anon_sym_restrict] = ACTIONS(1788),
    [anon_sym_volatile] = ACTIONS(1788),
    [anon_sym__Atomic] = ACTIONS(1788),
    [anon_sym_mutable] = ACTIONS(1788),
    [anon_sym_explicit] = ACTIONS(1788),
    [anon_sym_constexpr] = ACTIONS(1788),
    [anon_sym_unsigned] = ACTIONS(1788),
    [anon_sym_long] = ACTIONS(1788),
    [anon_sym_short] = ACTIONS(1788),
    [sym_primitive_type] = ACTIONS(1788),
    [anon_sym_enum] = ACTIONS(1788),
    [anon_sym_struct] = ACTIONS(1788),
    [anon_sym_union] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(1788),
    [anon_sym_case] = ACTIONS(1788),
    [anon_sym_default] = ACTIONS(1788),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_do] = ACTIONS(1788),
    [anon_sym_for] = ACTIONS(1788),
    [anon_sym_return] = ACTIONS(1788),
    [anon_sym_break] = ACTIONS(1788),
    [anon_sym_continue] = ACTIONS(1788),
    [anon_sym_goto] = ACTIONS(1788),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_TILDE] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_sizeof] = ACTIONS(1788),
    [sym_number_literal] = ACTIONS(1786),
    [sym_char_literal] = ACTIONS(1786),
    [sym_string_literal] = ACTIONS(1786),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1788),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1788),
    [sym_auto] = ACTIONS(1788),
    [anon_sym_typename] = ACTIONS(1788),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_delete] = ACTIONS(1788),
    [sym_nullptr] = ACTIONS(1788),
  },
  [2027] = {
    [sym_raw_string_literal] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1792),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1792),
    [sym_preproc_directive] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_typedef] = ACTIONS(1792),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_register] = ACTIONS(1792),
    [anon_sym_inline] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_restrict] = ACTIONS(1792),
    [anon_sym_volatile] = ACTIONS(1792),
    [anon_sym__Atomic] = ACTIONS(1792),
    [anon_sym_mutable] = ACTIONS(1792),
    [anon_sym_explicit] = ACTIONS(1792),
    [anon_sym_constexpr] = ACTIONS(1792),
    [anon_sym_unsigned] = ACTIONS(1792),
    [anon_sym_long] = ACTIONS(1792),
    [anon_sym_short] = ACTIONS(1792),
    [sym_primitive_type] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(1792),
    [anon_sym_union] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_goto] = ACTIONS(1792),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1790),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1790),
    [anon_sym_sizeof] = ACTIONS(1792),
    [sym_number_literal] = ACTIONS(1790),
    [sym_char_literal] = ACTIONS(1790),
    [sym_string_literal] = ACTIONS(1790),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(1792),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1792),
    [sym_auto] = ACTIONS(1792),
    [anon_sym_typename] = ACTIONS(1792),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_COLON_COLON] = ACTIONS(1790),
    [anon_sym_delete] = ACTIONS(1792),
    [sym_nullptr] = ACTIONS(1792),
  },
  [2028] = {
    [sym__declarator] = STATE(2406),
    [sym_pointer_declarator] = STATE(2406),
    [sym_function_declarator] = STATE(2406),
    [sym_array_declarator] = STATE(2406),
    [sym_init_declarator] = STATE(2407),
    [sym_reference_declarator] = STATE(2406),
    [sym_structured_binding_reference_declarator] = STATE(2408),
    [sym_structured_binding_declarator] = STATE(2409),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2406),
    [sym_destructor_name] = STATE(2406),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(5475),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_AMP] = ACTIONS(208),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5477),
  },
  [2029] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(5479),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2030] = {
    [anon_sym_SEMI] = ACTIONS(5479),
    [sym_comment] = ACTIONS(49),
  },
  [2031] = {
    [sym_preproc_include] = STATE(2411),
    [sym_preproc_def] = STATE(2411),
    [sym_preproc_function_def] = STATE(2411),
    [sym_preproc_call] = STATE(2411),
    [sym_preproc_if_in_compound_statement] = STATE(2026),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2027),
    [sym_declaration] = STATE(2411),
    [sym_type_definition] = STATE(2411),
    [sym__declaration_specifiers] = STATE(2028),
    [sym_compound_statement] = STATE(2411),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2411),
    [sym_expression_statement] = STATE(2411),
    [sym_if_statement] = STATE(2411),
    [sym_switch_statement] = STATE(2411),
    [sym_case_statement] = STATE(2411),
    [sym_while_statement] = STATE(2411),
    [sym_do_statement] = STATE(2411),
    [sym_for_statement] = STATE(2411),
    [sym_return_statement] = STATE(2411),
    [sym_break_statement] = STATE(2411),
    [sym_continue_statement] = STATE(2411),
    [sym_goto_statement] = STATE(2411),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym__empty_declaration] = STATE(2411),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2411),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2411),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2411),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4517),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4521),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5481),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4527),
    [sym_preproc_directive] = ACTIONS(4529),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_typedef] = ACTIONS(4533),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(4561),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2032] = {
    [sym_preproc_include] = STATE(2414),
    [sym_preproc_def] = STATE(2414),
    [sym_preproc_function_def] = STATE(2414),
    [sym_preproc_call] = STATE(2414),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2412),
    [sym_preproc_elif_in_compound_statement] = STATE(2413),
    [sym_declaration] = STATE(2414),
    [sym_type_definition] = STATE(2414),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2414),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2414),
    [sym_expression_statement] = STATE(2414),
    [sym_if_statement] = STATE(2414),
    [sym_switch_statement] = STATE(2414),
    [sym_case_statement] = STATE(2414),
    [sym_while_statement] = STATE(2414),
    [sym_do_statement] = STATE(2414),
    [sym_for_statement] = STATE(2414),
    [sym_return_statement] = STATE(2414),
    [sym_break_statement] = STATE(2414),
    [sym_continue_statement] = STATE(2414),
    [sym_goto_statement] = STATE(2414),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2414),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2414),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2414),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2414),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5483),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2033] = {
    [sym_preproc_arg] = ACTIONS(5485),
    [sym_comment] = ACTIONS(83),
  },
  [2034] = {
    [sym_raw_string_literal] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_switch] = ACTIONS(317),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_while] = ACTIONS(317),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(317),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(317),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_DASH_DASH] = ACTIONS(315),
    [anon_sym_PLUS_PLUS] = ACTIONS(315),
    [anon_sym_sizeof] = ACTIONS(317),
    [sym_number_literal] = ACTIONS(315),
    [sym_char_literal] = ACTIONS(315),
    [sym_string_literal] = ACTIONS(315),
    [sym_true] = ACTIONS(317),
    [sym_false] = ACTIONS(317),
    [sym_null] = ACTIONS(317),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [anon_sym_delete] = ACTIONS(317),
    [sym_nullptr] = ACTIONS(317),
  },
  [2035] = {
    [sym__type_declarator] = STATE(2416),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2036] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(2417),
    [sym_sized_type_specifier] = STATE(2417),
    [sym_enum_specifier] = STATE(2417),
    [sym_struct_specifier] = STATE(2417),
    [sym_union_specifier] = STATE(2417),
    [sym_macro_type_specifier] = STATE(2417),
    [sym_class_specifier] = STATE(2417),
    [sym_dependent_type] = STATE(2417),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5487),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5487),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2037] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [2038] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2039] = {
    [sym__expression] = STATE(2419),
    [sym_conditional_expression] = STATE(2419),
    [sym_assignment_expression] = STATE(2419),
    [sym_pointer_expression] = STATE(2419),
    [sym_logical_expression] = STATE(2419),
    [sym_bitwise_expression] = STATE(2419),
    [sym_equality_expression] = STATE(2419),
    [sym_relational_expression] = STATE(2419),
    [sym_shift_expression] = STATE(2419),
    [sym_math_expression] = STATE(2419),
    [sym_cast_expression] = STATE(2419),
    [sym_sizeof_expression] = STATE(2419),
    [sym_subscript_expression] = STATE(2419),
    [sym_call_expression] = STATE(2419),
    [sym_field_expression] = STATE(2419),
    [sym_compound_literal_expression] = STATE(2419),
    [sym_parenthesized_expression] = STATE(2419),
    [sym_concatenated_string] = STATE(2419),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2419),
    [sym_new_expression] = STATE(2419),
    [sym_delete_expression] = STATE(2419),
    [sym_lambda_expression] = STATE(2419),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5491),
    [sym_char_literal] = ACTIONS(5491),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5493),
    [sym_false] = ACTIONS(5493),
    [sym_null] = ACTIONS(5493),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5493),
  },
  [2040] = {
    [anon_sym_LPAREN] = ACTIONS(5495),
    [sym_comment] = ACTIONS(49),
  },
  [2041] = {
    [sym__expression] = STATE(2421),
    [sym_conditional_expression] = STATE(2421),
    [sym_assignment_expression] = STATE(2421),
    [sym_pointer_expression] = STATE(2421),
    [sym_logical_expression] = STATE(2421),
    [sym_bitwise_expression] = STATE(2421),
    [sym_equality_expression] = STATE(2421),
    [sym_relational_expression] = STATE(2421),
    [sym_shift_expression] = STATE(2421),
    [sym_math_expression] = STATE(2421),
    [sym_cast_expression] = STATE(2421),
    [sym_sizeof_expression] = STATE(2421),
    [sym_subscript_expression] = STATE(2421),
    [sym_call_expression] = STATE(2421),
    [sym_field_expression] = STATE(2421),
    [sym_compound_literal_expression] = STATE(2421),
    [sym_parenthesized_expression] = STATE(2421),
    [sym_concatenated_string] = STATE(2421),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2421),
    [sym_new_expression] = STATE(2421),
    [sym_delete_expression] = STATE(2421),
    [sym_lambda_expression] = STATE(2421),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5497),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5497),
    [sym_char_literal] = ACTIONS(5497),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5499),
    [sym_false] = ACTIONS(5499),
    [sym_null] = ACTIONS(5499),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5499),
  },
  [2042] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5501),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2043] = {
    [sym_declaration] = STATE(2424),
    [sym_type_definition] = STATE(2424),
    [sym__declaration_specifiers] = STATE(2425),
    [sym_compound_statement] = STATE(2424),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2424),
    [sym_expression_statement] = STATE(2424),
    [sym_if_statement] = STATE(2424),
    [sym_switch_statement] = STATE(2424),
    [sym_case_statement] = STATE(2424),
    [sym_while_statement] = STATE(2424),
    [sym_do_statement] = STATE(2424),
    [sym_for_statement] = STATE(2424),
    [sym_return_statement] = STATE(2424),
    [sym_break_statement] = STATE(2424),
    [sym_continue_statement] = STATE(2424),
    [sym_goto_statement] = STATE(2424),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2424),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5503),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2044] = {
    [sym__expression] = STATE(2426),
    [sym_conditional_expression] = STATE(2426),
    [sym_assignment_expression] = STATE(2426),
    [sym_pointer_expression] = STATE(2426),
    [sym_logical_expression] = STATE(2426),
    [sym_bitwise_expression] = STATE(2426),
    [sym_equality_expression] = STATE(2426),
    [sym_relational_expression] = STATE(2426),
    [sym_shift_expression] = STATE(2426),
    [sym_math_expression] = STATE(2426),
    [sym_cast_expression] = STATE(2426),
    [sym_sizeof_expression] = STATE(2426),
    [sym_subscript_expression] = STATE(2426),
    [sym_call_expression] = STATE(2426),
    [sym_field_expression] = STATE(2426),
    [sym_compound_literal_expression] = STATE(2426),
    [sym_parenthesized_expression] = STATE(2426),
    [sym_concatenated_string] = STATE(2426),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2426),
    [sym_new_expression] = STATE(2426),
    [sym_delete_expression] = STATE(2426),
    [sym_lambda_expression] = STATE(2426),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5505),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5505),
    [sym_char_literal] = ACTIONS(5505),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5507),
    [sym_false] = ACTIONS(5507),
    [sym_null] = ACTIONS(5507),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5507),
  },
  [2045] = {
    [anon_sym_while] = ACTIONS(5509),
    [sym_comment] = ACTIONS(49),
  },
  [2046] = {
    [sym_declaration] = STATE(2428),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(2429),
    [sym_conditional_expression] = STATE(2429),
    [sym_assignment_expression] = STATE(2429),
    [sym_pointer_expression] = STATE(2429),
    [sym_logical_expression] = STATE(2429),
    [sym_bitwise_expression] = STATE(2429),
    [sym_equality_expression] = STATE(2429),
    [sym_relational_expression] = STATE(2429),
    [sym_shift_expression] = STATE(2429),
    [sym_math_expression] = STATE(2429),
    [sym_cast_expression] = STATE(2429),
    [sym_sizeof_expression] = STATE(2429),
    [sym_subscript_expression] = STATE(2429),
    [sym_call_expression] = STATE(2429),
    [sym_field_expression] = STATE(2429),
    [sym_compound_literal_expression] = STATE(2429),
    [sym_parenthesized_expression] = STATE(2429),
    [sym_concatenated_string] = STATE(2429),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2429),
    [sym_for_range_declaration] = STATE(2430),
    [sym_new_expression] = STATE(2429),
    [sym_delete_expression] = STATE(2429),
    [sym_lambda_expression] = STATE(2429),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(5511),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(5513),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5511),
    [sym_char_literal] = ACTIONS(5511),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5515),
    [sym_false] = ACTIONS(5515),
    [sym_null] = ACTIONS(5515),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5515),
  },
  [2047] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [2048] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5517),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2049] = {
    [anon_sym_SEMI] = ACTIONS(5517),
    [sym_comment] = ACTIONS(49),
  },
  [2050] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [2051] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [2052] = {
    [anon_sym_SEMI] = ACTIONS(5519),
    [sym_comment] = ACTIONS(49),
  },
  [2053] = {
    [sym_compound_statement] = STATE(2434),
    [sym_labeled_statement] = STATE(2434),
    [sym_expression_statement] = STATE(2434),
    [sym_if_statement] = STATE(2434),
    [sym_switch_statement] = STATE(2434),
    [sym_case_statement] = STATE(2434),
    [sym_while_statement] = STATE(2434),
    [sym_do_statement] = STATE(2434),
    [sym_for_statement] = STATE(2434),
    [sym_return_statement] = STATE(2434),
    [sym_break_statement] = STATE(2434),
    [sym_continue_statement] = STATE(2434),
    [sym_goto_statement] = STATE(2434),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2434),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2054] = {
    [sym_raw_string_literal] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5525),
    [anon_sym_LPAREN] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym_LBRACE] = ACTIONS(5523),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_LBRACK] = ACTIONS(5523),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [anon_sym_if] = ACTIONS(5525),
    [anon_sym_switch] = ACTIONS(5525),
    [anon_sym_case] = ACTIONS(5525),
    [anon_sym_default] = ACTIONS(5525),
    [anon_sym_while] = ACTIONS(5525),
    [anon_sym_do] = ACTIONS(5525),
    [anon_sym_for] = ACTIONS(5525),
    [anon_sym_return] = ACTIONS(5525),
    [anon_sym_break] = ACTIONS(5525),
    [anon_sym_continue] = ACTIONS(5525),
    [anon_sym_goto] = ACTIONS(5525),
    [anon_sym_AMP] = ACTIONS(5523),
    [anon_sym_BANG] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_PLUS] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [anon_sym_DASH_DASH] = ACTIONS(5523),
    [anon_sym_PLUS_PLUS] = ACTIONS(5523),
    [anon_sym_sizeof] = ACTIONS(5525),
    [sym_number_literal] = ACTIONS(5523),
    [sym_char_literal] = ACTIONS(5523),
    [sym_string_literal] = ACTIONS(5523),
    [sym_true] = ACTIONS(5525),
    [sym_false] = ACTIONS(5525),
    [sym_null] = ACTIONS(5525),
    [sym_identifier] = ACTIONS(5525),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5525),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_new] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_delete] = ACTIONS(5525),
    [sym_nullptr] = ACTIONS(5525),
  },
  [2055] = {
    [sym_raw_string_literal] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5529),
    [anon_sym_LPAREN] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_RBRACE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5527),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [anon_sym_if] = ACTIONS(5529),
    [anon_sym_switch] = ACTIONS(5529),
    [anon_sym_case] = ACTIONS(5529),
    [anon_sym_default] = ACTIONS(5529),
    [anon_sym_while] = ACTIONS(5529),
    [anon_sym_do] = ACTIONS(5529),
    [anon_sym_for] = ACTIONS(5529),
    [anon_sym_return] = ACTIONS(5529),
    [anon_sym_break] = ACTIONS(5529),
    [anon_sym_continue] = ACTIONS(5529),
    [anon_sym_goto] = ACTIONS(5529),
    [anon_sym_AMP] = ACTIONS(5527),
    [anon_sym_BANG] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5529),
    [anon_sym_DASH_DASH] = ACTIONS(5527),
    [anon_sym_PLUS_PLUS] = ACTIONS(5527),
    [anon_sym_sizeof] = ACTIONS(5529),
    [sym_number_literal] = ACTIONS(5527),
    [sym_char_literal] = ACTIONS(5527),
    [sym_string_literal] = ACTIONS(5527),
    [sym_true] = ACTIONS(5529),
    [sym_false] = ACTIONS(5529),
    [sym_null] = ACTIONS(5529),
    [sym_identifier] = ACTIONS(5529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5529),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_new] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_delete] = ACTIONS(5529),
    [sym_nullptr] = ACTIONS(5529),
  },
  [2056] = {
    [sym_raw_string_literal] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_goto] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_sizeof] = ACTIONS(556),
    [sym_number_literal] = ACTIONS(554),
    [sym_char_literal] = ACTIONS(554),
    [sym_string_literal] = ACTIONS(554),
    [sym_true] = ACTIONS(556),
    [sym_false] = ACTIONS(556),
    [sym_null] = ACTIONS(556),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_delete] = ACTIONS(556),
    [sym_nullptr] = ACTIONS(556),
  },
  [2057] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(2436),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [2058] = {
    [aux_sym_declaration_repeat1] = STATE(2436),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(5531),
    [sym_comment] = ACTIONS(49),
  },
  [2059] = {
    [sym_argument_list] = STATE(2438),
    [sym_initializer_list] = STATE(2438),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(5533),
    [sym_comment] = ACTIONS(49),
  },
  [2060] = {
    [sym_argument_list] = STATE(2440),
    [sym_initializer_list] = STATE(2440),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(5535),
    [sym_comment] = ACTIONS(49),
  },
  [2061] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [2062] = {
    [sym_raw_string_literal] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym_LBRACE] = ACTIONS(5537),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [anon_sym_if] = ACTIONS(5539),
    [anon_sym_switch] = ACTIONS(5539),
    [anon_sym_case] = ACTIONS(5539),
    [anon_sym_default] = ACTIONS(5539),
    [anon_sym_while] = ACTIONS(5539),
    [anon_sym_do] = ACTIONS(5539),
    [anon_sym_for] = ACTIONS(5539),
    [anon_sym_return] = ACTIONS(5539),
    [anon_sym_break] = ACTIONS(5539),
    [anon_sym_continue] = ACTIONS(5539),
    [anon_sym_goto] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_BANG] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_PLUS] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5539),
    [anon_sym_DASH_DASH] = ACTIONS(5537),
    [anon_sym_PLUS_PLUS] = ACTIONS(5537),
    [anon_sym_sizeof] = ACTIONS(5539),
    [sym_number_literal] = ACTIONS(5537),
    [sym_char_literal] = ACTIONS(5537),
    [sym_string_literal] = ACTIONS(5537),
    [sym_true] = ACTIONS(5539),
    [sym_false] = ACTIONS(5539),
    [sym_null] = ACTIONS(5539),
    [sym_identifier] = ACTIONS(5539),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5539),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_new] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_delete] = ACTIONS(5539),
    [sym_nullptr] = ACTIONS(5539),
  },
  [2063] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5541),
    [sym_comment] = ACTIONS(49),
  },
  [2064] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(49),
  },
  [2065] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(5545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5548),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5551),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5557),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5557),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5557),
    [sym_preproc_directive] = ACTIONS(5565),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_typedef] = ACTIONS(5571),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3325),
    [anon_sym_long] = ACTIONS(3325),
    [anon_sym_short] = ACTIONS(3325),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3334),
    [anon_sym_union] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(5577),
    [anon_sym_switch] = ACTIONS(5580),
    [anon_sym_case] = ACTIONS(5583),
    [anon_sym_default] = ACTIONS(5586),
    [anon_sym_while] = ACTIONS(5589),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_for] = ACTIONS(5595),
    [anon_sym_return] = ACTIONS(5598),
    [anon_sym_break] = ACTIONS(5601),
    [anon_sym_continue] = ACTIONS(5604),
    [anon_sym_goto] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_sizeof] = ACTIONS(3385),
    [sym_number_literal] = ACTIONS(5545),
    [sym_char_literal] = ACTIONS(5545),
    [sym_string_literal] = ACTIONS(3388),
    [sym_true] = ACTIONS(5610),
    [sym_false] = ACTIONS(5610),
    [sym_null] = ACTIONS(5610),
    [sym_identifier] = ACTIONS(5613),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3397),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3409),
    [sym_nullptr] = ACTIONS(5610),
  },
  [2066] = {
    [sym_raw_string_literal] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5618),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [anon_sym_if] = ACTIONS(5618),
    [anon_sym_switch] = ACTIONS(5618),
    [anon_sym_case] = ACTIONS(5618),
    [anon_sym_default] = ACTIONS(5618),
    [anon_sym_while] = ACTIONS(5618),
    [anon_sym_do] = ACTIONS(5618),
    [anon_sym_for] = ACTIONS(5618),
    [anon_sym_return] = ACTIONS(5618),
    [anon_sym_break] = ACTIONS(5618),
    [anon_sym_continue] = ACTIONS(5618),
    [anon_sym_goto] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_BANG] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_sizeof] = ACTIONS(5618),
    [sym_number_literal] = ACTIONS(5616),
    [sym_char_literal] = ACTIONS(5616),
    [sym_string_literal] = ACTIONS(5616),
    [sym_true] = ACTIONS(5618),
    [sym_false] = ACTIONS(5618),
    [sym_null] = ACTIONS(5618),
    [sym_identifier] = ACTIONS(5618),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5618),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_new] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_delete] = ACTIONS(5618),
    [sym_nullptr] = ACTIONS(5618),
  },
  [2067] = {
    [sym_raw_string_literal] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5622),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [anon_sym_if] = ACTIONS(5622),
    [anon_sym_switch] = ACTIONS(5622),
    [anon_sym_case] = ACTIONS(5622),
    [anon_sym_default] = ACTIONS(5622),
    [anon_sym_while] = ACTIONS(5622),
    [anon_sym_do] = ACTIONS(5622),
    [anon_sym_for] = ACTIONS(5622),
    [anon_sym_return] = ACTIONS(5622),
    [anon_sym_break] = ACTIONS(5622),
    [anon_sym_continue] = ACTIONS(5622),
    [anon_sym_goto] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5620),
    [anon_sym_BANG] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_sizeof] = ACTIONS(5622),
    [sym_number_literal] = ACTIONS(5620),
    [sym_char_literal] = ACTIONS(5620),
    [sym_string_literal] = ACTIONS(5620),
    [sym_true] = ACTIONS(5622),
    [sym_false] = ACTIONS(5622),
    [sym_null] = ACTIONS(5622),
    [sym_identifier] = ACTIONS(5622),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5622),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_new] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_delete] = ACTIONS(5622),
    [sym_nullptr] = ACTIONS(5622),
  },
  [2068] = {
    [sym_raw_string_literal] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5626),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5626),
    [anon_sym_switch] = ACTIONS(5626),
    [anon_sym_case] = ACTIONS(5626),
    [anon_sym_default] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5626),
    [anon_sym_do] = ACTIONS(5626),
    [anon_sym_for] = ACTIONS(5626),
    [anon_sym_return] = ACTIONS(5626),
    [anon_sym_break] = ACTIONS(5626),
    [anon_sym_continue] = ACTIONS(5626),
    [anon_sym_goto] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5624),
    [anon_sym_BANG] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_sizeof] = ACTIONS(5626),
    [sym_number_literal] = ACTIONS(5624),
    [sym_char_literal] = ACTIONS(5624),
    [sym_string_literal] = ACTIONS(5624),
    [sym_true] = ACTIONS(5626),
    [sym_false] = ACTIONS(5626),
    [sym_null] = ACTIONS(5626),
    [sym_identifier] = ACTIONS(5626),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5626),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_new] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_delete] = ACTIONS(5626),
    [sym_nullptr] = ACTIONS(5626),
  },
  [2069] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
  },
  [2070] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5630),
    [sym_comment] = ACTIONS(49),
  },
  [2071] = {
    [sym_raw_string_literal] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [anon_sym_if] = ACTIONS(5634),
    [anon_sym_switch] = ACTIONS(5634),
    [anon_sym_case] = ACTIONS(5634),
    [anon_sym_default] = ACTIONS(5634),
    [anon_sym_while] = ACTIONS(5634),
    [anon_sym_do] = ACTIONS(5634),
    [anon_sym_for] = ACTIONS(5634),
    [anon_sym_return] = ACTIONS(5634),
    [anon_sym_break] = ACTIONS(5634),
    [anon_sym_continue] = ACTIONS(5634),
    [anon_sym_goto] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_BANG] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_sizeof] = ACTIONS(5634),
    [sym_number_literal] = ACTIONS(5632),
    [sym_char_literal] = ACTIONS(5632),
    [sym_string_literal] = ACTIONS(5632),
    [sym_true] = ACTIONS(5634),
    [sym_false] = ACTIONS(5634),
    [sym_null] = ACTIONS(5634),
    [sym_identifier] = ACTIONS(5634),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5634),
    [sym_auto] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_delete] = ACTIONS(5634),
    [sym_nullptr] = ACTIONS(5634),
  },
  [2072] = {
    [sym_raw_string_literal] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5638),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [anon_sym_if] = ACTIONS(5638),
    [anon_sym_switch] = ACTIONS(5638),
    [anon_sym_case] = ACTIONS(5638),
    [anon_sym_default] = ACTIONS(5638),
    [anon_sym_while] = ACTIONS(5638),
    [anon_sym_do] = ACTIONS(5638),
    [anon_sym_for] = ACTIONS(5638),
    [anon_sym_return] = ACTIONS(5638),
    [anon_sym_break] = ACTIONS(5638),
    [anon_sym_continue] = ACTIONS(5638),
    [anon_sym_goto] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5636),
    [anon_sym_BANG] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_sizeof] = ACTIONS(5638),
    [sym_number_literal] = ACTIONS(5636),
    [sym_char_literal] = ACTIONS(5636),
    [sym_string_literal] = ACTIONS(5636),
    [sym_true] = ACTIONS(5638),
    [sym_false] = ACTIONS(5638),
    [sym_null] = ACTIONS(5638),
    [sym_identifier] = ACTIONS(5638),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5638),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_new] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_delete] = ACTIONS(5638),
    [sym_nullptr] = ACTIONS(5638),
  },
  [2073] = {
    [sym_raw_string_literal] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5642),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [anon_sym_if] = ACTIONS(5642),
    [anon_sym_switch] = ACTIONS(5642),
    [anon_sym_case] = ACTIONS(5642),
    [anon_sym_default] = ACTIONS(5642),
    [anon_sym_while] = ACTIONS(5642),
    [anon_sym_do] = ACTIONS(5642),
    [anon_sym_for] = ACTIONS(5642),
    [anon_sym_return] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(5642),
    [anon_sym_continue] = ACTIONS(5642),
    [anon_sym_goto] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_BANG] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_sizeof] = ACTIONS(5642),
    [sym_number_literal] = ACTIONS(5640),
    [sym_char_literal] = ACTIONS(5640),
    [sym_string_literal] = ACTIONS(5640),
    [sym_true] = ACTIONS(5642),
    [sym_false] = ACTIONS(5642),
    [sym_null] = ACTIONS(5642),
    [sym_identifier] = ACTIONS(5642),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5642),
    [sym_auto] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_new] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_delete] = ACTIONS(5642),
    [sym_nullptr] = ACTIONS(5642),
  },
  [2074] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5644),
    [sym_comment] = ACTIONS(49),
  },
  [2075] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5646),
    [sym_comment] = ACTIONS(49),
  },
  [2076] = {
    [sym_raw_string_literal] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2030),
    [sym_char_literal] = ACTIONS(2030),
    [sym_string_literal] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_delete] = ACTIONS(2032),
    [sym_nullptr] = ACTIONS(2032),
  },
  [2077] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [2078] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2079] = {
    [anon_sym_RPAREN] = ACTIONS(5650),
    [sym_comment] = ACTIONS(49),
  },
  [2080] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(2449),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [2081] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2082] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2450),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(5652),
    [sym_comment] = ACTIONS(49),
  },
  [2083] = {
    [sym__expression] = STATE(2452),
    [sym_conditional_expression] = STATE(2452),
    [sym_assignment_expression] = STATE(2452),
    [sym_pointer_expression] = STATE(2452),
    [sym_logical_expression] = STATE(2452),
    [sym_bitwise_expression] = STATE(2452),
    [sym_equality_expression] = STATE(2452),
    [sym_relational_expression] = STATE(2452),
    [sym_shift_expression] = STATE(2452),
    [sym_math_expression] = STATE(2452),
    [sym_cast_expression] = STATE(2452),
    [sym_sizeof_expression] = STATE(2452),
    [sym_subscript_expression] = STATE(2452),
    [sym_call_expression] = STATE(2452),
    [sym_field_expression] = STATE(2452),
    [sym_compound_literal_expression] = STATE(2452),
    [sym_parenthesized_expression] = STATE(2452),
    [sym_concatenated_string] = STATE(2452),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2452),
    [sym_new_expression] = STATE(2452),
    [sym_delete_expression] = STATE(2452),
    [sym_lambda_expression] = STATE(2452),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5654),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5654),
    [sym_char_literal] = ACTIONS(5654),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5658),
    [sym_false] = ACTIONS(5658),
    [sym_null] = ACTIONS(5658),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5658),
  },
  [2084] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5660),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [2085] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2086] = {
    [sym_compound_statement] = STATE(2468),
    [sym_labeled_statement] = STATE(2468),
    [sym_expression_statement] = STATE(2468),
    [sym_if_statement] = STATE(2468),
    [sym_switch_statement] = STATE(2468),
    [sym_case_statement] = STATE(2468),
    [sym_while_statement] = STATE(2468),
    [sym_do_statement] = STATE(2468),
    [sym_for_statement] = STATE(2468),
    [sym_return_statement] = STATE(2468),
    [sym_break_statement] = STATE(2468),
    [sym_continue_statement] = STATE(2468),
    [sym_goto_statement] = STATE(2468),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(2468),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2087] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(2836),
  },
  [2088] = {
    [sym__expression] = STATE(2471),
    [sym_conditional_expression] = STATE(2471),
    [sym_assignment_expression] = STATE(2471),
    [sym_pointer_expression] = STATE(2471),
    [sym_logical_expression] = STATE(2471),
    [sym_bitwise_expression] = STATE(2471),
    [sym_equality_expression] = STATE(2471),
    [sym_relational_expression] = STATE(2471),
    [sym_shift_expression] = STATE(2471),
    [sym_math_expression] = STATE(2471),
    [sym_cast_expression] = STATE(2471),
    [sym_sizeof_expression] = STATE(2471),
    [sym_subscript_expression] = STATE(2471),
    [sym_call_expression] = STATE(2471),
    [sym_field_expression] = STATE(2471),
    [sym_compound_literal_expression] = STATE(2471),
    [sym_parenthesized_expression] = STATE(2471),
    [sym_concatenated_string] = STATE(2471),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2471),
    [sym_new_expression] = STATE(2471),
    [sym_delete_expression] = STATE(2471),
    [sym_lambda_expression] = STATE(2471),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5694),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5694),
    [sym_char_literal] = ACTIONS(5694),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5696),
    [sym_false] = ACTIONS(5696),
    [sym_null] = ACTIONS(5696),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5696),
  },
  [2089] = {
    [sym__expression] = STATE(2472),
    [sym_conditional_expression] = STATE(2472),
    [sym_assignment_expression] = STATE(2472),
    [sym_pointer_expression] = STATE(2472),
    [sym_logical_expression] = STATE(2472),
    [sym_bitwise_expression] = STATE(2472),
    [sym_equality_expression] = STATE(2472),
    [sym_relational_expression] = STATE(2472),
    [sym_shift_expression] = STATE(2472),
    [sym_math_expression] = STATE(2472),
    [sym_cast_expression] = STATE(2472),
    [sym_sizeof_expression] = STATE(2472),
    [sym_subscript_expression] = STATE(2472),
    [sym_call_expression] = STATE(2472),
    [sym_field_expression] = STATE(2472),
    [sym_compound_literal_expression] = STATE(2472),
    [sym_parenthesized_expression] = STATE(2472),
    [sym_concatenated_string] = STATE(2472),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2472),
    [sym_new_expression] = STATE(2472),
    [sym_delete_expression] = STATE(2472),
    [sym_lambda_expression] = STATE(2472),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5698),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(5698),
    [sym_char_literal] = ACTIONS(5698),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5700),
    [sym_false] = ACTIONS(5700),
    [sym_null] = ACTIONS(5700),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5700),
  },
  [2090] = {
    [sym__expression] = STATE(2473),
    [sym_conditional_expression] = STATE(2473),
    [sym_assignment_expression] = STATE(2473),
    [sym_pointer_expression] = STATE(2473),
    [sym_logical_expression] = STATE(2473),
    [sym_bitwise_expression] = STATE(2473),
    [sym_equality_expression] = STATE(2473),
    [sym_relational_expression] = STATE(2473),
    [sym_shift_expression] = STATE(2473),
    [sym_math_expression] = STATE(2473),
    [sym_cast_expression] = STATE(2473),
    [sym_sizeof_expression] = STATE(2473),
    [sym_subscript_expression] = STATE(2473),
    [sym_call_expression] = STATE(2473),
    [sym_field_expression] = STATE(2473),
    [sym_compound_literal_expression] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2473),
    [sym_concatenated_string] = STATE(2473),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2473),
    [sym_new_expression] = STATE(2473),
    [sym_delete_expression] = STATE(2473),
    [sym_lambda_expression] = STATE(2473),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5702),
    [sym_char_literal] = ACTIONS(5702),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5704),
    [sym_false] = ACTIONS(5704),
    [sym_null] = ACTIONS(5704),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5704),
  },
  [2091] = {
    [sym__expression] = STATE(2474),
    [sym_conditional_expression] = STATE(2474),
    [sym_assignment_expression] = STATE(2474),
    [sym_pointer_expression] = STATE(2474),
    [sym_logical_expression] = STATE(2474),
    [sym_bitwise_expression] = STATE(2474),
    [sym_equality_expression] = STATE(2474),
    [sym_relational_expression] = STATE(2474),
    [sym_shift_expression] = STATE(2474),
    [sym_math_expression] = STATE(2474),
    [sym_cast_expression] = STATE(2474),
    [sym_sizeof_expression] = STATE(2474),
    [sym_subscript_expression] = STATE(2474),
    [sym_call_expression] = STATE(2474),
    [sym_field_expression] = STATE(2474),
    [sym_compound_literal_expression] = STATE(2474),
    [sym_parenthesized_expression] = STATE(2474),
    [sym_concatenated_string] = STATE(2474),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2474),
    [sym_new_expression] = STATE(2474),
    [sym_delete_expression] = STATE(2474),
    [sym_lambda_expression] = STATE(2474),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5706),
    [sym_char_literal] = ACTIONS(5706),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5708),
    [sym_false] = ACTIONS(5708),
    [sym_null] = ACTIONS(5708),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5708),
  },
  [2092] = {
    [sym__expression] = STATE(2475),
    [sym_conditional_expression] = STATE(2475),
    [sym_assignment_expression] = STATE(2475),
    [sym_pointer_expression] = STATE(2475),
    [sym_logical_expression] = STATE(2475),
    [sym_bitwise_expression] = STATE(2475),
    [sym_equality_expression] = STATE(2475),
    [sym_relational_expression] = STATE(2475),
    [sym_shift_expression] = STATE(2475),
    [sym_math_expression] = STATE(2475),
    [sym_cast_expression] = STATE(2475),
    [sym_sizeof_expression] = STATE(2475),
    [sym_subscript_expression] = STATE(2475),
    [sym_call_expression] = STATE(2475),
    [sym_field_expression] = STATE(2475),
    [sym_compound_literal_expression] = STATE(2475),
    [sym_parenthesized_expression] = STATE(2475),
    [sym_concatenated_string] = STATE(2475),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2475),
    [sym_new_expression] = STATE(2475),
    [sym_delete_expression] = STATE(2475),
    [sym_lambda_expression] = STATE(2475),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5710),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5710),
    [sym_char_literal] = ACTIONS(5710),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5712),
    [sym_false] = ACTIONS(5712),
    [sym_null] = ACTIONS(5712),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5712),
  },
  [2093] = {
    [sym__expression] = STATE(2476),
    [sym_conditional_expression] = STATE(2476),
    [sym_assignment_expression] = STATE(2476),
    [sym_pointer_expression] = STATE(2476),
    [sym_logical_expression] = STATE(2476),
    [sym_bitwise_expression] = STATE(2476),
    [sym_equality_expression] = STATE(2476),
    [sym_relational_expression] = STATE(2476),
    [sym_shift_expression] = STATE(2476),
    [sym_math_expression] = STATE(2476),
    [sym_cast_expression] = STATE(2476),
    [sym_sizeof_expression] = STATE(2476),
    [sym_subscript_expression] = STATE(2476),
    [sym_call_expression] = STATE(2476),
    [sym_field_expression] = STATE(2476),
    [sym_compound_literal_expression] = STATE(2476),
    [sym_parenthesized_expression] = STATE(2476),
    [sym_concatenated_string] = STATE(2476),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2476),
    [sym_new_expression] = STATE(2476),
    [sym_delete_expression] = STATE(2476),
    [sym_lambda_expression] = STATE(2476),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5714),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5714),
    [sym_char_literal] = ACTIONS(5714),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5716),
    [sym_false] = ACTIONS(5716),
    [sym_null] = ACTIONS(5716),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5716),
  },
  [2094] = {
    [sym__expression] = STATE(2477),
    [sym_conditional_expression] = STATE(2477),
    [sym_assignment_expression] = STATE(2477),
    [sym_pointer_expression] = STATE(2477),
    [sym_logical_expression] = STATE(2477),
    [sym_bitwise_expression] = STATE(2477),
    [sym_equality_expression] = STATE(2477),
    [sym_relational_expression] = STATE(2477),
    [sym_shift_expression] = STATE(2477),
    [sym_math_expression] = STATE(2477),
    [sym_cast_expression] = STATE(2477),
    [sym_sizeof_expression] = STATE(2477),
    [sym_subscript_expression] = STATE(2477),
    [sym_call_expression] = STATE(2477),
    [sym_field_expression] = STATE(2477),
    [sym_compound_literal_expression] = STATE(2477),
    [sym_parenthesized_expression] = STATE(2477),
    [sym_concatenated_string] = STATE(2477),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2477),
    [sym_new_expression] = STATE(2477),
    [sym_delete_expression] = STATE(2477),
    [sym_lambda_expression] = STATE(2477),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5718),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5718),
    [sym_char_literal] = ACTIONS(5718),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5720),
    [sym_false] = ACTIONS(5720),
    [sym_null] = ACTIONS(5720),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5720),
  },
  [2095] = {
    [sym__expression] = STATE(2478),
    [sym_conditional_expression] = STATE(2478),
    [sym_assignment_expression] = STATE(2478),
    [sym_pointer_expression] = STATE(2478),
    [sym_logical_expression] = STATE(2478),
    [sym_bitwise_expression] = STATE(2478),
    [sym_equality_expression] = STATE(2478),
    [sym_relational_expression] = STATE(2478),
    [sym_shift_expression] = STATE(2478),
    [sym_math_expression] = STATE(2478),
    [sym_cast_expression] = STATE(2478),
    [sym_sizeof_expression] = STATE(2478),
    [sym_subscript_expression] = STATE(2478),
    [sym_call_expression] = STATE(2478),
    [sym_field_expression] = STATE(2478),
    [sym_compound_literal_expression] = STATE(2478),
    [sym_parenthesized_expression] = STATE(2478),
    [sym_concatenated_string] = STATE(2478),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2478),
    [sym_new_expression] = STATE(2478),
    [sym_delete_expression] = STATE(2478),
    [sym_lambda_expression] = STATE(2478),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5722),
    [sym_char_literal] = ACTIONS(5722),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5724),
    [sym_false] = ACTIONS(5724),
    [sym_null] = ACTIONS(5724),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5724),
  },
  [2096] = {
    [sym__expression] = STATE(2479),
    [sym_conditional_expression] = STATE(2479),
    [sym_assignment_expression] = STATE(2479),
    [sym_pointer_expression] = STATE(2479),
    [sym_logical_expression] = STATE(2479),
    [sym_bitwise_expression] = STATE(2479),
    [sym_equality_expression] = STATE(2479),
    [sym_relational_expression] = STATE(2479),
    [sym_shift_expression] = STATE(2479),
    [sym_math_expression] = STATE(2479),
    [sym_cast_expression] = STATE(2479),
    [sym_sizeof_expression] = STATE(2479),
    [sym_subscript_expression] = STATE(2479),
    [sym_call_expression] = STATE(2479),
    [sym_field_expression] = STATE(2479),
    [sym_compound_literal_expression] = STATE(2479),
    [sym_parenthesized_expression] = STATE(2479),
    [sym_concatenated_string] = STATE(2479),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2479),
    [sym_new_expression] = STATE(2479),
    [sym_delete_expression] = STATE(2479),
    [sym_lambda_expression] = STATE(2479),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5726),
    [sym_char_literal] = ACTIONS(5726),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5728),
    [sym_false] = ACTIONS(5728),
    [sym_null] = ACTIONS(5728),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5728),
  },
  [2097] = {
    [sym__expression] = STATE(2480),
    [sym_conditional_expression] = STATE(2480),
    [sym_assignment_expression] = STATE(2480),
    [sym_pointer_expression] = STATE(2480),
    [sym_logical_expression] = STATE(2480),
    [sym_bitwise_expression] = STATE(2480),
    [sym_equality_expression] = STATE(2480),
    [sym_relational_expression] = STATE(2480),
    [sym_shift_expression] = STATE(2480),
    [sym_math_expression] = STATE(2480),
    [sym_cast_expression] = STATE(2480),
    [sym_sizeof_expression] = STATE(2480),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2480),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_concatenated_string] = STATE(2480),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2480),
    [sym_new_expression] = STATE(2480),
    [sym_delete_expression] = STATE(2480),
    [sym_lambda_expression] = STATE(2480),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5730),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5730),
    [sym_char_literal] = ACTIONS(5730),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5732),
    [sym_false] = ACTIONS(5732),
    [sym_null] = ACTIONS(5732),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5732),
  },
  [2098] = {
    [sym__expression] = STATE(2481),
    [sym_conditional_expression] = STATE(2481),
    [sym_assignment_expression] = STATE(2481),
    [sym_pointer_expression] = STATE(2481),
    [sym_logical_expression] = STATE(2481),
    [sym_bitwise_expression] = STATE(2481),
    [sym_equality_expression] = STATE(2481),
    [sym_relational_expression] = STATE(2481),
    [sym_shift_expression] = STATE(2481),
    [sym_math_expression] = STATE(2481),
    [sym_cast_expression] = STATE(2481),
    [sym_sizeof_expression] = STATE(2481),
    [sym_subscript_expression] = STATE(2481),
    [sym_call_expression] = STATE(2481),
    [sym_field_expression] = STATE(2481),
    [sym_compound_literal_expression] = STATE(2481),
    [sym_parenthesized_expression] = STATE(2481),
    [sym_concatenated_string] = STATE(2481),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2481),
    [sym_new_expression] = STATE(2481),
    [sym_delete_expression] = STATE(2481),
    [sym_lambda_expression] = STATE(2481),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5734),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5734),
    [sym_char_literal] = ACTIONS(5734),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5736),
    [sym_false] = ACTIONS(5736),
    [sym_null] = ACTIONS(5736),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5736),
  },
  [2099] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2100] = {
    [sym_compound_statement] = STATE(2483),
    [sym_labeled_statement] = STATE(2483),
    [sym_expression_statement] = STATE(2483),
    [sym_if_statement] = STATE(2483),
    [sym_switch_statement] = STATE(2483),
    [sym_case_statement] = STATE(2483),
    [sym_while_statement] = STATE(2483),
    [sym_do_statement] = STATE(2483),
    [sym_for_statement] = STATE(2483),
    [sym_return_statement] = STATE(2483),
    [sym_break_statement] = STATE(2483),
    [sym_continue_statement] = STATE(2483),
    [sym_goto_statement] = STATE(2483),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2483),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2101] = {
    [sym__expression] = STATE(2484),
    [sym_conditional_expression] = STATE(2484),
    [sym_assignment_expression] = STATE(2484),
    [sym_pointer_expression] = STATE(2484),
    [sym_logical_expression] = STATE(2484),
    [sym_bitwise_expression] = STATE(2484),
    [sym_equality_expression] = STATE(2484),
    [sym_relational_expression] = STATE(2484),
    [sym_shift_expression] = STATE(2484),
    [sym_math_expression] = STATE(2484),
    [sym_cast_expression] = STATE(2484),
    [sym_sizeof_expression] = STATE(2484),
    [sym_subscript_expression] = STATE(2484),
    [sym_call_expression] = STATE(2484),
    [sym_field_expression] = STATE(2484),
    [sym_compound_literal_expression] = STATE(2484),
    [sym_parenthesized_expression] = STATE(2484),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(2484),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2484),
    [sym_new_expression] = STATE(2484),
    [sym_delete_expression] = STATE(2484),
    [sym_lambda_expression] = STATE(2484),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5740),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(5740),
    [sym_char_literal] = ACTIONS(5740),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5742),
    [sym_false] = ACTIONS(5742),
    [sym_null] = ACTIONS(5742),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5742),
  },
  [2102] = {
    [anon_sym_RPAREN] = ACTIONS(5744),
    [sym_comment] = ACTIONS(49),
  },
  [2103] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2103),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_COLON] = ACTIONS(4340),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
  },
  [2104] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5749),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [2105] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_COLON] = ACTIONS(4372),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2106] = {
    [sym__expression] = STATE(2487),
    [sym_conditional_expression] = STATE(2487),
    [sym_assignment_expression] = STATE(2487),
    [sym_pointer_expression] = STATE(2487),
    [sym_logical_expression] = STATE(2487),
    [sym_bitwise_expression] = STATE(2487),
    [sym_equality_expression] = STATE(2487),
    [sym_relational_expression] = STATE(2487),
    [sym_shift_expression] = STATE(2487),
    [sym_math_expression] = STATE(2487),
    [sym_cast_expression] = STATE(2487),
    [sym_sizeof_expression] = STATE(2487),
    [sym_subscript_expression] = STATE(2487),
    [sym_call_expression] = STATE(2487),
    [sym_field_expression] = STATE(2487),
    [sym_compound_literal_expression] = STATE(2487),
    [sym_parenthesized_expression] = STATE(2487),
    [sym_concatenated_string] = STATE(2487),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2487),
    [sym_new_expression] = STATE(2487),
    [sym_delete_expression] = STATE(2487),
    [sym_lambda_expression] = STATE(2487),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5751),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(5751),
    [sym_char_literal] = ACTIONS(5751),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5753),
    [sym_false] = ACTIONS(5753),
    [sym_null] = ACTIONS(5753),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5753),
  },
  [2107] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_COLON] = ACTIONS(4388),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(4390),
    [anon_sym_PERCENT] = ACTIONS(4390),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2108] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(4394),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2109] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_RBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [2110] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(5759),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2111] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2112] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2113] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2114] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2115] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2116] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2117] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_COLON] = ACTIONS(4410),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2118] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4414),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2119] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_COLON] = ACTIONS(4388),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2120] = {
    [sym_destructor_name] = STATE(298),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(5761),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(466),
  },
  [2121] = {
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_register] = ACTIONS(473),
    [anon_sym_inline] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_explicit] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(471),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [sym_identifier] = ACTIONS(473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [sym_operator_name] = ACTIONS(471),
  },
  [2122] = {
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(550),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_EQ] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_register] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_const] = ACTIONS(546),
    [anon_sym_restrict] = ACTIONS(546),
    [anon_sym_volatile] = ACTIONS(546),
    [anon_sym__Atomic] = ACTIONS(546),
    [anon_sym_mutable] = ACTIONS(546),
    [anon_sym_explicit] = ACTIONS(546),
    [anon_sym_constexpr] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_STAR_EQ] = ACTIONS(550),
    [anon_sym_SLASH_EQ] = ACTIONS(550),
    [anon_sym_PERCENT_EQ] = ACTIONS(550),
    [anon_sym_PLUS_EQ] = ACTIONS(550),
    [anon_sym_DASH_EQ] = ACTIONS(550),
    [anon_sym_LT_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_GT_EQ] = ACTIONS(550),
    [anon_sym_AMP_EQ] = ACTIONS(550),
    [anon_sym_CARET_EQ] = ACTIONS(550),
    [anon_sym_PIPE_EQ] = ACTIONS(550),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(550),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_EQ_EQ] = ACTIONS(550),
    [anon_sym_BANG_EQ] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(550),
    [anon_sym_LT_LT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(552),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DOT] = ACTIONS(550),
    [anon_sym_DASH_GT] = ACTIONS(550),
    [sym_identifier] = ACTIONS(546),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(548),
    [sym_operator_name] = ACTIONS(544),
  },
  [2123] = {
    [sym_destructor_name] = STATE(449),
    [anon_sym_TILDE] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(5763),
    [sym_comment] = ACTIONS(49),
    [sym_operator_name] = ACTIONS(734),
  },
  [2124] = {
    [sym_compound_statement] = STATE(2491),
    [sym_labeled_statement] = STATE(2491),
    [sym_expression_statement] = STATE(2491),
    [sym_if_statement] = STATE(2491),
    [sym_switch_statement] = STATE(2491),
    [sym_case_statement] = STATE(2491),
    [sym_while_statement] = STATE(2491),
    [sym_do_statement] = STATE(2491),
    [sym_for_statement] = STATE(2491),
    [sym_return_statement] = STATE(2491),
    [sym_break_statement] = STATE(2491),
    [sym_continue_statement] = STATE(2491),
    [sym_goto_statement] = STATE(2491),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2491),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2125] = {
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3274),
    [anon_sym_RPAREN] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_RBRACK] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_else] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_STAR_EQ] = ACTIONS(3274),
    [anon_sym_SLASH_EQ] = ACTIONS(3274),
    [anon_sym_PERCENT_EQ] = ACTIONS(3274),
    [anon_sym_PLUS_EQ] = ACTIONS(3274),
    [anon_sym_DASH_EQ] = ACTIONS(3274),
    [anon_sym_LT_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_GT_EQ] = ACTIONS(3274),
    [anon_sym_AMP_EQ] = ACTIONS(3274),
    [anon_sym_CARET_EQ] = ACTIONS(3274),
    [anon_sym_PIPE_EQ] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3276),
    [anon_sym_CARET] = ACTIONS(3276),
    [anon_sym_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3276),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3276),
    [anon_sym_GT_GT] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [sym_comment] = ACTIONS(49),
  },
  [2126] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(5765),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2127] = {
    [sym__expression] = STATE(2493),
    [sym_conditional_expression] = STATE(2493),
    [sym_assignment_expression] = STATE(2493),
    [sym_pointer_expression] = STATE(2493),
    [sym_logical_expression] = STATE(2493),
    [sym_bitwise_expression] = STATE(2493),
    [sym_equality_expression] = STATE(2493),
    [sym_relational_expression] = STATE(2493),
    [sym_shift_expression] = STATE(2493),
    [sym_math_expression] = STATE(2493),
    [sym_cast_expression] = STATE(2493),
    [sym_sizeof_expression] = STATE(2493),
    [sym_subscript_expression] = STATE(2493),
    [sym_call_expression] = STATE(2493),
    [sym_field_expression] = STATE(2493),
    [sym_compound_literal_expression] = STATE(2493),
    [sym_parenthesized_expression] = STATE(2493),
    [sym_concatenated_string] = STATE(2493),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2493),
    [sym_new_expression] = STATE(2493),
    [sym_delete_expression] = STATE(2493),
    [sym_lambda_expression] = STATE(2493),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5767),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5767),
    [sym_char_literal] = ACTIONS(5767),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5769),
    [sym_false] = ACTIONS(5769),
    [sym_null] = ACTIONS(5769),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5769),
  },
  [2128] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(5771),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2129] = {
    [sym_declaration] = STATE(2495),
    [sym_type_definition] = STATE(2495),
    [sym__declaration_specifiers] = STATE(2133),
    [sym_compound_statement] = STATE(2495),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2495),
    [sym_expression_statement] = STATE(2495),
    [sym_if_statement] = STATE(2495),
    [sym_switch_statement] = STATE(2495),
    [sym_case_statement] = STATE(2495),
    [sym_while_statement] = STATE(2495),
    [sym_do_statement] = STATE(2495),
    [sym_for_statement] = STATE(2495),
    [sym_return_statement] = STATE(2495),
    [sym_break_statement] = STATE(2495),
    [sym_continue_statement] = STATE(2495),
    [sym_goto_statement] = STATE(2495),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2495),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_typedef] = ACTIONS(4777),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(4779),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2130] = {
    [sym_type_qualifier] = STATE(2497),
    [sym__type_specifier] = STATE(2496),
    [sym_sized_type_specifier] = STATE(2496),
    [sym_enum_specifier] = STATE(2496),
    [sym_struct_specifier] = STATE(2496),
    [sym_union_specifier] = STATE(2496),
    [sym_macro_type_specifier] = STATE(2496),
    [sym_class_specifier] = STATE(2496),
    [sym_dependent_type] = STATE(2496),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(5773),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(5773),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2131] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(3168),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [2132] = {
    [anon_sym_else] = ACTIONS(4755),
    [anon_sym_while] = ACTIONS(4755),
    [sym_comment] = ACTIONS(49),
  },
  [2133] = {
    [sym__declarator] = STATE(2498),
    [sym_pointer_declarator] = STATE(2498),
    [sym_function_declarator] = STATE(2498),
    [sym_array_declarator] = STATE(2498),
    [sym_init_declarator] = STATE(2499),
    [sym_reference_declarator] = STATE(2498),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2498),
    [sym_destructor_name] = STATE(2498),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5775),
  },
  [2134] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2135] = {
    [anon_sym_LPAREN] = ACTIONS(5779),
    [sym_comment] = ACTIONS(49),
  },
  [2136] = {
    [sym__expression] = STATE(2503),
    [sym_conditional_expression] = STATE(2503),
    [sym_assignment_expression] = STATE(2503),
    [sym_pointer_expression] = STATE(2503),
    [sym_logical_expression] = STATE(2503),
    [sym_bitwise_expression] = STATE(2503),
    [sym_equality_expression] = STATE(2503),
    [sym_relational_expression] = STATE(2503),
    [sym_shift_expression] = STATE(2503),
    [sym_math_expression] = STATE(2503),
    [sym_cast_expression] = STATE(2503),
    [sym_sizeof_expression] = STATE(2503),
    [sym_subscript_expression] = STATE(2503),
    [sym_call_expression] = STATE(2503),
    [sym_field_expression] = STATE(2503),
    [sym_compound_literal_expression] = STATE(2503),
    [sym_parenthesized_expression] = STATE(2503),
    [sym_concatenated_string] = STATE(2503),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2503),
    [sym_new_expression] = STATE(2503),
    [sym_delete_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(2503),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5781),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(5783),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5781),
    [sym_char_literal] = ACTIONS(5781),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5785),
    [sym_false] = ACTIONS(5785),
    [sym_null] = ACTIONS(5785),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5785),
  },
  [2137] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5787),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2138] = {
    [anon_sym_COLON] = ACTIONS(5789),
    [sym_comment] = ACTIONS(49),
  },
  [2139] = {
    [anon_sym_else] = ACTIONS(4817),
    [anon_sym_while] = ACTIONS(4817),
    [sym_comment] = ACTIONS(49),
  },
  [2140] = {
    [anon_sym_else] = ACTIONS(4821),
    [anon_sym_while] = ACTIONS(4821),
    [sym_comment] = ACTIONS(49),
  },
  [2141] = {
    [anon_sym_else] = ACTIONS(4830),
    [anon_sym_while] = ACTIONS(4830),
    [sym_comment] = ACTIONS(49),
  },
  [2142] = {
    [sym__expression] = STATE(2506),
    [sym_conditional_expression] = STATE(2506),
    [sym_assignment_expression] = STATE(2506),
    [sym_pointer_expression] = STATE(2506),
    [sym_logical_expression] = STATE(2506),
    [sym_bitwise_expression] = STATE(2506),
    [sym_equality_expression] = STATE(2506),
    [sym_relational_expression] = STATE(2506),
    [sym_shift_expression] = STATE(2506),
    [sym_math_expression] = STATE(2506),
    [sym_cast_expression] = STATE(2506),
    [sym_sizeof_expression] = STATE(2506),
    [sym_subscript_expression] = STATE(2506),
    [sym_call_expression] = STATE(2506),
    [sym_field_expression] = STATE(2506),
    [sym_compound_literal_expression] = STATE(2506),
    [sym_parenthesized_expression] = STATE(2506),
    [sym_concatenated_string] = STATE(2506),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2506),
    [sym_new_expression] = STATE(2506),
    [sym_delete_expression] = STATE(2506),
    [sym_lambda_expression] = STATE(2506),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5791),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5791),
    [sym_char_literal] = ACTIONS(5791),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5793),
    [sym_false] = ACTIONS(5793),
    [sym_null] = ACTIONS(5793),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5793),
  },
  [2143] = {
    [sym__expression] = STATE(2508),
    [sym_conditional_expression] = STATE(2508),
    [sym_assignment_expression] = STATE(2508),
    [sym_pointer_expression] = STATE(2508),
    [sym_logical_expression] = STATE(2508),
    [sym_bitwise_expression] = STATE(2508),
    [sym_equality_expression] = STATE(2508),
    [sym_relational_expression] = STATE(2508),
    [sym_shift_expression] = STATE(2508),
    [sym_math_expression] = STATE(2508),
    [sym_cast_expression] = STATE(2508),
    [sym_sizeof_expression] = STATE(2508),
    [sym_subscript_expression] = STATE(2508),
    [sym_call_expression] = STATE(2508),
    [sym_field_expression] = STATE(2508),
    [sym_compound_literal_expression] = STATE(2508),
    [sym_parenthesized_expression] = STATE(2508),
    [sym_concatenated_string] = STATE(2508),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2508),
    [sym_new_expression] = STATE(2508),
    [sym_delete_expression] = STATE(2508),
    [sym_lambda_expression] = STATE(2508),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5795),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(5795),
    [sym_char_literal] = ACTIONS(5795),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(5799),
    [sym_false] = ACTIONS(5799),
    [sym_null] = ACTIONS(5799),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(5799),
  },
  [2144] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2145] = {
    [sym__declarator] = STATE(2510),
    [sym_pointer_declarator] = STATE(2510),
    [sym_function_declarator] = STATE(2510),
    [sym_array_declarator] = STATE(2510),
    [sym_reference_declarator] = STATE(2510),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2510),
    [sym_destructor_name] = STATE(2510),
    [sym_scoped_identifier] = STATE(2149),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_AMP_AMP] = ACTIONS(4809),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5803),
  },
  [2146] = {
    [sym__declarator] = STATE(2511),
    [sym_pointer_declarator] = STATE(2511),
    [sym_function_declarator] = STATE(2511),
    [sym_array_declarator] = STATE(2511),
    [sym_reference_declarator] = STATE(2511),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2511),
    [sym_destructor_name] = STATE(2511),
    [sym_scoped_identifier] = STATE(2149),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_AMP_AMP] = ACTIONS(4809),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5805),
  },
  [2147] = {
    [sym_parameter_list] = STATE(2513),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(2514),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_COLON] = ACTIONS(5809),
    [sym_comment] = ACTIONS(49),
  },
  [2148] = {
    [aux_sym_declaration_repeat1] = STATE(2514),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(5807),
    [sym_comment] = ACTIONS(49),
  },
  [2149] = {
    [sym_template_argument_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(218),
    [anon_sym_COMMA] = ACTIONS(218),
    [anon_sym_SEMI] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_EQ] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(2164),
    [sym_comment] = ACTIONS(49),
  },
  [2150] = {
    [sym__expression] = STATE(2515),
    [sym_conditional_expression] = STATE(2515),
    [sym_assignment_expression] = STATE(2515),
    [sym_pointer_expression] = STATE(2515),
    [sym_logical_expression] = STATE(2515),
    [sym_bitwise_expression] = STATE(2515),
    [sym_equality_expression] = STATE(2515),
    [sym_relational_expression] = STATE(2515),
    [sym_shift_expression] = STATE(2515),
    [sym_math_expression] = STATE(2515),
    [sym_cast_expression] = STATE(2515),
    [sym_sizeof_expression] = STATE(2515),
    [sym_subscript_expression] = STATE(2515),
    [sym_call_expression] = STATE(2515),
    [sym_field_expression] = STATE(2515),
    [sym_compound_literal_expression] = STATE(2515),
    [sym_parenthesized_expression] = STATE(2515),
    [sym_concatenated_string] = STATE(2515),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2515),
    [sym_new_expression] = STATE(2515),
    [sym_delete_expression] = STATE(2515),
    [sym_lambda_expression] = STATE(2515),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5811),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(5811),
    [sym_char_literal] = ACTIONS(5811),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(5813),
    [sym_false] = ACTIONS(5813),
    [sym_null] = ACTIONS(5813),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(5813),
  },
  [2151] = {
    [sym__expression] = STATE(2516),
    [sym_conditional_expression] = STATE(2516),
    [sym_assignment_expression] = STATE(2516),
    [sym_pointer_expression] = STATE(2516),
    [sym_logical_expression] = STATE(2516),
    [sym_bitwise_expression] = STATE(2516),
    [sym_equality_expression] = STATE(2516),
    [sym_relational_expression] = STATE(2516),
    [sym_shift_expression] = STATE(2516),
    [sym_math_expression] = STATE(2516),
    [sym_cast_expression] = STATE(2516),
    [sym_sizeof_expression] = STATE(2516),
    [sym_subscript_expression] = STATE(2516),
    [sym_call_expression] = STATE(2516),
    [sym_field_expression] = STATE(2516),
    [sym_compound_literal_expression] = STATE(2516),
    [sym_parenthesized_expression] = STATE(2516),
    [sym_concatenated_string] = STATE(2516),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2516),
    [sym_new_expression] = STATE(2516),
    [sym_delete_expression] = STATE(2516),
    [sym_lambda_expression] = STATE(2516),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5815),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(5815),
    [sym_char_literal] = ACTIONS(5815),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(5817),
    [sym_false] = ACTIONS(5817),
    [sym_null] = ACTIONS(5817),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(5817),
  },
  [2152] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_SEMI] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(5819),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5819),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(5821),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2153] = {
    [sym__expression] = STATE(2517),
    [sym_conditional_expression] = STATE(2517),
    [sym_assignment_expression] = STATE(2517),
    [sym_pointer_expression] = STATE(2517),
    [sym_logical_expression] = STATE(2517),
    [sym_bitwise_expression] = STATE(2517),
    [sym_equality_expression] = STATE(2517),
    [sym_relational_expression] = STATE(2517),
    [sym_shift_expression] = STATE(2517),
    [sym_math_expression] = STATE(2517),
    [sym_cast_expression] = STATE(2517),
    [sym_sizeof_expression] = STATE(2517),
    [sym_subscript_expression] = STATE(2517),
    [sym_call_expression] = STATE(2517),
    [sym_field_expression] = STATE(2517),
    [sym_compound_literal_expression] = STATE(2517),
    [sym_parenthesized_expression] = STATE(2517),
    [sym_concatenated_string] = STATE(2517),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2517),
    [sym_new_expression] = STATE(2517),
    [sym_delete_expression] = STATE(2517),
    [sym_lambda_expression] = STATE(2517),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5823),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5823),
    [sym_char_literal] = ACTIONS(5823),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5825),
    [sym_false] = ACTIONS(5825),
    [sym_null] = ACTIONS(5825),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5825),
  },
  [2154] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2155] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [2156] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5827),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2157] = {
    [anon_sym_SEMI] = ACTIONS(5827),
    [sym_comment] = ACTIONS(49),
  },
  [2158] = {
    [sym_raw_string_literal] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_RBRACE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2653),
    [sym_char_literal] = ACTIONS(2653),
    [sym_string_literal] = ACTIONS(2653),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_null] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2655),
    [sym_nullptr] = ACTIONS(2655),
  },
  [2159] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5829),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2160] = {
    [anon_sym_SEMI] = ACTIONS(5829),
    [sym_comment] = ACTIONS(49),
  },
  [2161] = {
    [sym_raw_string_literal] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [sym_string_literal] = ACTIONS(2659),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2661),
    [sym_nullptr] = ACTIONS(2661),
  },
  [2162] = {
    [sym__expression] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_logical_expression] = STATE(2520),
    [sym_bitwise_expression] = STATE(2520),
    [sym_equality_expression] = STATE(2520),
    [sym_relational_expression] = STATE(2520),
    [sym_shift_expression] = STATE(2520),
    [sym_math_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_concatenated_string] = STATE(2520),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5831),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5831),
    [sym_char_literal] = ACTIONS(5831),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5833),
    [sym_false] = ACTIONS(5833),
    [sym_null] = ACTIONS(5833),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5833),
  },
  [2163] = {
    [sym_parameter_list] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2164] = {
    [sym_parameter_list] = STATE(2165),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2165] = {
    [sym_type_qualifier] = STATE(2521),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2521),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2166] = {
    [sym_type_qualifier] = STATE(2248),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2248),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5108),
  },
  [2167] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_template] = ACTIONS(3436),
    [anon_sym_namespace] = ACTIONS(3436),
    [anon_sym_using] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [sym_operator_name] = ACTIONS(3434),
  },
  [2168] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_template] = ACTIONS(3446),
    [anon_sym_namespace] = ACTIONS(3446),
    [anon_sym_using] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [sym_operator_name] = ACTIONS(3444),
  },
  [2169] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3585),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3585),
    [sym_auto] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [sym_operator_name] = ACTIONS(3583),
  },
  [2170] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3589),
    [sym_preproc_directive] = ACTIONS(3589),
    [anon_sym_typedef] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_register] = ACTIONS(3589),
    [anon_sym_inline] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_restrict] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym__Atomic] = ACTIONS(3589),
    [anon_sym_mutable] = ACTIONS(3589),
    [anon_sym_explicit] = ACTIONS(3589),
    [anon_sym_constexpr] = ACTIONS(3589),
    [anon_sym_unsigned] = ACTIONS(3589),
    [anon_sym_long] = ACTIONS(3589),
    [anon_sym_short] = ACTIONS(3589),
    [sym_primitive_type] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_union] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3589),
    [sym_auto] = ACTIONS(3589),
    [anon_sym_typename] = ACTIONS(3589),
    [anon_sym_template] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [sym_operator_name] = ACTIONS(3587),
  },
  [2171] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3593),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3593),
    [sym_auto] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3591),
    [sym_operator_name] = ACTIONS(3591),
  },
  [2172] = {
    [anon_sym_LF] = ACTIONS(5835),
    [sym_comment] = ACTIONS(83),
  },
  [2173] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_template] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1883),
    [anon_sym_using] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [sym_operator_name] = ACTIONS(1881),
  },
  [2174] = {
    [anon_sym_LF] = ACTIONS(5837),
    [sym_comment] = ACTIONS(83),
  },
  [2175] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1969),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1969),
    [sym_preproc_directive] = ACTIONS(1969),
    [anon_sym_typedef] = ACTIONS(1969),
    [anon_sym_extern] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1969),
    [anon_sym_register] = ACTIONS(1969),
    [anon_sym_inline] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1969),
    [anon_sym_restrict] = ACTIONS(1969),
    [anon_sym_volatile] = ACTIONS(1969),
    [anon_sym__Atomic] = ACTIONS(1969),
    [anon_sym_mutable] = ACTIONS(1969),
    [anon_sym_explicit] = ACTIONS(1969),
    [anon_sym_constexpr] = ACTIONS(1969),
    [anon_sym_unsigned] = ACTIONS(1969),
    [anon_sym_long] = ACTIONS(1969),
    [anon_sym_short] = ACTIONS(1969),
    [sym_primitive_type] = ACTIONS(1969),
    [anon_sym_enum] = ACTIONS(1969),
    [anon_sym_struct] = ACTIONS(1969),
    [anon_sym_union] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1969),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1969),
    [sym_auto] = ACTIONS(1969),
    [anon_sym_typename] = ACTIONS(1969),
    [anon_sym_template] = ACTIONS(1969),
    [anon_sym_namespace] = ACTIONS(1969),
    [anon_sym_using] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1967),
    [sym_operator_name] = ACTIONS(1967),
  },
  [2176] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5839),
    [sym_comment] = ACTIONS(49),
  },
  [2177] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2020),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2020),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [sym_operator_name] = ACTIONS(2018),
  },
  [2178] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5841),
    [sym_comment] = ACTIONS(49),
  },
  [2179] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2026),
    [sym_preproc_directive] = ACTIONS(2026),
    [anon_sym_typedef] = ACTIONS(2026),
    [anon_sym_extern] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_register] = ACTIONS(2026),
    [anon_sym_inline] = ACTIONS(2026),
    [anon_sym_const] = ACTIONS(2026),
    [anon_sym_restrict] = ACTIONS(2026),
    [anon_sym_volatile] = ACTIONS(2026),
    [anon_sym__Atomic] = ACTIONS(2026),
    [anon_sym_mutable] = ACTIONS(2026),
    [anon_sym_explicit] = ACTIONS(2026),
    [anon_sym_constexpr] = ACTIONS(2026),
    [anon_sym_unsigned] = ACTIONS(2026),
    [anon_sym_long] = ACTIONS(2026),
    [anon_sym_short] = ACTIONS(2026),
    [sym_primitive_type] = ACTIONS(2026),
    [anon_sym_enum] = ACTIONS(2026),
    [anon_sym_struct] = ACTIONS(2026),
    [anon_sym_union] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_TILDE] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2026),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2026),
    [sym_auto] = ACTIONS(2026),
    [anon_sym_typename] = ACTIONS(2026),
    [anon_sym_template] = ACTIONS(2026),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_using] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2024),
    [sym_operator_name] = ACTIONS(2024),
  },
  [2180] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5843),
    [sym_comment] = ACTIONS(49),
  },
  [2181] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [sym_operator_name] = ACTIONS(2030),
  },
  [2182] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_template] = ACTIONS(2054),
    [anon_sym_namespace] = ACTIONS(2054),
    [anon_sym_using] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [sym_operator_name] = ACTIONS(2052),
  },
  [2183] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(5845),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2184] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2414),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [sym_operator_name] = ACTIONS(2412),
  },
  [2185] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2429),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [sym_operator_name] = ACTIONS(2427),
  },
  [2186] = {
    [anon_sym_SEMI] = ACTIONS(5847),
    [sym_comment] = ACTIONS(49),
  },
  [2187] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2445),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [sym_operator_name] = ACTIONS(2443),
  },
  [2188] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(2472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [2189] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [sym_operator_name] = ACTIONS(2550),
  },
  [2190] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5849),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2191] = {
    [anon_sym_SEMI] = ACTIONS(5849),
    [sym_comment] = ACTIONS(49),
  },
  [2192] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [sym_operator_name] = ACTIONS(2653),
  },
  [2193] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5851),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2194] = {
    [anon_sym_SEMI] = ACTIONS(5851),
    [sym_comment] = ACTIONS(49),
  },
  [2195] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [sym_operator_name] = ACTIONS(2659),
  },
  [2196] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_template] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_using] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [sym_operator_name] = ACTIONS(3274),
  },
  [2197] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3432),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3432),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3432),
    [sym_preproc_directive] = ACTIONS(3432),
    [anon_sym_typedef] = ACTIONS(3432),
    [anon_sym_extern] = ACTIONS(3432),
    [anon_sym_STAR] = ACTIONS(3430),
    [anon_sym_static] = ACTIONS(3432),
    [anon_sym_register] = ACTIONS(3432),
    [anon_sym_inline] = ACTIONS(3432),
    [anon_sym_const] = ACTIONS(3432),
    [anon_sym_restrict] = ACTIONS(3432),
    [anon_sym_volatile] = ACTIONS(3432),
    [anon_sym__Atomic] = ACTIONS(3432),
    [anon_sym_mutable] = ACTIONS(3432),
    [anon_sym_explicit] = ACTIONS(3432),
    [anon_sym_constexpr] = ACTIONS(3432),
    [anon_sym_unsigned] = ACTIONS(3432),
    [anon_sym_long] = ACTIONS(3432),
    [anon_sym_short] = ACTIONS(3432),
    [sym_primitive_type] = ACTIONS(3432),
    [anon_sym_enum] = ACTIONS(3432),
    [anon_sym_struct] = ACTIONS(3432),
    [anon_sym_union] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_TILDE] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3432),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3432),
    [sym_auto] = ACTIONS(3432),
    [anon_sym_typename] = ACTIONS(3432),
    [anon_sym_template] = ACTIONS(3432),
    [anon_sym_namespace] = ACTIONS(3432),
    [anon_sym_using] = ACTIONS(3432),
    [anon_sym_COLON_COLON] = ACTIONS(3430),
    [sym_operator_name] = ACTIONS(3430),
  },
  [2198] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [sym_operator_name] = ACTIONS(3613),
  },
  [2199] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3972),
    [sym_preproc_directive] = ACTIONS(3972),
    [anon_sym_typedef] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3972),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_register] = ACTIONS(3972),
    [anon_sym_inline] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3972),
    [anon_sym_restrict] = ACTIONS(3972),
    [anon_sym_volatile] = ACTIONS(3972),
    [anon_sym__Atomic] = ACTIONS(3972),
    [anon_sym_mutable] = ACTIONS(3972),
    [anon_sym_explicit] = ACTIONS(3972),
    [anon_sym_constexpr] = ACTIONS(3972),
    [anon_sym_unsigned] = ACTIONS(3972),
    [anon_sym_long] = ACTIONS(3972),
    [anon_sym_short] = ACTIONS(3972),
    [sym_primitive_type] = ACTIONS(3972),
    [anon_sym_enum] = ACTIONS(3972),
    [anon_sym_struct] = ACTIONS(3972),
    [anon_sym_union] = ACTIONS(3972),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3970),
    [anon_sym_TILDE] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3972),
    [sym_auto] = ACTIONS(3972),
    [anon_sym_typename] = ACTIONS(3972),
    [anon_sym_template] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_using] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [sym_operator_name] = ACTIONS(3970),
  },
  [2200] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_template] = ACTIONS(4174),
    [anon_sym_namespace] = ACTIONS(4174),
    [anon_sym_using] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [sym_operator_name] = ACTIONS(4172),
  },
  [2201] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4222),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_template] = ACTIONS(4222),
    [anon_sym_namespace] = ACTIONS(4222),
    [anon_sym_using] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [sym_operator_name] = ACTIONS(4220),
  },
  [2202] = {
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [sym_identifier] = ACTIONS(4958),
    [sym_comment] = ACTIONS(49),
  },
  [2203] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3882),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(3882),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
  },
  [2204] = {
    [anon_sym_LPAREN] = ACTIONS(5853),
    [anon_sym_RPAREN] = ACTIONS(5853),
    [anon_sym_SEMI] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5853),
    [sym_comment] = ACTIONS(49),
  },
  [2205] = {
    [sym_parameter_list] = STATE(2207),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2206] = {
    [sym_parameter_list] = STATE(2207),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2207] = {
    [sym_type_qualifier] = STATE(2531),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2531),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2208] = {
    [sym_type_qualifier] = STATE(2337),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2337),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5380),
  },
  [2209] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_type_definition] = STATE(2209),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(2209),
    [sym_field_declaration] = STATE(2209),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(2209),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(2209),
    [sym_access_specifier] = STATE(2209),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(2209),
    [sym_alias_declaration] = STATE(2209),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2209),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2188),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_restrict] = ACTIONS(2205),
    [anon_sym_volatile] = ACTIONS(2205),
    [anon_sym__Atomic] = ACTIONS(2205),
    [anon_sym_mutable] = ACTIONS(2205),
    [anon_sym_explicit] = ACTIONS(2205),
    [anon_sym_constexpr] = ACTIONS(2205),
    [anon_sym_unsigned] = ACTIONS(2208),
    [anon_sym_long] = ACTIONS(2208),
    [anon_sym_short] = ACTIONS(2208),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2217),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2238),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2241),
    [anon_sym_template] = ACTIONS(2244),
    [anon_sym_friend] = ACTIONS(2247),
    [anon_sym_private] = ACTIONS(2238),
    [anon_sym_protected] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [sym_operator_name] = ACTIONS(2256),
  },
  [2210] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5855),
    [sym_comment] = ACTIONS(49),
  },
  [2211] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5857),
    [sym_comment] = ACTIONS(49),
  },
  [2212] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(256),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(257),
    [sym_preproc_else_in_field_declaration_list] = STATE(2532),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2533),
    [sym_type_definition] = STATE(1708),
    [sym__declaration_specifiers] = STATE(258),
    [sym__declarator] = STATE(259),
    [sym_pointer_declarator] = STATE(259),
    [sym_function_declarator] = STATE(260),
    [sym_array_declarator] = STATE(259),
    [sym_storage_class_specifier] = STATE(267),
    [sym_type_qualifier] = STATE(267),
    [sym__type_specifier] = STATE(261),
    [sym_sized_type_specifier] = STATE(261),
    [sym_enum_specifier] = STATE(261),
    [sym_struct_specifier] = STATE(261),
    [sym_union_specifier] = STATE(261),
    [sym__field_declaration_list_item] = STATE(1708),
    [sym_field_declaration] = STATE(1708),
    [sym_macro_type_specifier] = STATE(261),
    [sym_class_specifier] = STATE(261),
    [sym_dependent_type] = STATE(261),
    [sym_template_declaration] = STATE(1708),
    [sym_inline_method_definition] = STATE(262),
    [sym_constructor_or_destructor_definition] = STATE(262),
    [sym_constructor_or_destructor_declaration] = STATE(263),
    [sym_friend_declaration] = STATE(1708),
    [sym_access_specifier] = STATE(1708),
    [sym_reference_declarator] = STATE(259),
    [sym_template_type] = STATE(264),
    [sym_template_function] = STATE(259),
    [sym_using_declaration] = STATE(1708),
    [sym_alias_declaration] = STATE(1708),
    [sym_destructor_name] = STATE(259),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(265),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1708),
    [aux_sym__declaration_specifiers_repeat1] = STATE(267),
    [aux_sym_sized_type_specifier_repeat1] = STATE(268),
    [anon_sym_LPAREN] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(380),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(27),
    [anon_sym_register] = ACTIONS(27),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_restrict] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym__Atomic] = ACTIONS(29),
    [anon_sym_mutable] = ACTIONS(29),
    [anon_sym_explicit] = ACTIONS(29),
    [anon_sym_constexpr] = ACTIONS(29),
    [anon_sym_unsigned] = ACTIONS(384),
    [anon_sym_long] = ACTIONS(384),
    [anon_sym_short] = ACTIONS(384),
    [sym_primitive_type] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(388),
    [anon_sym_union] = ACTIONS(390),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(396),
    [sym_auto] = ACTIONS(386),
    [anon_sym_typename] = ACTIONS(398),
    [anon_sym_template] = ACTIONS(400),
    [anon_sym_friend] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(396),
    [anon_sym_protected] = ACTIONS(396),
    [anon_sym_using] = ACTIONS(404),
    [anon_sym_COLON_COLON] = ACTIONS(406),
    [sym_operator_name] = ACTIONS(408),
  },
  [2213] = {
    [anon_sym_LPAREN] = ACTIONS(5861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5863),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5861),
    [anon_sym_typedef] = ACTIONS(5863),
    [anon_sym_extern] = ACTIONS(5863),
    [anon_sym_RBRACE] = ACTIONS(5861),
    [anon_sym_STAR] = ACTIONS(5861),
    [anon_sym_static] = ACTIONS(5863),
    [anon_sym_register] = ACTIONS(5863),
    [anon_sym_inline] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(5863),
    [anon_sym_restrict] = ACTIONS(5863),
    [anon_sym_volatile] = ACTIONS(5863),
    [anon_sym__Atomic] = ACTIONS(5863),
    [anon_sym_mutable] = ACTIONS(5863),
    [anon_sym_explicit] = ACTIONS(5863),
    [anon_sym_constexpr] = ACTIONS(5863),
    [anon_sym_unsigned] = ACTIONS(5863),
    [anon_sym_long] = ACTIONS(5863),
    [anon_sym_short] = ACTIONS(5863),
    [sym_primitive_type] = ACTIONS(5863),
    [anon_sym_enum] = ACTIONS(5863),
    [anon_sym_struct] = ACTIONS(5863),
    [anon_sym_union] = ACTIONS(5863),
    [anon_sym_AMP] = ACTIONS(5863),
    [anon_sym_AMP_AMP] = ACTIONS(5861),
    [anon_sym_TILDE] = ACTIONS(5861),
    [sym_identifier] = ACTIONS(5863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5863),
    [anon_sym_public] = ACTIONS(5863),
    [sym_auto] = ACTIONS(5863),
    [anon_sym_typename] = ACTIONS(5863),
    [anon_sym_template] = ACTIONS(5863),
    [anon_sym_friend] = ACTIONS(5863),
    [anon_sym_private] = ACTIONS(5863),
    [anon_sym_protected] = ACTIONS(5863),
    [anon_sym_using] = ACTIONS(5863),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [sym_operator_name] = ACTIONS(5861),
  },
  [2214] = {
    [anon_sym_LPAREN] = ACTIONS(5865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5865),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5865),
    [anon_sym_typedef] = ACTIONS(5867),
    [anon_sym_extern] = ACTIONS(5867),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [anon_sym_STAR] = ACTIONS(5865),
    [anon_sym_static] = ACTIONS(5867),
    [anon_sym_register] = ACTIONS(5867),
    [anon_sym_inline] = ACTIONS(5867),
    [anon_sym_const] = ACTIONS(5867),
    [anon_sym_restrict] = ACTIONS(5867),
    [anon_sym_volatile] = ACTIONS(5867),
    [anon_sym__Atomic] = ACTIONS(5867),
    [anon_sym_mutable] = ACTIONS(5867),
    [anon_sym_explicit] = ACTIONS(5867),
    [anon_sym_constexpr] = ACTIONS(5867),
    [anon_sym_unsigned] = ACTIONS(5867),
    [anon_sym_long] = ACTIONS(5867),
    [anon_sym_short] = ACTIONS(5867),
    [sym_primitive_type] = ACTIONS(5867),
    [anon_sym_enum] = ACTIONS(5867),
    [anon_sym_struct] = ACTIONS(5867),
    [anon_sym_union] = ACTIONS(5867),
    [anon_sym_AMP] = ACTIONS(5867),
    [anon_sym_AMP_AMP] = ACTIONS(5865),
    [anon_sym_TILDE] = ACTIONS(5865),
    [sym_identifier] = ACTIONS(5867),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5867),
    [anon_sym_public] = ACTIONS(5867),
    [sym_auto] = ACTIONS(5867),
    [anon_sym_typename] = ACTIONS(5867),
    [anon_sym_template] = ACTIONS(5867),
    [anon_sym_friend] = ACTIONS(5867),
    [anon_sym_private] = ACTIONS(5867),
    [anon_sym_protected] = ACTIONS(5867),
    [anon_sym_using] = ACTIONS(5867),
    [anon_sym_COLON_COLON] = ACTIONS(5865),
    [sym_operator_name] = ACTIONS(5865),
  },
  [2215] = {
    [anon_sym_LPAREN] = ACTIONS(5869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5869),
    [anon_sym_typedef] = ACTIONS(5871),
    [anon_sym_extern] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5869),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_static] = ACTIONS(5871),
    [anon_sym_register] = ACTIONS(5871),
    [anon_sym_inline] = ACTIONS(5871),
    [anon_sym_const] = ACTIONS(5871),
    [anon_sym_restrict] = ACTIONS(5871),
    [anon_sym_volatile] = ACTIONS(5871),
    [anon_sym__Atomic] = ACTIONS(5871),
    [anon_sym_mutable] = ACTIONS(5871),
    [anon_sym_explicit] = ACTIONS(5871),
    [anon_sym_constexpr] = ACTIONS(5871),
    [anon_sym_unsigned] = ACTIONS(5871),
    [anon_sym_long] = ACTIONS(5871),
    [anon_sym_short] = ACTIONS(5871),
    [sym_primitive_type] = ACTIONS(5871),
    [anon_sym_enum] = ACTIONS(5871),
    [anon_sym_struct] = ACTIONS(5871),
    [anon_sym_union] = ACTIONS(5871),
    [anon_sym_AMP] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5869),
    [anon_sym_TILDE] = ACTIONS(5869),
    [sym_identifier] = ACTIONS(5871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5871),
    [anon_sym_public] = ACTIONS(5871),
    [sym_auto] = ACTIONS(5871),
    [anon_sym_typename] = ACTIONS(5871),
    [anon_sym_template] = ACTIONS(5871),
    [anon_sym_friend] = ACTIONS(5871),
    [anon_sym_private] = ACTIONS(5871),
    [anon_sym_protected] = ACTIONS(5871),
    [anon_sym_using] = ACTIONS(5871),
    [anon_sym_COLON_COLON] = ACTIONS(5869),
    [sym_operator_name] = ACTIONS(5869),
  },
  [2216] = {
    [anon_sym_LPAREN] = ACTIONS(5873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5875),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5873),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5873),
    [anon_sym_typedef] = ACTIONS(5875),
    [anon_sym_extern] = ACTIONS(5875),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_STAR] = ACTIONS(5873),
    [anon_sym_static] = ACTIONS(5875),
    [anon_sym_register] = ACTIONS(5875),
    [anon_sym_inline] = ACTIONS(5875),
    [anon_sym_const] = ACTIONS(5875),
    [anon_sym_restrict] = ACTIONS(5875),
    [anon_sym_volatile] = ACTIONS(5875),
    [anon_sym__Atomic] = ACTIONS(5875),
    [anon_sym_mutable] = ACTIONS(5875),
    [anon_sym_explicit] = ACTIONS(5875),
    [anon_sym_constexpr] = ACTIONS(5875),
    [anon_sym_unsigned] = ACTIONS(5875),
    [anon_sym_long] = ACTIONS(5875),
    [anon_sym_short] = ACTIONS(5875),
    [sym_primitive_type] = ACTIONS(5875),
    [anon_sym_enum] = ACTIONS(5875),
    [anon_sym_struct] = ACTIONS(5875),
    [anon_sym_union] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_TILDE] = ACTIONS(5873),
    [sym_identifier] = ACTIONS(5875),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5875),
    [anon_sym_public] = ACTIONS(5875),
    [sym_auto] = ACTIONS(5875),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(5875),
    [anon_sym_friend] = ACTIONS(5875),
    [anon_sym_private] = ACTIONS(5875),
    [anon_sym_protected] = ACTIONS(5875),
    [anon_sym_using] = ACTIONS(5875),
    [anon_sym_COLON_COLON] = ACTIONS(5873),
    [sym_operator_name] = ACTIONS(5873),
  },
  [2217] = {
    [anon_sym_LPAREN] = ACTIONS(5877),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5879),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5877),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5877),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5877),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5877),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5877),
    [anon_sym_typedef] = ACTIONS(5879),
    [anon_sym_extern] = ACTIONS(5879),
    [anon_sym_RBRACE] = ACTIONS(5877),
    [anon_sym_STAR] = ACTIONS(5877),
    [anon_sym_static] = ACTIONS(5879),
    [anon_sym_register] = ACTIONS(5879),
    [anon_sym_inline] = ACTIONS(5879),
    [anon_sym_const] = ACTIONS(5879),
    [anon_sym_restrict] = ACTIONS(5879),
    [anon_sym_volatile] = ACTIONS(5879),
    [anon_sym__Atomic] = ACTIONS(5879),
    [anon_sym_mutable] = ACTIONS(5879),
    [anon_sym_explicit] = ACTIONS(5879),
    [anon_sym_constexpr] = ACTIONS(5879),
    [anon_sym_unsigned] = ACTIONS(5879),
    [anon_sym_long] = ACTIONS(5879),
    [anon_sym_short] = ACTIONS(5879),
    [sym_primitive_type] = ACTIONS(5879),
    [anon_sym_enum] = ACTIONS(5879),
    [anon_sym_struct] = ACTIONS(5879),
    [anon_sym_union] = ACTIONS(5879),
    [anon_sym_AMP] = ACTIONS(5879),
    [anon_sym_AMP_AMP] = ACTIONS(5877),
    [anon_sym_TILDE] = ACTIONS(5877),
    [sym_identifier] = ACTIONS(5879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5879),
    [anon_sym_public] = ACTIONS(5879),
    [sym_auto] = ACTIONS(5879),
    [anon_sym_typename] = ACTIONS(5879),
    [anon_sym_template] = ACTIONS(5879),
    [anon_sym_friend] = ACTIONS(5879),
    [anon_sym_private] = ACTIONS(5879),
    [anon_sym_protected] = ACTIONS(5879),
    [anon_sym_using] = ACTIONS(5879),
    [anon_sym_COLON_COLON] = ACTIONS(5877),
    [sym_operator_name] = ACTIONS(5877),
  },
  [2218] = {
    [anon_sym_LPAREN] = ACTIONS(5881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5881),
    [anon_sym_typedef] = ACTIONS(5883),
    [anon_sym_extern] = ACTIONS(5883),
    [anon_sym_RBRACE] = ACTIONS(5881),
    [anon_sym_STAR] = ACTIONS(5881),
    [anon_sym_static] = ACTIONS(5883),
    [anon_sym_register] = ACTIONS(5883),
    [anon_sym_inline] = ACTIONS(5883),
    [anon_sym_const] = ACTIONS(5883),
    [anon_sym_restrict] = ACTIONS(5883),
    [anon_sym_volatile] = ACTIONS(5883),
    [anon_sym__Atomic] = ACTIONS(5883),
    [anon_sym_mutable] = ACTIONS(5883),
    [anon_sym_explicit] = ACTIONS(5883),
    [anon_sym_constexpr] = ACTIONS(5883),
    [anon_sym_unsigned] = ACTIONS(5883),
    [anon_sym_long] = ACTIONS(5883),
    [anon_sym_short] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(5883),
    [anon_sym_enum] = ACTIONS(5883),
    [anon_sym_struct] = ACTIONS(5883),
    [anon_sym_union] = ACTIONS(5883),
    [anon_sym_AMP] = ACTIONS(5883),
    [anon_sym_AMP_AMP] = ACTIONS(5881),
    [anon_sym_TILDE] = ACTIONS(5881),
    [sym_identifier] = ACTIONS(5883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5883),
    [anon_sym_public] = ACTIONS(5883),
    [sym_auto] = ACTIONS(5883),
    [anon_sym_typename] = ACTIONS(5883),
    [anon_sym_template] = ACTIONS(5883),
    [anon_sym_friend] = ACTIONS(5883),
    [anon_sym_private] = ACTIONS(5883),
    [anon_sym_protected] = ACTIONS(5883),
    [anon_sym_using] = ACTIONS(5883),
    [anon_sym_COLON_COLON] = ACTIONS(5881),
    [sym_operator_name] = ACTIONS(5881),
  },
  [2219] = {
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_public] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_friend] = ACTIONS(3615),
    [anon_sym_private] = ACTIONS(3615),
    [anon_sym_protected] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [sym_operator_name] = ACTIONS(3613),
  },
  [2220] = {
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(2472),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [anon_sym_public] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_template] = ACTIONS(1682),
    [anon_sym_friend] = ACTIONS(1682),
    [anon_sym_private] = ACTIONS(1682),
    [anon_sym_protected] = ACTIONS(1682),
    [anon_sym_using] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [sym_operator_name] = ACTIONS(1680),
  },
  [2221] = {
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [anon_sym_public] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_friend] = ACTIONS(2552),
    [anon_sym_private] = ACTIONS(2552),
    [anon_sym_protected] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [sym_operator_name] = ACTIONS(2550),
  },
  [2222] = {
    [anon_sym_LPAREN] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3970),
    [anon_sym_typedef] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3972),
    [anon_sym_RBRACE] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_register] = ACTIONS(3972),
    [anon_sym_inline] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3972),
    [anon_sym_restrict] = ACTIONS(3972),
    [anon_sym_volatile] = ACTIONS(3972),
    [anon_sym__Atomic] = ACTIONS(3972),
    [anon_sym_mutable] = ACTIONS(3972),
    [anon_sym_explicit] = ACTIONS(3972),
    [anon_sym_constexpr] = ACTIONS(3972),
    [anon_sym_unsigned] = ACTIONS(3972),
    [anon_sym_long] = ACTIONS(3972),
    [anon_sym_short] = ACTIONS(3972),
    [sym_primitive_type] = ACTIONS(3972),
    [anon_sym_enum] = ACTIONS(3972),
    [anon_sym_struct] = ACTIONS(3972),
    [anon_sym_union] = ACTIONS(3972),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3970),
    [anon_sym_TILDE] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3972),
    [anon_sym_public] = ACTIONS(3972),
    [sym_auto] = ACTIONS(3972),
    [anon_sym_typename] = ACTIONS(3972),
    [anon_sym_template] = ACTIONS(3972),
    [anon_sym_friend] = ACTIONS(3972),
    [anon_sym_private] = ACTIONS(3972),
    [anon_sym_protected] = ACTIONS(3972),
    [anon_sym_using] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [sym_operator_name] = ACTIONS(3970),
  },
  [2223] = {
    [sym_type_qualifier] = STATE(977),
    [sym_trailing_return_type] = STATE(977),
    [aux_sym_function_declarator_repeat1] = STATE(977),
    [anon_sym_LPAREN] = ACTIONS(5055),
    [anon_sym_RPAREN] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(1901),
  },
  [2224] = {
    [sym_parameter_list] = STATE(2226),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(3698),
    [sym_comment] = ACTIONS(49),
  },
  [2225] = {
    [sym_parameter_list] = STATE(2226),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3702),
    [anon_sym_SEMI] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_COLON] = ACTIONS(3702),
    [sym_comment] = ACTIONS(49),
  },
  [2226] = {
    [sym_type_qualifier] = STATE(2535),
    [sym_trailing_return_type] = STATE(2535),
    [aux_sym_function_declarator_repeat1] = STATE(2535),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3739),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5887),
  },
  [2227] = {
    [anon_sym_LPAREN] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [sym_comment] = ACTIONS(49),
  },
  [2228] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5891),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2229] = {
    [anon_sym_LPAREN] = ACTIONS(5893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5895),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5893),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5893),
    [anon_sym_typedef] = ACTIONS(5895),
    [anon_sym_extern] = ACTIONS(5895),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(5893),
    [anon_sym_static] = ACTIONS(5895),
    [anon_sym_register] = ACTIONS(5895),
    [anon_sym_inline] = ACTIONS(5895),
    [anon_sym_const] = ACTIONS(5895),
    [anon_sym_restrict] = ACTIONS(5895),
    [anon_sym_volatile] = ACTIONS(5895),
    [anon_sym__Atomic] = ACTIONS(5895),
    [anon_sym_mutable] = ACTIONS(5895),
    [anon_sym_explicit] = ACTIONS(5895),
    [anon_sym_constexpr] = ACTIONS(5895),
    [anon_sym_unsigned] = ACTIONS(5895),
    [anon_sym_long] = ACTIONS(5895),
    [anon_sym_short] = ACTIONS(5895),
    [sym_primitive_type] = ACTIONS(5895),
    [anon_sym_enum] = ACTIONS(5895),
    [anon_sym_struct] = ACTIONS(5895),
    [anon_sym_union] = ACTIONS(5895),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_TILDE] = ACTIONS(5893),
    [sym_identifier] = ACTIONS(5895),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5895),
    [anon_sym_public] = ACTIONS(5895),
    [sym_auto] = ACTIONS(5895),
    [anon_sym_typename] = ACTIONS(5895),
    [anon_sym_template] = ACTIONS(5895),
    [anon_sym_friend] = ACTIONS(5895),
    [anon_sym_private] = ACTIONS(5895),
    [anon_sym_protected] = ACTIONS(5895),
    [anon_sym_using] = ACTIONS(5895),
    [anon_sym_COLON_COLON] = ACTIONS(5893),
    [sym_operator_name] = ACTIONS(5893),
  },
  [2230] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2232),
    [anon_sym_unsigned] = ACTIONS(5049),
    [anon_sym_long] = ACTIONS(5049),
    [anon_sym_short] = ACTIONS(5049),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(5053),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2231] = {
    [sym__abstract_declarator] = STATE(2539),
    [sym_abstract_pointer_declarator] = STATE(2539),
    [sym_abstract_function_declarator] = STATE(2539),
    [sym_abstract_array_declarator] = STATE(2539),
    [sym_parameter_list] = STATE(2540),
    [sym_abstract_reference_declarator] = STATE(2539),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(5897),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(5899),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [2232] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2541),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(5903),
    [anon_sym_long] = ACTIONS(5903),
    [anon_sym_short] = ACTIONS(5903),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [2233] = {
    [sym_type_qualifier] = STATE(2233),
    [sym_trailing_return_type] = STATE(2233),
    [aux_sym_function_declarator_repeat1] = STATE(2233),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(5905),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5908),
  },
  [2234] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5911),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2235] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_COLON] = ACTIONS(2362),
    [anon_sym_QMARK] = ACTIONS(2362),
    [anon_sym_STAR_EQ] = ACTIONS(2362),
    [anon_sym_SLASH_EQ] = ACTIONS(2362),
    [anon_sym_PERCENT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_GT_EQ] = ACTIONS(2362),
    [anon_sym_AMP_EQ] = ACTIONS(2362),
    [anon_sym_CARET_EQ] = ACTIONS(2362),
    [anon_sym_PIPE_EQ] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_CARET] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_PERCENT] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DOT] = ACTIONS(2362),
    [anon_sym_DASH_GT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(49),
  },
  [2236] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(5913),
    [sym_comment] = ACTIONS(49),
  },
  [2237] = {
    [sym__abstract_declarator] = STATE(2544),
    [sym_abstract_pointer_declarator] = STATE(2544),
    [sym_abstract_function_declarator] = STATE(2544),
    [sym_abstract_array_declarator] = STATE(2544),
    [sym_parameter_list] = STATE(2240),
    [sym_abstract_reference_declarator] = STATE(2544),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5075),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [2238] = {
    [sym__abstract_declarator] = STATE(2545),
    [sym_abstract_pointer_declarator] = STATE(2545),
    [sym_abstract_function_declarator] = STATE(2545),
    [sym_abstract_array_declarator] = STATE(2545),
    [sym_parameter_list] = STATE(2240),
    [sym_abstract_reference_declarator] = STATE(2545),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5075),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [2239] = {
    [sym_parameter_list] = STATE(2546),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [2240] = {
    [sym_type_qualifier] = STATE(2547),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2547),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [2241] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2241),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(5915),
    [anon_sym_long] = ACTIONS(5915),
    [anon_sym_short] = ACTIONS(5915),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [2242] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_RPAREN] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2243] = {
    [sym__expression] = STATE(2548),
    [sym_conditional_expression] = STATE(2548),
    [sym_assignment_expression] = STATE(2548),
    [sym_pointer_expression] = STATE(2548),
    [sym_logical_expression] = STATE(2548),
    [sym_bitwise_expression] = STATE(2548),
    [sym_equality_expression] = STATE(2548),
    [sym_relational_expression] = STATE(2548),
    [sym_shift_expression] = STATE(2548),
    [sym_math_expression] = STATE(2548),
    [sym_cast_expression] = STATE(2548),
    [sym_sizeof_expression] = STATE(2548),
    [sym_subscript_expression] = STATE(2548),
    [sym_call_expression] = STATE(2548),
    [sym_field_expression] = STATE(2548),
    [sym_compound_literal_expression] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2548),
    [sym_concatenated_string] = STATE(2548),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2548),
    [sym_new_expression] = STATE(2548),
    [sym_delete_expression] = STATE(2548),
    [sym_lambda_expression] = STATE(2548),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5922),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(5922),
    [sym_char_literal] = ACTIONS(5922),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(5924),
    [sym_false] = ACTIONS(5924),
    [sym_null] = ACTIONS(5924),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(5924),
  },
  [2244] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2245] = {
    [sym__expression] = STATE(2549),
    [sym_conditional_expression] = STATE(2549),
    [sym_assignment_expression] = STATE(2549),
    [sym_pointer_expression] = STATE(2549),
    [sym_logical_expression] = STATE(2549),
    [sym_bitwise_expression] = STATE(2549),
    [sym_equality_expression] = STATE(2549),
    [sym_relational_expression] = STATE(2549),
    [sym_shift_expression] = STATE(2549),
    [sym_math_expression] = STATE(2549),
    [sym_cast_expression] = STATE(2549),
    [sym_sizeof_expression] = STATE(2549),
    [sym_subscript_expression] = STATE(2549),
    [sym_call_expression] = STATE(2549),
    [sym_field_expression] = STATE(2549),
    [sym_compound_literal_expression] = STATE(2549),
    [sym_parenthesized_expression] = STATE(2549),
    [sym_concatenated_string] = STATE(2549),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2549),
    [sym_new_expression] = STATE(2549),
    [sym_delete_expression] = STATE(2549),
    [sym_lambda_expression] = STATE(2549),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(5926),
    [sym_char_literal] = ACTIONS(5926),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(5928),
    [sym_false] = ACTIONS(5928),
    [sym_null] = ACTIONS(5928),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(5928),
  },
  [2246] = {
    [sym_type_qualifier] = STATE(2248),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2248),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5108),
  },
  [2247] = {
    [sym__abstract_declarator] = STATE(2550),
    [sym_abstract_pointer_declarator] = STATE(2550),
    [sym_abstract_function_declarator] = STATE(2550),
    [sym_abstract_array_declarator] = STATE(2550),
    [sym_parameter_list] = STATE(1173),
    [sym_abstract_reference_declarator] = STATE(2550),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [sym_comment] = ACTIONS(49),
  },
  [2248] = {
    [sym_type_qualifier] = STATE(2248),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2248),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5930),
  },
  [2249] = {
    [anon_sym_LPAREN] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_SEMI] = ACTIONS(5933),
    [anon_sym_LBRACE] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_EQ] = ACTIONS(5933),
    [anon_sym_const] = ACTIONS(5935),
    [anon_sym_restrict] = ACTIONS(5933),
    [anon_sym_volatile] = ACTIONS(5933),
    [anon_sym__Atomic] = ACTIONS(5933),
    [anon_sym_mutable] = ACTIONS(5933),
    [anon_sym_explicit] = ACTIONS(5933),
    [anon_sym_constexpr] = ACTIONS(5933),
    [anon_sym_COLON] = ACTIONS(5933),
    [anon_sym_GT] = ACTIONS(5933),
    [anon_sym_DASH_GT] = ACTIONS(5933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5933),
  },
  [2250] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2251] = {
    [anon_sym_LPAREN] = ACTIONS(5939),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_RPAREN] = ACTIONS(5939),
    [anon_sym_SEMI] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_const] = ACTIONS(5941),
    [anon_sym_restrict] = ACTIONS(5939),
    [anon_sym_volatile] = ACTIONS(5939),
    [anon_sym__Atomic] = ACTIONS(5939),
    [anon_sym_mutable] = ACTIONS(5939),
    [anon_sym_explicit] = ACTIONS(5939),
    [anon_sym_constexpr] = ACTIONS(5939),
    [anon_sym_COLON] = ACTIONS(5939),
    [anon_sym_GT] = ACTIONS(5939),
    [anon_sym_DASH_GT] = ACTIONS(5939),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5939),
  },
  [2252] = {
    [sym_parameter_list] = STATE(1180),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
  },
  [2253] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2253),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(5943),
    [anon_sym_long] = ACTIONS(5943),
    [anon_sym_short] = ACTIONS(5943),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [2254] = {
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(49),
  },
  [2255] = {
    [aux_sym_argument_list_repeat1] = STATE(1827),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [sym_comment] = ACTIONS(49),
  },
  [2256] = {
    [anon_sym_COMMA] = ACTIONS(4000),
    [anon_sym_GT] = ACTIONS(4000),
    [sym_comment] = ACTIONS(49),
  },
  [2257] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4070),
    [sym_char_literal] = ACTIONS(4070),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4072),
  },
  [2258] = {
    [aux_sym_initializer_list_repeat1] = STATE(1851),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [sym_comment] = ACTIONS(49),
  },
  [2259] = {
    [anon_sym_RPAREN] = ACTIONS(5952),
    [sym_comment] = ACTIONS(49),
  },
  [2260] = {
    [sym_type_qualifier] = STATE(761),
    [sym__type_specifier] = STATE(757),
    [sym_sized_type_specifier] = STATE(757),
    [sym_enum_specifier] = STATE(757),
    [sym_struct_specifier] = STATE(757),
    [sym_union_specifier] = STATE(757),
    [sym__expression] = STATE(758),
    [sym_comma_expression] = STATE(759),
    [sym_conditional_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_pointer_expression] = STATE(758),
    [sym_logical_expression] = STATE(758),
    [sym_bitwise_expression] = STATE(758),
    [sym_equality_expression] = STATE(758),
    [sym_relational_expression] = STATE(758),
    [sym_shift_expression] = STATE(758),
    [sym_math_expression] = STATE(758),
    [sym_cast_expression] = STATE(758),
    [sym_type_descriptor] = STATE(2556),
    [sym_sizeof_expression] = STATE(758),
    [sym_subscript_expression] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_field_expression] = STATE(758),
    [sym_compound_literal_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenated_string] = STATE(758),
    [sym_macro_type_specifier] = STATE(757),
    [sym_class_specifier] = STATE(757),
    [sym_dependent_type] = STATE(757),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_delete_expression] = STATE(758),
    [sym_lambda_expression] = STATE(758),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_type_definition_repeat1] = STATE(761),
    [aux_sym_sized_type_specifier_repeat1] = STATE(762),
    [sym_raw_string_literal] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(1451),
    [anon_sym_typename] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(1453),
  },
  [2261] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2262] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2557),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_STAR_EQ] = ACTIONS(2784),
    [anon_sym_SLASH_EQ] = ACTIONS(2784),
    [anon_sym_PERCENT_EQ] = ACTIONS(2784),
    [anon_sym_PLUS_EQ] = ACTIONS(2784),
    [anon_sym_DASH_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_GT_EQ] = ACTIONS(2784),
    [anon_sym_AMP_EQ] = ACTIONS(2784),
    [anon_sym_CARET_EQ] = ACTIONS(2784),
    [anon_sym_PIPE_EQ] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_DASH_GT] = ACTIONS(2784),
    [sym_string_literal] = ACTIONS(5954),
    [sym_comment] = ACTIONS(49),
  },
  [2263] = {
    [sym__expression] = STATE(2559),
    [sym_conditional_expression] = STATE(2559),
    [sym_assignment_expression] = STATE(2559),
    [sym_pointer_expression] = STATE(2559),
    [sym_logical_expression] = STATE(2559),
    [sym_bitwise_expression] = STATE(2559),
    [sym_equality_expression] = STATE(2559),
    [sym_relational_expression] = STATE(2559),
    [sym_shift_expression] = STATE(2559),
    [sym_math_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_sizeof_expression] = STATE(2559),
    [sym_subscript_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_field_expression] = STATE(2559),
    [sym_compound_literal_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_concatenated_string] = STATE(2559),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2559),
    [sym_new_expression] = STATE(2559),
    [sym_delete_expression] = STATE(2559),
    [sym_lambda_expression] = STATE(2559),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5956),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5956),
    [sym_char_literal] = ACTIONS(5956),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5960),
    [sym_false] = ACTIONS(5960),
    [sym_null] = ACTIONS(5960),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5960),
  },
  [2264] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5962),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [2265] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(2826),
    [anon_sym_SLASH_EQ] = ACTIONS(2826),
    [anon_sym_PERCENT_EQ] = ACTIONS(2826),
    [anon_sym_PLUS_EQ] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(2826),
    [anon_sym_LT_LT_EQ] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(2826),
    [anon_sym_CARET_EQ] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2266] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_delete_expression] = STATE(1391),
    [sym_lambda_expression] = STATE(1391),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(2836),
  },
  [2267] = {
    [sym__expression] = STATE(2561),
    [sym_conditional_expression] = STATE(2561),
    [sym_assignment_expression] = STATE(2561),
    [sym_pointer_expression] = STATE(2561),
    [sym_logical_expression] = STATE(2561),
    [sym_bitwise_expression] = STATE(2561),
    [sym_equality_expression] = STATE(2561),
    [sym_relational_expression] = STATE(2561),
    [sym_shift_expression] = STATE(2561),
    [sym_math_expression] = STATE(2561),
    [sym_cast_expression] = STATE(2561),
    [sym_sizeof_expression] = STATE(2561),
    [sym_subscript_expression] = STATE(2561),
    [sym_call_expression] = STATE(2561),
    [sym_field_expression] = STATE(2561),
    [sym_compound_literal_expression] = STATE(2561),
    [sym_parenthesized_expression] = STATE(2561),
    [sym_concatenated_string] = STATE(2561),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2561),
    [sym_new_expression] = STATE(2561),
    [sym_delete_expression] = STATE(2561),
    [sym_lambda_expression] = STATE(2561),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5964),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5964),
    [sym_char_literal] = ACTIONS(5964),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5966),
    [sym_false] = ACTIONS(5966),
    [sym_null] = ACTIONS(5966),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5966),
  },
  [2268] = {
    [sym__expression] = STATE(2562),
    [sym_conditional_expression] = STATE(2562),
    [sym_assignment_expression] = STATE(2562),
    [sym_pointer_expression] = STATE(2562),
    [sym_logical_expression] = STATE(2562),
    [sym_bitwise_expression] = STATE(2562),
    [sym_equality_expression] = STATE(2562),
    [sym_relational_expression] = STATE(2562),
    [sym_shift_expression] = STATE(2562),
    [sym_math_expression] = STATE(2562),
    [sym_cast_expression] = STATE(2562),
    [sym_sizeof_expression] = STATE(2562),
    [sym_subscript_expression] = STATE(2562),
    [sym_call_expression] = STATE(2562),
    [sym_field_expression] = STATE(2562),
    [sym_compound_literal_expression] = STATE(2562),
    [sym_parenthesized_expression] = STATE(2562),
    [sym_concatenated_string] = STATE(2562),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2562),
    [sym_new_expression] = STATE(2562),
    [sym_delete_expression] = STATE(2562),
    [sym_lambda_expression] = STATE(2562),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5968),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(5968),
    [sym_char_literal] = ACTIONS(5968),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5970),
    [sym_false] = ACTIONS(5970),
    [sym_null] = ACTIONS(5970),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5970),
  },
  [2269] = {
    [sym__expression] = STATE(2563),
    [sym_conditional_expression] = STATE(2563),
    [sym_assignment_expression] = STATE(2563),
    [sym_pointer_expression] = STATE(2563),
    [sym_logical_expression] = STATE(2563),
    [sym_bitwise_expression] = STATE(2563),
    [sym_equality_expression] = STATE(2563),
    [sym_relational_expression] = STATE(2563),
    [sym_shift_expression] = STATE(2563),
    [sym_math_expression] = STATE(2563),
    [sym_cast_expression] = STATE(2563),
    [sym_sizeof_expression] = STATE(2563),
    [sym_subscript_expression] = STATE(2563),
    [sym_call_expression] = STATE(2563),
    [sym_field_expression] = STATE(2563),
    [sym_compound_literal_expression] = STATE(2563),
    [sym_parenthesized_expression] = STATE(2563),
    [sym_concatenated_string] = STATE(2563),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2563),
    [sym_new_expression] = STATE(2563),
    [sym_delete_expression] = STATE(2563),
    [sym_lambda_expression] = STATE(2563),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5972),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5972),
    [sym_char_literal] = ACTIONS(5972),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5974),
    [sym_false] = ACTIONS(5974),
    [sym_null] = ACTIONS(5974),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5974),
  },
  [2270] = {
    [sym__expression] = STATE(2564),
    [sym_conditional_expression] = STATE(2564),
    [sym_assignment_expression] = STATE(2564),
    [sym_pointer_expression] = STATE(2564),
    [sym_logical_expression] = STATE(2564),
    [sym_bitwise_expression] = STATE(2564),
    [sym_equality_expression] = STATE(2564),
    [sym_relational_expression] = STATE(2564),
    [sym_shift_expression] = STATE(2564),
    [sym_math_expression] = STATE(2564),
    [sym_cast_expression] = STATE(2564),
    [sym_sizeof_expression] = STATE(2564),
    [sym_subscript_expression] = STATE(2564),
    [sym_call_expression] = STATE(2564),
    [sym_field_expression] = STATE(2564),
    [sym_compound_literal_expression] = STATE(2564),
    [sym_parenthesized_expression] = STATE(2564),
    [sym_concatenated_string] = STATE(2564),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2564),
    [sym_new_expression] = STATE(2564),
    [sym_delete_expression] = STATE(2564),
    [sym_lambda_expression] = STATE(2564),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5976),
    [sym_char_literal] = ACTIONS(5976),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5978),
    [sym_false] = ACTIONS(5978),
    [sym_null] = ACTIONS(5978),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5978),
  },
  [2271] = {
    [sym__expression] = STATE(2565),
    [sym_conditional_expression] = STATE(2565),
    [sym_assignment_expression] = STATE(2565),
    [sym_pointer_expression] = STATE(2565),
    [sym_logical_expression] = STATE(2565),
    [sym_bitwise_expression] = STATE(2565),
    [sym_equality_expression] = STATE(2565),
    [sym_relational_expression] = STATE(2565),
    [sym_shift_expression] = STATE(2565),
    [sym_math_expression] = STATE(2565),
    [sym_cast_expression] = STATE(2565),
    [sym_sizeof_expression] = STATE(2565),
    [sym_subscript_expression] = STATE(2565),
    [sym_call_expression] = STATE(2565),
    [sym_field_expression] = STATE(2565),
    [sym_compound_literal_expression] = STATE(2565),
    [sym_parenthesized_expression] = STATE(2565),
    [sym_concatenated_string] = STATE(2565),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2565),
    [sym_new_expression] = STATE(2565),
    [sym_delete_expression] = STATE(2565),
    [sym_lambda_expression] = STATE(2565),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5980),
    [sym_char_literal] = ACTIONS(5980),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5982),
    [sym_false] = ACTIONS(5982),
    [sym_null] = ACTIONS(5982),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5982),
  },
  [2272] = {
    [sym__expression] = STATE(2566),
    [sym_conditional_expression] = STATE(2566),
    [sym_assignment_expression] = STATE(2566),
    [sym_pointer_expression] = STATE(2566),
    [sym_logical_expression] = STATE(2566),
    [sym_bitwise_expression] = STATE(2566),
    [sym_equality_expression] = STATE(2566),
    [sym_relational_expression] = STATE(2566),
    [sym_shift_expression] = STATE(2566),
    [sym_math_expression] = STATE(2566),
    [sym_cast_expression] = STATE(2566),
    [sym_sizeof_expression] = STATE(2566),
    [sym_subscript_expression] = STATE(2566),
    [sym_call_expression] = STATE(2566),
    [sym_field_expression] = STATE(2566),
    [sym_compound_literal_expression] = STATE(2566),
    [sym_parenthesized_expression] = STATE(2566),
    [sym_concatenated_string] = STATE(2566),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2566),
    [sym_new_expression] = STATE(2566),
    [sym_delete_expression] = STATE(2566),
    [sym_lambda_expression] = STATE(2566),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5984),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5984),
    [sym_char_literal] = ACTIONS(5984),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5986),
    [sym_false] = ACTIONS(5986),
    [sym_null] = ACTIONS(5986),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5986),
  },
  [2273] = {
    [sym__expression] = STATE(2567),
    [sym_conditional_expression] = STATE(2567),
    [sym_assignment_expression] = STATE(2567),
    [sym_pointer_expression] = STATE(2567),
    [sym_logical_expression] = STATE(2567),
    [sym_bitwise_expression] = STATE(2567),
    [sym_equality_expression] = STATE(2567),
    [sym_relational_expression] = STATE(2567),
    [sym_shift_expression] = STATE(2567),
    [sym_math_expression] = STATE(2567),
    [sym_cast_expression] = STATE(2567),
    [sym_sizeof_expression] = STATE(2567),
    [sym_subscript_expression] = STATE(2567),
    [sym_call_expression] = STATE(2567),
    [sym_field_expression] = STATE(2567),
    [sym_compound_literal_expression] = STATE(2567),
    [sym_parenthesized_expression] = STATE(2567),
    [sym_concatenated_string] = STATE(2567),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2567),
    [sym_new_expression] = STATE(2567),
    [sym_delete_expression] = STATE(2567),
    [sym_lambda_expression] = STATE(2567),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5988),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5988),
    [sym_char_literal] = ACTIONS(5988),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5990),
    [sym_false] = ACTIONS(5990),
    [sym_null] = ACTIONS(5990),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5990),
  },
  [2274] = {
    [sym__expression] = STATE(2568),
    [sym_conditional_expression] = STATE(2568),
    [sym_assignment_expression] = STATE(2568),
    [sym_pointer_expression] = STATE(2568),
    [sym_logical_expression] = STATE(2568),
    [sym_bitwise_expression] = STATE(2568),
    [sym_equality_expression] = STATE(2568),
    [sym_relational_expression] = STATE(2568),
    [sym_shift_expression] = STATE(2568),
    [sym_math_expression] = STATE(2568),
    [sym_cast_expression] = STATE(2568),
    [sym_sizeof_expression] = STATE(2568),
    [sym_subscript_expression] = STATE(2568),
    [sym_call_expression] = STATE(2568),
    [sym_field_expression] = STATE(2568),
    [sym_compound_literal_expression] = STATE(2568),
    [sym_parenthesized_expression] = STATE(2568),
    [sym_concatenated_string] = STATE(2568),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2568),
    [sym_new_expression] = STATE(2568),
    [sym_delete_expression] = STATE(2568),
    [sym_lambda_expression] = STATE(2568),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5992),
    [sym_char_literal] = ACTIONS(5992),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5994),
    [sym_false] = ACTIONS(5994),
    [sym_null] = ACTIONS(5994),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5994),
  },
  [2275] = {
    [sym__expression] = STATE(2569),
    [sym_conditional_expression] = STATE(2569),
    [sym_assignment_expression] = STATE(2569),
    [sym_pointer_expression] = STATE(2569),
    [sym_logical_expression] = STATE(2569),
    [sym_bitwise_expression] = STATE(2569),
    [sym_equality_expression] = STATE(2569),
    [sym_relational_expression] = STATE(2569),
    [sym_shift_expression] = STATE(2569),
    [sym_math_expression] = STATE(2569),
    [sym_cast_expression] = STATE(2569),
    [sym_sizeof_expression] = STATE(2569),
    [sym_subscript_expression] = STATE(2569),
    [sym_call_expression] = STATE(2569),
    [sym_field_expression] = STATE(2569),
    [sym_compound_literal_expression] = STATE(2569),
    [sym_parenthesized_expression] = STATE(2569),
    [sym_concatenated_string] = STATE(2569),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2569),
    [sym_new_expression] = STATE(2569),
    [sym_delete_expression] = STATE(2569),
    [sym_lambda_expression] = STATE(2569),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5996),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(5996),
    [sym_char_literal] = ACTIONS(5996),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(5998),
    [sym_false] = ACTIONS(5998),
    [sym_null] = ACTIONS(5998),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(5998),
  },
  [2276] = {
    [sym__expression] = STATE(2570),
    [sym_conditional_expression] = STATE(2570),
    [sym_assignment_expression] = STATE(2570),
    [sym_pointer_expression] = STATE(2570),
    [sym_logical_expression] = STATE(2570),
    [sym_bitwise_expression] = STATE(2570),
    [sym_equality_expression] = STATE(2570),
    [sym_relational_expression] = STATE(2570),
    [sym_shift_expression] = STATE(2570),
    [sym_math_expression] = STATE(2570),
    [sym_cast_expression] = STATE(2570),
    [sym_sizeof_expression] = STATE(2570),
    [sym_subscript_expression] = STATE(2570),
    [sym_call_expression] = STATE(2570),
    [sym_field_expression] = STATE(2570),
    [sym_compound_literal_expression] = STATE(2570),
    [sym_parenthesized_expression] = STATE(2570),
    [sym_concatenated_string] = STATE(2570),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2570),
    [sym_new_expression] = STATE(2570),
    [sym_delete_expression] = STATE(2570),
    [sym_lambda_expression] = STATE(2570),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6000),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(6000),
    [sym_char_literal] = ACTIONS(6000),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(6002),
    [sym_false] = ACTIONS(6002),
    [sym_null] = ACTIONS(6002),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(6002),
  },
  [2277] = {
    [sym__expression] = STATE(2571),
    [sym_conditional_expression] = STATE(2571),
    [sym_assignment_expression] = STATE(2571),
    [sym_pointer_expression] = STATE(2571),
    [sym_logical_expression] = STATE(2571),
    [sym_bitwise_expression] = STATE(2571),
    [sym_equality_expression] = STATE(2571),
    [sym_relational_expression] = STATE(2571),
    [sym_shift_expression] = STATE(2571),
    [sym_math_expression] = STATE(2571),
    [sym_cast_expression] = STATE(2571),
    [sym_sizeof_expression] = STATE(2571),
    [sym_subscript_expression] = STATE(2571),
    [sym_call_expression] = STATE(2571),
    [sym_field_expression] = STATE(2571),
    [sym_compound_literal_expression] = STATE(2571),
    [sym_parenthesized_expression] = STATE(2571),
    [sym_concatenated_string] = STATE(2571),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2571),
    [sym_new_expression] = STATE(2571),
    [sym_delete_expression] = STATE(2571),
    [sym_lambda_expression] = STATE(2571),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6004),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(6004),
    [sym_char_literal] = ACTIONS(6004),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(6006),
    [sym_false] = ACTIONS(6006),
    [sym_null] = ACTIONS(6006),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(6006),
  },
  [2278] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2280),
    [anon_sym_unsigned] = ACTIONS(5189),
    [anon_sym_long] = ACTIONS(5189),
    [anon_sym_short] = ACTIONS(5189),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(5193),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2279] = {
    [sym__abstract_declarator] = STATE(2574),
    [sym_abstract_pointer_declarator] = STATE(2574),
    [sym_abstract_function_declarator] = STATE(2574),
    [sym_abstract_array_declarator] = STATE(2574),
    [sym_parameter_list] = STATE(2575),
    [sym_abstract_reference_declarator] = STATE(2574),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6012),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [2280] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_EQ] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(6014),
    [anon_sym_long] = ACTIONS(6014),
    [anon_sym_short] = ACTIONS(6014),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [2281] = {
    [sym_type_qualifier] = STATE(2281),
    [sym_trailing_return_type] = STATE(2281),
    [aux_sym_function_declarator_repeat1] = STATE(2281),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_GT] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(6016),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6019),
  },
  [2282] = {
    [sym_parameter_list] = STATE(2284),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2283] = {
    [sym_parameter_list] = STATE(2284),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2284] = {
    [sym_type_qualifier] = STATE(2577),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2577),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2285] = {
    [sym_type_qualifier] = STATE(2288),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2288),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1244),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5204),
  },
  [2286] = {
    [sym_type_qualifier] = STATE(2288),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2288),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(3966),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5204),
  },
  [2287] = {
    [sym__abstract_declarator] = STATE(2578),
    [sym_abstract_pointer_declarator] = STATE(2578),
    [sym_abstract_function_declarator] = STATE(2578),
    [sym_abstract_array_declarator] = STATE(2578),
    [sym_parameter_list] = STATE(1216),
    [sym_abstract_reference_declarator] = STATE(2578),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [sym_comment] = ACTIONS(49),
  },
  [2288] = {
    [sym_type_qualifier] = STATE(2288),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2288),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6022),
  },
  [2289] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_SEMI] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(5334),
    [anon_sym_STAR] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6025),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2290] = {
    [sym__expression] = STATE(2579),
    [sym_conditional_expression] = STATE(2579),
    [sym_assignment_expression] = STATE(2579),
    [sym_pointer_expression] = STATE(2579),
    [sym_logical_expression] = STATE(2579),
    [sym_bitwise_expression] = STATE(2579),
    [sym_equality_expression] = STATE(2579),
    [sym_relational_expression] = STATE(2579),
    [sym_shift_expression] = STATE(2579),
    [sym_math_expression] = STATE(2579),
    [sym_cast_expression] = STATE(2579),
    [sym_sizeof_expression] = STATE(2579),
    [sym_subscript_expression] = STATE(2579),
    [sym_call_expression] = STATE(2579),
    [sym_field_expression] = STATE(2579),
    [sym_compound_literal_expression] = STATE(2579),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_concatenated_string] = STATE(2579),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2579),
    [sym_new_expression] = STATE(2579),
    [sym_delete_expression] = STATE(2579),
    [sym_lambda_expression] = STATE(2579),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(6029),
    [sym_char_literal] = ACTIONS(6029),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(6031),
    [sym_false] = ACTIONS(6031),
    [sym_null] = ACTIONS(6031),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(6031),
  },
  [2291] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2292] = {
    [sym__expression] = STATE(2580),
    [sym_conditional_expression] = STATE(2580),
    [sym_assignment_expression] = STATE(2580),
    [sym_pointer_expression] = STATE(2580),
    [sym_logical_expression] = STATE(2580),
    [sym_bitwise_expression] = STATE(2580),
    [sym_equality_expression] = STATE(2580),
    [sym_relational_expression] = STATE(2580),
    [sym_shift_expression] = STATE(2580),
    [sym_math_expression] = STATE(2580),
    [sym_cast_expression] = STATE(2580),
    [sym_sizeof_expression] = STATE(2580),
    [sym_subscript_expression] = STATE(2580),
    [sym_call_expression] = STATE(2580),
    [sym_field_expression] = STATE(2580),
    [sym_compound_literal_expression] = STATE(2580),
    [sym_parenthesized_expression] = STATE(2580),
    [sym_concatenated_string] = STATE(2580),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2580),
    [sym_new_expression] = STATE(2580),
    [sym_delete_expression] = STATE(2580),
    [sym_lambda_expression] = STATE(2580),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6033),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(6033),
    [sym_char_literal] = ACTIONS(6033),
    [sym_string_literal] = ACTIONS(1341),
    [sym_true] = ACTIONS(6035),
    [sym_false] = ACTIONS(6035),
    [sym_null] = ACTIONS(6035),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(1347),
    [sym_nullptr] = ACTIONS(6035),
  },
  [2293] = {
    [anon_sym_LPAREN] = ACTIONS(6037),
    [anon_sym_COMMA] = ACTIONS(6037),
    [anon_sym_RPAREN] = ACTIONS(6037),
    [anon_sym_SEMI] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6037),
    [anon_sym_RBRACE] = ACTIONS(6037),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_LBRACK] = ACTIONS(6037),
    [anon_sym_RBRACK] = ACTIONS(6037),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_QMARK] = ACTIONS(6037),
    [anon_sym_STAR_EQ] = ACTIONS(6037),
    [anon_sym_SLASH_EQ] = ACTIONS(6037),
    [anon_sym_PERCENT_EQ] = ACTIONS(6037),
    [anon_sym_PLUS_EQ] = ACTIONS(6037),
    [anon_sym_DASH_EQ] = ACTIONS(6037),
    [anon_sym_LT_LT_EQ] = ACTIONS(6037),
    [anon_sym_GT_GT_EQ] = ACTIONS(6037),
    [anon_sym_AMP_EQ] = ACTIONS(6037),
    [anon_sym_CARET_EQ] = ACTIONS(6037),
    [anon_sym_PIPE_EQ] = ACTIONS(6037),
    [anon_sym_AMP] = ACTIONS(6039),
    [anon_sym_PIPE_PIPE] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_EQ_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(6037),
    [anon_sym_LT] = ACTIONS(6039),
    [anon_sym_GT] = ACTIONS(6039),
    [anon_sym_LT_EQ] = ACTIONS(6037),
    [anon_sym_GT_EQ] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_PERCENT] = ACTIONS(6039),
    [anon_sym_DASH_DASH] = ACTIONS(6037),
    [anon_sym_PLUS_PLUS] = ACTIONS(6037),
    [anon_sym_DOT] = ACTIONS(6037),
    [anon_sym_DASH_GT] = ACTIONS(6037),
    [sym_comment] = ACTIONS(49),
  },
  [2294] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4070),
    [sym_char_literal] = ACTIONS(4070),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4072),
  },
  [2295] = {
    [anon_sym_LBRACK] = ACTIONS(5215),
    [anon_sym_EQ] = ACTIONS(5215),
    [anon_sym_DOT] = ACTIONS(5215),
    [sym_comment] = ACTIONS(49),
  },
  [2296] = {
    [sym_parameter_list] = STATE(2298),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2297] = {
    [sym_parameter_list] = STATE(2298),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3866),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2298] = {
    [sym_type_qualifier] = STATE(2581),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2581),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2299] = {
    [sym_type_qualifier] = STATE(2582),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2582),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6041),
  },
  [2300] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(5334),
    [anon_sym_STAR] = ACTIONS(6043),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6045),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2301] = {
    [sym__expression] = STATE(2583),
    [sym_conditional_expression] = STATE(2583),
    [sym_assignment_expression] = STATE(2583),
    [sym_pointer_expression] = STATE(2583),
    [sym_logical_expression] = STATE(2583),
    [sym_bitwise_expression] = STATE(2583),
    [sym_equality_expression] = STATE(2583),
    [sym_relational_expression] = STATE(2583),
    [sym_shift_expression] = STATE(2583),
    [sym_math_expression] = STATE(2583),
    [sym_cast_expression] = STATE(2583),
    [sym_sizeof_expression] = STATE(2583),
    [sym_subscript_expression] = STATE(2583),
    [sym_call_expression] = STATE(2583),
    [sym_field_expression] = STATE(2583),
    [sym_compound_literal_expression] = STATE(2583),
    [sym_parenthesized_expression] = STATE(2583),
    [sym_concatenated_string] = STATE(2583),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2583),
    [sym_new_expression] = STATE(2583),
    [sym_delete_expression] = STATE(2583),
    [sym_lambda_expression] = STATE(2583),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6047),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(6047),
    [sym_char_literal] = ACTIONS(6047),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(6049),
    [sym_false] = ACTIONS(6049),
    [sym_null] = ACTIONS(6049),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(6049),
  },
  [2302] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2303] = {
    [sym__expression] = STATE(2584),
    [sym_conditional_expression] = STATE(2584),
    [sym_assignment_expression] = STATE(2584),
    [sym_pointer_expression] = STATE(2584),
    [sym_logical_expression] = STATE(2584),
    [sym_bitwise_expression] = STATE(2584),
    [sym_equality_expression] = STATE(2584),
    [sym_relational_expression] = STATE(2584),
    [sym_shift_expression] = STATE(2584),
    [sym_math_expression] = STATE(2584),
    [sym_cast_expression] = STATE(2584),
    [sym_sizeof_expression] = STATE(2584),
    [sym_subscript_expression] = STATE(2584),
    [sym_call_expression] = STATE(2584),
    [sym_field_expression] = STATE(2584),
    [sym_compound_literal_expression] = STATE(2584),
    [sym_parenthesized_expression] = STATE(2584),
    [sym_concatenated_string] = STATE(2584),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2584),
    [sym_new_expression] = STATE(2584),
    [sym_delete_expression] = STATE(2584),
    [sym_lambda_expression] = STATE(2584),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6051),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(6051),
    [sym_char_literal] = ACTIONS(6051),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(6053),
    [sym_false] = ACTIONS(6053),
    [sym_null] = ACTIONS(6053),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(6053),
  },
  [2304] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6055),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2305] = {
    [sym__expression] = STATE(2585),
    [sym_conditional_expression] = STATE(2585),
    [sym_assignment_expression] = STATE(2585),
    [sym_pointer_expression] = STATE(2585),
    [sym_logical_expression] = STATE(2585),
    [sym_bitwise_expression] = STATE(2585),
    [sym_equality_expression] = STATE(2585),
    [sym_relational_expression] = STATE(2585),
    [sym_shift_expression] = STATE(2585),
    [sym_math_expression] = STATE(2585),
    [sym_cast_expression] = STATE(2585),
    [sym_sizeof_expression] = STATE(2585),
    [sym_subscript_expression] = STATE(2585),
    [sym_call_expression] = STATE(2585),
    [sym_field_expression] = STATE(2585),
    [sym_compound_literal_expression] = STATE(2585),
    [sym_parenthesized_expression] = STATE(2585),
    [sym_concatenated_string] = STATE(2585),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2585),
    [sym_new_expression] = STATE(2585),
    [sym_delete_expression] = STATE(2585),
    [sym_lambda_expression] = STATE(2585),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6059),
    [sym_char_literal] = ACTIONS(6059),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6061),
    [sym_false] = ACTIONS(6061),
    [sym_null] = ACTIONS(6061),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6061),
  },
  [2306] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2307] = {
    [sym__expression] = STATE(2586),
    [sym_conditional_expression] = STATE(2586),
    [sym_assignment_expression] = STATE(2586),
    [sym_pointer_expression] = STATE(2586),
    [sym_logical_expression] = STATE(2586),
    [sym_bitwise_expression] = STATE(2586),
    [sym_equality_expression] = STATE(2586),
    [sym_relational_expression] = STATE(2586),
    [sym_shift_expression] = STATE(2586),
    [sym_math_expression] = STATE(2586),
    [sym_cast_expression] = STATE(2586),
    [sym_sizeof_expression] = STATE(2586),
    [sym_subscript_expression] = STATE(2586),
    [sym_call_expression] = STATE(2586),
    [sym_field_expression] = STATE(2586),
    [sym_compound_literal_expression] = STATE(2586),
    [sym_parenthesized_expression] = STATE(2586),
    [sym_concatenated_string] = STATE(2586),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2586),
    [sym_new_expression] = STATE(2586),
    [sym_delete_expression] = STATE(2586),
    [sym_lambda_expression] = STATE(2586),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6063),
    [sym_char_literal] = ACTIONS(6063),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6065),
    [sym_false] = ACTIONS(6065),
    [sym_null] = ACTIONS(6065),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6065),
  },
  [2308] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2310),
    [anon_sym_unsigned] = ACTIONS(5277),
    [anon_sym_long] = ACTIONS(5277),
    [anon_sym_short] = ACTIONS(5277),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2544),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(5281),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2309] = {
    [sym__abstract_declarator] = STATE(2589),
    [sym_abstract_pointer_declarator] = STATE(2589),
    [sym_abstract_function_declarator] = STATE(2589),
    [sym_abstract_array_declarator] = STATE(2589),
    [sym_parameter_list] = STATE(2590),
    [sym_abstract_reference_declarator] = STATE(2589),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [2310] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2591),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_EQ] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(6073),
    [anon_sym_long] = ACTIONS(6073),
    [anon_sym_short] = ACTIONS(6073),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [2311] = {
    [sym_type_qualifier] = STATE(2311),
    [sym_trailing_return_type] = STATE(2311),
    [aux_sym_function_declarator_repeat1] = STATE(2311),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_DASH_GT] = ACTIONS(6075),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6078),
  },
  [2312] = {
    [sym__abstract_declarator] = STATE(1311),
    [sym_abstract_pointer_declarator] = STATE(1311),
    [sym_abstract_function_declarator] = STATE(1311),
    [sym_abstract_array_declarator] = STATE(1311),
    [sym_parameter_list] = STATE(750),
    [sym_abstract_reference_declarator] = STATE(1311),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(5285),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5289),
    [sym_comment] = ACTIONS(49),
  },
  [2313] = {
    [sym__abstract_declarator] = STATE(1313),
    [sym_abstract_pointer_declarator] = STATE(1313),
    [sym_abstract_function_declarator] = STATE(1313),
    [sym_abstract_array_declarator] = STATE(1313),
    [sym_parameter_list] = STATE(750),
    [sym_abstract_reference_declarator] = STATE(1313),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(5285),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5289),
    [sym_comment] = ACTIONS(49),
  },
  [2314] = {
    [sym_parameter_list] = STATE(1316),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2315] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(6081),
    [anon_sym_long] = ACTIONS(6081),
    [anon_sym_short] = ACTIONS(6081),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [2316] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(6084),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(5334),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6084),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6086),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2317] = {
    [sym__expression] = STATE(2592),
    [sym_conditional_expression] = STATE(2592),
    [sym_assignment_expression] = STATE(2592),
    [sym_pointer_expression] = STATE(2592),
    [sym_logical_expression] = STATE(2592),
    [sym_bitwise_expression] = STATE(2592),
    [sym_equality_expression] = STATE(2592),
    [sym_relational_expression] = STATE(2592),
    [sym_shift_expression] = STATE(2592),
    [sym_math_expression] = STATE(2592),
    [sym_cast_expression] = STATE(2592),
    [sym_sizeof_expression] = STATE(2592),
    [sym_subscript_expression] = STATE(2592),
    [sym_call_expression] = STATE(2592),
    [sym_field_expression] = STATE(2592),
    [sym_compound_literal_expression] = STATE(2592),
    [sym_parenthesized_expression] = STATE(2592),
    [sym_concatenated_string] = STATE(2592),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2592),
    [sym_new_expression] = STATE(2592),
    [sym_delete_expression] = STATE(2592),
    [sym_lambda_expression] = STATE(2592),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6088),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(6088),
    [sym_char_literal] = ACTIONS(6088),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(6090),
    [sym_false] = ACTIONS(6090),
    [sym_null] = ACTIONS(6090),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(6090),
  },
  [2318] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(5360),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2319] = {
    [sym__expression] = STATE(2593),
    [sym_conditional_expression] = STATE(2593),
    [sym_assignment_expression] = STATE(2593),
    [sym_pointer_expression] = STATE(2593),
    [sym_logical_expression] = STATE(2593),
    [sym_bitwise_expression] = STATE(2593),
    [sym_equality_expression] = STATE(2593),
    [sym_relational_expression] = STATE(2593),
    [sym_shift_expression] = STATE(2593),
    [sym_math_expression] = STATE(2593),
    [sym_cast_expression] = STATE(2593),
    [sym_sizeof_expression] = STATE(2593),
    [sym_subscript_expression] = STATE(2593),
    [sym_call_expression] = STATE(2593),
    [sym_field_expression] = STATE(2593),
    [sym_compound_literal_expression] = STATE(2593),
    [sym_parenthesized_expression] = STATE(2593),
    [sym_concatenated_string] = STATE(2593),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2593),
    [sym_new_expression] = STATE(2593),
    [sym_delete_expression] = STATE(2593),
    [sym_lambda_expression] = STATE(2593),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6092),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(6092),
    [sym_char_literal] = ACTIONS(6092),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(6094),
    [sym_false] = ACTIONS(6094),
    [sym_null] = ACTIONS(6094),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(6094),
  },
  [2320] = {
    [sym_raw_string_literal] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_RBRACK] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [sym_char_literal] = ACTIONS(3633),
    [sym_string_literal] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [sym_null] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_delete] = ACTIONS(3635),
    [sym_nullptr] = ACTIONS(3635),
  },
  [2321] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(6096),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [2322] = {
    [sym_raw_string_literal] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_register] = ACTIONS(2364),
    [anon_sym_inline] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym__Atomic] = ACTIONS(2364),
    [anon_sym_mutable] = ACTIONS(2364),
    [anon_sym_explicit] = ACTIONS(2364),
    [anon_sym_constexpr] = ACTIONS(2364),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [sym_number_literal] = ACTIONS(2362),
    [sym_char_literal] = ACTIONS(2362),
    [sym_string_literal] = ACTIONS(2362),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2364),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2364),
    [sym_nullptr] = ACTIONS(2364),
  },
  [2323] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(6098),
    [sym_comment] = ACTIONS(49),
  },
  [2324] = {
    [sym_raw_string_literal] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_RBRACK] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_register] = ACTIONS(3776),
    [anon_sym_inline] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_restrict] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym__Atomic] = ACTIONS(3776),
    [anon_sym_mutable] = ACTIONS(3776),
    [anon_sym_explicit] = ACTIONS(3776),
    [anon_sym_constexpr] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_sizeof] = ACTIONS(3776),
    [sym_number_literal] = ACTIONS(3774),
    [sym_char_literal] = ACTIONS(3774),
    [sym_string_literal] = ACTIONS(3774),
    [sym_true] = ACTIONS(3776),
    [sym_false] = ACTIONS(3776),
    [sym_null] = ACTIONS(3776),
    [sym_identifier] = ACTIONS(3776),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3776),
    [anon_sym_COLON_COLON] = ACTIONS(3774),
    [anon_sym_delete] = ACTIONS(3776),
    [sym_nullptr] = ACTIONS(3776),
  },
  [2325] = {
    [sym_raw_string_literal] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_extern] = ACTIONS(3780),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_RBRACK] = ACTIONS(3778),
    [anon_sym_static] = ACTIONS(3780),
    [anon_sym_register] = ACTIONS(3780),
    [anon_sym_inline] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_restrict] = ACTIONS(3780),
    [anon_sym_volatile] = ACTIONS(3780),
    [anon_sym__Atomic] = ACTIONS(3780),
    [anon_sym_mutable] = ACTIONS(3780),
    [anon_sym_explicit] = ACTIONS(3780),
    [anon_sym_constexpr] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_DASH] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3778),
    [anon_sym_sizeof] = ACTIONS(3780),
    [sym_number_literal] = ACTIONS(3778),
    [sym_char_literal] = ACTIONS(3778),
    [sym_string_literal] = ACTIONS(3778),
    [sym_true] = ACTIONS(3780),
    [sym_false] = ACTIONS(3780),
    [sym_null] = ACTIONS(3780),
    [sym_identifier] = ACTIONS(3780),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3780),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_delete] = ACTIONS(3780),
    [sym_nullptr] = ACTIONS(3780),
  },
  [2326] = {
    [sym_raw_string_literal] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3882),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3880),
    [anon_sym_STAR_EQ] = ACTIONS(3880),
    [anon_sym_SLASH_EQ] = ACTIONS(3880),
    [anon_sym_PERCENT_EQ] = ACTIONS(3880),
    [anon_sym_PLUS_EQ] = ACTIONS(3880),
    [anon_sym_DASH_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_GT_EQ] = ACTIONS(3880),
    [anon_sym_AMP_EQ] = ACTIONS(3880),
    [anon_sym_CARET_EQ] = ACTIONS(3880),
    [anon_sym_PIPE_EQ] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3882),
    [anon_sym_PIPE] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_EQ_EQ] = ACTIONS(3880),
    [anon_sym_BANG_EQ] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3882),
    [anon_sym_GT] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(3882),
    [anon_sym_PLUS] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3882),
    [anon_sym_SLASH] = ACTIONS(3882),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3882),
    [anon_sym_DOT] = ACTIONS(3880),
    [anon_sym_DASH_GT] = ACTIONS(3880),
    [sym_number_literal] = ACTIONS(3880),
    [sym_char_literal] = ACTIONS(3880),
    [sym_string_literal] = ACTIONS(3880),
    [sym_true] = ACTIONS(3882),
    [sym_false] = ACTIONS(3882),
    [sym_null] = ACTIONS(3882),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3882),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_delete] = ACTIONS(3882),
    [sym_nullptr] = ACTIONS(3882),
  },
  [2327] = {
    [sym_raw_string_literal] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_RBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3891),
    [anon_sym_register] = ACTIONS(3891),
    [anon_sym_inline] = ACTIONS(3891),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_restrict] = ACTIONS(3891),
    [anon_sym_volatile] = ACTIONS(3891),
    [anon_sym__Atomic] = ACTIONS(3891),
    [anon_sym_mutable] = ACTIONS(3891),
    [anon_sym_explicit] = ACTIONS(3891),
    [anon_sym_constexpr] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_BANG] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3891),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_sizeof] = ACTIONS(3891),
    [sym_number_literal] = ACTIONS(3889),
    [sym_char_literal] = ACTIONS(3889),
    [sym_string_literal] = ACTIONS(3889),
    [sym_true] = ACTIONS(3891),
    [sym_false] = ACTIONS(3891),
    [sym_null] = ACTIONS(3891),
    [sym_identifier] = ACTIONS(3891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3891),
    [anon_sym_COLON_COLON] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3891),
    [sym_nullptr] = ACTIONS(3891),
  },
  [2328] = {
    [sym_new_declarator] = STATE(2596),
    [anon_sym_LPAREN] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(6100),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [sym_comment] = ACTIONS(49),
  },
  [2329] = {
    [anon_sym_LPAREN] = ACTIONS(6102),
    [anon_sym_COMMA] = ACTIONS(6102),
    [anon_sym_RPAREN] = ACTIONS(6102),
    [anon_sym_SEMI] = ACTIONS(6102),
    [anon_sym_RBRACE] = ACTIONS(6102),
    [anon_sym_STAR] = ACTIONS(6104),
    [anon_sym_LBRACK] = ACTIONS(6102),
    [anon_sym_RBRACK] = ACTIONS(6102),
    [anon_sym_EQ] = ACTIONS(6104),
    [anon_sym_COLON] = ACTIONS(6102),
    [anon_sym_QMARK] = ACTIONS(6102),
    [anon_sym_STAR_EQ] = ACTIONS(6102),
    [anon_sym_SLASH_EQ] = ACTIONS(6102),
    [anon_sym_PERCENT_EQ] = ACTIONS(6102),
    [anon_sym_PLUS_EQ] = ACTIONS(6102),
    [anon_sym_DASH_EQ] = ACTIONS(6102),
    [anon_sym_LT_LT_EQ] = ACTIONS(6102),
    [anon_sym_GT_GT_EQ] = ACTIONS(6102),
    [anon_sym_AMP_EQ] = ACTIONS(6102),
    [anon_sym_CARET_EQ] = ACTIONS(6102),
    [anon_sym_PIPE_EQ] = ACTIONS(6102),
    [anon_sym_AMP] = ACTIONS(6104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6102),
    [anon_sym_AMP_AMP] = ACTIONS(6102),
    [anon_sym_PIPE] = ACTIONS(6104),
    [anon_sym_CARET] = ACTIONS(6104),
    [anon_sym_EQ_EQ] = ACTIONS(6102),
    [anon_sym_BANG_EQ] = ACTIONS(6102),
    [anon_sym_LT] = ACTIONS(6104),
    [anon_sym_GT] = ACTIONS(6104),
    [anon_sym_LT_EQ] = ACTIONS(6102),
    [anon_sym_GT_EQ] = ACTIONS(6102),
    [anon_sym_LT_LT] = ACTIONS(6104),
    [anon_sym_GT_GT] = ACTIONS(6104),
    [anon_sym_PLUS] = ACTIONS(6104),
    [anon_sym_DASH] = ACTIONS(6104),
    [anon_sym_SLASH] = ACTIONS(6104),
    [anon_sym_PERCENT] = ACTIONS(6104),
    [anon_sym_DASH_DASH] = ACTIONS(6102),
    [anon_sym_PLUS_PLUS] = ACTIONS(6102),
    [anon_sym_DOT] = ACTIONS(6102),
    [anon_sym_DASH_GT] = ACTIONS(6102),
    [sym_comment] = ACTIONS(49),
  },
  [2330] = {
    [anon_sym_LPAREN] = ACTIONS(6106),
    [anon_sym_COMMA] = ACTIONS(6106),
    [anon_sym_RPAREN] = ACTIONS(6106),
    [anon_sym_SEMI] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(6106),
    [anon_sym_STAR] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(6106),
    [anon_sym_RBRACK] = ACTIONS(6106),
    [anon_sym_EQ] = ACTIONS(6108),
    [anon_sym_COLON] = ACTIONS(6106),
    [anon_sym_QMARK] = ACTIONS(6106),
    [anon_sym_STAR_EQ] = ACTIONS(6106),
    [anon_sym_SLASH_EQ] = ACTIONS(6106),
    [anon_sym_PERCENT_EQ] = ACTIONS(6106),
    [anon_sym_PLUS_EQ] = ACTIONS(6106),
    [anon_sym_DASH_EQ] = ACTIONS(6106),
    [anon_sym_LT_LT_EQ] = ACTIONS(6106),
    [anon_sym_GT_GT_EQ] = ACTIONS(6106),
    [anon_sym_AMP_EQ] = ACTIONS(6106),
    [anon_sym_CARET_EQ] = ACTIONS(6106),
    [anon_sym_PIPE_EQ] = ACTIONS(6106),
    [anon_sym_AMP] = ACTIONS(6108),
    [anon_sym_PIPE_PIPE] = ACTIONS(6106),
    [anon_sym_AMP_AMP] = ACTIONS(6106),
    [anon_sym_PIPE] = ACTIONS(6108),
    [anon_sym_CARET] = ACTIONS(6108),
    [anon_sym_EQ_EQ] = ACTIONS(6106),
    [anon_sym_BANG_EQ] = ACTIONS(6106),
    [anon_sym_LT] = ACTIONS(6108),
    [anon_sym_GT] = ACTIONS(6108),
    [anon_sym_LT_EQ] = ACTIONS(6106),
    [anon_sym_GT_EQ] = ACTIONS(6106),
    [anon_sym_LT_LT] = ACTIONS(6108),
    [anon_sym_GT_GT] = ACTIONS(6108),
    [anon_sym_PLUS] = ACTIONS(6108),
    [anon_sym_DASH] = ACTIONS(6108),
    [anon_sym_SLASH] = ACTIONS(6108),
    [anon_sym_PERCENT] = ACTIONS(6108),
    [anon_sym_DASH_DASH] = ACTIONS(6106),
    [anon_sym_PLUS_PLUS] = ACTIONS(6106),
    [anon_sym_DOT] = ACTIONS(6106),
    [anon_sym_DASH_GT] = ACTIONS(6106),
    [sym_comment] = ACTIONS(49),
  },
  [2331] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2332] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(6114),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2333] = {
    [sym_type_qualifier] = STATE(2337),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2337),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5380),
  },
  [2334] = {
    [sym__type_specifier] = STATE(97),
    [sym_sized_type_specifier] = STATE(97),
    [sym_enum_specifier] = STATE(97),
    [sym_struct_specifier] = STATE(97),
    [sym_union_specifier] = STATE(97),
    [sym_macro_type_specifier] = STATE(97),
    [sym_class_specifier] = STATE(97),
    [sym_dependent_type] = STATE(97),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(34),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2336),
    [anon_sym_unsigned] = ACTIONS(5374),
    [anon_sym_long] = ACTIONS(5374),
    [anon_sym_short] = ACTIONS(5374),
    [sym_primitive_type] = ACTIONS(156),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(452),
    [anon_sym_union] = ACTIONS(454),
    [sym_identifier] = ACTIONS(458),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(460),
    [sym_auto] = ACTIONS(156),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2335] = {
    [sym__abstract_declarator] = STATE(1408),
    [sym_abstract_pointer_declarator] = STATE(1408),
    [sym_abstract_function_declarator] = STATE(1408),
    [sym_abstract_array_declarator] = STATE(1408),
    [sym_parameter_list] = STATE(1409),
    [sym_abstract_reference_declarator] = STATE(1408),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1618),
    [anon_sym_AMP_AMP] = ACTIONS(1620),
    [sym_comment] = ACTIONS(49),
  },
  [2336] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2597),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_unsigned] = ACTIONS(6116),
    [anon_sym_long] = ACTIONS(6116),
    [anon_sym_short] = ACTIONS(6116),
    [sym_primitive_type] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(49),
  },
  [2337] = {
    [sym_type_qualifier] = STATE(2337),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2337),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6118),
  },
  [2338] = {
    [sym_enumerator_list] = STATE(240),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_LBRACE] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [sym_comment] = ACTIONS(49),
  },
  [2339] = {
    [sym_field_declaration_list] = STATE(277),
    [sym_base_class_clause] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2330),
  },
  [2340] = {
    [sym_field_declaration_list] = STATE(283),
    [sym_base_class_clause] = STATE(284),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2332),
  },
  [2341] = {
    [sym_field_declaration_list] = STATE(299),
    [sym_base_class_clause] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2334),
  },
  [2342] = {
    [sym__abstract_declarator] = STATE(2598),
    [sym_abstract_pointer_declarator] = STATE(2598),
    [sym_abstract_function_declarator] = STATE(2598),
    [sym_abstract_array_declarator] = STATE(2598),
    [sym_parameter_list] = STATE(851),
    [sym_abstract_reference_declarator] = STATE(2598),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [sym_comment] = ACTIONS(49),
  },
  [2343] = {
    [sym__abstract_declarator] = STATE(2599),
    [sym_abstract_pointer_declarator] = STATE(2599),
    [sym_abstract_function_declarator] = STATE(2599),
    [sym_abstract_array_declarator] = STATE(2599),
    [sym_parameter_list] = STATE(851),
    [sym_abstract_reference_declarator] = STATE(2599),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [sym_comment] = ACTIONS(49),
  },
  [2344] = {
    [sym_parameter_list] = STATE(1410),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2345] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2345),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(6121),
    [anon_sym_long] = ACTIONS(6121),
    [anon_sym_short] = ACTIONS(6121),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [2346] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3882),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3880),
    [anon_sym_STAR_EQ] = ACTIONS(3880),
    [anon_sym_SLASH_EQ] = ACTIONS(3880),
    [anon_sym_PERCENT_EQ] = ACTIONS(3880),
    [anon_sym_PLUS_EQ] = ACTIONS(3880),
    [anon_sym_DASH_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_GT_EQ] = ACTIONS(3880),
    [anon_sym_AMP_EQ] = ACTIONS(3880),
    [anon_sym_CARET_EQ] = ACTIONS(3880),
    [anon_sym_PIPE_EQ] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_PIPE] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_EQ_EQ] = ACTIONS(3880),
    [anon_sym_BANG_EQ] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3882),
    [anon_sym_GT] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(3882),
    [anon_sym_PLUS] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3882),
    [anon_sym_SLASH] = ACTIONS(3882),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DOT] = ACTIONS(3880),
    [anon_sym_DASH_GT] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [sym_operator_name] = ACTIONS(3880),
  },
  [2347] = {
    [sym_raw_string_literal] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_PLUS] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3882),
    [sym_number_literal] = ACTIONS(3880),
    [sym_char_literal] = ACTIONS(3880),
    [sym_string_literal] = ACTIONS(3880),
    [sym_true] = ACTIONS(3882),
    [sym_false] = ACTIONS(3882),
    [sym_null] = ACTIONS(3882),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(3882),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_delete] = ACTIONS(3882),
    [sym_nullptr] = ACTIONS(3882),
  },
  [2348] = {
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_COMMA] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2074),
    [anon_sym_volatile] = ACTIONS(2074),
    [anon_sym__Atomic] = ACTIONS(2074),
    [anon_sym_mutable] = ACTIONS(2074),
    [anon_sym_explicit] = ACTIONS(2074),
    [anon_sym_constexpr] = ACTIONS(2074),
    [anon_sym_COLON] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_DASH_GT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2074),
  },
  [2349] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(6124),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [2350] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(6126),
    [anon_sym_RBRACE] = ACTIONS(6124),
    [sym_comment] = ACTIONS(49),
  },
  [2351] = {
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RPAREN] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_EQ] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2178),
    [anon_sym_volatile] = ACTIONS(2178),
    [anon_sym__Atomic] = ACTIONS(2178),
    [anon_sym_mutable] = ACTIONS(2178),
    [anon_sym_explicit] = ACTIONS(2178),
    [anon_sym_constexpr] = ACTIONS(2178),
    [anon_sym_COLON] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [anon_sym_DASH_GT] = ACTIONS(2178),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2178),
  },
  [2352] = {
    [anon_sym_LPAREN] = ACTIONS(2268),
    [anon_sym_COMMA] = ACTIONS(2268),
    [anon_sym_RPAREN] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_DASH_GT] = ACTIONS(2268),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2268),
  },
  [2353] = {
    [sym_field_declaration_list] = STATE(2602),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [2354] = {
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2272),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_DASH_GT] = ACTIONS(2272),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2272),
  },
  [2355] = {
    [sym_field_declaration_list] = STATE(2603),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [2356] = {
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_GT] = ACTIONS(2362),
    [anon_sym_DASH_GT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2362),
    [sym_noexcept] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
  },
  [2357] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(6128),
    [sym_comment] = ACTIONS(49),
  },
  [2358] = {
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_restrict] = ACTIONS(2371),
    [anon_sym_volatile] = ACTIONS(2371),
    [anon_sym__Atomic] = ACTIONS(2371),
    [anon_sym_mutable] = ACTIONS(2371),
    [anon_sym_explicit] = ACTIONS(2371),
    [anon_sym_constexpr] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2371),
  },
  [2359] = {
    [sym_field_declaration_list] = STATE(2605),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(49),
  },
  [2360] = {
    [sym_type_qualifier] = STATE(2361),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2361),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(648),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5411),
  },
  [2361] = {
    [sym_type_qualifier] = STATE(2361),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2361),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6130),
  },
  [2362] = {
    [sym_raw_string_literal] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_LBRACE] = ACTIONS(3434),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_if] = ACTIONS(3436),
    [anon_sym_switch] = ACTIONS(3436),
    [anon_sym_case] = ACTIONS(3436),
    [anon_sym_default] = ACTIONS(3436),
    [anon_sym_while] = ACTIONS(3436),
    [anon_sym_do] = ACTIONS(3436),
    [anon_sym_for] = ACTIONS(3436),
    [anon_sym_return] = ACTIONS(3436),
    [anon_sym_break] = ACTIONS(3436),
    [anon_sym_continue] = ACTIONS(3436),
    [anon_sym_goto] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_sizeof] = ACTIONS(3436),
    [sym_number_literal] = ACTIONS(3434),
    [sym_char_literal] = ACTIONS(3434),
    [sym_string_literal] = ACTIONS(3434),
    [sym_true] = ACTIONS(3436),
    [sym_false] = ACTIONS(3436),
    [sym_null] = ACTIONS(3436),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_new] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3436),
    [sym_nullptr] = ACTIONS(3436),
  },
  [2363] = {
    [sym_raw_string_literal] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_LBRACE] = ACTIONS(3444),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_if] = ACTIONS(3446),
    [anon_sym_switch] = ACTIONS(3446),
    [anon_sym_case] = ACTIONS(3446),
    [anon_sym_default] = ACTIONS(3446),
    [anon_sym_while] = ACTIONS(3446),
    [anon_sym_do] = ACTIONS(3446),
    [anon_sym_for] = ACTIONS(3446),
    [anon_sym_return] = ACTIONS(3446),
    [anon_sym_break] = ACTIONS(3446),
    [anon_sym_continue] = ACTIONS(3446),
    [anon_sym_goto] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_sizeof] = ACTIONS(3446),
    [sym_number_literal] = ACTIONS(3444),
    [sym_char_literal] = ACTIONS(3444),
    [sym_string_literal] = ACTIONS(3444),
    [sym_true] = ACTIONS(3446),
    [sym_false] = ACTIONS(3446),
    [sym_null] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3446),
    [sym_nullptr] = ACTIONS(3446),
  },
  [2364] = {
    [sym_preproc_arg] = ACTIONS(6133),
    [sym_comment] = ACTIONS(83),
  },
  [2365] = {
    [sym_raw_string_literal] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_sizeof] = ACTIONS(859),
    [sym_number_literal] = ACTIONS(857),
    [sym_char_literal] = ACTIONS(857),
    [sym_string_literal] = ACTIONS(857),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [anon_sym_delete] = ACTIONS(859),
    [sym_nullptr] = ACTIONS(859),
  },
  [2366] = {
    [anon_sym_LF] = ACTIONS(6135),
    [sym_preproc_arg] = ACTIONS(6137),
    [sym_comment] = ACTIONS(83),
  },
  [2367] = {
    [sym_raw_string_literal] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4509),
    [sym_preproc_directive] = ACTIONS(4509),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_typedef] = ACTIONS(4509),
    [anon_sym_extern] = ACTIONS(4509),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(4507),
    [anon_sym_static] = ACTIONS(4509),
    [anon_sym_register] = ACTIONS(4509),
    [anon_sym_inline] = ACTIONS(4509),
    [anon_sym_const] = ACTIONS(4509),
    [anon_sym_restrict] = ACTIONS(4509),
    [anon_sym_volatile] = ACTIONS(4509),
    [anon_sym__Atomic] = ACTIONS(4509),
    [anon_sym_mutable] = ACTIONS(4509),
    [anon_sym_explicit] = ACTIONS(4509),
    [anon_sym_constexpr] = ACTIONS(4509),
    [anon_sym_unsigned] = ACTIONS(4509),
    [anon_sym_long] = ACTIONS(4509),
    [anon_sym_short] = ACTIONS(4509),
    [sym_primitive_type] = ACTIONS(4509),
    [anon_sym_enum] = ACTIONS(4509),
    [anon_sym_struct] = ACTIONS(4509),
    [anon_sym_union] = ACTIONS(4509),
    [anon_sym_if] = ACTIONS(4509),
    [anon_sym_switch] = ACTIONS(4509),
    [anon_sym_case] = ACTIONS(4509),
    [anon_sym_default] = ACTIONS(4509),
    [anon_sym_while] = ACTIONS(4509),
    [anon_sym_do] = ACTIONS(4509),
    [anon_sym_for] = ACTIONS(4509),
    [anon_sym_return] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4509),
    [anon_sym_continue] = ACTIONS(4509),
    [anon_sym_goto] = ACTIONS(4509),
    [anon_sym_AMP] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_PLUS] = ACTIONS(4509),
    [anon_sym_DASH] = ACTIONS(4509),
    [anon_sym_DASH_DASH] = ACTIONS(4507),
    [anon_sym_PLUS_PLUS] = ACTIONS(4507),
    [anon_sym_sizeof] = ACTIONS(4509),
    [sym_number_literal] = ACTIONS(4507),
    [sym_char_literal] = ACTIONS(4507),
    [sym_string_literal] = ACTIONS(4507),
    [sym_true] = ACTIONS(4509),
    [sym_false] = ACTIONS(4509),
    [sym_null] = ACTIONS(4509),
    [sym_identifier] = ACTIONS(4509),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4509),
    [sym_auto] = ACTIONS(4509),
    [anon_sym_typename] = ACTIONS(4509),
    [anon_sym_new] = ACTIONS(4509),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_delete] = ACTIONS(4509),
    [sym_nullptr] = ACTIONS(4509),
  },
  [2368] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6139),
    [sym_comment] = ACTIONS(49),
  },
  [2369] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6141),
    [sym_comment] = ACTIONS(49),
  },
  [2370] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2612),
    [sym_preproc_elif_in_compound_statement] = STATE(2613),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2371] = {
    [sym_raw_string_literal] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4617),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4617),
    [sym_preproc_directive] = ACTIONS(4617),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_typedef] = ACTIONS(4617),
    [anon_sym_extern] = ACTIONS(4617),
    [anon_sym_LBRACE] = ACTIONS(4615),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_static] = ACTIONS(4617),
    [anon_sym_register] = ACTIONS(4617),
    [anon_sym_inline] = ACTIONS(4617),
    [anon_sym_const] = ACTIONS(4617),
    [anon_sym_restrict] = ACTIONS(4617),
    [anon_sym_volatile] = ACTIONS(4617),
    [anon_sym__Atomic] = ACTIONS(4617),
    [anon_sym_mutable] = ACTIONS(4617),
    [anon_sym_explicit] = ACTIONS(4617),
    [anon_sym_constexpr] = ACTIONS(4617),
    [anon_sym_unsigned] = ACTIONS(4617),
    [anon_sym_long] = ACTIONS(4617),
    [anon_sym_short] = ACTIONS(4617),
    [sym_primitive_type] = ACTIONS(4617),
    [anon_sym_enum] = ACTIONS(4617),
    [anon_sym_struct] = ACTIONS(4617),
    [anon_sym_union] = ACTIONS(4617),
    [anon_sym_if] = ACTIONS(4617),
    [anon_sym_switch] = ACTIONS(4617),
    [anon_sym_case] = ACTIONS(4617),
    [anon_sym_default] = ACTIONS(4617),
    [anon_sym_while] = ACTIONS(4617),
    [anon_sym_do] = ACTIONS(4617),
    [anon_sym_for] = ACTIONS(4617),
    [anon_sym_return] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4617),
    [anon_sym_continue] = ACTIONS(4617),
    [anon_sym_goto] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_BANG] = ACTIONS(4615),
    [anon_sym_TILDE] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_sizeof] = ACTIONS(4617),
    [sym_number_literal] = ACTIONS(4615),
    [sym_char_literal] = ACTIONS(4615),
    [sym_string_literal] = ACTIONS(4615),
    [sym_true] = ACTIONS(4617),
    [sym_false] = ACTIONS(4617),
    [sym_null] = ACTIONS(4617),
    [sym_identifier] = ACTIONS(4617),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4617),
    [sym_auto] = ACTIONS(4617),
    [anon_sym_typename] = ACTIONS(4617),
    [anon_sym_new] = ACTIONS(4617),
    [anon_sym_COLON_COLON] = ACTIONS(4615),
    [anon_sym_delete] = ACTIONS(4617),
    [sym_nullptr] = ACTIONS(4617),
  },
  [2372] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6145),
    [sym_comment] = ACTIONS(49),
  },
  [2373] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6147),
    [sym_comment] = ACTIONS(49),
  },
  [2374] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2617),
    [sym_preproc_elif_in_compound_statement] = STATE(2618),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2375] = {
    [sym_raw_string_literal] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4627),
    [sym_preproc_directive] = ACTIONS(4627),
    [anon_sym_SEMI] = ACTIONS(4625),
    [anon_sym_typedef] = ACTIONS(4627),
    [anon_sym_extern] = ACTIONS(4627),
    [anon_sym_LBRACE] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4625),
    [anon_sym_static] = ACTIONS(4627),
    [anon_sym_register] = ACTIONS(4627),
    [anon_sym_inline] = ACTIONS(4627),
    [anon_sym_const] = ACTIONS(4627),
    [anon_sym_restrict] = ACTIONS(4627),
    [anon_sym_volatile] = ACTIONS(4627),
    [anon_sym__Atomic] = ACTIONS(4627),
    [anon_sym_mutable] = ACTIONS(4627),
    [anon_sym_explicit] = ACTIONS(4627),
    [anon_sym_constexpr] = ACTIONS(4627),
    [anon_sym_unsigned] = ACTIONS(4627),
    [anon_sym_long] = ACTIONS(4627),
    [anon_sym_short] = ACTIONS(4627),
    [sym_primitive_type] = ACTIONS(4627),
    [anon_sym_enum] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_union] = ACTIONS(4627),
    [anon_sym_if] = ACTIONS(4627),
    [anon_sym_switch] = ACTIONS(4627),
    [anon_sym_case] = ACTIONS(4627),
    [anon_sym_default] = ACTIONS(4627),
    [anon_sym_while] = ACTIONS(4627),
    [anon_sym_do] = ACTIONS(4627),
    [anon_sym_for] = ACTIONS(4627),
    [anon_sym_return] = ACTIONS(4627),
    [anon_sym_break] = ACTIONS(4627),
    [anon_sym_continue] = ACTIONS(4627),
    [anon_sym_goto] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4625),
    [anon_sym_sizeof] = ACTIONS(4627),
    [sym_number_literal] = ACTIONS(4625),
    [sym_char_literal] = ACTIONS(4625),
    [sym_string_literal] = ACTIONS(4625),
    [sym_true] = ACTIONS(4627),
    [sym_false] = ACTIONS(4627),
    [sym_null] = ACTIONS(4627),
    [sym_identifier] = ACTIONS(4627),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4627),
    [sym_auto] = ACTIONS(4627),
    [anon_sym_typename] = ACTIONS(4627),
    [anon_sym_new] = ACTIONS(4627),
    [anon_sym_COLON_COLON] = ACTIONS(4625),
    [anon_sym_delete] = ACTIONS(4627),
    [sym_nullptr] = ACTIONS(4627),
  },
  [2376] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6151),
    [sym_comment] = ACTIONS(49),
  },
  [2377] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6153),
    [sym_comment] = ACTIONS(49),
  },
  [2378] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2622),
    [sym_preproc_elif_in_compound_statement] = STATE(2623),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2379] = {
    [sym_raw_string_literal] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(259),
    [sym_preproc_directive] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_typedef] = ACTIONS(259),
    [anon_sym_extern] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_register] = ACTIONS(259),
    [anon_sym_inline] = ACTIONS(259),
    [anon_sym_const] = ACTIONS(259),
    [anon_sym_restrict] = ACTIONS(259),
    [anon_sym_volatile] = ACTIONS(259),
    [anon_sym__Atomic] = ACTIONS(259),
    [anon_sym_mutable] = ACTIONS(259),
    [anon_sym_explicit] = ACTIONS(259),
    [anon_sym_constexpr] = ACTIONS(259),
    [anon_sym_unsigned] = ACTIONS(259),
    [anon_sym_long] = ACTIONS(259),
    [anon_sym_short] = ACTIONS(259),
    [sym_primitive_type] = ACTIONS(259),
    [anon_sym_enum] = ACTIONS(259),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(259),
    [anon_sym_if] = ACTIONS(259),
    [anon_sym_switch] = ACTIONS(259),
    [anon_sym_case] = ACTIONS(259),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_while] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_for] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(259),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_continue] = ACTIONS(259),
    [anon_sym_goto] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(257),
    [anon_sym_PLUS_PLUS] = ACTIONS(257),
    [anon_sym_sizeof] = ACTIONS(259),
    [sym_number_literal] = ACTIONS(257),
    [sym_char_literal] = ACTIONS(257),
    [sym_string_literal] = ACTIONS(257),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(259),
    [sym_auto] = ACTIONS(259),
    [anon_sym_typename] = ACTIONS(259),
    [anon_sym_new] = ACTIONS(259),
    [anon_sym_COLON_COLON] = ACTIONS(257),
    [anon_sym_delete] = ACTIONS(259),
    [sym_nullptr] = ACTIONS(259),
  },
  [2380] = {
    [sym_preproc_params] = STATE(2626),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(6157),
    [anon_sym_LF] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(265),
    [sym_comment] = ACTIONS(83),
  },
  [2381] = {
    [sym_preproc_include] = STATE(2630),
    [sym_preproc_def] = STATE(2630),
    [sym_preproc_function_def] = STATE(2630),
    [sym_preproc_call] = STATE(2630),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2628),
    [sym_preproc_elif_in_compound_statement] = STATE(2629),
    [sym_declaration] = STATE(2630),
    [sym_type_definition] = STATE(2630),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2630),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2630),
    [sym_expression_statement] = STATE(2630),
    [sym_if_statement] = STATE(2630),
    [sym_switch_statement] = STATE(2630),
    [sym_case_statement] = STATE(2630),
    [sym_while_statement] = STATE(2630),
    [sym_do_statement] = STATE(2630),
    [sym_for_statement] = STATE(2630),
    [sym_return_statement] = STATE(2630),
    [sym_break_statement] = STATE(2630),
    [sym_continue_statement] = STATE(2630),
    [sym_goto_statement] = STATE(2630),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2630),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2630),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2630),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2630),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2382] = {
    [sym_preproc_include] = STATE(2634),
    [sym_preproc_def] = STATE(2634),
    [sym_preproc_function_def] = STATE(2634),
    [sym_preproc_call] = STATE(2634),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2632),
    [sym_preproc_elif_in_compound_statement] = STATE(2633),
    [sym_declaration] = STATE(2634),
    [sym_type_definition] = STATE(2634),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2634),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2634),
    [sym_expression_statement] = STATE(2634),
    [sym_if_statement] = STATE(2634),
    [sym_switch_statement] = STATE(2634),
    [sym_case_statement] = STATE(2634),
    [sym_while_statement] = STATE(2634),
    [sym_do_statement] = STATE(2634),
    [sym_for_statement] = STATE(2634),
    [sym_return_statement] = STATE(2634),
    [sym_break_statement] = STATE(2634),
    [sym_continue_statement] = STATE(2634),
    [sym_goto_statement] = STATE(2634),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2634),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2634),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2634),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2383] = {
    [sym_preproc_include] = STATE(2638),
    [sym_preproc_def] = STATE(2638),
    [sym_preproc_function_def] = STATE(2638),
    [sym_preproc_call] = STATE(2638),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2636),
    [sym_preproc_elif_in_compound_statement] = STATE(2637),
    [sym_declaration] = STATE(2638),
    [sym_type_definition] = STATE(2638),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2638),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2638),
    [sym_expression_statement] = STATE(2638),
    [sym_if_statement] = STATE(2638),
    [sym_switch_statement] = STATE(2638),
    [sym_case_statement] = STATE(2638),
    [sym_while_statement] = STATE(2638),
    [sym_do_statement] = STATE(2638),
    [sym_for_statement] = STATE(2638),
    [sym_return_statement] = STATE(2638),
    [sym_break_statement] = STATE(2638),
    [sym_continue_statement] = STATE(2638),
    [sym_goto_statement] = STATE(2638),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2638),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2638),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2638),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2638),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2384] = {
    [sym_preproc_arg] = ACTIONS(6167),
    [sym_comment] = ACTIONS(83),
  },
  [2385] = {
    [sym_raw_string_literal] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(317),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(317),
    [sym_preproc_directive] = ACTIONS(317),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_typedef] = ACTIONS(317),
    [anon_sym_extern] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(315),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_register] = ACTIONS(317),
    [anon_sym_inline] = ACTIONS(317),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_mutable] = ACTIONS(317),
    [anon_sym_explicit] = ACTIONS(317),
    [anon_sym_constexpr] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_struct] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_switch] = ACTIONS(317),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_while] = ACTIONS(317),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(317),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(317),
    [anon_sym_goto] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_DASH_DASH] = ACTIONS(315),
    [anon_sym_PLUS_PLUS] = ACTIONS(315),
    [anon_sym_sizeof] = ACTIONS(317),
    [sym_number_literal] = ACTIONS(315),
    [sym_char_literal] = ACTIONS(315),
    [sym_string_literal] = ACTIONS(315),
    [sym_true] = ACTIONS(317),
    [sym_false] = ACTIONS(317),
    [sym_null] = ACTIONS(317),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(317),
    [sym_auto] = ACTIONS(317),
    [anon_sym_typename] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [anon_sym_delete] = ACTIONS(317),
    [sym_nullptr] = ACTIONS(317),
  },
  [2386] = {
    [sym__type_declarator] = STATE(2640),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2387] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(2641),
    [sym_sized_type_specifier] = STATE(2641),
    [sym_enum_specifier] = STATE(2641),
    [sym_struct_specifier] = STATE(2641),
    [sym_union_specifier] = STATE(2641),
    [sym_macro_type_specifier] = STATE(2641),
    [sym_class_specifier] = STATE(2641),
    [sym_dependent_type] = STATE(2641),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6169),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6169),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2388] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [2389] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(6171),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2390] = {
    [sym__expression] = STATE(2643),
    [sym_conditional_expression] = STATE(2643),
    [sym_assignment_expression] = STATE(2643),
    [sym_pointer_expression] = STATE(2643),
    [sym_logical_expression] = STATE(2643),
    [sym_bitwise_expression] = STATE(2643),
    [sym_equality_expression] = STATE(2643),
    [sym_relational_expression] = STATE(2643),
    [sym_shift_expression] = STATE(2643),
    [sym_math_expression] = STATE(2643),
    [sym_cast_expression] = STATE(2643),
    [sym_sizeof_expression] = STATE(2643),
    [sym_subscript_expression] = STATE(2643),
    [sym_call_expression] = STATE(2643),
    [sym_field_expression] = STATE(2643),
    [sym_compound_literal_expression] = STATE(2643),
    [sym_parenthesized_expression] = STATE(2643),
    [sym_concatenated_string] = STATE(2643),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2643),
    [sym_new_expression] = STATE(2643),
    [sym_delete_expression] = STATE(2643),
    [sym_lambda_expression] = STATE(2643),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6173),
    [sym_char_literal] = ACTIONS(6173),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6175),
    [sym_false] = ACTIONS(6175),
    [sym_null] = ACTIONS(6175),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6175),
  },
  [2391] = {
    [anon_sym_LPAREN] = ACTIONS(6177),
    [sym_comment] = ACTIONS(49),
  },
  [2392] = {
    [sym__expression] = STATE(2645),
    [sym_conditional_expression] = STATE(2645),
    [sym_assignment_expression] = STATE(2645),
    [sym_pointer_expression] = STATE(2645),
    [sym_logical_expression] = STATE(2645),
    [sym_bitwise_expression] = STATE(2645),
    [sym_equality_expression] = STATE(2645),
    [sym_relational_expression] = STATE(2645),
    [sym_shift_expression] = STATE(2645),
    [sym_math_expression] = STATE(2645),
    [sym_cast_expression] = STATE(2645),
    [sym_sizeof_expression] = STATE(2645),
    [sym_subscript_expression] = STATE(2645),
    [sym_call_expression] = STATE(2645),
    [sym_field_expression] = STATE(2645),
    [sym_compound_literal_expression] = STATE(2645),
    [sym_parenthesized_expression] = STATE(2645),
    [sym_concatenated_string] = STATE(2645),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2645),
    [sym_new_expression] = STATE(2645),
    [sym_delete_expression] = STATE(2645),
    [sym_lambda_expression] = STATE(2645),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6179),
    [sym_char_literal] = ACTIONS(6179),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6181),
    [sym_false] = ACTIONS(6181),
    [sym_null] = ACTIONS(6181),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6181),
  },
  [2393] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(6183),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2394] = {
    [sym_declaration] = STATE(2648),
    [sym_type_definition] = STATE(2648),
    [sym__declaration_specifiers] = STATE(2649),
    [sym_compound_statement] = STATE(2648),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2648),
    [sym_expression_statement] = STATE(2648),
    [sym_if_statement] = STATE(2648),
    [sym_switch_statement] = STATE(2648),
    [sym_case_statement] = STATE(2648),
    [sym_while_statement] = STATE(2648),
    [sym_do_statement] = STATE(2648),
    [sym_for_statement] = STATE(2648),
    [sym_return_statement] = STATE(2648),
    [sym_break_statement] = STATE(2648),
    [sym_continue_statement] = STATE(2648),
    [sym_goto_statement] = STATE(2648),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2648),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_typedef] = ACTIONS(4533),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2395] = {
    [sym__expression] = STATE(2650),
    [sym_conditional_expression] = STATE(2650),
    [sym_assignment_expression] = STATE(2650),
    [sym_pointer_expression] = STATE(2650),
    [sym_logical_expression] = STATE(2650),
    [sym_bitwise_expression] = STATE(2650),
    [sym_equality_expression] = STATE(2650),
    [sym_relational_expression] = STATE(2650),
    [sym_shift_expression] = STATE(2650),
    [sym_math_expression] = STATE(2650),
    [sym_cast_expression] = STATE(2650),
    [sym_sizeof_expression] = STATE(2650),
    [sym_subscript_expression] = STATE(2650),
    [sym_call_expression] = STATE(2650),
    [sym_field_expression] = STATE(2650),
    [sym_compound_literal_expression] = STATE(2650),
    [sym_parenthesized_expression] = STATE(2650),
    [sym_concatenated_string] = STATE(2650),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2650),
    [sym_new_expression] = STATE(2650),
    [sym_delete_expression] = STATE(2650),
    [sym_lambda_expression] = STATE(2650),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6187),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6187),
    [sym_char_literal] = ACTIONS(6187),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6189),
    [sym_false] = ACTIONS(6189),
    [sym_null] = ACTIONS(6189),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6189),
  },
  [2396] = {
    [anon_sym_while] = ACTIONS(6191),
    [sym_comment] = ACTIONS(49),
  },
  [2397] = {
    [sym_declaration] = STATE(2652),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(2653),
    [sym_conditional_expression] = STATE(2653),
    [sym_assignment_expression] = STATE(2653),
    [sym_pointer_expression] = STATE(2653),
    [sym_logical_expression] = STATE(2653),
    [sym_bitwise_expression] = STATE(2653),
    [sym_equality_expression] = STATE(2653),
    [sym_relational_expression] = STATE(2653),
    [sym_shift_expression] = STATE(2653),
    [sym_math_expression] = STATE(2653),
    [sym_cast_expression] = STATE(2653),
    [sym_sizeof_expression] = STATE(2653),
    [sym_subscript_expression] = STATE(2653),
    [sym_call_expression] = STATE(2653),
    [sym_field_expression] = STATE(2653),
    [sym_compound_literal_expression] = STATE(2653),
    [sym_parenthesized_expression] = STATE(2653),
    [sym_concatenated_string] = STATE(2653),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2653),
    [sym_for_range_declaration] = STATE(2654),
    [sym_new_expression] = STATE(2653),
    [sym_delete_expression] = STATE(2653),
    [sym_lambda_expression] = STATE(2653),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6193),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6195),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6193),
    [sym_char_literal] = ACTIONS(6193),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6197),
    [sym_false] = ACTIONS(6197),
    [sym_null] = ACTIONS(6197),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6197),
  },
  [2398] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [2399] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6199),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2400] = {
    [anon_sym_SEMI] = ACTIONS(6199),
    [sym_comment] = ACTIONS(49),
  },
  [2401] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [2402] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [2403] = {
    [anon_sym_SEMI] = ACTIONS(6201),
    [sym_comment] = ACTIONS(49),
  },
  [2404] = {
    [sym_compound_statement] = STATE(2658),
    [sym_labeled_statement] = STATE(2658),
    [sym_expression_statement] = STATE(2658),
    [sym_if_statement] = STATE(2658),
    [sym_switch_statement] = STATE(2658),
    [sym_case_statement] = STATE(2658),
    [sym_while_statement] = STATE(2658),
    [sym_do_statement] = STATE(2658),
    [sym_for_statement] = STATE(2658),
    [sym_return_statement] = STATE(2658),
    [sym_break_statement] = STATE(2658),
    [sym_continue_statement] = STATE(2658),
    [sym_goto_statement] = STATE(2658),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2658),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2405] = {
    [sym_raw_string_literal] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(556),
    [sym_preproc_directive] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_register] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_restrict] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym__Atomic] = ACTIONS(556),
    [anon_sym_mutable] = ACTIONS(556),
    [anon_sym_explicit] = ACTIONS(556),
    [anon_sym_constexpr] = ACTIONS(556),
    [anon_sym_unsigned] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [sym_primitive_type] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(556),
    [anon_sym_union] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_goto] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_sizeof] = ACTIONS(556),
    [sym_number_literal] = ACTIONS(554),
    [sym_char_literal] = ACTIONS(554),
    [sym_string_literal] = ACTIONS(554),
    [sym_true] = ACTIONS(556),
    [sym_false] = ACTIONS(556),
    [sym_null] = ACTIONS(556),
    [sym_identifier] = ACTIONS(556),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(556),
    [sym_auto] = ACTIONS(556),
    [anon_sym_typename] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_delete] = ACTIONS(556),
    [sym_nullptr] = ACTIONS(556),
  },
  [2406] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(2660),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6205),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [2407] = {
    [aux_sym_declaration_repeat1] = STATE(2660),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6205),
    [sym_comment] = ACTIONS(49),
  },
  [2408] = {
    [sym_argument_list] = STATE(2662),
    [sym_initializer_list] = STATE(2662),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(6207),
    [sym_comment] = ACTIONS(49),
  },
  [2409] = {
    [sym_argument_list] = STATE(2664),
    [sym_initializer_list] = STATE(2664),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(6209),
    [sym_comment] = ACTIONS(49),
  },
  [2410] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [2411] = {
    [sym_preproc_include] = STATE(2411),
    [sym_preproc_def] = STATE(2411),
    [sym_preproc_function_def] = STATE(2411),
    [sym_preproc_call] = STATE(2411),
    [sym_preproc_if_in_compound_statement] = STATE(2026),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2027),
    [sym_declaration] = STATE(2411),
    [sym_type_definition] = STATE(2411),
    [sym__declaration_specifiers] = STATE(2028),
    [sym_compound_statement] = STATE(2411),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2411),
    [sym_expression_statement] = STATE(2411),
    [sym_if_statement] = STATE(2411),
    [sym_switch_statement] = STATE(2411),
    [sym_case_statement] = STATE(2411),
    [sym_while_statement] = STATE(2411),
    [sym_do_statement] = STATE(2411),
    [sym_for_statement] = STATE(2411),
    [sym_return_statement] = STATE(2411),
    [sym_break_statement] = STATE(2411),
    [sym_continue_statement] = STATE(2411),
    [sym_goto_statement] = STATE(2411),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym__empty_declaration] = STATE(2411),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2411),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2411),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2411),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(6211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6214),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6217),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5557),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6223),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6226),
    [sym_preproc_directive] = ACTIONS(6229),
    [anon_sym_SEMI] = ACTIONS(6232),
    [anon_sym_typedef] = ACTIONS(6235),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(6238),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_restrict] = ACTIONS(3322),
    [anon_sym_volatile] = ACTIONS(3322),
    [anon_sym__Atomic] = ACTIONS(3322),
    [anon_sym_mutable] = ACTIONS(3322),
    [anon_sym_explicit] = ACTIONS(3322),
    [anon_sym_constexpr] = ACTIONS(3322),
    [anon_sym_unsigned] = ACTIONS(3325),
    [anon_sym_long] = ACTIONS(3325),
    [anon_sym_short] = ACTIONS(3325),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3334),
    [anon_sym_union] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(6241),
    [anon_sym_switch] = ACTIONS(6244),
    [anon_sym_case] = ACTIONS(6247),
    [anon_sym_default] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6253),
    [anon_sym_do] = ACTIONS(6256),
    [anon_sym_for] = ACTIONS(6259),
    [anon_sym_return] = ACTIONS(6262),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_continue] = ACTIONS(6268),
    [anon_sym_goto] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3376),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_sizeof] = ACTIONS(3385),
    [sym_number_literal] = ACTIONS(6211),
    [sym_char_literal] = ACTIONS(6211),
    [sym_string_literal] = ACTIONS(3388),
    [sym_true] = ACTIONS(6274),
    [sym_false] = ACTIONS(6274),
    [sym_null] = ACTIONS(6274),
    [sym_identifier] = ACTIONS(6277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3397),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_delete] = ACTIONS(3409),
    [sym_nullptr] = ACTIONS(6274),
  },
  [2412] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6280),
    [sym_comment] = ACTIONS(49),
  },
  [2413] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6282),
    [sym_comment] = ACTIONS(49),
  },
  [2414] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2665),
    [sym_preproc_elif_in_compound_statement] = STATE(2666),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6284),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2415] = {
    [anon_sym_LF] = ACTIONS(6286),
    [sym_comment] = ACTIONS(83),
  },
  [2416] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2417] = {
    [sym__type_declarator] = STATE(2669),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2418] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [2419] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6290),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2420] = {
    [sym__expression] = STATE(2671),
    [sym_conditional_expression] = STATE(2671),
    [sym_assignment_expression] = STATE(2671),
    [sym_pointer_expression] = STATE(2671),
    [sym_logical_expression] = STATE(2671),
    [sym_bitwise_expression] = STATE(2671),
    [sym_equality_expression] = STATE(2671),
    [sym_relational_expression] = STATE(2671),
    [sym_shift_expression] = STATE(2671),
    [sym_math_expression] = STATE(2671),
    [sym_cast_expression] = STATE(2671),
    [sym_sizeof_expression] = STATE(2671),
    [sym_subscript_expression] = STATE(2671),
    [sym_call_expression] = STATE(2671),
    [sym_field_expression] = STATE(2671),
    [sym_compound_literal_expression] = STATE(2671),
    [sym_parenthesized_expression] = STATE(2671),
    [sym_concatenated_string] = STATE(2671),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2671),
    [sym_new_expression] = STATE(2671),
    [sym_delete_expression] = STATE(2671),
    [sym_lambda_expression] = STATE(2671),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6292),
    [sym_char_literal] = ACTIONS(6292),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6294),
    [sym_false] = ACTIONS(6294),
    [sym_null] = ACTIONS(6294),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6294),
  },
  [2421] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2422] = {
    [sym_declaration] = STATE(2673),
    [sym_type_definition] = STATE(2673),
    [sym__declaration_specifiers] = STATE(2425),
    [sym_compound_statement] = STATE(2673),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2673),
    [sym_expression_statement] = STATE(2673),
    [sym_if_statement] = STATE(2673),
    [sym_switch_statement] = STATE(2673),
    [sym_case_statement] = STATE(2673),
    [sym_while_statement] = STATE(2673),
    [sym_do_statement] = STATE(2673),
    [sym_for_statement] = STATE(2673),
    [sym_return_statement] = STATE(2673),
    [sym_break_statement] = STATE(2673),
    [sym_continue_statement] = STATE(2673),
    [sym_goto_statement] = STATE(2673),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2673),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5503),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2423] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(4601),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [2424] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [2425] = {
    [sym__declarator] = STATE(2057),
    [sym_pointer_declarator] = STATE(2057),
    [sym_function_declarator] = STATE(2057),
    [sym_array_declarator] = STATE(2057),
    [sym_init_declarator] = STATE(2058),
    [sym_reference_declarator] = STATE(2057),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2057),
    [sym_destructor_name] = STATE(2057),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(4609),
  },
  [2426] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6298),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2427] = {
    [anon_sym_LPAREN] = ACTIONS(6300),
    [sym_comment] = ACTIONS(49),
  },
  [2428] = {
    [sym__expression] = STATE(2677),
    [sym_conditional_expression] = STATE(2677),
    [sym_assignment_expression] = STATE(2677),
    [sym_pointer_expression] = STATE(2677),
    [sym_logical_expression] = STATE(2677),
    [sym_bitwise_expression] = STATE(2677),
    [sym_equality_expression] = STATE(2677),
    [sym_relational_expression] = STATE(2677),
    [sym_shift_expression] = STATE(2677),
    [sym_math_expression] = STATE(2677),
    [sym_cast_expression] = STATE(2677),
    [sym_sizeof_expression] = STATE(2677),
    [sym_subscript_expression] = STATE(2677),
    [sym_call_expression] = STATE(2677),
    [sym_field_expression] = STATE(2677),
    [sym_compound_literal_expression] = STATE(2677),
    [sym_parenthesized_expression] = STATE(2677),
    [sym_concatenated_string] = STATE(2677),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2677),
    [sym_new_expression] = STATE(2677),
    [sym_delete_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(2677),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6302),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6302),
    [sym_char_literal] = ACTIONS(6302),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6306),
    [sym_false] = ACTIONS(6306),
    [sym_null] = ACTIONS(6306),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6306),
  },
  [2429] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2430] = {
    [anon_sym_COLON] = ACTIONS(6310),
    [sym_comment] = ACTIONS(49),
  },
  [2431] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [2432] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [2433] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(4601),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2434] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [2435] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [2436] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6312),
    [sym_comment] = ACTIONS(49),
  },
  [2437] = {
    [sym__expression] = STATE(2681),
    [sym_conditional_expression] = STATE(2681),
    [sym_assignment_expression] = STATE(2681),
    [sym_pointer_expression] = STATE(2681),
    [sym_logical_expression] = STATE(2681),
    [sym_bitwise_expression] = STATE(2681),
    [sym_equality_expression] = STATE(2681),
    [sym_relational_expression] = STATE(2681),
    [sym_shift_expression] = STATE(2681),
    [sym_math_expression] = STATE(2681),
    [sym_cast_expression] = STATE(2681),
    [sym_sizeof_expression] = STATE(2681),
    [sym_subscript_expression] = STATE(2681),
    [sym_call_expression] = STATE(2681),
    [sym_field_expression] = STATE(2681),
    [sym_compound_literal_expression] = STATE(2681),
    [sym_parenthesized_expression] = STATE(2681),
    [sym_initializer_list] = STATE(2682),
    [sym_concatenated_string] = STATE(2681),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2681),
    [sym_new_expression] = STATE(2681),
    [sym_delete_expression] = STATE(2681),
    [sym_lambda_expression] = STATE(2681),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6314),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6314),
    [sym_char_literal] = ACTIONS(6314),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6316),
    [sym_false] = ACTIONS(6316),
    [sym_null] = ACTIONS(6316),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6316),
  },
  [2438] = {
    [anon_sym_SEMI] = ACTIONS(6318),
    [sym_comment] = ACTIONS(49),
  },
  [2439] = {
    [sym__expression] = STATE(2684),
    [sym_conditional_expression] = STATE(2684),
    [sym_assignment_expression] = STATE(2684),
    [sym_pointer_expression] = STATE(2684),
    [sym_logical_expression] = STATE(2684),
    [sym_bitwise_expression] = STATE(2684),
    [sym_equality_expression] = STATE(2684),
    [sym_relational_expression] = STATE(2684),
    [sym_shift_expression] = STATE(2684),
    [sym_math_expression] = STATE(2684),
    [sym_cast_expression] = STATE(2684),
    [sym_sizeof_expression] = STATE(2684),
    [sym_subscript_expression] = STATE(2684),
    [sym_call_expression] = STATE(2684),
    [sym_field_expression] = STATE(2684),
    [sym_compound_literal_expression] = STATE(2684),
    [sym_parenthesized_expression] = STATE(2684),
    [sym_initializer_list] = STATE(2685),
    [sym_concatenated_string] = STATE(2684),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2684),
    [sym_new_expression] = STATE(2684),
    [sym_delete_expression] = STATE(2684),
    [sym_lambda_expression] = STATE(2684),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6320),
    [sym_char_literal] = ACTIONS(6320),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6322),
    [sym_false] = ACTIONS(6322),
    [sym_null] = ACTIONS(6322),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6322),
  },
  [2440] = {
    [anon_sym_SEMI] = ACTIONS(6324),
    [sym_comment] = ACTIONS(49),
  },
  [2441] = {
    [sym_raw_string_literal] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6328),
    [sym_preproc_directive] = ACTIONS(6328),
    [anon_sym_SEMI] = ACTIONS(6326),
    [anon_sym_typedef] = ACTIONS(6328),
    [anon_sym_extern] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6326),
    [anon_sym_RBRACE] = ACTIONS(6326),
    [anon_sym_STAR] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6326),
    [anon_sym_static] = ACTIONS(6328),
    [anon_sym_register] = ACTIONS(6328),
    [anon_sym_inline] = ACTIONS(6328),
    [anon_sym_const] = ACTIONS(6328),
    [anon_sym_restrict] = ACTIONS(6328),
    [anon_sym_volatile] = ACTIONS(6328),
    [anon_sym__Atomic] = ACTIONS(6328),
    [anon_sym_mutable] = ACTIONS(6328),
    [anon_sym_explicit] = ACTIONS(6328),
    [anon_sym_constexpr] = ACTIONS(6328),
    [anon_sym_unsigned] = ACTIONS(6328),
    [anon_sym_long] = ACTIONS(6328),
    [anon_sym_short] = ACTIONS(6328),
    [sym_primitive_type] = ACTIONS(6328),
    [anon_sym_enum] = ACTIONS(6328),
    [anon_sym_struct] = ACTIONS(6328),
    [anon_sym_union] = ACTIONS(6328),
    [anon_sym_if] = ACTIONS(6328),
    [anon_sym_switch] = ACTIONS(6328),
    [anon_sym_case] = ACTIONS(6328),
    [anon_sym_default] = ACTIONS(6328),
    [anon_sym_while] = ACTIONS(6328),
    [anon_sym_do] = ACTIONS(6328),
    [anon_sym_for] = ACTIONS(6328),
    [anon_sym_return] = ACTIONS(6328),
    [anon_sym_break] = ACTIONS(6328),
    [anon_sym_continue] = ACTIONS(6328),
    [anon_sym_goto] = ACTIONS(6328),
    [anon_sym_AMP] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_TILDE] = ACTIONS(6326),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_DASH_DASH] = ACTIONS(6326),
    [anon_sym_PLUS_PLUS] = ACTIONS(6326),
    [anon_sym_sizeof] = ACTIONS(6328),
    [sym_number_literal] = ACTIONS(6326),
    [sym_char_literal] = ACTIONS(6326),
    [sym_string_literal] = ACTIONS(6326),
    [sym_true] = ACTIONS(6328),
    [sym_false] = ACTIONS(6328),
    [sym_null] = ACTIONS(6328),
    [sym_identifier] = ACTIONS(6328),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6328),
    [sym_auto] = ACTIONS(6328),
    [anon_sym_typename] = ACTIONS(6328),
    [anon_sym_new] = ACTIONS(6328),
    [anon_sym_COLON_COLON] = ACTIONS(6326),
    [anon_sym_delete] = ACTIONS(6328),
    [sym_nullptr] = ACTIONS(6328),
  },
  [2442] = {
    [sym_raw_string_literal] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6332),
    [sym_preproc_directive] = ACTIONS(6332),
    [anon_sym_SEMI] = ACTIONS(6330),
    [anon_sym_typedef] = ACTIONS(6332),
    [anon_sym_extern] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6330),
    [anon_sym_RBRACE] = ACTIONS(6330),
    [anon_sym_STAR] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6330),
    [anon_sym_static] = ACTIONS(6332),
    [anon_sym_register] = ACTIONS(6332),
    [anon_sym_inline] = ACTIONS(6332),
    [anon_sym_const] = ACTIONS(6332),
    [anon_sym_restrict] = ACTIONS(6332),
    [anon_sym_volatile] = ACTIONS(6332),
    [anon_sym__Atomic] = ACTIONS(6332),
    [anon_sym_mutable] = ACTIONS(6332),
    [anon_sym_explicit] = ACTIONS(6332),
    [anon_sym_constexpr] = ACTIONS(6332),
    [anon_sym_unsigned] = ACTIONS(6332),
    [anon_sym_long] = ACTIONS(6332),
    [anon_sym_short] = ACTIONS(6332),
    [sym_primitive_type] = ACTIONS(6332),
    [anon_sym_enum] = ACTIONS(6332),
    [anon_sym_struct] = ACTIONS(6332),
    [anon_sym_union] = ACTIONS(6332),
    [anon_sym_if] = ACTIONS(6332),
    [anon_sym_switch] = ACTIONS(6332),
    [anon_sym_case] = ACTIONS(6332),
    [anon_sym_default] = ACTIONS(6332),
    [anon_sym_while] = ACTIONS(6332),
    [anon_sym_do] = ACTIONS(6332),
    [anon_sym_for] = ACTIONS(6332),
    [anon_sym_return] = ACTIONS(6332),
    [anon_sym_break] = ACTIONS(6332),
    [anon_sym_continue] = ACTIONS(6332),
    [anon_sym_goto] = ACTIONS(6332),
    [anon_sym_AMP] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_TILDE] = ACTIONS(6330),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_DASH_DASH] = ACTIONS(6330),
    [anon_sym_PLUS_PLUS] = ACTIONS(6330),
    [anon_sym_sizeof] = ACTIONS(6332),
    [sym_number_literal] = ACTIONS(6330),
    [sym_char_literal] = ACTIONS(6330),
    [sym_string_literal] = ACTIONS(6330),
    [sym_true] = ACTIONS(6332),
    [sym_false] = ACTIONS(6332),
    [sym_null] = ACTIONS(6332),
    [sym_identifier] = ACTIONS(6332),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6332),
    [sym_auto] = ACTIONS(6332),
    [anon_sym_typename] = ACTIONS(6332),
    [anon_sym_new] = ACTIONS(6332),
    [anon_sym_COLON_COLON] = ACTIONS(6330),
    [anon_sym_delete] = ACTIONS(6332),
    [sym_nullptr] = ACTIONS(6332),
  },
  [2443] = {
    [sym_raw_string_literal] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6336),
    [sym_preproc_directive] = ACTIONS(6336),
    [anon_sym_SEMI] = ACTIONS(6334),
    [anon_sym_typedef] = ACTIONS(6336),
    [anon_sym_extern] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6334),
    [anon_sym_RBRACE] = ACTIONS(6334),
    [anon_sym_STAR] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6334),
    [anon_sym_static] = ACTIONS(6336),
    [anon_sym_register] = ACTIONS(6336),
    [anon_sym_inline] = ACTIONS(6336),
    [anon_sym_const] = ACTIONS(6336),
    [anon_sym_restrict] = ACTIONS(6336),
    [anon_sym_volatile] = ACTIONS(6336),
    [anon_sym__Atomic] = ACTIONS(6336),
    [anon_sym_mutable] = ACTIONS(6336),
    [anon_sym_explicit] = ACTIONS(6336),
    [anon_sym_constexpr] = ACTIONS(6336),
    [anon_sym_unsigned] = ACTIONS(6336),
    [anon_sym_long] = ACTIONS(6336),
    [anon_sym_short] = ACTIONS(6336),
    [sym_primitive_type] = ACTIONS(6336),
    [anon_sym_enum] = ACTIONS(6336),
    [anon_sym_struct] = ACTIONS(6336),
    [anon_sym_union] = ACTIONS(6336),
    [anon_sym_if] = ACTIONS(6336),
    [anon_sym_switch] = ACTIONS(6336),
    [anon_sym_case] = ACTIONS(6336),
    [anon_sym_default] = ACTIONS(6336),
    [anon_sym_while] = ACTIONS(6336),
    [anon_sym_do] = ACTIONS(6336),
    [anon_sym_for] = ACTIONS(6336),
    [anon_sym_return] = ACTIONS(6336),
    [anon_sym_break] = ACTIONS(6336),
    [anon_sym_continue] = ACTIONS(6336),
    [anon_sym_goto] = ACTIONS(6336),
    [anon_sym_AMP] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_TILDE] = ACTIONS(6334),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_DASH_DASH] = ACTIONS(6334),
    [anon_sym_PLUS_PLUS] = ACTIONS(6334),
    [anon_sym_sizeof] = ACTIONS(6336),
    [sym_number_literal] = ACTIONS(6334),
    [sym_char_literal] = ACTIONS(6334),
    [sym_string_literal] = ACTIONS(6334),
    [sym_true] = ACTIONS(6336),
    [sym_false] = ACTIONS(6336),
    [sym_null] = ACTIONS(6336),
    [sym_identifier] = ACTIONS(6336),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6336),
    [sym_auto] = ACTIONS(6336),
    [anon_sym_typename] = ACTIONS(6336),
    [anon_sym_new] = ACTIONS(6336),
    [anon_sym_COLON_COLON] = ACTIONS(6334),
    [anon_sym_delete] = ACTIONS(6336),
    [sym_nullptr] = ACTIONS(6336),
  },
  [2444] = {
    [sym_raw_string_literal] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6338),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6338),
    [anon_sym_RBRACE] = ACTIONS(6338),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6338),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [anon_sym_if] = ACTIONS(6340),
    [anon_sym_switch] = ACTIONS(6340),
    [anon_sym_case] = ACTIONS(6340),
    [anon_sym_default] = ACTIONS(6340),
    [anon_sym_while] = ACTIONS(6340),
    [anon_sym_do] = ACTIONS(6340),
    [anon_sym_for] = ACTIONS(6340),
    [anon_sym_return] = ACTIONS(6340),
    [anon_sym_break] = ACTIONS(6340),
    [anon_sym_continue] = ACTIONS(6340),
    [anon_sym_goto] = ACTIONS(6340),
    [anon_sym_AMP] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_TILDE] = ACTIONS(6338),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_DASH_DASH] = ACTIONS(6338),
    [anon_sym_PLUS_PLUS] = ACTIONS(6338),
    [anon_sym_sizeof] = ACTIONS(6340),
    [sym_number_literal] = ACTIONS(6338),
    [sym_char_literal] = ACTIONS(6338),
    [sym_string_literal] = ACTIONS(6338),
    [sym_true] = ACTIONS(6340),
    [sym_false] = ACTIONS(6340),
    [sym_null] = ACTIONS(6340),
    [sym_identifier] = ACTIONS(6340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6340),
    [sym_auto] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_new] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6338),
    [anon_sym_delete] = ACTIONS(6340),
    [sym_nullptr] = ACTIONS(6340),
  },
  [2445] = {
    [sym_raw_string_literal] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6342),
    [anon_sym_RBRACE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6342),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [anon_sym_if] = ACTIONS(6344),
    [anon_sym_switch] = ACTIONS(6344),
    [anon_sym_case] = ACTIONS(6344),
    [anon_sym_default] = ACTIONS(6344),
    [anon_sym_while] = ACTIONS(6344),
    [anon_sym_do] = ACTIONS(6344),
    [anon_sym_for] = ACTIONS(6344),
    [anon_sym_return] = ACTIONS(6344),
    [anon_sym_break] = ACTIONS(6344),
    [anon_sym_continue] = ACTIONS(6344),
    [anon_sym_goto] = ACTIONS(6344),
    [anon_sym_AMP] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_DASH_DASH] = ACTIONS(6342),
    [anon_sym_PLUS_PLUS] = ACTIONS(6342),
    [anon_sym_sizeof] = ACTIONS(6344),
    [sym_number_literal] = ACTIONS(6342),
    [sym_char_literal] = ACTIONS(6342),
    [sym_string_literal] = ACTIONS(6342),
    [sym_true] = ACTIONS(6344),
    [sym_false] = ACTIONS(6344),
    [sym_null] = ACTIONS(6344),
    [sym_identifier] = ACTIONS(6344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6344),
    [sym_auto] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_new] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_delete] = ACTIONS(6344),
    [sym_nullptr] = ACTIONS(6344),
  },
  [2446] = {
    [sym_raw_string_literal] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6346),
    [anon_sym_RBRACE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6346),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [anon_sym_if] = ACTIONS(6348),
    [anon_sym_switch] = ACTIONS(6348),
    [anon_sym_case] = ACTIONS(6348),
    [anon_sym_default] = ACTIONS(6348),
    [anon_sym_while] = ACTIONS(6348),
    [anon_sym_do] = ACTIONS(6348),
    [anon_sym_for] = ACTIONS(6348),
    [anon_sym_return] = ACTIONS(6348),
    [anon_sym_break] = ACTIONS(6348),
    [anon_sym_continue] = ACTIONS(6348),
    [anon_sym_goto] = ACTIONS(6348),
    [anon_sym_AMP] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_DASH_DASH] = ACTIONS(6346),
    [anon_sym_PLUS_PLUS] = ACTIONS(6346),
    [anon_sym_sizeof] = ACTIONS(6348),
    [sym_number_literal] = ACTIONS(6346),
    [sym_char_literal] = ACTIONS(6346),
    [sym_string_literal] = ACTIONS(6346),
    [sym_true] = ACTIONS(6348),
    [sym_false] = ACTIONS(6348),
    [sym_null] = ACTIONS(6348),
    [sym_identifier] = ACTIONS(6348),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6348),
    [sym_auto] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_new] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_delete] = ACTIONS(6348),
    [sym_nullptr] = ACTIONS(6348),
  },
  [2447] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [2448] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2449] = {
    [anon_sym_RPAREN] = ACTIONS(6350),
    [sym_comment] = ACTIONS(49),
  },
  [2450] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2450),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(6352),
    [sym_comment] = ACTIONS(49),
  },
  [2451] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(6355),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [2452] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2453] = {
    [sym__expression] = STATE(2689),
    [sym_conditional_expression] = STATE(2689),
    [sym_assignment_expression] = STATE(2689),
    [sym_pointer_expression] = STATE(2689),
    [sym_logical_expression] = STATE(2689),
    [sym_bitwise_expression] = STATE(2689),
    [sym_equality_expression] = STATE(2689),
    [sym_relational_expression] = STATE(2689),
    [sym_shift_expression] = STATE(2689),
    [sym_math_expression] = STATE(2689),
    [sym_cast_expression] = STATE(2689),
    [sym_sizeof_expression] = STATE(2689),
    [sym_subscript_expression] = STATE(2689),
    [sym_call_expression] = STATE(2689),
    [sym_field_expression] = STATE(2689),
    [sym_compound_literal_expression] = STATE(2689),
    [sym_parenthesized_expression] = STATE(2689),
    [sym_concatenated_string] = STATE(2689),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2689),
    [sym_new_expression] = STATE(2689),
    [sym_delete_expression] = STATE(2689),
    [sym_lambda_expression] = STATE(2689),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6357),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6357),
    [sym_char_literal] = ACTIONS(6357),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6359),
    [sym_false] = ACTIONS(6359),
    [sym_null] = ACTIONS(6359),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6359),
  },
  [2454] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [2455] = {
    [sym_preproc_include] = STATE(2691),
    [sym_preproc_def] = STATE(2691),
    [sym_preproc_function_def] = STATE(2691),
    [sym_preproc_call] = STATE(2691),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(2691),
    [sym_type_definition] = STATE(2691),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(2691),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2691),
    [sym_expression_statement] = STATE(2691),
    [sym_if_statement] = STATE(2691),
    [sym_switch_statement] = STATE(2691),
    [sym_case_statement] = STATE(2691),
    [sym_while_statement] = STATE(2691),
    [sym_do_statement] = STATE(2691),
    [sym_for_statement] = STATE(2691),
    [sym_return_statement] = STATE(2691),
    [sym_break_statement] = STATE(2691),
    [sym_continue_statement] = STATE(2691),
    [sym_goto_statement] = STATE(2691),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(2691),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2691),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2691),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2691),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(6361),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2456] = {
    [anon_sym_LPAREN] = ACTIONS(6363),
    [anon_sym_constexpr] = ACTIONS(6365),
    [sym_comment] = ACTIONS(49),
  },
  [2457] = {
    [anon_sym_LPAREN] = ACTIONS(6367),
    [sym_comment] = ACTIONS(49),
  },
  [2458] = {
    [sym__expression] = STATE(2695),
    [sym_conditional_expression] = STATE(2695),
    [sym_assignment_expression] = STATE(2695),
    [sym_pointer_expression] = STATE(2695),
    [sym_logical_expression] = STATE(2695),
    [sym_bitwise_expression] = STATE(2695),
    [sym_equality_expression] = STATE(2695),
    [sym_relational_expression] = STATE(2695),
    [sym_shift_expression] = STATE(2695),
    [sym_math_expression] = STATE(2695),
    [sym_cast_expression] = STATE(2695),
    [sym_sizeof_expression] = STATE(2695),
    [sym_subscript_expression] = STATE(2695),
    [sym_call_expression] = STATE(2695),
    [sym_field_expression] = STATE(2695),
    [sym_compound_literal_expression] = STATE(2695),
    [sym_parenthesized_expression] = STATE(2695),
    [sym_concatenated_string] = STATE(2695),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2695),
    [sym_new_expression] = STATE(2695),
    [sym_delete_expression] = STATE(2695),
    [sym_lambda_expression] = STATE(2695),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6369),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(6369),
    [sym_char_literal] = ACTIONS(6369),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(6371),
    [sym_false] = ACTIONS(6371),
    [sym_null] = ACTIONS(6371),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(6371),
  },
  [2459] = {
    [anon_sym_COLON] = ACTIONS(6373),
    [sym_comment] = ACTIONS(49),
  },
  [2460] = {
    [anon_sym_LPAREN] = ACTIONS(6375),
    [sym_comment] = ACTIONS(49),
  },
  [2461] = {
    [sym_compound_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_case_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_break_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2698),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2462] = {
    [anon_sym_LPAREN] = ACTIONS(6377),
    [sym_comment] = ACTIONS(49),
  },
  [2463] = {
    [sym__expression] = STATE(2701),
    [sym_conditional_expression] = STATE(2701),
    [sym_assignment_expression] = STATE(2701),
    [sym_pointer_expression] = STATE(2701),
    [sym_logical_expression] = STATE(2701),
    [sym_bitwise_expression] = STATE(2701),
    [sym_equality_expression] = STATE(2701),
    [sym_relational_expression] = STATE(2701),
    [sym_shift_expression] = STATE(2701),
    [sym_math_expression] = STATE(2701),
    [sym_cast_expression] = STATE(2701),
    [sym_sizeof_expression] = STATE(2701),
    [sym_subscript_expression] = STATE(2701),
    [sym_call_expression] = STATE(2701),
    [sym_field_expression] = STATE(2701),
    [sym_compound_literal_expression] = STATE(2701),
    [sym_parenthesized_expression] = STATE(2701),
    [sym_initializer_list] = STATE(2702),
    [sym_concatenated_string] = STATE(2701),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2701),
    [sym_new_expression] = STATE(2701),
    [sym_delete_expression] = STATE(2701),
    [sym_lambda_expression] = STATE(2701),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6379),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6379),
    [sym_char_literal] = ACTIONS(6379),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6383),
    [sym_false] = ACTIONS(6383),
    [sym_null] = ACTIONS(6383),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6383),
  },
  [2464] = {
    [anon_sym_SEMI] = ACTIONS(6385),
    [sym_comment] = ACTIONS(49),
  },
  [2465] = {
    [anon_sym_SEMI] = ACTIONS(6387),
    [sym_comment] = ACTIONS(49),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(6389),
    [sym_comment] = ACTIONS(49),
  },
  [2467] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(6391),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2468] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_RBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(6397),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [2469] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(6399),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2470] = {
    [anon_sym_SEMI] = ACTIONS(6399),
    [sym_comment] = ACTIONS(49),
  },
  [2471] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2472] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(6401),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2473] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2474] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2475] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2476] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2477] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2478] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2479] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2480] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2481] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2482] = {
    [sym_compound_statement] = STATE(2710),
    [sym_labeled_statement] = STATE(2710),
    [sym_expression_statement] = STATE(2710),
    [sym_if_statement] = STATE(2710),
    [sym_switch_statement] = STATE(2710),
    [sym_case_statement] = STATE(2710),
    [sym_while_statement] = STATE(2710),
    [sym_do_statement] = STATE(2710),
    [sym_for_statement] = STATE(2710),
    [sym_return_statement] = STATE(2710),
    [sym_break_statement] = STATE(2710),
    [sym_continue_statement] = STATE(2710),
    [sym_goto_statement] = STATE(2710),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(2710),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2483] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_RBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [2484] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5298),
    [anon_sym_COLON] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_STAR_EQ] = ACTIONS(5296),
    [anon_sym_SLASH_EQ] = ACTIONS(5296),
    [anon_sym_PERCENT_EQ] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5296),
    [anon_sym_DASH_EQ] = ACTIONS(5296),
    [anon_sym_LT_LT_EQ] = ACTIONS(5296),
    [anon_sym_GT_GT_EQ] = ACTIONS(5296),
    [anon_sym_AMP_EQ] = ACTIONS(5296),
    [anon_sym_CARET_EQ] = ACTIONS(5296),
    [anon_sym_PIPE_EQ] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5298),
    [anon_sym_PIPE_PIPE] = ACTIONS(5296),
    [anon_sym_AMP_AMP] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5298),
    [anon_sym_CARET] = ACTIONS(5298),
    [anon_sym_EQ_EQ] = ACTIONS(5296),
    [anon_sym_BANG_EQ] = ACTIONS(5296),
    [anon_sym_LT] = ACTIONS(5298),
    [anon_sym_GT] = ACTIONS(5298),
    [anon_sym_LT_EQ] = ACTIONS(5296),
    [anon_sym_GT_EQ] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5298),
    [anon_sym_GT_GT] = ACTIONS(5298),
    [anon_sym_PLUS] = ACTIONS(5298),
    [anon_sym_DASH] = ACTIONS(5298),
    [anon_sym_SLASH] = ACTIONS(5298),
    [anon_sym_PERCENT] = ACTIONS(5298),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2485] = {
    [sym__expression] = STATE(2484),
    [sym_conditional_expression] = STATE(2484),
    [sym_assignment_expression] = STATE(2484),
    [sym_pointer_expression] = STATE(2484),
    [sym_logical_expression] = STATE(2484),
    [sym_bitwise_expression] = STATE(2484),
    [sym_equality_expression] = STATE(2484),
    [sym_relational_expression] = STATE(2484),
    [sym_shift_expression] = STATE(2484),
    [sym_math_expression] = STATE(2484),
    [sym_cast_expression] = STATE(2484),
    [sym_sizeof_expression] = STATE(2484),
    [sym_subscript_expression] = STATE(2484),
    [sym_call_expression] = STATE(2484),
    [sym_field_expression] = STATE(2484),
    [sym_compound_literal_expression] = STATE(2484),
    [sym_parenthesized_expression] = STATE(2484),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(2484),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2484),
    [sym_new_expression] = STATE(2484),
    [sym_delete_expression] = STATE(2484),
    [sym_lambda_expression] = STATE(2484),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5740),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(6407),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_COLON] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6409),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(5740),
    [sym_char_literal] = ACTIONS(5740),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(5742),
    [sym_false] = ACTIONS(5742),
    [sym_null] = ACTIONS(5742),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(5742),
  },
  [2486] = {
    [sym__expression] = STATE(2711),
    [sym_conditional_expression] = STATE(2711),
    [sym_assignment_expression] = STATE(2711),
    [sym_pointer_expression] = STATE(2711),
    [sym_logical_expression] = STATE(2711),
    [sym_bitwise_expression] = STATE(2711),
    [sym_equality_expression] = STATE(2711),
    [sym_relational_expression] = STATE(2711),
    [sym_shift_expression] = STATE(2711),
    [sym_math_expression] = STATE(2711),
    [sym_cast_expression] = STATE(2711),
    [sym_sizeof_expression] = STATE(2711),
    [sym_subscript_expression] = STATE(2711),
    [sym_call_expression] = STATE(2711),
    [sym_field_expression] = STATE(2711),
    [sym_compound_literal_expression] = STATE(2711),
    [sym_parenthesized_expression] = STATE(2711),
    [sym_concatenated_string] = STATE(2711),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2711),
    [sym_new_expression] = STATE(2711),
    [sym_delete_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(2711),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6411),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(6411),
    [sym_char_literal] = ACTIONS(6411),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(6413),
    [sym_false] = ACTIONS(6413),
    [sym_null] = ACTIONS(6413),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(6413),
  },
  [2487] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2488] = {
    [sym__expression] = STATE(2712),
    [sym_conditional_expression] = STATE(2712),
    [sym_assignment_expression] = STATE(2712),
    [sym_pointer_expression] = STATE(2712),
    [sym_logical_expression] = STATE(2712),
    [sym_bitwise_expression] = STATE(2712),
    [sym_equality_expression] = STATE(2712),
    [sym_relational_expression] = STATE(2712),
    [sym_shift_expression] = STATE(2712),
    [sym_math_expression] = STATE(2712),
    [sym_cast_expression] = STATE(2712),
    [sym_sizeof_expression] = STATE(2712),
    [sym_subscript_expression] = STATE(2712),
    [sym_call_expression] = STATE(2712),
    [sym_field_expression] = STATE(2712),
    [sym_compound_literal_expression] = STATE(2712),
    [sym_parenthesized_expression] = STATE(2712),
    [sym_concatenated_string] = STATE(2712),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2712),
    [sym_new_expression] = STATE(2712),
    [sym_delete_expression] = STATE(2712),
    [sym_lambda_expression] = STATE(2712),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6415),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(6415),
    [sym_char_literal] = ACTIONS(6415),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(6417),
    [sym_false] = ACTIONS(6417),
    [sym_null] = ACTIONS(6417),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(6417),
  },
  [2489] = {
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_register] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [anon_sym_restrict] = ACTIONS(1188),
    [anon_sym_volatile] = ACTIONS(1188),
    [anon_sym__Atomic] = ACTIONS(1188),
    [anon_sym_mutable] = ACTIONS(1188),
    [anon_sym_explicit] = ACTIONS(1188),
    [anon_sym_constexpr] = ACTIONS(1188),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_EQ] = ACTIONS(1192),
    [anon_sym_SLASH_EQ] = ACTIONS(1192),
    [anon_sym_PERCENT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_GT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_EQ] = ACTIONS(1192),
    [anon_sym_CARET_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_EQ] = ACTIONS(1192),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1192),
    [anon_sym_DASH_GT] = ACTIONS(1192),
    [sym_identifier] = ACTIONS(1188),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1190),
    [sym_operator_name] = ACTIONS(1186),
  },
  [2490] = {
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_register] = ACTIONS(1861),
    [anon_sym_inline] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_restrict] = ACTIONS(1861),
    [anon_sym_volatile] = ACTIONS(1861),
    [anon_sym__Atomic] = ACTIONS(1861),
    [anon_sym_mutable] = ACTIONS(1861),
    [anon_sym_explicit] = ACTIONS(1861),
    [anon_sym_constexpr] = ACTIONS(1861),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_STAR_EQ] = ACTIONS(1865),
    [anon_sym_SLASH_EQ] = ACTIONS(1865),
    [anon_sym_PERCENT_EQ] = ACTIONS(1865),
    [anon_sym_PLUS_EQ] = ACTIONS(1865),
    [anon_sym_DASH_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_GT_EQ] = ACTIONS(1865),
    [anon_sym_AMP_EQ] = ACTIONS(1865),
    [anon_sym_CARET_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_EQ] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4431),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_DASH_GT] = ACTIONS(1865),
    [sym_identifier] = ACTIONS(1861),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [sym_operator_name] = ACTIONS(1859),
  },
  [2491] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_RBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [2492] = {
    [sym_compound_statement] = STATE(2720),
    [sym_labeled_statement] = STATE(2720),
    [sym_expression_statement] = STATE(2720),
    [sym_if_statement] = STATE(2720),
    [sym_switch_statement] = STATE(2720),
    [sym_case_statement] = STATE(2720),
    [sym_while_statement] = STATE(2720),
    [sym_do_statement] = STATE(2720),
    [sym_for_statement] = STATE(2720),
    [sym_return_statement] = STATE(2720),
    [sym_break_statement] = STATE(2720),
    [sym_continue_statement] = STATE(2720),
    [sym_goto_statement] = STATE(2720),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2720),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2493] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6437),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2494] = {
    [sym_compound_statement] = STATE(2722),
    [sym_labeled_statement] = STATE(2722),
    [sym_expression_statement] = STATE(2722),
    [sym_if_statement] = STATE(2722),
    [sym_switch_statement] = STATE(2722),
    [sym_case_statement] = STATE(2722),
    [sym_while_statement] = STATE(2722),
    [sym_do_statement] = STATE(2722),
    [sym_for_statement] = STATE(2722),
    [sym_return_statement] = STATE(2722),
    [sym_break_statement] = STATE(2722),
    [sym_continue_statement] = STATE(2722),
    [sym_goto_statement] = STATE(2722),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2722),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2495] = {
    [anon_sym_else] = ACTIONS(5755),
    [anon_sym_while] = ACTIONS(5755),
    [sym_comment] = ACTIONS(49),
  },
  [2496] = {
    [sym__type_declarator] = STATE(2723),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2497] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2724),
    [sym_enum_specifier] = STATE(2724),
    [sym_struct_specifier] = STATE(2724),
    [sym_union_specifier] = STATE(2724),
    [sym_macro_type_specifier] = STATE(2724),
    [sym_class_specifier] = STATE(2724),
    [sym_dependent_type] = STATE(2724),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6439),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6439),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2498] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(2726),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6441),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [2499] = {
    [aux_sym_declaration_repeat1] = STATE(2726),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6441),
    [sym_comment] = ACTIONS(49),
  },
  [2500] = {
    [sym_compound_statement] = STATE(2727),
    [sym_labeled_statement] = STATE(2727),
    [sym_expression_statement] = STATE(2727),
    [sym_if_statement] = STATE(2727),
    [sym_switch_statement] = STATE(2727),
    [sym_case_statement] = STATE(2727),
    [sym_while_statement] = STATE(2727),
    [sym_do_statement] = STATE(2727),
    [sym_for_statement] = STATE(2727),
    [sym_return_statement] = STATE(2727),
    [sym_break_statement] = STATE(2727),
    [sym_continue_statement] = STATE(2727),
    [sym_goto_statement] = STATE(2727),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2727),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2501] = {
    [sym__expression] = STATE(2728),
    [sym_conditional_expression] = STATE(2728),
    [sym_assignment_expression] = STATE(2728),
    [sym_pointer_expression] = STATE(2728),
    [sym_logical_expression] = STATE(2728),
    [sym_bitwise_expression] = STATE(2728),
    [sym_equality_expression] = STATE(2728),
    [sym_relational_expression] = STATE(2728),
    [sym_shift_expression] = STATE(2728),
    [sym_math_expression] = STATE(2728),
    [sym_cast_expression] = STATE(2728),
    [sym_sizeof_expression] = STATE(2728),
    [sym_subscript_expression] = STATE(2728),
    [sym_call_expression] = STATE(2728),
    [sym_field_expression] = STATE(2728),
    [sym_compound_literal_expression] = STATE(2728),
    [sym_parenthesized_expression] = STATE(2728),
    [sym_concatenated_string] = STATE(2728),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2728),
    [sym_new_expression] = STATE(2728),
    [sym_delete_expression] = STATE(2728),
    [sym_lambda_expression] = STATE(2728),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6443),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6443),
    [sym_char_literal] = ACTIONS(6443),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6445),
    [sym_false] = ACTIONS(6445),
    [sym_null] = ACTIONS(6445),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6445),
  },
  [2502] = {
    [sym__expression] = STATE(2730),
    [sym_conditional_expression] = STATE(2730),
    [sym_assignment_expression] = STATE(2730),
    [sym_pointer_expression] = STATE(2730),
    [sym_logical_expression] = STATE(2730),
    [sym_bitwise_expression] = STATE(2730),
    [sym_equality_expression] = STATE(2730),
    [sym_relational_expression] = STATE(2730),
    [sym_shift_expression] = STATE(2730),
    [sym_math_expression] = STATE(2730),
    [sym_cast_expression] = STATE(2730),
    [sym_sizeof_expression] = STATE(2730),
    [sym_subscript_expression] = STATE(2730),
    [sym_call_expression] = STATE(2730),
    [sym_field_expression] = STATE(2730),
    [sym_compound_literal_expression] = STATE(2730),
    [sym_parenthesized_expression] = STATE(2730),
    [sym_concatenated_string] = STATE(2730),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2730),
    [sym_new_expression] = STATE(2730),
    [sym_delete_expression] = STATE(2730),
    [sym_lambda_expression] = STATE(2730),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6447),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6449),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6447),
    [sym_char_literal] = ACTIONS(6447),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6451),
    [sym_false] = ACTIONS(6451),
    [sym_null] = ACTIONS(6451),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6451),
  },
  [2503] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6453),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2504] = {
    [sym__expression] = STATE(2732),
    [sym_conditional_expression] = STATE(2732),
    [sym_assignment_expression] = STATE(2732),
    [sym_pointer_expression] = STATE(2732),
    [sym_logical_expression] = STATE(2732),
    [sym_bitwise_expression] = STATE(2732),
    [sym_equality_expression] = STATE(2732),
    [sym_relational_expression] = STATE(2732),
    [sym_shift_expression] = STATE(2732),
    [sym_math_expression] = STATE(2732),
    [sym_cast_expression] = STATE(2732),
    [sym_sizeof_expression] = STATE(2732),
    [sym_subscript_expression] = STATE(2732),
    [sym_call_expression] = STATE(2732),
    [sym_field_expression] = STATE(2732),
    [sym_compound_literal_expression] = STATE(2732),
    [sym_parenthesized_expression] = STATE(2732),
    [sym_concatenated_string] = STATE(2732),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2732),
    [sym_new_expression] = STATE(2732),
    [sym_delete_expression] = STATE(2732),
    [sym_lambda_expression] = STATE(2732),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6455),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6453),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6455),
    [sym_char_literal] = ACTIONS(6455),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6457),
    [sym_false] = ACTIONS(6457),
    [sym_null] = ACTIONS(6457),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6457),
  },
  [2505] = {
    [sym__expression] = STATE(2733),
    [sym_conditional_expression] = STATE(2733),
    [sym_assignment_expression] = STATE(2733),
    [sym_pointer_expression] = STATE(2733),
    [sym_logical_expression] = STATE(2733),
    [sym_bitwise_expression] = STATE(2733),
    [sym_equality_expression] = STATE(2733),
    [sym_relational_expression] = STATE(2733),
    [sym_shift_expression] = STATE(2733),
    [sym_math_expression] = STATE(2733),
    [sym_cast_expression] = STATE(2733),
    [sym_sizeof_expression] = STATE(2733),
    [sym_subscript_expression] = STATE(2733),
    [sym_call_expression] = STATE(2733),
    [sym_field_expression] = STATE(2733),
    [sym_compound_literal_expression] = STATE(2733),
    [sym_parenthesized_expression] = STATE(2733),
    [sym_concatenated_string] = STATE(2733),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2733),
    [sym_new_expression] = STATE(2733),
    [sym_delete_expression] = STATE(2733),
    [sym_lambda_expression] = STATE(2733),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6459),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6459),
    [sym_char_literal] = ACTIONS(6459),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6461),
    [sym_false] = ACTIONS(6461),
    [sym_null] = ACTIONS(6461),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6461),
  },
  [2506] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6463),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2507] = {
    [sym_compound_statement] = STATE(2735),
    [sym_labeled_statement] = STATE(2735),
    [sym_expression_statement] = STATE(2735),
    [sym_if_statement] = STATE(2735),
    [sym_switch_statement] = STATE(2735),
    [sym_case_statement] = STATE(2735),
    [sym_while_statement] = STATE(2735),
    [sym_do_statement] = STATE(2735),
    [sym_for_statement] = STATE(2735),
    [sym_return_statement] = STATE(2735),
    [sym_break_statement] = STATE(2735),
    [sym_continue_statement] = STATE(2735),
    [sym_goto_statement] = STATE(2735),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2735),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2508] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(2738),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6467),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2509] = {
    [sym__expression] = STATE(2739),
    [sym_conditional_expression] = STATE(2739),
    [sym_assignment_expression] = STATE(2739),
    [sym_pointer_expression] = STATE(2739),
    [sym_logical_expression] = STATE(2739),
    [sym_bitwise_expression] = STATE(2739),
    [sym_equality_expression] = STATE(2739),
    [sym_relational_expression] = STATE(2739),
    [sym_shift_expression] = STATE(2739),
    [sym_math_expression] = STATE(2739),
    [sym_cast_expression] = STATE(2739),
    [sym_sizeof_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_field_expression] = STATE(2739),
    [sym_compound_literal_expression] = STATE(2739),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_concatenated_string] = STATE(2739),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2739),
    [sym_new_expression] = STATE(2739),
    [sym_delete_expression] = STATE(2739),
    [sym_lambda_expression] = STATE(2739),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6469),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6467),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6469),
    [sym_char_literal] = ACTIONS(6469),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6471),
    [sym_false] = ACTIONS(6471),
    [sym_null] = ACTIONS(6471),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6471),
  },
  [2510] = {
    [sym_parameter_list] = STATE(2513),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(869),
    [anon_sym_COLON] = ACTIONS(869),
    [sym_comment] = ACTIONS(49),
  },
  [2511] = {
    [sym_parameter_list] = STATE(2513),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_COLON] = ACTIONS(871),
    [sym_comment] = ACTIONS(49),
  },
  [2512] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [2513] = {
    [sym_type_qualifier] = STATE(2741),
    [sym_trailing_return_type] = STATE(2741),
    [aux_sym_function_declarator_repeat1] = STATE(2741),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6475),
  },
  [2514] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6477),
    [sym_comment] = ACTIONS(49),
  },
  [2515] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6479),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2516] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6481),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2517] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2518] = {
    [sym_raw_string_literal] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_switch] = ACTIONS(4174),
    [anon_sym_case] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_break] = ACTIONS(4174),
    [anon_sym_continue] = ACTIONS(4174),
    [anon_sym_goto] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_BANG] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_sizeof] = ACTIONS(4174),
    [sym_number_literal] = ACTIONS(4172),
    [sym_char_literal] = ACTIONS(4172),
    [sym_string_literal] = ACTIONS(4172),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_null] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_delete] = ACTIONS(4174),
    [sym_nullptr] = ACTIONS(4174),
  },
  [2519] = {
    [sym_raw_string_literal] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_RBRACE] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_switch] = ACTIONS(4222),
    [anon_sym_case] = ACTIONS(4222),
    [anon_sym_default] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_do] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_return] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4222),
    [anon_sym_continue] = ACTIONS(4222),
    [anon_sym_goto] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_BANG] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4222),
    [anon_sym_DASH] = ACTIONS(4222),
    [anon_sym_DASH_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_PLUS] = ACTIONS(4220),
    [anon_sym_sizeof] = ACTIONS(4222),
    [sym_number_literal] = ACTIONS(4220),
    [sym_char_literal] = ACTIONS(4220),
    [sym_string_literal] = ACTIONS(4220),
    [sym_true] = ACTIONS(4222),
    [sym_false] = ACTIONS(4222),
    [sym_null] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [anon_sym_delete] = ACTIONS(4222),
    [sym_nullptr] = ACTIONS(4222),
  },
  [2520] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_SEMI] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2521] = {
    [sym_type_qualifier] = STATE(2248),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2248),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(877),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5108),
  },
  [2522] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_AMP_AMP] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_template] = ACTIONS(3436),
    [anon_sym_namespace] = ACTIONS(3436),
    [anon_sym_using] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [sym_operator_name] = ACTIONS(3434),
  },
  [2523] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_template] = ACTIONS(3446),
    [anon_sym_namespace] = ACTIONS(3446),
    [anon_sym_using] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [sym_operator_name] = ACTIONS(3444),
  },
  [2524] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3585),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3585),
    [sym_auto] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [sym_operator_name] = ACTIONS(3583),
  },
  [2525] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3589),
    [sym_preproc_directive] = ACTIONS(3589),
    [anon_sym_typedef] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_register] = ACTIONS(3589),
    [anon_sym_inline] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_restrict] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym__Atomic] = ACTIONS(3589),
    [anon_sym_mutable] = ACTIONS(3589),
    [anon_sym_explicit] = ACTIONS(3589),
    [anon_sym_constexpr] = ACTIONS(3589),
    [anon_sym_unsigned] = ACTIONS(3589),
    [anon_sym_long] = ACTIONS(3589),
    [anon_sym_short] = ACTIONS(3589),
    [sym_primitive_type] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_union] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3589),
    [sym_auto] = ACTIONS(3589),
    [anon_sym_typename] = ACTIONS(3589),
    [anon_sym_template] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [sym_operator_name] = ACTIONS(3587),
  },
  [2526] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3593),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3593),
    [sym_auto] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3591),
    [sym_operator_name] = ACTIONS(3591),
  },
  [2527] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [sym_operator_name] = ACTIONS(3613),
  },
  [2528] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3972),
    [sym_preproc_directive] = ACTIONS(3972),
    [anon_sym_typedef] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3972),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_register] = ACTIONS(3972),
    [anon_sym_inline] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3972),
    [anon_sym_restrict] = ACTIONS(3972),
    [anon_sym_volatile] = ACTIONS(3972),
    [anon_sym__Atomic] = ACTIONS(3972),
    [anon_sym_mutable] = ACTIONS(3972),
    [anon_sym_explicit] = ACTIONS(3972),
    [anon_sym_constexpr] = ACTIONS(3972),
    [anon_sym_unsigned] = ACTIONS(3972),
    [anon_sym_long] = ACTIONS(3972),
    [anon_sym_short] = ACTIONS(3972),
    [sym_primitive_type] = ACTIONS(3972),
    [anon_sym_enum] = ACTIONS(3972),
    [anon_sym_struct] = ACTIONS(3972),
    [anon_sym_union] = ACTIONS(3972),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3970),
    [anon_sym_TILDE] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3972),
    [sym_auto] = ACTIONS(3972),
    [anon_sym_typename] = ACTIONS(3972),
    [anon_sym_template] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_using] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [sym_operator_name] = ACTIONS(3970),
  },
  [2529] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_template] = ACTIONS(4174),
    [anon_sym_namespace] = ACTIONS(4174),
    [anon_sym_using] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [sym_operator_name] = ACTIONS(4172),
  },
  [2530] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4222),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_template] = ACTIONS(4222),
    [anon_sym_namespace] = ACTIONS(4222),
    [anon_sym_using] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [sym_operator_name] = ACTIONS(4220),
  },
  [2531] = {
    [sym_type_qualifier] = STATE(2337),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2337),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5380),
  },
  [2532] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6483),
    [sym_comment] = ACTIONS(49),
  },
  [2533] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6485),
    [sym_comment] = ACTIONS(49),
  },
  [2534] = {
    [sym__type_specifier] = STATE(2749),
    [sym_sized_type_specifier] = STATE(2749),
    [sym_enum_specifier] = STATE(2749),
    [sym_struct_specifier] = STATE(2749),
    [sym_union_specifier] = STATE(2749),
    [sym_macro_type_specifier] = STATE(2749),
    [sym_class_specifier] = STATE(2749),
    [sym_dependent_type] = STATE(2749),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2750),
    [anon_sym_unsigned] = ACTIONS(6487),
    [anon_sym_long] = ACTIONS(6487),
    [anon_sym_short] = ACTIONS(6487),
    [sym_primitive_type] = ACTIONS(6489),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(6491),
    [anon_sym_union] = ACTIONS(6493),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6495),
    [sym_auto] = ACTIONS(6489),
    [anon_sym_typename] = ACTIONS(6497),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2535] = {
    [sym_type_qualifier] = STATE(2751),
    [sym_trailing_return_type] = STATE(2751),
    [aux_sym_function_declarator_repeat1] = STATE(2751),
    [anon_sym_LPAREN] = ACTIONS(5055),
    [anon_sym_COMMA] = ACTIONS(5055),
    [anon_sym_SEMI] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5055),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6499),
  },
  [2536] = {
    [anon_sym_LPAREN] = ACTIONS(6501),
    [anon_sym_COMMA] = ACTIONS(6501),
    [anon_sym_RPAREN] = ACTIONS(6501),
    [anon_sym_SEMI] = ACTIONS(6501),
    [anon_sym_LBRACE] = ACTIONS(6501),
    [anon_sym_LBRACK] = ACTIONS(6501),
    [anon_sym_COLON] = ACTIONS(6501),
    [sym_comment] = ACTIONS(49),
  },
  [2537] = {
    [sym__abstract_declarator] = STATE(2752),
    [sym_abstract_pointer_declarator] = STATE(2752),
    [sym_abstract_function_declarator] = STATE(2752),
    [sym_abstract_array_declarator] = STATE(2752),
    [sym_parameter_list] = STATE(2540),
    [sym_abstract_reference_declarator] = STATE(2752),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(5897),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(5899),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [2538] = {
    [sym__abstract_declarator] = STATE(2753),
    [sym_abstract_pointer_declarator] = STATE(2753),
    [sym_abstract_function_declarator] = STATE(2753),
    [sym_abstract_array_declarator] = STATE(2753),
    [sym_parameter_list] = STATE(2540),
    [sym_abstract_reference_declarator] = STATE(2753),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(5897),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(5899),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [2539] = {
    [sym_parameter_list] = STATE(2754),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [2540] = {
    [sym_type_qualifier] = STATE(2755),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2755),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [2541] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2541),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(6503),
    [anon_sym_long] = ACTIONS(6503),
    [anon_sym_short] = ACTIONS(6503),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [2542] = {
    [anon_sym_LPAREN] = ACTIONS(6506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6506),
    [anon_sym_typedef] = ACTIONS(6508),
    [anon_sym_extern] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6506),
    [anon_sym_STAR] = ACTIONS(6506),
    [anon_sym_static] = ACTIONS(6508),
    [anon_sym_register] = ACTIONS(6508),
    [anon_sym_inline] = ACTIONS(6508),
    [anon_sym_const] = ACTIONS(6508),
    [anon_sym_restrict] = ACTIONS(6508),
    [anon_sym_volatile] = ACTIONS(6508),
    [anon_sym__Atomic] = ACTIONS(6508),
    [anon_sym_mutable] = ACTIONS(6508),
    [anon_sym_explicit] = ACTIONS(6508),
    [anon_sym_constexpr] = ACTIONS(6508),
    [anon_sym_unsigned] = ACTIONS(6508),
    [anon_sym_long] = ACTIONS(6508),
    [anon_sym_short] = ACTIONS(6508),
    [sym_primitive_type] = ACTIONS(6508),
    [anon_sym_enum] = ACTIONS(6508),
    [anon_sym_struct] = ACTIONS(6508),
    [anon_sym_union] = ACTIONS(6508),
    [anon_sym_AMP] = ACTIONS(6508),
    [anon_sym_AMP_AMP] = ACTIONS(6506),
    [anon_sym_TILDE] = ACTIONS(6506),
    [sym_identifier] = ACTIONS(6508),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6508),
    [anon_sym_public] = ACTIONS(6508),
    [sym_auto] = ACTIONS(6508),
    [anon_sym_typename] = ACTIONS(6508),
    [anon_sym_template] = ACTIONS(6508),
    [anon_sym_friend] = ACTIONS(6508),
    [anon_sym_private] = ACTIONS(6508),
    [anon_sym_protected] = ACTIONS(6508),
    [anon_sym_using] = ACTIONS(6508),
    [anon_sym_COLON_COLON] = ACTIONS(6506),
    [sym_operator_name] = ACTIONS(6506),
  },
  [2543] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3882),
    [anon_sym_COLON] = ACTIONS(3880),
    [anon_sym_QMARK] = ACTIONS(3880),
    [anon_sym_STAR_EQ] = ACTIONS(3880),
    [anon_sym_SLASH_EQ] = ACTIONS(3880),
    [anon_sym_PERCENT_EQ] = ACTIONS(3880),
    [anon_sym_PLUS_EQ] = ACTIONS(3880),
    [anon_sym_DASH_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_GT_EQ] = ACTIONS(3880),
    [anon_sym_AMP_EQ] = ACTIONS(3880),
    [anon_sym_CARET_EQ] = ACTIONS(3880),
    [anon_sym_PIPE_EQ] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_PIPE] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_EQ_EQ] = ACTIONS(3880),
    [anon_sym_BANG_EQ] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3882),
    [anon_sym_GT] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3880),
    [anon_sym_GT_EQ] = ACTIONS(3880),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(3882),
    [anon_sym_PLUS] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3882),
    [anon_sym_SLASH] = ACTIONS(3882),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_DOT] = ACTIONS(3880),
    [anon_sym_DASH_GT] = ACTIONS(3880),
    [sym_comment] = ACTIONS(49),
  },
  [2544] = {
    [sym_parameter_list] = STATE(2546),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2545] = {
    [sym_parameter_list] = STATE(2546),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_COLON] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2546] = {
    [sym_type_qualifier] = STATE(2756),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2756),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2547] = {
    [sym_type_qualifier] = STATE(2757),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2757),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(2166),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6510),
  },
  [2548] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_RPAREN] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2549] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_RPAREN] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2550] = {
    [sym_parameter_list] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2551] = {
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_SEMI] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_const] = ACTIONS(6514),
    [anon_sym_restrict] = ACTIONS(6512),
    [anon_sym_volatile] = ACTIONS(6512),
    [anon_sym__Atomic] = ACTIONS(6512),
    [anon_sym_mutable] = ACTIONS(6512),
    [anon_sym_explicit] = ACTIONS(6512),
    [anon_sym_constexpr] = ACTIONS(6512),
    [anon_sym_COLON] = ACTIONS(6512),
    [anon_sym_GT] = ACTIONS(6512),
    [anon_sym_DASH_GT] = ACTIONS(6512),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6512),
  },
  [2552] = {
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [sym_comment] = ACTIONS(49),
  },
  [2553] = {
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(49),
  },
  [2554] = {
    [sym__expression] = STATE(1852),
    [sym_conditional_expression] = STATE(1852),
    [sym_assignment_expression] = STATE(1852),
    [sym_pointer_expression] = STATE(1852),
    [sym_logical_expression] = STATE(1852),
    [sym_bitwise_expression] = STATE(1852),
    [sym_equality_expression] = STATE(1852),
    [sym_relational_expression] = STATE(1852),
    [sym_shift_expression] = STATE(1852),
    [sym_math_expression] = STATE(1852),
    [sym_cast_expression] = STATE(1852),
    [sym_sizeof_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_field_expression] = STATE(1852),
    [sym_compound_literal_expression] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_initializer_list] = STATE(1838),
    [sym_initializer_pair] = STATE(1838),
    [sym_subscript_designator] = STATE(708),
    [sym_field_designator] = STATE(708),
    [sym_concatenated_string] = STATE(1852),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1852),
    [sym_new_expression] = STATE(1852),
    [sym_delete_expression] = STATE(1852),
    [sym_lambda_expression] = STATE(1852),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [aux_sym_initializer_pair_repeat1] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1339),
    [sym_number_literal] = ACTIONS(4070),
    [sym_char_literal] = ACTIONS(4070),
    [sym_string_literal] = ACTIONS(1387),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_delete] = ACTIONS(1393),
    [sym_nullptr] = ACTIONS(4072),
  },
  [2555] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2556] = {
    [anon_sym_RPAREN] = ACTIONS(6518),
    [sym_comment] = ACTIONS(49),
  },
  [2557] = {
    [aux_sym_concatenated_string_repeat1] = STATE(2557),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4340),
    [anon_sym_STAR_EQ] = ACTIONS(4340),
    [anon_sym_SLASH_EQ] = ACTIONS(4340),
    [anon_sym_PERCENT_EQ] = ACTIONS(4340),
    [anon_sym_PLUS_EQ] = ACTIONS(4340),
    [anon_sym_DASH_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_GT_EQ] = ACTIONS(4340),
    [anon_sym_AMP_EQ] = ACTIONS(4340),
    [anon_sym_CARET_EQ] = ACTIONS(4340),
    [anon_sym_PIPE_EQ] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4342),
    [anon_sym_PIPE_PIPE] = ACTIONS(4340),
    [anon_sym_AMP_AMP] = ACTIONS(4340),
    [anon_sym_PIPE] = ACTIONS(4342),
    [anon_sym_CARET] = ACTIONS(4342),
    [anon_sym_EQ_EQ] = ACTIONS(4340),
    [anon_sym_BANG_EQ] = ACTIONS(4340),
    [anon_sym_LT] = ACTIONS(4342),
    [anon_sym_GT] = ACTIONS(4342),
    [anon_sym_LT_EQ] = ACTIONS(4340),
    [anon_sym_GT_EQ] = ACTIONS(4340),
    [anon_sym_LT_LT] = ACTIONS(4342),
    [anon_sym_GT_GT] = ACTIONS(4342),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_SLASH] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_DASH_GT] = ACTIONS(4340),
    [sym_string_literal] = ACTIONS(6520),
    [sym_comment] = ACTIONS(49),
  },
  [2558] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(777),
    [sym_new_expression] = STATE(777),
    [sym_delete_expression] = STATE(777),
    [sym_lambda_expression] = STATE(777),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_lambda_default_capture] = STATE(778),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_sizeof] = ACTIONS(1487),
    [sym_number_literal] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [sym_string_literal] = ACTIONS(1489),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1493),
    [anon_sym_delete] = ACTIONS(1495),
    [sym_nullptr] = ACTIONS(1491),
  },
  [2559] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4374),
    [anon_sym_QMARK] = ACTIONS(4372),
    [anon_sym_STAR_EQ] = ACTIONS(4372),
    [anon_sym_SLASH_EQ] = ACTIONS(4372),
    [anon_sym_PERCENT_EQ] = ACTIONS(4372),
    [anon_sym_PLUS_EQ] = ACTIONS(4372),
    [anon_sym_DASH_EQ] = ACTIONS(4372),
    [anon_sym_LT_LT_EQ] = ACTIONS(4372),
    [anon_sym_GT_GT_EQ] = ACTIONS(4372),
    [anon_sym_AMP_EQ] = ACTIONS(4372),
    [anon_sym_CARET_EQ] = ACTIONS(4372),
    [anon_sym_PIPE_EQ] = ACTIONS(4372),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2560] = {
    [sym__expression] = STATE(2761),
    [sym_conditional_expression] = STATE(2761),
    [sym_assignment_expression] = STATE(2761),
    [sym_pointer_expression] = STATE(2761),
    [sym_logical_expression] = STATE(2761),
    [sym_bitwise_expression] = STATE(2761),
    [sym_equality_expression] = STATE(2761),
    [sym_relational_expression] = STATE(2761),
    [sym_shift_expression] = STATE(2761),
    [sym_math_expression] = STATE(2761),
    [sym_cast_expression] = STATE(2761),
    [sym_sizeof_expression] = STATE(2761),
    [sym_subscript_expression] = STATE(2761),
    [sym_call_expression] = STATE(2761),
    [sym_field_expression] = STATE(2761),
    [sym_compound_literal_expression] = STATE(2761),
    [sym_parenthesized_expression] = STATE(2761),
    [sym_concatenated_string] = STATE(2761),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2761),
    [sym_new_expression] = STATE(2761),
    [sym_delete_expression] = STATE(2761),
    [sym_lambda_expression] = STATE(2761),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6525),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(6525),
    [sym_char_literal] = ACTIONS(6525),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(6527),
    [sym_false] = ACTIONS(6527),
    [sym_null] = ACTIONS(6527),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(6527),
  },
  [2561] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(4394),
    [anon_sym_STAR_EQ] = ACTIONS(5167),
    [anon_sym_SLASH_EQ] = ACTIONS(5167),
    [anon_sym_PERCENT_EQ] = ACTIONS(5167),
    [anon_sym_PLUS_EQ] = ACTIONS(5167),
    [anon_sym_DASH_EQ] = ACTIONS(5167),
    [anon_sym_LT_LT_EQ] = ACTIONS(5167),
    [anon_sym_GT_GT_EQ] = ACTIONS(5167),
    [anon_sym_AMP_EQ] = ACTIONS(5167),
    [anon_sym_CARET_EQ] = ACTIONS(5167),
    [anon_sym_PIPE_EQ] = ACTIONS(5167),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2562] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2563] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2564] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2565] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2566] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2567] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2568] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2569] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2570] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_STAR_EQ] = ACTIONS(4414),
    [anon_sym_SLASH_EQ] = ACTIONS(4414),
    [anon_sym_PERCENT_EQ] = ACTIONS(4414),
    [anon_sym_PLUS_EQ] = ACTIONS(4414),
    [anon_sym_DASH_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_GT_EQ] = ACTIONS(4414),
    [anon_sym_AMP_EQ] = ACTIONS(4414),
    [anon_sym_CARET_EQ] = ACTIONS(4414),
    [anon_sym_PIPE_EQ] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4414),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4414),
    [anon_sym_BANG_EQ] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4416),
    [anon_sym_GT] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4414),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2571] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_STAR_EQ] = ACTIONS(4388),
    [anon_sym_SLASH_EQ] = ACTIONS(4388),
    [anon_sym_PERCENT_EQ] = ACTIONS(4388),
    [anon_sym_PLUS_EQ] = ACTIONS(4388),
    [anon_sym_DASH_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_GT_EQ] = ACTIONS(4388),
    [anon_sym_AMP_EQ] = ACTIONS(4388),
    [anon_sym_CARET_EQ] = ACTIONS(4388),
    [anon_sym_PIPE_EQ] = ACTIONS(4388),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4388),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_CARET] = ACTIONS(4390),
    [anon_sym_EQ_EQ] = ACTIONS(4388),
    [anon_sym_BANG_EQ] = ACTIONS(4388),
    [anon_sym_LT] = ACTIONS(4390),
    [anon_sym_GT] = ACTIONS(4390),
    [anon_sym_LT_EQ] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(4388),
    [anon_sym_LT_LT] = ACTIONS(4390),
    [anon_sym_GT_GT] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4390),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2572] = {
    [sym__abstract_declarator] = STATE(2763),
    [sym_abstract_pointer_declarator] = STATE(2763),
    [sym_abstract_function_declarator] = STATE(2763),
    [sym_abstract_array_declarator] = STATE(2763),
    [sym_parameter_list] = STATE(2575),
    [sym_abstract_reference_declarator] = STATE(2763),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6012),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [2573] = {
    [sym__abstract_declarator] = STATE(2764),
    [sym_abstract_pointer_declarator] = STATE(2764),
    [sym_abstract_function_declarator] = STATE(2764),
    [sym_abstract_array_declarator] = STATE(2764),
    [sym_parameter_list] = STATE(2575),
    [sym_abstract_reference_declarator] = STATE(2764),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6012),
    [anon_sym_GT] = ACTIONS(2350),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [2574] = {
    [sym_parameter_list] = STATE(2765),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [2575] = {
    [sym_type_qualifier] = STATE(2766),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2766),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_GT] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [2576] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2576),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(6531),
    [anon_sym_long] = ACTIONS(6531),
    [anon_sym_short] = ACTIONS(6531),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [2577] = {
    [sym_type_qualifier] = STATE(2288),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2288),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1244),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(5204),
  },
  [2578] = {
    [sym_parameter_list] = STATE(1819),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2579] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(6110),
    [anon_sym_RBRACE] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2580] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_SEMI] = ACTIONS(6114),
    [anon_sym_RBRACE] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2504),
    [anon_sym_STAR_EQ] = ACTIONS(2506),
    [anon_sym_SLASH_EQ] = ACTIONS(2506),
    [anon_sym_PERCENT_EQ] = ACTIONS(2506),
    [anon_sym_PLUS_EQ] = ACTIONS(2506),
    [anon_sym_DASH_EQ] = ACTIONS(2506),
    [anon_sym_LT_LT_EQ] = ACTIONS(2506),
    [anon_sym_GT_GT_EQ] = ACTIONS(2506),
    [anon_sym_AMP_EQ] = ACTIONS(2506),
    [anon_sym_CARET_EQ] = ACTIONS(2506),
    [anon_sym_PIPE_EQ] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2581] = {
    [sym_type_qualifier] = STATE(2582),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2582),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6041),
  },
  [2582] = {
    [sym_type_qualifier] = STATE(2582),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2582),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6534),
  },
  [2583] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_RBRACE] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2584] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_RBRACE] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_STAR_EQ] = ACTIONS(2585),
    [anon_sym_SLASH_EQ] = ACTIONS(2585),
    [anon_sym_PERCENT_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
    [anon_sym_LT_LT_EQ] = ACTIONS(2585),
    [anon_sym_GT_GT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_EQ] = ACTIONS(2585),
    [anon_sym_CARET_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_EQ] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2603),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2585] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2586] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2587] = {
    [sym__abstract_declarator] = STATE(2767),
    [sym_abstract_pointer_declarator] = STATE(2767),
    [sym_abstract_function_declarator] = STATE(2767),
    [sym_abstract_array_declarator] = STATE(2767),
    [sym_parameter_list] = STATE(2590),
    [sym_abstract_reference_declarator] = STATE(2767),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [2588] = {
    [sym__abstract_declarator] = STATE(2768),
    [sym_abstract_pointer_declarator] = STATE(2768),
    [sym_abstract_function_declarator] = STATE(2768),
    [sym_abstract_array_declarator] = STATE(2768),
    [sym_parameter_list] = STATE(2590),
    [sym_abstract_reference_declarator] = STATE(2768),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [2589] = {
    [sym_parameter_list] = STATE(2769),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [2590] = {
    [sym_type_qualifier] = STATE(2770),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2770),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [2591] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2591),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(6537),
    [anon_sym_long] = ACTIONS(6537),
    [anon_sym_short] = ACTIONS(6537),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [2592] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2593] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(6114),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_STAR_EQ] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2728),
    [anon_sym_GT_GT_EQ] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_CARET] = ACTIONS(2738),
    [anon_sym_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_GT] = ACTIONS(2742),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_PERCENT] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2594] = {
    [sym_raw_string_literal] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4958),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4960),
    [anon_sym_DASH_DASH] = ACTIONS(4958),
    [anon_sym_PLUS_PLUS] = ACTIONS(4958),
    [anon_sym_sizeof] = ACTIONS(4960),
    [sym_number_literal] = ACTIONS(4958),
    [sym_char_literal] = ACTIONS(4958),
    [sym_string_literal] = ACTIONS(4958),
    [sym_true] = ACTIONS(4960),
    [sym_false] = ACTIONS(4960),
    [sym_null] = ACTIONS(4960),
    [sym_identifier] = ACTIONS(4960),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_delete] = ACTIONS(4960),
    [sym_nullptr] = ACTIONS(4960),
  },
  [2595] = {
    [sym_raw_string_literal] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_register] = ACTIONS(3882),
    [anon_sym_inline] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3882),
    [anon_sym_volatile] = ACTIONS(3882),
    [anon_sym__Atomic] = ACTIONS(3882),
    [anon_sym_mutable] = ACTIONS(3882),
    [anon_sym_explicit] = ACTIONS(3882),
    [anon_sym_constexpr] = ACTIONS(3882),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_PLUS] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3882),
    [sym_number_literal] = ACTIONS(3880),
    [sym_char_literal] = ACTIONS(3880),
    [sym_string_literal] = ACTIONS(3880),
    [sym_true] = ACTIONS(3882),
    [sym_false] = ACTIONS(3882),
    [sym_null] = ACTIONS(3882),
    [sym_identifier] = ACTIONS(3882),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(3882),
    [anon_sym_new] = ACTIONS(3882),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_delete] = ACTIONS(3882),
    [sym_nullptr] = ACTIONS(3882),
  },
  [2596] = {
    [anon_sym_LPAREN] = ACTIONS(6540),
    [anon_sym_LBRACE] = ACTIONS(6540),
    [sym_comment] = ACTIONS(49),
  },
  [2597] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2597),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_unsigned] = ACTIONS(6542),
    [anon_sym_long] = ACTIONS(6542),
    [anon_sym_short] = ACTIONS(6542),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
  },
  [2598] = {
    [sym_parameter_list] = STATE(1410),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2599] = {
    [sym_parameter_list] = STATE(1410),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [sym_comment] = ACTIONS(49),
  },
  [2600] = {
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RPAREN] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym__Atomic] = ACTIONS(3633),
    [anon_sym_mutable] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_constexpr] = ACTIONS(3633),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3633),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3633),
  },
  [2601] = {
    [sym_enumerator] = STATE(1079),
    [anon_sym_RBRACE] = ACTIONS(6545),
    [sym_identifier] = ACTIONS(364),
    [sym_comment] = ACTIONS(49),
  },
  [2602] = {
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_restrict] = ACTIONS(3774),
    [anon_sym_volatile] = ACTIONS(3774),
    [anon_sym__Atomic] = ACTIONS(3774),
    [anon_sym_mutable] = ACTIONS(3774),
    [anon_sym_explicit] = ACTIONS(3774),
    [anon_sym_constexpr] = ACTIONS(3774),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_GT] = ACTIONS(3774),
    [anon_sym_DASH_GT] = ACTIONS(3774),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3774),
  },
  [2603] = {
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_RPAREN] = ACTIONS(3778),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_restrict] = ACTIONS(3778),
    [anon_sym_volatile] = ACTIONS(3778),
    [anon_sym__Atomic] = ACTIONS(3778),
    [anon_sym_mutable] = ACTIONS(3778),
    [anon_sym_explicit] = ACTIONS(3778),
    [anon_sym_constexpr] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3780),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_DASH_GT] = ACTIONS(3778),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3778),
  },
  [2604] = {
    [anon_sym_LPAREN] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_restrict] = ACTIONS(3880),
    [anon_sym_volatile] = ACTIONS(3880),
    [anon_sym__Atomic] = ACTIONS(3880),
    [anon_sym_mutable] = ACTIONS(3880),
    [anon_sym_explicit] = ACTIONS(3880),
    [anon_sym_constexpr] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_GT] = ACTIONS(3880),
    [anon_sym_DASH_GT] = ACTIONS(3880),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(3880),
    [sym_noexcept] = ACTIONS(3880),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
  },
  [2605] = {
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3889),
    [anon_sym_RPAREN] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_AMP] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_GT] = ACTIONS(3889),
    [anon_sym_DASH_GT] = ACTIONS(3889),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3889),
  },
  [2606] = {
    [anon_sym_LF] = ACTIONS(6547),
    [sym_comment] = ACTIONS(83),
  },
  [2607] = {
    [sym_raw_string_literal] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_switch] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1883),
    [anon_sym_default] = ACTIONS(1883),
    [anon_sym_while] = ACTIONS(1883),
    [anon_sym_do] = ACTIONS(1883),
    [anon_sym_for] = ACTIONS(1883),
    [anon_sym_return] = ACTIONS(1883),
    [anon_sym_break] = ACTIONS(1883),
    [anon_sym_continue] = ACTIONS(1883),
    [anon_sym_goto] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1881),
    [anon_sym_sizeof] = ACTIONS(1883),
    [sym_number_literal] = ACTIONS(1881),
    [sym_char_literal] = ACTIONS(1881),
    [sym_string_literal] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [sym_null] = ACTIONS(1883),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1883),
    [sym_nullptr] = ACTIONS(1883),
  },
  [2608] = {
    [anon_sym_LF] = ACTIONS(6549),
    [sym_comment] = ACTIONS(83),
  },
  [2609] = {
    [sym_raw_string_literal] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5525),
    [anon_sym_LPAREN] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym_LBRACE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_LBRACK] = ACTIONS(5523),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [anon_sym_if] = ACTIONS(5525),
    [anon_sym_switch] = ACTIONS(5525),
    [anon_sym_case] = ACTIONS(5525),
    [anon_sym_default] = ACTIONS(5525),
    [anon_sym_while] = ACTIONS(5525),
    [anon_sym_do] = ACTIONS(5525),
    [anon_sym_for] = ACTIONS(5525),
    [anon_sym_return] = ACTIONS(5525),
    [anon_sym_break] = ACTIONS(5525),
    [anon_sym_continue] = ACTIONS(5525),
    [anon_sym_goto] = ACTIONS(5525),
    [anon_sym_AMP] = ACTIONS(5523),
    [anon_sym_BANG] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_PLUS] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [anon_sym_DASH_DASH] = ACTIONS(5523),
    [anon_sym_PLUS_PLUS] = ACTIONS(5523),
    [anon_sym_sizeof] = ACTIONS(5525),
    [sym_number_literal] = ACTIONS(5523),
    [sym_char_literal] = ACTIONS(5523),
    [sym_string_literal] = ACTIONS(5523),
    [sym_true] = ACTIONS(5525),
    [sym_false] = ACTIONS(5525),
    [sym_null] = ACTIONS(5525),
    [sym_identifier] = ACTIONS(5525),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5525),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_new] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_delete] = ACTIONS(5525),
    [sym_nullptr] = ACTIONS(5525),
  },
  [2610] = {
    [sym_raw_string_literal] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5529),
    [anon_sym_LPAREN] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5527),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [anon_sym_if] = ACTIONS(5529),
    [anon_sym_switch] = ACTIONS(5529),
    [anon_sym_case] = ACTIONS(5529),
    [anon_sym_default] = ACTIONS(5529),
    [anon_sym_while] = ACTIONS(5529),
    [anon_sym_do] = ACTIONS(5529),
    [anon_sym_for] = ACTIONS(5529),
    [anon_sym_return] = ACTIONS(5529),
    [anon_sym_break] = ACTIONS(5529),
    [anon_sym_continue] = ACTIONS(5529),
    [anon_sym_goto] = ACTIONS(5529),
    [anon_sym_AMP] = ACTIONS(5527),
    [anon_sym_BANG] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5529),
    [anon_sym_DASH_DASH] = ACTIONS(5527),
    [anon_sym_PLUS_PLUS] = ACTIONS(5527),
    [anon_sym_sizeof] = ACTIONS(5529),
    [sym_number_literal] = ACTIONS(5527),
    [sym_char_literal] = ACTIONS(5527),
    [sym_string_literal] = ACTIONS(5527),
    [sym_true] = ACTIONS(5529),
    [sym_false] = ACTIONS(5529),
    [sym_null] = ACTIONS(5529),
    [sym_identifier] = ACTIONS(5529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5529),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_new] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_delete] = ACTIONS(5529),
    [sym_nullptr] = ACTIONS(5529),
  },
  [2611] = {
    [sym_raw_string_literal] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym_LBRACE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [anon_sym_if] = ACTIONS(5539),
    [anon_sym_switch] = ACTIONS(5539),
    [anon_sym_case] = ACTIONS(5539),
    [anon_sym_default] = ACTIONS(5539),
    [anon_sym_while] = ACTIONS(5539),
    [anon_sym_do] = ACTIONS(5539),
    [anon_sym_for] = ACTIONS(5539),
    [anon_sym_return] = ACTIONS(5539),
    [anon_sym_break] = ACTIONS(5539),
    [anon_sym_continue] = ACTIONS(5539),
    [anon_sym_goto] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_BANG] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_PLUS] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5539),
    [anon_sym_DASH_DASH] = ACTIONS(5537),
    [anon_sym_PLUS_PLUS] = ACTIONS(5537),
    [anon_sym_sizeof] = ACTIONS(5539),
    [sym_number_literal] = ACTIONS(5537),
    [sym_char_literal] = ACTIONS(5537),
    [sym_string_literal] = ACTIONS(5537),
    [sym_true] = ACTIONS(5539),
    [sym_false] = ACTIONS(5539),
    [sym_null] = ACTIONS(5539),
    [sym_identifier] = ACTIONS(5539),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5539),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_new] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_delete] = ACTIONS(5539),
    [sym_nullptr] = ACTIONS(5539),
  },
  [2612] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6551),
    [sym_comment] = ACTIONS(49),
  },
  [2613] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6553),
    [sym_comment] = ACTIONS(49),
  },
  [2614] = {
    [sym_raw_string_literal] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5618),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [anon_sym_if] = ACTIONS(5618),
    [anon_sym_switch] = ACTIONS(5618),
    [anon_sym_case] = ACTIONS(5618),
    [anon_sym_default] = ACTIONS(5618),
    [anon_sym_while] = ACTIONS(5618),
    [anon_sym_do] = ACTIONS(5618),
    [anon_sym_for] = ACTIONS(5618),
    [anon_sym_return] = ACTIONS(5618),
    [anon_sym_break] = ACTIONS(5618),
    [anon_sym_continue] = ACTIONS(5618),
    [anon_sym_goto] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_BANG] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_sizeof] = ACTIONS(5618),
    [sym_number_literal] = ACTIONS(5616),
    [sym_char_literal] = ACTIONS(5616),
    [sym_string_literal] = ACTIONS(5616),
    [sym_true] = ACTIONS(5618),
    [sym_false] = ACTIONS(5618),
    [sym_null] = ACTIONS(5618),
    [sym_identifier] = ACTIONS(5618),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5618),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_new] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_delete] = ACTIONS(5618),
    [sym_nullptr] = ACTIONS(5618),
  },
  [2615] = {
    [sym_raw_string_literal] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5622),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [anon_sym_if] = ACTIONS(5622),
    [anon_sym_switch] = ACTIONS(5622),
    [anon_sym_case] = ACTIONS(5622),
    [anon_sym_default] = ACTIONS(5622),
    [anon_sym_while] = ACTIONS(5622),
    [anon_sym_do] = ACTIONS(5622),
    [anon_sym_for] = ACTIONS(5622),
    [anon_sym_return] = ACTIONS(5622),
    [anon_sym_break] = ACTIONS(5622),
    [anon_sym_continue] = ACTIONS(5622),
    [anon_sym_goto] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5620),
    [anon_sym_BANG] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_sizeof] = ACTIONS(5622),
    [sym_number_literal] = ACTIONS(5620),
    [sym_char_literal] = ACTIONS(5620),
    [sym_string_literal] = ACTIONS(5620),
    [sym_true] = ACTIONS(5622),
    [sym_false] = ACTIONS(5622),
    [sym_null] = ACTIONS(5622),
    [sym_identifier] = ACTIONS(5622),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5622),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_new] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_delete] = ACTIONS(5622),
    [sym_nullptr] = ACTIONS(5622),
  },
  [2616] = {
    [sym_raw_string_literal] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5626),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5626),
    [anon_sym_switch] = ACTIONS(5626),
    [anon_sym_case] = ACTIONS(5626),
    [anon_sym_default] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5626),
    [anon_sym_do] = ACTIONS(5626),
    [anon_sym_for] = ACTIONS(5626),
    [anon_sym_return] = ACTIONS(5626),
    [anon_sym_break] = ACTIONS(5626),
    [anon_sym_continue] = ACTIONS(5626),
    [anon_sym_goto] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5624),
    [anon_sym_BANG] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_sizeof] = ACTIONS(5626),
    [sym_number_literal] = ACTIONS(5624),
    [sym_char_literal] = ACTIONS(5624),
    [sym_string_literal] = ACTIONS(5624),
    [sym_true] = ACTIONS(5626),
    [sym_false] = ACTIONS(5626),
    [sym_null] = ACTIONS(5626),
    [sym_identifier] = ACTIONS(5626),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5626),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_new] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_delete] = ACTIONS(5626),
    [sym_nullptr] = ACTIONS(5626),
  },
  [2617] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6555),
    [sym_comment] = ACTIONS(49),
  },
  [2618] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6557),
    [sym_comment] = ACTIONS(49),
  },
  [2619] = {
    [sym_raw_string_literal] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [anon_sym_if] = ACTIONS(5634),
    [anon_sym_switch] = ACTIONS(5634),
    [anon_sym_case] = ACTIONS(5634),
    [anon_sym_default] = ACTIONS(5634),
    [anon_sym_while] = ACTIONS(5634),
    [anon_sym_do] = ACTIONS(5634),
    [anon_sym_for] = ACTIONS(5634),
    [anon_sym_return] = ACTIONS(5634),
    [anon_sym_break] = ACTIONS(5634),
    [anon_sym_continue] = ACTIONS(5634),
    [anon_sym_goto] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_BANG] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_sizeof] = ACTIONS(5634),
    [sym_number_literal] = ACTIONS(5632),
    [sym_char_literal] = ACTIONS(5632),
    [sym_string_literal] = ACTIONS(5632),
    [sym_true] = ACTIONS(5634),
    [sym_false] = ACTIONS(5634),
    [sym_null] = ACTIONS(5634),
    [sym_identifier] = ACTIONS(5634),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5634),
    [sym_auto] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_delete] = ACTIONS(5634),
    [sym_nullptr] = ACTIONS(5634),
  },
  [2620] = {
    [sym_raw_string_literal] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5638),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [anon_sym_if] = ACTIONS(5638),
    [anon_sym_switch] = ACTIONS(5638),
    [anon_sym_case] = ACTIONS(5638),
    [anon_sym_default] = ACTIONS(5638),
    [anon_sym_while] = ACTIONS(5638),
    [anon_sym_do] = ACTIONS(5638),
    [anon_sym_for] = ACTIONS(5638),
    [anon_sym_return] = ACTIONS(5638),
    [anon_sym_break] = ACTIONS(5638),
    [anon_sym_continue] = ACTIONS(5638),
    [anon_sym_goto] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5636),
    [anon_sym_BANG] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_sizeof] = ACTIONS(5638),
    [sym_number_literal] = ACTIONS(5636),
    [sym_char_literal] = ACTIONS(5636),
    [sym_string_literal] = ACTIONS(5636),
    [sym_true] = ACTIONS(5638),
    [sym_false] = ACTIONS(5638),
    [sym_null] = ACTIONS(5638),
    [sym_identifier] = ACTIONS(5638),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5638),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_new] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_delete] = ACTIONS(5638),
    [sym_nullptr] = ACTIONS(5638),
  },
  [2621] = {
    [sym_raw_string_literal] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5642),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [anon_sym_if] = ACTIONS(5642),
    [anon_sym_switch] = ACTIONS(5642),
    [anon_sym_case] = ACTIONS(5642),
    [anon_sym_default] = ACTIONS(5642),
    [anon_sym_while] = ACTIONS(5642),
    [anon_sym_do] = ACTIONS(5642),
    [anon_sym_for] = ACTIONS(5642),
    [anon_sym_return] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(5642),
    [anon_sym_continue] = ACTIONS(5642),
    [anon_sym_goto] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_BANG] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_sizeof] = ACTIONS(5642),
    [sym_number_literal] = ACTIONS(5640),
    [sym_char_literal] = ACTIONS(5640),
    [sym_string_literal] = ACTIONS(5640),
    [sym_true] = ACTIONS(5642),
    [sym_false] = ACTIONS(5642),
    [sym_null] = ACTIONS(5642),
    [sym_identifier] = ACTIONS(5642),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5642),
    [sym_auto] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_new] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_delete] = ACTIONS(5642),
    [sym_nullptr] = ACTIONS(5642),
  },
  [2622] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6559),
    [sym_comment] = ACTIONS(49),
  },
  [2623] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6561),
    [sym_comment] = ACTIONS(49),
  },
  [2624] = {
    [sym_preproc_arg] = ACTIONS(6563),
    [sym_comment] = ACTIONS(83),
  },
  [2625] = {
    [sym_raw_string_literal] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(859),
    [sym_preproc_directive] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_typedef] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_register] = ACTIONS(859),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_restrict] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym__Atomic] = ACTIONS(859),
    [anon_sym_mutable] = ACTIONS(859),
    [anon_sym_explicit] = ACTIONS(859),
    [anon_sym_constexpr] = ACTIONS(859),
    [anon_sym_unsigned] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [sym_primitive_type] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_sizeof] = ACTIONS(859),
    [sym_number_literal] = ACTIONS(857),
    [sym_char_literal] = ACTIONS(857),
    [sym_string_literal] = ACTIONS(857),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [sym_identifier] = ACTIONS(859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(859),
    [sym_auto] = ACTIONS(859),
    [anon_sym_typename] = ACTIONS(859),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(857),
    [anon_sym_delete] = ACTIONS(859),
    [sym_nullptr] = ACTIONS(859),
  },
  [2626] = {
    [anon_sym_LF] = ACTIONS(6565),
    [sym_preproc_arg] = ACTIONS(6567),
    [sym_comment] = ACTIONS(83),
  },
  [2627] = {
    [sym_raw_string_literal] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4509),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4509),
    [sym_preproc_directive] = ACTIONS(4509),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_typedef] = ACTIONS(4509),
    [anon_sym_extern] = ACTIONS(4509),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(4507),
    [anon_sym_static] = ACTIONS(4509),
    [anon_sym_register] = ACTIONS(4509),
    [anon_sym_inline] = ACTIONS(4509),
    [anon_sym_const] = ACTIONS(4509),
    [anon_sym_restrict] = ACTIONS(4509),
    [anon_sym_volatile] = ACTIONS(4509),
    [anon_sym__Atomic] = ACTIONS(4509),
    [anon_sym_mutable] = ACTIONS(4509),
    [anon_sym_explicit] = ACTIONS(4509),
    [anon_sym_constexpr] = ACTIONS(4509),
    [anon_sym_unsigned] = ACTIONS(4509),
    [anon_sym_long] = ACTIONS(4509),
    [anon_sym_short] = ACTIONS(4509),
    [sym_primitive_type] = ACTIONS(4509),
    [anon_sym_enum] = ACTIONS(4509),
    [anon_sym_struct] = ACTIONS(4509),
    [anon_sym_union] = ACTIONS(4509),
    [anon_sym_if] = ACTIONS(4509),
    [anon_sym_switch] = ACTIONS(4509),
    [anon_sym_case] = ACTIONS(4509),
    [anon_sym_default] = ACTIONS(4509),
    [anon_sym_while] = ACTIONS(4509),
    [anon_sym_do] = ACTIONS(4509),
    [anon_sym_for] = ACTIONS(4509),
    [anon_sym_return] = ACTIONS(4509),
    [anon_sym_break] = ACTIONS(4509),
    [anon_sym_continue] = ACTIONS(4509),
    [anon_sym_goto] = ACTIONS(4509),
    [anon_sym_AMP] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_PLUS] = ACTIONS(4509),
    [anon_sym_DASH] = ACTIONS(4509),
    [anon_sym_DASH_DASH] = ACTIONS(4507),
    [anon_sym_PLUS_PLUS] = ACTIONS(4507),
    [anon_sym_sizeof] = ACTIONS(4509),
    [sym_number_literal] = ACTIONS(4507),
    [sym_char_literal] = ACTIONS(4507),
    [sym_string_literal] = ACTIONS(4507),
    [sym_true] = ACTIONS(4509),
    [sym_false] = ACTIONS(4509),
    [sym_null] = ACTIONS(4509),
    [sym_identifier] = ACTIONS(4509),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4509),
    [sym_auto] = ACTIONS(4509),
    [anon_sym_typename] = ACTIONS(4509),
    [anon_sym_new] = ACTIONS(4509),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_delete] = ACTIONS(4509),
    [sym_nullptr] = ACTIONS(4509),
  },
  [2628] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6569),
    [sym_comment] = ACTIONS(49),
  },
  [2629] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6571),
    [sym_comment] = ACTIONS(49),
  },
  [2630] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2786),
    [sym_preproc_elif_in_compound_statement] = STATE(2787),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2631] = {
    [sym_raw_string_literal] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4617),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4617),
    [sym_preproc_directive] = ACTIONS(4617),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_typedef] = ACTIONS(4617),
    [anon_sym_extern] = ACTIONS(4617),
    [anon_sym_LBRACE] = ACTIONS(4615),
    [anon_sym_STAR] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_static] = ACTIONS(4617),
    [anon_sym_register] = ACTIONS(4617),
    [anon_sym_inline] = ACTIONS(4617),
    [anon_sym_const] = ACTIONS(4617),
    [anon_sym_restrict] = ACTIONS(4617),
    [anon_sym_volatile] = ACTIONS(4617),
    [anon_sym__Atomic] = ACTIONS(4617),
    [anon_sym_mutable] = ACTIONS(4617),
    [anon_sym_explicit] = ACTIONS(4617),
    [anon_sym_constexpr] = ACTIONS(4617),
    [anon_sym_unsigned] = ACTIONS(4617),
    [anon_sym_long] = ACTIONS(4617),
    [anon_sym_short] = ACTIONS(4617),
    [sym_primitive_type] = ACTIONS(4617),
    [anon_sym_enum] = ACTIONS(4617),
    [anon_sym_struct] = ACTIONS(4617),
    [anon_sym_union] = ACTIONS(4617),
    [anon_sym_if] = ACTIONS(4617),
    [anon_sym_switch] = ACTIONS(4617),
    [anon_sym_case] = ACTIONS(4617),
    [anon_sym_default] = ACTIONS(4617),
    [anon_sym_while] = ACTIONS(4617),
    [anon_sym_do] = ACTIONS(4617),
    [anon_sym_for] = ACTIONS(4617),
    [anon_sym_return] = ACTIONS(4617),
    [anon_sym_break] = ACTIONS(4617),
    [anon_sym_continue] = ACTIONS(4617),
    [anon_sym_goto] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4615),
    [anon_sym_BANG] = ACTIONS(4615),
    [anon_sym_TILDE] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_sizeof] = ACTIONS(4617),
    [sym_number_literal] = ACTIONS(4615),
    [sym_char_literal] = ACTIONS(4615),
    [sym_string_literal] = ACTIONS(4615),
    [sym_true] = ACTIONS(4617),
    [sym_false] = ACTIONS(4617),
    [sym_null] = ACTIONS(4617),
    [sym_identifier] = ACTIONS(4617),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4617),
    [sym_auto] = ACTIONS(4617),
    [anon_sym_typename] = ACTIONS(4617),
    [anon_sym_new] = ACTIONS(4617),
    [anon_sym_COLON_COLON] = ACTIONS(4615),
    [anon_sym_delete] = ACTIONS(4617),
    [sym_nullptr] = ACTIONS(4617),
  },
  [2632] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6575),
    [sym_comment] = ACTIONS(49),
  },
  [2633] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6577),
    [sym_comment] = ACTIONS(49),
  },
  [2634] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2791),
    [sym_preproc_elif_in_compound_statement] = STATE(2792),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6579),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2635] = {
    [sym_raw_string_literal] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4627),
    [anon_sym_LPAREN] = ACTIONS(4625),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4627),
    [sym_preproc_directive] = ACTIONS(4627),
    [anon_sym_SEMI] = ACTIONS(4625),
    [anon_sym_typedef] = ACTIONS(4627),
    [anon_sym_extern] = ACTIONS(4627),
    [anon_sym_LBRACE] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4625),
    [anon_sym_static] = ACTIONS(4627),
    [anon_sym_register] = ACTIONS(4627),
    [anon_sym_inline] = ACTIONS(4627),
    [anon_sym_const] = ACTIONS(4627),
    [anon_sym_restrict] = ACTIONS(4627),
    [anon_sym_volatile] = ACTIONS(4627),
    [anon_sym__Atomic] = ACTIONS(4627),
    [anon_sym_mutable] = ACTIONS(4627),
    [anon_sym_explicit] = ACTIONS(4627),
    [anon_sym_constexpr] = ACTIONS(4627),
    [anon_sym_unsigned] = ACTIONS(4627),
    [anon_sym_long] = ACTIONS(4627),
    [anon_sym_short] = ACTIONS(4627),
    [sym_primitive_type] = ACTIONS(4627),
    [anon_sym_enum] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_union] = ACTIONS(4627),
    [anon_sym_if] = ACTIONS(4627),
    [anon_sym_switch] = ACTIONS(4627),
    [anon_sym_case] = ACTIONS(4627),
    [anon_sym_default] = ACTIONS(4627),
    [anon_sym_while] = ACTIONS(4627),
    [anon_sym_do] = ACTIONS(4627),
    [anon_sym_for] = ACTIONS(4627),
    [anon_sym_return] = ACTIONS(4627),
    [anon_sym_break] = ACTIONS(4627),
    [anon_sym_continue] = ACTIONS(4627),
    [anon_sym_goto] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_DASH_DASH] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4625),
    [anon_sym_sizeof] = ACTIONS(4627),
    [sym_number_literal] = ACTIONS(4625),
    [sym_char_literal] = ACTIONS(4625),
    [sym_string_literal] = ACTIONS(4625),
    [sym_true] = ACTIONS(4627),
    [sym_false] = ACTIONS(4627),
    [sym_null] = ACTIONS(4627),
    [sym_identifier] = ACTIONS(4627),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4627),
    [sym_auto] = ACTIONS(4627),
    [anon_sym_typename] = ACTIONS(4627),
    [anon_sym_new] = ACTIONS(4627),
    [anon_sym_COLON_COLON] = ACTIONS(4625),
    [anon_sym_delete] = ACTIONS(4627),
    [sym_nullptr] = ACTIONS(4627),
  },
  [2636] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6581),
    [sym_comment] = ACTIONS(49),
  },
  [2637] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6583),
    [sym_comment] = ACTIONS(49),
  },
  [2638] = {
    [sym_preproc_include] = STATE(2065),
    [sym_preproc_def] = STATE(2065),
    [sym_preproc_function_def] = STATE(2065),
    [sym_preproc_call] = STATE(2065),
    [sym_preproc_if_in_compound_statement] = STATE(1480),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1481),
    [sym_preproc_else_in_compound_statement] = STATE(2796),
    [sym_preproc_elif_in_compound_statement] = STATE(2797),
    [sym_declaration] = STATE(2065),
    [sym_type_definition] = STATE(2065),
    [sym__declaration_specifiers] = STATE(1484),
    [sym_compound_statement] = STATE(2065),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2065),
    [sym_expression_statement] = STATE(2065),
    [sym_if_statement] = STATE(2065),
    [sym_switch_statement] = STATE(2065),
    [sym_case_statement] = STATE(2065),
    [sym_while_statement] = STATE(2065),
    [sym_do_statement] = STATE(2065),
    [sym_for_statement] = STATE(2065),
    [sym_return_statement] = STATE(2065),
    [sym_break_statement] = STATE(2065),
    [sym_continue_statement] = STATE(2065),
    [sym_goto_statement] = STATE(2065),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym__empty_declaration] = STATE(2065),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2065),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2065),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2065),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(2971),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2973),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2977),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2981),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2983),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2985),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2987),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2639] = {
    [anon_sym_LF] = ACTIONS(6587),
    [sym_comment] = ACTIONS(83),
  },
  [2640] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(6589),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2641] = {
    [sym__type_declarator] = STATE(2800),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2642] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [2643] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6591),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2644] = {
    [sym__expression] = STATE(2802),
    [sym_conditional_expression] = STATE(2802),
    [sym_assignment_expression] = STATE(2802),
    [sym_pointer_expression] = STATE(2802),
    [sym_logical_expression] = STATE(2802),
    [sym_bitwise_expression] = STATE(2802),
    [sym_equality_expression] = STATE(2802),
    [sym_relational_expression] = STATE(2802),
    [sym_shift_expression] = STATE(2802),
    [sym_math_expression] = STATE(2802),
    [sym_cast_expression] = STATE(2802),
    [sym_sizeof_expression] = STATE(2802),
    [sym_subscript_expression] = STATE(2802),
    [sym_call_expression] = STATE(2802),
    [sym_field_expression] = STATE(2802),
    [sym_compound_literal_expression] = STATE(2802),
    [sym_parenthesized_expression] = STATE(2802),
    [sym_concatenated_string] = STATE(2802),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2802),
    [sym_new_expression] = STATE(2802),
    [sym_delete_expression] = STATE(2802),
    [sym_lambda_expression] = STATE(2802),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6593),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6593),
    [sym_char_literal] = ACTIONS(6593),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6595),
    [sym_false] = ACTIONS(6595),
    [sym_null] = ACTIONS(6595),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6595),
  },
  [2645] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6597),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2646] = {
    [sym_declaration] = STATE(2804),
    [sym_type_definition] = STATE(2804),
    [sym__declaration_specifiers] = STATE(2649),
    [sym_compound_statement] = STATE(2804),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2804),
    [sym_expression_statement] = STATE(2804),
    [sym_if_statement] = STATE(2804),
    [sym_switch_statement] = STATE(2804),
    [sym_case_statement] = STATE(2804),
    [sym_while_statement] = STATE(2804),
    [sym_do_statement] = STATE(2804),
    [sym_for_statement] = STATE(2804),
    [sym_return_statement] = STATE(2804),
    [sym_break_statement] = STATE(2804),
    [sym_continue_statement] = STATE(2804),
    [sym_goto_statement] = STATE(2804),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2804),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_typedef] = ACTIONS(4533),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2647] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(5473),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [2648] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [2649] = {
    [sym__declarator] = STATE(2406),
    [sym_pointer_declarator] = STATE(2406),
    [sym_function_declarator] = STATE(2406),
    [sym_array_declarator] = STATE(2406),
    [sym_init_declarator] = STATE(2407),
    [sym_reference_declarator] = STATE(2406),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2406),
    [sym_destructor_name] = STATE(2406),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(5477),
  },
  [2650] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2651] = {
    [anon_sym_LPAREN] = ACTIONS(6601),
    [sym_comment] = ACTIONS(49),
  },
  [2652] = {
    [sym__expression] = STATE(2808),
    [sym_conditional_expression] = STATE(2808),
    [sym_assignment_expression] = STATE(2808),
    [sym_pointer_expression] = STATE(2808),
    [sym_logical_expression] = STATE(2808),
    [sym_bitwise_expression] = STATE(2808),
    [sym_equality_expression] = STATE(2808),
    [sym_relational_expression] = STATE(2808),
    [sym_shift_expression] = STATE(2808),
    [sym_math_expression] = STATE(2808),
    [sym_cast_expression] = STATE(2808),
    [sym_sizeof_expression] = STATE(2808),
    [sym_subscript_expression] = STATE(2808),
    [sym_call_expression] = STATE(2808),
    [sym_field_expression] = STATE(2808),
    [sym_compound_literal_expression] = STATE(2808),
    [sym_parenthesized_expression] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2808),
    [sym_new_expression] = STATE(2808),
    [sym_delete_expression] = STATE(2808),
    [sym_lambda_expression] = STATE(2808),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6603),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6605),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6603),
    [sym_char_literal] = ACTIONS(6603),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6607),
    [sym_false] = ACTIONS(6607),
    [sym_null] = ACTIONS(6607),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6607),
  },
  [2653] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6609),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2654] = {
    [anon_sym_COLON] = ACTIONS(6611),
    [sym_comment] = ACTIONS(49),
  },
  [2655] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [2656] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [2657] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(5473),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2658] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [2659] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [2660] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6613),
    [sym_comment] = ACTIONS(49),
  },
  [2661] = {
    [sym__expression] = STATE(2812),
    [sym_conditional_expression] = STATE(2812),
    [sym_assignment_expression] = STATE(2812),
    [sym_pointer_expression] = STATE(2812),
    [sym_logical_expression] = STATE(2812),
    [sym_bitwise_expression] = STATE(2812),
    [sym_equality_expression] = STATE(2812),
    [sym_relational_expression] = STATE(2812),
    [sym_shift_expression] = STATE(2812),
    [sym_math_expression] = STATE(2812),
    [sym_cast_expression] = STATE(2812),
    [sym_sizeof_expression] = STATE(2812),
    [sym_subscript_expression] = STATE(2812),
    [sym_call_expression] = STATE(2812),
    [sym_field_expression] = STATE(2812),
    [sym_compound_literal_expression] = STATE(2812),
    [sym_parenthesized_expression] = STATE(2812),
    [sym_initializer_list] = STATE(2813),
    [sym_concatenated_string] = STATE(2812),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2812),
    [sym_new_expression] = STATE(2812),
    [sym_delete_expression] = STATE(2812),
    [sym_lambda_expression] = STATE(2812),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6615),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6615),
    [sym_char_literal] = ACTIONS(6615),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6617),
    [sym_false] = ACTIONS(6617),
    [sym_null] = ACTIONS(6617),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6617),
  },
  [2662] = {
    [anon_sym_SEMI] = ACTIONS(6619),
    [sym_comment] = ACTIONS(49),
  },
  [2663] = {
    [sym__expression] = STATE(2815),
    [sym_conditional_expression] = STATE(2815),
    [sym_assignment_expression] = STATE(2815),
    [sym_pointer_expression] = STATE(2815),
    [sym_logical_expression] = STATE(2815),
    [sym_bitwise_expression] = STATE(2815),
    [sym_equality_expression] = STATE(2815),
    [sym_relational_expression] = STATE(2815),
    [sym_shift_expression] = STATE(2815),
    [sym_math_expression] = STATE(2815),
    [sym_cast_expression] = STATE(2815),
    [sym_sizeof_expression] = STATE(2815),
    [sym_subscript_expression] = STATE(2815),
    [sym_call_expression] = STATE(2815),
    [sym_field_expression] = STATE(2815),
    [sym_compound_literal_expression] = STATE(2815),
    [sym_parenthesized_expression] = STATE(2815),
    [sym_initializer_list] = STATE(2816),
    [sym_concatenated_string] = STATE(2815),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2815),
    [sym_new_expression] = STATE(2815),
    [sym_delete_expression] = STATE(2815),
    [sym_lambda_expression] = STATE(2815),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6621),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6621),
    [sym_char_literal] = ACTIONS(6621),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6623),
    [sym_false] = ACTIONS(6623),
    [sym_null] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6623),
  },
  [2664] = {
    [anon_sym_SEMI] = ACTIONS(6625),
    [sym_comment] = ACTIONS(49),
  },
  [2665] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6627),
    [sym_comment] = ACTIONS(49),
  },
  [2666] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6629),
    [sym_comment] = ACTIONS(49),
  },
  [2667] = {
    [sym_raw_string_literal] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2030),
    [sym_char_literal] = ACTIONS(2030),
    [sym_string_literal] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_delete] = ACTIONS(2032),
    [sym_nullptr] = ACTIONS(2032),
  },
  [2668] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [2669] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(6631),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2670] = {
    [sym_compound_statement] = STATE(2833),
    [sym_labeled_statement] = STATE(2833),
    [sym_expression_statement] = STATE(2833),
    [sym_if_statement] = STATE(2833),
    [sym_switch_statement] = STATE(2833),
    [sym_case_statement] = STATE(2833),
    [sym_while_statement] = STATE(2833),
    [sym_do_statement] = STATE(2833),
    [sym_for_statement] = STATE(2833),
    [sym_return_statement] = STATE(2833),
    [sym_break_statement] = STATE(2833),
    [sym_continue_statement] = STATE(2833),
    [sym_goto_statement] = STATE(2833),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(2833),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [2671] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6665),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2672] = {
    [sym_compound_statement] = STATE(2837),
    [sym_labeled_statement] = STATE(2837),
    [sym_expression_statement] = STATE(2837),
    [sym_if_statement] = STATE(2837),
    [sym_switch_statement] = STATE(2837),
    [sym_case_statement] = STATE(2837),
    [sym_while_statement] = STATE(2837),
    [sym_do_statement] = STATE(2837),
    [sym_for_statement] = STATE(2837),
    [sym_return_statement] = STATE(2837),
    [sym_break_statement] = STATE(2837),
    [sym_continue_statement] = STATE(2837),
    [sym_goto_statement] = STATE(2837),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2837),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2673] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [2674] = {
    [sym_compound_statement] = STATE(2838),
    [sym_labeled_statement] = STATE(2838),
    [sym_expression_statement] = STATE(2838),
    [sym_if_statement] = STATE(2838),
    [sym_switch_statement] = STATE(2838),
    [sym_case_statement] = STATE(2838),
    [sym_while_statement] = STATE(2838),
    [sym_do_statement] = STATE(2838),
    [sym_for_statement] = STATE(2838),
    [sym_return_statement] = STATE(2838),
    [sym_break_statement] = STATE(2838),
    [sym_continue_statement] = STATE(2838),
    [sym_goto_statement] = STATE(2838),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2838),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2675] = {
    [sym__expression] = STATE(2839),
    [sym_conditional_expression] = STATE(2839),
    [sym_assignment_expression] = STATE(2839),
    [sym_pointer_expression] = STATE(2839),
    [sym_logical_expression] = STATE(2839),
    [sym_bitwise_expression] = STATE(2839),
    [sym_equality_expression] = STATE(2839),
    [sym_relational_expression] = STATE(2839),
    [sym_shift_expression] = STATE(2839),
    [sym_math_expression] = STATE(2839),
    [sym_cast_expression] = STATE(2839),
    [sym_sizeof_expression] = STATE(2839),
    [sym_subscript_expression] = STATE(2839),
    [sym_call_expression] = STATE(2839),
    [sym_field_expression] = STATE(2839),
    [sym_compound_literal_expression] = STATE(2839),
    [sym_parenthesized_expression] = STATE(2839),
    [sym_concatenated_string] = STATE(2839),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2839),
    [sym_new_expression] = STATE(2839),
    [sym_delete_expression] = STATE(2839),
    [sym_lambda_expression] = STATE(2839),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6667),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6667),
    [sym_char_literal] = ACTIONS(6667),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6669),
    [sym_false] = ACTIONS(6669),
    [sym_null] = ACTIONS(6669),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6669),
  },
  [2676] = {
    [sym__expression] = STATE(2841),
    [sym_conditional_expression] = STATE(2841),
    [sym_assignment_expression] = STATE(2841),
    [sym_pointer_expression] = STATE(2841),
    [sym_logical_expression] = STATE(2841),
    [sym_bitwise_expression] = STATE(2841),
    [sym_equality_expression] = STATE(2841),
    [sym_relational_expression] = STATE(2841),
    [sym_shift_expression] = STATE(2841),
    [sym_math_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_sizeof_expression] = STATE(2841),
    [sym_subscript_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_field_expression] = STATE(2841),
    [sym_compound_literal_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_concatenated_string] = STATE(2841),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2841),
    [sym_new_expression] = STATE(2841),
    [sym_delete_expression] = STATE(2841),
    [sym_lambda_expression] = STATE(2841),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6671),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6673),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6671),
    [sym_char_literal] = ACTIONS(6671),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6675),
    [sym_false] = ACTIONS(6675),
    [sym_null] = ACTIONS(6675),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6675),
  },
  [2677] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6677),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2678] = {
    [sym__expression] = STATE(2843),
    [sym_conditional_expression] = STATE(2843),
    [sym_assignment_expression] = STATE(2843),
    [sym_pointer_expression] = STATE(2843),
    [sym_logical_expression] = STATE(2843),
    [sym_bitwise_expression] = STATE(2843),
    [sym_equality_expression] = STATE(2843),
    [sym_relational_expression] = STATE(2843),
    [sym_shift_expression] = STATE(2843),
    [sym_math_expression] = STATE(2843),
    [sym_cast_expression] = STATE(2843),
    [sym_sizeof_expression] = STATE(2843),
    [sym_subscript_expression] = STATE(2843),
    [sym_call_expression] = STATE(2843),
    [sym_field_expression] = STATE(2843),
    [sym_compound_literal_expression] = STATE(2843),
    [sym_parenthesized_expression] = STATE(2843),
    [sym_concatenated_string] = STATE(2843),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2843),
    [sym_new_expression] = STATE(2843),
    [sym_delete_expression] = STATE(2843),
    [sym_lambda_expression] = STATE(2843),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6679),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6677),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6679),
    [sym_char_literal] = ACTIONS(6679),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6681),
    [sym_false] = ACTIONS(6681),
    [sym_null] = ACTIONS(6681),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6681),
  },
  [2679] = {
    [sym__expression] = STATE(2844),
    [sym_conditional_expression] = STATE(2844),
    [sym_assignment_expression] = STATE(2844),
    [sym_pointer_expression] = STATE(2844),
    [sym_logical_expression] = STATE(2844),
    [sym_bitwise_expression] = STATE(2844),
    [sym_equality_expression] = STATE(2844),
    [sym_relational_expression] = STATE(2844),
    [sym_shift_expression] = STATE(2844),
    [sym_math_expression] = STATE(2844),
    [sym_cast_expression] = STATE(2844),
    [sym_sizeof_expression] = STATE(2844),
    [sym_subscript_expression] = STATE(2844),
    [sym_call_expression] = STATE(2844),
    [sym_field_expression] = STATE(2844),
    [sym_compound_literal_expression] = STATE(2844),
    [sym_parenthesized_expression] = STATE(2844),
    [sym_concatenated_string] = STATE(2844),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2844),
    [sym_new_expression] = STATE(2844),
    [sym_delete_expression] = STATE(2844),
    [sym_lambda_expression] = STATE(2844),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6683),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6683),
    [sym_char_literal] = ACTIONS(6683),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6685),
    [sym_false] = ACTIONS(6685),
    [sym_null] = ACTIONS(6685),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6685),
  },
  [2680] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [2681] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6687),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2682] = {
    [anon_sym_SEMI] = ACTIONS(6687),
    [sym_comment] = ACTIONS(49),
  },
  [2683] = {
    [sym_raw_string_literal] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2653),
    [sym_char_literal] = ACTIONS(2653),
    [sym_string_literal] = ACTIONS(2653),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_null] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2655),
    [sym_nullptr] = ACTIONS(2655),
  },
  [2684] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6689),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2685] = {
    [anon_sym_SEMI] = ACTIONS(6689),
    [sym_comment] = ACTIONS(49),
  },
  [2686] = {
    [sym_raw_string_literal] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [sym_string_literal] = ACTIONS(2659),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2661),
    [sym_nullptr] = ACTIONS(2661),
  },
  [2687] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(6691),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6691),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6693),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2688] = {
    [sym__expression] = STATE(2847),
    [sym_conditional_expression] = STATE(2847),
    [sym_assignment_expression] = STATE(2847),
    [sym_pointer_expression] = STATE(2847),
    [sym_logical_expression] = STATE(2847),
    [sym_bitwise_expression] = STATE(2847),
    [sym_equality_expression] = STATE(2847),
    [sym_relational_expression] = STATE(2847),
    [sym_shift_expression] = STATE(2847),
    [sym_math_expression] = STATE(2847),
    [sym_cast_expression] = STATE(2847),
    [sym_sizeof_expression] = STATE(2847),
    [sym_subscript_expression] = STATE(2847),
    [sym_call_expression] = STATE(2847),
    [sym_field_expression] = STATE(2847),
    [sym_compound_literal_expression] = STATE(2847),
    [sym_parenthesized_expression] = STATE(2847),
    [sym_concatenated_string] = STATE(2847),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2847),
    [sym_new_expression] = STATE(2847),
    [sym_delete_expression] = STATE(2847),
    [sym_lambda_expression] = STATE(2847),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6695),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6695),
    [sym_char_literal] = ACTIONS(6695),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6697),
    [sym_false] = ACTIONS(6697),
    [sym_null] = ACTIONS(6697),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6697),
  },
  [2689] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2690] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [2691] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(6699),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2692] = {
    [sym__expression] = STATE(2849),
    [sym_conditional_expression] = STATE(2849),
    [sym_assignment_expression] = STATE(2849),
    [sym_pointer_expression] = STATE(2849),
    [sym_logical_expression] = STATE(2849),
    [sym_bitwise_expression] = STATE(2849),
    [sym_equality_expression] = STATE(2849),
    [sym_relational_expression] = STATE(2849),
    [sym_shift_expression] = STATE(2849),
    [sym_math_expression] = STATE(2849),
    [sym_cast_expression] = STATE(2849),
    [sym_sizeof_expression] = STATE(2849),
    [sym_subscript_expression] = STATE(2849),
    [sym_call_expression] = STATE(2849),
    [sym_field_expression] = STATE(2849),
    [sym_compound_literal_expression] = STATE(2849),
    [sym_parenthesized_expression] = STATE(2849),
    [sym_concatenated_string] = STATE(2849),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2849),
    [sym_new_expression] = STATE(2849),
    [sym_delete_expression] = STATE(2849),
    [sym_lambda_expression] = STATE(2849),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6701),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6701),
    [sym_char_literal] = ACTIONS(6701),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6703),
    [sym_false] = ACTIONS(6703),
    [sym_null] = ACTIONS(6703),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6703),
  },
  [2693] = {
    [anon_sym_LPAREN] = ACTIONS(6705),
    [sym_comment] = ACTIONS(49),
  },
  [2694] = {
    [sym__expression] = STATE(2851),
    [sym_conditional_expression] = STATE(2851),
    [sym_assignment_expression] = STATE(2851),
    [sym_pointer_expression] = STATE(2851),
    [sym_logical_expression] = STATE(2851),
    [sym_bitwise_expression] = STATE(2851),
    [sym_equality_expression] = STATE(2851),
    [sym_relational_expression] = STATE(2851),
    [sym_shift_expression] = STATE(2851),
    [sym_math_expression] = STATE(2851),
    [sym_cast_expression] = STATE(2851),
    [sym_sizeof_expression] = STATE(2851),
    [sym_subscript_expression] = STATE(2851),
    [sym_call_expression] = STATE(2851),
    [sym_field_expression] = STATE(2851),
    [sym_compound_literal_expression] = STATE(2851),
    [sym_parenthesized_expression] = STATE(2851),
    [sym_concatenated_string] = STATE(2851),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2851),
    [sym_new_expression] = STATE(2851),
    [sym_delete_expression] = STATE(2851),
    [sym_lambda_expression] = STATE(2851),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6707),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6707),
    [sym_char_literal] = ACTIONS(6707),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6709),
    [sym_false] = ACTIONS(6709),
    [sym_null] = ACTIONS(6709),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6709),
  },
  [2695] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(6711),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2696] = {
    [sym_declaration] = STATE(2855),
    [sym_type_definition] = STATE(2855),
    [sym__declaration_specifiers] = STATE(2856),
    [sym_compound_statement] = STATE(2855),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2855),
    [sym_expression_statement] = STATE(2855),
    [sym_if_statement] = STATE(2855),
    [sym_switch_statement] = STATE(2855),
    [sym_case_statement] = STATE(2855),
    [sym_while_statement] = STATE(2855),
    [sym_do_statement] = STATE(2855),
    [sym_for_statement] = STATE(2855),
    [sym_return_statement] = STATE(2855),
    [sym_break_statement] = STATE(2855),
    [sym_continue_statement] = STATE(2855),
    [sym_goto_statement] = STATE(2855),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(2855),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_typedef] = ACTIONS(6713),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(6715),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2697] = {
    [sym__expression] = STATE(2857),
    [sym_conditional_expression] = STATE(2857),
    [sym_assignment_expression] = STATE(2857),
    [sym_pointer_expression] = STATE(2857),
    [sym_logical_expression] = STATE(2857),
    [sym_bitwise_expression] = STATE(2857),
    [sym_equality_expression] = STATE(2857),
    [sym_relational_expression] = STATE(2857),
    [sym_shift_expression] = STATE(2857),
    [sym_math_expression] = STATE(2857),
    [sym_cast_expression] = STATE(2857),
    [sym_sizeof_expression] = STATE(2857),
    [sym_subscript_expression] = STATE(2857),
    [sym_call_expression] = STATE(2857),
    [sym_field_expression] = STATE(2857),
    [sym_compound_literal_expression] = STATE(2857),
    [sym_parenthesized_expression] = STATE(2857),
    [sym_concatenated_string] = STATE(2857),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2857),
    [sym_new_expression] = STATE(2857),
    [sym_delete_expression] = STATE(2857),
    [sym_lambda_expression] = STATE(2857),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6717),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6717),
    [sym_char_literal] = ACTIONS(6717),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6719),
    [sym_false] = ACTIONS(6719),
    [sym_null] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6719),
  },
  [2698] = {
    [anon_sym_while] = ACTIONS(6721),
    [sym_comment] = ACTIONS(49),
  },
  [2699] = {
    [sym_declaration] = STATE(2859),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(2860),
    [sym_conditional_expression] = STATE(2860),
    [sym_assignment_expression] = STATE(2860),
    [sym_pointer_expression] = STATE(2860),
    [sym_logical_expression] = STATE(2860),
    [sym_bitwise_expression] = STATE(2860),
    [sym_equality_expression] = STATE(2860),
    [sym_relational_expression] = STATE(2860),
    [sym_shift_expression] = STATE(2860),
    [sym_math_expression] = STATE(2860),
    [sym_cast_expression] = STATE(2860),
    [sym_sizeof_expression] = STATE(2860),
    [sym_subscript_expression] = STATE(2860),
    [sym_call_expression] = STATE(2860),
    [sym_field_expression] = STATE(2860),
    [sym_compound_literal_expression] = STATE(2860),
    [sym_parenthesized_expression] = STATE(2860),
    [sym_concatenated_string] = STATE(2860),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2860),
    [sym_for_range_declaration] = STATE(2861),
    [sym_new_expression] = STATE(2860),
    [sym_delete_expression] = STATE(2860),
    [sym_lambda_expression] = STATE(2860),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6723),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6725),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6723),
    [sym_char_literal] = ACTIONS(6723),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6727),
    [sym_false] = ACTIONS(6727),
    [sym_null] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6727),
  },
  [2700] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_else] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [2701] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2702] = {
    [anon_sym_SEMI] = ACTIONS(6729),
    [sym_comment] = ACTIONS(49),
  },
  [2703] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [2704] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [2705] = {
    [anon_sym_SEMI] = ACTIONS(6731),
    [sym_comment] = ACTIONS(49),
  },
  [2706] = {
    [sym_compound_statement] = STATE(2864),
    [sym_labeled_statement] = STATE(2864),
    [sym_expression_statement] = STATE(2864),
    [sym_if_statement] = STATE(2864),
    [sym_switch_statement] = STATE(2864),
    [sym_case_statement] = STATE(2864),
    [sym_while_statement] = STATE(2864),
    [sym_do_statement] = STATE(2864),
    [sym_for_statement] = STATE(2864),
    [sym_return_statement] = STATE(2864),
    [sym_break_statement] = STATE(2864),
    [sym_continue_statement] = STATE(2864),
    [sym_goto_statement] = STATE(2864),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(2864),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2707] = {
    [sym_compound_statement] = STATE(2865),
    [sym_labeled_statement] = STATE(2865),
    [sym_expression_statement] = STATE(2865),
    [sym_if_statement] = STATE(2865),
    [sym_switch_statement] = STATE(2865),
    [sym_case_statement] = STATE(2865),
    [sym_while_statement] = STATE(2865),
    [sym_do_statement] = STATE(2865),
    [sym_for_statement] = STATE(2865),
    [sym_return_statement] = STATE(2865),
    [sym_break_statement] = STATE(2865),
    [sym_continue_statement] = STATE(2865),
    [sym_goto_statement] = STATE(2865),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2865),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2708] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [2709] = {
    [sym__expression] = STATE(2866),
    [sym_conditional_expression] = STATE(2866),
    [sym_assignment_expression] = STATE(2866),
    [sym_pointer_expression] = STATE(2866),
    [sym_logical_expression] = STATE(2866),
    [sym_bitwise_expression] = STATE(2866),
    [sym_equality_expression] = STATE(2866),
    [sym_relational_expression] = STATE(2866),
    [sym_shift_expression] = STATE(2866),
    [sym_math_expression] = STATE(2866),
    [sym_cast_expression] = STATE(2866),
    [sym_sizeof_expression] = STATE(2866),
    [sym_subscript_expression] = STATE(2866),
    [sym_call_expression] = STATE(2866),
    [sym_field_expression] = STATE(2866),
    [sym_compound_literal_expression] = STATE(2866),
    [sym_parenthesized_expression] = STATE(2866),
    [sym_concatenated_string] = STATE(2866),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2866),
    [sym_new_expression] = STATE(2866),
    [sym_delete_expression] = STATE(2866),
    [sym_lambda_expression] = STATE(2866),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6733),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6733),
    [sym_char_literal] = ACTIONS(6733),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6735),
    [sym_false] = ACTIONS(6735),
    [sym_null] = ACTIONS(6735),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6735),
  },
  [2710] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_RBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(6741),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [2711] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_COLON] = ACTIONS(6110),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2712] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2713] = {
    [anon_sym_LPAREN] = ACTIONS(6743),
    [anon_sym_constexpr] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
  },
  [2714] = {
    [anon_sym_LPAREN] = ACTIONS(6747),
    [sym_comment] = ACTIONS(49),
  },
  [2715] = {
    [sym__expression] = STATE(2871),
    [sym_conditional_expression] = STATE(2871),
    [sym_assignment_expression] = STATE(2871),
    [sym_pointer_expression] = STATE(2871),
    [sym_logical_expression] = STATE(2871),
    [sym_bitwise_expression] = STATE(2871),
    [sym_equality_expression] = STATE(2871),
    [sym_relational_expression] = STATE(2871),
    [sym_shift_expression] = STATE(2871),
    [sym_math_expression] = STATE(2871),
    [sym_cast_expression] = STATE(2871),
    [sym_sizeof_expression] = STATE(2871),
    [sym_subscript_expression] = STATE(2871),
    [sym_call_expression] = STATE(2871),
    [sym_field_expression] = STATE(2871),
    [sym_compound_literal_expression] = STATE(2871),
    [sym_parenthesized_expression] = STATE(2871),
    [sym_concatenated_string] = STATE(2871),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2871),
    [sym_new_expression] = STATE(2871),
    [sym_delete_expression] = STATE(2871),
    [sym_lambda_expression] = STATE(2871),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6749),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(6749),
    [sym_char_literal] = ACTIONS(6749),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(6751),
    [sym_false] = ACTIONS(6751),
    [sym_null] = ACTIONS(6751),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(6751),
  },
  [2716] = {
    [anon_sym_COLON] = ACTIONS(6753),
    [sym_comment] = ACTIONS(49),
  },
  [2717] = {
    [anon_sym_LPAREN] = ACTIONS(6755),
    [sym_comment] = ACTIONS(49),
  },
  [2718] = {
    [anon_sym_LPAREN] = ACTIONS(6757),
    [sym_comment] = ACTIONS(49),
  },
  [2719] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2720] = {
    [anon_sym_else] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(6393),
    [sym_comment] = ACTIONS(49),
  },
  [2721] = {
    [sym_compound_statement] = STATE(2877),
    [sym_labeled_statement] = STATE(2877),
    [sym_expression_statement] = STATE(2877),
    [sym_if_statement] = STATE(2877),
    [sym_switch_statement] = STATE(2877),
    [sym_case_statement] = STATE(2877),
    [sym_while_statement] = STATE(2877),
    [sym_do_statement] = STATE(2877),
    [sym_for_statement] = STATE(2877),
    [sym_return_statement] = STATE(2877),
    [sym_break_statement] = STATE(2877),
    [sym_continue_statement] = STATE(2877),
    [sym_goto_statement] = STATE(2877),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2877),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2722] = {
    [anon_sym_else] = ACTIONS(6403),
    [anon_sym_while] = ACTIONS(6403),
    [sym_comment] = ACTIONS(49),
  },
  [2723] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(6763),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2724] = {
    [sym__type_declarator] = STATE(2879),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2725] = {
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_comment] = ACTIONS(49),
  },
  [2726] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(6765),
    [sym_comment] = ACTIONS(49),
  },
  [2727] = {
    [anon_sym_else] = ACTIONS(6419),
    [anon_sym_while] = ACTIONS(6419),
    [sym_comment] = ACTIONS(49),
  },
  [2728] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6767),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2729] = {
    [sym_compound_statement] = STATE(2882),
    [sym_labeled_statement] = STATE(2882),
    [sym_expression_statement] = STATE(2882),
    [sym_if_statement] = STATE(2882),
    [sym_switch_statement] = STATE(2882),
    [sym_case_statement] = STATE(2882),
    [sym_while_statement] = STATE(2882),
    [sym_do_statement] = STATE(2882),
    [sym_for_statement] = STATE(2882),
    [sym_return_statement] = STATE(2882),
    [sym_break_statement] = STATE(2882),
    [sym_continue_statement] = STATE(2882),
    [sym_goto_statement] = STATE(2882),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2882),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2730] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(2884),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6769),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2731] = {
    [sym__expression] = STATE(2885),
    [sym_conditional_expression] = STATE(2885),
    [sym_assignment_expression] = STATE(2885),
    [sym_pointer_expression] = STATE(2885),
    [sym_logical_expression] = STATE(2885),
    [sym_bitwise_expression] = STATE(2885),
    [sym_equality_expression] = STATE(2885),
    [sym_relational_expression] = STATE(2885),
    [sym_shift_expression] = STATE(2885),
    [sym_math_expression] = STATE(2885),
    [sym_cast_expression] = STATE(2885),
    [sym_sizeof_expression] = STATE(2885),
    [sym_subscript_expression] = STATE(2885),
    [sym_call_expression] = STATE(2885),
    [sym_field_expression] = STATE(2885),
    [sym_compound_literal_expression] = STATE(2885),
    [sym_parenthesized_expression] = STATE(2885),
    [sym_concatenated_string] = STATE(2885),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2885),
    [sym_new_expression] = STATE(2885),
    [sym_delete_expression] = STATE(2885),
    [sym_lambda_expression] = STATE(2885),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6771),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6769),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6771),
    [sym_char_literal] = ACTIONS(6771),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6773),
    [sym_false] = ACTIONS(6773),
    [sym_null] = ACTIONS(6773),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6773),
  },
  [2732] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6775),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2733] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6777),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2734] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_RBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [2735] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [2736] = {
    [sym__expression] = STATE(2888),
    [sym_conditional_expression] = STATE(2888),
    [sym_assignment_expression] = STATE(2888),
    [sym_pointer_expression] = STATE(2888),
    [sym_logical_expression] = STATE(2888),
    [sym_bitwise_expression] = STATE(2888),
    [sym_equality_expression] = STATE(2888),
    [sym_relational_expression] = STATE(2888),
    [sym_shift_expression] = STATE(2888),
    [sym_math_expression] = STATE(2888),
    [sym_cast_expression] = STATE(2888),
    [sym_sizeof_expression] = STATE(2888),
    [sym_subscript_expression] = STATE(2888),
    [sym_call_expression] = STATE(2888),
    [sym_field_expression] = STATE(2888),
    [sym_compound_literal_expression] = STATE(2888),
    [sym_parenthesized_expression] = STATE(2888),
    [sym_concatenated_string] = STATE(2888),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2888),
    [sym_new_expression] = STATE(2888),
    [sym_delete_expression] = STATE(2888),
    [sym_lambda_expression] = STATE(2888),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6787),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6787),
    [sym_char_literal] = ACTIONS(6787),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6789),
    [sym_false] = ACTIONS(6789),
    [sym_null] = ACTIONS(6789),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6789),
  },
  [2737] = {
    [sym_compound_statement] = STATE(2889),
    [sym_labeled_statement] = STATE(2889),
    [sym_expression_statement] = STATE(2889),
    [sym_if_statement] = STATE(2889),
    [sym_switch_statement] = STATE(2889),
    [sym_case_statement] = STATE(2889),
    [sym_while_statement] = STATE(2889),
    [sym_do_statement] = STATE(2889),
    [sym_for_statement] = STATE(2889),
    [sym_return_statement] = STATE(2889),
    [sym_break_statement] = STATE(2889),
    [sym_continue_statement] = STATE(2889),
    [sym_goto_statement] = STATE(2889),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2889),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2738] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6791),
    [sym_comment] = ACTIONS(49),
  },
  [2739] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6791),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2740] = {
    [sym__type_specifier] = STATE(2894),
    [sym_sized_type_specifier] = STATE(2894),
    [sym_enum_specifier] = STATE(2894),
    [sym_struct_specifier] = STATE(2894),
    [sym_union_specifier] = STATE(2894),
    [sym_macro_type_specifier] = STATE(2894),
    [sym_class_specifier] = STATE(2894),
    [sym_dependent_type] = STATE(2894),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2895),
    [anon_sym_unsigned] = ACTIONS(6793),
    [anon_sym_long] = ACTIONS(6793),
    [anon_sym_short] = ACTIONS(6793),
    [sym_primitive_type] = ACTIONS(6795),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(6795),
    [anon_sym_typename] = ACTIONS(6797),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2741] = {
    [sym_type_qualifier] = STATE(2896),
    [sym_trailing_return_type] = STATE(2896),
    [aux_sym_function_declarator_repeat1] = STATE(2896),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_COMMA] = ACTIONS(1654),
    [anon_sym_SEMI] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1654),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(1654),
    [anon_sym_DASH_GT] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6799),
  },
  [2742] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [2743] = {
    [sym__expression] = STATE(2897),
    [sym_conditional_expression] = STATE(2897),
    [sym_assignment_expression] = STATE(2897),
    [sym_pointer_expression] = STATE(2897),
    [sym_logical_expression] = STATE(2897),
    [sym_bitwise_expression] = STATE(2897),
    [sym_equality_expression] = STATE(2897),
    [sym_relational_expression] = STATE(2897),
    [sym_shift_expression] = STATE(2897),
    [sym_math_expression] = STATE(2897),
    [sym_cast_expression] = STATE(2897),
    [sym_sizeof_expression] = STATE(2897),
    [sym_subscript_expression] = STATE(2897),
    [sym_call_expression] = STATE(2897),
    [sym_field_expression] = STATE(2897),
    [sym_compound_literal_expression] = STATE(2897),
    [sym_parenthesized_expression] = STATE(2897),
    [sym_concatenated_string] = STATE(2897),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2897),
    [sym_new_expression] = STATE(2897),
    [sym_delete_expression] = STATE(2897),
    [sym_lambda_expression] = STATE(2897),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6791),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6801),
    [sym_char_literal] = ACTIONS(6801),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6803),
    [sym_false] = ACTIONS(6803),
    [sym_null] = ACTIONS(6803),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6803),
  },
  [2744] = {
    [sym_compound_statement] = STATE(2898),
    [sym_labeled_statement] = STATE(2898),
    [sym_expression_statement] = STATE(2898),
    [sym_if_statement] = STATE(2898),
    [sym_switch_statement] = STATE(2898),
    [sym_case_statement] = STATE(2898),
    [sym_while_statement] = STATE(2898),
    [sym_do_statement] = STATE(2898),
    [sym_for_statement] = STATE(2898),
    [sym_return_statement] = STATE(2898),
    [sym_break_statement] = STATE(2898),
    [sym_continue_statement] = STATE(2898),
    [sym_goto_statement] = STATE(2898),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2898),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2745] = {
    [sym_field_declaration_list] = STATE(1425),
    [sym__class_name] = STATE(2899),
    [sym_base_class_clause] = STATE(1427),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2746] = {
    [sym_field_declaration_list] = STATE(1431),
    [sym__class_name] = STATE(2900),
    [sym_base_class_clause] = STATE(1433),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2747] = {
    [sym_field_declaration_list] = STATE(1438),
    [sym__class_name] = STATE(2901),
    [sym_base_class_clause] = STATE(1440),
    [sym_template_type] = STATE(1428),
    [sym_scoped_type_identifier] = STATE(1429),
    [sym_scoped_namespace_identifier] = STATE(869),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2917),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2748] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2750),
    [anon_sym_unsigned] = ACTIONS(6487),
    [anon_sym_long] = ACTIONS(6487),
    [anon_sym_short] = ACTIONS(6487),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(6491),
    [anon_sym_union] = ACTIONS(6493),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6495),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(6497),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2749] = {
    [sym__abstract_declarator] = STATE(2904),
    [sym_abstract_pointer_declarator] = STATE(2904),
    [sym_abstract_function_declarator] = STATE(2904),
    [sym_abstract_array_declarator] = STATE(2904),
    [sym_parameter_list] = STATE(2905),
    [sym_abstract_reference_declarator] = STATE(2904),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(6805),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(6807),
    [anon_sym_AMP_AMP] = ACTIONS(6809),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [2750] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2906),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(6811),
    [anon_sym_long] = ACTIONS(6811),
    [anon_sym_short] = ACTIONS(6811),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [2751] = {
    [sym_type_qualifier] = STATE(2751),
    [sym_trailing_return_type] = STATE(2751),
    [aux_sym_function_declarator_repeat1] = STATE(2751),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6816),
  },
  [2752] = {
    [sym_parameter_list] = STATE(2754),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2753] = {
    [sym_parameter_list] = STATE(2754),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_COLON] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2754] = {
    [sym_type_qualifier] = STATE(2907),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2907),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2755] = {
    [sym_type_qualifier] = STATE(2908),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2908),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6819),
  },
  [2756] = {
    [sym_type_qualifier] = STATE(2757),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2757),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(2166),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6510),
  },
  [2757] = {
    [sym_type_qualifier] = STATE(2757),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2757),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6821),
  },
  [2758] = {
    [anon_sym_COMMA] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [sym_comment] = ACTIONS(49),
  },
  [2759] = {
    [sym__expression] = STATE(1906),
    [sym_conditional_expression] = STATE(1906),
    [sym_assignment_expression] = STATE(1906),
    [sym_pointer_expression] = STATE(1906),
    [sym_logical_expression] = STATE(1906),
    [sym_bitwise_expression] = STATE(1906),
    [sym_equality_expression] = STATE(1906),
    [sym_relational_expression] = STATE(1906),
    [sym_shift_expression] = STATE(1906),
    [sym_math_expression] = STATE(1906),
    [sym_cast_expression] = STATE(1906),
    [sym_sizeof_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_field_expression] = STATE(1906),
    [sym_compound_literal_expression] = STATE(1906),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_initializer_list] = STATE(1907),
    [sym_concatenated_string] = STATE(1906),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1906),
    [sym_new_expression] = STATE(1906),
    [sym_delete_expression] = STATE(1906),
    [sym_lambda_expression] = STATE(1906),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_COMMA] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(6824),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(6824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_BANG] = ACTIONS(6826),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_BANG_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_DASH_GT] = ACTIONS(5334),
    [sym_number_literal] = ACTIONS(4253),
    [sym_char_literal] = ACTIONS(4253),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(4255),
    [sym_false] = ACTIONS(4255),
    [sym_null] = ACTIONS(4255),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(4255),
  },
  [2760] = {
    [sym__expression] = STATE(2909),
    [sym_conditional_expression] = STATE(2909),
    [sym_assignment_expression] = STATE(2909),
    [sym_pointer_expression] = STATE(2909),
    [sym_logical_expression] = STATE(2909),
    [sym_bitwise_expression] = STATE(2909),
    [sym_equality_expression] = STATE(2909),
    [sym_relational_expression] = STATE(2909),
    [sym_shift_expression] = STATE(2909),
    [sym_math_expression] = STATE(2909),
    [sym_cast_expression] = STATE(2909),
    [sym_sizeof_expression] = STATE(2909),
    [sym_subscript_expression] = STATE(2909),
    [sym_call_expression] = STATE(2909),
    [sym_field_expression] = STATE(2909),
    [sym_compound_literal_expression] = STATE(2909),
    [sym_parenthesized_expression] = STATE(2909),
    [sym_concatenated_string] = STATE(2909),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2909),
    [sym_new_expression] = STATE(2909),
    [sym_delete_expression] = STATE(2909),
    [sym_lambda_expression] = STATE(2909),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6828),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(6828),
    [sym_char_literal] = ACTIONS(6828),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(6830),
    [sym_false] = ACTIONS(6830),
    [sym_null] = ACTIONS(6830),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(6830),
  },
  [2761] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2762] = {
    [sym__expression] = STATE(2910),
    [sym_conditional_expression] = STATE(2910),
    [sym_assignment_expression] = STATE(2910),
    [sym_pointer_expression] = STATE(2910),
    [sym_logical_expression] = STATE(2910),
    [sym_bitwise_expression] = STATE(2910),
    [sym_equality_expression] = STATE(2910),
    [sym_relational_expression] = STATE(2910),
    [sym_shift_expression] = STATE(2910),
    [sym_math_expression] = STATE(2910),
    [sym_cast_expression] = STATE(2910),
    [sym_sizeof_expression] = STATE(2910),
    [sym_subscript_expression] = STATE(2910),
    [sym_call_expression] = STATE(2910),
    [sym_field_expression] = STATE(2910),
    [sym_compound_literal_expression] = STATE(2910),
    [sym_parenthesized_expression] = STATE(2910),
    [sym_concatenated_string] = STATE(2910),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2910),
    [sym_new_expression] = STATE(2910),
    [sym_delete_expression] = STATE(2910),
    [sym_lambda_expression] = STATE(2910),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6832),
    [anon_sym_LPAREN] = ACTIONS(3915),
    [anon_sym_STAR] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(6832),
    [sym_char_literal] = ACTIONS(6832),
    [sym_string_literal] = ACTIONS(3929),
    [sym_true] = ACTIONS(6834),
    [sym_false] = ACTIONS(6834),
    [sym_null] = ACTIONS(6834),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_delete] = ACTIONS(3935),
    [sym_nullptr] = ACTIONS(6834),
  },
  [2763] = {
    [sym_parameter_list] = STATE(2765),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2764] = {
    [sym_parameter_list] = STATE(2765),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3866),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_GT] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2765] = {
    [sym_type_qualifier] = STATE(2911),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2911),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2766] = {
    [sym_type_qualifier] = STATE(2912),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2912),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6836),
  },
  [2767] = {
    [sym_parameter_list] = STATE(2769),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [2768] = {
    [sym_parameter_list] = STATE(2769),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3866),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [2769] = {
    [sym_type_qualifier] = STATE(2913),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2913),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [2770] = {
    [sym_type_qualifier] = STATE(2914),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2914),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4237),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6838),
  },
  [2771] = {
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_RPAREN] = ACTIONS(4958),
    [anon_sym_SEMI] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_EQ] = ACTIONS(4958),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4958),
    [anon_sym_volatile] = ACTIONS(4958),
    [anon_sym__Atomic] = ACTIONS(4958),
    [anon_sym_mutable] = ACTIONS(4958),
    [anon_sym_explicit] = ACTIONS(4958),
    [anon_sym_constexpr] = ACTIONS(4958),
    [anon_sym_COLON] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_GT] = ACTIONS(4958),
    [anon_sym_DASH_GT] = ACTIONS(4958),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4958),
  },
  [2772] = {
    [sym_raw_string_literal] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_LBRACE] = ACTIONS(3434),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_if] = ACTIONS(3436),
    [anon_sym_switch] = ACTIONS(3436),
    [anon_sym_case] = ACTIONS(3436),
    [anon_sym_default] = ACTIONS(3436),
    [anon_sym_while] = ACTIONS(3436),
    [anon_sym_do] = ACTIONS(3436),
    [anon_sym_for] = ACTIONS(3436),
    [anon_sym_return] = ACTIONS(3436),
    [anon_sym_break] = ACTIONS(3436),
    [anon_sym_continue] = ACTIONS(3436),
    [anon_sym_goto] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_sizeof] = ACTIONS(3436),
    [sym_number_literal] = ACTIONS(3434),
    [sym_char_literal] = ACTIONS(3434),
    [sym_string_literal] = ACTIONS(3434),
    [sym_true] = ACTIONS(3436),
    [sym_false] = ACTIONS(3436),
    [sym_null] = ACTIONS(3436),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_new] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3436),
    [sym_nullptr] = ACTIONS(3436),
  },
  [2773] = {
    [sym_raw_string_literal] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_LBRACE] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_if] = ACTIONS(3446),
    [anon_sym_switch] = ACTIONS(3446),
    [anon_sym_case] = ACTIONS(3446),
    [anon_sym_default] = ACTIONS(3446),
    [anon_sym_while] = ACTIONS(3446),
    [anon_sym_do] = ACTIONS(3446),
    [anon_sym_for] = ACTIONS(3446),
    [anon_sym_return] = ACTIONS(3446),
    [anon_sym_break] = ACTIONS(3446),
    [anon_sym_continue] = ACTIONS(3446),
    [anon_sym_goto] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_sizeof] = ACTIONS(3446),
    [sym_number_literal] = ACTIONS(3444),
    [sym_char_literal] = ACTIONS(3444),
    [sym_string_literal] = ACTIONS(3444),
    [sym_true] = ACTIONS(3446),
    [sym_false] = ACTIONS(3446),
    [sym_null] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3446),
    [sym_nullptr] = ACTIONS(3446),
  },
  [2774] = {
    [sym_raw_string_literal] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6328),
    [sym_preproc_directive] = ACTIONS(6328),
    [anon_sym_SEMI] = ACTIONS(6326),
    [anon_sym_typedef] = ACTIONS(6328),
    [anon_sym_extern] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6326),
    [anon_sym_STAR] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6326),
    [anon_sym_static] = ACTIONS(6328),
    [anon_sym_register] = ACTIONS(6328),
    [anon_sym_inline] = ACTIONS(6328),
    [anon_sym_const] = ACTIONS(6328),
    [anon_sym_restrict] = ACTIONS(6328),
    [anon_sym_volatile] = ACTIONS(6328),
    [anon_sym__Atomic] = ACTIONS(6328),
    [anon_sym_mutable] = ACTIONS(6328),
    [anon_sym_explicit] = ACTIONS(6328),
    [anon_sym_constexpr] = ACTIONS(6328),
    [anon_sym_unsigned] = ACTIONS(6328),
    [anon_sym_long] = ACTIONS(6328),
    [anon_sym_short] = ACTIONS(6328),
    [sym_primitive_type] = ACTIONS(6328),
    [anon_sym_enum] = ACTIONS(6328),
    [anon_sym_struct] = ACTIONS(6328),
    [anon_sym_union] = ACTIONS(6328),
    [anon_sym_if] = ACTIONS(6328),
    [anon_sym_switch] = ACTIONS(6328),
    [anon_sym_case] = ACTIONS(6328),
    [anon_sym_default] = ACTIONS(6328),
    [anon_sym_while] = ACTIONS(6328),
    [anon_sym_do] = ACTIONS(6328),
    [anon_sym_for] = ACTIONS(6328),
    [anon_sym_return] = ACTIONS(6328),
    [anon_sym_break] = ACTIONS(6328),
    [anon_sym_continue] = ACTIONS(6328),
    [anon_sym_goto] = ACTIONS(6328),
    [anon_sym_AMP] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_TILDE] = ACTIONS(6326),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_DASH_DASH] = ACTIONS(6326),
    [anon_sym_PLUS_PLUS] = ACTIONS(6326),
    [anon_sym_sizeof] = ACTIONS(6328),
    [sym_number_literal] = ACTIONS(6326),
    [sym_char_literal] = ACTIONS(6326),
    [sym_string_literal] = ACTIONS(6326),
    [sym_true] = ACTIONS(6328),
    [sym_false] = ACTIONS(6328),
    [sym_null] = ACTIONS(6328),
    [sym_identifier] = ACTIONS(6328),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6328),
    [sym_auto] = ACTIONS(6328),
    [anon_sym_typename] = ACTIONS(6328),
    [anon_sym_new] = ACTIONS(6328),
    [anon_sym_COLON_COLON] = ACTIONS(6326),
    [anon_sym_delete] = ACTIONS(6328),
    [sym_nullptr] = ACTIONS(6328),
  },
  [2775] = {
    [sym_raw_string_literal] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6332),
    [sym_preproc_directive] = ACTIONS(6332),
    [anon_sym_SEMI] = ACTIONS(6330),
    [anon_sym_typedef] = ACTIONS(6332),
    [anon_sym_extern] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6330),
    [anon_sym_STAR] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6330),
    [anon_sym_static] = ACTIONS(6332),
    [anon_sym_register] = ACTIONS(6332),
    [anon_sym_inline] = ACTIONS(6332),
    [anon_sym_const] = ACTIONS(6332),
    [anon_sym_restrict] = ACTIONS(6332),
    [anon_sym_volatile] = ACTIONS(6332),
    [anon_sym__Atomic] = ACTIONS(6332),
    [anon_sym_mutable] = ACTIONS(6332),
    [anon_sym_explicit] = ACTIONS(6332),
    [anon_sym_constexpr] = ACTIONS(6332),
    [anon_sym_unsigned] = ACTIONS(6332),
    [anon_sym_long] = ACTIONS(6332),
    [anon_sym_short] = ACTIONS(6332),
    [sym_primitive_type] = ACTIONS(6332),
    [anon_sym_enum] = ACTIONS(6332),
    [anon_sym_struct] = ACTIONS(6332),
    [anon_sym_union] = ACTIONS(6332),
    [anon_sym_if] = ACTIONS(6332),
    [anon_sym_switch] = ACTIONS(6332),
    [anon_sym_case] = ACTIONS(6332),
    [anon_sym_default] = ACTIONS(6332),
    [anon_sym_while] = ACTIONS(6332),
    [anon_sym_do] = ACTIONS(6332),
    [anon_sym_for] = ACTIONS(6332),
    [anon_sym_return] = ACTIONS(6332),
    [anon_sym_break] = ACTIONS(6332),
    [anon_sym_continue] = ACTIONS(6332),
    [anon_sym_goto] = ACTIONS(6332),
    [anon_sym_AMP] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_TILDE] = ACTIONS(6330),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_DASH_DASH] = ACTIONS(6330),
    [anon_sym_PLUS_PLUS] = ACTIONS(6330),
    [anon_sym_sizeof] = ACTIONS(6332),
    [sym_number_literal] = ACTIONS(6330),
    [sym_char_literal] = ACTIONS(6330),
    [sym_string_literal] = ACTIONS(6330),
    [sym_true] = ACTIONS(6332),
    [sym_false] = ACTIONS(6332),
    [sym_null] = ACTIONS(6332),
    [sym_identifier] = ACTIONS(6332),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6332),
    [sym_auto] = ACTIONS(6332),
    [anon_sym_typename] = ACTIONS(6332),
    [anon_sym_new] = ACTIONS(6332),
    [anon_sym_COLON_COLON] = ACTIONS(6330),
    [anon_sym_delete] = ACTIONS(6332),
    [sym_nullptr] = ACTIONS(6332),
  },
  [2776] = {
    [sym_raw_string_literal] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6336),
    [sym_preproc_directive] = ACTIONS(6336),
    [anon_sym_SEMI] = ACTIONS(6334),
    [anon_sym_typedef] = ACTIONS(6336),
    [anon_sym_extern] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6334),
    [anon_sym_STAR] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6334),
    [anon_sym_static] = ACTIONS(6336),
    [anon_sym_register] = ACTIONS(6336),
    [anon_sym_inline] = ACTIONS(6336),
    [anon_sym_const] = ACTIONS(6336),
    [anon_sym_restrict] = ACTIONS(6336),
    [anon_sym_volatile] = ACTIONS(6336),
    [anon_sym__Atomic] = ACTIONS(6336),
    [anon_sym_mutable] = ACTIONS(6336),
    [anon_sym_explicit] = ACTIONS(6336),
    [anon_sym_constexpr] = ACTIONS(6336),
    [anon_sym_unsigned] = ACTIONS(6336),
    [anon_sym_long] = ACTIONS(6336),
    [anon_sym_short] = ACTIONS(6336),
    [sym_primitive_type] = ACTIONS(6336),
    [anon_sym_enum] = ACTIONS(6336),
    [anon_sym_struct] = ACTIONS(6336),
    [anon_sym_union] = ACTIONS(6336),
    [anon_sym_if] = ACTIONS(6336),
    [anon_sym_switch] = ACTIONS(6336),
    [anon_sym_case] = ACTIONS(6336),
    [anon_sym_default] = ACTIONS(6336),
    [anon_sym_while] = ACTIONS(6336),
    [anon_sym_do] = ACTIONS(6336),
    [anon_sym_for] = ACTIONS(6336),
    [anon_sym_return] = ACTIONS(6336),
    [anon_sym_break] = ACTIONS(6336),
    [anon_sym_continue] = ACTIONS(6336),
    [anon_sym_goto] = ACTIONS(6336),
    [anon_sym_AMP] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_TILDE] = ACTIONS(6334),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_DASH_DASH] = ACTIONS(6334),
    [anon_sym_PLUS_PLUS] = ACTIONS(6334),
    [anon_sym_sizeof] = ACTIONS(6336),
    [sym_number_literal] = ACTIONS(6334),
    [sym_char_literal] = ACTIONS(6334),
    [sym_string_literal] = ACTIONS(6334),
    [sym_true] = ACTIONS(6336),
    [sym_false] = ACTIONS(6336),
    [sym_null] = ACTIONS(6336),
    [sym_identifier] = ACTIONS(6336),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6336),
    [sym_auto] = ACTIONS(6336),
    [anon_sym_typename] = ACTIONS(6336),
    [anon_sym_new] = ACTIONS(6336),
    [anon_sym_COLON_COLON] = ACTIONS(6334),
    [anon_sym_delete] = ACTIONS(6336),
    [sym_nullptr] = ACTIONS(6336),
  },
  [2777] = {
    [sym_raw_string_literal] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6338),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6338),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6338),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [anon_sym_if] = ACTIONS(6340),
    [anon_sym_switch] = ACTIONS(6340),
    [anon_sym_case] = ACTIONS(6340),
    [anon_sym_default] = ACTIONS(6340),
    [anon_sym_while] = ACTIONS(6340),
    [anon_sym_do] = ACTIONS(6340),
    [anon_sym_for] = ACTIONS(6340),
    [anon_sym_return] = ACTIONS(6340),
    [anon_sym_break] = ACTIONS(6340),
    [anon_sym_continue] = ACTIONS(6340),
    [anon_sym_goto] = ACTIONS(6340),
    [anon_sym_AMP] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_TILDE] = ACTIONS(6338),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_DASH_DASH] = ACTIONS(6338),
    [anon_sym_PLUS_PLUS] = ACTIONS(6338),
    [anon_sym_sizeof] = ACTIONS(6340),
    [sym_number_literal] = ACTIONS(6338),
    [sym_char_literal] = ACTIONS(6338),
    [sym_string_literal] = ACTIONS(6338),
    [sym_true] = ACTIONS(6340),
    [sym_false] = ACTIONS(6340),
    [sym_null] = ACTIONS(6340),
    [sym_identifier] = ACTIONS(6340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6340),
    [sym_auto] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_new] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6338),
    [anon_sym_delete] = ACTIONS(6340),
    [sym_nullptr] = ACTIONS(6340),
  },
  [2778] = {
    [sym_raw_string_literal] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6342),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [anon_sym_if] = ACTIONS(6344),
    [anon_sym_switch] = ACTIONS(6344),
    [anon_sym_case] = ACTIONS(6344),
    [anon_sym_default] = ACTIONS(6344),
    [anon_sym_while] = ACTIONS(6344),
    [anon_sym_do] = ACTIONS(6344),
    [anon_sym_for] = ACTIONS(6344),
    [anon_sym_return] = ACTIONS(6344),
    [anon_sym_break] = ACTIONS(6344),
    [anon_sym_continue] = ACTIONS(6344),
    [anon_sym_goto] = ACTIONS(6344),
    [anon_sym_AMP] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_DASH_DASH] = ACTIONS(6342),
    [anon_sym_PLUS_PLUS] = ACTIONS(6342),
    [anon_sym_sizeof] = ACTIONS(6344),
    [sym_number_literal] = ACTIONS(6342),
    [sym_char_literal] = ACTIONS(6342),
    [sym_string_literal] = ACTIONS(6342),
    [sym_true] = ACTIONS(6344),
    [sym_false] = ACTIONS(6344),
    [sym_null] = ACTIONS(6344),
    [sym_identifier] = ACTIONS(6344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6344),
    [sym_auto] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_new] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_delete] = ACTIONS(6344),
    [sym_nullptr] = ACTIONS(6344),
  },
  [2779] = {
    [sym_raw_string_literal] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6346),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [anon_sym_if] = ACTIONS(6348),
    [anon_sym_switch] = ACTIONS(6348),
    [anon_sym_case] = ACTIONS(6348),
    [anon_sym_default] = ACTIONS(6348),
    [anon_sym_while] = ACTIONS(6348),
    [anon_sym_do] = ACTIONS(6348),
    [anon_sym_for] = ACTIONS(6348),
    [anon_sym_return] = ACTIONS(6348),
    [anon_sym_break] = ACTIONS(6348),
    [anon_sym_continue] = ACTIONS(6348),
    [anon_sym_goto] = ACTIONS(6348),
    [anon_sym_AMP] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_DASH_DASH] = ACTIONS(6346),
    [anon_sym_PLUS_PLUS] = ACTIONS(6346),
    [anon_sym_sizeof] = ACTIONS(6348),
    [sym_number_literal] = ACTIONS(6346),
    [sym_char_literal] = ACTIONS(6346),
    [sym_string_literal] = ACTIONS(6346),
    [sym_true] = ACTIONS(6348),
    [sym_false] = ACTIONS(6348),
    [sym_null] = ACTIONS(6348),
    [sym_identifier] = ACTIONS(6348),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6348),
    [sym_auto] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_new] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_delete] = ACTIONS(6348),
    [sym_nullptr] = ACTIONS(6348),
  },
  [2780] = {
    [anon_sym_LF] = ACTIONS(6840),
    [sym_comment] = ACTIONS(83),
  },
  [2781] = {
    [sym_raw_string_literal] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1883),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1883),
    [sym_preproc_directive] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_typedef] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_register] = ACTIONS(1883),
    [anon_sym_inline] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_restrict] = ACTIONS(1883),
    [anon_sym_volatile] = ACTIONS(1883),
    [anon_sym__Atomic] = ACTIONS(1883),
    [anon_sym_mutable] = ACTIONS(1883),
    [anon_sym_explicit] = ACTIONS(1883),
    [anon_sym_constexpr] = ACTIONS(1883),
    [anon_sym_unsigned] = ACTIONS(1883),
    [anon_sym_long] = ACTIONS(1883),
    [anon_sym_short] = ACTIONS(1883),
    [sym_primitive_type] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_switch] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1883),
    [anon_sym_default] = ACTIONS(1883),
    [anon_sym_while] = ACTIONS(1883),
    [anon_sym_do] = ACTIONS(1883),
    [anon_sym_for] = ACTIONS(1883),
    [anon_sym_return] = ACTIONS(1883),
    [anon_sym_break] = ACTIONS(1883),
    [anon_sym_continue] = ACTIONS(1883),
    [anon_sym_goto] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1881),
    [anon_sym_sizeof] = ACTIONS(1883),
    [sym_number_literal] = ACTIONS(1881),
    [sym_char_literal] = ACTIONS(1881),
    [sym_string_literal] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [sym_null] = ACTIONS(1883),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1883),
    [sym_auto] = ACTIONS(1883),
    [anon_sym_typename] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1883),
    [sym_nullptr] = ACTIONS(1883),
  },
  [2782] = {
    [anon_sym_LF] = ACTIONS(6842),
    [sym_comment] = ACTIONS(83),
  },
  [2783] = {
    [sym_raw_string_literal] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5525),
    [anon_sym_LPAREN] = ACTIONS(5523),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5525),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym_LBRACE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_LBRACK] = ACTIONS(5523),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [anon_sym_if] = ACTIONS(5525),
    [anon_sym_switch] = ACTIONS(5525),
    [anon_sym_case] = ACTIONS(5525),
    [anon_sym_default] = ACTIONS(5525),
    [anon_sym_while] = ACTIONS(5525),
    [anon_sym_do] = ACTIONS(5525),
    [anon_sym_for] = ACTIONS(5525),
    [anon_sym_return] = ACTIONS(5525),
    [anon_sym_break] = ACTIONS(5525),
    [anon_sym_continue] = ACTIONS(5525),
    [anon_sym_goto] = ACTIONS(5525),
    [anon_sym_AMP] = ACTIONS(5523),
    [anon_sym_BANG] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_PLUS] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [anon_sym_DASH_DASH] = ACTIONS(5523),
    [anon_sym_PLUS_PLUS] = ACTIONS(5523),
    [anon_sym_sizeof] = ACTIONS(5525),
    [sym_number_literal] = ACTIONS(5523),
    [sym_char_literal] = ACTIONS(5523),
    [sym_string_literal] = ACTIONS(5523),
    [sym_true] = ACTIONS(5525),
    [sym_false] = ACTIONS(5525),
    [sym_null] = ACTIONS(5525),
    [sym_identifier] = ACTIONS(5525),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5525),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_new] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_delete] = ACTIONS(5525),
    [sym_nullptr] = ACTIONS(5525),
  },
  [2784] = {
    [sym_raw_string_literal] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5529),
    [anon_sym_LPAREN] = ACTIONS(5527),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5529),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5527),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [anon_sym_if] = ACTIONS(5529),
    [anon_sym_switch] = ACTIONS(5529),
    [anon_sym_case] = ACTIONS(5529),
    [anon_sym_default] = ACTIONS(5529),
    [anon_sym_while] = ACTIONS(5529),
    [anon_sym_do] = ACTIONS(5529),
    [anon_sym_for] = ACTIONS(5529),
    [anon_sym_return] = ACTIONS(5529),
    [anon_sym_break] = ACTIONS(5529),
    [anon_sym_continue] = ACTIONS(5529),
    [anon_sym_goto] = ACTIONS(5529),
    [anon_sym_AMP] = ACTIONS(5527),
    [anon_sym_BANG] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5529),
    [anon_sym_DASH_DASH] = ACTIONS(5527),
    [anon_sym_PLUS_PLUS] = ACTIONS(5527),
    [anon_sym_sizeof] = ACTIONS(5529),
    [sym_number_literal] = ACTIONS(5527),
    [sym_char_literal] = ACTIONS(5527),
    [sym_string_literal] = ACTIONS(5527),
    [sym_true] = ACTIONS(5529),
    [sym_false] = ACTIONS(5529),
    [sym_null] = ACTIONS(5529),
    [sym_identifier] = ACTIONS(5529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5529),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_new] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_delete] = ACTIONS(5529),
    [sym_nullptr] = ACTIONS(5529),
  },
  [2785] = {
    [sym_raw_string_literal] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5537),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym_LBRACE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [anon_sym_if] = ACTIONS(5539),
    [anon_sym_switch] = ACTIONS(5539),
    [anon_sym_case] = ACTIONS(5539),
    [anon_sym_default] = ACTIONS(5539),
    [anon_sym_while] = ACTIONS(5539),
    [anon_sym_do] = ACTIONS(5539),
    [anon_sym_for] = ACTIONS(5539),
    [anon_sym_return] = ACTIONS(5539),
    [anon_sym_break] = ACTIONS(5539),
    [anon_sym_continue] = ACTIONS(5539),
    [anon_sym_goto] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_BANG] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_PLUS] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5539),
    [anon_sym_DASH_DASH] = ACTIONS(5537),
    [anon_sym_PLUS_PLUS] = ACTIONS(5537),
    [anon_sym_sizeof] = ACTIONS(5539),
    [sym_number_literal] = ACTIONS(5537),
    [sym_char_literal] = ACTIONS(5537),
    [sym_string_literal] = ACTIONS(5537),
    [sym_true] = ACTIONS(5539),
    [sym_false] = ACTIONS(5539),
    [sym_null] = ACTIONS(5539),
    [sym_identifier] = ACTIONS(5539),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5539),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_new] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_delete] = ACTIONS(5539),
    [sym_nullptr] = ACTIONS(5539),
  },
  [2786] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6844),
    [sym_comment] = ACTIONS(49),
  },
  [2787] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6846),
    [sym_comment] = ACTIONS(49),
  },
  [2788] = {
    [sym_raw_string_literal] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5618),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5618),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5618),
    [sym_preproc_directive] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_typedef] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5616),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [anon_sym_if] = ACTIONS(5618),
    [anon_sym_switch] = ACTIONS(5618),
    [anon_sym_case] = ACTIONS(5618),
    [anon_sym_default] = ACTIONS(5618),
    [anon_sym_while] = ACTIONS(5618),
    [anon_sym_do] = ACTIONS(5618),
    [anon_sym_for] = ACTIONS(5618),
    [anon_sym_return] = ACTIONS(5618),
    [anon_sym_break] = ACTIONS(5618),
    [anon_sym_continue] = ACTIONS(5618),
    [anon_sym_goto] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_BANG] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_sizeof] = ACTIONS(5618),
    [sym_number_literal] = ACTIONS(5616),
    [sym_char_literal] = ACTIONS(5616),
    [sym_string_literal] = ACTIONS(5616),
    [sym_true] = ACTIONS(5618),
    [sym_false] = ACTIONS(5618),
    [sym_null] = ACTIONS(5618),
    [sym_identifier] = ACTIONS(5618),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5618),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_new] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_delete] = ACTIONS(5618),
    [sym_nullptr] = ACTIONS(5618),
  },
  [2789] = {
    [sym_raw_string_literal] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5622),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5622),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5622),
    [sym_preproc_directive] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_typedef] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_register] = ACTIONS(5622),
    [anon_sym_inline] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_union] = ACTIONS(5622),
    [anon_sym_if] = ACTIONS(5622),
    [anon_sym_switch] = ACTIONS(5622),
    [anon_sym_case] = ACTIONS(5622),
    [anon_sym_default] = ACTIONS(5622),
    [anon_sym_while] = ACTIONS(5622),
    [anon_sym_do] = ACTIONS(5622),
    [anon_sym_for] = ACTIONS(5622),
    [anon_sym_return] = ACTIONS(5622),
    [anon_sym_break] = ACTIONS(5622),
    [anon_sym_continue] = ACTIONS(5622),
    [anon_sym_goto] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5620),
    [anon_sym_BANG] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_sizeof] = ACTIONS(5622),
    [sym_number_literal] = ACTIONS(5620),
    [sym_char_literal] = ACTIONS(5620),
    [sym_string_literal] = ACTIONS(5620),
    [sym_true] = ACTIONS(5622),
    [sym_false] = ACTIONS(5622),
    [sym_null] = ACTIONS(5622),
    [sym_identifier] = ACTIONS(5622),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5622),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_typename] = ACTIONS(5622),
    [anon_sym_new] = ACTIONS(5622),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_delete] = ACTIONS(5622),
    [sym_nullptr] = ACTIONS(5622),
  },
  [2790] = {
    [sym_raw_string_literal] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5626),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5626),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5626),
    [sym_preproc_directive] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_typedef] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_static] = ACTIONS(5626),
    [anon_sym_register] = ACTIONS(5626),
    [anon_sym_inline] = ACTIONS(5626),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_union] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5626),
    [anon_sym_switch] = ACTIONS(5626),
    [anon_sym_case] = ACTIONS(5626),
    [anon_sym_default] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5626),
    [anon_sym_do] = ACTIONS(5626),
    [anon_sym_for] = ACTIONS(5626),
    [anon_sym_return] = ACTIONS(5626),
    [anon_sym_break] = ACTIONS(5626),
    [anon_sym_continue] = ACTIONS(5626),
    [anon_sym_goto] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5624),
    [anon_sym_BANG] = ACTIONS(5624),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_sizeof] = ACTIONS(5626),
    [sym_number_literal] = ACTIONS(5624),
    [sym_char_literal] = ACTIONS(5624),
    [sym_string_literal] = ACTIONS(5624),
    [sym_true] = ACTIONS(5626),
    [sym_false] = ACTIONS(5626),
    [sym_null] = ACTIONS(5626),
    [sym_identifier] = ACTIONS(5626),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5626),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_typename] = ACTIONS(5626),
    [anon_sym_new] = ACTIONS(5626),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_delete] = ACTIONS(5626),
    [sym_nullptr] = ACTIONS(5626),
  },
  [2791] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6848),
    [sym_comment] = ACTIONS(49),
  },
  [2792] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6850),
    [sym_comment] = ACTIONS(49),
  },
  [2793] = {
    [sym_raw_string_literal] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5634),
    [sym_preproc_directive] = ACTIONS(5634),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_typedef] = ACTIONS(5634),
    [anon_sym_extern] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_static] = ACTIONS(5634),
    [anon_sym_register] = ACTIONS(5634),
    [anon_sym_inline] = ACTIONS(5634),
    [anon_sym_const] = ACTIONS(5634),
    [anon_sym_restrict] = ACTIONS(5634),
    [anon_sym_volatile] = ACTIONS(5634),
    [anon_sym__Atomic] = ACTIONS(5634),
    [anon_sym_mutable] = ACTIONS(5634),
    [anon_sym_explicit] = ACTIONS(5634),
    [anon_sym_constexpr] = ACTIONS(5634),
    [anon_sym_unsigned] = ACTIONS(5634),
    [anon_sym_long] = ACTIONS(5634),
    [anon_sym_short] = ACTIONS(5634),
    [sym_primitive_type] = ACTIONS(5634),
    [anon_sym_enum] = ACTIONS(5634),
    [anon_sym_struct] = ACTIONS(5634),
    [anon_sym_union] = ACTIONS(5634),
    [anon_sym_if] = ACTIONS(5634),
    [anon_sym_switch] = ACTIONS(5634),
    [anon_sym_case] = ACTIONS(5634),
    [anon_sym_default] = ACTIONS(5634),
    [anon_sym_while] = ACTIONS(5634),
    [anon_sym_do] = ACTIONS(5634),
    [anon_sym_for] = ACTIONS(5634),
    [anon_sym_return] = ACTIONS(5634),
    [anon_sym_break] = ACTIONS(5634),
    [anon_sym_continue] = ACTIONS(5634),
    [anon_sym_goto] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_BANG] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_sizeof] = ACTIONS(5634),
    [sym_number_literal] = ACTIONS(5632),
    [sym_char_literal] = ACTIONS(5632),
    [sym_string_literal] = ACTIONS(5632),
    [sym_true] = ACTIONS(5634),
    [sym_false] = ACTIONS(5634),
    [sym_null] = ACTIONS(5634),
    [sym_identifier] = ACTIONS(5634),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5634),
    [sym_auto] = ACTIONS(5634),
    [anon_sym_typename] = ACTIONS(5634),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5632),
    [anon_sym_delete] = ACTIONS(5634),
    [sym_nullptr] = ACTIONS(5634),
  },
  [2794] = {
    [sym_raw_string_literal] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5638),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5638),
    [sym_preproc_directive] = ACTIONS(5638),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_typedef] = ACTIONS(5638),
    [anon_sym_extern] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_static] = ACTIONS(5638),
    [anon_sym_register] = ACTIONS(5638),
    [anon_sym_inline] = ACTIONS(5638),
    [anon_sym_const] = ACTIONS(5638),
    [anon_sym_restrict] = ACTIONS(5638),
    [anon_sym_volatile] = ACTIONS(5638),
    [anon_sym__Atomic] = ACTIONS(5638),
    [anon_sym_mutable] = ACTIONS(5638),
    [anon_sym_explicit] = ACTIONS(5638),
    [anon_sym_constexpr] = ACTIONS(5638),
    [anon_sym_unsigned] = ACTIONS(5638),
    [anon_sym_long] = ACTIONS(5638),
    [anon_sym_short] = ACTIONS(5638),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_enum] = ACTIONS(5638),
    [anon_sym_struct] = ACTIONS(5638),
    [anon_sym_union] = ACTIONS(5638),
    [anon_sym_if] = ACTIONS(5638),
    [anon_sym_switch] = ACTIONS(5638),
    [anon_sym_case] = ACTIONS(5638),
    [anon_sym_default] = ACTIONS(5638),
    [anon_sym_while] = ACTIONS(5638),
    [anon_sym_do] = ACTIONS(5638),
    [anon_sym_for] = ACTIONS(5638),
    [anon_sym_return] = ACTIONS(5638),
    [anon_sym_break] = ACTIONS(5638),
    [anon_sym_continue] = ACTIONS(5638),
    [anon_sym_goto] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5636),
    [anon_sym_BANG] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_sizeof] = ACTIONS(5638),
    [sym_number_literal] = ACTIONS(5636),
    [sym_char_literal] = ACTIONS(5636),
    [sym_string_literal] = ACTIONS(5636),
    [sym_true] = ACTIONS(5638),
    [sym_false] = ACTIONS(5638),
    [sym_null] = ACTIONS(5638),
    [sym_identifier] = ACTIONS(5638),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5638),
    [sym_auto] = ACTIONS(5638),
    [anon_sym_typename] = ACTIONS(5638),
    [anon_sym_new] = ACTIONS(5638),
    [anon_sym_COLON_COLON] = ACTIONS(5636),
    [anon_sym_delete] = ACTIONS(5638),
    [sym_nullptr] = ACTIONS(5638),
  },
  [2795] = {
    [sym_raw_string_literal] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5642),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5642),
    [sym_preproc_directive] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_typedef] = ACTIONS(5642),
    [anon_sym_extern] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_static] = ACTIONS(5642),
    [anon_sym_register] = ACTIONS(5642),
    [anon_sym_inline] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5642),
    [anon_sym_restrict] = ACTIONS(5642),
    [anon_sym_volatile] = ACTIONS(5642),
    [anon_sym__Atomic] = ACTIONS(5642),
    [anon_sym_mutable] = ACTIONS(5642),
    [anon_sym_explicit] = ACTIONS(5642),
    [anon_sym_constexpr] = ACTIONS(5642),
    [anon_sym_unsigned] = ACTIONS(5642),
    [anon_sym_long] = ACTIONS(5642),
    [anon_sym_short] = ACTIONS(5642),
    [sym_primitive_type] = ACTIONS(5642),
    [anon_sym_enum] = ACTIONS(5642),
    [anon_sym_struct] = ACTIONS(5642),
    [anon_sym_union] = ACTIONS(5642),
    [anon_sym_if] = ACTIONS(5642),
    [anon_sym_switch] = ACTIONS(5642),
    [anon_sym_case] = ACTIONS(5642),
    [anon_sym_default] = ACTIONS(5642),
    [anon_sym_while] = ACTIONS(5642),
    [anon_sym_do] = ACTIONS(5642),
    [anon_sym_for] = ACTIONS(5642),
    [anon_sym_return] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(5642),
    [anon_sym_continue] = ACTIONS(5642),
    [anon_sym_goto] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_BANG] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_sizeof] = ACTIONS(5642),
    [sym_number_literal] = ACTIONS(5640),
    [sym_char_literal] = ACTIONS(5640),
    [sym_string_literal] = ACTIONS(5640),
    [sym_true] = ACTIONS(5642),
    [sym_false] = ACTIONS(5642),
    [sym_null] = ACTIONS(5642),
    [sym_identifier] = ACTIONS(5642),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5642),
    [sym_auto] = ACTIONS(5642),
    [anon_sym_typename] = ACTIONS(5642),
    [anon_sym_new] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_delete] = ACTIONS(5642),
    [sym_nullptr] = ACTIONS(5642),
  },
  [2796] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6852),
    [sym_comment] = ACTIONS(49),
  },
  [2797] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6854),
    [sym_comment] = ACTIONS(49),
  },
  [2798] = {
    [sym_raw_string_literal] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2030),
    [sym_char_literal] = ACTIONS(2030),
    [sym_string_literal] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2032),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_delete] = ACTIONS(2032),
    [sym_nullptr] = ACTIONS(2032),
  },
  [2799] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [2800] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(6856),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2801] = {
    [sym_compound_statement] = STATE(2938),
    [sym_labeled_statement] = STATE(2938),
    [sym_expression_statement] = STATE(2938),
    [sym_if_statement] = STATE(2938),
    [sym_switch_statement] = STATE(2938),
    [sym_case_statement] = STATE(2938),
    [sym_while_statement] = STATE(2938),
    [sym_do_statement] = STATE(2938),
    [sym_for_statement] = STATE(2938),
    [sym_return_statement] = STATE(2938),
    [sym_break_statement] = STATE(2938),
    [sym_continue_statement] = STATE(2938),
    [sym_goto_statement] = STATE(2938),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(2938),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [2802] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6890),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2803] = {
    [sym_compound_statement] = STATE(2942),
    [sym_labeled_statement] = STATE(2942),
    [sym_expression_statement] = STATE(2942),
    [sym_if_statement] = STATE(2942),
    [sym_switch_statement] = STATE(2942),
    [sym_case_statement] = STATE(2942),
    [sym_while_statement] = STATE(2942),
    [sym_do_statement] = STATE(2942),
    [sym_for_statement] = STATE(2942),
    [sym_return_statement] = STATE(2942),
    [sym_break_statement] = STATE(2942),
    [sym_continue_statement] = STATE(2942),
    [sym_goto_statement] = STATE(2942),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2942),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2804] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [2805] = {
    [sym_compound_statement] = STATE(2943),
    [sym_labeled_statement] = STATE(2943),
    [sym_expression_statement] = STATE(2943),
    [sym_if_statement] = STATE(2943),
    [sym_switch_statement] = STATE(2943),
    [sym_case_statement] = STATE(2943),
    [sym_while_statement] = STATE(2943),
    [sym_do_statement] = STATE(2943),
    [sym_for_statement] = STATE(2943),
    [sym_return_statement] = STATE(2943),
    [sym_break_statement] = STATE(2943),
    [sym_continue_statement] = STATE(2943),
    [sym_goto_statement] = STATE(2943),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(2943),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2806] = {
    [sym__expression] = STATE(2944),
    [sym_conditional_expression] = STATE(2944),
    [sym_assignment_expression] = STATE(2944),
    [sym_pointer_expression] = STATE(2944),
    [sym_logical_expression] = STATE(2944),
    [sym_bitwise_expression] = STATE(2944),
    [sym_equality_expression] = STATE(2944),
    [sym_relational_expression] = STATE(2944),
    [sym_shift_expression] = STATE(2944),
    [sym_math_expression] = STATE(2944),
    [sym_cast_expression] = STATE(2944),
    [sym_sizeof_expression] = STATE(2944),
    [sym_subscript_expression] = STATE(2944),
    [sym_call_expression] = STATE(2944),
    [sym_field_expression] = STATE(2944),
    [sym_compound_literal_expression] = STATE(2944),
    [sym_parenthesized_expression] = STATE(2944),
    [sym_concatenated_string] = STATE(2944),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2944),
    [sym_new_expression] = STATE(2944),
    [sym_delete_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(2944),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6892),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6892),
    [sym_char_literal] = ACTIONS(6892),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6894),
    [sym_false] = ACTIONS(6894),
    [sym_null] = ACTIONS(6894),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6894),
  },
  [2807] = {
    [sym__expression] = STATE(2946),
    [sym_conditional_expression] = STATE(2946),
    [sym_assignment_expression] = STATE(2946),
    [sym_pointer_expression] = STATE(2946),
    [sym_logical_expression] = STATE(2946),
    [sym_bitwise_expression] = STATE(2946),
    [sym_equality_expression] = STATE(2946),
    [sym_relational_expression] = STATE(2946),
    [sym_shift_expression] = STATE(2946),
    [sym_math_expression] = STATE(2946),
    [sym_cast_expression] = STATE(2946),
    [sym_sizeof_expression] = STATE(2946),
    [sym_subscript_expression] = STATE(2946),
    [sym_call_expression] = STATE(2946),
    [sym_field_expression] = STATE(2946),
    [sym_compound_literal_expression] = STATE(2946),
    [sym_parenthesized_expression] = STATE(2946),
    [sym_concatenated_string] = STATE(2946),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2946),
    [sym_new_expression] = STATE(2946),
    [sym_delete_expression] = STATE(2946),
    [sym_lambda_expression] = STATE(2946),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6896),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6898),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6896),
    [sym_char_literal] = ACTIONS(6896),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6900),
    [sym_false] = ACTIONS(6900),
    [sym_null] = ACTIONS(6900),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6900),
  },
  [2808] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2809] = {
    [sym__expression] = STATE(2948),
    [sym_conditional_expression] = STATE(2948),
    [sym_assignment_expression] = STATE(2948),
    [sym_pointer_expression] = STATE(2948),
    [sym_logical_expression] = STATE(2948),
    [sym_bitwise_expression] = STATE(2948),
    [sym_equality_expression] = STATE(2948),
    [sym_relational_expression] = STATE(2948),
    [sym_shift_expression] = STATE(2948),
    [sym_math_expression] = STATE(2948),
    [sym_cast_expression] = STATE(2948),
    [sym_sizeof_expression] = STATE(2948),
    [sym_subscript_expression] = STATE(2948),
    [sym_call_expression] = STATE(2948),
    [sym_field_expression] = STATE(2948),
    [sym_compound_literal_expression] = STATE(2948),
    [sym_parenthesized_expression] = STATE(2948),
    [sym_concatenated_string] = STATE(2948),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2948),
    [sym_new_expression] = STATE(2948),
    [sym_delete_expression] = STATE(2948),
    [sym_lambda_expression] = STATE(2948),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6904),
    [sym_char_literal] = ACTIONS(6904),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6906),
    [sym_false] = ACTIONS(6906),
    [sym_null] = ACTIONS(6906),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6906),
  },
  [2810] = {
    [sym__expression] = STATE(2949),
    [sym_conditional_expression] = STATE(2949),
    [sym_assignment_expression] = STATE(2949),
    [sym_pointer_expression] = STATE(2949),
    [sym_logical_expression] = STATE(2949),
    [sym_bitwise_expression] = STATE(2949),
    [sym_equality_expression] = STATE(2949),
    [sym_relational_expression] = STATE(2949),
    [sym_shift_expression] = STATE(2949),
    [sym_math_expression] = STATE(2949),
    [sym_cast_expression] = STATE(2949),
    [sym_sizeof_expression] = STATE(2949),
    [sym_subscript_expression] = STATE(2949),
    [sym_call_expression] = STATE(2949),
    [sym_field_expression] = STATE(2949),
    [sym_compound_literal_expression] = STATE(2949),
    [sym_parenthesized_expression] = STATE(2949),
    [sym_concatenated_string] = STATE(2949),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2949),
    [sym_new_expression] = STATE(2949),
    [sym_delete_expression] = STATE(2949),
    [sym_lambda_expression] = STATE(2949),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6908),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6908),
    [sym_char_literal] = ACTIONS(6908),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6910),
    [sym_false] = ACTIONS(6910),
    [sym_null] = ACTIONS(6910),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6910),
  },
  [2811] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [2812] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6912),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2813] = {
    [anon_sym_SEMI] = ACTIONS(6912),
    [sym_comment] = ACTIONS(49),
  },
  [2814] = {
    [sym_raw_string_literal] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2655),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2653),
    [sym_char_literal] = ACTIONS(2653),
    [sym_string_literal] = ACTIONS(2653),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [sym_null] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2655),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2655),
    [sym_nullptr] = ACTIONS(2655),
  },
  [2815] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6914),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2816] = {
    [anon_sym_SEMI] = ACTIONS(6914),
    [sym_comment] = ACTIONS(49),
  },
  [2817] = {
    [sym_raw_string_literal] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2661),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [sym_string_literal] = ACTIONS(2659),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2661),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2661),
    [sym_nullptr] = ACTIONS(2661),
  },
  [2818] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [2819] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [2820] = {
    [sym_preproc_include] = STATE(2953),
    [sym_preproc_def] = STATE(2953),
    [sym_preproc_function_def] = STATE(2953),
    [sym_preproc_call] = STATE(2953),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(2953),
    [sym_type_definition] = STATE(2953),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(2953),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(2953),
    [sym_expression_statement] = STATE(2953),
    [sym_if_statement] = STATE(2953),
    [sym_switch_statement] = STATE(2953),
    [sym_case_statement] = STATE(2953),
    [sym_while_statement] = STATE(2953),
    [sym_do_statement] = STATE(2953),
    [sym_for_statement] = STATE(2953),
    [sym_return_statement] = STATE(2953),
    [sym_break_statement] = STATE(2953),
    [sym_continue_statement] = STATE(2953),
    [sym_goto_statement] = STATE(2953),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(2953),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(2953),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2953),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2953),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(6916),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2821] = {
    [anon_sym_LPAREN] = ACTIONS(6918),
    [anon_sym_constexpr] = ACTIONS(6920),
    [sym_comment] = ACTIONS(49),
  },
  [2822] = {
    [anon_sym_LPAREN] = ACTIONS(6922),
    [sym_comment] = ACTIONS(49),
  },
  [2823] = {
    [sym__expression] = STATE(2957),
    [sym_conditional_expression] = STATE(2957),
    [sym_assignment_expression] = STATE(2957),
    [sym_pointer_expression] = STATE(2957),
    [sym_logical_expression] = STATE(2957),
    [sym_bitwise_expression] = STATE(2957),
    [sym_equality_expression] = STATE(2957),
    [sym_relational_expression] = STATE(2957),
    [sym_shift_expression] = STATE(2957),
    [sym_math_expression] = STATE(2957),
    [sym_cast_expression] = STATE(2957),
    [sym_sizeof_expression] = STATE(2957),
    [sym_subscript_expression] = STATE(2957),
    [sym_call_expression] = STATE(2957),
    [sym_field_expression] = STATE(2957),
    [sym_compound_literal_expression] = STATE(2957),
    [sym_parenthesized_expression] = STATE(2957),
    [sym_concatenated_string] = STATE(2957),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2957),
    [sym_new_expression] = STATE(2957),
    [sym_delete_expression] = STATE(2957),
    [sym_lambda_expression] = STATE(2957),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6924),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(6924),
    [sym_char_literal] = ACTIONS(6924),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(6926),
    [sym_false] = ACTIONS(6926),
    [sym_null] = ACTIONS(6926),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(6926),
  },
  [2824] = {
    [anon_sym_COLON] = ACTIONS(6928),
    [sym_comment] = ACTIONS(49),
  },
  [2825] = {
    [anon_sym_LPAREN] = ACTIONS(6930),
    [sym_comment] = ACTIONS(49),
  },
  [2826] = {
    [sym_compound_statement] = STATE(2960),
    [sym_labeled_statement] = STATE(2960),
    [sym_expression_statement] = STATE(2960),
    [sym_if_statement] = STATE(2960),
    [sym_switch_statement] = STATE(2960),
    [sym_case_statement] = STATE(2960),
    [sym_while_statement] = STATE(2960),
    [sym_do_statement] = STATE(2960),
    [sym_for_statement] = STATE(2960),
    [sym_return_statement] = STATE(2960),
    [sym_break_statement] = STATE(2960),
    [sym_continue_statement] = STATE(2960),
    [sym_goto_statement] = STATE(2960),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2960),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2827] = {
    [anon_sym_LPAREN] = ACTIONS(6932),
    [sym_comment] = ACTIONS(49),
  },
  [2828] = {
    [sym__expression] = STATE(2963),
    [sym_conditional_expression] = STATE(2963),
    [sym_assignment_expression] = STATE(2963),
    [sym_pointer_expression] = STATE(2963),
    [sym_logical_expression] = STATE(2963),
    [sym_bitwise_expression] = STATE(2963),
    [sym_equality_expression] = STATE(2963),
    [sym_relational_expression] = STATE(2963),
    [sym_shift_expression] = STATE(2963),
    [sym_math_expression] = STATE(2963),
    [sym_cast_expression] = STATE(2963),
    [sym_sizeof_expression] = STATE(2963),
    [sym_subscript_expression] = STATE(2963),
    [sym_call_expression] = STATE(2963),
    [sym_field_expression] = STATE(2963),
    [sym_compound_literal_expression] = STATE(2963),
    [sym_parenthesized_expression] = STATE(2963),
    [sym_initializer_list] = STATE(2964),
    [sym_concatenated_string] = STATE(2963),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2963),
    [sym_new_expression] = STATE(2963),
    [sym_delete_expression] = STATE(2963),
    [sym_lambda_expression] = STATE(2963),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6934),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6936),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6934),
    [sym_char_literal] = ACTIONS(6934),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6938),
    [sym_false] = ACTIONS(6938),
    [sym_null] = ACTIONS(6938),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6938),
  },
  [2829] = {
    [anon_sym_SEMI] = ACTIONS(6940),
    [sym_comment] = ACTIONS(49),
  },
  [2830] = {
    [anon_sym_SEMI] = ACTIONS(6942),
    [sym_comment] = ACTIONS(49),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(6944),
    [sym_comment] = ACTIONS(49),
  },
  [2832] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(6946),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2833] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(6948),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [2834] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(6950),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2835] = {
    [anon_sym_SEMI] = ACTIONS(6950),
    [sym_comment] = ACTIONS(49),
  },
  [2836] = {
    [sym_compound_statement] = STATE(2971),
    [sym_labeled_statement] = STATE(2971),
    [sym_expression_statement] = STATE(2971),
    [sym_if_statement] = STATE(2971),
    [sym_switch_statement] = STATE(2971),
    [sym_case_statement] = STATE(2971),
    [sym_while_statement] = STATE(2971),
    [sym_do_statement] = STATE(2971),
    [sym_for_statement] = STATE(2971),
    [sym_return_statement] = STATE(2971),
    [sym_break_statement] = STATE(2971),
    [sym_continue_statement] = STATE(2971),
    [sym_goto_statement] = STATE(2971),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(2971),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [2837] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [2838] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [2839] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6952),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2840] = {
    [sym_compound_statement] = STATE(2973),
    [sym_labeled_statement] = STATE(2973),
    [sym_expression_statement] = STATE(2973),
    [sym_if_statement] = STATE(2973),
    [sym_switch_statement] = STATE(2973),
    [sym_case_statement] = STATE(2973),
    [sym_while_statement] = STATE(2973),
    [sym_do_statement] = STATE(2973),
    [sym_for_statement] = STATE(2973),
    [sym_return_statement] = STATE(2973),
    [sym_break_statement] = STATE(2973),
    [sym_continue_statement] = STATE(2973),
    [sym_goto_statement] = STATE(2973),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(2973),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2841] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(2975),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6954),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2842] = {
    [sym__expression] = STATE(2976),
    [sym_conditional_expression] = STATE(2976),
    [sym_assignment_expression] = STATE(2976),
    [sym_pointer_expression] = STATE(2976),
    [sym_logical_expression] = STATE(2976),
    [sym_bitwise_expression] = STATE(2976),
    [sym_equality_expression] = STATE(2976),
    [sym_relational_expression] = STATE(2976),
    [sym_shift_expression] = STATE(2976),
    [sym_math_expression] = STATE(2976),
    [sym_cast_expression] = STATE(2976),
    [sym_sizeof_expression] = STATE(2976),
    [sym_subscript_expression] = STATE(2976),
    [sym_call_expression] = STATE(2976),
    [sym_field_expression] = STATE(2976),
    [sym_compound_literal_expression] = STATE(2976),
    [sym_parenthesized_expression] = STATE(2976),
    [sym_concatenated_string] = STATE(2976),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2976),
    [sym_new_expression] = STATE(2976),
    [sym_delete_expression] = STATE(2976),
    [sym_lambda_expression] = STATE(2976),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6956),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(6954),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(6956),
    [sym_char_literal] = ACTIONS(6956),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(6958),
    [sym_false] = ACTIONS(6958),
    [sym_null] = ACTIONS(6958),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(6958),
  },
  [2843] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6960),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2844] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6962),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2845] = {
    [sym_raw_string_literal] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_switch] = ACTIONS(4174),
    [anon_sym_case] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_break] = ACTIONS(4174),
    [anon_sym_continue] = ACTIONS(4174),
    [anon_sym_goto] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_BANG] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_sizeof] = ACTIONS(4174),
    [sym_number_literal] = ACTIONS(4172),
    [sym_char_literal] = ACTIONS(4172),
    [sym_string_literal] = ACTIONS(4172),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_null] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_delete] = ACTIONS(4174),
    [sym_nullptr] = ACTIONS(4174),
  },
  [2846] = {
    [sym_raw_string_literal] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_switch] = ACTIONS(4222),
    [anon_sym_case] = ACTIONS(4222),
    [anon_sym_default] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_do] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_return] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4222),
    [anon_sym_continue] = ACTIONS(4222),
    [anon_sym_goto] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_BANG] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4222),
    [anon_sym_DASH] = ACTIONS(4222),
    [anon_sym_DASH_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_PLUS] = ACTIONS(4220),
    [anon_sym_sizeof] = ACTIONS(4222),
    [sym_number_literal] = ACTIONS(4220),
    [sym_char_literal] = ACTIONS(4220),
    [sym_string_literal] = ACTIONS(4220),
    [sym_true] = ACTIONS(4222),
    [sym_false] = ACTIONS(4222),
    [sym_null] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [anon_sym_delete] = ACTIONS(4222),
    [sym_nullptr] = ACTIONS(4222),
  },
  [2847] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2848] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_else] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [2849] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6964),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2850] = {
    [sym__expression] = STATE(2980),
    [sym_conditional_expression] = STATE(2980),
    [sym_assignment_expression] = STATE(2980),
    [sym_pointer_expression] = STATE(2980),
    [sym_logical_expression] = STATE(2980),
    [sym_bitwise_expression] = STATE(2980),
    [sym_equality_expression] = STATE(2980),
    [sym_relational_expression] = STATE(2980),
    [sym_shift_expression] = STATE(2980),
    [sym_math_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_sizeof_expression] = STATE(2980),
    [sym_subscript_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_field_expression] = STATE(2980),
    [sym_compound_literal_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_concatenated_string] = STATE(2980),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2980),
    [sym_new_expression] = STATE(2980),
    [sym_delete_expression] = STATE(2980),
    [sym_lambda_expression] = STATE(2980),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6966),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6966),
    [sym_char_literal] = ACTIONS(6966),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6968),
    [sym_false] = ACTIONS(6968),
    [sym_null] = ACTIONS(6968),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6968),
  },
  [2851] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6970),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2852] = {
    [sym_declaration] = STATE(2982),
    [sym_type_definition] = STATE(2982),
    [sym__declaration_specifiers] = STATE(2856),
    [sym_compound_statement] = STATE(2982),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2982),
    [sym_expression_statement] = STATE(2982),
    [sym_if_statement] = STATE(2982),
    [sym_switch_statement] = STATE(2982),
    [sym_case_statement] = STATE(2982),
    [sym_while_statement] = STATE(2982),
    [sym_do_statement] = STATE(2982),
    [sym_for_statement] = STATE(2982),
    [sym_return_statement] = STATE(2982),
    [sym_break_statement] = STATE(2982),
    [sym_continue_statement] = STATE(2982),
    [sym_goto_statement] = STATE(2982),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(2982),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_typedef] = ACTIONS(6713),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(6715),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2853] = {
    [sym_type_qualifier] = STATE(2984),
    [sym__type_specifier] = STATE(2983),
    [sym_sized_type_specifier] = STATE(2983),
    [sym_enum_specifier] = STATE(2983),
    [sym_struct_specifier] = STATE(2983),
    [sym_union_specifier] = STATE(2983),
    [sym_macro_type_specifier] = STATE(2983),
    [sym_class_specifier] = STATE(2983),
    [sym_dependent_type] = STATE(2983),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(2984),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(6972),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(6972),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2854] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(6391),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [2855] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_else] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [2856] = {
    [sym__declarator] = STATE(2985),
    [sym_pointer_declarator] = STATE(2985),
    [sym_function_declarator] = STATE(2985),
    [sym_array_declarator] = STATE(2985),
    [sym_init_declarator] = STATE(2986),
    [sym_reference_declarator] = STATE(2985),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(2985),
    [sym_destructor_name] = STATE(2985),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(6974),
  },
  [2857] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6976),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2858] = {
    [anon_sym_LPAREN] = ACTIONS(6978),
    [sym_comment] = ACTIONS(49),
  },
  [2859] = {
    [sym__expression] = STATE(2990),
    [sym_conditional_expression] = STATE(2990),
    [sym_assignment_expression] = STATE(2990),
    [sym_pointer_expression] = STATE(2990),
    [sym_logical_expression] = STATE(2990),
    [sym_bitwise_expression] = STATE(2990),
    [sym_equality_expression] = STATE(2990),
    [sym_relational_expression] = STATE(2990),
    [sym_shift_expression] = STATE(2990),
    [sym_math_expression] = STATE(2990),
    [sym_cast_expression] = STATE(2990),
    [sym_sizeof_expression] = STATE(2990),
    [sym_subscript_expression] = STATE(2990),
    [sym_call_expression] = STATE(2990),
    [sym_field_expression] = STATE(2990),
    [sym_compound_literal_expression] = STATE(2990),
    [sym_parenthesized_expression] = STATE(2990),
    [sym_concatenated_string] = STATE(2990),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2990),
    [sym_new_expression] = STATE(2990),
    [sym_delete_expression] = STATE(2990),
    [sym_lambda_expression] = STATE(2990),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6980),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(6982),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(6980),
    [sym_char_literal] = ACTIONS(6980),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(6984),
    [sym_false] = ACTIONS(6984),
    [sym_null] = ACTIONS(6984),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(6984),
  },
  [2860] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2861] = {
    [anon_sym_COLON] = ACTIONS(6988),
    [sym_comment] = ACTIONS(49),
  },
  [2862] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_RBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_else] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [2863] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_else] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [2864] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_else] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [2865] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [2866] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2867] = {
    [sym_compound_statement] = STATE(2993),
    [sym_labeled_statement] = STATE(2993),
    [sym_expression_statement] = STATE(2993),
    [sym_if_statement] = STATE(2993),
    [sym_switch_statement] = STATE(2993),
    [sym_case_statement] = STATE(2993),
    [sym_while_statement] = STATE(2993),
    [sym_do_statement] = STATE(2993),
    [sym_for_statement] = STATE(2993),
    [sym_return_statement] = STATE(2993),
    [sym_break_statement] = STATE(2993),
    [sym_continue_statement] = STATE(2993),
    [sym_goto_statement] = STATE(2993),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(2993),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2868] = {
    [sym__expression] = STATE(2994),
    [sym_conditional_expression] = STATE(2994),
    [sym_assignment_expression] = STATE(2994),
    [sym_pointer_expression] = STATE(2994),
    [sym_logical_expression] = STATE(2994),
    [sym_bitwise_expression] = STATE(2994),
    [sym_equality_expression] = STATE(2994),
    [sym_relational_expression] = STATE(2994),
    [sym_shift_expression] = STATE(2994),
    [sym_math_expression] = STATE(2994),
    [sym_cast_expression] = STATE(2994),
    [sym_sizeof_expression] = STATE(2994),
    [sym_subscript_expression] = STATE(2994),
    [sym_call_expression] = STATE(2994),
    [sym_field_expression] = STATE(2994),
    [sym_compound_literal_expression] = STATE(2994),
    [sym_parenthesized_expression] = STATE(2994),
    [sym_concatenated_string] = STATE(2994),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2994),
    [sym_new_expression] = STATE(2994),
    [sym_delete_expression] = STATE(2994),
    [sym_lambda_expression] = STATE(2994),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6994),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(6994),
    [sym_char_literal] = ACTIONS(6994),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(6996),
    [sym_false] = ACTIONS(6996),
    [sym_null] = ACTIONS(6996),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(6996),
  },
  [2869] = {
    [anon_sym_LPAREN] = ACTIONS(6998),
    [sym_comment] = ACTIONS(49),
  },
  [2870] = {
    [sym__expression] = STATE(2996),
    [sym_conditional_expression] = STATE(2996),
    [sym_assignment_expression] = STATE(2996),
    [sym_pointer_expression] = STATE(2996),
    [sym_logical_expression] = STATE(2996),
    [sym_bitwise_expression] = STATE(2996),
    [sym_equality_expression] = STATE(2996),
    [sym_relational_expression] = STATE(2996),
    [sym_shift_expression] = STATE(2996),
    [sym_math_expression] = STATE(2996),
    [sym_cast_expression] = STATE(2996),
    [sym_sizeof_expression] = STATE(2996),
    [sym_subscript_expression] = STATE(2996),
    [sym_call_expression] = STATE(2996),
    [sym_field_expression] = STATE(2996),
    [sym_compound_literal_expression] = STATE(2996),
    [sym_parenthesized_expression] = STATE(2996),
    [sym_concatenated_string] = STATE(2996),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2996),
    [sym_new_expression] = STATE(2996),
    [sym_delete_expression] = STATE(2996),
    [sym_lambda_expression] = STATE(2996),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7000),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7000),
    [sym_char_literal] = ACTIONS(7000),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7002),
    [sym_false] = ACTIONS(7002),
    [sym_null] = ACTIONS(7002),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7002),
  },
  [2871] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(7004),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2872] = {
    [sym_declaration] = STATE(2132),
    [sym_type_definition] = STATE(2132),
    [sym__declaration_specifiers] = STATE(2133),
    [sym_compound_statement] = STATE(2132),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2132),
    [sym_expression_statement] = STATE(2132),
    [sym_if_statement] = STATE(2132),
    [sym_switch_statement] = STATE(2132),
    [sym_case_statement] = STATE(2132),
    [sym_while_statement] = STATE(2132),
    [sym_do_statement] = STATE(2132),
    [sym_for_statement] = STATE(2132),
    [sym_return_statement] = STATE(2132),
    [sym_break_statement] = STATE(2132),
    [sym_continue_statement] = STATE(2132),
    [sym_goto_statement] = STATE(2132),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2132),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_typedef] = ACTIONS(4777),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(7006),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2873] = {
    [sym__expression] = STATE(2999),
    [sym_conditional_expression] = STATE(2999),
    [sym_assignment_expression] = STATE(2999),
    [sym_pointer_expression] = STATE(2999),
    [sym_logical_expression] = STATE(2999),
    [sym_bitwise_expression] = STATE(2999),
    [sym_equality_expression] = STATE(2999),
    [sym_relational_expression] = STATE(2999),
    [sym_shift_expression] = STATE(2999),
    [sym_math_expression] = STATE(2999),
    [sym_cast_expression] = STATE(2999),
    [sym_sizeof_expression] = STATE(2999),
    [sym_subscript_expression] = STATE(2999),
    [sym_call_expression] = STATE(2999),
    [sym_field_expression] = STATE(2999),
    [sym_compound_literal_expression] = STATE(2999),
    [sym_parenthesized_expression] = STATE(2999),
    [sym_concatenated_string] = STATE(2999),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2999),
    [sym_new_expression] = STATE(2999),
    [sym_delete_expression] = STATE(2999),
    [sym_lambda_expression] = STATE(2999),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7008),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7008),
    [sym_char_literal] = ACTIONS(7008),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7010),
    [sym_false] = ACTIONS(7010),
    [sym_null] = ACTIONS(7010),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7010),
  },
  [2874] = {
    [sym_declaration] = STATE(3000),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(3001),
    [sym_conditional_expression] = STATE(3001),
    [sym_assignment_expression] = STATE(3001),
    [sym_pointer_expression] = STATE(3001),
    [sym_logical_expression] = STATE(3001),
    [sym_bitwise_expression] = STATE(3001),
    [sym_equality_expression] = STATE(3001),
    [sym_relational_expression] = STATE(3001),
    [sym_shift_expression] = STATE(3001),
    [sym_math_expression] = STATE(3001),
    [sym_cast_expression] = STATE(3001),
    [sym_sizeof_expression] = STATE(3001),
    [sym_subscript_expression] = STATE(3001),
    [sym_call_expression] = STATE(3001),
    [sym_field_expression] = STATE(3001),
    [sym_compound_literal_expression] = STATE(3001),
    [sym_parenthesized_expression] = STATE(3001),
    [sym_concatenated_string] = STATE(3001),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(3001),
    [sym_for_range_declaration] = STATE(3002),
    [sym_new_expression] = STATE(3001),
    [sym_delete_expression] = STATE(3001),
    [sym_lambda_expression] = STATE(3001),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(7012),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7014),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7012),
    [sym_char_literal] = ACTIONS(7012),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7016),
    [sym_false] = ACTIONS(7016),
    [sym_null] = ACTIONS(7016),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7016),
  },
  [2875] = {
    [sym_compound_statement] = STATE(2141),
    [sym_labeled_statement] = STATE(2141),
    [sym_expression_statement] = STATE(2141),
    [sym_if_statement] = STATE(2141),
    [sym_switch_statement] = STATE(2141),
    [sym_case_statement] = STATE(2141),
    [sym_while_statement] = STATE(2141),
    [sym_do_statement] = STATE(2141),
    [sym_for_statement] = STATE(2141),
    [sym_return_statement] = STATE(2141),
    [sym_break_statement] = STATE(2141),
    [sym_continue_statement] = STATE(2141),
    [sym_goto_statement] = STATE(2141),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2141),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2876] = {
    [sym_compound_statement] = STATE(3003),
    [sym_labeled_statement] = STATE(3003),
    [sym_expression_statement] = STATE(3003),
    [sym_if_statement] = STATE(3003),
    [sym_switch_statement] = STATE(3003),
    [sym_case_statement] = STATE(3003),
    [sym_while_statement] = STATE(3003),
    [sym_do_statement] = STATE(3003),
    [sym_for_statement] = STATE(3003),
    [sym_return_statement] = STATE(3003),
    [sym_break_statement] = STATE(3003),
    [sym_continue_statement] = STATE(3003),
    [sym_goto_statement] = STATE(3003),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3003),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2877] = {
    [anon_sym_else] = ACTIONS(7018),
    [anon_sym_while] = ACTIONS(6737),
    [sym_comment] = ACTIONS(49),
  },
  [2878] = {
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [sym_comment] = ACTIONS(49),
  },
  [2879] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7020),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [2880] = {
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_comment] = ACTIONS(49),
  },
  [2881] = {
    [anon_sym_else] = ACTIONS(6779),
    [anon_sym_while] = ACTIONS(6779),
    [sym_comment] = ACTIONS(49),
  },
  [2882] = {
    [anon_sym_else] = ACTIONS(6783),
    [anon_sym_while] = ACTIONS(6783),
    [sym_comment] = ACTIONS(49),
  },
  [2883] = {
    [sym_compound_statement] = STATE(3006),
    [sym_labeled_statement] = STATE(3006),
    [sym_expression_statement] = STATE(3006),
    [sym_if_statement] = STATE(3006),
    [sym_switch_statement] = STATE(3006),
    [sym_case_statement] = STATE(3006),
    [sym_while_statement] = STATE(3006),
    [sym_do_statement] = STATE(3006),
    [sym_for_statement] = STATE(3006),
    [sym_return_statement] = STATE(3006),
    [sym_break_statement] = STATE(3006),
    [sym_continue_statement] = STATE(3006),
    [sym_goto_statement] = STATE(3006),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3006),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2884] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [sym_comment] = ACTIONS(49),
  },
  [2885] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3008),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2886] = {
    [sym__expression] = STATE(3009),
    [sym_conditional_expression] = STATE(3009),
    [sym_assignment_expression] = STATE(3009),
    [sym_pointer_expression] = STATE(3009),
    [sym_logical_expression] = STATE(3009),
    [sym_bitwise_expression] = STATE(3009),
    [sym_equality_expression] = STATE(3009),
    [sym_relational_expression] = STATE(3009),
    [sym_shift_expression] = STATE(3009),
    [sym_math_expression] = STATE(3009),
    [sym_cast_expression] = STATE(3009),
    [sym_sizeof_expression] = STATE(3009),
    [sym_subscript_expression] = STATE(3009),
    [sym_call_expression] = STATE(3009),
    [sym_field_expression] = STATE(3009),
    [sym_compound_literal_expression] = STATE(3009),
    [sym_parenthesized_expression] = STATE(3009),
    [sym_concatenated_string] = STATE(3009),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3009),
    [sym_new_expression] = STATE(3009),
    [sym_delete_expression] = STATE(3009),
    [sym_lambda_expression] = STATE(3009),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7024),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7024),
    [sym_char_literal] = ACTIONS(7024),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7026),
    [sym_false] = ACTIONS(7026),
    [sym_null] = ACTIONS(7026),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7026),
  },
  [2887] = {
    [sym_compound_statement] = STATE(3010),
    [sym_labeled_statement] = STATE(3010),
    [sym_expression_statement] = STATE(3010),
    [sym_if_statement] = STATE(3010),
    [sym_switch_statement] = STATE(3010),
    [sym_case_statement] = STATE(3010),
    [sym_while_statement] = STATE(3010),
    [sym_do_statement] = STATE(3010),
    [sym_for_statement] = STATE(3010),
    [sym_return_statement] = STATE(3010),
    [sym_break_statement] = STATE(3010),
    [sym_continue_statement] = STATE(3010),
    [sym_goto_statement] = STATE(3010),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3010),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2888] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2889] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_RBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [2890] = {
    [sym_compound_statement] = STATE(3011),
    [sym_labeled_statement] = STATE(3011),
    [sym_expression_statement] = STATE(3011),
    [sym_if_statement] = STATE(3011),
    [sym_switch_statement] = STATE(3011),
    [sym_case_statement] = STATE(3011),
    [sym_while_statement] = STATE(3011),
    [sym_do_statement] = STATE(3011),
    [sym_for_statement] = STATE(3011),
    [sym_return_statement] = STATE(3011),
    [sym_break_statement] = STATE(3011),
    [sym_continue_statement] = STATE(3011),
    [sym_goto_statement] = STATE(3011),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(3011),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2891] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(7032),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [sym_comment] = ACTIONS(49),
  },
  [2892] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7035),
    [sym_comment] = ACTIONS(49),
  },
  [2893] = {
    [sym__type_specifier] = STATE(1441),
    [sym_sized_type_specifier] = STATE(1441),
    [sym_enum_specifier] = STATE(1441),
    [sym_struct_specifier] = STATE(1441),
    [sym_union_specifier] = STATE(1441),
    [sym_macro_type_specifier] = STATE(1441),
    [sym_class_specifier] = STATE(1441),
    [sym_dependent_type] = STATE(1441),
    [sym_template_type] = STATE(867),
    [sym_scoped_type_identifier] = STATE(868),
    [sym_scoped_namespace_identifier] = STATE(869),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2895),
    [anon_sym_unsigned] = ACTIONS(6793),
    [anon_sym_long] = ACTIONS(6793),
    [anon_sym_short] = ACTIONS(6793),
    [sym_primitive_type] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_union] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1648),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(6797),
    [anon_sym_COLON_COLON] = ACTIONS(1652),
  },
  [2894] = {
    [sym__abstract_declarator] = STATE(3015),
    [sym_abstract_pointer_declarator] = STATE(3015),
    [sym_abstract_function_declarator] = STATE(3015),
    [sym_abstract_array_declarator] = STATE(3015),
    [sym_parameter_list] = STATE(3016),
    [sym_abstract_reference_declarator] = STATE(3015),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(7037),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2933),
    [anon_sym_volatile] = ACTIONS(2933),
    [anon_sym__Atomic] = ACTIONS(2933),
    [anon_sym_mutable] = ACTIONS(2933),
    [anon_sym_explicit] = ACTIONS(2933),
    [anon_sym_constexpr] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(7039),
    [anon_sym_AMP_AMP] = ACTIONS(7041),
    [anon_sym_DASH_GT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2933),
  },
  [2895] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3017),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_EQ] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(248),
    [anon_sym_restrict] = ACTIONS(248),
    [anon_sym_volatile] = ACTIONS(248),
    [anon_sym__Atomic] = ACTIONS(248),
    [anon_sym_mutable] = ACTIONS(248),
    [anon_sym_explicit] = ACTIONS(248),
    [anon_sym_constexpr] = ACTIONS(248),
    [anon_sym_unsigned] = ACTIONS(7043),
    [anon_sym_long] = ACTIONS(7043),
    [anon_sym_short] = ACTIONS(7043),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(246),
    [sym_identifier] = ACTIONS(2949),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(248),
  },
  [2896] = {
    [sym_type_qualifier] = STATE(2896),
    [sym_trailing_return_type] = STATE(2896),
    [aux_sym_function_declarator_repeat1] = STATE(2896),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(7045),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7048),
  },
  [2897] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3018),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7035),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2898] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [2899] = {
    [sym_field_declaration_list] = STATE(1980),
    [sym_base_class_clause] = STATE(1981),
    [anon_sym_LPAREN] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_restrict] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym__Atomic] = ACTIONS(426),
    [anon_sym_mutable] = ACTIONS(426),
    [anon_sym_explicit] = ACTIONS(426),
    [anon_sym_constexpr] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(428),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(426),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4470),
    [sym_noexcept] = ACTIONS(426),
  },
  [2900] = {
    [sym_field_declaration_list] = STATE(1983),
    [sym_base_class_clause] = STATE(1984),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_const] = ACTIONS(440),
    [anon_sym_restrict] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym__Atomic] = ACTIONS(438),
    [anon_sym_mutable] = ACTIONS(438),
    [anon_sym_explicit] = ACTIONS(438),
    [anon_sym_constexpr] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_DASH_GT] = ACTIONS(438),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4472),
    [sym_noexcept] = ACTIONS(438),
  },
  [2901] = {
    [sym_field_declaration_list] = STATE(1989),
    [sym_base_class_clause] = STATE(1990),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(477),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_mutable] = ACTIONS(475),
    [anon_sym_explicit] = ACTIONS(475),
    [anon_sym_constexpr] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(475),
    [sym_comment] = ACTIONS(49),
    [sym_virtual_specifier] = ACTIONS(4478),
    [sym_noexcept] = ACTIONS(475),
  },
  [2902] = {
    [sym__abstract_declarator] = STATE(3019),
    [sym_abstract_pointer_declarator] = STATE(3019),
    [sym_abstract_function_declarator] = STATE(3019),
    [sym_abstract_array_declarator] = STATE(3019),
    [sym_parameter_list] = STATE(2905),
    [sym_abstract_reference_declarator] = STATE(3019),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(6805),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(6807),
    [anon_sym_AMP_AMP] = ACTIONS(6809),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [2903] = {
    [sym__abstract_declarator] = STATE(3020),
    [sym_abstract_pointer_declarator] = STATE(3020),
    [sym_abstract_function_declarator] = STATE(3020),
    [sym_abstract_array_declarator] = STATE(3020),
    [sym_parameter_list] = STATE(2905),
    [sym_abstract_reference_declarator] = STATE(3020),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(6805),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(6807),
    [anon_sym_AMP_AMP] = ACTIONS(6809),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [2904] = {
    [sym_parameter_list] = STATE(3021),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [2905] = {
    [sym_type_qualifier] = STATE(3022),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3022),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [2906] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2906),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(7055),
    [anon_sym_long] = ACTIONS(7055),
    [anon_sym_short] = ACTIONS(7055),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [2907] = {
    [sym_type_qualifier] = STATE(2908),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2908),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(3741),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6819),
  },
  [2908] = {
    [sym_type_qualifier] = STATE(2908),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2908),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7058),
  },
  [2909] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2910] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_STAR_EQ] = ACTIONS(5167),
    [anon_sym_SLASH_EQ] = ACTIONS(5167),
    [anon_sym_PERCENT_EQ] = ACTIONS(5167),
    [anon_sym_PLUS_EQ] = ACTIONS(5167),
    [anon_sym_DASH_EQ] = ACTIONS(5167),
    [anon_sym_LT_LT_EQ] = ACTIONS(5167),
    [anon_sym_GT_GT_EQ] = ACTIONS(5167),
    [anon_sym_AMP_EQ] = ACTIONS(5167),
    [anon_sym_CARET_EQ] = ACTIONS(5167),
    [anon_sym_PIPE_EQ] = ACTIONS(5167),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5177),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5161),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2911] = {
    [sym_type_qualifier] = STATE(2912),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2912),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6836),
  },
  [2912] = {
    [sym_type_qualifier] = STATE(2912),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2912),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7061),
  },
  [2913] = {
    [sym_type_qualifier] = STATE(2914),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2914),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(4237),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(6838),
  },
  [2914] = {
    [sym_type_qualifier] = STATE(2914),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2914),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7064),
  },
  [2915] = {
    [sym_raw_string_literal] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3436),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3436),
    [sym_preproc_directive] = ACTIONS(3436),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_typedef] = ACTIONS(3436),
    [anon_sym_extern] = ACTIONS(3436),
    [anon_sym_LBRACE] = ACTIONS(3434),
    [anon_sym_STAR] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3436),
    [anon_sym_register] = ACTIONS(3436),
    [anon_sym_inline] = ACTIONS(3436),
    [anon_sym_const] = ACTIONS(3436),
    [anon_sym_restrict] = ACTIONS(3436),
    [anon_sym_volatile] = ACTIONS(3436),
    [anon_sym__Atomic] = ACTIONS(3436),
    [anon_sym_mutable] = ACTIONS(3436),
    [anon_sym_explicit] = ACTIONS(3436),
    [anon_sym_constexpr] = ACTIONS(3436),
    [anon_sym_unsigned] = ACTIONS(3436),
    [anon_sym_long] = ACTIONS(3436),
    [anon_sym_short] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3436),
    [anon_sym_enum] = ACTIONS(3436),
    [anon_sym_struct] = ACTIONS(3436),
    [anon_sym_union] = ACTIONS(3436),
    [anon_sym_if] = ACTIONS(3436),
    [anon_sym_switch] = ACTIONS(3436),
    [anon_sym_case] = ACTIONS(3436),
    [anon_sym_default] = ACTIONS(3436),
    [anon_sym_while] = ACTIONS(3436),
    [anon_sym_do] = ACTIONS(3436),
    [anon_sym_for] = ACTIONS(3436),
    [anon_sym_return] = ACTIONS(3436),
    [anon_sym_break] = ACTIONS(3436),
    [anon_sym_continue] = ACTIONS(3436),
    [anon_sym_goto] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_sizeof] = ACTIONS(3436),
    [sym_number_literal] = ACTIONS(3434),
    [sym_char_literal] = ACTIONS(3434),
    [sym_string_literal] = ACTIONS(3434),
    [sym_true] = ACTIONS(3436),
    [sym_false] = ACTIONS(3436),
    [sym_null] = ACTIONS(3436),
    [sym_identifier] = ACTIONS(3436),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3436),
    [sym_auto] = ACTIONS(3436),
    [anon_sym_typename] = ACTIONS(3436),
    [anon_sym_new] = ACTIONS(3436),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3436),
    [sym_nullptr] = ACTIONS(3436),
  },
  [2916] = {
    [sym_raw_string_literal] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3444),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3446),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3446),
    [sym_preproc_directive] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3446),
    [anon_sym_extern] = ACTIONS(3446),
    [anon_sym_LBRACE] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3446),
    [anon_sym_register] = ACTIONS(3446),
    [anon_sym_inline] = ACTIONS(3446),
    [anon_sym_const] = ACTIONS(3446),
    [anon_sym_restrict] = ACTIONS(3446),
    [anon_sym_volatile] = ACTIONS(3446),
    [anon_sym__Atomic] = ACTIONS(3446),
    [anon_sym_mutable] = ACTIONS(3446),
    [anon_sym_explicit] = ACTIONS(3446),
    [anon_sym_constexpr] = ACTIONS(3446),
    [anon_sym_unsigned] = ACTIONS(3446),
    [anon_sym_long] = ACTIONS(3446),
    [anon_sym_short] = ACTIONS(3446),
    [sym_primitive_type] = ACTIONS(3446),
    [anon_sym_enum] = ACTIONS(3446),
    [anon_sym_struct] = ACTIONS(3446),
    [anon_sym_union] = ACTIONS(3446),
    [anon_sym_if] = ACTIONS(3446),
    [anon_sym_switch] = ACTIONS(3446),
    [anon_sym_case] = ACTIONS(3446),
    [anon_sym_default] = ACTIONS(3446),
    [anon_sym_while] = ACTIONS(3446),
    [anon_sym_do] = ACTIONS(3446),
    [anon_sym_for] = ACTIONS(3446),
    [anon_sym_return] = ACTIONS(3446),
    [anon_sym_break] = ACTIONS(3446),
    [anon_sym_continue] = ACTIONS(3446),
    [anon_sym_goto] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3446),
    [anon_sym_DASH_DASH] = ACTIONS(3444),
    [anon_sym_PLUS_PLUS] = ACTIONS(3444),
    [anon_sym_sizeof] = ACTIONS(3446),
    [sym_number_literal] = ACTIONS(3444),
    [sym_char_literal] = ACTIONS(3444),
    [sym_string_literal] = ACTIONS(3444),
    [sym_true] = ACTIONS(3446),
    [sym_false] = ACTIONS(3446),
    [sym_null] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3446),
    [sym_auto] = ACTIONS(3446),
    [anon_sym_typename] = ACTIONS(3446),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3446),
    [sym_nullptr] = ACTIONS(3446),
  },
  [2917] = {
    [sym_raw_string_literal] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6328),
    [sym_preproc_directive] = ACTIONS(6328),
    [anon_sym_SEMI] = ACTIONS(6326),
    [anon_sym_typedef] = ACTIONS(6328),
    [anon_sym_extern] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6326),
    [anon_sym_STAR] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6326),
    [anon_sym_static] = ACTIONS(6328),
    [anon_sym_register] = ACTIONS(6328),
    [anon_sym_inline] = ACTIONS(6328),
    [anon_sym_const] = ACTIONS(6328),
    [anon_sym_restrict] = ACTIONS(6328),
    [anon_sym_volatile] = ACTIONS(6328),
    [anon_sym__Atomic] = ACTIONS(6328),
    [anon_sym_mutable] = ACTIONS(6328),
    [anon_sym_explicit] = ACTIONS(6328),
    [anon_sym_constexpr] = ACTIONS(6328),
    [anon_sym_unsigned] = ACTIONS(6328),
    [anon_sym_long] = ACTIONS(6328),
    [anon_sym_short] = ACTIONS(6328),
    [sym_primitive_type] = ACTIONS(6328),
    [anon_sym_enum] = ACTIONS(6328),
    [anon_sym_struct] = ACTIONS(6328),
    [anon_sym_union] = ACTIONS(6328),
    [anon_sym_if] = ACTIONS(6328),
    [anon_sym_switch] = ACTIONS(6328),
    [anon_sym_case] = ACTIONS(6328),
    [anon_sym_default] = ACTIONS(6328),
    [anon_sym_while] = ACTIONS(6328),
    [anon_sym_do] = ACTIONS(6328),
    [anon_sym_for] = ACTIONS(6328),
    [anon_sym_return] = ACTIONS(6328),
    [anon_sym_break] = ACTIONS(6328),
    [anon_sym_continue] = ACTIONS(6328),
    [anon_sym_goto] = ACTIONS(6328),
    [anon_sym_AMP] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_TILDE] = ACTIONS(6326),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_DASH_DASH] = ACTIONS(6326),
    [anon_sym_PLUS_PLUS] = ACTIONS(6326),
    [anon_sym_sizeof] = ACTIONS(6328),
    [sym_number_literal] = ACTIONS(6326),
    [sym_char_literal] = ACTIONS(6326),
    [sym_string_literal] = ACTIONS(6326),
    [sym_true] = ACTIONS(6328),
    [sym_false] = ACTIONS(6328),
    [sym_null] = ACTIONS(6328),
    [sym_identifier] = ACTIONS(6328),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6328),
    [sym_auto] = ACTIONS(6328),
    [anon_sym_typename] = ACTIONS(6328),
    [anon_sym_new] = ACTIONS(6328),
    [anon_sym_COLON_COLON] = ACTIONS(6326),
    [anon_sym_delete] = ACTIONS(6328),
    [sym_nullptr] = ACTIONS(6328),
  },
  [2918] = {
    [sym_raw_string_literal] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6332),
    [sym_preproc_directive] = ACTIONS(6332),
    [anon_sym_SEMI] = ACTIONS(6330),
    [anon_sym_typedef] = ACTIONS(6332),
    [anon_sym_extern] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6330),
    [anon_sym_STAR] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6330),
    [anon_sym_static] = ACTIONS(6332),
    [anon_sym_register] = ACTIONS(6332),
    [anon_sym_inline] = ACTIONS(6332),
    [anon_sym_const] = ACTIONS(6332),
    [anon_sym_restrict] = ACTIONS(6332),
    [anon_sym_volatile] = ACTIONS(6332),
    [anon_sym__Atomic] = ACTIONS(6332),
    [anon_sym_mutable] = ACTIONS(6332),
    [anon_sym_explicit] = ACTIONS(6332),
    [anon_sym_constexpr] = ACTIONS(6332),
    [anon_sym_unsigned] = ACTIONS(6332),
    [anon_sym_long] = ACTIONS(6332),
    [anon_sym_short] = ACTIONS(6332),
    [sym_primitive_type] = ACTIONS(6332),
    [anon_sym_enum] = ACTIONS(6332),
    [anon_sym_struct] = ACTIONS(6332),
    [anon_sym_union] = ACTIONS(6332),
    [anon_sym_if] = ACTIONS(6332),
    [anon_sym_switch] = ACTIONS(6332),
    [anon_sym_case] = ACTIONS(6332),
    [anon_sym_default] = ACTIONS(6332),
    [anon_sym_while] = ACTIONS(6332),
    [anon_sym_do] = ACTIONS(6332),
    [anon_sym_for] = ACTIONS(6332),
    [anon_sym_return] = ACTIONS(6332),
    [anon_sym_break] = ACTIONS(6332),
    [anon_sym_continue] = ACTIONS(6332),
    [anon_sym_goto] = ACTIONS(6332),
    [anon_sym_AMP] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_TILDE] = ACTIONS(6330),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_DASH_DASH] = ACTIONS(6330),
    [anon_sym_PLUS_PLUS] = ACTIONS(6330),
    [anon_sym_sizeof] = ACTIONS(6332),
    [sym_number_literal] = ACTIONS(6330),
    [sym_char_literal] = ACTIONS(6330),
    [sym_string_literal] = ACTIONS(6330),
    [sym_true] = ACTIONS(6332),
    [sym_false] = ACTIONS(6332),
    [sym_null] = ACTIONS(6332),
    [sym_identifier] = ACTIONS(6332),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6332),
    [sym_auto] = ACTIONS(6332),
    [anon_sym_typename] = ACTIONS(6332),
    [anon_sym_new] = ACTIONS(6332),
    [anon_sym_COLON_COLON] = ACTIONS(6330),
    [anon_sym_delete] = ACTIONS(6332),
    [sym_nullptr] = ACTIONS(6332),
  },
  [2919] = {
    [sym_raw_string_literal] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6336),
    [sym_preproc_directive] = ACTIONS(6336),
    [anon_sym_SEMI] = ACTIONS(6334),
    [anon_sym_typedef] = ACTIONS(6336),
    [anon_sym_extern] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6334),
    [anon_sym_STAR] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6334),
    [anon_sym_static] = ACTIONS(6336),
    [anon_sym_register] = ACTIONS(6336),
    [anon_sym_inline] = ACTIONS(6336),
    [anon_sym_const] = ACTIONS(6336),
    [anon_sym_restrict] = ACTIONS(6336),
    [anon_sym_volatile] = ACTIONS(6336),
    [anon_sym__Atomic] = ACTIONS(6336),
    [anon_sym_mutable] = ACTIONS(6336),
    [anon_sym_explicit] = ACTIONS(6336),
    [anon_sym_constexpr] = ACTIONS(6336),
    [anon_sym_unsigned] = ACTIONS(6336),
    [anon_sym_long] = ACTIONS(6336),
    [anon_sym_short] = ACTIONS(6336),
    [sym_primitive_type] = ACTIONS(6336),
    [anon_sym_enum] = ACTIONS(6336),
    [anon_sym_struct] = ACTIONS(6336),
    [anon_sym_union] = ACTIONS(6336),
    [anon_sym_if] = ACTIONS(6336),
    [anon_sym_switch] = ACTIONS(6336),
    [anon_sym_case] = ACTIONS(6336),
    [anon_sym_default] = ACTIONS(6336),
    [anon_sym_while] = ACTIONS(6336),
    [anon_sym_do] = ACTIONS(6336),
    [anon_sym_for] = ACTIONS(6336),
    [anon_sym_return] = ACTIONS(6336),
    [anon_sym_break] = ACTIONS(6336),
    [anon_sym_continue] = ACTIONS(6336),
    [anon_sym_goto] = ACTIONS(6336),
    [anon_sym_AMP] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_TILDE] = ACTIONS(6334),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_DASH_DASH] = ACTIONS(6334),
    [anon_sym_PLUS_PLUS] = ACTIONS(6334),
    [anon_sym_sizeof] = ACTIONS(6336),
    [sym_number_literal] = ACTIONS(6334),
    [sym_char_literal] = ACTIONS(6334),
    [sym_string_literal] = ACTIONS(6334),
    [sym_true] = ACTIONS(6336),
    [sym_false] = ACTIONS(6336),
    [sym_null] = ACTIONS(6336),
    [sym_identifier] = ACTIONS(6336),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6336),
    [sym_auto] = ACTIONS(6336),
    [anon_sym_typename] = ACTIONS(6336),
    [anon_sym_new] = ACTIONS(6336),
    [anon_sym_COLON_COLON] = ACTIONS(6334),
    [anon_sym_delete] = ACTIONS(6336),
    [sym_nullptr] = ACTIONS(6336),
  },
  [2920] = {
    [sym_raw_string_literal] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6340),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6338),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6338),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6338),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [anon_sym_if] = ACTIONS(6340),
    [anon_sym_switch] = ACTIONS(6340),
    [anon_sym_case] = ACTIONS(6340),
    [anon_sym_default] = ACTIONS(6340),
    [anon_sym_while] = ACTIONS(6340),
    [anon_sym_do] = ACTIONS(6340),
    [anon_sym_for] = ACTIONS(6340),
    [anon_sym_return] = ACTIONS(6340),
    [anon_sym_break] = ACTIONS(6340),
    [anon_sym_continue] = ACTIONS(6340),
    [anon_sym_goto] = ACTIONS(6340),
    [anon_sym_AMP] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_TILDE] = ACTIONS(6338),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_DASH_DASH] = ACTIONS(6338),
    [anon_sym_PLUS_PLUS] = ACTIONS(6338),
    [anon_sym_sizeof] = ACTIONS(6340),
    [sym_number_literal] = ACTIONS(6338),
    [sym_char_literal] = ACTIONS(6338),
    [sym_string_literal] = ACTIONS(6338),
    [sym_true] = ACTIONS(6340),
    [sym_false] = ACTIONS(6340),
    [sym_null] = ACTIONS(6340),
    [sym_identifier] = ACTIONS(6340),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6340),
    [sym_auto] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_new] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6338),
    [anon_sym_delete] = ACTIONS(6340),
    [sym_nullptr] = ACTIONS(6340),
  },
  [2921] = {
    [sym_raw_string_literal] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6342),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6344),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6342),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [anon_sym_if] = ACTIONS(6344),
    [anon_sym_switch] = ACTIONS(6344),
    [anon_sym_case] = ACTIONS(6344),
    [anon_sym_default] = ACTIONS(6344),
    [anon_sym_while] = ACTIONS(6344),
    [anon_sym_do] = ACTIONS(6344),
    [anon_sym_for] = ACTIONS(6344),
    [anon_sym_return] = ACTIONS(6344),
    [anon_sym_break] = ACTIONS(6344),
    [anon_sym_continue] = ACTIONS(6344),
    [anon_sym_goto] = ACTIONS(6344),
    [anon_sym_AMP] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_DASH_DASH] = ACTIONS(6342),
    [anon_sym_PLUS_PLUS] = ACTIONS(6342),
    [anon_sym_sizeof] = ACTIONS(6344),
    [sym_number_literal] = ACTIONS(6342),
    [sym_char_literal] = ACTIONS(6342),
    [sym_string_literal] = ACTIONS(6342),
    [sym_true] = ACTIONS(6344),
    [sym_false] = ACTIONS(6344),
    [sym_null] = ACTIONS(6344),
    [sym_identifier] = ACTIONS(6344),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6344),
    [sym_auto] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_new] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_delete] = ACTIONS(6344),
    [sym_nullptr] = ACTIONS(6344),
  },
  [2922] = {
    [sym_raw_string_literal] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6346),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [anon_sym_if] = ACTIONS(6348),
    [anon_sym_switch] = ACTIONS(6348),
    [anon_sym_case] = ACTIONS(6348),
    [anon_sym_default] = ACTIONS(6348),
    [anon_sym_while] = ACTIONS(6348),
    [anon_sym_do] = ACTIONS(6348),
    [anon_sym_for] = ACTIONS(6348),
    [anon_sym_return] = ACTIONS(6348),
    [anon_sym_break] = ACTIONS(6348),
    [anon_sym_continue] = ACTIONS(6348),
    [anon_sym_goto] = ACTIONS(6348),
    [anon_sym_AMP] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_DASH_DASH] = ACTIONS(6346),
    [anon_sym_PLUS_PLUS] = ACTIONS(6346),
    [anon_sym_sizeof] = ACTIONS(6348),
    [sym_number_literal] = ACTIONS(6346),
    [sym_char_literal] = ACTIONS(6346),
    [sym_string_literal] = ACTIONS(6346),
    [sym_true] = ACTIONS(6348),
    [sym_false] = ACTIONS(6348),
    [sym_null] = ACTIONS(6348),
    [sym_identifier] = ACTIONS(6348),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6348),
    [sym_auto] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_new] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_delete] = ACTIONS(6348),
    [sym_nullptr] = ACTIONS(6348),
  },
  [2923] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [2924] = {
    [sym_raw_string_literal] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_mutable] = ACTIONS(1674),
    [anon_sym_explicit] = ACTIONS(1674),
    [anon_sym_constexpr] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [sym_char_literal] = ACTIONS(1672),
    [sym_string_literal] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1674),
    [sym_auto] = ACTIONS(1674),
    [anon_sym_typename] = ACTIONS(1674),
    [anon_sym_new] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1672),
    [anon_sym_delete] = ACTIONS(1674),
    [sym_nullptr] = ACTIONS(1674),
  },
  [2925] = {
    [sym_preproc_include] = STATE(3024),
    [sym_preproc_def] = STATE(3024),
    [sym_preproc_function_def] = STATE(3024),
    [sym_preproc_call] = STATE(3024),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(3024),
    [sym_type_definition] = STATE(3024),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(3024),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(3024),
    [sym_expression_statement] = STATE(3024),
    [sym_if_statement] = STATE(3024),
    [sym_switch_statement] = STATE(3024),
    [sym_case_statement] = STATE(3024),
    [sym_while_statement] = STATE(3024),
    [sym_do_statement] = STATE(3024),
    [sym_for_statement] = STATE(3024),
    [sym_return_statement] = STATE(3024),
    [sym_break_statement] = STATE(3024),
    [sym_continue_statement] = STATE(3024),
    [sym_goto_statement] = STATE(3024),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(3024),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(3024),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(3024),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(3024),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(7067),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2926] = {
    [anon_sym_LPAREN] = ACTIONS(7069),
    [anon_sym_constexpr] = ACTIONS(7071),
    [sym_comment] = ACTIONS(49),
  },
  [2927] = {
    [anon_sym_LPAREN] = ACTIONS(7073),
    [sym_comment] = ACTIONS(49),
  },
  [2928] = {
    [sym__expression] = STATE(3028),
    [sym_conditional_expression] = STATE(3028),
    [sym_assignment_expression] = STATE(3028),
    [sym_pointer_expression] = STATE(3028),
    [sym_logical_expression] = STATE(3028),
    [sym_bitwise_expression] = STATE(3028),
    [sym_equality_expression] = STATE(3028),
    [sym_relational_expression] = STATE(3028),
    [sym_shift_expression] = STATE(3028),
    [sym_math_expression] = STATE(3028),
    [sym_cast_expression] = STATE(3028),
    [sym_sizeof_expression] = STATE(3028),
    [sym_subscript_expression] = STATE(3028),
    [sym_call_expression] = STATE(3028),
    [sym_field_expression] = STATE(3028),
    [sym_compound_literal_expression] = STATE(3028),
    [sym_parenthesized_expression] = STATE(3028),
    [sym_concatenated_string] = STATE(3028),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3028),
    [sym_new_expression] = STATE(3028),
    [sym_delete_expression] = STATE(3028),
    [sym_lambda_expression] = STATE(3028),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(897),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7075),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_DASH] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1702),
    [anon_sym_sizeof] = ACTIONS(1704),
    [sym_number_literal] = ACTIONS(7075),
    [sym_char_literal] = ACTIONS(7075),
    [sym_string_literal] = ACTIONS(1706),
    [sym_true] = ACTIONS(7077),
    [sym_false] = ACTIONS(7077),
    [sym_null] = ACTIONS(7077),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1712),
    [sym_nullptr] = ACTIONS(7077),
  },
  [2929] = {
    [anon_sym_COLON] = ACTIONS(7079),
    [sym_comment] = ACTIONS(49),
  },
  [2930] = {
    [anon_sym_LPAREN] = ACTIONS(7081),
    [sym_comment] = ACTIONS(49),
  },
  [2931] = {
    [sym_compound_statement] = STATE(3031),
    [sym_labeled_statement] = STATE(3031),
    [sym_expression_statement] = STATE(3031),
    [sym_if_statement] = STATE(3031),
    [sym_switch_statement] = STATE(3031),
    [sym_case_statement] = STATE(3031),
    [sym_while_statement] = STATE(3031),
    [sym_do_statement] = STATE(3031),
    [sym_for_statement] = STATE(3031),
    [sym_return_statement] = STATE(3031),
    [sym_break_statement] = STATE(3031),
    [sym_continue_statement] = STATE(3031),
    [sym_goto_statement] = STATE(3031),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3031),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2932] = {
    [anon_sym_LPAREN] = ACTIONS(7083),
    [sym_comment] = ACTIONS(49),
  },
  [2933] = {
    [sym__expression] = STATE(3034),
    [sym_conditional_expression] = STATE(3034),
    [sym_assignment_expression] = STATE(3034),
    [sym_pointer_expression] = STATE(3034),
    [sym_logical_expression] = STATE(3034),
    [sym_bitwise_expression] = STATE(3034),
    [sym_equality_expression] = STATE(3034),
    [sym_relational_expression] = STATE(3034),
    [sym_shift_expression] = STATE(3034),
    [sym_math_expression] = STATE(3034),
    [sym_cast_expression] = STATE(3034),
    [sym_sizeof_expression] = STATE(3034),
    [sym_subscript_expression] = STATE(3034),
    [sym_call_expression] = STATE(3034),
    [sym_field_expression] = STATE(3034),
    [sym_compound_literal_expression] = STATE(3034),
    [sym_parenthesized_expression] = STATE(3034),
    [sym_initializer_list] = STATE(3035),
    [sym_concatenated_string] = STATE(3034),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3034),
    [sym_new_expression] = STATE(3034),
    [sym_delete_expression] = STATE(3034),
    [sym_lambda_expression] = STATE(3034),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7085),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7087),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7085),
    [sym_char_literal] = ACTIONS(7085),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7089),
    [sym_false] = ACTIONS(7089),
    [sym_null] = ACTIONS(7089),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7089),
  },
  [2934] = {
    [anon_sym_SEMI] = ACTIONS(7091),
    [sym_comment] = ACTIONS(49),
  },
  [2935] = {
    [anon_sym_SEMI] = ACTIONS(7093),
    [sym_comment] = ACTIONS(49),
  },
  [2936] = {
    [sym_identifier] = ACTIONS(7095),
    [sym_comment] = ACTIONS(49),
  },
  [2937] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_COLON] = ACTIONS(7097),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
  },
  [2938] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(7099),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [2939] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(7101),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_QMARK] = ACTIONS(1806),
    [anon_sym_STAR_EQ] = ACTIONS(1808),
    [anon_sym_SLASH_EQ] = ACTIONS(1808),
    [anon_sym_PERCENT_EQ] = ACTIONS(1808),
    [anon_sym_PLUS_EQ] = ACTIONS(1808),
    [anon_sym_DASH_EQ] = ACTIONS(1808),
    [anon_sym_LT_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_GT_EQ] = ACTIONS(1808),
    [anon_sym_AMP_EQ] = ACTIONS(1808),
    [anon_sym_CARET_EQ] = ACTIONS(1808),
    [anon_sym_PIPE_EQ] = ACTIONS(1808),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1822),
    [anon_sym_LT_EQ] = ACTIONS(1824),
    [anon_sym_GT_EQ] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2940] = {
    [anon_sym_SEMI] = ACTIONS(7101),
    [sym_comment] = ACTIONS(49),
  },
  [2941] = {
    [sym_compound_statement] = STATE(3042),
    [sym_labeled_statement] = STATE(3042),
    [sym_expression_statement] = STATE(3042),
    [sym_if_statement] = STATE(3042),
    [sym_switch_statement] = STATE(3042),
    [sym_case_statement] = STATE(3042),
    [sym_while_statement] = STATE(3042),
    [sym_do_statement] = STATE(3042),
    [sym_for_statement] = STATE(3042),
    [sym_return_statement] = STATE(3042),
    [sym_break_statement] = STATE(3042),
    [sym_continue_statement] = STATE(3042),
    [sym_goto_statement] = STATE(3042),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3042),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [2942] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [2943] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [2944] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7103),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2945] = {
    [sym_compound_statement] = STATE(3044),
    [sym_labeled_statement] = STATE(3044),
    [sym_expression_statement] = STATE(3044),
    [sym_if_statement] = STATE(3044),
    [sym_switch_statement] = STATE(3044),
    [sym_case_statement] = STATE(3044),
    [sym_while_statement] = STATE(3044),
    [sym_do_statement] = STATE(3044),
    [sym_for_statement] = STATE(3044),
    [sym_return_statement] = STATE(3044),
    [sym_break_statement] = STATE(3044),
    [sym_continue_statement] = STATE(3044),
    [sym_goto_statement] = STATE(3044),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3044),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [2946] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3046),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7105),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2947] = {
    [sym__expression] = STATE(3047),
    [sym_conditional_expression] = STATE(3047),
    [sym_assignment_expression] = STATE(3047),
    [sym_pointer_expression] = STATE(3047),
    [sym_logical_expression] = STATE(3047),
    [sym_bitwise_expression] = STATE(3047),
    [sym_equality_expression] = STATE(3047),
    [sym_relational_expression] = STATE(3047),
    [sym_shift_expression] = STATE(3047),
    [sym_math_expression] = STATE(3047),
    [sym_cast_expression] = STATE(3047),
    [sym_sizeof_expression] = STATE(3047),
    [sym_subscript_expression] = STATE(3047),
    [sym_call_expression] = STATE(3047),
    [sym_field_expression] = STATE(3047),
    [sym_compound_literal_expression] = STATE(3047),
    [sym_parenthesized_expression] = STATE(3047),
    [sym_concatenated_string] = STATE(3047),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3047),
    [sym_new_expression] = STATE(3047),
    [sym_delete_expression] = STATE(3047),
    [sym_lambda_expression] = STATE(3047),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7107),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7105),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7107),
    [sym_char_literal] = ACTIONS(7107),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7109),
    [sym_false] = ACTIONS(7109),
    [sym_null] = ACTIONS(7109),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7109),
  },
  [2948] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7111),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2949] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7113),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2950] = {
    [sym_raw_string_literal] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4174),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4174),
    [sym_preproc_directive] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_typedef] = ACTIONS(4174),
    [anon_sym_extern] = ACTIONS(4174),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4174),
    [anon_sym_inline] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_explicit] = ACTIONS(4174),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [sym_primitive_type] = ACTIONS(4174),
    [anon_sym_enum] = ACTIONS(4174),
    [anon_sym_struct] = ACTIONS(4174),
    [anon_sym_union] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_switch] = ACTIONS(4174),
    [anon_sym_case] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_break] = ACTIONS(4174),
    [anon_sym_continue] = ACTIONS(4174),
    [anon_sym_goto] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_BANG] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_sizeof] = ACTIONS(4174),
    [sym_number_literal] = ACTIONS(4172),
    [sym_char_literal] = ACTIONS(4172),
    [sym_string_literal] = ACTIONS(4172),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_null] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4174),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4174),
    [sym_auto] = ACTIONS(4174),
    [anon_sym_typename] = ACTIONS(4174),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_delete] = ACTIONS(4174),
    [sym_nullptr] = ACTIONS(4174),
  },
  [2951] = {
    [sym_raw_string_literal] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4222),
    [sym_preproc_directive] = ACTIONS(4222),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym_typedef] = ACTIONS(4222),
    [anon_sym_extern] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4222),
    [anon_sym_register] = ACTIONS(4222),
    [anon_sym_inline] = ACTIONS(4222),
    [anon_sym_const] = ACTIONS(4222),
    [anon_sym_restrict] = ACTIONS(4222),
    [anon_sym_volatile] = ACTIONS(4222),
    [anon_sym__Atomic] = ACTIONS(4222),
    [anon_sym_mutable] = ACTIONS(4222),
    [anon_sym_explicit] = ACTIONS(4222),
    [anon_sym_constexpr] = ACTIONS(4222),
    [anon_sym_unsigned] = ACTIONS(4222),
    [anon_sym_long] = ACTIONS(4222),
    [anon_sym_short] = ACTIONS(4222),
    [sym_primitive_type] = ACTIONS(4222),
    [anon_sym_enum] = ACTIONS(4222),
    [anon_sym_struct] = ACTIONS(4222),
    [anon_sym_union] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_switch] = ACTIONS(4222),
    [anon_sym_case] = ACTIONS(4222),
    [anon_sym_default] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_do] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_return] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4222),
    [anon_sym_continue] = ACTIONS(4222),
    [anon_sym_goto] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_BANG] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4222),
    [anon_sym_DASH] = ACTIONS(4222),
    [anon_sym_DASH_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_PLUS] = ACTIONS(4220),
    [anon_sym_sizeof] = ACTIONS(4222),
    [sym_number_literal] = ACTIONS(4220),
    [sym_char_literal] = ACTIONS(4220),
    [sym_string_literal] = ACTIONS(4220),
    [sym_true] = ACTIONS(4222),
    [sym_false] = ACTIONS(4222),
    [sym_null] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4222),
    [sym_auto] = ACTIONS(4222),
    [anon_sym_typename] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4220),
    [anon_sym_delete] = ACTIONS(4222),
    [sym_nullptr] = ACTIONS(4222),
  },
  [2952] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [2953] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(7115),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [2954] = {
    [sym__expression] = STATE(3051),
    [sym_conditional_expression] = STATE(3051),
    [sym_assignment_expression] = STATE(3051),
    [sym_pointer_expression] = STATE(3051),
    [sym_logical_expression] = STATE(3051),
    [sym_bitwise_expression] = STATE(3051),
    [sym_equality_expression] = STATE(3051),
    [sym_relational_expression] = STATE(3051),
    [sym_shift_expression] = STATE(3051),
    [sym_math_expression] = STATE(3051),
    [sym_cast_expression] = STATE(3051),
    [sym_sizeof_expression] = STATE(3051),
    [sym_subscript_expression] = STATE(3051),
    [sym_call_expression] = STATE(3051),
    [sym_field_expression] = STATE(3051),
    [sym_compound_literal_expression] = STATE(3051),
    [sym_parenthesized_expression] = STATE(3051),
    [sym_concatenated_string] = STATE(3051),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3051),
    [sym_new_expression] = STATE(3051),
    [sym_delete_expression] = STATE(3051),
    [sym_lambda_expression] = STATE(3051),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7117),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7117),
    [sym_char_literal] = ACTIONS(7117),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7119),
    [sym_false] = ACTIONS(7119),
    [sym_null] = ACTIONS(7119),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7119),
  },
  [2955] = {
    [anon_sym_LPAREN] = ACTIONS(7121),
    [sym_comment] = ACTIONS(49),
  },
  [2956] = {
    [sym__expression] = STATE(3053),
    [sym_conditional_expression] = STATE(3053),
    [sym_assignment_expression] = STATE(3053),
    [sym_pointer_expression] = STATE(3053),
    [sym_logical_expression] = STATE(3053),
    [sym_bitwise_expression] = STATE(3053),
    [sym_equality_expression] = STATE(3053),
    [sym_relational_expression] = STATE(3053),
    [sym_shift_expression] = STATE(3053),
    [sym_math_expression] = STATE(3053),
    [sym_cast_expression] = STATE(3053),
    [sym_sizeof_expression] = STATE(3053),
    [sym_subscript_expression] = STATE(3053),
    [sym_call_expression] = STATE(3053),
    [sym_field_expression] = STATE(3053),
    [sym_compound_literal_expression] = STATE(3053),
    [sym_parenthesized_expression] = STATE(3053),
    [sym_concatenated_string] = STATE(3053),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3053),
    [sym_new_expression] = STATE(3053),
    [sym_delete_expression] = STATE(3053),
    [sym_lambda_expression] = STATE(3053),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7123),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7123),
    [sym_char_literal] = ACTIONS(7123),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7125),
    [sym_false] = ACTIONS(7125),
    [sym_null] = ACTIONS(7125),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7125),
  },
  [2957] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(7127),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [2958] = {
    [sym_declaration] = STATE(3057),
    [sym_type_definition] = STATE(3057),
    [sym__declaration_specifiers] = STATE(3058),
    [sym_compound_statement] = STATE(3057),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(3057),
    [sym_expression_statement] = STATE(3057),
    [sym_if_statement] = STATE(3057),
    [sym_switch_statement] = STATE(3057),
    [sym_case_statement] = STATE(3057),
    [sym_while_statement] = STATE(3057),
    [sym_do_statement] = STATE(3057),
    [sym_for_statement] = STATE(3057),
    [sym_return_statement] = STATE(3057),
    [sym_break_statement] = STATE(3057),
    [sym_continue_statement] = STATE(3057),
    [sym_goto_statement] = STATE(3057),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3057),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_typedef] = ACTIONS(7129),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(7131),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [2959] = {
    [sym__expression] = STATE(3059),
    [sym_conditional_expression] = STATE(3059),
    [sym_assignment_expression] = STATE(3059),
    [sym_pointer_expression] = STATE(3059),
    [sym_logical_expression] = STATE(3059),
    [sym_bitwise_expression] = STATE(3059),
    [sym_equality_expression] = STATE(3059),
    [sym_relational_expression] = STATE(3059),
    [sym_shift_expression] = STATE(3059),
    [sym_math_expression] = STATE(3059),
    [sym_cast_expression] = STATE(3059),
    [sym_sizeof_expression] = STATE(3059),
    [sym_subscript_expression] = STATE(3059),
    [sym_call_expression] = STATE(3059),
    [sym_field_expression] = STATE(3059),
    [sym_compound_literal_expression] = STATE(3059),
    [sym_parenthesized_expression] = STATE(3059),
    [sym_concatenated_string] = STATE(3059),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3059),
    [sym_new_expression] = STATE(3059),
    [sym_delete_expression] = STATE(3059),
    [sym_lambda_expression] = STATE(3059),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7133),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7133),
    [sym_char_literal] = ACTIONS(7133),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7135),
    [sym_false] = ACTIONS(7135),
    [sym_null] = ACTIONS(7135),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7135),
  },
  [2960] = {
    [anon_sym_while] = ACTIONS(7137),
    [sym_comment] = ACTIONS(49),
  },
  [2961] = {
    [sym_declaration] = STATE(3061),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(3062),
    [sym_conditional_expression] = STATE(3062),
    [sym_assignment_expression] = STATE(3062),
    [sym_pointer_expression] = STATE(3062),
    [sym_logical_expression] = STATE(3062),
    [sym_bitwise_expression] = STATE(3062),
    [sym_equality_expression] = STATE(3062),
    [sym_relational_expression] = STATE(3062),
    [sym_shift_expression] = STATE(3062),
    [sym_math_expression] = STATE(3062),
    [sym_cast_expression] = STATE(3062),
    [sym_sizeof_expression] = STATE(3062),
    [sym_subscript_expression] = STATE(3062),
    [sym_call_expression] = STATE(3062),
    [sym_field_expression] = STATE(3062),
    [sym_compound_literal_expression] = STATE(3062),
    [sym_parenthesized_expression] = STATE(3062),
    [sym_concatenated_string] = STATE(3062),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(3062),
    [sym_for_range_declaration] = STATE(3063),
    [sym_new_expression] = STATE(3062),
    [sym_delete_expression] = STATE(3062),
    [sym_lambda_expression] = STATE(3062),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(7139),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7141),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7139),
    [sym_char_literal] = ACTIONS(7139),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7143),
    [sym_false] = ACTIONS(7143),
    [sym_null] = ACTIONS(7143),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7143),
  },
  [2962] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_else] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [2963] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7145),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2964] = {
    [anon_sym_SEMI] = ACTIONS(7145),
    [sym_comment] = ACTIONS(49),
  },
  [2965] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [2966] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [2967] = {
    [anon_sym_SEMI] = ACTIONS(7147),
    [sym_comment] = ACTIONS(49),
  },
  [2968] = {
    [sym_compound_statement] = STATE(3066),
    [sym_labeled_statement] = STATE(3066),
    [sym_expression_statement] = STATE(3066),
    [sym_if_statement] = STATE(3066),
    [sym_switch_statement] = STATE(3066),
    [sym_case_statement] = STATE(3066),
    [sym_while_statement] = STATE(3066),
    [sym_do_statement] = STATE(3066),
    [sym_for_statement] = STATE(3066),
    [sym_return_statement] = STATE(3066),
    [sym_break_statement] = STATE(3066),
    [sym_continue_statement] = STATE(3066),
    [sym_goto_statement] = STATE(3066),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3066),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [2969] = {
    [sym_compound_statement] = STATE(3067),
    [sym_labeled_statement] = STATE(3067),
    [sym_expression_statement] = STATE(3067),
    [sym_if_statement] = STATE(3067),
    [sym_switch_statement] = STATE(3067),
    [sym_case_statement] = STATE(3067),
    [sym_while_statement] = STATE(3067),
    [sym_do_statement] = STATE(3067),
    [sym_for_statement] = STATE(3067),
    [sym_return_statement] = STATE(3067),
    [sym_break_statement] = STATE(3067),
    [sym_continue_statement] = STATE(3067),
    [sym_goto_statement] = STATE(3067),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3067),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2970] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [2971] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(7149),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [2972] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [2973] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [2974] = {
    [sym_compound_statement] = STATE(3069),
    [sym_labeled_statement] = STATE(3069),
    [sym_expression_statement] = STATE(3069),
    [sym_if_statement] = STATE(3069),
    [sym_switch_statement] = STATE(3069),
    [sym_case_statement] = STATE(3069),
    [sym_while_statement] = STATE(3069),
    [sym_do_statement] = STATE(3069),
    [sym_for_statement] = STATE(3069),
    [sym_return_statement] = STATE(3069),
    [sym_break_statement] = STATE(3069),
    [sym_continue_statement] = STATE(3069),
    [sym_goto_statement] = STATE(3069),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3069),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2975] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7151),
    [sym_comment] = ACTIONS(49),
  },
  [2976] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3071),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7151),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2977] = {
    [sym__expression] = STATE(3072),
    [sym_conditional_expression] = STATE(3072),
    [sym_assignment_expression] = STATE(3072),
    [sym_pointer_expression] = STATE(3072),
    [sym_logical_expression] = STATE(3072),
    [sym_bitwise_expression] = STATE(3072),
    [sym_equality_expression] = STATE(3072),
    [sym_relational_expression] = STATE(3072),
    [sym_shift_expression] = STATE(3072),
    [sym_math_expression] = STATE(3072),
    [sym_cast_expression] = STATE(3072),
    [sym_sizeof_expression] = STATE(3072),
    [sym_subscript_expression] = STATE(3072),
    [sym_call_expression] = STATE(3072),
    [sym_field_expression] = STATE(3072),
    [sym_compound_literal_expression] = STATE(3072),
    [sym_parenthesized_expression] = STATE(3072),
    [sym_concatenated_string] = STATE(3072),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3072),
    [sym_new_expression] = STATE(3072),
    [sym_delete_expression] = STATE(3072),
    [sym_lambda_expression] = STATE(3072),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7153),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7151),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7153),
    [sym_char_literal] = ACTIONS(7153),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7155),
    [sym_false] = ACTIONS(7155),
    [sym_null] = ACTIONS(7155),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7155),
  },
  [2978] = {
    [sym_compound_statement] = STATE(3073),
    [sym_labeled_statement] = STATE(3073),
    [sym_expression_statement] = STATE(3073),
    [sym_if_statement] = STATE(3073),
    [sym_switch_statement] = STATE(3073),
    [sym_case_statement] = STATE(3073),
    [sym_while_statement] = STATE(3073),
    [sym_do_statement] = STATE(3073),
    [sym_for_statement] = STATE(3073),
    [sym_return_statement] = STATE(3073),
    [sym_break_statement] = STATE(3073),
    [sym_continue_statement] = STATE(3073),
    [sym_goto_statement] = STATE(3073),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3073),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [2979] = {
    [sym_compound_statement] = STATE(3074),
    [sym_labeled_statement] = STATE(3074),
    [sym_expression_statement] = STATE(3074),
    [sym_if_statement] = STATE(3074),
    [sym_switch_statement] = STATE(3074),
    [sym_case_statement] = STATE(3074),
    [sym_while_statement] = STATE(3074),
    [sym_do_statement] = STATE(3074),
    [sym_for_statement] = STATE(3074),
    [sym_return_statement] = STATE(3074),
    [sym_break_statement] = STATE(3074),
    [sym_continue_statement] = STATE(3074),
    [sym_goto_statement] = STATE(3074),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3074),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2980] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7157),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2981] = {
    [sym_compound_statement] = STATE(3076),
    [sym_labeled_statement] = STATE(3076),
    [sym_expression_statement] = STATE(3076),
    [sym_if_statement] = STATE(3076),
    [sym_switch_statement] = STATE(3076),
    [sym_case_statement] = STATE(3076),
    [sym_while_statement] = STATE(3076),
    [sym_do_statement] = STATE(3076),
    [sym_for_statement] = STATE(3076),
    [sym_return_statement] = STATE(3076),
    [sym_break_statement] = STATE(3076),
    [sym_continue_statement] = STATE(3076),
    [sym_goto_statement] = STATE(3076),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3076),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2982] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_RBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_else] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [2983] = {
    [sym__type_declarator] = STATE(3077),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [2984] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(3078),
    [sym_sized_type_specifier] = STATE(3078),
    [sym_enum_specifier] = STATE(3078),
    [sym_struct_specifier] = STATE(3078),
    [sym_union_specifier] = STATE(3078),
    [sym_macro_type_specifier] = STATE(3078),
    [sym_class_specifier] = STATE(3078),
    [sym_dependent_type] = STATE(3078),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7159),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7159),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [2985] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(3080),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7161),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [2986] = {
    [aux_sym_declaration_repeat1] = STATE(3080),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7161),
    [sym_comment] = ACTIONS(49),
  },
  [2987] = {
    [sym_compound_statement] = STATE(3081),
    [sym_labeled_statement] = STATE(3081),
    [sym_expression_statement] = STATE(3081),
    [sym_if_statement] = STATE(3081),
    [sym_switch_statement] = STATE(3081),
    [sym_case_statement] = STATE(3081),
    [sym_while_statement] = STATE(3081),
    [sym_do_statement] = STATE(3081),
    [sym_for_statement] = STATE(3081),
    [sym_return_statement] = STATE(3081),
    [sym_break_statement] = STATE(3081),
    [sym_continue_statement] = STATE(3081),
    [sym_goto_statement] = STATE(3081),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3081),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [2988] = {
    [sym__expression] = STATE(3082),
    [sym_conditional_expression] = STATE(3082),
    [sym_assignment_expression] = STATE(3082),
    [sym_pointer_expression] = STATE(3082),
    [sym_logical_expression] = STATE(3082),
    [sym_bitwise_expression] = STATE(3082),
    [sym_equality_expression] = STATE(3082),
    [sym_relational_expression] = STATE(3082),
    [sym_shift_expression] = STATE(3082),
    [sym_math_expression] = STATE(3082),
    [sym_cast_expression] = STATE(3082),
    [sym_sizeof_expression] = STATE(3082),
    [sym_subscript_expression] = STATE(3082),
    [sym_call_expression] = STATE(3082),
    [sym_field_expression] = STATE(3082),
    [sym_compound_literal_expression] = STATE(3082),
    [sym_parenthesized_expression] = STATE(3082),
    [sym_concatenated_string] = STATE(3082),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3082),
    [sym_new_expression] = STATE(3082),
    [sym_delete_expression] = STATE(3082),
    [sym_lambda_expression] = STATE(3082),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7163),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7163),
    [sym_char_literal] = ACTIONS(7163),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7165),
    [sym_false] = ACTIONS(7165),
    [sym_null] = ACTIONS(7165),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7165),
  },
  [2989] = {
    [sym__expression] = STATE(3084),
    [sym_conditional_expression] = STATE(3084),
    [sym_assignment_expression] = STATE(3084),
    [sym_pointer_expression] = STATE(3084),
    [sym_logical_expression] = STATE(3084),
    [sym_bitwise_expression] = STATE(3084),
    [sym_equality_expression] = STATE(3084),
    [sym_relational_expression] = STATE(3084),
    [sym_shift_expression] = STATE(3084),
    [sym_math_expression] = STATE(3084),
    [sym_cast_expression] = STATE(3084),
    [sym_sizeof_expression] = STATE(3084),
    [sym_subscript_expression] = STATE(3084),
    [sym_call_expression] = STATE(3084),
    [sym_field_expression] = STATE(3084),
    [sym_compound_literal_expression] = STATE(3084),
    [sym_parenthesized_expression] = STATE(3084),
    [sym_concatenated_string] = STATE(3084),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3084),
    [sym_new_expression] = STATE(3084),
    [sym_delete_expression] = STATE(3084),
    [sym_lambda_expression] = STATE(3084),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7167),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7169),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7167),
    [sym_char_literal] = ACTIONS(7167),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7171),
    [sym_false] = ACTIONS(7171),
    [sym_null] = ACTIONS(7171),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7171),
  },
  [2990] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7173),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2991] = {
    [sym__expression] = STATE(3086),
    [sym_conditional_expression] = STATE(3086),
    [sym_assignment_expression] = STATE(3086),
    [sym_pointer_expression] = STATE(3086),
    [sym_logical_expression] = STATE(3086),
    [sym_bitwise_expression] = STATE(3086),
    [sym_equality_expression] = STATE(3086),
    [sym_relational_expression] = STATE(3086),
    [sym_shift_expression] = STATE(3086),
    [sym_math_expression] = STATE(3086),
    [sym_cast_expression] = STATE(3086),
    [sym_sizeof_expression] = STATE(3086),
    [sym_subscript_expression] = STATE(3086),
    [sym_call_expression] = STATE(3086),
    [sym_field_expression] = STATE(3086),
    [sym_compound_literal_expression] = STATE(3086),
    [sym_parenthesized_expression] = STATE(3086),
    [sym_concatenated_string] = STATE(3086),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3086),
    [sym_new_expression] = STATE(3086),
    [sym_delete_expression] = STATE(3086),
    [sym_lambda_expression] = STATE(3086),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7175),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7173),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7175),
    [sym_char_literal] = ACTIONS(7175),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7177),
    [sym_false] = ACTIONS(7177),
    [sym_null] = ACTIONS(7177),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7177),
  },
  [2992] = {
    [sym__expression] = STATE(3087),
    [sym_conditional_expression] = STATE(3087),
    [sym_assignment_expression] = STATE(3087),
    [sym_pointer_expression] = STATE(3087),
    [sym_logical_expression] = STATE(3087),
    [sym_bitwise_expression] = STATE(3087),
    [sym_equality_expression] = STATE(3087),
    [sym_relational_expression] = STATE(3087),
    [sym_shift_expression] = STATE(3087),
    [sym_math_expression] = STATE(3087),
    [sym_cast_expression] = STATE(3087),
    [sym_sizeof_expression] = STATE(3087),
    [sym_subscript_expression] = STATE(3087),
    [sym_call_expression] = STATE(3087),
    [sym_field_expression] = STATE(3087),
    [sym_compound_literal_expression] = STATE(3087),
    [sym_parenthesized_expression] = STATE(3087),
    [sym_concatenated_string] = STATE(3087),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3087),
    [sym_new_expression] = STATE(3087),
    [sym_delete_expression] = STATE(3087),
    [sym_lambda_expression] = STATE(3087),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7179),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7179),
    [sym_char_literal] = ACTIONS(7179),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7181),
    [sym_false] = ACTIONS(7181),
    [sym_null] = ACTIONS(7181),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7181),
  },
  [2993] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_RBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [2994] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7187),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2995] = {
    [sym__expression] = STATE(3089),
    [sym_conditional_expression] = STATE(3089),
    [sym_assignment_expression] = STATE(3089),
    [sym_pointer_expression] = STATE(3089),
    [sym_logical_expression] = STATE(3089),
    [sym_bitwise_expression] = STATE(3089),
    [sym_equality_expression] = STATE(3089),
    [sym_relational_expression] = STATE(3089),
    [sym_shift_expression] = STATE(3089),
    [sym_math_expression] = STATE(3089),
    [sym_cast_expression] = STATE(3089),
    [sym_sizeof_expression] = STATE(3089),
    [sym_subscript_expression] = STATE(3089),
    [sym_call_expression] = STATE(3089),
    [sym_field_expression] = STATE(3089),
    [sym_compound_literal_expression] = STATE(3089),
    [sym_parenthesized_expression] = STATE(3089),
    [sym_concatenated_string] = STATE(3089),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3089),
    [sym_new_expression] = STATE(3089),
    [sym_delete_expression] = STATE(3089),
    [sym_lambda_expression] = STATE(3089),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7189),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7189),
    [sym_char_literal] = ACTIONS(7189),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7191),
    [sym_false] = ACTIONS(7191),
    [sym_null] = ACTIONS(7191),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7191),
  },
  [2996] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7193),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [2997] = {
    [sym_declaration] = STATE(2495),
    [sym_type_definition] = STATE(2495),
    [sym__declaration_specifiers] = STATE(2133),
    [sym_compound_statement] = STATE(2495),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(2495),
    [sym_expression_statement] = STATE(2495),
    [sym_if_statement] = STATE(2495),
    [sym_switch_statement] = STATE(2495),
    [sym_case_statement] = STATE(2495),
    [sym_while_statement] = STATE(2495),
    [sym_do_statement] = STATE(2495),
    [sym_for_statement] = STATE(2495),
    [sym_return_statement] = STATE(2495),
    [sym_break_statement] = STATE(2495),
    [sym_continue_statement] = STATE(2495),
    [sym_goto_statement] = STATE(2495),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2495),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_typedef] = ACTIONS(4777),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(7006),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [2998] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [2999] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7195),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3000] = {
    [sym__expression] = STATE(3093),
    [sym_conditional_expression] = STATE(3093),
    [sym_assignment_expression] = STATE(3093),
    [sym_pointer_expression] = STATE(3093),
    [sym_logical_expression] = STATE(3093),
    [sym_bitwise_expression] = STATE(3093),
    [sym_equality_expression] = STATE(3093),
    [sym_relational_expression] = STATE(3093),
    [sym_shift_expression] = STATE(3093),
    [sym_math_expression] = STATE(3093),
    [sym_cast_expression] = STATE(3093),
    [sym_sizeof_expression] = STATE(3093),
    [sym_subscript_expression] = STATE(3093),
    [sym_call_expression] = STATE(3093),
    [sym_field_expression] = STATE(3093),
    [sym_compound_literal_expression] = STATE(3093),
    [sym_parenthesized_expression] = STATE(3093),
    [sym_concatenated_string] = STATE(3093),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3093),
    [sym_new_expression] = STATE(3093),
    [sym_delete_expression] = STATE(3093),
    [sym_lambda_expression] = STATE(3093),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7199),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7197),
    [sym_char_literal] = ACTIONS(7197),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7201),
    [sym_false] = ACTIONS(7201),
    [sym_null] = ACTIONS(7201),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7201),
  },
  [3001] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7203),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3002] = {
    [anon_sym_COLON] = ACTIONS(7205),
    [sym_comment] = ACTIONS(49),
  },
  [3003] = {
    [anon_sym_else] = ACTIONS(6990),
    [anon_sym_while] = ACTIONS(6990),
    [sym_comment] = ACTIONS(49),
  },
  [3004] = {
    [sym_compound_statement] = STATE(3096),
    [sym_labeled_statement] = STATE(3096),
    [sym_expression_statement] = STATE(3096),
    [sym_if_statement] = STATE(3096),
    [sym_switch_statement] = STATE(3096),
    [sym_case_statement] = STATE(3096),
    [sym_while_statement] = STATE(3096),
    [sym_do_statement] = STATE(3096),
    [sym_for_statement] = STATE(3096),
    [sym_return_statement] = STATE(3096),
    [sym_break_statement] = STATE(3096),
    [sym_continue_statement] = STATE(3096),
    [sym_goto_statement] = STATE(3096),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3096),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3005] = {
    [anon_sym_else] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [sym_comment] = ACTIONS(49),
  },
  [3006] = {
    [anon_sym_else] = ACTIONS(7028),
    [anon_sym_while] = ACTIONS(7028),
    [sym_comment] = ACTIONS(49),
  },
  [3007] = {
    [sym_compound_statement] = STATE(3097),
    [sym_labeled_statement] = STATE(3097),
    [sym_expression_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_switch_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_do_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_return_statement] = STATE(3097),
    [sym_break_statement] = STATE(3097),
    [sym_continue_statement] = STATE(3097),
    [sym_goto_statement] = STATE(3097),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3097),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3008] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7207),
    [sym_comment] = ACTIONS(49),
  },
  [3009] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3099),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3010] = {
    [anon_sym_else] = ACTIONS(7051),
    [anon_sym_while] = ACTIONS(7051),
    [sym_comment] = ACTIONS(49),
  },
  [3011] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_RBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3012] = {
    [sym_compound_statement] = STATE(3100),
    [sym_labeled_statement] = STATE(3100),
    [sym_expression_statement] = STATE(3100),
    [sym_if_statement] = STATE(3100),
    [sym_switch_statement] = STATE(3100),
    [sym_case_statement] = STATE(3100),
    [sym_while_statement] = STATE(3100),
    [sym_do_statement] = STATE(3100),
    [sym_for_statement] = STATE(3100),
    [sym_return_statement] = STATE(3100),
    [sym_break_statement] = STATE(3100),
    [sym_continue_statement] = STATE(3100),
    [sym_goto_statement] = STATE(3100),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(3100),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [3013] = {
    [sym__abstract_declarator] = STATE(3101),
    [sym_abstract_pointer_declarator] = STATE(3101),
    [sym_abstract_function_declarator] = STATE(3101),
    [sym_abstract_array_declarator] = STATE(3101),
    [sym_parameter_list] = STATE(3016),
    [sym_abstract_reference_declarator] = STATE(3101),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(7037),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(7039),
    [anon_sym_AMP_AMP] = ACTIONS(7041),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2342),
  },
  [3014] = {
    [sym__abstract_declarator] = STATE(3102),
    [sym_abstract_pointer_declarator] = STATE(3102),
    [sym_abstract_function_declarator] = STATE(3102),
    [sym_abstract_array_declarator] = STATE(3102),
    [sym_parameter_list] = STATE(3016),
    [sym_abstract_reference_declarator] = STATE(3102),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(7037),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(4482),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(7039),
    [anon_sym_AMP_AMP] = ACTIONS(7041),
    [anon_sym_DASH_GT] = ACTIONS(2350),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2350),
  },
  [3015] = {
    [sym_parameter_list] = STATE(3103),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_const] = ACTIONS(4486),
    [anon_sym_restrict] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym__Atomic] = ACTIONS(4484),
    [anon_sym_mutable] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_constexpr] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4484),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(4484),
  },
  [3016] = {
    [sym_type_qualifier] = STATE(3104),
    [sym_trailing_return_type] = STATE(1182),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3104),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [anon_sym_DASH_GT] = ACTIONS(2356),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(2356),
  },
  [3017] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3017),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_restrict] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym__Atomic] = ACTIONS(850),
    [anon_sym_mutable] = ACTIONS(850),
    [anon_sym_explicit] = ACTIONS(850),
    [anon_sym_constexpr] = ACTIONS(850),
    [anon_sym_unsigned] = ACTIONS(7213),
    [anon_sym_long] = ACTIONS(7213),
    [anon_sym_short] = ACTIONS(7213),
    [sym_primitive_type] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_DASH_GT] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(850),
  },
  [3018] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7216),
    [sym_comment] = ACTIONS(49),
  },
  [3019] = {
    [sym_parameter_list] = STATE(3021),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [3020] = {
    [sym_parameter_list] = STATE(3021),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_COLON] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [3021] = {
    [sym_type_qualifier] = STATE(3106),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3106),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [3022] = {
    [sym_type_qualifier] = STATE(3107),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3107),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7218),
  },
  [3023] = {
    [sym_raw_string_literal] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1682),
    [sym_preproc_directive] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_typedef] = ACTIONS(1682),
    [anon_sym_extern] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_register] = ACTIONS(1682),
    [anon_sym_inline] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_restrict] = ACTIONS(1682),
    [anon_sym_volatile] = ACTIONS(1682),
    [anon_sym__Atomic] = ACTIONS(1682),
    [anon_sym_mutable] = ACTIONS(1682),
    [anon_sym_explicit] = ACTIONS(1682),
    [anon_sym_constexpr] = ACTIONS(1682),
    [anon_sym_unsigned] = ACTIONS(1682),
    [anon_sym_long] = ACTIONS(1682),
    [anon_sym_short] = ACTIONS(1682),
    [sym_primitive_type] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_struct] = ACTIONS(1682),
    [anon_sym_union] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_goto] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_sizeof] = ACTIONS(1682),
    [sym_number_literal] = ACTIONS(1680),
    [sym_char_literal] = ACTIONS(1680),
    [sym_string_literal] = ACTIONS(1680),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1682),
    [sym_auto] = ACTIONS(1682),
    [anon_sym_typename] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_delete] = ACTIONS(1682),
    [sym_nullptr] = ACTIONS(1682),
  },
  [3024] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(431),
    [sym_preproc_ifdef_in_compound_statement] = STATE(432),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(433),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(440),
    [sym_type_qualifier] = STATE(440),
    [sym__type_specifier] = STATE(30),
    [sym_sized_type_specifier] = STATE(30),
    [sym_enum_specifier] = STATE(30),
    [sym_struct_specifier] = STATE(30),
    [sym_union_specifier] = STATE(30),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(30),
    [sym_class_specifier] = STATE(30),
    [sym_dependent_type] = STATE(30),
    [sym_structured_binding_declaration] = STATE(955),
    [sym_template_type] = STATE(436),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(955),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(438),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(440),
    [aux_sym_sized_type_specifier_repeat1] = STATE(38),
    [sym_raw_string_literal] = ACTIONS(652),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(654),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(658),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(662),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(31),
    [anon_sym_long] = ACTIONS(31),
    [anon_sym_short] = ACTIONS(31),
    [sym_primitive_type] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(33),
    [anon_sym_typename] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [3025] = {
    [sym__expression] = STATE(3109),
    [sym_conditional_expression] = STATE(3109),
    [sym_assignment_expression] = STATE(3109),
    [sym_pointer_expression] = STATE(3109),
    [sym_logical_expression] = STATE(3109),
    [sym_bitwise_expression] = STATE(3109),
    [sym_equality_expression] = STATE(3109),
    [sym_relational_expression] = STATE(3109),
    [sym_shift_expression] = STATE(3109),
    [sym_math_expression] = STATE(3109),
    [sym_cast_expression] = STATE(3109),
    [sym_sizeof_expression] = STATE(3109),
    [sym_subscript_expression] = STATE(3109),
    [sym_call_expression] = STATE(3109),
    [sym_field_expression] = STATE(3109),
    [sym_compound_literal_expression] = STATE(3109),
    [sym_parenthesized_expression] = STATE(3109),
    [sym_concatenated_string] = STATE(3109),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3109),
    [sym_new_expression] = STATE(3109),
    [sym_delete_expression] = STATE(3109),
    [sym_lambda_expression] = STATE(3109),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7222),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7222),
    [sym_char_literal] = ACTIONS(7222),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7224),
    [sym_false] = ACTIONS(7224),
    [sym_null] = ACTIONS(7224),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7224),
  },
  [3026] = {
    [anon_sym_LPAREN] = ACTIONS(7226),
    [sym_comment] = ACTIONS(49),
  },
  [3027] = {
    [sym__expression] = STATE(3111),
    [sym_conditional_expression] = STATE(3111),
    [sym_assignment_expression] = STATE(3111),
    [sym_pointer_expression] = STATE(3111),
    [sym_logical_expression] = STATE(3111),
    [sym_bitwise_expression] = STATE(3111),
    [sym_equality_expression] = STATE(3111),
    [sym_relational_expression] = STATE(3111),
    [sym_shift_expression] = STATE(3111),
    [sym_math_expression] = STATE(3111),
    [sym_cast_expression] = STATE(3111),
    [sym_sizeof_expression] = STATE(3111),
    [sym_subscript_expression] = STATE(3111),
    [sym_call_expression] = STATE(3111),
    [sym_field_expression] = STATE(3111),
    [sym_compound_literal_expression] = STATE(3111),
    [sym_parenthesized_expression] = STATE(3111),
    [sym_concatenated_string] = STATE(3111),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3111),
    [sym_new_expression] = STATE(3111),
    [sym_delete_expression] = STATE(3111),
    [sym_lambda_expression] = STATE(3111),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7228),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7228),
    [sym_char_literal] = ACTIONS(7228),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7230),
    [sym_false] = ACTIONS(7230),
    [sym_null] = ACTIONS(7230),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7230),
  },
  [3028] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(7232),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(3125),
    [anon_sym_DASH_GT] = ACTIONS(3125),
    [sym_comment] = ACTIONS(49),
  },
  [3029] = {
    [sym_declaration] = STATE(3115),
    [sym_type_definition] = STATE(3115),
    [sym__declaration_specifiers] = STATE(3116),
    [sym_compound_statement] = STATE(3115),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(3115),
    [sym_expression_statement] = STATE(3115),
    [sym_if_statement] = STATE(3115),
    [sym_switch_statement] = STATE(3115),
    [sym_case_statement] = STATE(3115),
    [sym_while_statement] = STATE(3115),
    [sym_do_statement] = STATE(3115),
    [sym_for_statement] = STATE(3115),
    [sym_return_statement] = STATE(3115),
    [sym_break_statement] = STATE(3115),
    [sym_continue_statement] = STATE(3115),
    [sym_goto_statement] = STATE(3115),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3115),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_typedef] = ACTIONS(7234),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(7236),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3030] = {
    [sym__expression] = STATE(3117),
    [sym_conditional_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3117),
    [sym_pointer_expression] = STATE(3117),
    [sym_logical_expression] = STATE(3117),
    [sym_bitwise_expression] = STATE(3117),
    [sym_equality_expression] = STATE(3117),
    [sym_relational_expression] = STATE(3117),
    [sym_shift_expression] = STATE(3117),
    [sym_math_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_subscript_expression] = STATE(3117),
    [sym_call_expression] = STATE(3117),
    [sym_field_expression] = STATE(3117),
    [sym_compound_literal_expression] = STATE(3117),
    [sym_parenthesized_expression] = STATE(3117),
    [sym_concatenated_string] = STATE(3117),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3117),
    [sym_new_expression] = STATE(3117),
    [sym_delete_expression] = STATE(3117),
    [sym_lambda_expression] = STATE(3117),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7238),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7238),
    [sym_char_literal] = ACTIONS(7238),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7240),
    [sym_false] = ACTIONS(7240),
    [sym_null] = ACTIONS(7240),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7240),
  },
  [3031] = {
    [anon_sym_while] = ACTIONS(7242),
    [sym_comment] = ACTIONS(49),
  },
  [3032] = {
    [sym_declaration] = STATE(3119),
    [sym__declaration_specifiers] = STATE(1566),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(3120),
    [sym_conditional_expression] = STATE(3120),
    [sym_assignment_expression] = STATE(3120),
    [sym_pointer_expression] = STATE(3120),
    [sym_logical_expression] = STATE(3120),
    [sym_bitwise_expression] = STATE(3120),
    [sym_equality_expression] = STATE(3120),
    [sym_relational_expression] = STATE(3120),
    [sym_shift_expression] = STATE(3120),
    [sym_math_expression] = STATE(3120),
    [sym_cast_expression] = STATE(3120),
    [sym_sizeof_expression] = STATE(3120),
    [sym_subscript_expression] = STATE(3120),
    [sym_call_expression] = STATE(3120),
    [sym_field_expression] = STATE(3120),
    [sym_compound_literal_expression] = STATE(3120),
    [sym_parenthesized_expression] = STATE(3120),
    [sym_concatenated_string] = STATE(3120),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(3120),
    [sym_for_range_declaration] = STATE(3121),
    [sym_new_expression] = STATE(3120),
    [sym_delete_expression] = STATE(3120),
    [sym_lambda_expression] = STATE(3120),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(7244),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7246),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7244),
    [sym_char_literal] = ACTIONS(7244),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7248),
    [sym_false] = ACTIONS(7248),
    [sym_null] = ACTIONS(7248),
    [sym_identifier] = ACTIONS(3180),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7248),
  },
  [3033] = {
    [sym_raw_string_literal] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3186),
    [sym_preproc_directive] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_typedef] = ACTIONS(3186),
    [anon_sym_extern] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_register] = ACTIONS(3186),
    [anon_sym_inline] = ACTIONS(3186),
    [anon_sym_const] = ACTIONS(3186),
    [anon_sym_restrict] = ACTIONS(3186),
    [anon_sym_volatile] = ACTIONS(3186),
    [anon_sym__Atomic] = ACTIONS(3186),
    [anon_sym_mutable] = ACTIONS(3186),
    [anon_sym_explicit] = ACTIONS(3186),
    [anon_sym_constexpr] = ACTIONS(3186),
    [anon_sym_unsigned] = ACTIONS(3186),
    [anon_sym_long] = ACTIONS(3186),
    [anon_sym_short] = ACTIONS(3186),
    [sym_primitive_type] = ACTIONS(3186),
    [anon_sym_enum] = ACTIONS(3186),
    [anon_sym_struct] = ACTIONS(3186),
    [anon_sym_union] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3186),
    [anon_sym_else] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(3186),
    [anon_sym_case] = ACTIONS(3186),
    [anon_sym_default] = ACTIONS(3186),
    [anon_sym_while] = ACTIONS(3186),
    [anon_sym_do] = ACTIONS(3186),
    [anon_sym_for] = ACTIONS(3186),
    [anon_sym_return] = ACTIONS(3186),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_continue] = ACTIONS(3186),
    [anon_sym_goto] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_sizeof] = ACTIONS(3186),
    [sym_number_literal] = ACTIONS(3184),
    [sym_char_literal] = ACTIONS(3184),
    [sym_string_literal] = ACTIONS(3184),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3186),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3186),
    [sym_auto] = ACTIONS(3186),
    [anon_sym_typename] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_COLON_COLON] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3186),
    [sym_nullptr] = ACTIONS(3186),
  },
  [3034] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7250),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3035] = {
    [anon_sym_SEMI] = ACTIONS(7250),
    [sym_comment] = ACTIONS(49),
  },
  [3036] = {
    [sym_raw_string_literal] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3192),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3192),
    [sym_preproc_directive] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_typedef] = ACTIONS(3192),
    [anon_sym_extern] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_register] = ACTIONS(3192),
    [anon_sym_inline] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_restrict] = ACTIONS(3192),
    [anon_sym_volatile] = ACTIONS(3192),
    [anon_sym__Atomic] = ACTIONS(3192),
    [anon_sym_mutable] = ACTIONS(3192),
    [anon_sym_explicit] = ACTIONS(3192),
    [anon_sym_constexpr] = ACTIONS(3192),
    [anon_sym_unsigned] = ACTIONS(3192),
    [anon_sym_long] = ACTIONS(3192),
    [anon_sym_short] = ACTIONS(3192),
    [sym_primitive_type] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [anon_sym_struct] = ACTIONS(3192),
    [anon_sym_union] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_goto] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_sizeof] = ACTIONS(3192),
    [sym_number_literal] = ACTIONS(3190),
    [sym_char_literal] = ACTIONS(3190),
    [sym_string_literal] = ACTIONS(3190),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3192),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3192),
    [sym_auto] = ACTIONS(3192),
    [anon_sym_typename] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_COLON_COLON] = ACTIONS(3190),
    [anon_sym_delete] = ACTIONS(3192),
    [sym_nullptr] = ACTIONS(3192),
  },
  [3037] = {
    [sym_raw_string_literal] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3196),
    [sym_preproc_directive] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_typedef] = ACTIONS(3196),
    [anon_sym_extern] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_register] = ACTIONS(3196),
    [anon_sym_inline] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_restrict] = ACTIONS(3196),
    [anon_sym_volatile] = ACTIONS(3196),
    [anon_sym__Atomic] = ACTIONS(3196),
    [anon_sym_mutable] = ACTIONS(3196),
    [anon_sym_explicit] = ACTIONS(3196),
    [anon_sym_constexpr] = ACTIONS(3196),
    [anon_sym_unsigned] = ACTIONS(3196),
    [anon_sym_long] = ACTIONS(3196),
    [anon_sym_short] = ACTIONS(3196),
    [sym_primitive_type] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_struct] = ACTIONS(3196),
    [anon_sym_union] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_goto] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_sizeof] = ACTIONS(3196),
    [sym_number_literal] = ACTIONS(3194),
    [sym_char_literal] = ACTIONS(3194),
    [sym_string_literal] = ACTIONS(3194),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(3196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3196),
    [sym_auto] = ACTIONS(3196),
    [anon_sym_typename] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_COLON_COLON] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3196),
    [sym_nullptr] = ACTIONS(3196),
  },
  [3038] = {
    [anon_sym_SEMI] = ACTIONS(7252),
    [sym_comment] = ACTIONS(49),
  },
  [3039] = {
    [sym_compound_statement] = STATE(3124),
    [sym_labeled_statement] = STATE(3124),
    [sym_expression_statement] = STATE(3124),
    [sym_if_statement] = STATE(3124),
    [sym_switch_statement] = STATE(3124),
    [sym_case_statement] = STATE(3124),
    [sym_while_statement] = STATE(3124),
    [sym_do_statement] = STATE(3124),
    [sym_for_statement] = STATE(3124),
    [sym_return_statement] = STATE(3124),
    [sym_break_statement] = STATE(3124),
    [sym_continue_statement] = STATE(3124),
    [sym_goto_statement] = STATE(3124),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3124),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3040] = {
    [sym_compound_statement] = STATE(3125),
    [sym_labeled_statement] = STATE(3125),
    [sym_expression_statement] = STATE(3125),
    [sym_if_statement] = STATE(3125),
    [sym_switch_statement] = STATE(3125),
    [sym_case_statement] = STATE(3125),
    [sym_while_statement] = STATE(3125),
    [sym_do_statement] = STATE(3125),
    [sym_for_statement] = STATE(3125),
    [sym_return_statement] = STATE(3125),
    [sym_break_statement] = STATE(3125),
    [sym_continue_statement] = STATE(3125),
    [sym_goto_statement] = STATE(3125),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3125),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3041] = {
    [sym_raw_string_literal] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3226),
    [sym_preproc_directive] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_typedef] = ACTIONS(3226),
    [anon_sym_extern] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_register] = ACTIONS(3226),
    [anon_sym_inline] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_restrict] = ACTIONS(3226),
    [anon_sym_volatile] = ACTIONS(3226),
    [anon_sym__Atomic] = ACTIONS(3226),
    [anon_sym_mutable] = ACTIONS(3226),
    [anon_sym_explicit] = ACTIONS(3226),
    [anon_sym_constexpr] = ACTIONS(3226),
    [anon_sym_unsigned] = ACTIONS(3226),
    [anon_sym_long] = ACTIONS(3226),
    [anon_sym_short] = ACTIONS(3226),
    [sym_primitive_type] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [anon_sym_struct] = ACTIONS(3226),
    [anon_sym_union] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_goto] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_sizeof] = ACTIONS(3226),
    [sym_number_literal] = ACTIONS(3224),
    [sym_char_literal] = ACTIONS(3224),
    [sym_string_literal] = ACTIONS(3224),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3226),
    [sym_auto] = ACTIONS(3226),
    [anon_sym_typename] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_COLON_COLON] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3226),
    [sym_nullptr] = ACTIONS(3226),
  },
  [3042] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(7254),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [3043] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [3044] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [3045] = {
    [sym_compound_statement] = STATE(3127),
    [sym_labeled_statement] = STATE(3127),
    [sym_expression_statement] = STATE(3127),
    [sym_if_statement] = STATE(3127),
    [sym_switch_statement] = STATE(3127),
    [sym_case_statement] = STATE(3127),
    [sym_while_statement] = STATE(3127),
    [sym_do_statement] = STATE(3127),
    [sym_for_statement] = STATE(3127),
    [sym_return_statement] = STATE(3127),
    [sym_break_statement] = STATE(3127),
    [sym_continue_statement] = STATE(3127),
    [sym_goto_statement] = STATE(3127),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3127),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3046] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7256),
    [sym_comment] = ACTIONS(49),
  },
  [3047] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3129),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7256),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3048] = {
    [sym__expression] = STATE(3130),
    [sym_conditional_expression] = STATE(3130),
    [sym_assignment_expression] = STATE(3130),
    [sym_pointer_expression] = STATE(3130),
    [sym_logical_expression] = STATE(3130),
    [sym_bitwise_expression] = STATE(3130),
    [sym_equality_expression] = STATE(3130),
    [sym_relational_expression] = STATE(3130),
    [sym_shift_expression] = STATE(3130),
    [sym_math_expression] = STATE(3130),
    [sym_cast_expression] = STATE(3130),
    [sym_sizeof_expression] = STATE(3130),
    [sym_subscript_expression] = STATE(3130),
    [sym_call_expression] = STATE(3130),
    [sym_field_expression] = STATE(3130),
    [sym_compound_literal_expression] = STATE(3130),
    [sym_parenthesized_expression] = STATE(3130),
    [sym_concatenated_string] = STATE(3130),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3130),
    [sym_new_expression] = STATE(3130),
    [sym_delete_expression] = STATE(3130),
    [sym_lambda_expression] = STATE(3130),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7258),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7256),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7258),
    [sym_char_literal] = ACTIONS(7258),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7260),
    [sym_false] = ACTIONS(7260),
    [sym_null] = ACTIONS(7260),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7260),
  },
  [3049] = {
    [sym_compound_statement] = STATE(3131),
    [sym_labeled_statement] = STATE(3131),
    [sym_expression_statement] = STATE(3131),
    [sym_if_statement] = STATE(3131),
    [sym_switch_statement] = STATE(3131),
    [sym_case_statement] = STATE(3131),
    [sym_while_statement] = STATE(3131),
    [sym_do_statement] = STATE(3131),
    [sym_for_statement] = STATE(3131),
    [sym_return_statement] = STATE(3131),
    [sym_break_statement] = STATE(3131),
    [sym_continue_statement] = STATE(3131),
    [sym_goto_statement] = STATE(3131),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3131),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3050] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_else] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [3051] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7262),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3052] = {
    [sym__expression] = STATE(3133),
    [sym_conditional_expression] = STATE(3133),
    [sym_assignment_expression] = STATE(3133),
    [sym_pointer_expression] = STATE(3133),
    [sym_logical_expression] = STATE(3133),
    [sym_bitwise_expression] = STATE(3133),
    [sym_equality_expression] = STATE(3133),
    [sym_relational_expression] = STATE(3133),
    [sym_shift_expression] = STATE(3133),
    [sym_math_expression] = STATE(3133),
    [sym_cast_expression] = STATE(3133),
    [sym_sizeof_expression] = STATE(3133),
    [sym_subscript_expression] = STATE(3133),
    [sym_call_expression] = STATE(3133),
    [sym_field_expression] = STATE(3133),
    [sym_compound_literal_expression] = STATE(3133),
    [sym_parenthesized_expression] = STATE(3133),
    [sym_concatenated_string] = STATE(3133),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3133),
    [sym_new_expression] = STATE(3133),
    [sym_delete_expression] = STATE(3133),
    [sym_lambda_expression] = STATE(3133),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7264),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7264),
    [sym_char_literal] = ACTIONS(7264),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7266),
    [sym_false] = ACTIONS(7266),
    [sym_null] = ACTIONS(7266),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7266),
  },
  [3053] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7268),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3054] = {
    [sym_declaration] = STATE(3135),
    [sym_type_definition] = STATE(3135),
    [sym__declaration_specifiers] = STATE(3058),
    [sym_compound_statement] = STATE(3135),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(3135),
    [sym_expression_statement] = STATE(3135),
    [sym_if_statement] = STATE(3135),
    [sym_switch_statement] = STATE(3135),
    [sym_case_statement] = STATE(3135),
    [sym_while_statement] = STATE(3135),
    [sym_do_statement] = STATE(3135),
    [sym_for_statement] = STATE(3135),
    [sym_return_statement] = STATE(3135),
    [sym_break_statement] = STATE(3135),
    [sym_continue_statement] = STATE(3135),
    [sym_goto_statement] = STATE(3135),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3135),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_typedef] = ACTIONS(7129),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(7131),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3055] = {
    [sym_type_qualifier] = STATE(3137),
    [sym__type_specifier] = STATE(3136),
    [sym_sized_type_specifier] = STATE(3136),
    [sym_enum_specifier] = STATE(3136),
    [sym_struct_specifier] = STATE(3136),
    [sym_union_specifier] = STATE(3136),
    [sym_macro_type_specifier] = STATE(3136),
    [sym_class_specifier] = STATE(3136),
    [sym_dependent_type] = STATE(3136),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(3137),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7270),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7270),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3056] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(6946),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [3057] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_else] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [3058] = {
    [sym__declarator] = STATE(3138),
    [sym_pointer_declarator] = STATE(3138),
    [sym_function_declarator] = STATE(3138),
    [sym_array_declarator] = STATE(3138),
    [sym_init_declarator] = STATE(3139),
    [sym_reference_declarator] = STATE(3138),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(3138),
    [sym_destructor_name] = STATE(3138),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(7272),
  },
  [3059] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3060] = {
    [anon_sym_LPAREN] = ACTIONS(7276),
    [sym_comment] = ACTIONS(49),
  },
  [3061] = {
    [sym__expression] = STATE(3143),
    [sym_conditional_expression] = STATE(3143),
    [sym_assignment_expression] = STATE(3143),
    [sym_pointer_expression] = STATE(3143),
    [sym_logical_expression] = STATE(3143),
    [sym_bitwise_expression] = STATE(3143),
    [sym_equality_expression] = STATE(3143),
    [sym_relational_expression] = STATE(3143),
    [sym_shift_expression] = STATE(3143),
    [sym_math_expression] = STATE(3143),
    [sym_cast_expression] = STATE(3143),
    [sym_sizeof_expression] = STATE(3143),
    [sym_subscript_expression] = STATE(3143),
    [sym_call_expression] = STATE(3143),
    [sym_field_expression] = STATE(3143),
    [sym_compound_literal_expression] = STATE(3143),
    [sym_parenthesized_expression] = STATE(3143),
    [sym_concatenated_string] = STATE(3143),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3143),
    [sym_new_expression] = STATE(3143),
    [sym_delete_expression] = STATE(3143),
    [sym_lambda_expression] = STATE(3143),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7278),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7280),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7278),
    [sym_char_literal] = ACTIONS(7278),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7282),
    [sym_false] = ACTIONS(7282),
    [sym_null] = ACTIONS(7282),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7282),
  },
  [3062] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7284),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3063] = {
    [anon_sym_COLON] = ACTIONS(7286),
    [sym_comment] = ACTIONS(49),
  },
  [3064] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_else] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [3065] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_else] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [3066] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_else] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [3067] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [3068] = {
    [sym_compound_statement] = STATE(3146),
    [sym_labeled_statement] = STATE(3146),
    [sym_expression_statement] = STATE(3146),
    [sym_if_statement] = STATE(3146),
    [sym_switch_statement] = STATE(3146),
    [sym_case_statement] = STATE(3146),
    [sym_while_statement] = STATE(3146),
    [sym_do_statement] = STATE(3146),
    [sym_for_statement] = STATE(3146),
    [sym_return_statement] = STATE(3146),
    [sym_break_statement] = STATE(3146),
    [sym_continue_statement] = STATE(3146),
    [sym_goto_statement] = STATE(3146),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3146),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [3069] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [3070] = {
    [sym_compound_statement] = STATE(3147),
    [sym_labeled_statement] = STATE(3147),
    [sym_expression_statement] = STATE(3147),
    [sym_if_statement] = STATE(3147),
    [sym_switch_statement] = STATE(3147),
    [sym_case_statement] = STATE(3147),
    [sym_while_statement] = STATE(3147),
    [sym_do_statement] = STATE(3147),
    [sym_for_statement] = STATE(3147),
    [sym_return_statement] = STATE(3147),
    [sym_break_statement] = STATE(3147),
    [sym_continue_statement] = STATE(3147),
    [sym_goto_statement] = STATE(3147),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3147),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [3071] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7288),
    [sym_comment] = ACTIONS(49),
  },
  [3072] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3149),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3073] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [3074] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_RBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(7290),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [3075] = {
    [sym_compound_statement] = STATE(3151),
    [sym_labeled_statement] = STATE(3151),
    [sym_expression_statement] = STATE(3151),
    [sym_if_statement] = STATE(3151),
    [sym_switch_statement] = STATE(3151),
    [sym_case_statement] = STATE(3151),
    [sym_while_statement] = STATE(3151),
    [sym_do_statement] = STATE(3151),
    [sym_for_statement] = STATE(3151),
    [sym_return_statement] = STATE(3151),
    [sym_break_statement] = STATE(3151),
    [sym_continue_statement] = STATE(3151),
    [sym_goto_statement] = STATE(3151),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3151),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3076] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_RBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_else] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [3077] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3078] = {
    [sym__type_declarator] = STATE(3153),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [3079] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [3080] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7294),
    [sym_comment] = ACTIONS(49),
  },
  [3081] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_RBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_else] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [3082] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7296),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3083] = {
    [sym_compound_statement] = STATE(3156),
    [sym_labeled_statement] = STATE(3156),
    [sym_expression_statement] = STATE(3156),
    [sym_if_statement] = STATE(3156),
    [sym_switch_statement] = STATE(3156),
    [sym_case_statement] = STATE(3156),
    [sym_while_statement] = STATE(3156),
    [sym_do_statement] = STATE(3156),
    [sym_for_statement] = STATE(3156),
    [sym_return_statement] = STATE(3156),
    [sym_break_statement] = STATE(3156),
    [sym_continue_statement] = STATE(3156),
    [sym_goto_statement] = STATE(3156),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3156),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3084] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3158),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3085] = {
    [sym__expression] = STATE(3159),
    [sym_conditional_expression] = STATE(3159),
    [sym_assignment_expression] = STATE(3159),
    [sym_pointer_expression] = STATE(3159),
    [sym_logical_expression] = STATE(3159),
    [sym_bitwise_expression] = STATE(3159),
    [sym_equality_expression] = STATE(3159),
    [sym_relational_expression] = STATE(3159),
    [sym_shift_expression] = STATE(3159),
    [sym_math_expression] = STATE(3159),
    [sym_cast_expression] = STATE(3159),
    [sym_sizeof_expression] = STATE(3159),
    [sym_subscript_expression] = STATE(3159),
    [sym_call_expression] = STATE(3159),
    [sym_field_expression] = STATE(3159),
    [sym_compound_literal_expression] = STATE(3159),
    [sym_parenthesized_expression] = STATE(3159),
    [sym_concatenated_string] = STATE(3159),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3159),
    [sym_new_expression] = STATE(3159),
    [sym_delete_expression] = STATE(3159),
    [sym_lambda_expression] = STATE(3159),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7300),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7298),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7300),
    [sym_char_literal] = ACTIONS(7300),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7302),
    [sym_false] = ACTIONS(7302),
    [sym_null] = ACTIONS(7302),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7302),
  },
  [3086] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7304),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3087] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7306),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3088] = {
    [sym_compound_statement] = STATE(3162),
    [sym_labeled_statement] = STATE(3162),
    [sym_expression_statement] = STATE(3162),
    [sym_if_statement] = STATE(3162),
    [sym_switch_statement] = STATE(3162),
    [sym_case_statement] = STATE(3162),
    [sym_while_statement] = STATE(3162),
    [sym_do_statement] = STATE(3162),
    [sym_for_statement] = STATE(3162),
    [sym_return_statement] = STATE(3162),
    [sym_break_statement] = STATE(3162),
    [sym_continue_statement] = STATE(3162),
    [sym_goto_statement] = STATE(3162),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3162),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3089] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7308),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3090] = {
    [sym_compound_statement] = STATE(2722),
    [sym_labeled_statement] = STATE(2722),
    [sym_expression_statement] = STATE(2722),
    [sym_if_statement] = STATE(2722),
    [sym_switch_statement] = STATE(2722),
    [sym_case_statement] = STATE(2722),
    [sym_while_statement] = STATE(2722),
    [sym_do_statement] = STATE(2722),
    [sym_for_statement] = STATE(2722),
    [sym_return_statement] = STATE(2722),
    [sym_break_statement] = STATE(2722),
    [sym_continue_statement] = STATE(2722),
    [sym_goto_statement] = STATE(2722),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2722),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3091] = {
    [sym_compound_statement] = STATE(2727),
    [sym_labeled_statement] = STATE(2727),
    [sym_expression_statement] = STATE(2727),
    [sym_if_statement] = STATE(2727),
    [sym_switch_statement] = STATE(2727),
    [sym_case_statement] = STATE(2727),
    [sym_while_statement] = STATE(2727),
    [sym_do_statement] = STATE(2727),
    [sym_for_statement] = STATE(2727),
    [sym_return_statement] = STATE(2727),
    [sym_break_statement] = STATE(2727),
    [sym_continue_statement] = STATE(2727),
    [sym_goto_statement] = STATE(2727),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2727),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3092] = {
    [sym__expression] = STATE(3165),
    [sym_conditional_expression] = STATE(3165),
    [sym_assignment_expression] = STATE(3165),
    [sym_pointer_expression] = STATE(3165),
    [sym_logical_expression] = STATE(3165),
    [sym_bitwise_expression] = STATE(3165),
    [sym_equality_expression] = STATE(3165),
    [sym_relational_expression] = STATE(3165),
    [sym_shift_expression] = STATE(3165),
    [sym_math_expression] = STATE(3165),
    [sym_cast_expression] = STATE(3165),
    [sym_sizeof_expression] = STATE(3165),
    [sym_subscript_expression] = STATE(3165),
    [sym_call_expression] = STATE(3165),
    [sym_field_expression] = STATE(3165),
    [sym_compound_literal_expression] = STATE(3165),
    [sym_parenthesized_expression] = STATE(3165),
    [sym_concatenated_string] = STATE(3165),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3165),
    [sym_new_expression] = STATE(3165),
    [sym_delete_expression] = STATE(3165),
    [sym_lambda_expression] = STATE(3165),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7310),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7310),
    [sym_char_literal] = ACTIONS(7310),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7314),
    [sym_false] = ACTIONS(7314),
    [sym_null] = ACTIONS(7314),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7314),
  },
  [3093] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7316),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3094] = {
    [sym__expression] = STATE(3167),
    [sym_conditional_expression] = STATE(3167),
    [sym_assignment_expression] = STATE(3167),
    [sym_pointer_expression] = STATE(3167),
    [sym_logical_expression] = STATE(3167),
    [sym_bitwise_expression] = STATE(3167),
    [sym_equality_expression] = STATE(3167),
    [sym_relational_expression] = STATE(3167),
    [sym_shift_expression] = STATE(3167),
    [sym_math_expression] = STATE(3167),
    [sym_cast_expression] = STATE(3167),
    [sym_sizeof_expression] = STATE(3167),
    [sym_subscript_expression] = STATE(3167),
    [sym_call_expression] = STATE(3167),
    [sym_field_expression] = STATE(3167),
    [sym_compound_literal_expression] = STATE(3167),
    [sym_parenthesized_expression] = STATE(3167),
    [sym_concatenated_string] = STATE(3167),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3167),
    [sym_new_expression] = STATE(3167),
    [sym_delete_expression] = STATE(3167),
    [sym_lambda_expression] = STATE(3167),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7318),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7316),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7318),
    [sym_char_literal] = ACTIONS(7318),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7320),
    [sym_false] = ACTIONS(7320),
    [sym_null] = ACTIONS(7320),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7320),
  },
  [3095] = {
    [sym__expression] = STATE(3168),
    [sym_conditional_expression] = STATE(3168),
    [sym_assignment_expression] = STATE(3168),
    [sym_pointer_expression] = STATE(3168),
    [sym_logical_expression] = STATE(3168),
    [sym_bitwise_expression] = STATE(3168),
    [sym_equality_expression] = STATE(3168),
    [sym_relational_expression] = STATE(3168),
    [sym_shift_expression] = STATE(3168),
    [sym_math_expression] = STATE(3168),
    [sym_cast_expression] = STATE(3168),
    [sym_sizeof_expression] = STATE(3168),
    [sym_subscript_expression] = STATE(3168),
    [sym_call_expression] = STATE(3168),
    [sym_field_expression] = STATE(3168),
    [sym_compound_literal_expression] = STATE(3168),
    [sym_parenthesized_expression] = STATE(3168),
    [sym_concatenated_string] = STATE(3168),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3168),
    [sym_new_expression] = STATE(3168),
    [sym_delete_expression] = STATE(3168),
    [sym_lambda_expression] = STATE(3168),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7322),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7322),
    [sym_char_literal] = ACTIONS(7322),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7324),
    [sym_false] = ACTIONS(7324),
    [sym_null] = ACTIONS(7324),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7324),
  },
  [3096] = {
    [anon_sym_else] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7183),
    [sym_comment] = ACTIONS(49),
  },
  [3097] = {
    [anon_sym_else] = ACTIONS(7209),
    [anon_sym_while] = ACTIONS(7209),
    [sym_comment] = ACTIONS(49),
  },
  [3098] = {
    [sym_compound_statement] = STATE(3169),
    [sym_labeled_statement] = STATE(3169),
    [sym_expression_statement] = STATE(3169),
    [sym_if_statement] = STATE(3169),
    [sym_switch_statement] = STATE(3169),
    [sym_case_statement] = STATE(3169),
    [sym_while_statement] = STATE(3169),
    [sym_do_statement] = STATE(3169),
    [sym_for_statement] = STATE(3169),
    [sym_return_statement] = STATE(3169),
    [sym_break_statement] = STATE(3169),
    [sym_continue_statement] = STATE(3169),
    [sym_goto_statement] = STATE(3169),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3169),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3099] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7326),
    [sym_comment] = ACTIONS(49),
  },
  [3100] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_RBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3101] = {
    [sym_parameter_list] = STATE(3103),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(3854),
    [anon_sym_volatile] = ACTIONS(3854),
    [anon_sym__Atomic] = ACTIONS(3854),
    [anon_sym_mutable] = ACTIONS(3854),
    [anon_sym_explicit] = ACTIONS(3854),
    [anon_sym_constexpr] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_DASH_GT] = ACTIONS(3854),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3854),
  },
  [3102] = {
    [sym_parameter_list] = STATE(3103),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(3866),
    [anon_sym_const] = ACTIONS(5409),
    [anon_sym_restrict] = ACTIONS(3866),
    [anon_sym_volatile] = ACTIONS(3866),
    [anon_sym__Atomic] = ACTIONS(3866),
    [anon_sym_mutable] = ACTIONS(3866),
    [anon_sym_explicit] = ACTIONS(3866),
    [anon_sym_constexpr] = ACTIONS(3866),
    [anon_sym_COLON] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3866),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3866),
  },
  [3103] = {
    [sym_type_qualifier] = STATE(3171),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3171),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_mutable] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_constexpr] = ACTIONS(3868),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(3868),
  },
  [3104] = {
    [sym_type_qualifier] = STATE(3172),
    [sym_trailing_return_type] = STATE(1785),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3172),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_COMMA] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3868),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(3868),
    [anon_sym_DASH_GT] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7332),
  },
  [3105] = {
    [sym_compound_statement] = STATE(3173),
    [sym_labeled_statement] = STATE(3173),
    [sym_expression_statement] = STATE(3173),
    [sym_if_statement] = STATE(3173),
    [sym_switch_statement] = STATE(3173),
    [sym_case_statement] = STATE(3173),
    [sym_while_statement] = STATE(3173),
    [sym_do_statement] = STATE(3173),
    [sym_for_statement] = STATE(3173),
    [sym_return_statement] = STATE(3173),
    [sym_break_statement] = STATE(3173),
    [sym_continue_statement] = STATE(3173),
    [sym_goto_statement] = STATE(3173),
    [sym__expression] = STATE(434),
    [sym_comma_expression] = STATE(435),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(434),
    [sym_for_range_loop] = STATE(3173),
    [sym_new_expression] = STATE(434),
    [sym_delete_expression] = STATE(434),
    [sym_lambda_expression] = STATE(434),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_goto] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(652),
    [sym_char_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_identifier] = ACTIONS(3202),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(712),
  },
  [3106] = {
    [sym_type_qualifier] = STATE(3107),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3107),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7218),
  },
  [3107] = {
    [sym_type_qualifier] = STATE(3107),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3107),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7334),
  },
  [3108] = {
    [sym_raw_string_literal] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3276),
    [sym_preproc_directive] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_typedef] = ACTIONS(3276),
    [anon_sym_extern] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_register] = ACTIONS(3276),
    [anon_sym_inline] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [anon_sym_restrict] = ACTIONS(3276),
    [anon_sym_volatile] = ACTIONS(3276),
    [anon_sym__Atomic] = ACTIONS(3276),
    [anon_sym_mutable] = ACTIONS(3276),
    [anon_sym_explicit] = ACTIONS(3276),
    [anon_sym_constexpr] = ACTIONS(3276),
    [anon_sym_unsigned] = ACTIONS(3276),
    [anon_sym_long] = ACTIONS(3276),
    [anon_sym_short] = ACTIONS(3276),
    [sym_primitive_type] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_struct] = ACTIONS(3276),
    [anon_sym_union] = ACTIONS(3276),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_else] = ACTIONS(3276),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_goto] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_sizeof] = ACTIONS(3276),
    [sym_number_literal] = ACTIONS(3274),
    [sym_char_literal] = ACTIONS(3274),
    [sym_string_literal] = ACTIONS(3274),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3276),
    [sym_auto] = ACTIONS(3276),
    [anon_sym_typename] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_COLON_COLON] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3276),
    [sym_nullptr] = ACTIONS(3276),
  },
  [3109] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7337),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3110] = {
    [sym__expression] = STATE(3175),
    [sym_conditional_expression] = STATE(3175),
    [sym_assignment_expression] = STATE(3175),
    [sym_pointer_expression] = STATE(3175),
    [sym_logical_expression] = STATE(3175),
    [sym_bitwise_expression] = STATE(3175),
    [sym_equality_expression] = STATE(3175),
    [sym_relational_expression] = STATE(3175),
    [sym_shift_expression] = STATE(3175),
    [sym_math_expression] = STATE(3175),
    [sym_cast_expression] = STATE(3175),
    [sym_sizeof_expression] = STATE(3175),
    [sym_subscript_expression] = STATE(3175),
    [sym_call_expression] = STATE(3175),
    [sym_field_expression] = STATE(3175),
    [sym_compound_literal_expression] = STATE(3175),
    [sym_parenthesized_expression] = STATE(3175),
    [sym_concatenated_string] = STATE(3175),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3175),
    [sym_new_expression] = STATE(3175),
    [sym_delete_expression] = STATE(3175),
    [sym_lambda_expression] = STATE(3175),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7339),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7339),
    [sym_char_literal] = ACTIONS(7339),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7341),
    [sym_false] = ACTIONS(7341),
    [sym_null] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7341),
  },
  [3111] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7343),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3112] = {
    [sym_declaration] = STATE(3177),
    [sym_type_definition] = STATE(3177),
    [sym__declaration_specifiers] = STATE(3116),
    [sym_compound_statement] = STATE(3177),
    [sym_storage_class_specifier] = STATE(114),
    [sym_type_qualifier] = STATE(114),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(3177),
    [sym_expression_statement] = STATE(3177),
    [sym_if_statement] = STATE(3177),
    [sym_switch_statement] = STATE(3177),
    [sym_case_statement] = STATE(3177),
    [sym_while_statement] = STATE(3177),
    [sym_do_statement] = STATE(3177),
    [sym_for_statement] = STATE(3177),
    [sym_return_statement] = STATE(3177),
    [sym_break_statement] = STATE(3177),
    [sym_continue_statement] = STATE(3177),
    [sym_goto_statement] = STATE(3177),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_macro_type_specifier] = STATE(110),
    [sym_class_specifier] = STATE(110),
    [sym_dependent_type] = STATE(110),
    [sym_template_type] = STATE(1541),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3177),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(437),
    [sym_scoped_namespace_identifier] = STATE(1542),
    [aux_sym__declaration_specifiers_repeat1] = STATE(114),
    [aux_sym_sized_type_specifier_repeat1] = STATE(115),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_typedef] = ACTIONS(7234),
    [anon_sym_extern] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(162),
    [anon_sym_register] = ACTIONS(162),
    [anon_sym_inline] = ACTIONS(162),
    [anon_sym_const] = ACTIONS(166),
    [anon_sym_restrict] = ACTIONS(166),
    [anon_sym_volatile] = ACTIONS(166),
    [anon_sym__Atomic] = ACTIONS(166),
    [anon_sym_mutable] = ACTIONS(166),
    [anon_sym_explicit] = ACTIONS(166),
    [anon_sym_constexpr] = ACTIONS(166),
    [anon_sym_unsigned] = ACTIONS(168),
    [anon_sym_long] = ACTIONS(168),
    [anon_sym_short] = ACTIONS(168),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_union] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(7236),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [sym_auto] = ACTIONS(170),
    [anon_sym_typename] = ACTIONS(180),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3113] = {
    [sym_type_qualifier] = STATE(3179),
    [sym__type_specifier] = STATE(3178),
    [sym_sized_type_specifier] = STATE(3178),
    [sym_enum_specifier] = STATE(3178),
    [sym_struct_specifier] = STATE(3178),
    [sym_union_specifier] = STATE(3178),
    [sym_macro_type_specifier] = STATE(3178),
    [sym_class_specifier] = STATE(3178),
    [sym_dependent_type] = STATE(3178),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(3179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7345),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7345),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3114] = {
    [sym_initializer_list] = STATE(804),
    [sym_template_argument_list] = STATE(2121),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(148),
    [anon_sym_register] = ACTIONS(148),
    [anon_sym_inline] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(148),
    [anon_sym_restrict] = ACTIONS(148),
    [anon_sym_volatile] = ACTIONS(148),
    [anon_sym__Atomic] = ACTIONS(148),
    [anon_sym_mutable] = ACTIONS(148),
    [anon_sym_explicit] = ACTIONS(148),
    [anon_sym_constexpr] = ACTIONS(148),
    [anon_sym_COLON] = ACTIONS(7097),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_STAR_EQ] = ACTIONS(1531),
    [anon_sym_SLASH_EQ] = ACTIONS(1531),
    [anon_sym_PERCENT_EQ] = ACTIONS(1531),
    [anon_sym_PLUS_EQ] = ACTIONS(1531),
    [anon_sym_DASH_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_GT_EQ] = ACTIONS(1531),
    [anon_sym_AMP_EQ] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1531),
    [anon_sym_PIPE_EQ] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DOT] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [sym_operator_name] = ACTIONS(146),
  },
  [3115] = {
    [sym_raw_string_literal] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4757),
    [sym_preproc_directive] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_typedef] = ACTIONS(4757),
    [anon_sym_extern] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_static] = ACTIONS(4757),
    [anon_sym_register] = ACTIONS(4757),
    [anon_sym_inline] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_restrict] = ACTIONS(4757),
    [anon_sym_volatile] = ACTIONS(4757),
    [anon_sym__Atomic] = ACTIONS(4757),
    [anon_sym_mutable] = ACTIONS(4757),
    [anon_sym_explicit] = ACTIONS(4757),
    [anon_sym_constexpr] = ACTIONS(4757),
    [anon_sym_unsigned] = ACTIONS(4757),
    [anon_sym_long] = ACTIONS(4757),
    [anon_sym_short] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(4757),
    [anon_sym_enum] = ACTIONS(4757),
    [anon_sym_struct] = ACTIONS(4757),
    [anon_sym_union] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_else] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_goto] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_sizeof] = ACTIONS(4757),
    [sym_number_literal] = ACTIONS(4755),
    [sym_char_literal] = ACTIONS(4755),
    [sym_string_literal] = ACTIONS(4755),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4757),
    [sym_auto] = ACTIONS(4757),
    [anon_sym_typename] = ACTIONS(4757),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_delete] = ACTIONS(4757),
    [sym_nullptr] = ACTIONS(4757),
  },
  [3116] = {
    [sym__declarator] = STATE(3180),
    [sym_pointer_declarator] = STATE(3180),
    [sym_function_declarator] = STATE(3180),
    [sym_array_declarator] = STATE(3180),
    [sym_init_declarator] = STATE(3181),
    [sym_reference_declarator] = STATE(3180),
    [sym_template_type] = STATE(46),
    [sym_template_function] = STATE(3180),
    [sym_destructor_name] = STATE(3180),
    [sym_scoped_identifier] = STATE(33),
    [sym_scoped_type_identifier] = STATE(47),
    [sym_scoped_namespace_identifier] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(45),
    [sym_identifier] = ACTIONS(75),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(77),
    [sym_operator_name] = ACTIONS(7347),
  },
  [3117] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7349),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3118] = {
    [anon_sym_LPAREN] = ACTIONS(7351),
    [sym_comment] = ACTIONS(49),
  },
  [3119] = {
    [sym__expression] = STATE(3185),
    [sym_conditional_expression] = STATE(3185),
    [sym_assignment_expression] = STATE(3185),
    [sym_pointer_expression] = STATE(3185),
    [sym_logical_expression] = STATE(3185),
    [sym_bitwise_expression] = STATE(3185),
    [sym_equality_expression] = STATE(3185),
    [sym_relational_expression] = STATE(3185),
    [sym_shift_expression] = STATE(3185),
    [sym_math_expression] = STATE(3185),
    [sym_cast_expression] = STATE(3185),
    [sym_sizeof_expression] = STATE(3185),
    [sym_subscript_expression] = STATE(3185),
    [sym_call_expression] = STATE(3185),
    [sym_field_expression] = STATE(3185),
    [sym_compound_literal_expression] = STATE(3185),
    [sym_parenthesized_expression] = STATE(3185),
    [sym_concatenated_string] = STATE(3185),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3185),
    [sym_new_expression] = STATE(3185),
    [sym_delete_expression] = STATE(3185),
    [sym_lambda_expression] = STATE(3185),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7353),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7355),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7353),
    [sym_char_literal] = ACTIONS(7353),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7357),
    [sym_false] = ACTIONS(7357),
    [sym_null] = ACTIONS(7357),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7357),
  },
  [3120] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7359),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3121] = {
    [anon_sym_COLON] = ACTIONS(7361),
    [sym_comment] = ACTIONS(49),
  },
  [3122] = {
    [sym_raw_string_literal] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4819),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4819),
    [sym_preproc_directive] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_typedef] = ACTIONS(4819),
    [anon_sym_extern] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4819),
    [anon_sym_register] = ACTIONS(4819),
    [anon_sym_inline] = ACTIONS(4819),
    [anon_sym_const] = ACTIONS(4819),
    [anon_sym_restrict] = ACTIONS(4819),
    [anon_sym_volatile] = ACTIONS(4819),
    [anon_sym__Atomic] = ACTIONS(4819),
    [anon_sym_mutable] = ACTIONS(4819),
    [anon_sym_explicit] = ACTIONS(4819),
    [anon_sym_constexpr] = ACTIONS(4819),
    [anon_sym_unsigned] = ACTIONS(4819),
    [anon_sym_long] = ACTIONS(4819),
    [anon_sym_short] = ACTIONS(4819),
    [sym_primitive_type] = ACTIONS(4819),
    [anon_sym_enum] = ACTIONS(4819),
    [anon_sym_struct] = ACTIONS(4819),
    [anon_sym_union] = ACTIONS(4819),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_else] = ACTIONS(4819),
    [anon_sym_switch] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_default] = ACTIONS(4819),
    [anon_sym_while] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_for] = ACTIONS(4819),
    [anon_sym_return] = ACTIONS(4819),
    [anon_sym_break] = ACTIONS(4819),
    [anon_sym_continue] = ACTIONS(4819),
    [anon_sym_goto] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4817),
    [anon_sym_BANG] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4817),
    [anon_sym_PLUS] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_DASH] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4817),
    [anon_sym_sizeof] = ACTIONS(4819),
    [sym_number_literal] = ACTIONS(4817),
    [sym_char_literal] = ACTIONS(4817),
    [sym_string_literal] = ACTIONS(4817),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4819),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4819),
    [sym_auto] = ACTIONS(4819),
    [anon_sym_typename] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(4819),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_delete] = ACTIONS(4819),
    [sym_nullptr] = ACTIONS(4819),
  },
  [3123] = {
    [sym_raw_string_literal] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4821),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4823),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4823),
    [sym_preproc_directive] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_typedef] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_register] = ACTIONS(4823),
    [anon_sym_inline] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_restrict] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym__Atomic] = ACTIONS(4823),
    [anon_sym_mutable] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_constexpr] = ACTIONS(4823),
    [anon_sym_unsigned] = ACTIONS(4823),
    [anon_sym_long] = ACTIONS(4823),
    [anon_sym_short] = ACTIONS(4823),
    [sym_primitive_type] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_union] = ACTIONS(4823),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_else] = ACTIONS(4823),
    [anon_sym_switch] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_default] = ACTIONS(4823),
    [anon_sym_while] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_for] = ACTIONS(4823),
    [anon_sym_return] = ACTIONS(4823),
    [anon_sym_break] = ACTIONS(4823),
    [anon_sym_continue] = ACTIONS(4823),
    [anon_sym_goto] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4821),
    [anon_sym_BANG] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4821),
    [anon_sym_PLUS] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_DASH] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4821),
    [anon_sym_sizeof] = ACTIONS(4823),
    [sym_number_literal] = ACTIONS(4821),
    [sym_char_literal] = ACTIONS(4821),
    [sym_string_literal] = ACTIONS(4821),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4823),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_typename] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_delete] = ACTIONS(4823),
    [sym_nullptr] = ACTIONS(4823),
  },
  [3124] = {
    [sym_raw_string_literal] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4832),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4832),
    [sym_preproc_directive] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_typedef] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_register] = ACTIONS(4832),
    [anon_sym_inline] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_unsigned] = ACTIONS(4832),
    [anon_sym_long] = ACTIONS(4832),
    [anon_sym_short] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_union] = ACTIONS(4832),
    [anon_sym_if] = ACTIONS(4832),
    [anon_sym_else] = ACTIONS(4832),
    [anon_sym_switch] = ACTIONS(4832),
    [anon_sym_case] = ACTIONS(4832),
    [anon_sym_default] = ACTIONS(4832),
    [anon_sym_while] = ACTIONS(4832),
    [anon_sym_do] = ACTIONS(4832),
    [anon_sym_for] = ACTIONS(4832),
    [anon_sym_return] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4832),
    [anon_sym_continue] = ACTIONS(4832),
    [anon_sym_goto] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_BANG] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4830),
    [anon_sym_PLUS_PLUS] = ACTIONS(4830),
    [anon_sym_sizeof] = ACTIONS(4832),
    [sym_number_literal] = ACTIONS(4830),
    [sym_char_literal] = ACTIONS(4830),
    [sym_string_literal] = ACTIONS(4830),
    [sym_true] = ACTIONS(4832),
    [sym_false] = ACTIONS(4832),
    [sym_null] = ACTIONS(4832),
    [sym_identifier] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(4832),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_typename] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_delete] = ACTIONS(4832),
    [sym_nullptr] = ACTIONS(4832),
  },
  [3125] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [3126] = {
    [sym_compound_statement] = STATE(3188),
    [sym_labeled_statement] = STATE(3188),
    [sym_expression_statement] = STATE(3188),
    [sym_if_statement] = STATE(3188),
    [sym_switch_statement] = STATE(3188),
    [sym_case_statement] = STATE(3188),
    [sym_while_statement] = STATE(3188),
    [sym_do_statement] = STATE(3188),
    [sym_for_statement] = STATE(3188),
    [sym_return_statement] = STATE(3188),
    [sym_break_statement] = STATE(3188),
    [sym_continue_statement] = STATE(3188),
    [sym_goto_statement] = STATE(3188),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3188),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3127] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [3128] = {
    [sym_compound_statement] = STATE(3189),
    [sym_labeled_statement] = STATE(3189),
    [sym_expression_statement] = STATE(3189),
    [sym_if_statement] = STATE(3189),
    [sym_switch_statement] = STATE(3189),
    [sym_case_statement] = STATE(3189),
    [sym_while_statement] = STATE(3189),
    [sym_do_statement] = STATE(3189),
    [sym_for_statement] = STATE(3189),
    [sym_return_statement] = STATE(3189),
    [sym_break_statement] = STATE(3189),
    [sym_continue_statement] = STATE(3189),
    [sym_goto_statement] = STATE(3189),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3189),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3129] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7363),
    [sym_comment] = ACTIONS(49),
  },
  [3130] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3191),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7363),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3131] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [3132] = {
    [sym_compound_statement] = STATE(3192),
    [sym_labeled_statement] = STATE(3192),
    [sym_expression_statement] = STATE(3192),
    [sym_if_statement] = STATE(3192),
    [sym_switch_statement] = STATE(3192),
    [sym_case_statement] = STATE(3192),
    [sym_while_statement] = STATE(3192),
    [sym_do_statement] = STATE(3192),
    [sym_for_statement] = STATE(3192),
    [sym_return_statement] = STATE(3192),
    [sym_break_statement] = STATE(3192),
    [sym_continue_statement] = STATE(3192),
    [sym_goto_statement] = STATE(3192),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3192),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3133] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7365),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3134] = {
    [sym_compound_statement] = STATE(3194),
    [sym_labeled_statement] = STATE(3194),
    [sym_expression_statement] = STATE(3194),
    [sym_if_statement] = STATE(3194),
    [sym_switch_statement] = STATE(3194),
    [sym_case_statement] = STATE(3194),
    [sym_while_statement] = STATE(3194),
    [sym_do_statement] = STATE(3194),
    [sym_for_statement] = STATE(3194),
    [sym_return_statement] = STATE(3194),
    [sym_break_statement] = STATE(3194),
    [sym_continue_statement] = STATE(3194),
    [sym_goto_statement] = STATE(3194),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3194),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3135] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_else] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [3136] = {
    [sym__type_declarator] = STATE(3195),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [3137] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(3196),
    [sym_sized_type_specifier] = STATE(3196),
    [sym_enum_specifier] = STATE(3196),
    [sym_struct_specifier] = STATE(3196),
    [sym_union_specifier] = STATE(3196),
    [sym_macro_type_specifier] = STATE(3196),
    [sym_class_specifier] = STATE(3196),
    [sym_dependent_type] = STATE(3196),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7367),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7367),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3138] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(3198),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7369),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [3139] = {
    [aux_sym_declaration_repeat1] = STATE(3198),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7369),
    [sym_comment] = ACTIONS(49),
  },
  [3140] = {
    [sym_compound_statement] = STATE(3199),
    [sym_labeled_statement] = STATE(3199),
    [sym_expression_statement] = STATE(3199),
    [sym_if_statement] = STATE(3199),
    [sym_switch_statement] = STATE(3199),
    [sym_case_statement] = STATE(3199),
    [sym_while_statement] = STATE(3199),
    [sym_do_statement] = STATE(3199),
    [sym_for_statement] = STATE(3199),
    [sym_return_statement] = STATE(3199),
    [sym_break_statement] = STATE(3199),
    [sym_continue_statement] = STATE(3199),
    [sym_goto_statement] = STATE(3199),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3199),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3141] = {
    [sym__expression] = STATE(3200),
    [sym_conditional_expression] = STATE(3200),
    [sym_assignment_expression] = STATE(3200),
    [sym_pointer_expression] = STATE(3200),
    [sym_logical_expression] = STATE(3200),
    [sym_bitwise_expression] = STATE(3200),
    [sym_equality_expression] = STATE(3200),
    [sym_relational_expression] = STATE(3200),
    [sym_shift_expression] = STATE(3200),
    [sym_math_expression] = STATE(3200),
    [sym_cast_expression] = STATE(3200),
    [sym_sizeof_expression] = STATE(3200),
    [sym_subscript_expression] = STATE(3200),
    [sym_call_expression] = STATE(3200),
    [sym_field_expression] = STATE(3200),
    [sym_compound_literal_expression] = STATE(3200),
    [sym_parenthesized_expression] = STATE(3200),
    [sym_concatenated_string] = STATE(3200),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3200),
    [sym_new_expression] = STATE(3200),
    [sym_delete_expression] = STATE(3200),
    [sym_lambda_expression] = STATE(3200),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7371),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7371),
    [sym_char_literal] = ACTIONS(7371),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7373),
    [sym_false] = ACTIONS(7373),
    [sym_null] = ACTIONS(7373),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7373),
  },
  [3142] = {
    [sym__expression] = STATE(3202),
    [sym_conditional_expression] = STATE(3202),
    [sym_assignment_expression] = STATE(3202),
    [sym_pointer_expression] = STATE(3202),
    [sym_logical_expression] = STATE(3202),
    [sym_bitwise_expression] = STATE(3202),
    [sym_equality_expression] = STATE(3202),
    [sym_relational_expression] = STATE(3202),
    [sym_shift_expression] = STATE(3202),
    [sym_math_expression] = STATE(3202),
    [sym_cast_expression] = STATE(3202),
    [sym_sizeof_expression] = STATE(3202),
    [sym_subscript_expression] = STATE(3202),
    [sym_call_expression] = STATE(3202),
    [sym_field_expression] = STATE(3202),
    [sym_compound_literal_expression] = STATE(3202),
    [sym_parenthesized_expression] = STATE(3202),
    [sym_concatenated_string] = STATE(3202),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3202),
    [sym_new_expression] = STATE(3202),
    [sym_delete_expression] = STATE(3202),
    [sym_lambda_expression] = STATE(3202),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7375),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7377),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7375),
    [sym_char_literal] = ACTIONS(7375),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7379),
    [sym_false] = ACTIONS(7379),
    [sym_null] = ACTIONS(7379),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7379),
  },
  [3143] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7381),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3144] = {
    [sym__expression] = STATE(3204),
    [sym_conditional_expression] = STATE(3204),
    [sym_assignment_expression] = STATE(3204),
    [sym_pointer_expression] = STATE(3204),
    [sym_logical_expression] = STATE(3204),
    [sym_bitwise_expression] = STATE(3204),
    [sym_equality_expression] = STATE(3204),
    [sym_relational_expression] = STATE(3204),
    [sym_shift_expression] = STATE(3204),
    [sym_math_expression] = STATE(3204),
    [sym_cast_expression] = STATE(3204),
    [sym_sizeof_expression] = STATE(3204),
    [sym_subscript_expression] = STATE(3204),
    [sym_call_expression] = STATE(3204),
    [sym_field_expression] = STATE(3204),
    [sym_compound_literal_expression] = STATE(3204),
    [sym_parenthesized_expression] = STATE(3204),
    [sym_concatenated_string] = STATE(3204),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3204),
    [sym_new_expression] = STATE(3204),
    [sym_delete_expression] = STATE(3204),
    [sym_lambda_expression] = STATE(3204),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7383),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7381),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7383),
    [sym_char_literal] = ACTIONS(7383),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7385),
    [sym_false] = ACTIONS(7385),
    [sym_null] = ACTIONS(7385),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7385),
  },
  [3145] = {
    [sym__expression] = STATE(3205),
    [sym_conditional_expression] = STATE(3205),
    [sym_assignment_expression] = STATE(3205),
    [sym_pointer_expression] = STATE(3205),
    [sym_logical_expression] = STATE(3205),
    [sym_bitwise_expression] = STATE(3205),
    [sym_equality_expression] = STATE(3205),
    [sym_relational_expression] = STATE(3205),
    [sym_shift_expression] = STATE(3205),
    [sym_math_expression] = STATE(3205),
    [sym_cast_expression] = STATE(3205),
    [sym_sizeof_expression] = STATE(3205),
    [sym_subscript_expression] = STATE(3205),
    [sym_call_expression] = STATE(3205),
    [sym_field_expression] = STATE(3205),
    [sym_compound_literal_expression] = STATE(3205),
    [sym_parenthesized_expression] = STATE(3205),
    [sym_concatenated_string] = STATE(3205),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3205),
    [sym_new_expression] = STATE(3205),
    [sym_delete_expression] = STATE(3205),
    [sym_lambda_expression] = STATE(3205),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7387),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7387),
    [sym_char_literal] = ACTIONS(7387),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7389),
    [sym_false] = ACTIONS(7389),
    [sym_null] = ACTIONS(7389),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7389),
  },
  [3146] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [3147] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3148] = {
    [sym_compound_statement] = STATE(3206),
    [sym_labeled_statement] = STATE(3206),
    [sym_expression_statement] = STATE(3206),
    [sym_if_statement] = STATE(3206),
    [sym_switch_statement] = STATE(3206),
    [sym_case_statement] = STATE(3206),
    [sym_while_statement] = STATE(3206),
    [sym_do_statement] = STATE(3206),
    [sym_for_statement] = STATE(3206),
    [sym_return_statement] = STATE(3206),
    [sym_break_statement] = STATE(3206),
    [sym_continue_statement] = STATE(3206),
    [sym_goto_statement] = STATE(3206),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3206),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [3149] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7391),
    [sym_comment] = ACTIONS(49),
  },
  [3150] = {
    [sym_compound_statement] = STATE(3208),
    [sym_labeled_statement] = STATE(3208),
    [sym_expression_statement] = STATE(3208),
    [sym_if_statement] = STATE(3208),
    [sym_switch_statement] = STATE(3208),
    [sym_case_statement] = STATE(3208),
    [sym_while_statement] = STATE(3208),
    [sym_do_statement] = STATE(3208),
    [sym_for_statement] = STATE(3208),
    [sym_return_statement] = STATE(3208),
    [sym_break_statement] = STATE(3208),
    [sym_continue_statement] = STATE(3208),
    [sym_goto_statement] = STATE(3208),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3208),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3151] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_RBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(7393),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [3152] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [3153] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7395),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3154] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_else] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [3155] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_RBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_else] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [3156] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_else] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [3157] = {
    [sym_compound_statement] = STATE(3211),
    [sym_labeled_statement] = STATE(3211),
    [sym_expression_statement] = STATE(3211),
    [sym_if_statement] = STATE(3211),
    [sym_switch_statement] = STATE(3211),
    [sym_case_statement] = STATE(3211),
    [sym_while_statement] = STATE(3211),
    [sym_do_statement] = STATE(3211),
    [sym_for_statement] = STATE(3211),
    [sym_return_statement] = STATE(3211),
    [sym_break_statement] = STATE(3211),
    [sym_continue_statement] = STATE(3211),
    [sym_goto_statement] = STATE(3211),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3211),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3158] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7397),
    [sym_comment] = ACTIONS(49),
  },
  [3159] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3213),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7397),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3160] = {
    [sym__expression] = STATE(3214),
    [sym_conditional_expression] = STATE(3214),
    [sym_assignment_expression] = STATE(3214),
    [sym_pointer_expression] = STATE(3214),
    [sym_logical_expression] = STATE(3214),
    [sym_bitwise_expression] = STATE(3214),
    [sym_equality_expression] = STATE(3214),
    [sym_relational_expression] = STATE(3214),
    [sym_shift_expression] = STATE(3214),
    [sym_math_expression] = STATE(3214),
    [sym_cast_expression] = STATE(3214),
    [sym_sizeof_expression] = STATE(3214),
    [sym_subscript_expression] = STATE(3214),
    [sym_call_expression] = STATE(3214),
    [sym_field_expression] = STATE(3214),
    [sym_compound_literal_expression] = STATE(3214),
    [sym_parenthesized_expression] = STATE(3214),
    [sym_concatenated_string] = STATE(3214),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3214),
    [sym_new_expression] = STATE(3214),
    [sym_delete_expression] = STATE(3214),
    [sym_lambda_expression] = STATE(3214),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7399),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7397),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7399),
    [sym_char_literal] = ACTIONS(7399),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7401),
    [sym_false] = ACTIONS(7401),
    [sym_null] = ACTIONS(7401),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7401),
  },
  [3161] = {
    [sym_compound_statement] = STATE(3215),
    [sym_labeled_statement] = STATE(3215),
    [sym_expression_statement] = STATE(3215),
    [sym_if_statement] = STATE(3215),
    [sym_switch_statement] = STATE(3215),
    [sym_case_statement] = STATE(3215),
    [sym_while_statement] = STATE(3215),
    [sym_do_statement] = STATE(3215),
    [sym_for_statement] = STATE(3215),
    [sym_return_statement] = STATE(3215),
    [sym_break_statement] = STATE(3215),
    [sym_continue_statement] = STATE(3215),
    [sym_goto_statement] = STATE(3215),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3215),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3162] = {
    [anon_sym_else] = ACTIONS(7403),
    [anon_sym_while] = ACTIONS(6393),
    [sym_comment] = ACTIONS(49),
  },
  [3163] = {
    [sym_compound_statement] = STATE(3217),
    [sym_labeled_statement] = STATE(3217),
    [sym_expression_statement] = STATE(3217),
    [sym_if_statement] = STATE(3217),
    [sym_switch_statement] = STATE(3217),
    [sym_case_statement] = STATE(3217),
    [sym_while_statement] = STATE(3217),
    [sym_do_statement] = STATE(3217),
    [sym_for_statement] = STATE(3217),
    [sym_return_statement] = STATE(3217),
    [sym_break_statement] = STATE(3217),
    [sym_continue_statement] = STATE(3217),
    [sym_goto_statement] = STATE(3217),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3217),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3164] = {
    [sym_compound_statement] = STATE(2882),
    [sym_labeled_statement] = STATE(2882),
    [sym_expression_statement] = STATE(2882),
    [sym_if_statement] = STATE(2882),
    [sym_switch_statement] = STATE(2882),
    [sym_case_statement] = STATE(2882),
    [sym_while_statement] = STATE(2882),
    [sym_do_statement] = STATE(2882),
    [sym_for_statement] = STATE(2882),
    [sym_return_statement] = STATE(2882),
    [sym_break_statement] = STATE(2882),
    [sym_continue_statement] = STATE(2882),
    [sym_goto_statement] = STATE(2882),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(2882),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3165] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3219),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7405),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3166] = {
    [sym__expression] = STATE(3220),
    [sym_conditional_expression] = STATE(3220),
    [sym_assignment_expression] = STATE(3220),
    [sym_pointer_expression] = STATE(3220),
    [sym_logical_expression] = STATE(3220),
    [sym_bitwise_expression] = STATE(3220),
    [sym_equality_expression] = STATE(3220),
    [sym_relational_expression] = STATE(3220),
    [sym_shift_expression] = STATE(3220),
    [sym_math_expression] = STATE(3220),
    [sym_cast_expression] = STATE(3220),
    [sym_sizeof_expression] = STATE(3220),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3220),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_concatenated_string] = STATE(3220),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3220),
    [sym_new_expression] = STATE(3220),
    [sym_delete_expression] = STATE(3220),
    [sym_lambda_expression] = STATE(3220),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7407),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7405),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7407),
    [sym_char_literal] = ACTIONS(7407),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7409),
    [sym_false] = ACTIONS(7409),
    [sym_null] = ACTIONS(7409),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7409),
  },
  [3167] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7411),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3168] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7413),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3169] = {
    [anon_sym_else] = ACTIONS(7328),
    [anon_sym_while] = ACTIONS(7328),
    [sym_comment] = ACTIONS(49),
  },
  [3170] = {
    [sym_compound_statement] = STATE(3223),
    [sym_labeled_statement] = STATE(3223),
    [sym_expression_statement] = STATE(3223),
    [sym_if_statement] = STATE(3223),
    [sym_switch_statement] = STATE(3223),
    [sym_case_statement] = STATE(3223),
    [sym_while_statement] = STATE(3223),
    [sym_do_statement] = STATE(3223),
    [sym_for_statement] = STATE(3223),
    [sym_return_statement] = STATE(3223),
    [sym_break_statement] = STATE(3223),
    [sym_continue_statement] = STATE(3223),
    [sym_goto_statement] = STATE(3223),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3223),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_case] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1730),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3171] = {
    [sym_type_qualifier] = STATE(3172),
    [sym_trailing_return_type] = STATE(2251),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3172),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_restrict] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym__Atomic] = ACTIONS(646),
    [anon_sym_mutable] = ACTIONS(646),
    [anon_sym_explicit] = ACTIONS(646),
    [anon_sym_constexpr] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(5120),
    [anon_sym_DASH_GT] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7332),
  },
  [3172] = {
    [sym_type_qualifier] = STATE(3172),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3172),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_explicit] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5124),
    [anon_sym_DASH_GT] = ACTIONS(5124),
    [sym_comment] = ACTIONS(49),
    [sym_noexcept] = ACTIONS(7415),
  },
  [3173] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_RBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
  [3174] = {
    [sym_compound_statement] = STATE(3224),
    [sym_labeled_statement] = STATE(3224),
    [sym_expression_statement] = STATE(3224),
    [sym_if_statement] = STATE(3224),
    [sym_switch_statement] = STATE(3224),
    [sym_case_statement] = STATE(3224),
    [sym_while_statement] = STATE(3224),
    [sym_do_statement] = STATE(3224),
    [sym_for_statement] = STATE(3224),
    [sym_return_statement] = STATE(3224),
    [sym_break_statement] = STATE(3224),
    [sym_continue_statement] = STATE(3224),
    [sym_goto_statement] = STATE(3224),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3224),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3175] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7422),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3176] = {
    [sym_compound_statement] = STATE(3226),
    [sym_labeled_statement] = STATE(3226),
    [sym_expression_statement] = STATE(3226),
    [sym_if_statement] = STATE(3226),
    [sym_switch_statement] = STATE(3226),
    [sym_case_statement] = STATE(3226),
    [sym_while_statement] = STATE(3226),
    [sym_do_statement] = STATE(3226),
    [sym_for_statement] = STATE(3226),
    [sym_return_statement] = STATE(3226),
    [sym_break_statement] = STATE(3226),
    [sym_continue_statement] = STATE(3226),
    [sym_goto_statement] = STATE(3226),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3226),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3177] = {
    [sym_raw_string_literal] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5757),
    [anon_sym_LPAREN] = ACTIONS(5755),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5757),
    [sym_preproc_directive] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5757),
    [anon_sym_extern] = ACTIONS(5757),
    [anon_sym_LBRACE] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5757),
    [anon_sym_register] = ACTIONS(5757),
    [anon_sym_inline] = ACTIONS(5757),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_explicit] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_unsigned] = ACTIONS(5757),
    [anon_sym_long] = ACTIONS(5757),
    [anon_sym_short] = ACTIONS(5757),
    [sym_primitive_type] = ACTIONS(5757),
    [anon_sym_enum] = ACTIONS(5757),
    [anon_sym_struct] = ACTIONS(5757),
    [anon_sym_union] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_else] = ACTIONS(5757),
    [anon_sym_switch] = ACTIONS(5757),
    [anon_sym_case] = ACTIONS(5757),
    [anon_sym_default] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_break] = ACTIONS(5757),
    [anon_sym_continue] = ACTIONS(5757),
    [anon_sym_goto] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_BANG] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_DASH_DASH] = ACTIONS(5755),
    [anon_sym_PLUS_PLUS] = ACTIONS(5755),
    [anon_sym_sizeof] = ACTIONS(5757),
    [sym_number_literal] = ACTIONS(5755),
    [sym_char_literal] = ACTIONS(5755),
    [sym_string_literal] = ACTIONS(5755),
    [sym_true] = ACTIONS(5757),
    [sym_false] = ACTIONS(5757),
    [sym_null] = ACTIONS(5757),
    [sym_identifier] = ACTIONS(5757),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(5757),
    [sym_auto] = ACTIONS(5757),
    [anon_sym_typename] = ACTIONS(5757),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_COLON_COLON] = ACTIONS(5755),
    [anon_sym_delete] = ACTIONS(5757),
    [sym_nullptr] = ACTIONS(5757),
  },
  [3178] = {
    [sym__type_declarator] = STATE(3227),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [3179] = {
    [sym_type_qualifier] = STATE(229),
    [sym__type_specifier] = STATE(3228),
    [sym_sized_type_specifier] = STATE(3228),
    [sym_enum_specifier] = STATE(3228),
    [sym_struct_specifier] = STATE(3228),
    [sym_union_specifier] = STATE(3228),
    [sym_macro_type_specifier] = STATE(3228),
    [sym_class_specifier] = STATE(3228),
    [sym_dependent_type] = STATE(3228),
    [sym_template_type] = STATE(62),
    [sym_scoped_type_identifier] = STATE(63),
    [sym_scoped_namespace_identifier] = STATE(64),
    [aux_sym_type_definition_repeat1] = STATE(229),
    [aux_sym_sized_type_specifier_repeat1] = STATE(66),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_restrict] = ACTIONS(93),
    [anon_sym_volatile] = ACTIONS(93),
    [anon_sym__Atomic] = ACTIONS(93),
    [anon_sym_mutable] = ACTIONS(93),
    [anon_sym_explicit] = ACTIONS(93),
    [anon_sym_constexpr] = ACTIONS(93),
    [anon_sym_unsigned] = ACTIONS(95),
    [anon_sym_long] = ACTIONS(95),
    [anon_sym_short] = ACTIONS(95),
    [sym_primitive_type] = ACTIONS(7424),
    [anon_sym_enum] = ACTIONS(99),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(107),
    [sym_auto] = ACTIONS(7424),
    [anon_sym_typename] = ACTIONS(109),
    [anon_sym_COLON_COLON] = ACTIONS(111),
  },
  [3180] = {
    [sym_parameter_list] = STATE(353),
    [sym_argument_list] = STATE(354),
    [sym_initializer_list] = STATE(354),
    [aux_sym_declaration_repeat1] = STATE(3230),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7426),
    [anon_sym_LBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_EQ] = ACTIONS(576),
    [sym_comment] = ACTIONS(49),
  },
  [3181] = {
    [aux_sym_declaration_repeat1] = STATE(3230),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7426),
    [sym_comment] = ACTIONS(49),
  },
  [3182] = {
    [sym_compound_statement] = STATE(3231),
    [sym_labeled_statement] = STATE(3231),
    [sym_expression_statement] = STATE(3231),
    [sym_if_statement] = STATE(3231),
    [sym_switch_statement] = STATE(3231),
    [sym_case_statement] = STATE(3231),
    [sym_while_statement] = STATE(3231),
    [sym_do_statement] = STATE(3231),
    [sym_for_statement] = STATE(3231),
    [sym_return_statement] = STATE(3231),
    [sym_break_statement] = STATE(3231),
    [sym_continue_statement] = STATE(3231),
    [sym_goto_statement] = STATE(3231),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3231),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3183] = {
    [sym__expression] = STATE(3232),
    [sym_conditional_expression] = STATE(3232),
    [sym_assignment_expression] = STATE(3232),
    [sym_pointer_expression] = STATE(3232),
    [sym_logical_expression] = STATE(3232),
    [sym_bitwise_expression] = STATE(3232),
    [sym_equality_expression] = STATE(3232),
    [sym_relational_expression] = STATE(3232),
    [sym_shift_expression] = STATE(3232),
    [sym_math_expression] = STATE(3232),
    [sym_cast_expression] = STATE(3232),
    [sym_sizeof_expression] = STATE(3232),
    [sym_subscript_expression] = STATE(3232),
    [sym_call_expression] = STATE(3232),
    [sym_field_expression] = STATE(3232),
    [sym_compound_literal_expression] = STATE(3232),
    [sym_parenthesized_expression] = STATE(3232),
    [sym_concatenated_string] = STATE(3232),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3232),
    [sym_new_expression] = STATE(3232),
    [sym_delete_expression] = STATE(3232),
    [sym_lambda_expression] = STATE(3232),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7428),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7428),
    [sym_char_literal] = ACTIONS(7428),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7430),
    [sym_false] = ACTIONS(7430),
    [sym_null] = ACTIONS(7430),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7430),
  },
  [3184] = {
    [sym__expression] = STATE(3234),
    [sym_conditional_expression] = STATE(3234),
    [sym_assignment_expression] = STATE(3234),
    [sym_pointer_expression] = STATE(3234),
    [sym_logical_expression] = STATE(3234),
    [sym_bitwise_expression] = STATE(3234),
    [sym_equality_expression] = STATE(3234),
    [sym_relational_expression] = STATE(3234),
    [sym_shift_expression] = STATE(3234),
    [sym_math_expression] = STATE(3234),
    [sym_cast_expression] = STATE(3234),
    [sym_sizeof_expression] = STATE(3234),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3234),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_concatenated_string] = STATE(3234),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3234),
    [sym_new_expression] = STATE(3234),
    [sym_delete_expression] = STATE(3234),
    [sym_lambda_expression] = STATE(3234),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7432),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7434),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7432),
    [sym_char_literal] = ACTIONS(7432),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7436),
    [sym_false] = ACTIONS(7436),
    [sym_null] = ACTIONS(7436),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7436),
  },
  [3185] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7438),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3186] = {
    [sym__expression] = STATE(3236),
    [sym_conditional_expression] = STATE(3236),
    [sym_assignment_expression] = STATE(3236),
    [sym_pointer_expression] = STATE(3236),
    [sym_logical_expression] = STATE(3236),
    [sym_bitwise_expression] = STATE(3236),
    [sym_equality_expression] = STATE(3236),
    [sym_relational_expression] = STATE(3236),
    [sym_shift_expression] = STATE(3236),
    [sym_math_expression] = STATE(3236),
    [sym_cast_expression] = STATE(3236),
    [sym_sizeof_expression] = STATE(3236),
    [sym_subscript_expression] = STATE(3236),
    [sym_call_expression] = STATE(3236),
    [sym_field_expression] = STATE(3236),
    [sym_compound_literal_expression] = STATE(3236),
    [sym_parenthesized_expression] = STATE(3236),
    [sym_concatenated_string] = STATE(3236),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3236),
    [sym_new_expression] = STATE(3236),
    [sym_delete_expression] = STATE(3236),
    [sym_lambda_expression] = STATE(3236),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7440),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(7438),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(7440),
    [sym_char_literal] = ACTIONS(7440),
    [sym_string_literal] = ACTIONS(1411),
    [sym_true] = ACTIONS(7442),
    [sym_false] = ACTIONS(7442),
    [sym_null] = ACTIONS(7442),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1417),
    [sym_nullptr] = ACTIONS(7442),
  },
  [3187] = {
    [sym__expression] = STATE(3237),
    [sym_conditional_expression] = STATE(3237),
    [sym_assignment_expression] = STATE(3237),
    [sym_pointer_expression] = STATE(3237),
    [sym_logical_expression] = STATE(3237),
    [sym_bitwise_expression] = STATE(3237),
    [sym_equality_expression] = STATE(3237),
    [sym_relational_expression] = STATE(3237),
    [sym_shift_expression] = STATE(3237),
    [sym_math_expression] = STATE(3237),
    [sym_cast_expression] = STATE(3237),
    [sym_sizeof_expression] = STATE(3237),
    [sym_subscript_expression] = STATE(3237),
    [sym_call_expression] = STATE(3237),
    [sym_field_expression] = STATE(3237),
    [sym_compound_literal_expression] = STATE(3237),
    [sym_parenthesized_expression] = STATE(3237),
    [sym_concatenated_string] = STATE(3237),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3237),
    [sym_new_expression] = STATE(3237),
    [sym_delete_expression] = STATE(3237),
    [sym_lambda_expression] = STATE(3237),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7444),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3047),
    [sym_number_literal] = ACTIONS(7444),
    [sym_char_literal] = ACTIONS(7444),
    [sym_string_literal] = ACTIONS(3049),
    [sym_true] = ACTIONS(7446),
    [sym_false] = ACTIONS(7446),
    [sym_null] = ACTIONS(7446),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3055),
    [sym_nullptr] = ACTIONS(7446),
  },
  [3188] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [3189] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3190] = {
    [sym_compound_statement] = STATE(3238),
    [sym_labeled_statement] = STATE(3238),
    [sym_expression_statement] = STATE(3238),
    [sym_if_statement] = STATE(3238),
    [sym_switch_statement] = STATE(3238),
    [sym_case_statement] = STATE(3238),
    [sym_while_statement] = STATE(3238),
    [sym_do_statement] = STATE(3238),
    [sym_for_statement] = STATE(3238),
    [sym_return_statement] = STATE(3238),
    [sym_break_statement] = STATE(3238),
    [sym_continue_statement] = STATE(3238),
    [sym_goto_statement] = STATE(3238),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3238),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3191] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7448),
    [sym_comment] = ACTIONS(49),
  },
  [3192] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(7450),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [3193] = {
    [sym_compound_statement] = STATE(3241),
    [sym_labeled_statement] = STATE(3241),
    [sym_expression_statement] = STATE(3241),
    [sym_if_statement] = STATE(3241),
    [sym_switch_statement] = STATE(3241),
    [sym_case_statement] = STATE(3241),
    [sym_while_statement] = STATE(3241),
    [sym_do_statement] = STATE(3241),
    [sym_for_statement] = STATE(3241),
    [sym_return_statement] = STATE(3241),
    [sym_break_statement] = STATE(3241),
    [sym_continue_statement] = STATE(3241),
    [sym_goto_statement] = STATE(3241),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3241),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3194] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_else] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [3195] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7452),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3196] = {
    [sym__type_declarator] = STATE(3243),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [3197] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [3198] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7454),
    [sym_comment] = ACTIONS(49),
  },
  [3199] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_else] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [3200] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7456),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3201] = {
    [sym_compound_statement] = STATE(3246),
    [sym_labeled_statement] = STATE(3246),
    [sym_expression_statement] = STATE(3246),
    [sym_if_statement] = STATE(3246),
    [sym_switch_statement] = STATE(3246),
    [sym_case_statement] = STATE(3246),
    [sym_while_statement] = STATE(3246),
    [sym_do_statement] = STATE(3246),
    [sym_for_statement] = STATE(3246),
    [sym_return_statement] = STATE(3246),
    [sym_break_statement] = STATE(3246),
    [sym_continue_statement] = STATE(3246),
    [sym_goto_statement] = STATE(3246),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3246),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3202] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3248),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7458),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3203] = {
    [sym__expression] = STATE(3249),
    [sym_conditional_expression] = STATE(3249),
    [sym_assignment_expression] = STATE(3249),
    [sym_pointer_expression] = STATE(3249),
    [sym_logical_expression] = STATE(3249),
    [sym_bitwise_expression] = STATE(3249),
    [sym_equality_expression] = STATE(3249),
    [sym_relational_expression] = STATE(3249),
    [sym_shift_expression] = STATE(3249),
    [sym_math_expression] = STATE(3249),
    [sym_cast_expression] = STATE(3249),
    [sym_sizeof_expression] = STATE(3249),
    [sym_subscript_expression] = STATE(3249),
    [sym_call_expression] = STATE(3249),
    [sym_field_expression] = STATE(3249),
    [sym_compound_literal_expression] = STATE(3249),
    [sym_parenthesized_expression] = STATE(3249),
    [sym_concatenated_string] = STATE(3249),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3249),
    [sym_new_expression] = STATE(3249),
    [sym_delete_expression] = STATE(3249),
    [sym_lambda_expression] = STATE(3249),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7460),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7458),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7460),
    [sym_char_literal] = ACTIONS(7460),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7462),
    [sym_false] = ACTIONS(7462),
    [sym_null] = ACTIONS(7462),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7462),
  },
  [3204] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7464),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3205] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7466),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3206] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3207] = {
    [sym_compound_statement] = STATE(3252),
    [sym_labeled_statement] = STATE(3252),
    [sym_expression_statement] = STATE(3252),
    [sym_if_statement] = STATE(3252),
    [sym_switch_statement] = STATE(3252),
    [sym_case_statement] = STATE(3252),
    [sym_while_statement] = STATE(3252),
    [sym_do_statement] = STATE(3252),
    [sym_for_statement] = STATE(3252),
    [sym_return_statement] = STATE(3252),
    [sym_break_statement] = STATE(3252),
    [sym_continue_statement] = STATE(3252),
    [sym_goto_statement] = STATE(3252),
    [sym__expression] = STATE(1485),
    [sym_comma_expression] = STATE(1486),
    [sym_conditional_expression] = STATE(1485),
    [sym_assignment_expression] = STATE(1485),
    [sym_pointer_expression] = STATE(1485),
    [sym_logical_expression] = STATE(1485),
    [sym_bitwise_expression] = STATE(1485),
    [sym_equality_expression] = STATE(1485),
    [sym_relational_expression] = STATE(1485),
    [sym_shift_expression] = STATE(1485),
    [sym_math_expression] = STATE(1485),
    [sym_cast_expression] = STATE(1485),
    [sym_sizeof_expression] = STATE(1485),
    [sym_subscript_expression] = STATE(1485),
    [sym_call_expression] = STATE(1485),
    [sym_field_expression] = STATE(1485),
    [sym_compound_literal_expression] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1485),
    [sym_concatenated_string] = STATE(1485),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(1485),
    [sym_for_range_loop] = STATE(3252),
    [sym_new_expression] = STATE(1485),
    [sym_delete_expression] = STATE(1485),
    [sym_lambda_expression] = STATE(1485),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(2971),
    [sym_char_literal] = ACTIONS(2971),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(3019),
  },
  [3208] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_else] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [3209] = {
    [sym_compound_statement] = STATE(3253),
    [sym_labeled_statement] = STATE(3253),
    [sym_expression_statement] = STATE(3253),
    [sym_if_statement] = STATE(3253),
    [sym_switch_statement] = STATE(3253),
    [sym_case_statement] = STATE(3253),
    [sym_while_statement] = STATE(3253),
    [sym_do_statement] = STATE(3253),
    [sym_for_statement] = STATE(3253),
    [sym_return_statement] = STATE(3253),
    [sym_break_statement] = STATE(3253),
    [sym_continue_statement] = STATE(3253),
    [sym_goto_statement] = STATE(3253),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3253),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3210] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [3211] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_RBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_else] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [3212] = {
    [sym_compound_statement] = STATE(3254),
    [sym_labeled_statement] = STATE(3254),
    [sym_expression_statement] = STATE(3254),
    [sym_if_statement] = STATE(3254),
    [sym_switch_statement] = STATE(3254),
    [sym_case_statement] = STATE(3254),
    [sym_while_statement] = STATE(3254),
    [sym_do_statement] = STATE(3254),
    [sym_for_statement] = STATE(3254),
    [sym_return_statement] = STATE(3254),
    [sym_break_statement] = STATE(3254),
    [sym_continue_statement] = STATE(3254),
    [sym_goto_statement] = STATE(3254),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3254),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3213] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7468),
    [sym_comment] = ACTIONS(49),
  },
  [3214] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3256),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7468),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3215] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_RBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [3216] = {
    [sym_compound_statement] = STATE(3003),
    [sym_labeled_statement] = STATE(3003),
    [sym_expression_statement] = STATE(3003),
    [sym_if_statement] = STATE(3003),
    [sym_switch_statement] = STATE(3003),
    [sym_case_statement] = STATE(3003),
    [sym_while_statement] = STATE(3003),
    [sym_do_statement] = STATE(3003),
    [sym_for_statement] = STATE(3003),
    [sym_return_statement] = STATE(3003),
    [sym_break_statement] = STATE(3003),
    [sym_continue_statement] = STATE(3003),
    [sym_goto_statement] = STATE(3003),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3003),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3217] = {
    [anon_sym_else] = ACTIONS(7470),
    [anon_sym_while] = ACTIONS(6737),
    [sym_comment] = ACTIONS(49),
  },
  [3218] = {
    [sym_compound_statement] = STATE(3006),
    [sym_labeled_statement] = STATE(3006),
    [sym_expression_statement] = STATE(3006),
    [sym_if_statement] = STATE(3006),
    [sym_switch_statement] = STATE(3006),
    [sym_case_statement] = STATE(3006),
    [sym_while_statement] = STATE(3006),
    [sym_do_statement] = STATE(3006),
    [sym_for_statement] = STATE(3006),
    [sym_return_statement] = STATE(3006),
    [sym_break_statement] = STATE(3006),
    [sym_continue_statement] = STATE(3006),
    [sym_goto_statement] = STATE(3006),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3006),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3219] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7472),
    [sym_comment] = ACTIONS(49),
  },
  [3220] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3259),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3221] = {
    [sym__expression] = STATE(3260),
    [sym_conditional_expression] = STATE(3260),
    [sym_assignment_expression] = STATE(3260),
    [sym_pointer_expression] = STATE(3260),
    [sym_logical_expression] = STATE(3260),
    [sym_bitwise_expression] = STATE(3260),
    [sym_equality_expression] = STATE(3260),
    [sym_relational_expression] = STATE(3260),
    [sym_shift_expression] = STATE(3260),
    [sym_math_expression] = STATE(3260),
    [sym_cast_expression] = STATE(3260),
    [sym_sizeof_expression] = STATE(3260),
    [sym_subscript_expression] = STATE(3260),
    [sym_call_expression] = STATE(3260),
    [sym_field_expression] = STATE(3260),
    [sym_compound_literal_expression] = STATE(3260),
    [sym_parenthesized_expression] = STATE(3260),
    [sym_concatenated_string] = STATE(3260),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3260),
    [sym_new_expression] = STATE(3260),
    [sym_delete_expression] = STATE(3260),
    [sym_lambda_expression] = STATE(3260),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7474),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7472),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7474),
    [sym_char_literal] = ACTIONS(7474),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7476),
    [sym_false] = ACTIONS(7476),
    [sym_null] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7476),
  },
  [3222] = {
    [sym_compound_statement] = STATE(3010),
    [sym_labeled_statement] = STATE(3010),
    [sym_expression_statement] = STATE(3010),
    [sym_if_statement] = STATE(3010),
    [sym_switch_statement] = STATE(3010),
    [sym_case_statement] = STATE(3010),
    [sym_while_statement] = STATE(3010),
    [sym_do_statement] = STATE(3010),
    [sym_for_statement] = STATE(3010),
    [sym_return_statement] = STATE(3010),
    [sym_break_statement] = STATE(3010),
    [sym_continue_statement] = STATE(3010),
    [sym_goto_statement] = STATE(3010),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3010),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3223] = {
    [anon_sym_else] = ACTIONS(7418),
    [anon_sym_while] = ACTIONS(7418),
    [sym_comment] = ACTIONS(49),
  },
  [3224] = {
    [sym_raw_string_literal] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6395),
    [anon_sym_LPAREN] = ACTIONS(6393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6395),
    [sym_preproc_directive] = ACTIONS(6395),
    [anon_sym_SEMI] = ACTIONS(6393),
    [anon_sym_typedef] = ACTIONS(6395),
    [anon_sym_extern] = ACTIONS(6395),
    [anon_sym_LBRACE] = ACTIONS(6393),
    [anon_sym_STAR] = ACTIONS(6393),
    [anon_sym_LBRACK] = ACTIONS(6393),
    [anon_sym_static] = ACTIONS(6395),
    [anon_sym_register] = ACTIONS(6395),
    [anon_sym_inline] = ACTIONS(6395),
    [anon_sym_const] = ACTIONS(6395),
    [anon_sym_restrict] = ACTIONS(6395),
    [anon_sym_volatile] = ACTIONS(6395),
    [anon_sym__Atomic] = ACTIONS(6395),
    [anon_sym_mutable] = ACTIONS(6395),
    [anon_sym_explicit] = ACTIONS(6395),
    [anon_sym_constexpr] = ACTIONS(6395),
    [anon_sym_unsigned] = ACTIONS(6395),
    [anon_sym_long] = ACTIONS(6395),
    [anon_sym_short] = ACTIONS(6395),
    [sym_primitive_type] = ACTIONS(6395),
    [anon_sym_enum] = ACTIONS(6395),
    [anon_sym_struct] = ACTIONS(6395),
    [anon_sym_union] = ACTIONS(6395),
    [anon_sym_if] = ACTIONS(6395),
    [anon_sym_else] = ACTIONS(7478),
    [anon_sym_switch] = ACTIONS(6395),
    [anon_sym_case] = ACTIONS(6395),
    [anon_sym_default] = ACTIONS(6395),
    [anon_sym_while] = ACTIONS(6395),
    [anon_sym_do] = ACTIONS(6395),
    [anon_sym_for] = ACTIONS(6395),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_break] = ACTIONS(6395),
    [anon_sym_continue] = ACTIONS(6395),
    [anon_sym_goto] = ACTIONS(6395),
    [anon_sym_AMP] = ACTIONS(6393),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_TILDE] = ACTIONS(6393),
    [anon_sym_PLUS] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DASH_DASH] = ACTIONS(6393),
    [anon_sym_PLUS_PLUS] = ACTIONS(6393),
    [anon_sym_sizeof] = ACTIONS(6395),
    [sym_number_literal] = ACTIONS(6393),
    [sym_char_literal] = ACTIONS(6393),
    [sym_string_literal] = ACTIONS(6393),
    [sym_true] = ACTIONS(6395),
    [sym_false] = ACTIONS(6395),
    [sym_null] = ACTIONS(6395),
    [sym_identifier] = ACTIONS(6395),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6395),
    [sym_auto] = ACTIONS(6395),
    [anon_sym_typename] = ACTIONS(6395),
    [anon_sym_new] = ACTIONS(6395),
    [anon_sym_COLON_COLON] = ACTIONS(6393),
    [anon_sym_delete] = ACTIONS(6395),
    [sym_nullptr] = ACTIONS(6395),
  },
  [3225] = {
    [sym_compound_statement] = STATE(3262),
    [sym_labeled_statement] = STATE(3262),
    [sym_expression_statement] = STATE(3262),
    [sym_if_statement] = STATE(3262),
    [sym_switch_statement] = STATE(3262),
    [sym_case_statement] = STATE(3262),
    [sym_while_statement] = STATE(3262),
    [sym_do_statement] = STATE(3262),
    [sym_for_statement] = STATE(3262),
    [sym_return_statement] = STATE(3262),
    [sym_break_statement] = STATE(3262),
    [sym_continue_statement] = STATE(3262),
    [sym_goto_statement] = STATE(3262),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3262),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3226] = {
    [sym_raw_string_literal] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6405),
    [anon_sym_LPAREN] = ACTIONS(6403),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6405),
    [sym_preproc_directive] = ACTIONS(6405),
    [anon_sym_SEMI] = ACTIONS(6403),
    [anon_sym_typedef] = ACTIONS(6405),
    [anon_sym_extern] = ACTIONS(6405),
    [anon_sym_LBRACE] = ACTIONS(6403),
    [anon_sym_STAR] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(6403),
    [anon_sym_static] = ACTIONS(6405),
    [anon_sym_register] = ACTIONS(6405),
    [anon_sym_inline] = ACTIONS(6405),
    [anon_sym_const] = ACTIONS(6405),
    [anon_sym_restrict] = ACTIONS(6405),
    [anon_sym_volatile] = ACTIONS(6405),
    [anon_sym__Atomic] = ACTIONS(6405),
    [anon_sym_mutable] = ACTIONS(6405),
    [anon_sym_explicit] = ACTIONS(6405),
    [anon_sym_constexpr] = ACTIONS(6405),
    [anon_sym_unsigned] = ACTIONS(6405),
    [anon_sym_long] = ACTIONS(6405),
    [anon_sym_short] = ACTIONS(6405),
    [sym_primitive_type] = ACTIONS(6405),
    [anon_sym_enum] = ACTIONS(6405),
    [anon_sym_struct] = ACTIONS(6405),
    [anon_sym_union] = ACTIONS(6405),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_else] = ACTIONS(6405),
    [anon_sym_switch] = ACTIONS(6405),
    [anon_sym_case] = ACTIONS(6405),
    [anon_sym_default] = ACTIONS(6405),
    [anon_sym_while] = ACTIONS(6405),
    [anon_sym_do] = ACTIONS(6405),
    [anon_sym_for] = ACTIONS(6405),
    [anon_sym_return] = ACTIONS(6405),
    [anon_sym_break] = ACTIONS(6405),
    [anon_sym_continue] = ACTIONS(6405),
    [anon_sym_goto] = ACTIONS(6405),
    [anon_sym_AMP] = ACTIONS(6403),
    [anon_sym_BANG] = ACTIONS(6403),
    [anon_sym_TILDE] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DASH_DASH] = ACTIONS(6403),
    [anon_sym_PLUS_PLUS] = ACTIONS(6403),
    [anon_sym_sizeof] = ACTIONS(6405),
    [sym_number_literal] = ACTIONS(6403),
    [sym_char_literal] = ACTIONS(6403),
    [sym_string_literal] = ACTIONS(6403),
    [sym_true] = ACTIONS(6405),
    [sym_false] = ACTIONS(6405),
    [sym_null] = ACTIONS(6405),
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6405),
    [sym_auto] = ACTIONS(6405),
    [anon_sym_typename] = ACTIONS(6405),
    [anon_sym_new] = ACTIONS(6405),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_delete] = ACTIONS(6405),
    [sym_nullptr] = ACTIONS(6405),
  },
  [3227] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7480),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3228] = {
    [sym__type_declarator] = STATE(3264),
    [sym_pointer_type_declarator] = STATE(223),
    [sym_function_type_declarator] = STATE(224),
    [sym_array_type_declarator] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(345),
    [sym_identifier] = ACTIONS(347),
    [sym_comment] = ACTIONS(49),
  },
  [3229] = {
    [sym_raw_string_literal] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1313),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym_mutable] = ACTIONS(1313),
    [anon_sym_explicit] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1311),
    [sym_char_literal] = ACTIONS(1311),
    [sym_string_literal] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1313),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1313),
    [sym_auto] = ACTIONS(1313),
    [anon_sym_typename] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_COLON_COLON] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1313),
    [sym_nullptr] = ACTIONS(1313),
  },
  [3230] = {
    [aux_sym_declaration_repeat1] = STATE(715),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(7482),
    [sym_comment] = ACTIONS(49),
  },
  [3231] = {
    [sym_raw_string_literal] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6421),
    [anon_sym_LPAREN] = ACTIONS(6419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6421),
    [sym_preproc_directive] = ACTIONS(6421),
    [anon_sym_SEMI] = ACTIONS(6419),
    [anon_sym_typedef] = ACTIONS(6421),
    [anon_sym_extern] = ACTIONS(6421),
    [anon_sym_LBRACE] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_static] = ACTIONS(6421),
    [anon_sym_register] = ACTIONS(6421),
    [anon_sym_inline] = ACTIONS(6421),
    [anon_sym_const] = ACTIONS(6421),
    [anon_sym_restrict] = ACTIONS(6421),
    [anon_sym_volatile] = ACTIONS(6421),
    [anon_sym__Atomic] = ACTIONS(6421),
    [anon_sym_mutable] = ACTIONS(6421),
    [anon_sym_explicit] = ACTIONS(6421),
    [anon_sym_constexpr] = ACTIONS(6421),
    [anon_sym_unsigned] = ACTIONS(6421),
    [anon_sym_long] = ACTIONS(6421),
    [anon_sym_short] = ACTIONS(6421),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(6421),
    [anon_sym_struct] = ACTIONS(6421),
    [anon_sym_union] = ACTIONS(6421),
    [anon_sym_if] = ACTIONS(6421),
    [anon_sym_else] = ACTIONS(6421),
    [anon_sym_switch] = ACTIONS(6421),
    [anon_sym_case] = ACTIONS(6421),
    [anon_sym_default] = ACTIONS(6421),
    [anon_sym_while] = ACTIONS(6421),
    [anon_sym_do] = ACTIONS(6421),
    [anon_sym_for] = ACTIONS(6421),
    [anon_sym_return] = ACTIONS(6421),
    [anon_sym_break] = ACTIONS(6421),
    [anon_sym_continue] = ACTIONS(6421),
    [anon_sym_goto] = ACTIONS(6421),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_BANG] = ACTIONS(6419),
    [anon_sym_TILDE] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DASH_DASH] = ACTIONS(6419),
    [anon_sym_PLUS_PLUS] = ACTIONS(6419),
    [anon_sym_sizeof] = ACTIONS(6421),
    [sym_number_literal] = ACTIONS(6419),
    [sym_char_literal] = ACTIONS(6419),
    [sym_string_literal] = ACTIONS(6419),
    [sym_true] = ACTIONS(6421),
    [sym_false] = ACTIONS(6421),
    [sym_null] = ACTIONS(6421),
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6421),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(6421),
    [anon_sym_new] = ACTIONS(6421),
    [anon_sym_COLON_COLON] = ACTIONS(6419),
    [anon_sym_delete] = ACTIONS(6421),
    [sym_nullptr] = ACTIONS(6421),
  },
  [3232] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7484),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3233] = {
    [sym_compound_statement] = STATE(3267),
    [sym_labeled_statement] = STATE(3267),
    [sym_expression_statement] = STATE(3267),
    [sym_if_statement] = STATE(3267),
    [sym_switch_statement] = STATE(3267),
    [sym_case_statement] = STATE(3267),
    [sym_while_statement] = STATE(3267),
    [sym_do_statement] = STATE(3267),
    [sym_for_statement] = STATE(3267),
    [sym_return_statement] = STATE(3267),
    [sym_break_statement] = STATE(3267),
    [sym_continue_statement] = STATE(3267),
    [sym_goto_statement] = STATE(3267),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3267),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3234] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3269),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7486),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3235] = {
    [sym__expression] = STATE(3270),
    [sym_conditional_expression] = STATE(3270),
    [sym_assignment_expression] = STATE(3270),
    [sym_pointer_expression] = STATE(3270),
    [sym_logical_expression] = STATE(3270),
    [sym_bitwise_expression] = STATE(3270),
    [sym_equality_expression] = STATE(3270),
    [sym_relational_expression] = STATE(3270),
    [sym_shift_expression] = STATE(3270),
    [sym_math_expression] = STATE(3270),
    [sym_cast_expression] = STATE(3270),
    [sym_sizeof_expression] = STATE(3270),
    [sym_subscript_expression] = STATE(3270),
    [sym_call_expression] = STATE(3270),
    [sym_field_expression] = STATE(3270),
    [sym_compound_literal_expression] = STATE(3270),
    [sym_parenthesized_expression] = STATE(3270),
    [sym_concatenated_string] = STATE(3270),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3270),
    [sym_new_expression] = STATE(3270),
    [sym_delete_expression] = STATE(3270),
    [sym_lambda_expression] = STATE(3270),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7488),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7486),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7488),
    [sym_char_literal] = ACTIONS(7488),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7490),
    [sym_false] = ACTIONS(7490),
    [sym_null] = ACTIONS(7490),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7490),
  },
  [3236] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2629),
    [anon_sym_STAR_EQ] = ACTIONS(2631),
    [anon_sym_SLASH_EQ] = ACTIONS(2631),
    [anon_sym_PERCENT_EQ] = ACTIONS(2631),
    [anon_sym_PLUS_EQ] = ACTIONS(2631),
    [anon_sym_DASH_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_GT_EQ] = ACTIONS(2631),
    [anon_sym_AMP_EQ] = ACTIONS(2631),
    [anon_sym_CARET_EQ] = ACTIONS(2631),
    [anon_sym_PIPE_EQ] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_EQ_EQ] = ACTIONS(2643),
    [anon_sym_BANG_EQ] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2649),
    [anon_sym_GT_GT] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3237] = {
    [sym_argument_list] = STATE(844),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(7494),
    [anon_sym_STAR] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4663),
    [anon_sym_SLASH_EQ] = ACTIONS(4663),
    [anon_sym_PERCENT_EQ] = ACTIONS(4663),
    [anon_sym_PLUS_EQ] = ACTIONS(4663),
    [anon_sym_DASH_EQ] = ACTIONS(4663),
    [anon_sym_LT_LT_EQ] = ACTIONS(4663),
    [anon_sym_GT_GT_EQ] = ACTIONS(4663),
    [anon_sym_AMP_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4663),
    [anon_sym_PIPE_EQ] = ACTIONS(4663),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4671),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_EQ_EQ] = ACTIONS(4675),
    [anon_sym_BANG_EQ] = ACTIONS(4675),
    [anon_sym_LT] = ACTIONS(4677),
    [anon_sym_GT] = ACTIONS(4677),
    [anon_sym_LT_EQ] = ACTIONS(4679),
    [anon_sym_GT_EQ] = ACTIONS(4679),
    [anon_sym_LT_LT] = ACTIONS(4681),
    [anon_sym_GT_GT] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3238] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3239] = {
    [sym_compound_statement] = STATE(3273),
    [sym_labeled_statement] = STATE(3273),
    [sym_expression_statement] = STATE(3273),
    [sym_if_statement] = STATE(3273),
    [sym_switch_statement] = STATE(3273),
    [sym_case_statement] = STATE(3273),
    [sym_while_statement] = STATE(3273),
    [sym_do_statement] = STATE(3273),
    [sym_for_statement] = STATE(3273),
    [sym_return_statement] = STATE(3273),
    [sym_break_statement] = STATE(3273),
    [sym_continue_statement] = STATE(3273),
    [sym_goto_statement] = STATE(3273),
    [sym__expression] = STATE(2029),
    [sym_comma_expression] = STATE(2030),
    [sym_conditional_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_pointer_expression] = STATE(2029),
    [sym_logical_expression] = STATE(2029),
    [sym_bitwise_expression] = STATE(2029),
    [sym_equality_expression] = STATE(2029),
    [sym_relational_expression] = STATE(2029),
    [sym_shift_expression] = STATE(2029),
    [sym_math_expression] = STATE(2029),
    [sym_cast_expression] = STATE(2029),
    [sym_sizeof_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_field_expression] = STATE(2029),
    [sym_compound_literal_expression] = STATE(2029),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_concatenated_string] = STATE(2029),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2029),
    [sym_for_range_loop] = STATE(3273),
    [sym_new_expression] = STATE(2029),
    [sym_delete_expression] = STATE(2029),
    [sym_lambda_expression] = STATE(2029),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(4537),
    [anon_sym_switch] = ACTIONS(4539),
    [anon_sym_case] = ACTIONS(4541),
    [anon_sym_default] = ACTIONS(4543),
    [anon_sym_while] = ACTIONS(4545),
    [anon_sym_do] = ACTIONS(4547),
    [anon_sym_for] = ACTIONS(4549),
    [anon_sym_return] = ACTIONS(4551),
    [anon_sym_break] = ACTIONS(4553),
    [anon_sym_continue] = ACTIONS(4555),
    [anon_sym_goto] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(4515),
    [sym_char_literal] = ACTIONS(4515),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(4559),
    [sym_false] = ACTIONS(4559),
    [sym_null] = ACTIONS(4559),
    [sym_identifier] = ACTIONS(6203),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(4559),
  },
  [3240] = {
    [sym_compound_statement] = STATE(3274),
    [sym_labeled_statement] = STATE(3274),
    [sym_expression_statement] = STATE(3274),
    [sym_if_statement] = STATE(3274),
    [sym_switch_statement] = STATE(3274),
    [sym_case_statement] = STATE(3274),
    [sym_while_statement] = STATE(3274),
    [sym_do_statement] = STATE(3274),
    [sym_for_statement] = STATE(3274),
    [sym_return_statement] = STATE(3274),
    [sym_break_statement] = STATE(3274),
    [sym_continue_statement] = STATE(3274),
    [sym_goto_statement] = STATE(3274),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3274),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3241] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(7496),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [3242] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [3243] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7498),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3244] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_else] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [3245] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_else] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [3246] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_else] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [3247] = {
    [sym_compound_statement] = STATE(3277),
    [sym_labeled_statement] = STATE(3277),
    [sym_expression_statement] = STATE(3277),
    [sym_if_statement] = STATE(3277),
    [sym_switch_statement] = STATE(3277),
    [sym_case_statement] = STATE(3277),
    [sym_while_statement] = STATE(3277),
    [sym_do_statement] = STATE(3277),
    [sym_for_statement] = STATE(3277),
    [sym_return_statement] = STATE(3277),
    [sym_break_statement] = STATE(3277),
    [sym_continue_statement] = STATE(3277),
    [sym_goto_statement] = STATE(3277),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3277),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3248] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7500),
    [sym_comment] = ACTIONS(49),
  },
  [3249] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3279),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3250] = {
    [sym__expression] = STATE(3280),
    [sym_conditional_expression] = STATE(3280),
    [sym_assignment_expression] = STATE(3280),
    [sym_pointer_expression] = STATE(3280),
    [sym_logical_expression] = STATE(3280),
    [sym_bitwise_expression] = STATE(3280),
    [sym_equality_expression] = STATE(3280),
    [sym_relational_expression] = STATE(3280),
    [sym_shift_expression] = STATE(3280),
    [sym_math_expression] = STATE(3280),
    [sym_cast_expression] = STATE(3280),
    [sym_sizeof_expression] = STATE(3280),
    [sym_subscript_expression] = STATE(3280),
    [sym_call_expression] = STATE(3280),
    [sym_field_expression] = STATE(3280),
    [sym_compound_literal_expression] = STATE(3280),
    [sym_parenthesized_expression] = STATE(3280),
    [sym_concatenated_string] = STATE(3280),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3280),
    [sym_new_expression] = STATE(3280),
    [sym_delete_expression] = STATE(3280),
    [sym_lambda_expression] = STATE(3280),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7502),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7500),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7502),
    [sym_char_literal] = ACTIONS(7502),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7504),
    [sym_false] = ACTIONS(7504),
    [sym_null] = ACTIONS(7504),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7504),
  },
  [3251] = {
    [sym_compound_statement] = STATE(3281),
    [sym_labeled_statement] = STATE(3281),
    [sym_expression_statement] = STATE(3281),
    [sym_if_statement] = STATE(3281),
    [sym_switch_statement] = STATE(3281),
    [sym_case_statement] = STATE(3281),
    [sym_while_statement] = STATE(3281),
    [sym_do_statement] = STATE(3281),
    [sym_for_statement] = STATE(3281),
    [sym_return_statement] = STATE(3281),
    [sym_break_statement] = STATE(3281),
    [sym_continue_statement] = STATE(3281),
    [sym_goto_statement] = STATE(3281),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3281),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3252] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
  [3253] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_RBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_else] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [3254] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_RBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3255] = {
    [sym_compound_statement] = STATE(3282),
    [sym_labeled_statement] = STATE(3282),
    [sym_expression_statement] = STATE(3282),
    [sym_if_statement] = STATE(3282),
    [sym_switch_statement] = STATE(3282),
    [sym_case_statement] = STATE(3282),
    [sym_while_statement] = STATE(3282),
    [sym_do_statement] = STATE(3282),
    [sym_for_statement] = STATE(3282),
    [sym_return_statement] = STATE(3282),
    [sym_break_statement] = STATE(3282),
    [sym_continue_statement] = STATE(3282),
    [sym_goto_statement] = STATE(3282),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3282),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3256] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [sym_comment] = ACTIONS(49),
  },
  [3257] = {
    [sym_compound_statement] = STATE(3096),
    [sym_labeled_statement] = STATE(3096),
    [sym_expression_statement] = STATE(3096),
    [sym_if_statement] = STATE(3096),
    [sym_switch_statement] = STATE(3096),
    [sym_case_statement] = STATE(3096),
    [sym_while_statement] = STATE(3096),
    [sym_do_statement] = STATE(3096),
    [sym_for_statement] = STATE(3096),
    [sym_return_statement] = STATE(3096),
    [sym_break_statement] = STATE(3096),
    [sym_continue_statement] = STATE(3096),
    [sym_goto_statement] = STATE(3096),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3096),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3258] = {
    [sym_compound_statement] = STATE(3097),
    [sym_labeled_statement] = STATE(3097),
    [sym_expression_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_switch_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_do_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_return_statement] = STATE(3097),
    [sym_break_statement] = STATE(3097),
    [sym_continue_statement] = STATE(3097),
    [sym_goto_statement] = STATE(3097),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3097),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3259] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7508),
    [sym_comment] = ACTIONS(49),
  },
  [3260] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3285),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7508),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3261] = {
    [sym_compound_statement] = STATE(3286),
    [sym_labeled_statement] = STATE(3286),
    [sym_expression_statement] = STATE(3286),
    [sym_if_statement] = STATE(3286),
    [sym_switch_statement] = STATE(3286),
    [sym_case_statement] = STATE(3286),
    [sym_while_statement] = STATE(3286),
    [sym_do_statement] = STATE(3286),
    [sym_for_statement] = STATE(3286),
    [sym_return_statement] = STATE(3286),
    [sym_break_statement] = STATE(3286),
    [sym_continue_statement] = STATE(3286),
    [sym_goto_statement] = STATE(3286),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3286),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3262] = {
    [sym_raw_string_literal] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6737),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6739),
    [sym_preproc_directive] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6737),
    [anon_sym_typedef] = ACTIONS(6739),
    [anon_sym_extern] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6737),
    [anon_sym_STAR] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(6737),
    [anon_sym_static] = ACTIONS(6739),
    [anon_sym_register] = ACTIONS(6739),
    [anon_sym_inline] = ACTIONS(6739),
    [anon_sym_const] = ACTIONS(6739),
    [anon_sym_restrict] = ACTIONS(6739),
    [anon_sym_volatile] = ACTIONS(6739),
    [anon_sym__Atomic] = ACTIONS(6739),
    [anon_sym_mutable] = ACTIONS(6739),
    [anon_sym_explicit] = ACTIONS(6739),
    [anon_sym_constexpr] = ACTIONS(6739),
    [anon_sym_unsigned] = ACTIONS(6739),
    [anon_sym_long] = ACTIONS(6739),
    [anon_sym_short] = ACTIONS(6739),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_enum] = ACTIONS(6739),
    [anon_sym_struct] = ACTIONS(6739),
    [anon_sym_union] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(7510),
    [anon_sym_switch] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_default] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [anon_sym_continue] = ACTIONS(6739),
    [anon_sym_goto] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6737),
    [anon_sym_BANG] = ACTIONS(6737),
    [anon_sym_TILDE] = ACTIONS(6737),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(6739),
    [anon_sym_DASH_DASH] = ACTIONS(6737),
    [anon_sym_PLUS_PLUS] = ACTIONS(6737),
    [anon_sym_sizeof] = ACTIONS(6739),
    [sym_number_literal] = ACTIONS(6737),
    [sym_char_literal] = ACTIONS(6737),
    [sym_string_literal] = ACTIONS(6737),
    [sym_true] = ACTIONS(6739),
    [sym_false] = ACTIONS(6739),
    [sym_null] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6739),
    [sym_auto] = ACTIONS(6739),
    [anon_sym_typename] = ACTIONS(6739),
    [anon_sym_new] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6737),
    [anon_sym_delete] = ACTIONS(6739),
    [sym_nullptr] = ACTIONS(6739),
  },
  [3263] = {
    [sym_raw_string_literal] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2054),
    [sym_preproc_directive] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2054),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_mutable] = ACTIONS(2054),
    [anon_sym_explicit] = ACTIONS(2054),
    [anon_sym_constexpr] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_goto] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_sizeof] = ACTIONS(2054),
    [sym_number_literal] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [sym_string_literal] = ACTIONS(2052),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2054),
    [sym_auto] = ACTIONS(2054),
    [anon_sym_typename] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2054),
    [sym_nullptr] = ACTIONS(2054),
  },
  [3264] = {
    [sym_parameter_list] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(7512),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(49),
  },
  [3265] = {
    [sym_raw_string_literal] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_else] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [sym_string_literal] = ACTIONS(2550),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2552),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(2552),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2552),
    [sym_nullptr] = ACTIONS(2552),
  },
  [3266] = {
    [sym_raw_string_literal] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6781),
    [anon_sym_LPAREN] = ACTIONS(6779),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6781),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6781),
    [sym_preproc_directive] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6779),
    [anon_sym_typedef] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym_LBRACE] = ACTIONS(6779),
    [anon_sym_STAR] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6779),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6781),
    [anon_sym_else] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6781),
    [anon_sym_default] = ACTIONS(6781),
    [anon_sym_while] = ACTIONS(6781),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6781),
    [anon_sym_return] = ACTIONS(6781),
    [anon_sym_break] = ACTIONS(6781),
    [anon_sym_continue] = ACTIONS(6781),
    [anon_sym_goto] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6779),
    [anon_sym_sizeof] = ACTIONS(6781),
    [sym_number_literal] = ACTIONS(6779),
    [sym_char_literal] = ACTIONS(6779),
    [sym_string_literal] = ACTIONS(6779),
    [sym_true] = ACTIONS(6781),
    [sym_false] = ACTIONS(6781),
    [sym_null] = ACTIONS(6781),
    [sym_identifier] = ACTIONS(6781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6781),
    [sym_auto] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_new] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6781),
    [sym_nullptr] = ACTIONS(6781),
  },
  [3267] = {
    [sym_raw_string_literal] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6785),
    [sym_preproc_directive] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_typedef] = ACTIONS(6785),
    [anon_sym_extern] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_static] = ACTIONS(6785),
    [anon_sym_register] = ACTIONS(6785),
    [anon_sym_inline] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_restrict] = ACTIONS(6785),
    [anon_sym_volatile] = ACTIONS(6785),
    [anon_sym__Atomic] = ACTIONS(6785),
    [anon_sym_mutable] = ACTIONS(6785),
    [anon_sym_explicit] = ACTIONS(6785),
    [anon_sym_constexpr] = ACTIONS(6785),
    [anon_sym_unsigned] = ACTIONS(6785),
    [anon_sym_long] = ACTIONS(6785),
    [anon_sym_short] = ACTIONS(6785),
    [sym_primitive_type] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_struct] = ACTIONS(6785),
    [anon_sym_union] = ACTIONS(6785),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_else] = ACTIONS(6785),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_goto] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_sizeof] = ACTIONS(6785),
    [sym_number_literal] = ACTIONS(6783),
    [sym_char_literal] = ACTIONS(6783),
    [sym_string_literal] = ACTIONS(6783),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(6785),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6785),
    [sym_auto] = ACTIONS(6785),
    [anon_sym_typename] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_delete] = ACTIONS(6785),
    [sym_nullptr] = ACTIONS(6785),
  },
  [3268] = {
    [sym_compound_statement] = STATE(3289),
    [sym_labeled_statement] = STATE(3289),
    [sym_expression_statement] = STATE(3289),
    [sym_if_statement] = STATE(3289),
    [sym_switch_statement] = STATE(3289),
    [sym_case_statement] = STATE(3289),
    [sym_while_statement] = STATE(3289),
    [sym_do_statement] = STATE(3289),
    [sym_for_statement] = STATE(3289),
    [sym_return_statement] = STATE(3289),
    [sym_break_statement] = STATE(3289),
    [sym_continue_statement] = STATE(3289),
    [sym_goto_statement] = STATE(3289),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3289),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3269] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7514),
    [sym_comment] = ACTIONS(49),
  },
  [3270] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3291),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3271] = {
    [sym__expression] = STATE(3292),
    [sym_conditional_expression] = STATE(3292),
    [sym_assignment_expression] = STATE(3292),
    [sym_pointer_expression] = STATE(3292),
    [sym_logical_expression] = STATE(3292),
    [sym_bitwise_expression] = STATE(3292),
    [sym_equality_expression] = STATE(3292),
    [sym_relational_expression] = STATE(3292),
    [sym_shift_expression] = STATE(3292),
    [sym_math_expression] = STATE(3292),
    [sym_cast_expression] = STATE(3292),
    [sym_sizeof_expression] = STATE(3292),
    [sym_subscript_expression] = STATE(3292),
    [sym_call_expression] = STATE(3292),
    [sym_field_expression] = STATE(3292),
    [sym_compound_literal_expression] = STATE(3292),
    [sym_parenthesized_expression] = STATE(3292),
    [sym_concatenated_string] = STATE(3292),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(3292),
    [sym_new_expression] = STATE(3292),
    [sym_delete_expression] = STATE(3292),
    [sym_lambda_expression] = STATE(3292),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(7516),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(7514),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(7516),
    [sym_char_literal] = ACTIONS(7516),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(7518),
    [sym_false] = ACTIONS(7518),
    [sym_null] = ACTIONS(7518),
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [sym_nullptr] = ACTIONS(7518),
  },
  [3272] = {
    [sym_compound_statement] = STATE(3293),
    [sym_labeled_statement] = STATE(3293),
    [sym_expression_statement] = STATE(3293),
    [sym_if_statement] = STATE(3293),
    [sym_switch_statement] = STATE(3293),
    [sym_case_statement] = STATE(3293),
    [sym_while_statement] = STATE(3293),
    [sym_do_statement] = STATE(3293),
    [sym_for_statement] = STATE(3293),
    [sym_return_statement] = STATE(3293),
    [sym_break_statement] = STATE(3293),
    [sym_continue_statement] = STATE(3293),
    [sym_goto_statement] = STATE(3293),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3293),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3273] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
  [3274] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_else] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [3275] = {
    [sym_compound_statement] = STATE(3294),
    [sym_labeled_statement] = STATE(3294),
    [sym_expression_statement] = STATE(3294),
    [sym_if_statement] = STATE(3294),
    [sym_switch_statement] = STATE(3294),
    [sym_case_statement] = STATE(3294),
    [sym_while_statement] = STATE(3294),
    [sym_do_statement] = STATE(3294),
    [sym_for_statement] = STATE(3294),
    [sym_return_statement] = STATE(3294),
    [sym_break_statement] = STATE(3294),
    [sym_continue_statement] = STATE(3294),
    [sym_goto_statement] = STATE(3294),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3294),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3276] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [3277] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_else] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [3278] = {
    [sym_compound_statement] = STATE(3295),
    [sym_labeled_statement] = STATE(3295),
    [sym_expression_statement] = STATE(3295),
    [sym_if_statement] = STATE(3295),
    [sym_switch_statement] = STATE(3295),
    [sym_case_statement] = STATE(3295),
    [sym_while_statement] = STATE(3295),
    [sym_do_statement] = STATE(3295),
    [sym_for_statement] = STATE(3295),
    [sym_return_statement] = STATE(3295),
    [sym_break_statement] = STATE(3295),
    [sym_continue_statement] = STATE(3295),
    [sym_goto_statement] = STATE(3295),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3295),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3279] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7520),
    [sym_comment] = ACTIONS(49),
  },
  [3280] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3297),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7520),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3281] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [3282] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_RBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3283] = {
    [sym_compound_statement] = STATE(3298),
    [sym_labeled_statement] = STATE(3298),
    [sym_expression_statement] = STATE(3298),
    [sym_if_statement] = STATE(3298),
    [sym_switch_statement] = STATE(3298),
    [sym_case_statement] = STATE(3298),
    [sym_while_statement] = STATE(3298),
    [sym_do_statement] = STATE(3298),
    [sym_for_statement] = STATE(3298),
    [sym_return_statement] = STATE(3298),
    [sym_break_statement] = STATE(3298),
    [sym_continue_statement] = STATE(3298),
    [sym_goto_statement] = STATE(3298),
    [sym__expression] = STATE(2469),
    [sym_comma_expression] = STATE(2470),
    [sym_conditional_expression] = STATE(2469),
    [sym_assignment_expression] = STATE(2469),
    [sym_pointer_expression] = STATE(2469),
    [sym_logical_expression] = STATE(2469),
    [sym_bitwise_expression] = STATE(2469),
    [sym_equality_expression] = STATE(2469),
    [sym_relational_expression] = STATE(2469),
    [sym_shift_expression] = STATE(2469),
    [sym_math_expression] = STATE(2469),
    [sym_cast_expression] = STATE(2469),
    [sym_sizeof_expression] = STATE(2469),
    [sym_subscript_expression] = STATE(2469),
    [sym_call_expression] = STATE(2469),
    [sym_field_expression] = STATE(2469),
    [sym_compound_literal_expression] = STATE(2469),
    [sym_parenthesized_expression] = STATE(2469),
    [sym_concatenated_string] = STATE(2469),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2469),
    [sym_for_range_loop] = STATE(3298),
    [sym_new_expression] = STATE(2469),
    [sym_delete_expression] = STATE(2469),
    [sym_lambda_expression] = STATE(2469),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5672),
    [anon_sym_default] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_break] = ACTIONS(5684),
    [anon_sym_continue] = ACTIONS(5686),
    [anon_sym_goto] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(5662),
    [sym_char_literal] = ACTIONS(5662),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(5690),
    [sym_false] = ACTIONS(5690),
    [sym_null] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(5690),
  },
  [3284] = {
    [sym_compound_statement] = STATE(3169),
    [sym_labeled_statement] = STATE(3169),
    [sym_expression_statement] = STATE(3169),
    [sym_if_statement] = STATE(3169),
    [sym_switch_statement] = STATE(3169),
    [sym_case_statement] = STATE(3169),
    [sym_while_statement] = STATE(3169),
    [sym_do_statement] = STATE(3169),
    [sym_for_statement] = STATE(3169),
    [sym_return_statement] = STATE(3169),
    [sym_break_statement] = STATE(3169),
    [sym_continue_statement] = STATE(3169),
    [sym_goto_statement] = STATE(3169),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3169),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3285] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7522),
    [sym_comment] = ACTIONS(49),
  },
  [3286] = {
    [sym_raw_string_literal] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6992),
    [sym_preproc_directive] = ACTIONS(6992),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_typedef] = ACTIONS(6992),
    [anon_sym_extern] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_static] = ACTIONS(6992),
    [anon_sym_register] = ACTIONS(6992),
    [anon_sym_inline] = ACTIONS(6992),
    [anon_sym_const] = ACTIONS(6992),
    [anon_sym_restrict] = ACTIONS(6992),
    [anon_sym_volatile] = ACTIONS(6992),
    [anon_sym__Atomic] = ACTIONS(6992),
    [anon_sym_mutable] = ACTIONS(6992),
    [anon_sym_explicit] = ACTIONS(6992),
    [anon_sym_constexpr] = ACTIONS(6992),
    [anon_sym_unsigned] = ACTIONS(6992),
    [anon_sym_long] = ACTIONS(6992),
    [anon_sym_short] = ACTIONS(6992),
    [sym_primitive_type] = ACTIONS(6992),
    [anon_sym_enum] = ACTIONS(6992),
    [anon_sym_struct] = ACTIONS(6992),
    [anon_sym_union] = ACTIONS(6992),
    [anon_sym_if] = ACTIONS(6992),
    [anon_sym_else] = ACTIONS(6992),
    [anon_sym_switch] = ACTIONS(6992),
    [anon_sym_case] = ACTIONS(6992),
    [anon_sym_default] = ACTIONS(6992),
    [anon_sym_while] = ACTIONS(6992),
    [anon_sym_do] = ACTIONS(6992),
    [anon_sym_for] = ACTIONS(6992),
    [anon_sym_return] = ACTIONS(6992),
    [anon_sym_break] = ACTIONS(6992),
    [anon_sym_continue] = ACTIONS(6992),
    [anon_sym_goto] = ACTIONS(6992),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6992),
    [anon_sym_DASH] = ACTIONS(6992),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_sizeof] = ACTIONS(6992),
    [sym_number_literal] = ACTIONS(6990),
    [sym_char_literal] = ACTIONS(6990),
    [sym_string_literal] = ACTIONS(6990),
    [sym_true] = ACTIONS(6992),
    [sym_false] = ACTIONS(6992),
    [sym_null] = ACTIONS(6992),
    [sym_identifier] = ACTIONS(6992),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(6992),
    [sym_auto] = ACTIONS(6992),
    [anon_sym_typename] = ACTIONS(6992),
    [anon_sym_new] = ACTIONS(6992),
    [anon_sym_COLON_COLON] = ACTIONS(6990),
    [anon_sym_delete] = ACTIONS(6992),
    [sym_nullptr] = ACTIONS(6992),
  },
  [3287] = {
    [sym_compound_statement] = STATE(3300),
    [sym_labeled_statement] = STATE(3300),
    [sym_expression_statement] = STATE(3300),
    [sym_if_statement] = STATE(3300),
    [sym_switch_statement] = STATE(3300),
    [sym_case_statement] = STATE(3300),
    [sym_while_statement] = STATE(3300),
    [sym_do_statement] = STATE(3300),
    [sym_for_statement] = STATE(3300),
    [sym_return_statement] = STATE(3300),
    [sym_break_statement] = STATE(3300),
    [sym_continue_statement] = STATE(3300),
    [sym_goto_statement] = STATE(3300),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3300),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3288] = {
    [sym_raw_string_literal] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [sym_char_literal] = ACTIONS(3613),
    [sym_string_literal] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(3615),
    [sym_auto] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_delete] = ACTIONS(3615),
    [sym_nullptr] = ACTIONS(3615),
  },
  [3289] = {
    [sym_raw_string_literal] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7030),
    [anon_sym_LPAREN] = ACTIONS(7028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7030),
    [sym_preproc_directive] = ACTIONS(7030),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_typedef] = ACTIONS(7030),
    [anon_sym_extern] = ACTIONS(7030),
    [anon_sym_LBRACE] = ACTIONS(7028),
    [anon_sym_STAR] = ACTIONS(7028),
    [anon_sym_LBRACK] = ACTIONS(7028),
    [anon_sym_static] = ACTIONS(7030),
    [anon_sym_register] = ACTIONS(7030),
    [anon_sym_inline] = ACTIONS(7030),
    [anon_sym_const] = ACTIONS(7030),
    [anon_sym_restrict] = ACTIONS(7030),
    [anon_sym_volatile] = ACTIONS(7030),
    [anon_sym__Atomic] = ACTIONS(7030),
    [anon_sym_mutable] = ACTIONS(7030),
    [anon_sym_explicit] = ACTIONS(7030),
    [anon_sym_constexpr] = ACTIONS(7030),
    [anon_sym_unsigned] = ACTIONS(7030),
    [anon_sym_long] = ACTIONS(7030),
    [anon_sym_short] = ACTIONS(7030),
    [sym_primitive_type] = ACTIONS(7030),
    [anon_sym_enum] = ACTIONS(7030),
    [anon_sym_struct] = ACTIONS(7030),
    [anon_sym_union] = ACTIONS(7030),
    [anon_sym_if] = ACTIONS(7030),
    [anon_sym_else] = ACTIONS(7030),
    [anon_sym_switch] = ACTIONS(7030),
    [anon_sym_case] = ACTIONS(7030),
    [anon_sym_default] = ACTIONS(7030),
    [anon_sym_while] = ACTIONS(7030),
    [anon_sym_do] = ACTIONS(7030),
    [anon_sym_for] = ACTIONS(7030),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_break] = ACTIONS(7030),
    [anon_sym_continue] = ACTIONS(7030),
    [anon_sym_goto] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_BANG] = ACTIONS(7028),
    [anon_sym_TILDE] = ACTIONS(7028),
    [anon_sym_PLUS] = ACTIONS(7030),
    [anon_sym_DASH] = ACTIONS(7030),
    [anon_sym_DASH_DASH] = ACTIONS(7028),
    [anon_sym_PLUS_PLUS] = ACTIONS(7028),
    [anon_sym_sizeof] = ACTIONS(7030),
    [sym_number_literal] = ACTIONS(7028),
    [sym_char_literal] = ACTIONS(7028),
    [sym_string_literal] = ACTIONS(7028),
    [sym_true] = ACTIONS(7030),
    [sym_false] = ACTIONS(7030),
    [sym_null] = ACTIONS(7030),
    [sym_identifier] = ACTIONS(7030),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7030),
    [sym_auto] = ACTIONS(7030),
    [anon_sym_typename] = ACTIONS(7030),
    [anon_sym_new] = ACTIONS(7030),
    [anon_sym_COLON_COLON] = ACTIONS(7028),
    [anon_sym_delete] = ACTIONS(7030),
    [sym_nullptr] = ACTIONS(7030),
  },
  [3290] = {
    [sym_compound_statement] = STATE(3301),
    [sym_labeled_statement] = STATE(3301),
    [sym_expression_statement] = STATE(3301),
    [sym_if_statement] = STATE(3301),
    [sym_switch_statement] = STATE(3301),
    [sym_case_statement] = STATE(3301),
    [sym_while_statement] = STATE(3301),
    [sym_do_statement] = STATE(3301),
    [sym_for_statement] = STATE(3301),
    [sym_return_statement] = STATE(3301),
    [sym_break_statement] = STATE(3301),
    [sym_continue_statement] = STATE(3301),
    [sym_goto_statement] = STATE(3301),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3301),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3291] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7524),
    [sym_comment] = ACTIONS(49),
  },
  [3292] = {
    [sym_argument_list] = STATE(844),
    [aux_sym_for_statement_repeat1] = STATE(3303),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7524),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2304),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_EQ_EQ] = ACTIONS(2318),
    [anon_sym_BANG_EQ] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_LT_EQ] = ACTIONS(2322),
    [anon_sym_GT_EQ] = ACTIONS(2322),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [sym_comment] = ACTIONS(49),
  },
  [3293] = {
    [sym_raw_string_literal] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7053),
    [anon_sym_LPAREN] = ACTIONS(7051),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7053),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7053),
    [sym_preproc_directive] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7051),
    [anon_sym_typedef] = ACTIONS(7053),
    [anon_sym_extern] = ACTIONS(7053),
    [anon_sym_LBRACE] = ACTIONS(7051),
    [anon_sym_STAR] = ACTIONS(7051),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_static] = ACTIONS(7053),
    [anon_sym_register] = ACTIONS(7053),
    [anon_sym_inline] = ACTIONS(7053),
    [anon_sym_const] = ACTIONS(7053),
    [anon_sym_restrict] = ACTIONS(7053),
    [anon_sym_volatile] = ACTIONS(7053),
    [anon_sym__Atomic] = ACTIONS(7053),
    [anon_sym_mutable] = ACTIONS(7053),
    [anon_sym_explicit] = ACTIONS(7053),
    [anon_sym_constexpr] = ACTIONS(7053),
    [anon_sym_unsigned] = ACTIONS(7053),
    [anon_sym_long] = ACTIONS(7053),
    [anon_sym_short] = ACTIONS(7053),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_enum] = ACTIONS(7053),
    [anon_sym_struct] = ACTIONS(7053),
    [anon_sym_union] = ACTIONS(7053),
    [anon_sym_if] = ACTIONS(7053),
    [anon_sym_else] = ACTIONS(7053),
    [anon_sym_switch] = ACTIONS(7053),
    [anon_sym_case] = ACTIONS(7053),
    [anon_sym_default] = ACTIONS(7053),
    [anon_sym_while] = ACTIONS(7053),
    [anon_sym_do] = ACTIONS(7053),
    [anon_sym_for] = ACTIONS(7053),
    [anon_sym_return] = ACTIONS(7053),
    [anon_sym_break] = ACTIONS(7053),
    [anon_sym_continue] = ACTIONS(7053),
    [anon_sym_goto] = ACTIONS(7053),
    [anon_sym_AMP] = ACTIONS(7051),
    [anon_sym_BANG] = ACTIONS(7051),
    [anon_sym_TILDE] = ACTIONS(7051),
    [anon_sym_PLUS] = ACTIONS(7053),
    [anon_sym_DASH] = ACTIONS(7053),
    [anon_sym_DASH_DASH] = ACTIONS(7051),
    [anon_sym_PLUS_PLUS] = ACTIONS(7051),
    [anon_sym_sizeof] = ACTIONS(7053),
    [sym_number_literal] = ACTIONS(7051),
    [sym_char_literal] = ACTIONS(7051),
    [sym_string_literal] = ACTIONS(7051),
    [sym_true] = ACTIONS(7053),
    [sym_false] = ACTIONS(7053),
    [sym_null] = ACTIONS(7053),
    [sym_identifier] = ACTIONS(7053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7053),
    [sym_auto] = ACTIONS(7053),
    [anon_sym_typename] = ACTIONS(7053),
    [anon_sym_new] = ACTIONS(7053),
    [anon_sym_COLON_COLON] = ACTIONS(7051),
    [anon_sym_delete] = ACTIONS(7053),
    [sym_nullptr] = ACTIONS(7053),
  },
  [3294] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_else] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [3295] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3296] = {
    [sym_compound_statement] = STATE(3304),
    [sym_labeled_statement] = STATE(3304),
    [sym_expression_statement] = STATE(3304),
    [sym_if_statement] = STATE(3304),
    [sym_switch_statement] = STATE(3304),
    [sym_case_statement] = STATE(3304),
    [sym_while_statement] = STATE(3304),
    [sym_do_statement] = STATE(3304),
    [sym_for_statement] = STATE(3304),
    [sym_return_statement] = STATE(3304),
    [sym_break_statement] = STATE(3304),
    [sym_continue_statement] = STATE(3304),
    [sym_goto_statement] = STATE(3304),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3304),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3297] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7526),
    [sym_comment] = ACTIONS(49),
  },
  [3298] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_RBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_else] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
  [3299] = {
    [sym_compound_statement] = STATE(3223),
    [sym_labeled_statement] = STATE(3223),
    [sym_expression_statement] = STATE(3223),
    [sym_if_statement] = STATE(3223),
    [sym_switch_statement] = STATE(3223),
    [sym_case_statement] = STATE(3223),
    [sym_while_statement] = STATE(3223),
    [sym_do_statement] = STATE(3223),
    [sym_for_statement] = STATE(3223),
    [sym_return_statement] = STATE(3223),
    [sym_break_statement] = STATE(3223),
    [sym_continue_statement] = STATE(3223),
    [sym_goto_statement] = STATE(3223),
    [sym__expression] = STATE(915),
    [sym_comma_expression] = STATE(916),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(915),
    [sym_for_range_loop] = STATE(3223),
    [sym_new_expression] = STATE(915),
    [sym_delete_expression] = STATE(915),
    [sym_lambda_expression] = STATE(915),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6423),
    [anon_sym_switch] = ACTIONS(6425),
    [anon_sym_case] = ACTIONS(6427),
    [anon_sym_default] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(6431),
    [anon_sym_do] = ACTIONS(1734),
    [anon_sym_for] = ACTIONS(6433),
    [anon_sym_return] = ACTIONS(1738),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(6435),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(1746),
  },
  [3300] = {
    [sym_raw_string_literal] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7185),
    [anon_sym_LPAREN] = ACTIONS(7183),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7185),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7185),
    [sym_preproc_directive] = ACTIONS(7185),
    [anon_sym_SEMI] = ACTIONS(7183),
    [anon_sym_typedef] = ACTIONS(7185),
    [anon_sym_extern] = ACTIONS(7185),
    [anon_sym_LBRACE] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_static] = ACTIONS(7185),
    [anon_sym_register] = ACTIONS(7185),
    [anon_sym_inline] = ACTIONS(7185),
    [anon_sym_const] = ACTIONS(7185),
    [anon_sym_restrict] = ACTIONS(7185),
    [anon_sym_volatile] = ACTIONS(7185),
    [anon_sym__Atomic] = ACTIONS(7185),
    [anon_sym_mutable] = ACTIONS(7185),
    [anon_sym_explicit] = ACTIONS(7185),
    [anon_sym_constexpr] = ACTIONS(7185),
    [anon_sym_unsigned] = ACTIONS(7185),
    [anon_sym_long] = ACTIONS(7185),
    [anon_sym_short] = ACTIONS(7185),
    [sym_primitive_type] = ACTIONS(7185),
    [anon_sym_enum] = ACTIONS(7185),
    [anon_sym_struct] = ACTIONS(7185),
    [anon_sym_union] = ACTIONS(7185),
    [anon_sym_if] = ACTIONS(7185),
    [anon_sym_else] = ACTIONS(7185),
    [anon_sym_switch] = ACTIONS(7185),
    [anon_sym_case] = ACTIONS(7185),
    [anon_sym_default] = ACTIONS(7185),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(7185),
    [anon_sym_for] = ACTIONS(7185),
    [anon_sym_return] = ACTIONS(7185),
    [anon_sym_break] = ACTIONS(7185),
    [anon_sym_continue] = ACTIONS(7185),
    [anon_sym_goto] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_BANG] = ACTIONS(7183),
    [anon_sym_TILDE] = ACTIONS(7183),
    [anon_sym_PLUS] = ACTIONS(7185),
    [anon_sym_DASH] = ACTIONS(7185),
    [anon_sym_DASH_DASH] = ACTIONS(7183),
    [anon_sym_PLUS_PLUS] = ACTIONS(7183),
    [anon_sym_sizeof] = ACTIONS(7185),
    [sym_number_literal] = ACTIONS(7183),
    [sym_char_literal] = ACTIONS(7183),
    [sym_string_literal] = ACTIONS(7183),
    [sym_true] = ACTIONS(7185),
    [sym_false] = ACTIONS(7185),
    [sym_null] = ACTIONS(7185),
    [sym_identifier] = ACTIONS(7185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7185),
    [sym_auto] = ACTIONS(7185),
    [anon_sym_typename] = ACTIONS(7185),
    [anon_sym_new] = ACTIONS(7185),
    [anon_sym_COLON_COLON] = ACTIONS(7183),
    [anon_sym_delete] = ACTIONS(7185),
    [sym_nullptr] = ACTIONS(7185),
  },
  [3301] = {
    [sym_raw_string_literal] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(7209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7211),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7211),
    [sym_preproc_directive] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(7209),
    [anon_sym_typedef] = ACTIONS(7211),
    [anon_sym_extern] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7209),
    [anon_sym_STAR] = ACTIONS(7209),
    [anon_sym_LBRACK] = ACTIONS(7209),
    [anon_sym_static] = ACTIONS(7211),
    [anon_sym_register] = ACTIONS(7211),
    [anon_sym_inline] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [anon_sym_restrict] = ACTIONS(7211),
    [anon_sym_volatile] = ACTIONS(7211),
    [anon_sym__Atomic] = ACTIONS(7211),
    [anon_sym_mutable] = ACTIONS(7211),
    [anon_sym_explicit] = ACTIONS(7211),
    [anon_sym_constexpr] = ACTIONS(7211),
    [anon_sym_unsigned] = ACTIONS(7211),
    [anon_sym_long] = ACTIONS(7211),
    [anon_sym_short] = ACTIONS(7211),
    [sym_primitive_type] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_struct] = ACTIONS(7211),
    [anon_sym_union] = ACTIONS(7211),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_goto] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7209),
    [anon_sym_BANG] = ACTIONS(7209),
    [anon_sym_TILDE] = ACTIONS(7209),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(7209),
    [anon_sym_PLUS_PLUS] = ACTIONS(7209),
    [anon_sym_sizeof] = ACTIONS(7211),
    [sym_number_literal] = ACTIONS(7209),
    [sym_char_literal] = ACTIONS(7209),
    [sym_string_literal] = ACTIONS(7209),
    [sym_true] = ACTIONS(7211),
    [sym_false] = ACTIONS(7211),
    [sym_null] = ACTIONS(7211),
    [sym_identifier] = ACTIONS(7211),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7211),
    [sym_auto] = ACTIONS(7211),
    [anon_sym_typename] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_COLON_COLON] = ACTIONS(7209),
    [anon_sym_delete] = ACTIONS(7211),
    [sym_nullptr] = ACTIONS(7211),
  },
  [3302] = {
    [sym_compound_statement] = STATE(3306),
    [sym_labeled_statement] = STATE(3306),
    [sym_expression_statement] = STATE(3306),
    [sym_if_statement] = STATE(3306),
    [sym_switch_statement] = STATE(3306),
    [sym_case_statement] = STATE(3306),
    [sym_while_statement] = STATE(3306),
    [sym_do_statement] = STATE(3306),
    [sym_for_statement] = STATE(3306),
    [sym_return_statement] = STATE(3306),
    [sym_break_statement] = STATE(3306),
    [sym_continue_statement] = STATE(3306),
    [sym_goto_statement] = STATE(3306),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3306),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3303] = {
    [aux_sym_for_statement_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(7528),
    [sym_comment] = ACTIONS(49),
  },
  [3304] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3305] = {
    [sym_compound_statement] = STATE(3308),
    [sym_labeled_statement] = STATE(3308),
    [sym_expression_statement] = STATE(3308),
    [sym_if_statement] = STATE(3308),
    [sym_switch_statement] = STATE(3308),
    [sym_case_statement] = STATE(3308),
    [sym_while_statement] = STATE(3308),
    [sym_do_statement] = STATE(3308),
    [sym_for_statement] = STATE(3308),
    [sym_return_statement] = STATE(3308),
    [sym_break_statement] = STATE(3308),
    [sym_continue_statement] = STATE(3308),
    [sym_goto_statement] = STATE(3308),
    [sym__expression] = STATE(2834),
    [sym_comma_expression] = STATE(2835),
    [sym_conditional_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2834),
    [sym_pointer_expression] = STATE(2834),
    [sym_logical_expression] = STATE(2834),
    [sym_bitwise_expression] = STATE(2834),
    [sym_equality_expression] = STATE(2834),
    [sym_relational_expression] = STATE(2834),
    [sym_shift_expression] = STATE(2834),
    [sym_math_expression] = STATE(2834),
    [sym_cast_expression] = STATE(2834),
    [sym_sizeof_expression] = STATE(2834),
    [sym_subscript_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_field_expression] = STATE(2834),
    [sym_compound_literal_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_concatenated_string] = STATE(2834),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2834),
    [sym_for_range_loop] = STATE(3308),
    [sym_new_expression] = STATE(2834),
    [sym_delete_expression] = STATE(2834),
    [sym_lambda_expression] = STATE(2834),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6633),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6635),
    [anon_sym_LBRACE] = ACTIONS(6637),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6639),
    [anon_sym_switch] = ACTIONS(6641),
    [anon_sym_case] = ACTIONS(6643),
    [anon_sym_default] = ACTIONS(6645),
    [anon_sym_while] = ACTIONS(6647),
    [anon_sym_do] = ACTIONS(6649),
    [anon_sym_for] = ACTIONS(6651),
    [anon_sym_return] = ACTIONS(6653),
    [anon_sym_break] = ACTIONS(6655),
    [anon_sym_continue] = ACTIONS(6657),
    [anon_sym_goto] = ACTIONS(6659),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6633),
    [sym_char_literal] = ACTIONS(6633),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6661),
    [sym_false] = ACTIONS(6661),
    [sym_null] = ACTIONS(6661),
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6661),
  },
  [3306] = {
    [sym_raw_string_literal] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7330),
    [anon_sym_LPAREN] = ACTIONS(7328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7330),
    [sym_preproc_directive] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_typedef] = ACTIONS(7330),
    [anon_sym_extern] = ACTIONS(7330),
    [anon_sym_LBRACE] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(7328),
    [anon_sym_static] = ACTIONS(7330),
    [anon_sym_register] = ACTIONS(7330),
    [anon_sym_inline] = ACTIONS(7330),
    [anon_sym_const] = ACTIONS(7330),
    [anon_sym_restrict] = ACTIONS(7330),
    [anon_sym_volatile] = ACTIONS(7330),
    [anon_sym__Atomic] = ACTIONS(7330),
    [anon_sym_mutable] = ACTIONS(7330),
    [anon_sym_explicit] = ACTIONS(7330),
    [anon_sym_constexpr] = ACTIONS(7330),
    [anon_sym_unsigned] = ACTIONS(7330),
    [anon_sym_long] = ACTIONS(7330),
    [anon_sym_short] = ACTIONS(7330),
    [sym_primitive_type] = ACTIONS(7330),
    [anon_sym_enum] = ACTIONS(7330),
    [anon_sym_struct] = ACTIONS(7330),
    [anon_sym_union] = ACTIONS(7330),
    [anon_sym_if] = ACTIONS(7330),
    [anon_sym_else] = ACTIONS(7330),
    [anon_sym_switch] = ACTIONS(7330),
    [anon_sym_case] = ACTIONS(7330),
    [anon_sym_default] = ACTIONS(7330),
    [anon_sym_while] = ACTIONS(7330),
    [anon_sym_do] = ACTIONS(7330),
    [anon_sym_for] = ACTIONS(7330),
    [anon_sym_return] = ACTIONS(7330),
    [anon_sym_break] = ACTIONS(7330),
    [anon_sym_continue] = ACTIONS(7330),
    [anon_sym_goto] = ACTIONS(7330),
    [anon_sym_AMP] = ACTIONS(7328),
    [anon_sym_BANG] = ACTIONS(7328),
    [anon_sym_TILDE] = ACTIONS(7328),
    [anon_sym_PLUS] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7330),
    [anon_sym_DASH_DASH] = ACTIONS(7328),
    [anon_sym_PLUS_PLUS] = ACTIONS(7328),
    [anon_sym_sizeof] = ACTIONS(7330),
    [sym_number_literal] = ACTIONS(7328),
    [sym_char_literal] = ACTIONS(7328),
    [sym_string_literal] = ACTIONS(7328),
    [sym_true] = ACTIONS(7330),
    [sym_false] = ACTIONS(7330),
    [sym_null] = ACTIONS(7330),
    [sym_identifier] = ACTIONS(7330),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7330),
    [sym_auto] = ACTIONS(7330),
    [anon_sym_typename] = ACTIONS(7330),
    [anon_sym_new] = ACTIONS(7330),
    [anon_sym_COLON_COLON] = ACTIONS(7328),
    [anon_sym_delete] = ACTIONS(7330),
    [sym_nullptr] = ACTIONS(7330),
  },
  [3307] = {
    [sym_compound_statement] = STATE(3309),
    [sym_labeled_statement] = STATE(3309),
    [sym_expression_statement] = STATE(3309),
    [sym_if_statement] = STATE(3309),
    [sym_switch_statement] = STATE(3309),
    [sym_case_statement] = STATE(3309),
    [sym_while_statement] = STATE(3309),
    [sym_do_statement] = STATE(3309),
    [sym_for_statement] = STATE(3309),
    [sym_return_statement] = STATE(3309),
    [sym_break_statement] = STATE(3309),
    [sym_continue_statement] = STATE(3309),
    [sym_goto_statement] = STATE(3309),
    [sym__expression] = STATE(2939),
    [sym_comma_expression] = STATE(2940),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_template_type] = STATE(620),
    [sym_template_function] = STATE(2939),
    [sym_for_range_loop] = STATE(3309),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(391),
    [sym_scoped_identifier] = STATE(392),
    [sym_scoped_type_identifier] = STATE(621),
    [sym_scoped_namespace_identifier] = STATE(622),
    [sym_raw_string_literal] = ACTIONS(6858),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6862),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(6864),
    [anon_sym_switch] = ACTIONS(6866),
    [anon_sym_case] = ACTIONS(6868),
    [anon_sym_default] = ACTIONS(6870),
    [anon_sym_while] = ACTIONS(6872),
    [anon_sym_do] = ACTIONS(6874),
    [anon_sym_for] = ACTIONS(6876),
    [anon_sym_return] = ACTIONS(6878),
    [anon_sym_break] = ACTIONS(6880),
    [anon_sym_continue] = ACTIONS(6882),
    [anon_sym_goto] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_sizeof] = ACTIONS(708),
    [sym_number_literal] = ACTIONS(6858),
    [sym_char_literal] = ACTIONS(6858),
    [sym_string_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(6886),
    [sym_false] = ACTIONS(6886),
    [sym_null] = ACTIONS(6886),
    [sym_identifier] = ACTIONS(6888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_delete] = ACTIONS(718),
    [sym_nullptr] = ACTIONS(6886),
  },
  [3308] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_else] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
  [3309] = {
    [sym_raw_string_literal] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7420),
    [anon_sym_LPAREN] = ACTIONS(7418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7420),
    [sym_preproc_directive] = ACTIONS(7420),
    [anon_sym_SEMI] = ACTIONS(7418),
    [anon_sym_typedef] = ACTIONS(7420),
    [anon_sym_extern] = ACTIONS(7420),
    [anon_sym_LBRACE] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_static] = ACTIONS(7420),
    [anon_sym_register] = ACTIONS(7420),
    [anon_sym_inline] = ACTIONS(7420),
    [anon_sym_const] = ACTIONS(7420),
    [anon_sym_restrict] = ACTIONS(7420),
    [anon_sym_volatile] = ACTIONS(7420),
    [anon_sym__Atomic] = ACTIONS(7420),
    [anon_sym_mutable] = ACTIONS(7420),
    [anon_sym_explicit] = ACTIONS(7420),
    [anon_sym_constexpr] = ACTIONS(7420),
    [anon_sym_unsigned] = ACTIONS(7420),
    [anon_sym_long] = ACTIONS(7420),
    [anon_sym_short] = ACTIONS(7420),
    [sym_primitive_type] = ACTIONS(7420),
    [anon_sym_enum] = ACTIONS(7420),
    [anon_sym_struct] = ACTIONS(7420),
    [anon_sym_union] = ACTIONS(7420),
    [anon_sym_if] = ACTIONS(7420),
    [anon_sym_else] = ACTIONS(7420),
    [anon_sym_switch] = ACTIONS(7420),
    [anon_sym_case] = ACTIONS(7420),
    [anon_sym_default] = ACTIONS(7420),
    [anon_sym_while] = ACTIONS(7420),
    [anon_sym_do] = ACTIONS(7420),
    [anon_sym_for] = ACTIONS(7420),
    [anon_sym_return] = ACTIONS(7420),
    [anon_sym_break] = ACTIONS(7420),
    [anon_sym_continue] = ACTIONS(7420),
    [anon_sym_goto] = ACTIONS(7420),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_BANG] = ACTIONS(7418),
    [anon_sym_TILDE] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7420),
    [anon_sym_DASH] = ACTIONS(7420),
    [anon_sym_DASH_DASH] = ACTIONS(7418),
    [anon_sym_PLUS_PLUS] = ACTIONS(7418),
    [anon_sym_sizeof] = ACTIONS(7420),
    [sym_number_literal] = ACTIONS(7418),
    [sym_char_literal] = ACTIONS(7418),
    [sym_string_literal] = ACTIONS(7418),
    [sym_true] = ACTIONS(7420),
    [sym_false] = ACTIONS(7420),
    [sym_null] = ACTIONS(7420),
    [sym_identifier] = ACTIONS(7420),
    [sym_comment] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(7420),
    [sym_auto] = ACTIONS(7420),
    [anon_sym_typename] = ACTIONS(7420),
    [anon_sym_new] = ACTIONS(7420),
    [anon_sym_COLON_COLON] = ACTIONS(7418),
    [anon_sym_delete] = ACTIONS(7420),
    [sym_nullptr] = ACTIONS(7420),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(2),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = true}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(38),
  [33] = {.count = 1, .reusable = false}, SHIFT(30),
  [35] = {.count = 1, .reusable = false}, SHIFT(14),
  [37] = {.count = 1, .reusable = false}, SHIFT(15),
  [39] = {.count = 1, .reusable = false}, SHIFT(16),
  [41] = {.count = 1, .reusable = false}, SHIFT(17),
  [43] = {.count = 1, .reusable = true}, SHIFT(17),
  [45] = {.count = 1, .reusable = true}, SHIFT(18),
  [47] = {.count = 1, .reusable = false}, SHIFT(19),
  [49] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [51] = {.count = 1, .reusable = false}, SHIFT(20),
  [53] = {.count = 1, .reusable = false}, SHIFT(21),
  [55] = {.count = 1, .reusable = false}, SHIFT(22),
  [57] = {.count = 1, .reusable = false}, SHIFT(23),
  [59] = {.count = 1, .reusable = false}, SHIFT(24),
  [61] = {.count = 1, .reusable = true}, SHIFT(25),
  [63] = {.count = 1, .reusable = true}, SHIFT(28),
  [65] = {.count = 1, .reusable = true}, SHIFT(39),
  [67] = {.count = 1, .reusable = true}, SHIFT(40),
  [69] = {.count = 1, .reusable = true}, SHIFT(41),
  [71] = {.count = 1, .reusable = false}, SHIFT(42),
  [73] = {.count = 1, .reusable = true}, SHIFT(42),
  [75] = {.count = 1, .reusable = false}, SHIFT(43),
  [77] = {.count = 1, .reusable = true}, SHIFT(44),
  [79] = {.count = 1, .reusable = true}, SHIFT(45),
  [81] = {.count = 1, .reusable = false}, SHIFT(48),
  [83] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [85] = {.count = 1, .reusable = true}, SHIFT(49),
  [87] = {.count = 1, .reusable = true}, SHIFT(50),
  [89] = {.count = 1, .reusable = false}, SHIFT(51),
  [91] = {.count = 1, .reusable = false}, SHIFT(52),
  [93] = {.count = 1, .reusable = false}, SHIFT(53),
  [95] = {.count = 1, .reusable = false}, SHIFT(66),
  [97] = {.count = 1, .reusable = false}, SHIFT(61),
  [99] = {.count = 1, .reusable = false}, SHIFT(54),
  [101] = {.count = 1, .reusable = false}, SHIFT(55),
  [103] = {.count = 1, .reusable = false}, SHIFT(56),
  [105] = {.count = 1, .reusable = false}, SHIFT(57),
  [107] = {.count = 1, .reusable = false}, SHIFT(58),
  [109] = {.count = 1, .reusable = false}, SHIFT(59),
  [111] = {.count = 1, .reusable = true}, SHIFT(60),
  [113] = {.count = 1, .reusable = true}, REDUCE(sym_storage_class_specifier, 1),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym_storage_class_specifier, 1),
  [117] = {.count = 1, .reusable = true}, SHIFT(67),
  [119] = {.count = 1, .reusable = true}, SHIFT(68),
  [121] = {.count = 1, .reusable = true}, REDUCE(sym_type_qualifier, 1),
  [123] = {.count = 1, .reusable = false}, REDUCE(sym_type_qualifier, 1),
  [125] = {.count = 1, .reusable = true}, SHIFT(69),
  [127] = {.count = 1, .reusable = true}, SHIFT(70),
  [129] = {.count = 1, .reusable = true}, SHIFT(72),
  [131] = {.count = 1, .reusable = false}, SHIFT(73),
  [133] = {.count = 1, .reusable = false}, SHIFT(74),
  [135] = {.count = 1, .reusable = false}, SHIFT(75),
  [137] = {.count = 1, .reusable = true}, SHIFT(76),
  [139] = {.count = 1, .reusable = false}, SHIFT(83),
  [141] = {.count = 1, .reusable = true}, SHIFT(87),
  [143] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [146] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [148] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [150] = {.count = 1, .reusable = true}, SHIFT(88),
  [152] = {.count = 1, .reusable = true}, SHIFT(89),
  [154] = {.count = 1, .reusable = false}, SHIFT(91),
  [156] = {.count = 1, .reusable = false}, SHIFT(97),
  [158] = {.count = 1, .reusable = false}, SHIFT(95),
  [160] = {.count = 1, .reusable = true}, SHIFT(96),
  [162] = {.count = 1, .reusable = false}, SHIFT(100),
  [164] = {.count = 1, .reusable = true}, SHIFT(101),
  [166] = {.count = 1, .reusable = false}, SHIFT(102),
  [168] = {.count = 1, .reusable = false}, SHIFT(115),
  [170] = {.count = 1, .reusable = false}, SHIFT(110),
  [172] = {.count = 1, .reusable = false}, SHIFT(103),
  [174] = {.count = 1, .reusable = true}, SHIFT(103),
  [176] = {.count = 1, .reusable = true}, SHIFT(104),
  [178] = {.count = 1, .reusable = false}, SHIFT(105),
  [180] = {.count = 1, .reusable = false}, SHIFT(106),
  [182] = {.count = 1, .reusable = true}, SHIFT(107),
  [184] = {.count = 1, .reusable = true}, SHIFT(109),
  [186] = {.count = 1, .reusable = true}, SHIFT(116),
  [188] = {.count = 1, .reusable = true}, SHIFT(117),
  [190] = {.count = 1, .reusable = false}, SHIFT(119),
  [192] = {.count = 1, .reusable = false}, SHIFT(120),
  [194] = {.count = 1, .reusable = true}, SHIFT(121),
  [196] = {.count = 1, .reusable = false}, SHIFT(124),
  [198] = {.count = 1, .reusable = true}, SHIFT(125),
  [200] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [202] = {.count = 1, .reusable = true}, SHIFT(126),
  [204] = {.count = 1, .reusable = true}, SHIFT(127),
  [206] = {.count = 1, .reusable = true}, SHIFT(128),
  [208] = {.count = 1, .reusable = false}, SHIFT(129),
  [210] = {.count = 1, .reusable = true}, SHIFT(129),
  [212] = {.count = 1, .reusable = true}, SHIFT(130),
  [214] = {.count = 1, .reusable = true}, SHIFT(134),
  [216] = {.count = 1, .reusable = true}, SHIFT(135),
  [218] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 1),
  [220] = {.count = 1, .reusable = true}, SHIFT(137),
  [222] = {.count = 1, .reusable = true}, SHIFT(138),
  [224] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 1),
  [226] = {.count = 1, .reusable = false}, SHIFT(141),
  [228] = {.count = 1, .reusable = false}, SHIFT(142),
  [230] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 1),
  [232] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 1, .alias_sequence_id = 2),
  [234] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 1, .alias_sequence_id = 2),
  [236] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1),
  [238] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1),
  [240] = {.count = 1, .reusable = true}, SHIFT(144),
  [242] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 1),
  [244] = {.count = 1, .reusable = false}, SHIFT(149),
  [246] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 1),
  [248] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 1),
  [250] = {.count = 1, .reusable = false}, SHIFT(153),
  [252] = {.count = 1, .reusable = false}, SHIFT(151),
  [254] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(152),
  [257] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 3),
  [259] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 3),
  [261] = {.count = 1, .reusable = false}, SHIFT(154),
  [263] = {.count = 1, .reusable = false}, SHIFT(155),
  [265] = {.count = 1, .reusable = false}, SHIFT(156),
  [267] = {.count = 1, .reusable = true}, SHIFT(158),
  [269] = {.count = 1, .reusable = true}, SHIFT(159),
  [271] = {.count = 1, .reusable = false}, REDUCE(sym__declarator, 1),
  [273] = {.count = 1, .reusable = true}, SHIFT(160),
  [275] = {.count = 1, .reusable = false}, SHIFT(162),
  [277] = {.count = 1, .reusable = true}, SHIFT(163),
  [279] = {.count = 1, .reusable = true}, SHIFT(165),
  [281] = {.count = 1, .reusable = false}, SHIFT(166),
  [283] = {.count = 1, .reusable = false}, SHIFT(167),
  [285] = {.count = 1, .reusable = false}, SHIFT(168),
  [287] = {.count = 1, .reusable = false}, SHIFT(169),
  [289] = {.count = 1, .reusable = false}, SHIFT(170),
  [291] = {.count = 1, .reusable = false}, SHIFT(171),
  [293] = {.count = 1, .reusable = false}, SHIFT(172),
  [295] = {.count = 1, .reusable = false}, SHIFT(173),
  [297] = {.count = 1, .reusable = false}, SHIFT(174),
  [299] = {.count = 1, .reusable = false}, SHIFT(175),
  [301] = {.count = 1, .reusable = false}, SHIFT(176),
  [303] = {.count = 1, .reusable = false}, SHIFT(177),
  [305] = {.count = 1, .reusable = false}, SHIFT(178),
  [307] = {.count = 1, .reusable = false}, SHIFT(179),
  [309] = {.count = 1, .reusable = false}, SHIFT(186),
  [311] = {.count = 1, .reusable = false}, SHIFT(189),
  [313] = {.count = 1, .reusable = false}, SHIFT(192),
  [315] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 2),
  [317] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 2),
  [319] = {.count = 1, .reusable = true}, SHIFT(193),
  [321] = {.count = 1, .reusable = true}, SHIFT(194),
  [323] = {.count = 1, .reusable = true}, SHIFT(196),
  [325] = {.count = 1, .reusable = false}, SHIFT(197),
  [327] = {.count = 1, .reusable = false}, SHIFT(198),
  [329] = {.count = 1, .reusable = true}, SHIFT(199),
  [331] = {.count = 1, .reusable = false}, SHIFT(206),
  [333] = {.count = 1, .reusable = true}, SHIFT(210),
  [335] = {.count = 1, .reusable = true}, SHIFT(211),
  [337] = {.count = 1, .reusable = false}, SHIFT(213),
  [339] = {.count = 1, .reusable = false}, SHIFT(217),
  [341] = {.count = 1, .reusable = true}, SHIFT(218),
  [343] = {.count = 1, .reusable = true}, SHIFT(219),
  [345] = {.count = 1, .reusable = true}, SHIFT(220),
  [347] = {.count = 1, .reusable = true}, SHIFT(221),
  [349] = {.count = 1, .reusable = true}, SHIFT(226),
  [351] = {.count = 1, .reusable = false}, SHIFT(228),
  [353] = {.count = 1, .reusable = false}, SHIFT(232),
  [355] = {.count = 1, .reusable = false}, SHIFT(230),
  [357] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(231),
  [360] = {.count = 1, .reusable = true}, SHIFT(236),
  [362] = {.count = 1, .reusable = true}, SHIFT(237),
  [364] = {.count = 1, .reusable = true}, SHIFT(238),
  [366] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 4),
  [368] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 4),
  [370] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2),
  [372] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2),
  [374] = {.count = 1, .reusable = false}, SHIFT(241),
  [376] = {.count = 1, .reusable = true}, SHIFT(242),
  [378] = {.count = 1, .reusable = true}, SHIFT(243),
  [380] = {.count = 1, .reusable = false}, SHIFT(244),
  [382] = {.count = 1, .reusable = true}, SHIFT(245),
  [384] = {.count = 1, .reusable = false}, SHIFT(268),
  [386] = {.count = 1, .reusable = false}, SHIFT(261),
  [388] = {.count = 1, .reusable = false}, SHIFT(246),
  [390] = {.count = 1, .reusable = false}, SHIFT(247),
  [392] = {.count = 1, .reusable = false}, SHIFT(248),
  [394] = {.count = 1, .reusable = false}, SHIFT(249),
  [396] = {.count = 1, .reusable = false}, SHIFT(250),
  [398] = {.count = 1, .reusable = false}, SHIFT(251),
  [400] = {.count = 1, .reusable = false}, SHIFT(252),
  [402] = {.count = 1, .reusable = false}, SHIFT(253),
  [404] = {.count = 1, .reusable = false}, SHIFT(254),
  [406] = {.count = 1, .reusable = true}, SHIFT(255),
  [408] = {.count = 1, .reusable = true}, SHIFT(259),
  [410] = {.count = 1, .reusable = false}, SHIFT(269),
  [412] = {.count = 1, .reusable = false}, SHIFT(270),
  [414] = {.count = 1, .reusable = true}, REDUCE(sym__class_name, 1, .alias_sequence_id = 1),
  [416] = {.count = 1, .reusable = false}, REDUCE(sym__class_name, 1, .alias_sequence_id = 1),
  [418] = {.count = 1, .reusable = true}, SHIFT(274),
  [420] = {.count = 1, .reusable = true}, SHIFT(275),
  [422] = {.count = 1, .reusable = true}, SHIFT(73),
  [424] = {.count = 1, .reusable = true}, SHIFT(279),
  [426] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2),
  [428] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2),
  [430] = {.count = 1, .reusable = false}, SHIFT(280),
  [432] = {.count = 1, .reusable = true}, REDUCE(sym__class_name, 1),
  [434] = {.count = 1, .reusable = false}, REDUCE(sym__class_name, 1),
  [436] = {.count = 1, .reusable = true}, SHIFT(281),
  [438] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2),
  [440] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2),
  [442] = {.count = 1, .reusable = false}, SHIFT(285),
  [444] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_name, 2),
  [446] = {.count = 1, .reusable = true}, SHIFT(286),
  [448] = {.count = 1, .reusable = false}, SHIFT(296),
  [450] = {.count = 1, .reusable = false}, SHIFT(293),
  [452] = {.count = 1, .reusable = false}, SHIFT(287),
  [454] = {.count = 1, .reusable = false}, SHIFT(288),
  [456] = {.count = 1, .reusable = true}, SHIFT(289),
  [458] = {.count = 1, .reusable = false}, SHIFT(290),
  [460] = {.count = 1, .reusable = false}, SHIFT(291),
  [462] = {.count = 1, .reusable = false}, SHIFT(292),
  [464] = {.count = 1, .reusable = false}, SHIFT(297),
  [466] = {.count = 1, .reusable = true}, SHIFT(298),
  [468] = {.count = 2, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [471] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [473] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [475] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 2),
  [477] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 2),
  [479] = {.count = 1, .reusable = false}, SHIFT(301),
  [481] = {.count = 1, .reusable = true}, SHIFT(302),
  [483] = {.count = 1, .reusable = true}, SHIFT(304),
  [485] = {.count = 1, .reusable = true}, REDUCE(sym_dependent_type, 2),
  [487] = {.count = 1, .reusable = false}, REDUCE(sym_dependent_type, 2),
  [489] = {.count = 1, .reusable = true}, SHIFT(305),
  [491] = {.count = 1, .reusable = true}, SHIFT(306),
  [493] = {.count = 1, .reusable = true}, SHIFT(307),
  [495] = {.count = 1, .reusable = false}, SHIFT(314),
  [497] = {.count = 1, .reusable = false}, SHIFT(311),
  [499] = {.count = 1, .reusable = true}, SHIFT(308),
  [501] = {.count = 1, .reusable = false}, SHIFT(309),
  [503] = {.count = 1, .reusable = true}, SHIFT(315),
  [505] = {.count = 1, .reusable = false}, SHIFT(317),
  [507] = {.count = 1, .reusable = true}, SHIFT(318),
  [509] = {.count = 1, .reusable = true}, SHIFT(319),
  [511] = {.count = 1, .reusable = false}, SHIFT(327),
  [513] = {.count = 1, .reusable = false}, SHIFT(325),
  [515] = {.count = 1, .reusable = false}, SHIFT(322),
  [517] = {.count = 1, .reusable = true}, SHIFT(328),
  [519] = {.count = 1, .reusable = false}, SHIFT(329),
  [521] = {.count = 1, .reusable = false}, SHIFT(331),
  [523] = {.count = 1, .reusable = true}, SHIFT(332),
  [525] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 2),
  [527] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 2),
  [529] = {.count = 1, .reusable = true}, SHIFT(335),
  [531] = {.count = 1, .reusable = true}, SHIFT(336),
  [533] = {.count = 1, .reusable = true}, SHIFT(337),
  [535] = {.count = 1, .reusable = true}, SHIFT(338),
  [537] = {.count = 1, .reusable = false}, SHIFT(340),
  [539] = {.count = 1, .reusable = true}, SHIFT(341),
  [541] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [544] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [546] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [548] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 2, .alias_sequence_id = 5),
  [550] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 2),
  [552] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 2),
  [554] = {.count = 1, .reusable = true}, REDUCE(sym__empty_declaration, 2),
  [556] = {.count = 1, .reusable = false}, REDUCE(sym__empty_declaration, 2),
  [558] = {.count = 1, .reusable = false}, SHIFT(342),
  [560] = {.count = 1, .reusable = true}, SHIFT(342),
  [562] = {.count = 1, .reusable = true}, SHIFT(343),
  [564] = {.count = 1, .reusable = true}, SHIFT(344),
  [566] = {.count = 1, .reusable = true}, SHIFT(345),
  [568] = {.count = 1, .reusable = true}, SHIFT(347),
  [570] = {.count = 1, .reusable = true}, SHIFT(348),
  [572] = {.count = 1, .reusable = true}, SHIFT(349),
  [574] = {.count = 1, .reusable = true}, SHIFT(350),
  [576] = {.count = 1, .reusable = true}, SHIFT(351),
  [578] = {.count = 1, .reusable = true}, SHIFT(356),
  [580] = {.count = 1, .reusable = true}, SHIFT(357),
  [582] = {.count = 1, .reusable = true}, SHIFT(358),
  [584] = {.count = 1, .reusable = true}, SHIFT(360),
  [586] = {.count = 1, .reusable = true}, SHIFT(362),
  [588] = {.count = 1, .reusable = true}, SHIFT(363),
  [590] = {.count = 1, .reusable = false}, SHIFT(368),
  [592] = {.count = 1, .reusable = false}, SHIFT(366),
  [594] = {.count = 1, .reusable = false}, SHIFT(364),
  [596] = {.count = 1, .reusable = true}, SHIFT(389),
  [598] = {.count = 1, .reusable = true}, SHIFT(369),
  [600] = {.count = 1, .reusable = true}, SHIFT(370),
  [602] = {.count = 1, .reusable = true}, SHIFT(371),
  [604] = {.count = 1, .reusable = true}, SHIFT(372),
  [606] = {.count = 1, .reusable = false}, SHIFT(396),
  [608] = {.count = 1, .reusable = false}, SHIFT(388),
  [610] = {.count = 1, .reusable = false}, SHIFT(373),
  [612] = {.count = 1, .reusable = false}, SHIFT(374),
  [614] = {.count = 1, .reusable = false}, SHIFT(375),
  [616] = {.count = 1, .reusable = true}, SHIFT(376),
  [618] = {.count = 1, .reusable = true}, SHIFT(377),
  [620] = {.count = 1, .reusable = false}, SHIFT(378),
  [622] = {.count = 1, .reusable = true}, SHIFT(378),
  [624] = {.count = 1, .reusable = false}, SHIFT(379),
  [626] = {.count = 1, .reusable = true}, SHIFT(380),
  [628] = {.count = 1, .reusable = false}, SHIFT(389),
  [630] = {.count = 1, .reusable = false}, SHIFT(381),
  [632] = {.count = 1, .reusable = false}, SHIFT(382),
  [634] = {.count = 1, .reusable = false}, SHIFT(383),
  [636] = {.count = 1, .reusable = false}, SHIFT(384),
  [638] = {.count = 1, .reusable = true}, SHIFT(385),
  [640] = {.count = 1, .reusable = false}, SHIFT(386),
  [642] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 2),
  [644] = {.count = 1, .reusable = false}, SHIFT(397),
  [646] = {.count = 1, .reusable = true}, SHIFT(397),
  [648] = {.count = 1, .reusable = true}, SHIFT(398),
  [650] = {.count = 1, .reusable = true}, SHIFT(399),
  [652] = {.count = 1, .reusable = true}, SHIFT(434),
  [654] = {.count = 1, .reusable = false}, SHIFT(400),
  [656] = {.count = 1, .reusable = false}, SHIFT(401),
  [658] = {.count = 1, .reusable = true}, SHIFT(402),
  [660] = {.count = 1, .reusable = false}, SHIFT(403),
  [662] = {.count = 1, .reusable = false}, SHIFT(404),
  [664] = {.count = 1, .reusable = false}, SHIFT(405),
  [666] = {.count = 1, .reusable = false}, SHIFT(406),
  [668] = {.count = 1, .reusable = true}, SHIFT(407),
  [670] = {.count = 1, .reusable = false}, SHIFT(408),
  [672] = {.count = 1, .reusable = true}, SHIFT(409),
  [674] = {.count = 1, .reusable = true}, SHIFT(410),
  [676] = {.count = 1, .reusable = true}, SHIFT(411),
  [678] = {.count = 1, .reusable = false}, SHIFT(412),
  [680] = {.count = 1, .reusable = false}, SHIFT(413),
  [682] = {.count = 1, .reusable = false}, SHIFT(414),
  [684] = {.count = 1, .reusable = false}, SHIFT(415),
  [686] = {.count = 1, .reusable = false}, SHIFT(416),
  [688] = {.count = 1, .reusable = false}, SHIFT(417),
  [690] = {.count = 1, .reusable = false}, SHIFT(418),
  [692] = {.count = 1, .reusable = false}, SHIFT(419),
  [694] = {.count = 1, .reusable = false}, SHIFT(420),
  [696] = {.count = 1, .reusable = false}, SHIFT(421),
  [698] = {.count = 1, .reusable = false}, SHIFT(422),
  [700] = {.count = 1, .reusable = true}, SHIFT(423),
  [702] = {.count = 1, .reusable = true}, SHIFT(424),
  [704] = {.count = 1, .reusable = false}, SHIFT(425),
  [706] = {.count = 1, .reusable = true}, SHIFT(425),
  [708] = {.count = 1, .reusable = false}, SHIFT(426),
  [710] = {.count = 1, .reusable = true}, SHIFT(427),
  [712] = {.count = 1, .reusable = false}, SHIFT(434),
  [714] = {.count = 1, .reusable = false}, SHIFT(428),
  [716] = {.count = 1, .reusable = true}, SHIFT(429),
  [718] = {.count = 1, .reusable = false}, SHIFT(430),
  [720] = {.count = 1, .reusable = true}, SHIFT(441),
  [722] = {.count = 1, .reusable = true}, SHIFT(442),
  [724] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [726] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [728] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 2),
  [730] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 2),
  [732] = {.count = 1, .reusable = false}, SHIFT(448),
  [734] = {.count = 1, .reusable = true}, SHIFT(449),
  [736] = {.count = 1, .reusable = true}, REDUCE(sym_template_function, 2),
  [738] = {.count = 1, .reusable = false}, REDUCE(sym_template_function, 2),
  [740] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2),
  [742] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2),
  [744] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [746] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2),
  [749] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3),
  [752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4),
  [755] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5),
  [758] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6),
  [761] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7),
  [764] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8),
  [767] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9),
  [770] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(10),
  [773] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(11),
  [776] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(12),
  [779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(13),
  [782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(38),
  [785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(30),
  [788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(14),
  [791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(15),
  [794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(16),
  [797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(17),
  [800] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(17),
  [803] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(18),
  [806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(19),
  [809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(20),
  [812] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(21),
  [815] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(22),
  [818] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(23),
  [821] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(24),
  [824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(25),
  [827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(28),
  [830] = {.count = 1, .reusable = true}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [832] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(12),
  [835] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(13),
  [838] = {.count = 1, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [840] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2),
  [842] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2),
  [844] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 4),
  [846] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 4),
  [848] = {.count = 1, .reusable = true}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [850] = {.count = 1, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [852] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(153),
  [855] = {.count = 1, .reusable = false}, SHIFT(452),
  [857] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 6),
  [859] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 6),
  [861] = {.count = 1, .reusable = true}, SHIFT(453),
  [863] = {.count = 1, .reusable = true}, SHIFT(454),
  [865] = {.count = 1, .reusable = false}, SHIFT(455),
  [867] = {.count = 1, .reusable = false}, SHIFT(456),
  [869] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 2),
  [871] = {.count = 1, .reusable = true}, REDUCE(sym_reference_declarator, 2),
  [873] = {.count = 1, .reusable = false}, SHIFT(457),
  [875] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 3),
  [877] = {.count = 1, .reusable = true}, SHIFT(458),
  [879] = {.count = 1, .reusable = true}, SHIFT(459),
  [881] = {.count = 1, .reusable = false}, SHIFT(460),
  [883] = {.count = 1, .reusable = true}, SHIFT(461),
  [885] = {.count = 1, .reusable = true}, SHIFT(462),
  [887] = {.count = 1, .reusable = false}, SHIFT(463),
  [889] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 7),
  [891] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 7),
  [893] = {.count = 1, .reusable = true}, SHIFT(464),
  [895] = {.count = 1, .reusable = true}, SHIFT(465),
  [897] = {.count = 1, .reusable = false}, SHIFT(466),
  [899] = {.count = 1, .reusable = false}, SHIFT(467),
  [901] = {.count = 1, .reusable = false}, SHIFT(468),
  [903] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 1, .alias_sequence_id = 8),
  [905] = {.count = 1, .reusable = false}, SHIFT(469),
  [907] = {.count = 1, .reusable = false}, SHIFT(470),
  [909] = {.count = 1, .reusable = false}, SHIFT(471),
  [911] = {.count = 1, .reusable = false}, SHIFT(472),
  [913] = {.count = 1, .reusable = false}, SHIFT(473),
  [915] = {.count = 1, .reusable = false}, SHIFT(474),
  [917] = {.count = 1, .reusable = false}, SHIFT(475),
  [919] = {.count = 1, .reusable = false}, SHIFT(476),
  [921] = {.count = 1, .reusable = false}, SHIFT(482),
  [923] = {.count = 1, .reusable = false}, SHIFT(483),
  [925] = {.count = 1, .reusable = false}, SHIFT(484),
  [927] = {.count = 1, .reusable = false}, SHIFT(485),
  [929] = {.count = 1, .reusable = true}, SHIFT(487),
  [931] = {.count = 1, .reusable = true}, SHIFT(489),
  [933] = {.count = 1, .reusable = true}, SHIFT(491),
  [935] = {.count = 1, .reusable = true}, SHIFT(492),
  [937] = {.count = 1, .reusable = false}, SHIFT(494),
  [939] = {.count = 1, .reusable = false}, SHIFT(495),
  [941] = {.count = 1, .reusable = true}, SHIFT(497),
  [943] = {.count = 1, .reusable = true}, SHIFT(498),
  [945] = {.count = 1, .reusable = true}, SHIFT(499),
  [947] = {.count = 1, .reusable = true}, SHIFT(503),
  [949] = {.count = 1, .reusable = false}, SHIFT(497),
  [951] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 9),
  [953] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 9),
  [955] = {.count = 1, .reusable = true}, SHIFT(509),
  [957] = {.count = 1, .reusable = false}, SHIFT(509),
  [959] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 10),
  [961] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 10),
  [963] = {.count = 1, .reusable = true}, SHIFT(511),
  [965] = {.count = 1, .reusable = false}, SHIFT(511),
  [967] = {.count = 1, .reusable = true}, SHIFT(513),
  [969] = {.count = 1, .reusable = true}, SHIFT(514),
  [971] = {.count = 1, .reusable = true}, SHIFT(515),
  [973] = {.count = 1, .reusable = true}, SHIFT(518),
  [975] = {.count = 1, .reusable = true}, SHIFT(520),
  [977] = {.count = 1, .reusable = true}, SHIFT(521),
  [979] = {.count = 1, .reusable = true}, SHIFT(525),
  [981] = {.count = 1, .reusable = false}, SHIFT(526),
  [983] = {.count = 1, .reusable = true}, SHIFT(527),
  [985] = {.count = 1, .reusable = false}, SHIFT(531),
  [987] = {.count = 1, .reusable = true}, SHIFT(532),
  [989] = {.count = 1, .reusable = true}, SHIFT(534),
  [991] = {.count = 1, .reusable = false}, SHIFT(537),
  [993] = {.count = 1, .reusable = true}, SHIFT(538),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 1),
  [997] = {.count = 1, .reusable = true}, SHIFT(541),
  [999] = {.count = 1, .reusable = true}, SHIFT(542),
  [1001] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 11),
  [1003] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 12),
  [1005] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 13),
  [1007] = {.count = 1, .reusable = true}, SHIFT(544),
  [1009] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(53),
  [1012] = {.count = 1, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1014] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(232),
  [1019] = {.count = 1, .reusable = true}, REDUCE(sym_linkage_specification, 3),
  [1021] = {.count = 1, .reusable = false}, REDUCE(sym_linkage_specification, 3),
  [1023] = {.count = 1, .reusable = true}, SHIFT(546),
  [1025] = {.count = 1, .reusable = true}, SHIFT(547),
  [1027] = {.count = 1, .reusable = true}, SHIFT(548),
  [1029] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 2),
  [1031] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 2),
  [1033] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 1),
  [1035] = {.count = 1, .reusable = true}, SHIFT(549),
  [1037] = {.count = 1, .reusable = true}, SHIFT(550),
  [1039] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 4),
  [1041] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 4),
  [1043] = {.count = 1, .reusable = false}, SHIFT(552),
  [1045] = {.count = 1, .reusable = true}, SHIFT(553),
  [1047] = {.count = 1, .reusable = true}, SHIFT(554),
  [1049] = {.count = 1, .reusable = false}, SHIFT(555),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [1055] = {.count = 1, .reusable = true}, SHIFT(559),
  [1057] = {.count = 1, .reusable = true}, SHIFT(562),
  [1059] = {.count = 1, .reusable = false}, SHIFT(567),
  [1061] = {.count = 1, .reusable = false}, SHIFT(568),
  [1063] = {.count = 1, .reusable = false}, SHIFT(570),
  [1065] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 14),
  [1067] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 14),
  [1069] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 15),
  [1071] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 15),
  [1073] = {.count = 1, .reusable = true}, SHIFT(571),
  [1075] = {.count = 1, .reusable = true}, SHIFT(572),
  [1077] = {.count = 1, .reusable = true}, SHIFT(573),
  [1079] = {.count = 1, .reusable = false}, SHIFT(574),
  [1081] = {.count = 1, .reusable = false}, SHIFT(575),
  [1083] = {.count = 1, .reusable = true}, SHIFT(575),
  [1085] = {.count = 1, .reusable = false}, SHIFT(576),
  [1087] = {.count = 1, .reusable = true}, SHIFT(577),
  [1089] = {.count = 1, .reusable = true}, SHIFT(578),
  [1091] = {.count = 1, .reusable = true}, SHIFT(586),
  [1093] = {.count = 1, .reusable = true}, SHIFT(587),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 2),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 2),
  [1099] = {.count = 1, .reusable = true}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 16),
  [1101] = {.count = 1, .reusable = false}, REDUCE(sym__field_declaration_list_item, 1, .alias_sequence_id = 16),
  [1103] = {.count = 1, .reusable = true}, SHIFT(591),
  [1105] = {.count = 1, .reusable = true}, SHIFT(592),
  [1107] = {.count = 1, .reusable = false}, SHIFT(595),
  [1109] = {.count = 1, .reusable = false}, SHIFT(596),
  [1111] = {.count = 1, .reusable = true}, SHIFT(269),
  [1113] = {.count = 1, .reusable = true}, SHIFT(598),
  [1115] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 2),
  [1117] = {.count = 1, .reusable = true}, SHIFT(600),
  [1119] = {.count = 1, .reusable = true}, SHIFT(602),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3),
  [1125] = {.count = 1, .reusable = true}, SHIFT(605),
  [1127] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3),
  [1129] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3),
  [1131] = {.count = 1, .reusable = true}, SHIFT(618),
  [1133] = {.count = 1, .reusable = true}, SHIFT(608),
  [1135] = {.count = 1, .reusable = true}, SHIFT(609),
  [1137] = {.count = 1, .reusable = true}, SHIFT(610),
  [1139] = {.count = 1, .reusable = true}, SHIFT(611),
  [1141] = {.count = 1, .reusable = false}, SHIFT(612),
  [1143] = {.count = 1, .reusable = true}, SHIFT(612),
  [1145] = {.count = 1, .reusable = false}, SHIFT(613),
  [1147] = {.count = 1, .reusable = true}, SHIFT(614),
  [1149] = {.count = 1, .reusable = false}, SHIFT(618),
  [1151] = {.count = 1, .reusable = false}, SHIFT(615),
  [1153] = {.count = 1, .reusable = true}, SHIFT(616),
  [1155] = {.count = 1, .reusable = false}, SHIFT(617),
  [1157] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 2),
  [1159] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 2),
  [1161] = {.count = 1, .reusable = true}, SHIFT(627),
  [1163] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 1),
  [1165] = {.count = 1, .reusable = true}, SHIFT(628),
  [1167] = {.count = 1, .reusable = true}, SHIFT(629),
  [1169] = {.count = 1, .reusable = false}, SHIFT(630),
  [1171] = {.count = 1, .reusable = true}, SHIFT(630),
  [1173] = {.count = 1, .reusable = true}, SHIFT(633),
  [1175] = {.count = 1, .reusable = true}, SHIFT(634),
  [1177] = {.count = 1, .reusable = false}, SHIFT(636),
  [1179] = {.count = 1, .reusable = false}, SHIFT(637),
  [1181] = {.count = 1, .reusable = false}, SHIFT(152),
  [1183] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1186] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1188] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [1190] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 19),
  [1192] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17),
  [1194] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17),
  [1196] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 3),
  [1198] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 3),
  [1200] = {.count = 1, .reusable = true}, SHIFT(640),
  [1202] = {.count = 1, .reusable = true}, SHIFT(641),
  [1204] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 2),
  [1206] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 2),
  [1208] = {.count = 1, .reusable = false}, SHIFT(642),
  [1210] = {.count = 1, .reusable = false}, SHIFT(643),
  [1212] = {.count = 1, .reusable = true}, SHIFT(644),
  [1214] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 1),
  [1216] = {.count = 1, .reusable = true}, SHIFT(645),
  [1218] = {.count = 1, .reusable = false}, SHIFT(646),
  [1220] = {.count = 1, .reusable = true}, SHIFT(646),
  [1222] = {.count = 1, .reusable = false}, SHIFT(647),
  [1224] = {.count = 1, .reusable = true}, SHIFT(648),
  [1226] = {.count = 1, .reusable = true}, SHIFT(649),
  [1228] = {.count = 1, .reusable = true}, SHIFT(655),
  [1230] = {.count = 1, .reusable = true}, SHIFT(656),
  [1232] = {.count = 1, .reusable = false}, SHIFT(658),
  [1234] = {.count = 1, .reusable = false}, SHIFT(659),
  [1236] = {.count = 1, .reusable = false}, SHIFT(660),
  [1238] = {.count = 1, .reusable = true}, SHIFT(661),
  [1240] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 3),
  [1242] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 3),
  [1244] = {.count = 1, .reusable = true}, SHIFT(662),
  [1246] = {.count = 1, .reusable = true}, SHIFT(663),
  [1248] = {.count = 1, .reusable = true}, REDUCE(sym_template_declaration, 3),
  [1250] = {.count = 1, .reusable = false}, REDUCE(sym_template_declaration, 3),
  [1252] = {.count = 1, .reusable = false}, SHIFT(666),
  [1254] = {.count = 1, .reusable = false}, SHIFT(667),
  [1256] = {.count = 1, .reusable = false}, SHIFT(668),
  [1258] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(100),
  [1261] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(102),
  [1264] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(331),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [1269] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [1271] = {.count = 1, .reusable = true}, SHIFT(670),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 3),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 3),
  [1277] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 3),
  [1279] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 3),
  [1281] = {.count = 1, .reusable = false}, SHIFT(676),
  [1283] = {.count = 1, .reusable = false}, SHIFT(673),
  [1285] = {.count = 1, .reusable = false}, SHIFT(672),
  [1287] = {.count = 1, .reusable = false}, SHIFT(677),
  [1289] = {.count = 1, .reusable = true}, SHIFT(678),
  [1291] = {.count = 1, .reusable = false}, SHIFT(679),
  [1293] = {.count = 1, .reusable = true}, SHIFT(680),
  [1295] = {.count = 1, .reusable = true}, SHIFT(681),
  [1297] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_reference_declarator, 2),
  [1299] = {.count = 1, .reusable = true}, SHIFT(686),
  [1301] = {.count = 1, .reusable = true}, SHIFT(683),
  [1303] = {.count = 1, .reusable = false}, SHIFT(686),
  [1305] = {.count = 1, .reusable = false}, SHIFT(684),
  [1307] = {.count = 1, .reusable = true}, SHIFT(685),
  [1309] = {.count = 1, .reusable = true}, SHIFT(690),
  [1311] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 3),
  [1313] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 3),
  [1315] = {.count = 1, .reusable = true}, SHIFT(706),
  [1317] = {.count = 1, .reusable = true}, SHIFT(692),
  [1319] = {.count = 1, .reusable = true}, SHIFT(693),
  [1321] = {.count = 1, .reusable = true}, SHIFT(694),
  [1323] = {.count = 1, .reusable = true}, SHIFT(695),
  [1325] = {.count = 1, .reusable = true}, SHIFT(696),
  [1327] = {.count = 1, .reusable = true}, SHIFT(697),
  [1329] = {.count = 1, .reusable = true}, SHIFT(698),
  [1331] = {.count = 1, .reusable = true}, SHIFT(699),
  [1333] = {.count = 1, .reusable = false}, SHIFT(700),
  [1335] = {.count = 1, .reusable = true}, SHIFT(700),
  [1337] = {.count = 1, .reusable = false}, SHIFT(701),
  [1339] = {.count = 1, .reusable = true}, SHIFT(702),
  [1341] = {.count = 1, .reusable = true}, SHIFT(703),
  [1343] = {.count = 1, .reusable = false}, SHIFT(706),
  [1345] = {.count = 1, .reusable = true}, SHIFT(704),
  [1347] = {.count = 1, .reusable = false}, SHIFT(705),
  [1349] = {.count = 1, .reusable = true}, SHIFT(710),
  [1351] = {.count = 1, .reusable = false}, SHIFT(710),
  [1353] = {.count = 1, .reusable = true}, SHIFT(709),
  [1355] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1357] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1359] = {.count = 1, .reusable = true}, SHIFT(712),
  [1361] = {.count = 1, .reusable = true}, SHIFT(713),
  [1363] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 2),
  [1365] = {.count = 1, .reusable = true}, SHIFT(714),
  [1367] = {.count = 1, .reusable = true}, SHIFT(716),
  [1369] = {.count = 1, .reusable = true}, SHIFT(727),
  [1371] = {.count = 1, .reusable = true}, SHIFT(717),
  [1373] = {.count = 1, .reusable = true}, SHIFT(718),
  [1375] = {.count = 1, .reusable = true}, SHIFT(719),
  [1377] = {.count = 1, .reusable = true}, SHIFT(720),
  [1379] = {.count = 1, .reusable = true}, SHIFT(721),
  [1381] = {.count = 1, .reusable = false}, SHIFT(722),
  [1383] = {.count = 1, .reusable = true}, SHIFT(722),
  [1385] = {.count = 1, .reusable = false}, SHIFT(723),
  [1387] = {.count = 1, .reusable = true}, SHIFT(724),
  [1389] = {.count = 1, .reusable = false}, SHIFT(727),
  [1391] = {.count = 1, .reusable = true}, SHIFT(725),
  [1393] = {.count = 1, .reusable = false}, SHIFT(726),
  [1395] = {.count = 1, .reusable = true}, SHIFT(737),
  [1397] = {.count = 1, .reusable = true}, SHIFT(728),
  [1399] = {.count = 1, .reusable = true}, SHIFT(729),
  [1401] = {.count = 1, .reusable = true}, SHIFT(730),
  [1403] = {.count = 1, .reusable = true}, SHIFT(731),
  [1405] = {.count = 1, .reusable = false}, SHIFT(732),
  [1407] = {.count = 1, .reusable = true}, SHIFT(732),
  [1409] = {.count = 1, .reusable = false}, SHIFT(733),
  [1411] = {.count = 1, .reusable = true}, SHIFT(734),
  [1413] = {.count = 1, .reusable = false}, SHIFT(737),
  [1415] = {.count = 1, .reusable = true}, SHIFT(735),
  [1417] = {.count = 1, .reusable = false}, SHIFT(736),
  [1419] = {.count = 1, .reusable = true}, SHIFT(739),
  [1421] = {.count = 1, .reusable = true}, SHIFT(740),
  [1423] = {.count = 1, .reusable = false}, SHIFT(740),
  [1425] = {.count = 1, .reusable = true}, SHIFT(742),
  [1427] = {.count = 1, .reusable = true}, SHIFT(743),
  [1429] = {.count = 1, .reusable = true}, SHIFT(744),
  [1431] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1),
  [1433] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1),
  [1435] = {.count = 1, .reusable = true}, SHIFT(746),
  [1437] = {.count = 1, .reusable = false}, SHIFT(747),
  [1439] = {.count = 1, .reusable = true}, SHIFT(747),
  [1441] = {.count = 1, .reusable = true}, SHIFT(748),
  [1443] = {.count = 1, .reusable = false}, SHIFT(752),
  [1445] = {.count = 1, .reusable = false}, SHIFT(753),
  [1447] = {.count = 1, .reusable = true}, SHIFT(758),
  [1449] = {.count = 1, .reusable = false}, SHIFT(762),
  [1451] = {.count = 1, .reusable = false}, SHIFT(757),
  [1453] = {.count = 1, .reusable = false}, SHIFT(758),
  [1455] = {.count = 1, .reusable = false}, SHIFT(754),
  [1457] = {.count = 1, .reusable = false}, SHIFT(755),
  [1459] = {.count = 1, .reusable = true}, SHIFT(756),
  [1461] = {.count = 1, .reusable = true}, SHIFT(764),
  [1463] = {.count = 1, .reusable = false}, SHIFT(764),
  [1465] = {.count = 1, .reusable = true}, SHIFT(763),
  [1467] = {.count = 1, .reusable = true}, SHIFT(777),
  [1469] = {.count = 1, .reusable = true}, SHIFT(765),
  [1471] = {.count = 1, .reusable = true}, SHIFT(766),
  [1473] = {.count = 1, .reusable = true}, SHIFT(767),
  [1475] = {.count = 1, .reusable = true}, SHIFT(768),
  [1477] = {.count = 1, .reusable = true}, SHIFT(769),
  [1479] = {.count = 1, .reusable = true}, SHIFT(770),
  [1481] = {.count = 1, .reusable = true}, SHIFT(771),
  [1483] = {.count = 1, .reusable = false}, SHIFT(772),
  [1485] = {.count = 1, .reusable = true}, SHIFT(772),
  [1487] = {.count = 1, .reusable = false}, SHIFT(773),
  [1489] = {.count = 1, .reusable = true}, SHIFT(774),
  [1491] = {.count = 1, .reusable = false}, SHIFT(777),
  [1493] = {.count = 1, .reusable = true}, SHIFT(775),
  [1495] = {.count = 1, .reusable = false}, SHIFT(776),
  [1497] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 3),
  [1499] = {.count = 1, .reusable = true}, SHIFT(779),
  [1501] = {.count = 1, .reusable = true}, SHIFT(780),
  [1503] = {.count = 1, .reusable = true}, SHIFT(782),
  [1505] = {.count = 1, .reusable = false}, SHIFT(783),
  [1507] = {.count = 1, .reusable = false}, SHIFT(784),
  [1509] = {.count = 1, .reusable = true}, SHIFT(785),
  [1511] = {.count = 1, .reusable = false}, SHIFT(792),
  [1513] = {.count = 1, .reusable = true}, SHIFT(796),
  [1515] = {.count = 1, .reusable = false}, SHIFT(796),
  [1517] = {.count = 1, .reusable = true}, SHIFT(797),
  [1519] = {.count = 1, .reusable = false}, SHIFT(797),
  [1521] = {.count = 1, .reusable = true}, SHIFT(798),
  [1523] = {.count = 1, .reusable = false}, SHIFT(798),
  [1525] = {.count = 1, .reusable = true}, SHIFT(800),
  [1527] = {.count = 1, .reusable = true}, SHIFT(799),
  [1529] = {.count = 1, .reusable = false}, SHIFT(800),
  [1531] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1533] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1535] = {.count = 1, .reusable = true}, SHIFT(801),
  [1537] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1540] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1543] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(802),
  [1546] = {.count = 1, .reusable = true}, SHIFT(803),
  [1548] = {.count = 1, .reusable = false}, SHIFT(806),
  [1550] = {.count = 1, .reusable = false}, SHIFT(812),
  [1552] = {.count = 1, .reusable = false}, SHIFT(810),
  [1554] = {.count = 1, .reusable = true}, SHIFT(811),
  [1556] = {.count = 1, .reusable = true}, SHIFT(816),
  [1558] = {.count = 1, .reusable = true}, SHIFT(819),
  [1560] = {.count = 1, .reusable = false}, SHIFT(820),
  [1562] = {.count = 1, .reusable = false}, SHIFT(821),
  [1564] = {.count = 1, .reusable = true}, SHIFT(823),
  [1566] = {.count = 1, .reusable = true}, SHIFT(822),
  [1568] = {.count = 1, .reusable = false}, SHIFT(823),
  [1570] = {.count = 1, .reusable = true}, SHIFT(825),
  [1572] = {.count = 1, .reusable = true}, SHIFT(824),
  [1574] = {.count = 1, .reusable = false}, SHIFT(825),
  [1576] = {.count = 1, .reusable = false}, SHIFT(826),
  [1578] = {.count = 1, .reusable = false}, SHIFT(827),
  [1580] = {.count = 1, .reusable = false}, SHIFT(829),
  [1582] = {.count = 1, .reusable = true}, SHIFT(830),
  [1584] = {.count = 1, .reusable = false}, SHIFT(831),
  [1586] = {.count = 1, .reusable = true}, SHIFT(832),
  [1588] = {.count = 1, .reusable = true}, SHIFT(831),
  [1590] = {.count = 1, .reusable = false}, SHIFT(833),
  [1592] = {.count = 1, .reusable = true}, SHIFT(834),
  [1594] = {.count = 1, .reusable = true}, SHIFT(835),
  [1596] = {.count = 1, .reusable = false}, SHIFT(836),
  [1598] = {.count = 1, .reusable = false}, SHIFT(837),
  [1600] = {.count = 1, .reusable = true}, SHIFT(838),
  [1602] = {.count = 1, .reusable = false}, SHIFT(839),
  [1604] = {.count = 1, .reusable = true}, SHIFT(839),
  [1606] = {.count = 1, .reusable = false}, SHIFT(840),
  [1608] = {.count = 1, .reusable = false}, SHIFT(841),
  [1610] = {.count = 1, .reusable = true}, SHIFT(842),
  [1612] = {.count = 1, .reusable = true}, SHIFT(843),
  [1614] = {.count = 1, .reusable = true}, SHIFT(845),
  [1616] = {.count = 1, .reusable = true}, SHIFT(847),
  [1618] = {.count = 1, .reusable = false}, SHIFT(848),
  [1620] = {.count = 1, .reusable = true}, SHIFT(848),
  [1622] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(852),
  [1625] = {.count = 1, .reusable = true}, SHIFT(853),
  [1627] = {.count = 1, .reusable = false}, SHIFT(855),
  [1629] = {.count = 1, .reusable = false}, SHIFT(858),
  [1631] = {.count = 1, .reusable = false}, SHIFT(856),
  [1633] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(857),
  [1636] = {.count = 1, .reusable = false}, SHIFT(870),
  [1638] = {.count = 1, .reusable = false}, SHIFT(866),
  [1640] = {.count = 1, .reusable = false}, SHIFT(859),
  [1642] = {.count = 1, .reusable = false}, SHIFT(860),
  [1644] = {.count = 1, .reusable = false}, SHIFT(861),
  [1646] = {.count = 1, .reusable = false}, SHIFT(862),
  [1648] = {.count = 1, .reusable = false}, SHIFT(863),
  [1650] = {.count = 1, .reusable = false}, SHIFT(864),
  [1652] = {.count = 1, .reusable = true}, SHIFT(865),
  [1654] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 3),
  [1656] = {.count = 1, .reusable = true}, SHIFT(871),
  [1658] = {.count = 1, .reusable = true}, SHIFT(872),
  [1660] = {.count = 1, .reusable = true}, SHIFT(873),
  [1662] = {.count = 1, .reusable = false}, SHIFT(875),
  [1664] = {.count = 1, .reusable = true}, SHIFT(876),
  [1666] = {.count = 1, .reusable = true}, SHIFT(877),
  [1668] = {.count = 1, .reusable = false}, SHIFT(878),
  [1670] = {.count = 1, .reusable = false}, SHIFT(879),
  [1672] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [1674] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 1),
  [1676] = {.count = 1, .reusable = false}, SHIFT(880),
  [1678] = {.count = 1, .reusable = true}, SHIFT(882),
  [1680] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [1682] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [1684] = {.count = 1, .reusable = true}, SHIFT(884),
  [1686] = {.count = 1, .reusable = true}, SHIFT(885),
  [1688] = {.count = 1, .reusable = true}, SHIFT(886),
  [1690] = {.count = 1, .reusable = true}, SHIFT(896),
  [1692] = {.count = 1, .reusable = true}, SHIFT(887),
  [1694] = {.count = 1, .reusable = true}, SHIFT(888),
  [1696] = {.count = 1, .reusable = true}, SHIFT(889),
  [1698] = {.count = 1, .reusable = true}, SHIFT(890),
  [1700] = {.count = 1, .reusable = false}, SHIFT(891),
  [1702] = {.count = 1, .reusable = true}, SHIFT(891),
  [1704] = {.count = 1, .reusable = false}, SHIFT(892),
  [1706] = {.count = 1, .reusable = true}, SHIFT(893),
  [1708] = {.count = 1, .reusable = false}, SHIFT(896),
  [1710] = {.count = 1, .reusable = true}, SHIFT(894),
  [1712] = {.count = 1, .reusable = false}, SHIFT(895),
  [1714] = {.count = 1, .reusable = true}, SHIFT(898),
  [1716] = {.count = 1, .reusable = true}, SHIFT(899),
  [1718] = {.count = 1, .reusable = true}, SHIFT(915),
  [1720] = {.count = 1, .reusable = true}, SHIFT(900),
  [1722] = {.count = 1, .reusable = true}, SHIFT(901),
  [1724] = {.count = 1, .reusable = false}, SHIFT(902),
  [1726] = {.count = 1, .reusable = false}, SHIFT(903),
  [1728] = {.count = 1, .reusable = false}, SHIFT(904),
  [1730] = {.count = 1, .reusable = false}, SHIFT(905),
  [1732] = {.count = 1, .reusable = false}, SHIFT(906),
  [1734] = {.count = 1, .reusable = false}, SHIFT(907),
  [1736] = {.count = 1, .reusable = false}, SHIFT(908),
  [1738] = {.count = 1, .reusable = false}, SHIFT(909),
  [1740] = {.count = 1, .reusable = false}, SHIFT(910),
  [1742] = {.count = 1, .reusable = false}, SHIFT(911),
  [1744] = {.count = 1, .reusable = false}, SHIFT(912),
  [1746] = {.count = 1, .reusable = false}, SHIFT(915),
  [1748] = {.count = 1, .reusable = false}, SHIFT(913),
  [1750] = {.count = 1, .reusable = true}, SHIFT(917),
  [1752] = {.count = 1, .reusable = true}, SHIFT(919),
  [1754] = {.count = 1, .reusable = true}, SHIFT(918),
  [1756] = {.count = 1, .reusable = false}, SHIFT(919),
  [1758] = {.count = 1, .reusable = true}, SHIFT(921),
  [1760] = {.count = 1, .reusable = true}, SHIFT(922),
  [1762] = {.count = 1, .reusable = true}, SHIFT(923),
  [1764] = {.count = 1, .reusable = true}, SHIFT(925),
  [1766] = {.count = 1, .reusable = true}, SHIFT(924),
  [1768] = {.count = 1, .reusable = false}, SHIFT(925),
  [1770] = {.count = 1, .reusable = true}, SHIFT(926),
  [1772] = {.count = 1, .reusable = false}, SHIFT(927),
  [1774] = {.count = 1, .reusable = true}, SHIFT(928),
  [1776] = {.count = 1, .reusable = false}, SHIFT(930),
  [1778] = {.count = 1, .reusable = false}, SHIFT(931),
  [1780] = {.count = 1, .reusable = true}, SHIFT(933),
  [1782] = {.count = 1, .reusable = true}, SHIFT(932),
  [1784] = {.count = 1, .reusable = false}, SHIFT(933),
  [1786] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 14),
  [1788] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 14),
  [1790] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 15),
  [1792] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 15),
  [1794] = {.count = 1, .reusable = true}, SHIFT(934),
  [1796] = {.count = 1, .reusable = true}, SHIFT(935),
  [1798] = {.count = 1, .reusable = true}, SHIFT(939),
  [1800] = {.count = 1, .reusable = true}, SHIFT(940),
  [1802] = {.count = 1, .reusable = false}, SHIFT(941),
  [1804] = {.count = 1, .reusable = false}, SHIFT(942),
  [1806] = {.count = 1, .reusable = true}, SHIFT(943),
  [1808] = {.count = 1, .reusable = true}, SHIFT(942),
  [1810] = {.count = 1, .reusable = false}, SHIFT(944),
  [1812] = {.count = 1, .reusable = true}, SHIFT(945),
  [1814] = {.count = 1, .reusable = true}, SHIFT(946),
  [1816] = {.count = 1, .reusable = false}, SHIFT(947),
  [1818] = {.count = 1, .reusable = false}, SHIFT(948),
  [1820] = {.count = 1, .reusable = true}, SHIFT(949),
  [1822] = {.count = 1, .reusable = false}, SHIFT(950),
  [1824] = {.count = 1, .reusable = true}, SHIFT(950),
  [1826] = {.count = 1, .reusable = false}, SHIFT(951),
  [1828] = {.count = 1, .reusable = false}, SHIFT(952),
  [1830] = {.count = 1, .reusable = true}, SHIFT(953),
  [1832] = {.count = 1, .reusable = true}, SHIFT(954),
  [1834] = {.count = 1, .reusable = true}, SHIFT(956),
  [1836] = {.count = 1, .reusable = false}, SHIFT(958),
  [1838] = {.count = 1, .reusable = true}, SHIFT(959),
  [1840] = {.count = 1, .reusable = true}, SHIFT(960),
  [1842] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 2),
  [1844] = {.count = 1, .reusable = true}, SHIFT(962),
  [1846] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [1848] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [1850] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(141),
  [1853] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(142),
  [1856] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1859] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1861] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [1863] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 21),
  [1865] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3),
  [1867] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3),
  [1869] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 3),
  [1871] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 3),
  [1873] = {.count = 1, .reusable = true}, SHIFT(965),
  [1875] = {.count = 1, .reusable = true}, SHIFT(966),
  [1877] = {.count = 1, .reusable = true}, SHIFT(967),
  [1879] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 2),
  [1881] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 6),
  [1883] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 6),
  [1885] = {.count = 1, .reusable = true}, SHIFT(969),
  [1887] = {.count = 1, .reusable = false}, SHIFT(976),
  [1889] = {.count = 1, .reusable = false}, SHIFT(975),
  [1891] = {.count = 1, .reusable = false}, SHIFT(970),
  [1893] = {.count = 1, .reusable = false}, SHIFT(971),
  [1895] = {.count = 1, .reusable = false}, SHIFT(972),
  [1897] = {.count = 1, .reusable = false}, SHIFT(973),
  [1899] = {.count = 1, .reusable = false}, SHIFT(974),
  [1901] = {.count = 1, .reusable = true}, SHIFT(977),
  [1903] = {.count = 1, .reusable = false}, SHIFT(978),
  [1905] = {.count = 1, .reusable = false}, SHIFT(979),
  [1907] = {.count = 1, .reusable = false}, SHIFT(981),
  [1909] = {.count = 1, .reusable = false}, SHIFT(984),
  [1911] = {.count = 1, .reusable = false}, SHIFT(987),
  [1913] = {.count = 1, .reusable = true}, SHIFT(990),
  [1915] = {.count = 1, .reusable = true}, SHIFT(991),
  [1917] = {.count = 1, .reusable = false}, SHIFT(992),
  [1919] = {.count = 1, .reusable = true}, SHIFT(993),
  [1921] = {.count = 1, .reusable = true}, SHIFT(994),
  [1923] = {.count = 1, .reusable = false}, SHIFT(995),
  [1925] = {.count = 1, .reusable = false}, SHIFT(996),
  [1927] = {.count = 1, .reusable = false}, SHIFT(997),
  [1929] = {.count = 1, .reusable = true}, SHIFT(999),
  [1931] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1937] = {.count = 1, .reusable = false}, SHIFT(1006),
  [1939] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1947] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 2, .alias_sequence_id = 8),
  [1949] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 2, .alias_sequence_id = 22),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1953] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1957] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1959] = {.count = 1, .reusable = true}, SHIFT(1030),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1963] = {.count = 1, .reusable = true}, SHIFT(1034),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1035),
  [1967] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 23),
  [1969] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 23),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1973] = {.count = 1, .reusable = true}, SHIFT(1038),
  [1975] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1979] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1981] = {.count = 1, .reusable = true}, SHIFT(1048),
  [1983] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(166),
  [1986] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(167),
  [1989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(168),
  [1992] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [1994] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(170),
  [1997] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(171),
  [2000] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(174),
  [2003] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(175),
  [2006] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(176),
  [2009] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(177),
  [2012] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(178),
  [2015] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(179),
  [2018] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 24),
  [2020] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 24),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2024] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 25),
  [2026] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 25),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2030] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 4),
  [2032] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 4),
  [2034] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2036] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2038] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2042] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2046] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2050] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 2),
  [2052] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 4),
  [2054] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 4),
  [2056] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2058] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2060] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2062] = {.count = 1, .reusable = true}, REDUCE(sym_function_type_declarator, 2),
  [2064] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2068] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2074] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 3),
  [2076] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 3),
  [2078] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2080] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2082] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2086] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2092] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2094] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2096] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2098] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2100] = {.count = 1, .reusable = true}, REDUCE(sym_access_specifier, 2),
  [2102] = {.count = 1, .reusable = false}, REDUCE(sym_access_specifier, 2),
  [2104] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 2),
  [2106] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 2),
  [2108] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1109),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2126] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [2128] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2132] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2134] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2138] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 26),
  [2140] = {.count = 1, .reusable = false}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 26),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2144] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2146] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2154] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 11),
  [2156] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 12),
  [2158] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 13),
  [2160] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 27),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2170] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [2172] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [2174] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2176] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2178] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [2180] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [2182] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(4),
  [2185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(241),
  [2188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(242),
  [2191] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(243),
  [2194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(244),
  [2197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(12),
  [2200] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2202] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(11),
  [2205] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13),
  [2208] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(268),
  [2211] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(261),
  [2214] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [2217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(246),
  [2220] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(247),
  [2223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(17),
  [2226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(17),
  [2229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(18),
  [2232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(248),
  [2235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(249),
  [2238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(250),
  [2241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(251),
  [2244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(252),
  [2247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(253),
  [2250] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(254),
  [2253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(255),
  [2256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(259),
  [2259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(596),
  [2262] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 3),
  [2264] = {.count = 1, .reusable = false}, SHIFT(1138),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2268] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 4),
  [2270] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 4),
  [2272] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 4),
  [2274] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 4),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2280] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2286] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2288] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2294] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2296] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2300] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2302] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2304] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2306] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2308] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2310] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2316] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2318] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2320] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2322] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2324] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2326] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2330] = {.count = 1, .reusable = true}, SHIFT(280),
  [2332] = {.count = 1, .reusable = true}, SHIFT(285),
  [2334] = {.count = 1, .reusable = true}, SHIFT(301),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2340] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2342] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 1),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2348] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2350] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 1),
  [2352] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 2),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2356] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 1),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2360] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2362] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 3),
  [2364] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 3),
  [2366] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2368] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(637),
  [2371] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 4),
  [2373] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 4),
  [2375] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_declaration, 2, .alias_sequence_id = 4),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2387] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2395] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 2),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2401] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2403] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 3),
  [2405] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 3),
  [2407] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2409] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(659),
  [2412] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 4),
  [2414] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 4),
  [2416] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2418] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2420] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2424] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(667),
  [2427] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [2429] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2433] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2439] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2441] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2443] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 4),
  [2445] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 4),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2449] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 3),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2453] = {.count = 2, .reusable = true}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1), REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2458] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2466] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 2),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2478] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2484] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2496] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2500] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2502] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2508] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2514] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2516] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2520] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2522] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2524] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2526] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2534] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 3),
  [2536] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2538] = {.count = 1, .reusable = false}, SHIFT(1264),
  [2540] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2542] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2546] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2550] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 4),
  [2552] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 4),
  [2554] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(348),
  [2557] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2559] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2561] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 2),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2579] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2605] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2611] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2615] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2627] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2635] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2653] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 4, .alias_sequence_id = 28),
  [2655] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 4, .alias_sequence_id = 28),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2659] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 4),
  [2661] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 4),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2665] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3, .dynamic_precedence = 1),
  [2667] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 3, .dynamic_precedence = 1),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2681] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(753),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2688] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2690] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2692] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_expression, 2),
  [2694] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_expression, 2),
  [2696] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 2),
  [2698] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 2),
  [2700] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_default_capture, 1),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2706] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2710] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2716] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2720] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2728] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2730] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2736] = {.count = 1, .reusable = false}, SHIFT(1341),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2746] = {.count = 1, .reusable = false}, SHIFT(1345),
  [2748] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2752] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2760] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2762] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2766] = {.count = 1, .reusable = false}, SHIFT(1365),
  [2768] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 2),
  [2770] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 2),
  [2772] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 2),
  [2774] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 2),
  [2776] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 2),
  [2778] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 2),
  [2780] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 2),
  [2782] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 2),
  [2784] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [2786] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2790] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2792] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [2798] = {.count = 2, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [2801] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2815] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2822] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2824] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 2),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 2),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 4),
  [2832] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2834] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2836] = {.count = 1, .reusable = false}, SHIFT(1391),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2840] = {.count = 1, .reusable = false}, SHIFT(1392),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2844] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2848] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2850] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2852] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2854] = {.count = 1, .reusable = true}, SHIFT(1396),
  [2856] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2858] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2860] = {.count = 1, .reusable = false}, SHIFT(1397),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2864] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2866] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2868] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2870] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2872] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2876] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2878] = {.count = 1, .reusable = true}, SHIFT(1402),
  [2880] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2884] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2888] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [2890] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [2892] = {.count = 1, .reusable = false}, SHIFT(1407),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2),
  [2896] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 1),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2904] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2906] = {.count = 1, .reusable = true}, SHIFT(1416),
  [2908] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(858),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2917] = {.count = 1, .reusable = false}, SHIFT(1423),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1424),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1437),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1441),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2933] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 2),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2937] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 2),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1444),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2945] = {.count = 1, .reusable = false}, SHIFT(1451),
  [2947] = {.count = 1, .reusable = false}, SHIFT(1449),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1450),
  [2951] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [2953] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(397),
  [2956] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(397),
  [2959] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(398),
  [2962] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(871),
  [2965] = {.count = 1, .reusable = false}, SHIFT(1452),
  [2967] = {.count = 1, .reusable = false}, SHIFT(1453),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1485),
  [2973] = {.count = 1, .reusable = false}, SHIFT(1456),
  [2975] = {.count = 1, .reusable = false}, SHIFT(1457),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1458),
  [2979] = {.count = 1, .reusable = false}, SHIFT(1459),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1460),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1461),
  [2985] = {.count = 1, .reusable = false}, SHIFT(1462),
  [2987] = {.count = 1, .reusable = false}, SHIFT(1463),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1464),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2993] = {.count = 1, .reusable = false}, SHIFT(1466),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1467),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1468),
  [2999] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1470),
  [3003] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3005] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3007] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3009] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3011] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3013] = {.count = 1, .reusable = false}, SHIFT(1476),
  [3015] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3017] = {.count = 1, .reusable = false}, SHIFT(1478),
  [3019] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3021] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3023] = {.count = 1, .reusable = false}, SHIFT(1488),
  [3025] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3027] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1498),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3035] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3043] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3045] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3047] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3051] = {.count = 1, .reusable = false}, SHIFT(1509),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3055] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3065] = {.count = 1, .reusable = false}, SHIFT(1513),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3069] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3073] = {.count = 1, .reusable = false}, SHIFT(1515),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3077] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1518),
  [3085] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3087] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3093] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3095] = {.count = 1, .reusable = false}, SHIFT(1523),
  [3097] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1534),
  [3123] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3127] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1126),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3132] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3134] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3136] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3138] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3142] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3144] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3146] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3148] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3150] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3152] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3154] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3156] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3158] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3160] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3162] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3168] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3178] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3180] = {.count = 1, .reusable = false}, SHIFT(1564),
  [3182] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3184] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [3186] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [3188] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3190] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [3192] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [3194] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [3196] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [3198] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3200] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3202] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3204] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3210] = {.count = 1, .reusable = false}, SHIFT(1577),
  [3212] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3214] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3216] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3218] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3220] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3222] = {.count = 1, .reusable = false}, SHIFT(1585),
  [3224] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [3226] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [3228] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3230] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3234] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3238] = {.count = 1, .reusable = false}, SHIFT(1589),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3242] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3246] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3250] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3254] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3258] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3262] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3266] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3270] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3272] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3274] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3276] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3278] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(434),
  [3281] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(400),
  [3284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(401),
  [3287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(402),
  [3290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(403),
  [3293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(404),
  [3296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(405),
  [3299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(406),
  [3302] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(407),
  [3305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(408),
  [3308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(100),
  [3311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(409),
  [3314] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [3316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(411),
  [3319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(371),
  [3322] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(102),
  [3325] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(38),
  [3328] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(30),
  [3331] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(14),
  [3334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(15),
  [3337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(16),
  [3340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(412),
  [3343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(413),
  [3346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(414),
  [3349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(415),
  [3352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(416),
  [3355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(417),
  [3358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(418),
  [3361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(419),
  [3364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(420),
  [3367] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(421),
  [3370] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(422),
  [3373] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(423),
  [3376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(424),
  [3379] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(425),
  [3382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(425),
  [3385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(426),
  [3388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(427),
  [3391] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(434),
  [3394] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(428),
  [3397] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(20),
  [3400] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(21),
  [3403] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(384),
  [3406] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(429),
  [3409] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(430),
  [3412] = {.count = 1, .reusable = false}, SHIFT(1599),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3416] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2, .alias_sequence_id = 26),
  [3418] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 29),
  [3420] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2),
  [3422] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 3),
  [3424] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3428] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2),
  [3430] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [3432] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [3434] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 6),
  [3436] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 6),
  [3438] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3440] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 3),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3444] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 6),
  [3446] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 6),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3454] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3456] = {.count = 1, .reusable = false}, SHIFT(1616),
  [3458] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(458),
  [3461] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(977),
  [3464] = {.count = 1, .reusable = false}, SHIFT(1617),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3468] = {.count = 1, .reusable = false}, SHIFT(1619),
  [3470] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3472] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1622),
  [3478] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3480] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3482] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3484] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3486] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3488] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3490] = {.count = 1, .reusable = false}, SHIFT(1635),
  [3492] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3494] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3496] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3498] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3504] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3512] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3518] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(466),
  [3521] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(467),
  [3524] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(468),
  [3527] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(469),
  [3530] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(470),
  [3533] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(471),
  [3536] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(472),
  [3539] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(473),
  [3542] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(474),
  [3545] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(475),
  [3548] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(476),
  [3551] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 22),
  [3553] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 22),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3571] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3577] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3583] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 30),
  [3585] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 30),
  [3587] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 31),
  [3589] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 31),
  [3591] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 32),
  [3593] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 32),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3603] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 3),
  [3605] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 3),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3609] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3611] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3613] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 5),
  [3615] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 5),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3623] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3625] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(546),
  [3628] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1076),
  [3631] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 3),
  [3633] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 4),
  [3635] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 4),
  [3637] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1700),
  [3644] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [3646] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [3648] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, .alias_sequence_id = 8),
  [3650] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3652] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3654] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3658] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 9),
  [3660] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 9),
  [3662] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3664] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3666] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3668] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 10),
  [3670] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 10),
  [3672] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3674] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3678] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3682] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3686] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 3),
  [3688] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 3),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3696] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3698] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 2),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3702] = {.count = 1, .reusable = true}, REDUCE(sym_reference_field_declarator, 2),
  [3704] = {.count = 1, .reusable = false}, SHIFT(1733),
  [3706] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2, .alias_sequence_id = 26),
  [3708] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2, .alias_sequence_id = 26),
  [3710] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 29), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 4),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3721] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [3723] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3729] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3733] = {.count = 1, .reusable = false}, SHIFT(1740),
  [3735] = {.count = 1, .reusable = true}, REDUCE(sym_inline_method_definition, 3),
  [3737] = {.count = 1, .reusable = false}, REDUCE(sym_inline_method_definition, 3),
  [3739] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 2),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3747] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3751] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2),
  [3753] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2),
  [3755] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3759] = {.count = 1, .reusable = false}, SHIFT(1748),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3765] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 4),
  [3767] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2),
  [3769] = {.count = 2, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2), SHIFT_REPEAT(598),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3774] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 5),
  [3776] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 5),
  [3778] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 5),
  [3780] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 5),
  [3782] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3784] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3786] = {.count = 1, .reusable = false}, SHIFT(1759),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3792] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3794] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3796] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3798] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3800] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3802] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3804] = {.count = 1, .reusable = false}, SHIFT(1764),
  [3806] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3808] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3810] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3812] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3814] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3816] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3818] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3820] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3824] = {.count = 1, .reusable = false}, SHIFT(1769),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3828] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3830] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3832] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3836] = {.count = 1, .reusable = false}, SHIFT(1772),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3840] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3844] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3846] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3848] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3850] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3852] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3854] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 2),
  [3856] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 2),
  [3858] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 2),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3864] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3866] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 2),
  [3868] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 2),
  [3870] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3872] = {.count = 1, .reusable = false}, SHIFT(1787),
  [3874] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 2),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3878] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2),
  [3880] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 4),
  [3882] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 4),
  [3884] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2), SHIFT_REPEAT(633),
  [3887] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 3),
  [3889] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 5),
  [3891] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 5),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3895] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3897] = {.count = 1, .reusable = false}, SHIFT(1789),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1793),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3911] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3913] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3917] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3921] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3923] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1808),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3935] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3941] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3943] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2),
  [3945] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 4),
  [3947] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 4),
  [3949] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2), SHIFT_REPEAT(655),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3954] = {.count = 1, .reusable = false}, SHIFT(1813),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3958] = {.count = 1, .reusable = false}, SHIFT(1816),
  [3960] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(662),
  [3963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1210),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3970] = {.count = 1, .reusable = true}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 4),
  [3972] = {.count = 1, .reusable = false}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 4),
  [3974] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1219),
  [3977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2),
  [3979] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 4),
  [3981] = {.count = 2, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2), SHIFT_REPEAT(680),
  [3984] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3990] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3992] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4000] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 3),
  [4002] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 3),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4006] = {.count = 1, .reusable = true}, REDUCE(sym_field_designator, 2, .alias_sequence_id = 29),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1837),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1839),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1840),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1841),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4038] = {.count = 1, .reusable = false}, SHIFT(1842),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1843),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4046] = {.count = 1, .reusable = false}, SHIFT(1844),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4054] = {.count = 1, .reusable = false}, SHIFT(1846),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4058] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4060] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4062] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1849),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4070] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4072] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4076] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4080] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1257),
  [4085] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [4087] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(702),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4096] = {.count = 1, .reusable = false}, SHIFT(1863),
  [4098] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(712),
  [4101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1266),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4112] = {.count = 1, .reusable = false}, SHIFT(1868),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4118] = {.count = 1, .reusable = false}, SHIFT(1870),
  [4120] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4122] = {.count = 1, .reusable = false}, SHIFT(1871),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4126] = {.count = 1, .reusable = false}, SHIFT(1872),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4130] = {.count = 1, .reusable = false}, SHIFT(1873),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4134] = {.count = 1, .reusable = false}, SHIFT(1874),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4138] = {.count = 1, .reusable = false}, SHIFT(1875),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4142] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4146] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4148] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4150] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4152] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4154] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4158] = {.count = 1, .reusable = false}, SHIFT(1880),
  [4160] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4172] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 5, .alias_sequence_id = 28),
  [4174] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 5, .alias_sequence_id = 28),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4178] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4186] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4188] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4190] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1891),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4198] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1893),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4210] = {.count = 1, .reusable = false}, SHIFT(1895),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4214] = {.count = 1, .reusable = false}, SHIFT(1896),
  [4216] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4218] = {.count = 1, .reusable = false}, SHIFT(1897),
  [4220] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 5),
  [4222] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 5),
  [4224] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [4226] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 4, .dynamic_precedence = 1),
  [4228] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 4, .dynamic_precedence = 1),
  [4230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(743),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4235] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4243] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4245] = {.count = 1, .reusable = false}, SHIFT(1903),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4251] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [4253] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4255] = {.count = 1, .reusable = false}, SHIFT(1906),
  [4257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1325),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4264] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4266] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4268] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4270] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4274] = {.count = 1, .reusable = false}, SHIFT(1915),
  [4276] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 3),
  [4278] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 3),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4282] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4286] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4290] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4294] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4298] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4304] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4306] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4308] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4310] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4314] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4318] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4322] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4326] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4330] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4332] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4334] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4340] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [4342] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [4344] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1367),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4349] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 17), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [4352] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4354] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4356] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4358] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4360] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 4),
  [4362] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 4),
  [4364] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [4366] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [4368] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_name, 2),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4372] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 3),
  [4374] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 3),
  [4376] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4378] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4380] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 5),
  [4382] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(826),
  [4385] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(827),
  [4388] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 3),
  [4390] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 3),
  [4392] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4394] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4398] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 3),
  [4400] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 3),
  [4402] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 3),
  [4404] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 3),
  [4406] = {.count = 1, .reusable = true}, REDUCE(sym_equality_expression, 3),
  [4408] = {.count = 1, .reusable = false}, REDUCE(sym_equality_expression, 3),
  [4410] = {.count = 1, .reusable = true}, REDUCE(sym_relational_expression, 3),
  [4412] = {.count = 1, .reusable = false}, REDUCE(sym_relational_expression, 3),
  [4414] = {.count = 1, .reusable = true}, REDUCE(sym_shift_expression, 3),
  [4416] = {.count = 1, .reusable = false}, REDUCE(sym_shift_expression, 3),
  [4418] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33),
  [4420] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33),
  [4422] = {.count = 2, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 33), SHIFT(852),
  [4425] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3),
  [4427] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3),
  [4429] = {.count = 1, .reusable = true}, SHIFT(852),
  [4431] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [4434] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4436] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4438] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4440] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_expression, 3),
  [4442] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_expression, 3),
  [4444] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4446] = {.count = 1, .reusable = false}, SHIFT(1967),
  [4448] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4450] = {.count = 1, .reusable = false}, SHIFT(1963),
  [4452] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4454] = {.count = 1, .reusable = false}, SHIFT(1965),
  [4456] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4458] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4460] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4464] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4466] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4474] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4476] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4480] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 1),
  [4482] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 1),
  [4484] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 3),
  [4486] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 3),
  [4488] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 1),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4492] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1451),
  [4495] = {.count = 1, .reusable = false}, SHIFT(1997),
  [4497] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4499] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4501] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4503] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4505] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4507] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 7),
  [4509] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 7),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4513] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4515] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4517] = {.count = 1, .reusable = false}, SHIFT(2005),
  [4519] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4521] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4523] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 1, .alias_sequence_id = 8),
  [4525] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4527] = {.count = 1, .reusable = false}, SHIFT(2009),
  [4529] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4531] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4533] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4535] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4537] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4539] = {.count = 1, .reusable = false}, SHIFT(2015),
  [4541] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4543] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4545] = {.count = 1, .reusable = false}, SHIFT(2018),
  [4547] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4549] = {.count = 1, .reusable = false}, SHIFT(2020),
  [4551] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4553] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4555] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4557] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4559] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4561] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4563] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4565] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4567] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4569] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4571] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4575] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4577] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4579] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4581] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4583] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4585] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4587] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4589] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4591] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4593] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4597] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4599] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4601] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4603] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4605] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4607] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4609] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4611] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4613] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4615] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 9),
  [4617] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 9),
  [4619] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4621] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4623] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4625] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 10),
  [4627] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 10),
  [4629] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4633] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4635] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4637] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4643] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4647] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4657] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4659] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2090),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4671] = {.count = 1, .reusable = false}, SHIFT(2093),
  [4673] = {.count = 1, .reusable = false}, SHIFT(2094),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4677] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4681] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4683] = {.count = 1, .reusable = false}, SHIFT(2098),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4687] = {.count = 1, .reusable = false}, SHIFT(2099),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4699] = {.count = 1, .reusable = false}, SHIFT(2105),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2107),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4709] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4713] = {.count = 1, .reusable = false}, SHIFT(2110),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2111),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2112),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4725] = {.count = 1, .reusable = false}, SHIFT(2113),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4729] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4733] = {.count = 1, .reusable = false}, SHIFT(2115),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2116),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4741] = {.count = 1, .reusable = false}, SHIFT(2117),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4745] = {.count = 1, .reusable = false}, SHIFT(2118),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4753] = {.count = 1, .reusable = false}, SHIFT(2122),
  [4755] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3),
  [4757] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4767] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4773] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4777] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4779] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4791] = {.count = 1, .reusable = false}, SHIFT(2137),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4803] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4815] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4817] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [4819] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [4821] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 34),
  [4823] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 34),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1572),
  [4830] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 35),
  [4832] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 35),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2154),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4844] = {.count = 1, .reusable = false}, SHIFT(2156),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4850] = {.count = 1, .reusable = false}, SHIFT(2159),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4854] = {.count = 1, .reusable = true}, REDUCE(sym_comma_expression, 3),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4858] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 36),
  [4860] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 17),
  [4862] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [4864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(960),
  [4867] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 33),
  [4869] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3),
  [4871] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [4873] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 4),
  [4875] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(966),
  [4878] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1616),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4883] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4891] = {.count = 1, .reusable = false}, SHIFT(2172),
  [4893] = {.count = 1, .reusable = false}, SHIFT(2173),
  [4895] = {.count = 1, .reusable = false}, SHIFT(2174),
  [4897] = {.count = 1, .reusable = true}, SHIFT(2175),
  [4899] = {.count = 1, .reusable = false}, SHIFT(2175),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4903] = {.count = 1, .reusable = false}, SHIFT(2177),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4907] = {.count = 1, .reusable = false}, SHIFT(2179),
  [4909] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2189),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2190),
  [4925] = {.count = 1, .reusable = false}, SHIFT(2190),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2193),
  [4931] = {.count = 1, .reusable = false}, SHIFT(2193),
  [4933] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4937] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 4, .alias_sequence_id = 22),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4949] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4951] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 4),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2204),
  [4955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1698),
  [4958] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 5),
  [4960] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 5),
  [4962] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, .alias_sequence_id = 8),
  [4964] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 2, .alias_sequence_id = 22),
  [4966] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 37),
  [4968] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 37),
  [4970] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 38),
  [4972] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 38),
  [4974] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [4976] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [4978] = {.count = 1, .reusable = true}, SHIFT(2213),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2214),
  [4982] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 39),
  [4984] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 39),
  [4986] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 40),
  [4988] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 40),
  [4990] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [4992] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2215),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4998] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 41),
  [5000] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 41),
  [5002] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 42),
  [5004] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 42),
  [5006] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [5008] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5022] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 3),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5026] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [5028] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [5030] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 36), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 18),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5037] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2),
  [5039] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 3),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2228),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5049] = {.count = 1, .reusable = false}, SHIFT(2232),
  [5051] = {.count = 1, .reusable = false}, SHIFT(2231),
  [5053] = {.count = 1, .reusable = false}, SHIFT(2230),
  [5055] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 3),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5061] = {.count = 1, .reusable = false}, SHIFT(2234),
  [5063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2), SHIFT_REPEAT(1118),
  [5066] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 33), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 20),
  [5069] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5071] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5073] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5075] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5077] = {.count = 1, .reusable = false}, SHIFT(2241),
  [5079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1128),
  [5082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1751),
  [5085] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 3),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1758),
  [5092] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5094] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5096] = {.count = 1, .reusable = false}, SHIFT(2244),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 3),
  [5102] = {.count = 1, .reusable = false}, REDUCE(sym__abstract_declarator, 3),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5106] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5110] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 3),
  [5112] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 3),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5118] = {.count = 1, .reusable = false}, SHIFT(2250),
  [5120] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 3),
  [5122] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 3),
  [5124] = {.count = 1, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2),
  [5126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(397),
  [5129] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(397),
  [5132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1788),
  [5135] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type_parameter_declaration, 4, .alias_sequence_id = 4),
  [5137] = {.count = 1, .reusable = false}, SHIFT(2253),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5143] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5145] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2261),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5153] = {.count = 1, .reusable = false}, SHIFT(2263),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5157] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5159] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5161] = {.count = 1, .reusable = false}, SHIFT(2266),
  [5163] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5165] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5169] = {.count = 1, .reusable = false}, SHIFT(2269),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2272),
  [5177] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5181] = {.count = 1, .reusable = false}, SHIFT(2275),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5185] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5187] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5189] = {.count = 1, .reusable = false}, SHIFT(2280),
  [5191] = {.count = 1, .reusable = false}, SHIFT(2279),
  [5193] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1816),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5202] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5206] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [5208] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [5210] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [5212] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1226),
  [5215] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_designator, 3),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1832),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5226] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5228] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 4),
  [5230] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 4),
  [5232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT(939),
  [5235] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [5237] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5239] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(2294),
  [5244] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5246] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_pair, 3),
  [5248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1863),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1866),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5260] = {.count = 1, .reusable = false}, SHIFT(2302),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1883),
  [5269] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5273] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5277] = {.count = 1, .reusable = false}, SHIFT(2310),
  [5279] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5281] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5287] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5291] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1905),
  [5296] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4),
  [5298] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4),
  [5300] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 4),
  [5302] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 4),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1911),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5313] = {.count = 1, .reusable = false}, SHIFT(2318),
  [5315] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5319] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 4),
  [5321] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 4),
  [5323] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1333),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5328] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5332] = {.count = 1, .reusable = false}, SHIFT(370),
  [5334] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 4),
  [5336] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 4),
  [5338] = {.count = 1, .reusable = false}, SHIFT(376),
  [5340] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5342] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5344] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 4),
  [5346] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 4),
  [5348] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 20),
  [5350] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4, .alias_sequence_id = 20),
  [5352] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4),
  [5354] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4),
  [5356] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5358] = {.count = 1, .reusable = false}, SHIFT(2331),
  [5360] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 4),
  [5362] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 4),
  [5364] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [5366] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [5368] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5370] = {.count = 1, .reusable = false}, SHIFT(2332),
  [5372] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5374] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5376] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5378] = {.count = 1, .reusable = false}, SHIFT(2334),
  [5380] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5386] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5390] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1969),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5407] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 2),
  [5409] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 2),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5417] = {.count = 1, .reusable = false}, SHIFT(2364),
  [5419] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5421] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5423] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5425] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5431] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5433] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5437] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5439] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5441] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5447] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5449] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5453] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5457] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5465] = {.count = 1, .reusable = false}, SHIFT(2399),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5473] = {.count = 1, .reusable = false}, SHIFT(2404),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5477] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5481] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 2, .alias_sequence_id = 8),
  [5483] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 2, .alias_sequence_id = 22),
  [5485] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5487] = {.count = 1, .reusable = false}, SHIFT(2417),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5493] = {.count = 1, .reusable = false}, SHIFT(2419),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5499] = {.count = 1, .reusable = false}, SHIFT(2421),
  [5501] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5503] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5507] = {.count = 1, .reusable = false}, SHIFT(2426),
  [5509] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5511] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5513] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5515] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5521] = {.count = 1, .reusable = false}, SHIFT(2433),
  [5523] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 37),
  [5525] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 37),
  [5527] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 38),
  [5529] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 38),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5537] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [5539] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5545] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1485),
  [5548] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1456),
  [5551] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1457),
  [5554] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1458),
  [5557] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [5559] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1460),
  [5562] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1461),
  [5565] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1464),
  [5568] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1465),
  [5571] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1466),
  [5574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1467),
  [5577] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1468),
  [5580] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1469),
  [5583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1470),
  [5586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1471),
  [5589] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1472),
  [5592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1473),
  [5595] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1474),
  [5598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1475),
  [5601] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1476),
  [5604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1477),
  [5607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1478),
  [5610] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1485),
  [5613] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1479),
  [5616] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 39),
  [5618] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 39),
  [5620] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 40),
  [5622] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 40),
  [5624] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [5626] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5632] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 41),
  [5634] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 41),
  [5636] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 42),
  [5638] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 42),
  [5640] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [5642] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5658] = {.count = 1, .reusable = false}, SHIFT(2452),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5668] = {.count = 1, .reusable = false}, SHIFT(2456),
  [5670] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5674] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5676] = {.count = 1, .reusable = false}, SHIFT(2460),
  [5678] = {.count = 1, .reusable = false}, SHIFT(2461),
  [5680] = {.count = 1, .reusable = false}, SHIFT(2462),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2463),
  [5684] = {.count = 1, .reusable = false}, SHIFT(2464),
  [5686] = {.count = 1, .reusable = false}, SHIFT(2465),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2466),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5692] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5696] = {.count = 1, .reusable = false}, SHIFT(2471),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5700] = {.count = 1, .reusable = false}, SHIFT(2472),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5704] = {.count = 1, .reusable = false}, SHIFT(2473),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5708] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5712] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5716] = {.count = 1, .reusable = false}, SHIFT(2476),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5720] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5724] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5728] = {.count = 1, .reusable = false}, SHIFT(2479),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5736] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2484),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2103),
  [5749] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5751] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5753] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5755] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4),
  [5757] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4),
  [5759] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5761] = {.count = 1, .reusable = false}, SHIFT(2489),
  [5763] = {.count = 1, .reusable = false}, SHIFT(2490),
  [5765] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5767] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5769] = {.count = 1, .reusable = false}, SHIFT(2493),
  [5771] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5773] = {.count = 1, .reusable = false}, SHIFT(2496),
  [5775] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5777] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5779] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5781] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5783] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5785] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5789] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5791] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5793] = {.count = 1, .reusable = false}, SHIFT(2506),
  [5795] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5797] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5799] = {.count = 1, .reusable = false}, SHIFT(2508),
  [5801] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5803] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5807] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5809] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_declaration, 2),
  [5811] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5813] = {.count = 1, .reusable = false}, SHIFT(2515),
  [5815] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5817] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5819] = {.count = 1, .reusable = false}, SHIFT(411),
  [5821] = {.count = 1, .reusable = false}, SHIFT(423),
  [5823] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5825] = {.count = 1, .reusable = false}, SHIFT(2517),
  [5827] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5829] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5831] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5833] = {.count = 1, .reusable = false}, SHIFT(2520),
  [5835] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5837] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5839] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5841] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5843] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5845] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5847] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5849] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5853] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 5),
  [5855] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 43),
  [5857] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 44),
  [5859] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 22),
  [5861] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 45),
  [5863] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 45),
  [5865] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 46),
  [5867] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 46),
  [5869] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 47),
  [5871] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 47),
  [5873] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 48),
  [5875] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 48),
  [5877] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 49),
  [5879] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 49),
  [5881] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 50),
  [5883] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 50),
  [5885] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5889] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 4),
  [5891] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5893] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 5),
  [5895] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 5),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5899] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5903] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1741),
  [5908] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2233),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5915] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2241),
  [5918] = {.count = 1, .reusable = false}, SHIFT(609),
  [5920] = {.count = 1, .reusable = false}, SHIFT(610),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5924] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5926] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5928] = {.count = 1, .reusable = false}, SHIFT(2549),
  [5930] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2248),
  [5933] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 4),
  [5935] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 4),
  [5937] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5939] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 4),
  [5941] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 4),
  [5943] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2253),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5960] = {.count = 1, .reusable = false}, SHIFT(2559),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5966] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5968] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5970] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5974] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5978] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5980] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5982] = {.count = 1, .reusable = false}, SHIFT(2565),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5998] = {.count = 1, .reusable = false}, SHIFT(2569),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2570),
  [6002] = {.count = 1, .reusable = false}, SHIFT(2570),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2571),
  [6006] = {.count = 1, .reusable = false}, SHIFT(2571),
  [6008] = {.count = 1, .reusable = true}, SHIFT(2572),
  [6010] = {.count = 1, .reusable = false}, SHIFT(2573),
  [6012] = {.count = 1, .reusable = true}, SHIFT(2573),
  [6014] = {.count = 1, .reusable = false}, SHIFT(2576),
  [6016] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1809),
  [6019] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2281),
  [6022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2288),
  [6025] = {.count = 1, .reusable = false}, SHIFT(696),
  [6027] = {.count = 1, .reusable = false}, SHIFT(698),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2579),
  [6031] = {.count = 1, .reusable = false}, SHIFT(2579),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2580),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2580),
  [6037] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 5),
  [6039] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 5),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2582),
  [6043] = {.count = 1, .reusable = false}, SHIFT(719),
  [6045] = {.count = 1, .reusable = false}, SHIFT(720),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2583),
  [6049] = {.count = 1, .reusable = false}, SHIFT(2583),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2584),
  [6053] = {.count = 1, .reusable = false}, SHIFT(2584),
  [6055] = {.count = 1, .reusable = false}, SHIFT(729),
  [6057] = {.count = 1, .reusable = false}, SHIFT(730),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2585),
  [6061] = {.count = 1, .reusable = false}, SHIFT(2585),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2586),
  [6065] = {.count = 1, .reusable = false}, SHIFT(2586),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2587),
  [6069] = {.count = 1, .reusable = false}, SHIFT(2588),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2588),
  [6073] = {.count = 1, .reusable = false}, SHIFT(2591),
  [6075] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1899),
  [6078] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2311),
  [6081] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2315),
  [6084] = {.count = 1, .reusable = false}, SHIFT(766),
  [6086] = {.count = 1, .reusable = false}, SHIFT(770),
  [6088] = {.count = 1, .reusable = true}, SHIFT(2592),
  [6090] = {.count = 1, .reusable = false}, SHIFT(2592),
  [6092] = {.count = 1, .reusable = true}, SHIFT(2593),
  [6094] = {.count = 1, .reusable = false}, SHIFT(2593),
  [6096] = {.count = 1, .reusable = true}, SHIFT(2594),
  [6098] = {.count = 1, .reusable = true}, SHIFT(2595),
  [6100] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 3),
  [6102] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 5, .alias_sequence_id = 20),
  [6104] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 5, .alias_sequence_id = 20),
  [6106] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 5),
  [6108] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 5),
  [6110] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 5),
  [6112] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 5),
  [6114] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [6116] = {.count = 1, .reusable = false}, SHIFT(2597),
  [6118] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2337),
  [6121] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2345),
  [6124] = {.count = 1, .reusable = true}, SHIFT(2600),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6128] = {.count = 1, .reusable = true}, SHIFT(2604),
  [6130] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2361),
  [6133] = {.count = 1, .reusable = false}, SHIFT(2606),
  [6135] = {.count = 1, .reusable = false}, SHIFT(2607),
  [6137] = {.count = 1, .reusable = false}, SHIFT(2608),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2610),
  [6143] = {.count = 1, .reusable = false}, SHIFT(2611),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6149] = {.count = 1, .reusable = false}, SHIFT(2616),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6153] = {.count = 1, .reusable = true}, SHIFT(2620),
  [6155] = {.count = 1, .reusable = false}, SHIFT(2621),
  [6157] = {.count = 1, .reusable = false}, SHIFT(2624),
  [6159] = {.count = 1, .reusable = false}, SHIFT(2625),
  [6161] = {.count = 1, .reusable = false}, SHIFT(2627),
  [6163] = {.count = 1, .reusable = false}, SHIFT(2631),
  [6165] = {.count = 1, .reusable = false}, SHIFT(2635),
  [6167] = {.count = 1, .reusable = false}, SHIFT(2639),
  [6169] = {.count = 1, .reusable = false}, SHIFT(2641),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6175] = {.count = 1, .reusable = false}, SHIFT(2643),
  [6177] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6179] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6181] = {.count = 1, .reusable = false}, SHIFT(2645),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6185] = {.count = 1, .reusable = false}, SHIFT(2647),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2650),
  [6189] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6197] = {.count = 1, .reusable = false}, SHIFT(2653),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6203] = {.count = 1, .reusable = false}, SHIFT(2657),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6211] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2029),
  [6214] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2005),
  [6217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2006),
  [6220] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2007),
  [6223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2008),
  [6226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2009),
  [6229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2010),
  [6232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2011),
  [6235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2012),
  [6238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2013),
  [6241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2014),
  [6244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2015),
  [6247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2016),
  [6250] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2017),
  [6253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2018),
  [6256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2019),
  [6259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2020),
  [6262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2021),
  [6265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2022),
  [6268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2023),
  [6271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2024),
  [6274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2029),
  [6277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(2025),
  [6280] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 43),
  [6282] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 44),
  [6284] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 22),
  [6286] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6288] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6290] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6292] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6294] = {.count = 1, .reusable = false}, SHIFT(2671),
  [6296] = {.count = 1, .reusable = true}, SHIFT(2672),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2674),
  [6300] = {.count = 1, .reusable = true}, SHIFT(2675),
  [6302] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6304] = {.count = 1, .reusable = true}, SHIFT(2676),
  [6306] = {.count = 1, .reusable = false}, SHIFT(2677),
  [6308] = {.count = 1, .reusable = true}, SHIFT(2678),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6312] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6314] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6316] = {.count = 1, .reusable = false}, SHIFT(2681),
  [6318] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6320] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6322] = {.count = 1, .reusable = false}, SHIFT(2684),
  [6324] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6326] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 45),
  [6328] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 45),
  [6330] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 46),
  [6332] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 46),
  [6334] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 47),
  [6336] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 47),
  [6338] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 48),
  [6340] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 48),
  [6342] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 49),
  [6344] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 49),
  [6346] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 50),
  [6348] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 50),
  [6350] = {.count = 1, .reusable = true}, SHIFT(2687),
  [6352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2450),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6359] = {.count = 1, .reusable = false}, SHIFT(2689),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6365] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6371] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6373] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6375] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6377] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6379] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6383] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6387] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6389] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6391] = {.count = 1, .reusable = false}, SHIFT(2706),
  [6393] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [6395] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [6397] = {.count = 1, .reusable = false}, SHIFT(2707),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6401] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6403] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 5),
  [6405] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 5),
  [6407] = {.count = 1, .reusable = false}, SHIFT(888),
  [6409] = {.count = 1, .reusable = false}, SHIFT(889),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6413] = {.count = 1, .reusable = false}, SHIFT(2711),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6417] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6419] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [6421] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [6423] = {.count = 1, .reusable = false}, SHIFT(2713),
  [6425] = {.count = 1, .reusable = false}, SHIFT(2714),
  [6427] = {.count = 1, .reusable = false}, SHIFT(2715),
  [6429] = {.count = 1, .reusable = false}, SHIFT(2716),
  [6431] = {.count = 1, .reusable = false}, SHIFT(2717),
  [6433] = {.count = 1, .reusable = false}, SHIFT(2718),
  [6435] = {.count = 1, .reusable = false}, SHIFT(2719),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6439] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6445] = {.count = 1, .reusable = false}, SHIFT(2728),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6451] = {.count = 1, .reusable = false}, SHIFT(2730),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6457] = {.count = 1, .reusable = false}, SHIFT(2732),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6461] = {.count = 1, .reusable = false}, SHIFT(2733),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6471] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6479] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6483] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 51),
  [6485] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 52),
  [6487] = {.count = 1, .reusable = false}, SHIFT(2750),
  [6489] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6491] = {.count = 1, .reusable = false}, SHIFT(2745),
  [6493] = {.count = 1, .reusable = false}, SHIFT(2746),
  [6495] = {.count = 1, .reusable = false}, SHIFT(2747),
  [6497] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6501] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 5),
  [6503] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2541),
  [6506] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 6),
  [6508] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 6),
  [6510] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6512] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 5),
  [6514] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 5),
  [6516] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6518] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6520] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2557),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6525] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6527] = {.count = 1, .reusable = false}, SHIFT(2761),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6531] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2576),
  [6534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2582),
  [6537] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2591),
  [6540] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 4),
  [6542] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2597),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6547] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6557] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6561] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6563] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6565] = {.count = 1, .reusable = false}, SHIFT(2781),
  [6567] = {.count = 1, .reusable = false}, SHIFT(2782),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6571] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6573] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6577] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6579] = {.count = 1, .reusable = false}, SHIFT(2790),
  [6581] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6583] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6585] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6587] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6589] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6591] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6593] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6595] = {.count = 1, .reusable = false}, SHIFT(2802),
  [6597] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6599] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6601] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6603] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6605] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6607] = {.count = 1, .reusable = false}, SHIFT(2808),
  [6609] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6611] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6613] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6617] = {.count = 1, .reusable = false}, SHIFT(2812),
  [6619] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6621] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6623] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6625] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6627] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 51),
  [6629] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 52),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6633] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6635] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6637] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6639] = {.count = 1, .reusable = false}, SHIFT(2821),
  [6641] = {.count = 1, .reusable = false}, SHIFT(2822),
  [6643] = {.count = 1, .reusable = false}, SHIFT(2823),
  [6645] = {.count = 1, .reusable = false}, SHIFT(2824),
  [6647] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6649] = {.count = 1, .reusable = false}, SHIFT(2826),
  [6651] = {.count = 1, .reusable = false}, SHIFT(2827),
  [6653] = {.count = 1, .reusable = false}, SHIFT(2828),
  [6655] = {.count = 1, .reusable = false}, SHIFT(2829),
  [6657] = {.count = 1, .reusable = false}, SHIFT(2830),
  [6659] = {.count = 1, .reusable = false}, SHIFT(2831),
  [6661] = {.count = 1, .reusable = false}, SHIFT(2834),
  [6663] = {.count = 1, .reusable = false}, SHIFT(2832),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6667] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6669] = {.count = 1, .reusable = false}, SHIFT(2839),
  [6671] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6673] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6675] = {.count = 1, .reusable = false}, SHIFT(2841),
  [6677] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6679] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6681] = {.count = 1, .reusable = false}, SHIFT(2843),
  [6683] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6685] = {.count = 1, .reusable = false}, SHIFT(2844),
  [6687] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6689] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6691] = {.count = 1, .reusable = false}, SHIFT(1501),
  [6693] = {.count = 1, .reusable = false}, SHIFT(1502),
  [6695] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6697] = {.count = 1, .reusable = false}, SHIFT(2847),
  [6699] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6701] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6703] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6705] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6707] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6709] = {.count = 1, .reusable = false}, SHIFT(2851),
  [6711] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6713] = {.count = 1, .reusable = false}, SHIFT(2853),
  [6715] = {.count = 1, .reusable = false}, SHIFT(2854),
  [6717] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6719] = {.count = 1, .reusable = false}, SHIFT(2857),
  [6721] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6723] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6725] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6727] = {.count = 1, .reusable = false}, SHIFT(2860),
  [6729] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6731] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6733] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6735] = {.count = 1, .reusable = false}, SHIFT(2866),
  [6737] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [6739] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [6741] = {.count = 1, .reusable = false}, SHIFT(2867),
  [6743] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6745] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6747] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6749] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6751] = {.count = 1, .reusable = false}, SHIFT(2871),
  [6753] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6755] = {.count = 1, .reusable = true}, SHIFT(2873),
  [6757] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6759] = {.count = 1, .reusable = false}, SHIFT(2875),
  [6761] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6763] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6765] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6767] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6769] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6771] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6773] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6775] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6779] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 6),
  [6781] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 6),
  [6783] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [6785] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [6787] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6789] = {.count = 1, .reusable = false}, SHIFT(2888),
  [6791] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6793] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6795] = {.count = 1, .reusable = false}, SHIFT(2894),
  [6797] = {.count = 1, .reusable = false}, SHIFT(2893),
  [6799] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6801] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6803] = {.count = 1, .reusable = false}, SHIFT(2897),
  [6805] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6807] = {.count = 1, .reusable = false}, SHIFT(2903),
  [6809] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6811] = {.count = 1, .reusable = false}, SHIFT(2906),
  [6813] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2534),
  [6816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2751),
  [6819] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2757),
  [6824] = {.count = 1, .reusable = false}, SHIFT(1800),
  [6826] = {.count = 1, .reusable = false}, SHIFT(1801),
  [6828] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6830] = {.count = 1, .reusable = false}, SHIFT(2909),
  [6832] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6834] = {.count = 1, .reusable = false}, SHIFT(2910),
  [6836] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6838] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6842] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6844] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6846] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6848] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6850] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6852] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6854] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6856] = {.count = 1, .reusable = true}, SHIFT(2923),
  [6858] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6860] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6862] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6864] = {.count = 1, .reusable = false}, SHIFT(2926),
  [6866] = {.count = 1, .reusable = false}, SHIFT(2927),
  [6868] = {.count = 1, .reusable = false}, SHIFT(2928),
  [6870] = {.count = 1, .reusable = false}, SHIFT(2929),
  [6872] = {.count = 1, .reusable = false}, SHIFT(2930),
  [6874] = {.count = 1, .reusable = false}, SHIFT(2931),
  [6876] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6878] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6880] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6882] = {.count = 1, .reusable = false}, SHIFT(2935),
  [6884] = {.count = 1, .reusable = false}, SHIFT(2936),
  [6886] = {.count = 1, .reusable = false}, SHIFT(2939),
  [6888] = {.count = 1, .reusable = false}, SHIFT(2937),
  [6890] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6892] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6894] = {.count = 1, .reusable = false}, SHIFT(2944),
  [6896] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6898] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6900] = {.count = 1, .reusable = false}, SHIFT(2946),
  [6902] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6904] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6906] = {.count = 1, .reusable = false}, SHIFT(2948),
  [6908] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6910] = {.count = 1, .reusable = false}, SHIFT(2949),
  [6912] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6914] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6916] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6918] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6920] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6922] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6924] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6926] = {.count = 1, .reusable = false}, SHIFT(2957),
  [6928] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6930] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6932] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6934] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6936] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6938] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6940] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6942] = {.count = 1, .reusable = true}, SHIFT(2966),
  [6944] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6946] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6948] = {.count = 1, .reusable = false}, SHIFT(2969),
  [6950] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6952] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6954] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6956] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6958] = {.count = 1, .reusable = false}, SHIFT(2976),
  [6960] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6962] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6964] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6966] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6968] = {.count = 1, .reusable = false}, SHIFT(2980),
  [6970] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6972] = {.count = 1, .reusable = false}, SHIFT(2983),
  [6974] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6976] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6978] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6980] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6982] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6984] = {.count = 1, .reusable = false}, SHIFT(2990),
  [6986] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6988] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6990] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [6992] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [6994] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6996] = {.count = 1, .reusable = false}, SHIFT(2994),
  [6998] = {.count = 1, .reusable = true}, SHIFT(2995),
  [7000] = {.count = 1, .reusable = true}, SHIFT(2996),
  [7002] = {.count = 1, .reusable = false}, SHIFT(2996),
  [7004] = {.count = 1, .reusable = true}, SHIFT(2997),
  [7006] = {.count = 1, .reusable = false}, SHIFT(2998),
  [7008] = {.count = 1, .reusable = true}, SHIFT(2999),
  [7010] = {.count = 1, .reusable = false}, SHIFT(2999),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3001),
  [7014] = {.count = 1, .reusable = true}, SHIFT(3000),
  [7016] = {.count = 1, .reusable = false}, SHIFT(3001),
  [7018] = {.count = 1, .reusable = true}, SHIFT(3004),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3005),
  [7022] = {.count = 1, .reusable = true}, SHIFT(3007),
  [7024] = {.count = 1, .reusable = true}, SHIFT(3009),
  [7026] = {.count = 1, .reusable = false}, SHIFT(3009),
  [7028] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [7030] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [7032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2736),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3012),
  [7037] = {.count = 1, .reusable = true}, SHIFT(3013),
  [7039] = {.count = 1, .reusable = false}, SHIFT(3014),
  [7041] = {.count = 1, .reusable = true}, SHIFT(3014),
  [7043] = {.count = 1, .reusable = false}, SHIFT(3017),
  [7045] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2740),
  [7048] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2896),
  [7051] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_loop, 7),
  [7053] = {.count = 1, .reusable = false}, REDUCE(sym_for_range_loop, 7),
  [7055] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2906),
  [7058] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2908),
  [7061] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2912),
  [7064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2914),
  [7067] = {.count = 1, .reusable = true}, SHIFT(3023),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3025),
  [7071] = {.count = 1, .reusable = true}, SHIFT(3026),
  [7073] = {.count = 1, .reusable = true}, SHIFT(3027),
  [7075] = {.count = 1, .reusable = true}, SHIFT(3028),
  [7077] = {.count = 1, .reusable = false}, SHIFT(3028),
  [7079] = {.count = 1, .reusable = true}, SHIFT(3029),
  [7081] = {.count = 1, .reusable = true}, SHIFT(3030),
  [7083] = {.count = 1, .reusable = true}, SHIFT(3032),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3034),
  [7087] = {.count = 1, .reusable = true}, SHIFT(3033),
  [7089] = {.count = 1, .reusable = false}, SHIFT(3034),
  [7091] = {.count = 1, .reusable = true}, SHIFT(3036),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3037),
  [7095] = {.count = 1, .reusable = true}, SHIFT(3038),
  [7097] = {.count = 1, .reusable = false}, SHIFT(3039),
  [7099] = {.count = 1, .reusable = false}, SHIFT(3040),
  [7101] = {.count = 1, .reusable = true}, SHIFT(3041),
  [7103] = {.count = 1, .reusable = true}, SHIFT(3043),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3045),
  [7107] = {.count = 1, .reusable = true}, SHIFT(3047),
  [7109] = {.count = 1, .reusable = false}, SHIFT(3047),
  [7111] = {.count = 1, .reusable = true}, SHIFT(3048),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3049),
  [7115] = {.count = 1, .reusable = true}, SHIFT(3050),
  [7117] = {.count = 1, .reusable = true}, SHIFT(3051),
  [7119] = {.count = 1, .reusable = false}, SHIFT(3051),
  [7121] = {.count = 1, .reusable = true}, SHIFT(3052),
  [7123] = {.count = 1, .reusable = true}, SHIFT(3053),
  [7125] = {.count = 1, .reusable = false}, SHIFT(3053),
  [7127] = {.count = 1, .reusable = true}, SHIFT(3054),
  [7129] = {.count = 1, .reusable = false}, SHIFT(3055),
  [7131] = {.count = 1, .reusable = false}, SHIFT(3056),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3059),
  [7135] = {.count = 1, .reusable = false}, SHIFT(3059),
  [7137] = {.count = 1, .reusable = true}, SHIFT(3060),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3062),
  [7141] = {.count = 1, .reusable = true}, SHIFT(3061),
  [7143] = {.count = 1, .reusable = false}, SHIFT(3062),
  [7145] = {.count = 1, .reusable = true}, SHIFT(3064),
  [7147] = {.count = 1, .reusable = true}, SHIFT(3065),
  [7149] = {.count = 1, .reusable = false}, SHIFT(3068),
  [7151] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7153] = {.count = 1, .reusable = true}, SHIFT(3072),
  [7155] = {.count = 1, .reusable = false}, SHIFT(3072),
  [7157] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7159] = {.count = 1, .reusable = false}, SHIFT(3078),
  [7161] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7163] = {.count = 1, .reusable = true}, SHIFT(3082),
  [7165] = {.count = 1, .reusable = false}, SHIFT(3082),
  [7167] = {.count = 1, .reusable = true}, SHIFT(3084),
  [7169] = {.count = 1, .reusable = true}, SHIFT(3083),
  [7171] = {.count = 1, .reusable = false}, SHIFT(3084),
  [7173] = {.count = 1, .reusable = true}, SHIFT(3085),
  [7175] = {.count = 1, .reusable = true}, SHIFT(3086),
  [7177] = {.count = 1, .reusable = false}, SHIFT(3086),
  [7179] = {.count = 1, .reusable = true}, SHIFT(3087),
  [7181] = {.count = 1, .reusable = false}, SHIFT(3087),
  [7183] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 8),
  [7185] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 8),
  [7187] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7189] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7191] = {.count = 1, .reusable = false}, SHIFT(3089),
  [7193] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7195] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7197] = {.count = 1, .reusable = true}, SHIFT(3093),
  [7199] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7201] = {.count = 1, .reusable = false}, SHIFT(3093),
  [7203] = {.count = 1, .reusable = true}, SHIFT(3094),
  [7205] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7207] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7209] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [7211] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [7213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3017),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7218] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7220] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7222] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7224] = {.count = 1, .reusable = false}, SHIFT(3109),
  [7226] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7228] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7230] = {.count = 1, .reusable = false}, SHIFT(3111),
  [7232] = {.count = 1, .reusable = true}, SHIFT(3112),
  [7234] = {.count = 1, .reusable = false}, SHIFT(3113),
  [7236] = {.count = 1, .reusable = false}, SHIFT(3114),
  [7238] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7240] = {.count = 1, .reusable = false}, SHIFT(3117),
  [7242] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7244] = {.count = 1, .reusable = true}, SHIFT(3120),
  [7246] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7248] = {.count = 1, .reusable = false}, SHIFT(3120),
  [7250] = {.count = 1, .reusable = true}, SHIFT(3122),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7254] = {.count = 1, .reusable = false}, SHIFT(3126),
  [7256] = {.count = 1, .reusable = true}, SHIFT(3128),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3130),
  [7260] = {.count = 1, .reusable = false}, SHIFT(3130),
  [7262] = {.count = 1, .reusable = true}, SHIFT(3132),
  [7264] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7266] = {.count = 1, .reusable = false}, SHIFT(3133),
  [7268] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7270] = {.count = 1, .reusable = false}, SHIFT(3136),
  [7272] = {.count = 1, .reusable = true}, SHIFT(3138),
  [7274] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7276] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7278] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7280] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7282] = {.count = 1, .reusable = false}, SHIFT(3143),
  [7284] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7286] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7288] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7290] = {.count = 1, .reusable = false}, SHIFT(3150),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7294] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7298] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7302] = {.count = 1, .reusable = false}, SHIFT(3159),
  [7304] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7306] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7310] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7314] = {.count = 1, .reusable = false}, SHIFT(3165),
  [7316] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7318] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7320] = {.count = 1, .reusable = false}, SHIFT(3167),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7324] = {.count = 1, .reusable = false}, SHIFT(3168),
  [7326] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7328] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [7330] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [7332] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7334] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3107),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7339] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7341] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7345] = {.count = 1, .reusable = false}, SHIFT(3178),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7349] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7351] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7353] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7355] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7357] = {.count = 1, .reusable = false}, SHIFT(3185),
  [7359] = {.count = 1, .reusable = true}, SHIFT(3186),
  [7361] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7363] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7365] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7367] = {.count = 1, .reusable = false}, SHIFT(3196),
  [7369] = {.count = 1, .reusable = true}, SHIFT(3197),
  [7371] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7373] = {.count = 1, .reusable = false}, SHIFT(3200),
  [7375] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7379] = {.count = 1, .reusable = false}, SHIFT(3202),
  [7381] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7385] = {.count = 1, .reusable = false}, SHIFT(3204),
  [7387] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7389] = {.count = 1, .reusable = false}, SHIFT(3205),
  [7391] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7393] = {.count = 1, .reusable = false}, SHIFT(3209),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3214),
  [7401] = {.count = 1, .reusable = false}, SHIFT(3214),
  [7403] = {.count = 1, .reusable = true}, SHIFT(3216),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7409] = {.count = 1, .reusable = false}, SHIFT(3220),
  [7411] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7413] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7415] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3172),
  [7418] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [7420] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [7422] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7424] = {.count = 1, .reusable = false}, SHIFT(3228),
  [7426] = {.count = 1, .reusable = true}, SHIFT(3229),
  [7428] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7430] = {.count = 1, .reusable = false}, SHIFT(3232),
  [7432] = {.count = 1, .reusable = true}, SHIFT(3234),
  [7434] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7436] = {.count = 1, .reusable = false}, SHIFT(3234),
  [7438] = {.count = 1, .reusable = true}, SHIFT(3235),
  [7440] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7442] = {.count = 1, .reusable = false}, SHIFT(3236),
  [7444] = {.count = 1, .reusable = true}, SHIFT(3237),
  [7446] = {.count = 1, .reusable = false}, SHIFT(3237),
  [7448] = {.count = 1, .reusable = true}, SHIFT(3239),
  [7450] = {.count = 1, .reusable = false}, SHIFT(3240),
  [7452] = {.count = 1, .reusable = true}, SHIFT(3242),
  [7454] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7456] = {.count = 1, .reusable = true}, SHIFT(3245),
  [7458] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7460] = {.count = 1, .reusable = true}, SHIFT(3249),
  [7462] = {.count = 1, .reusable = false}, SHIFT(3249),
  [7464] = {.count = 1, .reusable = true}, SHIFT(3250),
  [7466] = {.count = 1, .reusable = true}, SHIFT(3251),
  [7468] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7470] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7472] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7474] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7476] = {.count = 1, .reusable = false}, SHIFT(3260),
  [7478] = {.count = 1, .reusable = false}, SHIFT(3261),
  [7480] = {.count = 1, .reusable = true}, SHIFT(3263),
  [7482] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7484] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7486] = {.count = 1, .reusable = true}, SHIFT(3268),
  [7488] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7490] = {.count = 1, .reusable = false}, SHIFT(3270),
  [7492] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7494] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7496] = {.count = 1, .reusable = false}, SHIFT(3275),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7500] = {.count = 1, .reusable = true}, SHIFT(3278),
  [7502] = {.count = 1, .reusable = true}, SHIFT(3280),
  [7504] = {.count = 1, .reusable = false}, SHIFT(3280),
  [7506] = {.count = 1, .reusable = true}, SHIFT(3283),
  [7508] = {.count = 1, .reusable = true}, SHIFT(3284),
  [7510] = {.count = 1, .reusable = false}, SHIFT(3287),
  [7512] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7514] = {.count = 1, .reusable = true}, SHIFT(3290),
  [7516] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7518] = {.count = 1, .reusable = false}, SHIFT(3292),
  [7520] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7522] = {.count = 1, .reusable = true}, SHIFT(3299),
  [7524] = {.count = 1, .reusable = true}, SHIFT(3302),
  [7526] = {.count = 1, .reusable = true}, SHIFT(3305),
  [7528] = {.count = 1, .reusable = true}, SHIFT(3307),
};

void *tree_sitter_cpp_external_scanner_create();
void tree_sitter_cpp_external_scanner_destroy(void *);
bool tree_sitter_cpp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cpp_external_scanner_serialize(void *, char *);
void tree_sitter_cpp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_cpp() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_cpp_external_scanner_create,
      tree_sitter_cpp_external_scanner_destroy,
      tree_sitter_cpp_external_scanner_scan,
      tree_sitter_cpp_external_scanner_serialize,
      tree_sitter_cpp_external_scanner_deserialize,
    },
  };
  return &language;
}
